;                         ͻ
;                                 IMAGE.MSG         
;                                version 1.01       
;                                                   
;                               20 / 04 / 1995      
;                         ͼ

;  Source for Assemble.

;  status(current,next_img,counter,status,cfg_ptr,change).
;  0(0,0,0,-1,0,0): $0000 --> 0 (error) or 1 (no error).
;  1(0,0,0,-1,!0,0): $0004 --> 1 (error) or 2 (no error), next image.
;  2(0,!0,0,0,!0,0): $03?? --> 2 (not finished yet) or {change = -1, 3} (finished).
;  3(!0,?,?,-1,!0,?): $0004 --> 3 (one image or error) or 4 or 5.
;  4(!0,!0,?,0,!0,-1): $0006 --> 5 (cf below).
;  5(!0,!0,?,0,!0,0): $03?? --> 5 (not finished yet) or 6 or 7.
;  6(!0,!0,!0,1,!0,0): $0202 --> 6 or 7 (cf below).
;  7(!0,!0,0,1,!0,0): $0004 --> current = next_img, change = -1, 3 or 4 or 5.
;  ?(?,?,?,?,?,?): $0202 --> if (counter > 0) counter--.
;  ?(?,?,?,?,?,-1): $0004 --> free background image.
;                   $0006 --> counter = ncounter.
;  ?(!0,?,?,?,?,?): $0006 --> display current image, change = 0.

               OPT  O+  ;Maximal optimisation.
               MC68030  ;68030 processor.
               USER     ;Privileged instructions forbidden.

gemdos         equ      1
fopen          equ      $3D
fclose         equ      $3E
fread          equ      $3F
fseek          equ      $42
seek_set       equ      0
seek_end       equ      2
malloc         equ      $48
mfree          equ      $49

ras_magic      equ      $59A66A95
ras_width      equ      624
ras_height     equ      416
ras_depth      equ      24
ras_type       equ      1
pl_length      equ      (624*416)>>3
map_length     equ      pl_length*7
img_length     equ      map_length+96*4

handle         equr     d3
length         equr     d4

iregs          reg      d0-d4/a0-a3
cregs          reg      d0-d7/a0-a3
mregs          reg      d0-d4/a0-a4
dregs          reg      d0-d2/a0-a2

mgemdos        MACRO
               move.w   #\1,-(sp)
               trap     #gemdos
               add.l    #\2,sp
               ENDM

               TEXT

header:        ascii    'MSG1'              ;Header.
               cmpi.w   #$0006,d0
               beq      disp                ;Display (if possible).
               pea      ([header.w,pc])     ;Address of the next message file.
               cmpi.w   #$0004,d0
               beq      menu_msg            ;Menu display message.
               cmpi.w   #$0001,d0
               beq      init                ;Init: read "IMAGE.CFG".
               cmpi.w   #$0202,d0
               bne.s    tst_03xx
               move.l   a0,-(sp)
               lea      counter(pc),a0
               tst.w    (a0)
               beq.s    dcntr_end
               subq.w   #1,(a0)
dcntr_end:     movea.l  (sp)+,a0
rts:           rts
tst_03xx:      cmpi.w   #$0300,d0
               bcs.s    rts
               cmpi.w   #$0400,d0
               bcc.s    rts
               tst.b    status(pc)
               bne.s    rts
               movem.l  cregs,-(sp)         ;status = 0: background computation.
               ext.w    d0
               beq.s    lbl0
               moveq    #96,d0
lbl0:          move.w   d0,-(sp)
calc_loop:     moveq    #255/3,d7
               lea      img_pos(pc),a0
               movea.l  next_img(pc),a2
               lea      (map_length,a2),a3
               addq.l   #1,(a0)
               beq.s    calc
               move.l   (a0),d0
               moveq    #ras_width/8,d1
               divu.w   d1,d0
               swap     d0
               tst.w    d0
               bne.s    calc
               add.l    d1,(a0)
               swap     d0
               cmpi.w   #ras_height-1,d0
               bne.s    calc
               clr.b    d0                  ;Green component.
green_loop:    clr.b    d1                  ;Red component.
red_loop:      clr.b    d2                  ;Blue component.
blue_loop:     clr.b    (a3)+
               move.b   d1,(a3)+            ;Red component.
               move.b   d0,(a3)+            ;Green component.
               move.b   d2,(a3)+            ;Blue component.
               add.b    d7,d2
               bcc.s    blue_loop
               add.b    d7,d1
               bcc.s    red_loop
               addi.b   #255/5,d0
               bcc.s    green_loop
               addq.b   #1,status-img_pos(a0)
               movea.l  img_file-img_pos(a0),a3
               bsr      free_mem
calc_end:      addq.l   #2,sp
               movem.l  (sp)+,cregs
               rts                          ;Go to the next message file.

calc:          move.l   (a0)+,d0
               movea.l  (a0),a1
               lea      ([28.w,a1],a1.l,32.w),a1
               moveq    #24,d1
               mulu.w   d0,d1
               adda.l   d1,a1
               adda.l   d0,a2
               moveq    #3,d3
               clr.w    d4
               moveq    #25,d5
               moveq    #42,d6
loop1:         clr.w    d0                  ;Green component.
               clr.w    d1                  ;Red component.
               clr.w    d2                  ;Blue component.
               bsr.s    calc0
               lea      3*ras_width(a1),a1
               bsr.s    calc0
               subq.l   #6,a1
               bsr.s    calc0
               lea      -3*ras_width(a1),a1
               bsr.s    calc0
               dbf      d3,loop1
               moveq    #0,d0
               moveq    #0,d1
               moveq    #0,d2
               clr.w    d3
               moveq    #3,d4
loop2:         lsr.l    #2,d0
               lsr.l    #2,d1
               lsr.l    #2,d2
               lsr.w    #2,d3
               moveq    #6,d7
               bsr.s    calc1
               moveq    #15,d7
               bsr.s    calc1
               moveq    #14,d7
               bsr.s    calc1
               moveq    #7,d7
               bsr.s    calc1
               dbf      d4,loop2
               move.w   d3,-(sp)
               movem.l  d0-d2,-(sp)
               moveq    #6,d1
loop3:         move.w   (sp)+,d0
               move.b   d0,(a2)
               lsr.w    #8,d0
               move.b   d0,ras_width/8(a2)
               lea      pl_length(a2),a2
               dbf      d1,loop3
               subq.w   #1,(sp)
               bcs      calc_end
               bra      calc_loop

calc0:         add.w    d5,d0
               add.w    d6,d1
               add.w    d6,d2
               move.b   (a1)+,d4
               add.w    d4,d2
               move.b   (a1)+,d4
               add.w    d4,d0
               move.b   (a1)+,d4
               add.w    d4,d1
               ext.l    d0
               divu.w   #51,d0
               move.b   d0,(a3)+
               swap     d0
               ext.l    d1
               divu.w   d7,d1
               move.b   d1,(a3)+
               swap     d1
               ext.l    d2
               divu.w   d7,d2
               move.b   d2,(a3)+
               swap     d2
               sub.w    d5,d0
               sub.w    d6,d1
               sub.w    d6,d2
               rts

calc1:         moveq    #16,d6
               add.b    d7,d6
               move.b   -(a3),d5
               lsr.b    #1,d5
               bcc.s    lbl1
               bset     d6,d0
lbl1:          tst.b    d5
               beq.s    lbl2
               bset     d7,d0
lbl2:          move.b   -(a3),d5
               lsr.b    #1,d5
               bcc.s    lbl3
               bset     d6,d1
lbl3:          tst.b    d5
               beq.s    lbl4
               bset     d7,d1
lbl4:          move.b   -(a3),d5
               lsr.b    #1,d5
               bcc.s    lbl5
               bset     d6,d2
lbl5:          lsr.b    #1,d5
               bcc.s    lbl6
               bset     d7,d2
lbl6:          tst.b    d5
               beq.s    lbl7
               bset     d7,d3
lbl7:          rts

init:          movem.l  iregs,-(sp)
               moveq    #2,length
               lea      fname(pc),a3
               bsr.s    read_file
               bmi.s    init_end1
               clr.w    (a3,length.l)       ;Store two $00 at the end of the block.
               moveq    #' ',d1
               movea.l  a3,a0
init_loop1:    move.b   (a0)+,d0            ;Search for the first
               beq.s    init_end2           ;non-blank character.
               cmp.b    d1,d0
               bls.s    init_loop1          ;Branch while blank character.
init_loop2:    cmpi.b   #'0',d0             ;Error if D0 isn't a digit.
               bcs.s    init_end2
               cmpi.b   #'9',d0
               bhi.s    init_end2
               move.b   (a0)+,d0
               beq.s    init_end2
               cmp.b    d1,d0
               bhi.s    init_loop2          ;Branch until blank character.
init_loop3:    move.b   (a0)+,d0
               beq.s    init_end2
               cmp.b    d1,d0
               bls.s    init_loop3          ;Branch while blank character.
init_loop4:    move.b   (a0)+,d0
               beq.s    init_loop6
               cmp.b    d1,d0
               bhi.s    init_loop4          ;Branch until blank character.
               clr.b    -1(a0)              ;Replace the 1st blank by 0.
init_loop5:    cmp.b    d1,d0
               bhi.s    init_loop2          ;Branch if non-blank character.
               move.b   (a0)+,d0
               bne.s    init_loop5          ;Branch until 0 (EOF).
               subq.l   #1,a0
init_loop6:    clr.b    (a0)                ;The last non-blank character
               tst.b    -(a0)               ;must be followed by two $00.
               bne.s    init_loop6
               lea      cfg_ptr(pc),a0
               move.l   a3,(a0)+
               move.l   a3,(a0)
init_end1:     movem.l  (sp)+,iregs
               rts

init_end2:     pea      init_end1(pc)       ;Error.
free_mem:      pea      (a3)
               mgemdos  mfree,6
free_rts:      rts

read_file:     clr.w    -(sp)
               pea      (a3)
               mgemdos  fopen,8             ;Open "IMAGE.CFG".
               move.l   d0,handle
               bmi.s    free_rts
               moveq    #seek_end,d0
               bsr.s    seek                ;File pointer: EOF.
               bmi.s    rf_close
               beq.s    rf_close
               exg.l    d0,length           ;--> length of the file.
               add.l    length,d0
               move.l   d0,-(sp)
               mgemdos  malloc,6            ;Reserve memory.
               tst.l    d0
               bmi.s    rf_close
               movea.l  d0,a3               ;A3: address of the block.
               moveq    #seek_set,d0
               bsr.s    seek                ;File pointer: 0.
               bmi.s    rf_close
               pea      (a3)
               move.l   length,-(sp)
               move.w   handle,-(sp)
               mgemdos  fread,12            ;Read the whole file.
               cmp.l    d0,length
               beq.s    rf_noerr
               bsr.s    free_mem
rf_close:      move.w   handle,-(sp)
               mgemdos  fclose,4
               moveq    #-1,d1              ;N = 1.
               rts
rf_noerr:      bsr.s    rf_close
               tst.l    d0
               rts

seek:          move.w   d0,-(sp)
               move.w   handle,-(sp)
               clr.l    -(sp)
               mgemdos  fseek,10
               tst.l    d0
seek_rts:      rts

menu_msg:      tst.l    cfg_ptr(pc)
               beq.s    seek_rts
               movem.l  mregs,-(sp)
               lea      counter(pc),a4
               tst.w    (a4)+
               bne.s    menu1               ;Branch if counter != 0.
               cmpi.b   #1,(a4)
               bne.s    menu1               ;Branch if status != 1.
               move.w   #$FFFF,(a4)         ;status = change = -1.
               move.w   ncounter-status(a4),counter-status(a4)
               movea.l  current-status(a4),a3
               move.l   next_img-status(a4),current-status(a4)
               bsr      free_mem
menu1:         tst.b    (a4)
               bpl      menu2
               lea      img_ptr(pc),a2      ;status == -1: load the next image.
               movea.l  (a2),a1
               moveq    #0,d0
               clr.w    d1
               moveq    #0,d2
               not.w    d2
               moveq    #'0',d3
menu_loop1:    move.b   (a1)+,d0
               sub.b    d3,d0
               bcs.s    menu_loop1
menu_loop2:    mulu.w   #10,d1
               add.l    d0,d1
               cmp.l    d1,d2
               bcc.s    menu_lbl1
               move.l   d2,d1
menu_lbl1:     move.b   (a1)+,d0
               sub.b    d3,d0
               bcc.s    menu_loop2
               move.w   d1,ncounter-status(a4)
menu_loop3:    movea.l  a1,a3
               cmpi.b   #' ',(a1)+
               bls.s    menu_loop3
menu_loop4:    tst.b    (a1)+
               bne.s    menu_loop4
               tst.b    (a1)
               bne.s    menu_lbl2
               movea.l  cfg_ptr(pc),a1
menu_lbl2:     tst.l    current-status(a4)
               beq.s    menu_lbl3
               cmpa.l   (a2),a1
               beq.s    menu2
menu_lbl3:     move.l   a1,(a2)             ;Next image.
               moveq    #0,length
               bsr      read_file           ;Load image (read the file).
               bmi.s    menu2
               lea      img_file(pc),a0
               move.l   a3,(a0)             ;Store the address of the buffer.
               movea.l  a3,a1
               cmpi.l   #ras_magic,(a1)+
               bne.s    menu_error          ;Error if it isn't a rasterfile.
               cmpi.l   #ras_width,(a1)+
               bne.s    menu_error          ;Error if bad width (require: 624).
               cmpi.l   #ras_height,(a1)+
               bne.s    menu_error          ;Error if bad height (require: 416).
               moveq    #ras_depth,d0
               cmp.l    (a1),d0
               bne.s    menu_error          ;Error if bad depth (require: 24).
               subq.l   #ras_type,8(a1)
               bne.s    menu_error          ;Error if bad type (require: 1).
               move.l   #img_length,-(sp)
               mgemdos  malloc,6            ;Reserve a block for the 7-bit image.
               moveq    #-1,d1
               move.l   d1,img_pos-status(a4)
               move.l   d0,next_img-status(a4)
               smi      (a4)                ;status = 0 unless not enough memory.
               bpl.s    menu2               ;Branch unless not enough memory.
menu_error:    bsr      free_mem
menu2:         movem.l  (sp)+,mregs
               jsr      ([sp])              ;Next message file.
               addq.l   #4,sp
               tst.w    change(pc)
               beq.s    menu_rts
               moveq    #1,d0               ;The background image must be changed.
menu_rts:      rts

disp:          move.l   a0,-(sp)
               lea      change(pc),a0
               clr.b    (a0)
               movea.l  (sp)+,a0
               jsr      ([header.w,pc])     ;Next message file.
               tst.l    current(pc)
               beq.s    disp_rts
               movem.l  dregs,-(sp)
               move.l   #img_length,-(sp)   ;Reserve memory for the
               mgemdos  malloc,6            ;background image.
               tst.l    d0
               bmi.s    disp_end            ;Branch if not enough memory.
               move.l   d0,(sp)             ;D0-saved: address of this block.
               movea.l  d0,a0               ;Note: this block will
               movea.l  current(pc),a1      ;be freed by TETRHEX.
               move.w   #img_length>>2-1,d0
disp_loop:     move.l   (a1)+,(a0)+         ;Copy the image.
               dbf      d0,disp_loop
disp_end:      movem.l  (sp)+,dregs
disp_rts:      rts

img_pos:       dc.l     0
img_file:      dc.l     0
current:       dc.l     0
next_img:      dc.l     0
cfg_ptr:       dc.l     0
img_ptr:       dc.l     0
ncounter:      dc.w     0
counter:       dc.w     0
status:        dc.b     -1
change:        dc.b     0
fname:         asciiz   "IMAGE.CFG"

               END
