;                            ͻ
;                                         TETRHEX 1.41             
;                                                                  
;                                  Pour ordinateur Falcon 030      
;                                  640 x 480  -  256 couleurs      
;                                                                  
;                                        fichier source            
;                                  pour l'assembleur ASSEMBLE      
;                                                                  
;                                  crit par  Vincent Lefvre      
;                                        02 / 02 / 1996            
;                            ͼ

;\6
;  Notes (utilisation):
;  
;   _ Du point de vue hardware, seuls le processeur 68030 et un des 2 timers A ou D sont utiliss (le timer utilis
;     dpend de l'tat de la touche shift lors du lancement du programme).
;   _ La rsolution doit tre d'au moins 640 x 480, en exactement 256 couleurs. Le jeu lui-mme se droule dans une
;     zone de 624 x 416.
;   _ Pour la prsentation (uniquement), les formats graphiques (disposition des plans dans la mmoire video, table
;     de correspondance  VDI <--> XBIOS/hardware  pour les couleurs)  doivent tre  ceux  du Falcon 030.  En ce qui
;     concerne le jeu lui-mme,  seule la VDI est utilise,  sauf  pour le changement de la palette de couleurs  et
;     pour certains transferts dans la mmoire cran.
;\3
;   _ Utilisation avec une disquette ou un disque dur amovible:
;      . Il ne faut pas changer de disque  si la liste des scores peut tre modifie,  surtout si le nouveau disque
;        contient un fichier de mme nom (avec le mme chemin). Cf "Utilisation avec un autre systme que le TOS".
;\5
;   _ Utilisation avec SpeedoGDOS:
;      . Si SpeedoGDOS est install, des fontes vectorielles peuvent tre utilises.
;      . Avec la version 4.xx, le changement de rsolution est impossible, mais il n'y a pas de plantage.
;      . Si une chane crite avec une fonte vectorielle est souligne (dans l'aide), les rectangles pleins ne sont
;        plus affichs. Ceci semble provenir d'un bug de SpeedoGDOS.
;\5
;   _ Utilisation avec NVDI:
;      . Le changement de rsolution est impossible (avec la version 2.5), mais il n'y a pas de plantage.
;      . Il vaut mieux activer l'option "TOS compatibility"  si la fonction "Charger une rgle" est utilise.  Dans
;        le cas contraire,  si le jeu se droule sur tout l'cran,  la partie situe  sous le slecteur de fichiers
;        est efface, et si le jeu se droule dans une fentre GEM, la fentre doit tre raffiche.
;\7
;   _ Utilisation avec la carte Screen Blaster:
;      . Il n'y a jamais de tentative de changement de rsolution, sinon a plante.  Pour savoir si la carte Screen
;        Blaster est prsente,  on recherche le cookie OSBL.  Note: ce cookie ne peut tre enlev qu'aprs un red-
;        marrage complet (ctrl-alt-Rshift-delete);  par consquent, il se peut que le changement de rsolution soit
;        refus bien que la carte soit totalement dsactive (aprs un redmarrage partiel).
;      . Quand le jeu  se droule  sur tout l'cran,  seule la partie de l'cran  faisant 640 x 480 et centre  est
;        utilise.
;\3
;   _ Utilisation sous MultiTOS (ou avec l'option -ww):
;      . Il n'y a jamais de changement de rsolution (videmment).  si l'option -ws n'est
;      . Une fentre d'un peu moins de 640 x 480 est ouverte.       pas utilise.
;\4
;   _ Utilisation avec un autre systme que le TOS (MiNT...):
;      . Il ne faut pas utiliser la protection mmoire si la mmoire video est protge contre la lecture/criture.
;      . Il ne faut pas modifier un fichier de rgle charg par TETRHEX  si la liste des meilleurs scores peut tre
;        modifie, car TETRHEX ne s'en rendrait pas compte et la structure du fichier pourrait devenir mauvaise.
;\2
;   _ Utilisation avec Outside (mmoire virtuelle):
;      . Il n'y a aucun problme. Les drapeaux concernant la TT-RAM peuvent tre activs.
;\6
;   _ Utilisation avec Let 'em Fly:
;      . Si l'option "Send Redraw" est active, il y a un problme d'affichage aprs appel du slecteur de fichiers:
;        si le jeu se droule dans une fentre GEM,  un message de redraw inutile est envoy;  si le jeu se droule
;        sur tout l'cran,  la partie situe sous le slecteur de fichiers est efface (on doit alors quitter).  Il
;        est donc recommand de dsactiver l'option "Send Redraw"  si on a besoin de charger diffrents fichiers de
;        rgle, surtout si le jeu se droule sur tout l'cran.
;\2
;   _ Utilisation avec Idle (protecteur d'cran):
;      . Lorsque la protection s'active, des blocs de mmoire de TETRHEX sont parfois altrs.
;\3
;   _ Utilisation avec LED Panel:
;      . Pour viter des conflits d'affichage, on a la possibilit de dsactiver LED Panel si le jeu se droule sur
;        tout l'cran.
;\2
;   _ Lorsque la fentre de TETRHEX n'est pas au premier plan ou est iconifie,  elle passe en mode PAUSE (il n'y a
;     plus d'image de fond, et "-- PAUSE --" est affich).
;\4
;   _ Touches pour le menu principal (non modifiables):
;      . HELP: aide sur TETRHEX.
;      . SHIFT-HELP: aide sur le fichier de rgle charg.
;      . UNDO: charger une rgle.
;      . N: nom du joueur.
;      . RETURN: jouer.
;      . F1-F20: meilleurs scores.
;      . CTRL-TAB: bottom (quivaut  cliquer sur la barre de titre).
;      . CTRL-Q: quitter (quivaut  cliquer sur le CLOSER).
;      . CTRL-(,),/,* (pav numrique): changer le nombre de petits hexagones.
;     Lorsque le jeu se termine, il faut appuyer sur ESC pour revenir au menu principal.
;\4
;   _ Aide:
;      . Flches vers le haut et vers le bas: une ligne vers le haut / vers le bas.
;      . CTRL-flche: 4 lignes vers le haut / vers le bas.
;      . SHIFT-flche: une page vers le haut / vers le bas.
;      . CTRL-SHIFT-flche: 4 pages vers le haut / vers le bas.
;      . ClrHome: dbut du texte.
;      . SHIFT-ClrHome: fin du texte.
;      . ESCAPE: retour au menu principal.
;\3
;   _ Lors de l'affichage des meilleurs scores:
;      . F1-F20: affichage d'autres scores.
;      . ESCAPE: retour au menu principal.
;\4
;   _ Entre du nom du joueur:
;      . Seuls les caractres affichables (code ASCII  32) sont accepts comme caractres du nom.
;      . CR (touche RETURN ou ENTER): valider le nom.
;      . BACKSPACE: effacer le dernier caractre (s'il y en a un).
;      . ESCAPE: effacer le nom en entier.
;      . Flche droite: rcuprer le dernier caractre effac (utile au dbut, aprs BACKSPACE et aprs ESCAPE).
;      . Flche vers le haut: rcuprer le nom en entier (quivaut  plusieurs flches vers la droite).
;      . CTRL-C: mettre fin  l'entre du nom (renvoie un nom vide).
;\2
;   _ Lorsque le jeu se droule dans une fentre GEM, la touche CTRL-F et le bouton droit de la souris permettent 
;     tout moment de librer la mmoire prise par l'image de fond (si elle n'a pas t libre auparavant).
;\4
;   _ Lancement de TETRHEX: TETRHEX peut tre lanc soit en double-cliquant dessus  partir du bureau, soit dans un
;     shell.  La lecture des options s'effectue de la mme manire dans les 2 cas.  On forme une chane compose du
;     fichier TETRHEX.CFG  (s'il existe),  suivi  des options  de la ligne de commande  (s'il y en a).  Les options
;     commencent toutes par le caractre '-' et sont spares par des sparateurs (suite de blancs et de caractres
;     de contrle). La ligne de commande ne doit pas contenir plus de 125 caractres. Si la syntaxe est incorrecte,
;     le programme se termine. Voici les options reconnues par TETRHEX:
;      -b nombres  Couleurs du grand hexagone.  L'option "-b" est suivie de 6 nombres, tous compris entre 0 et 255.
;                  Les 3 premiers nombres  sont les intensits des composantes rouge, verte et bleue du cadre.  Les
;                  3 nombres suivants  sont les valeurs  enlever  chacune des intensits  pour passer  la partie
;                  du cadre  situe un cran plus loin vers le fond.  Le triple de chacune de ces valeurs  doit tre
;                  infrieur ou gal  la valeur correspondante de la partie situe au premier plan.  Les 6 nombres
;                  par dfaut  sont 240, 240, 240, 48, 48, 48.  Si les conditions ne sont pas respectes,  l'option
;                  n'est pas prise en compte.
;      -cd nbres   [Color Date]  Couleur de la date.  Cette option est suivie  de 3 nombres compris entre 0 et 255:
;                  intensit des composantes rouge, verte et bleue.  Si un nombre n'est pas compris entre 0 et 255,
;                  l'intensit de la composante correspondante est inchange.  Si,  aprs toutes les occurrences de
;                  "-cd", les 3 intensits sont nulles, alors les 3 intensits sont mises  255 (blanc).
;      -ch nbres   [Color Help]  Couleur du texte d'aide (cf option "-cd").
;      -ci nombre  [Color Icon]  Index de la couleur de l'icne ( partir de l'AES 4.1), entre 0 et 15.
;      -cp nombre  [Color Pause] Index de la couleur de "-- PAUSE --" (pause de la fentre), entre 0 et 15.
;      -ct nbres   [Color Time]  Couleur de l'heure (cf option "-cd").
;      -da         [Display All]     Affiche la date et l'heure (comme -dy -ds). 
;      -dd         [Display Date]    Affiche la date sans l'anne.               
;      -dn         [Display Nothing] N'affiche ni la date, ni l'heure.            Le format d'affichage est donn
;      -ds         [Display Seconds] Affiche l'heure avec les secondes.           par le cookie "_IDT".
;      -dt         [Display Time]    Affiche l'heure sans les secondes.          
;      -dy         [Display Year]    Affiche la date avec l'anne.               
;      -e[+/-]     [Error display]   Affiche les messages d'erreur sur la sortie standard.
;      -f+ nombre  Nombre qu'il faut ajouter aux numros des fontes vectorielles pour obtenir l'index  (utilis par
;                  la VDI). Valeur par dfaut: 0. C'est habituellement 0 ou 5000.  Dans les options -f? ci-dessous,
;                  la fonte est vectorielle  quand le nombre  est prcd  d'un '+'  (il peut y avoir un sparateur
;                  entre le '+' et le nombre).
;      -fe nombre  [Font mEnu]       Numro de la fonte Speedo utilise pour afficher "Menu".
;      -fg nombre  [Font Game]       Numro de la fonte Speedo utilise dans le jeu lui-mme.
;      -fh nombre  [Font Help]       Numro de la fonte Speedo utilise pour afficher l'aide.
;      -fm nombre  [Font Menu]       Numro de la fonte Speedo utilise dans les menus.
;      -fn nombre  [Font Name]       Numro de la fonte Speedo utilise pour afficher le nom de la rgle.
;      -fo nombre  [Font game Over]  Numro de la fonte Speedo utilise pour afficher "game over".
;      -fp nombre  [Font Pause]      Numro de la fonte Speedo utilise en mode PAUSE (affichage de "-- PAUSE --").
;      -fr nombre  [Font Register]   Numro de la fonte Speedo utilise pour afficher le texte sous "Shareware".
;      -fs nombre  [Font Score]      Numro de la fonte Speedo utilise pour afficher les meilleurs scores.
;      -ft nombre  [Font Tetrhex]    Numro de la fonte Speedo utilise pour afficher "TETRHEX x.xx".
;      -fw nombre  [Font shareWare]  Numro de la fonte Speedo utilise pour afficher "Shareware".
;      -gdos       Fait comme si SpeedoGDOS tait prsent (utile si le flag GDOS n'est pas correct).
;      -h          Aide (abrviation de -help). Cf -help.
;      -help       Aide: le fichier d'aide est envoy sur la sortie standard.
;      -i off      Internal speaker OFF: coupe le haut-parleur interne.   L'tat antrieur ne sera pas rcupr
;      -i on       Internal speaker ON: branche le haut-parleur interne.   la fin du programme.
;      -k          Cette option permet d'ignorer les touches par dfaut dfinies dans TETRHEX.PRG, et de prendre en
;                  compte ( la place) les dfinitions dans le fichier de rgle.
;      -l param    Prfrences du langage. Il y a autant de paramtres que l'on veut (ventuellement aucun). Chaque
;                  paramtre est  soit un nombre positif ou nul,  indiquant le langage de manire absolue,  soit le
;                  caractre '?',  indiquant le langage donn par le cookie _AKP  (langage utilis par le systme),
;                  soit le caractre '*',  indiquant  un ou plusieurs langages  se rapprochant  de celui du systme
;                  (pour l'instant,  il n'y a que 3 groupes de langages:  {0,3}, {1,8}, {2,7}).  La chane de para-
;                  mtres par dfaut est "* 0 3".
;      -ma         [Memory Allocate] La zone mmoire contenant l'image de fond ne sera jamais libre (sauf lorsque
;                  le programme se termine), ainsi l'image de fond ne sera jamais recalcule.
;      -mf         [Memory Free]     La zone mmoire contenant l'image de fond  sera toujours libre aprs l'affi-
;                  chage, et l'image de fond sera toujours recalcule aprs un mode PAUSE.
;      -n nombre   Taille d'un ct du tableau hexagonal (entre 6 et 9).
;      -o fichier  La liste des options restantes est remplace par le fichier (extension .CFG).
;      -p chane   La chane contient le nom du joueur, mis entre guillemets ou apostrophes.  Si la chane est vide
;                  (valeur par dfaut), le joueur devra entrer son nom  la fin du jeu si son score est assez lev
;                  pour entrer dans la liste des meilleurs scores.
;      -r fichier  Dtermine le fichier de rgle (extension .RUL)  charger par dfaut.
;      -s fichier  Ce fichier,  appel fichier de messages (extension .MSG),  permet  TETRHEX  de communiquer avec
;                  l'extrieur (par ex. utiliser des module players pour faire jouer des modules  certains moments
;                  prcis,  envoyer des signaux  TETRHEX pendant une partie...).  Il doit contenir un header suivi
;                  d'une routine entirement relogeable (qui sera appele en mode utilisateur).
;      -ta         [Timer A] C'est le timer A qui sera utilis (indpendemment de l'tat de shift).
;      -td         [Timer D] C'est le timer D qui sera utilis (indpendemment de l'tat de shift).
;      -u[+/-]     Laisse la liste des scores inchange (dans ce cas, le joueur n'entrera jamais son nom).
;      -vhc nbres  [Video Hex Color]  Intensits des 8 niveaux  pour l'affichage des petits hexagones.  "nbres" est
;                  une suite de 8 nombres compris entre 0 et 255, le premier correspondant au niveau le plus fonc,
;                  et le dernier au niveau le plus clair. Par exemple, pour un petit hexagone jaune, les intensits
;                  en rouge et en vert auront la valeur donne par l'option, et l'intensit en bleu sera nulle. Les
;                  valeurs par dfaut sont (en hexadcimal): $30, $60, $78, $90, $A8, $C8, $D8, $F8.
;      -vhw nbres  [Video Hex White]  Intensits en blanc supplmentaires.  "nbres" a la mme signification qu'avec
;                  l'option "-vhc".  L'intensit indique  est ajoute   chacune des 3 composantes rouge, verte et
;                  bleue.  Si, pour une ou plusieurs composantes, la somme est suprieure  255, elle est ramene 
;                  255. Les valeurs par dfaut sont (en hexadcimal): $00, $00, $00, $00, $10, $20, $50, $80.
;      -vl[+/-]    [Video LED Panel] Dsactive LED Panel (programme DP de Christoph Zwerschke) si le jeu se droule
;                  sur tout l'cran.
;      -vr[+/-]    [Video Resolution] Interdit le changement de rsolution.
;      -vs[+/-]    [Video Synchro]    Synchronisation avec l'interruption VBL pour certains affichages.
;      -wp x0 y0   [Window Position] Position du point suprieur gauche de la fentre (quand le jeu se droule dans
;                  une fentre GEM).  Il s'agit de la fentre entire,  et non pas de la zone de travail.  Si cette
;                  position est incorrecte, la fentre est place  la position par dfaut.
;      -wpc        [Window Position: Centered] Centre la fentre (si le jeu se droule dans une fentre GEM).
;      -ws         [Window Screen]   Le jeu se droule sur tout l'cran. Il ne vaut mieux pas utiliser cette option
;                  lorsque l'on travaille en multitches.
;      -wu[+/-]    [Window Update]   Si le jeu  se droule  sur tout l'cran,  le smaphore d'cran  est activ  en
;                  permanence.  Ainsi les applications tournant en arrire plan (i.e. gnralement les accessoires)
;                  ne peuvent plus rien afficher.
;      -ww         [Window Window]   Le jeu se droule dans une fentre GEM.
;     Les nombres sont en dcimal, sauf s'ils sont prcds d'un '$', auquel cas ils sont en hexadcimal.  Pour les
;     options -u, -vr et -vs, le "-" sert  retirer l'option; le "+" (facultatif) sert  l'ajouter.
;     On peut aussi faire glisser un fichier d'options (ou de configuration),  un fichier de rgle ou un fichier de
;     messages sur le nom du programme TETRHEX. Ceci correspond respectivement aux options "-o", "-r" et "-s".
;     Remarque: certaines options s'annulent mutuellement  (ma/mf, ta/td, wp/wpc, ws/ww, options avec +/-);  alors,
;       seule la dernire est prise en compte.
;\5
;  _ TETRHEX est un jeu shareware. La version non enregistre prsente les limitations suivantes:
;     . On ne peut pas changer de rgle (la touche UNDO est dsactive).
;     . Pas de sauvegarde des scores.
;     . 10 parties au maximum.
;     . Pas de message.

;\8
;  Notes (programmation):
;  
;   _ Flags du programme (PRGFLAGS):
;      . Bit 0: il est prfrable de le mettre  1 pour acclrer le lancement.
;      . Bits 1 et 2: il est prfrable de les mettre  1.
;      . Bit 3: inutilis (mettre  0).
;      . Bits 4 et 5: il est prfrable de les mettre  0.
;      . Bits 6  15: inutiliss (mettre  0).
;\4
;   _ Codes de retour:
;      . 0: pas d'erreur.
;      .-1: erreur systme.
;      . 1: mmoire insuffisante.
;      . 2: impossible de changer de rsolution.
;      . 3: mauvais processeur (il faut au moins un 68020).
;      . 4: impossible d'ouvrir une station de travail.
;      . 5: impossible de crer une fentre.
;      . 6: problme de fonte.
;      . 7: fichier de rgle non trouv.
;      . 8: mauvais format de fichier de rgle.
;      . 9: erreur interne.
;      .10: chane d'options incorrecte.
;      .11: mauvais format de fichier de langue.
;      .12: fichier d'aide inexistant ou non trouv.
;      .13: mauvais format d'aide.
;      .14: stack overflow.
;\6
;   _ Si une fentre est dplace  et qu'une partie  tait en dehors de l'cran,  un message redraw lui est envoy,
;     mme si toute la zone de travail tait sur l'cran (bug du GEM).  De plus, les 2 lignes situes en bas et les
;     2 colonnes situes  droite  (dues au relief)  ne font pas partie de la fentre  (pourquoi ?).  On doit tenir
;     compte de ces 2 pixels supplmentaires dans la routine max_coord;  mais cela peut poser des problmes suivant
;     la version du GEM et celle du bureau (on ne peut pas faire autrement, pour viter que la fentre soit raffi-
;     che inutilement).
;\4
;   _ Pour le changement de palette de couleurs,  j'utilise le XBIOS  car  il est  beaucoup plus rapide  que la VDI
;     (mais dans une prochaine version  il y aura peut-tre les 2 possibilits).  Un problme se pose sous MultiTOS
;     lorsque plusieurs applications  utilisent des palettes de couleurs diffrentes.  En supposant  que toutes les
;     applications  slectionnent la palette avec la VDI,  ce devrait tre  la VDI  de modifier automatiquement la
;     palette physique lorsqu'on change de fentre active.  Mais ce n'est pas le cas (il n'y a donc quasiment aucun
;     avantage  utiliser la VDI).  Voici la mthode utilise:  lorsque la fentre de TETRHEX redevient active,  on
;     rtablit la palette de couleurs de TETRHEX; lorsqu'elle passe inactive, on ne fait rien. En effet, on ne sait
;     pas quelle est la palette associe  la nouvelle fentre active; de plus, il ne faudrait surtout pas modifier
;     la palette trop tard... De toutes faons, si les applications qui utilisent la palette en entier font le mme
;     raisonnement,  il n'y a pas de problme,  et  les applications  qui n'utilisent que les 16 premires couleurs
;     n'ont pas  s'en occuper. Le problme se pose aussi lorsque l'on quitte TETRHEX: faut-il restituer l'ancienne
;     palette?  normalement non,  pour la mme raison  que ci-dessus.  On ne la restituera alors  que si le jeu  se
;     droule sur tout l'cran; car dans le cas contraire, il peut y avoir conflit (cf ci-dessus).
;\3
;   _ Dtection application/accessoire:
;      . A0 == 0: application.
;      . A0 != 0: accessoire.

;\5
;  Version enregistre:
;  
;   _ reg_name: nom cod de la personne enregistre (32 octets).  Nom dcod:  il s'agit du nom (caractres 8 bits)
;     suivi d'octets nuls.  Le codage s'effectue en XORant l'octet i (0  i  31) par (-7) * (-11)^i modulo 256, et
;     par l'octet i-1 cod si i > 0. On note N(i) l'octet i du nom cod.
;   _ key1: premire cl (non teste): 32 octets. Elle s'obtient  partir du nom cod: K1(-1) = 29; l'octet i de la
;     premire cl est K1(i) = 5 * N(i) - 3 * K1(i-1).
;   _ key2: seconde cl (non teste): 24 octets. Elle s'obtient aussi  partir du nom cod. L'octet i de la seconde
;     cl est K2(i) = 19 * N(i+2) - 17 * N(i+5) + 55 * i.
;   _ Les 24 octets  partir de patdef sont cods. Pour les dcoder, ajouter (5-i) * N(i)  l'octet i.
;   _ La partie allant de rlp_expl  rlp_end est code. Pour la dcoder, ajouter (i+3) * N(i mod 32)  l'octet i.
;   _ Dans la version shareware non enregistre,  patdef et rlp_expl  sont aussi cods.  Mais comme il n'y a pas de
;     nom de personne enregistre, on prend bfire  la place du nom cod.

;\7
;  Rgles (fichiers .RUL):
;  
;   _ Les fichiers .RUL, appels fichiers de rgle, servent  dfinir des rgles du jeu, en fonction des actions du
;     joueur, appeles signaux,  de la configuration du tableau, et d'autres paramtres comme le score.  Le fichier
;     contenant la rgle par dfaut est TETRHEX.RUL (choisi s'il n'y a pas d'option correspondante dans la ligne de
;     commande, ni de fichier de configuration). Un fichier de rgle contient aussi une liste de touches par dfaut
;     et la liste des meilleurs scores (dont le nombre maximal dpend du fichier de rgle).
;\4
;   _ Touches par dfaut pour les signaux standards:
;      sig  nom    touche       action par dfaut
;      $01  DOWN     Q      aller en bas (ce signal est envoy par TETRHEX  chaque descente de la pice).
;      $02  LFDN   INSERT   aller en bas  gauche.
;      $03  RGDN  CLR-HOME  aller en bas  droite.
;      $04  ROTL   "down"   rotation gauche (sens trigo).
;      $05  ROTR    "up"    rotation droite.
;      $06  LEFT    <--     aller  gauche (mme hauteur).
;      $07  RGHT    -->     aller  droite (mme hauteur).
;      $08  DROP    S.B.    drop (la pice tombe).
;      $09  STOP    ESC     abandon.
;      $0A  PAUS    UNDO    pause.
;      $0B  CONT   RETURN   fin de pause (reprendre la partie).
;      $0C  NEXT   +(num)   passage au niveau suivant.
;      $0D  PREV   -(num)   passage au niveau prcdent.
;      $0E  RDAR    HELP    radar on/off (visualisation de la forme suivante).
;     Remarques: seuls les codes clavier (scancodes) et l'tat des touches spciales sont pris en compte; les codes
;        ASCII sont ignors (ce qui peut poser des problmes dans certains cas, suivant les claviers des diffrents
;        pays). Les touches correspondant aux autres signaux, spcifiques  la rgle, sont uniquement dfinies dans
;        le fichier de rgle.  Une rgle peut ne pas respecter  l'action par dfaut  et effectuer  une autre action
;        (mais c'est dconseill).  Attention  ne pas associer de signal  une touche dj utilise pour une autre
;        fonction (ctrl-F par exemple)! Le signal 1 existe toujours, et ne devrait jamais tre redfini.
;\4
;   _ Le clavier n'est pas le seul moyen d'envoyer des signaux.  En effet, on pourra aussi jouer avec un contrleur
;     digital (les boutons par dfaut ne sont pas encore dfinis) ou appeler une routine qui sera charge d'envoyer
;     les signaux.  Une telle routine  permettra de faire jouer l'ordinateur ou d'envoyer des signaux  l'aide d'un
;     priphrique non directement support par TETRHEX; elle est dans le fichier de messages (extension .MSG).
;\5
;   _ Les pices sont composes de plusieurs petits hexagones arrangs dans une certaine disposition, appele forme
;     (dfinie  une rotation de 1/6 tour prs).  Chaque hexagone a sa propre couleur  (1: bleu, 2: vert, 3: vert +
;     bleu, 4: rouge, 5: rouge + bleu, 6: rouge + vert)  et son propre motif  (dessin sur l'hexagone, de la couleur
;     de l'hexagone,  dont chaque pixel  a une intensit comprise entre 0 et 7).  Toutes les dfinitions concernant
;     les pices, leurs probabilits d'apparition et leur comportement se trouvent dans le fichier de rgle.
;\4
;   _ Structure d'un fichier de rgle:
;      . Header. Les offsets sont par rapport au dbut du fichier.
;         _ 1 mot long: "RUL3" (MSB du 1er octet: 0).
;         _ 1 mot long: couleur de "-- PAUSE --", en mode pause du jeu (0, R, G, B).
;         _ 1 mot long: couleur de "game over" (0, R, G, B).
;         _ 1 mot long: couleur de "Votre nom:" et du nom (0, R, G, B).
;         _ 1 mot long: couleur du nom de la rgle (0, R, G, B).
;         _ 1 mot: hauteur par dfaut du nom de la rgle.
;         _ 24 octets: nom de la rgle, termin par un octet nul.
;         _ 1 mot: numro de la fonte Speedo utilise pour afficher le nom de la rgle,  ou 0 si la fonte est fixe
;             par l'utilisateur (i.e. dtermine par l'option -fn).
;         _ 1 mot: numro de la fonte Speedo utilise pour afficher  les noms des valeurs affiches pendant le jeu,
;             ou 0 si la fonte est fixe par l'utilisateur (i.e. dtermine par l'option -fg).
;         _ 1 octet: nombre de motifs (de 1  255).
;         _ 1 octet: nombre de formes (de 1  255).
;         _ 1 octet: nombre total de signaux (de 1  255).
;         _ 1 octet: nombre de petits hexagones dans un ct du grand hexagone  (de 6  9),  ou 0 s'il est variable
;             (i.e. dtermin par le fichier de rgle prcdent ou par l'option -n).
;         _ 1 octet: nombre de scores (de 0  255) pour 6 hexagones.
;         _ 1 octet: nombre de scores (de 0  255) pour 7 hexagones.
;         _ 1 octet: nombre de scores (de 0  255) pour 8 hexagones.
;         _ 1 octet: nombre de scores (de 0  255) pour 9 hexagones.
;         _ 1 octet: nombre maximal de scores (de 0  255) pour 6 hexagones.
;         _ 1 octet: nombre maximal de scores (de 0  255) pour 7 hexagones.
;         _ 1 octet: nombre maximal de scores (de 0  255) pour 8 hexagones.
;         _ 1 octet: nombre maximal de scores (de 0  255) pour 9 hexagones.
;         _ 1 mot long: taille de la pile (cf ci-dessous: codes d'une rgle).
;         _ 1 mot long: offset sur la dfinition des signaux.
;         _ 1 mot long: offset sur la dfinition des nombres  afficher.
;         _ 1 mot long: offset sur la partie 0 de la rgle (dbut de la partie, initialisation).
;         _ 1 mot long: offset sur la partie A de la rgle (cration de la pice).
;         _ 1 mot long: offset sur la partie B de la rgle (descente de la pice).
;         _ 1 mot long: offset sur la partie C de la rgle (arrive de la pice en bas).
;         _ 1 mot long: offset sur la partie P de la rgle (dbut du mode pause de la fentre).
;         _ 1 mot long: offset sur la partie Q de la rgle (fin du mode pause de la fentre).
;         _ 1 mot long: offset sur la partie S de la rgle (fin de la partie, dtermination du score).
;         _ 1 mot long: offset sur le texte (help), crit dans plusieurs langues. Nul s'il n'y a pas de texte.
;         _ 1 mot long: offset sur les meilleurs scores (pointe vers la fin du fichier s'il n'y a pas de score).
;      . Dfinition des motifs.  Chaque hexagone est form de 288 points d'intensit de 0  7  (0: noir, 4: couleur
;        du fond).  A chaque motif  est associ  un tableau de 288 nombres de 3 bits.  La dfinition d'un motif est
;        indpendante de la couleur de l'hexagone.  Les motifs sont numrots de 0  254 (il peut donc y avoir de 1
;         255 motifs). Un motif occupe 108 octets (54 mots). Suggestion pour faire ses propres motifs (en relief):
;        la couleur du fond de l'hexagone est 4,  la couleur du motif est 5 (ou ventuellement 6);  on fait ensuite
;        une modification  pour  faire apparatre  le relief:  les points du motif  dont le voisin en haut  gauche
;        appartient au fond sont mis  7,  et ceux du fond dont le voisin en haut  gauche appartient au motif sont
;        mis  0 ou  1.
;      . Dfinition des formes. Cette dfinition est indpendante de celle des motifs.
;         _ Pour chaque forme:
;            . 1 octet: nombre n d'hexagones (de 1  4).
;            . 1 octet: drapeau de rotation: nul si la forme ne peut pas tourner, ngatif si la forme tourne autour
;              de l'hexagone de rfrence "de faon standard", positif si la forme tourne d'une autre faon (cf jeu
;              columns);  dans ce dernier cas, ce drapeau indique le nombre de positions diffrentes, compris entre
;              1 et 6.
;            . 1 mot: offset sur la liste des positions  (tableau de tableaux de 4 octets)  si le drapeau ci-dessus
;              est positif, sinon mot nul.
;            . 4 octets: positions des hexagones par rapport  l'hexagone de rfrence (seuls les n premiers octets
;              sont pris en compte, les autres doivent tre nuls).
;         _ Listes ventuelles des positions (dans n'importe quel ordre).
;        --> Positions (0: hexagone de rfrence):
;                         13
;                     14      12
;                 15      04      11
;                     05      03
;                 16      00      10
;                     06      02
;                 17      01      09
;                     18      08
;                         07
;         N.B.: les pices doivent tre connexes, ou ne doivent pas dpasser les dimensions des pices connexes.
;      . Dfinition des signaux (y compris les signaux standards). Pour chaque signal, on a:
;         _ 1 mot long: nom du signal (4 lettres). Ce mot long doit tre strictement positif.
;         _ 1 mot: scancode de la touche correspondant au signal.
;         _ 1 mot nul (rserv).
;        Il est possible de redfinir les signaux standards, mais c'est dconseill; et dans ce cas, il faut utili-
;        ser l'option -k, car les touches dfinies dans TETRHEX n'ont plus de sens.
;      . Dfinition des nombres  afficher (score, bonus, niveau...).
;         _ 1 mot: nombre n (entre 0 et 8) de nombres  afficher.
;         _ Tableau de n mots: offsets par rapport au dbut du tableau des dfinitions des nombres  afficher.
;         _ Pour chaque nombre, on a:
;            . 1 octet: nombre maximal de chiffres du nombre en question (de 1  8).
;            . 1 octet: nombre minimal de chiffres  afficher (de 1  8).
;            . 1 octet: hauteur par dfaut du texte, en pixels (de 16  127).
;            . 1 octet: hauteur par dfaut du nombre, en pixels (de 16  127).
;            . 1 mot long: couleur du texte (0, R, G, B).
;            . 1 mot long: couleur des "0" non significatifs (0, R, G, B).
;            . 1 mot long: couleur des chiffres significatifs (0, R, G, B).
;            . 1 octet: 0 si le texte doit tre affich au-dessus, +1 s'il doit tre affich  gauche, -1 s'il doit
;              tre affich  droite.
;            . Pour chaque langue (il doit y en avoir au moins une):
;               _ 1 octet (de 1  127): nombre n de lettres du texte.
;               _ 1 octet: code de la langue.
;               _ n octets: texte.
;            . 1 octet nul, indiquant qu'il n'y a plus de langue.
;      . Rgle, constitue de 7 parties:
;         _ Partie 0: initialisation (au tout dbut du jeu).
;         _ Partie A: dtermination d'une prochaine pice.  Une pice est dfinie par sa forme, et la couleur et le
;           motif  de chacune  de ses composantes (hexagones).  Ces donnes  sont en gnral  alatoires,  mais pas
;           forcment quiprobables.
;         _ Partie B: transformation  de signaux  en actions  (phase gnralement appele pendant la descente d'une
;           pice pour dfinir son comportement, mais elle peut tre appele  tout moment  la fin d'un mode pause
;           de la fentre - cf plus loin).
;         _ Partie C: actions dclenches par l'arrive de la pice en bas.
;         _ Partie P: dbut du mode pause de la fentre (cf codes d'une rgle).
;         _ Partie Q: fin du mode pause de la fentre (cf codes d'une rgle).
;         _ Partie S: dtermination du score ( la fin de la partie).
;      . Texte, crit dans plusieurs langues.
;         _ Pour chaque langue:
;            . 1 mot long: adresse relative de la prochaine langue (ou du mot long nul).
;            . 1 octet: code de la langue.
;            . 1 octet: caractre de soulignement (0 si pas de caractre de soulignement). Cf ci-dessous.
;            . 1 octet (rserv). Une valeur non nulle pourra indiquer, dans une version ultrieure, l'existence de
;              donnes supplmentaires, permettant par exemple d'avoir une aide en hypertexte.  La valeur n'est pas
;              prise en compte dans cette version;  mais pour la compatibilit du fichier de rgle avec une version
;              ultrieure de TETRHEX, la valeur doit tre nulle.
;            . Texte dans cette langue, termin par un octet nul.  Les caractres doivent avoir un code ASCII  32,
;              sauf les fins de ligne (CR/LF).  Le texte pourra tre envoy directement sur la sortie standard;  il
;              doit donc dj tre format.  Il pourra aussi tre affich dans la fentre de TETRHEX  (shift-HELP);
;              dans ce cas,  on cherchera la largeur du texte (i.e. largeur maximale d'une ligne du texte),  et les
;              lignes ayant cette largeur seront justifies. La largeur conseille est de 76 caractres. A cause de
;              cette justification, les lignes ne sont pas affiches telles quelles:  il existe deux caractres qui
;              ont un comportement spcial.  Il s'agit  de l'espace  et du caractre de soulignement.  Une squence
;              d'espaces situe en dbut de ligne provoque un dplacement du dbut de ligne (indentation),  tel que
;              la proportion du nombre d'espaces par rapport  la largeur du texte est gale  celle du dplacement
;              par rapport  la largeur de la partie de la fentre rserve au texte; idem pour une squence situe
;              en fin de ligne justifie (i.e. dont la largeur est gale  celle du texte).  Une squence d'espaces
;              situe  l'intrieur d'une ligne justifie  est remplace  par un seul espace  (le fait  qu'il y ait
;              plusieurs espaces entre deux mots successifs  est d  la justification des lignes en caractres non
;              proportionnels).  Les lignes formes uniquement d'espaces et de caractres de soulignement, appeles
;              lignes de soulignement, ne sont pas affiches: elles sont prises en compte lors de l'affichage de la
;              ligne prcdente; chaque squence de caractres de soulignement appartenant  une ligne de souligne-
;              ment a pour effet de souligner la squence de caractres situe juste au-dessus excepts les espaces
;              situs aux extrmits de cette squence. Si la ligne ne se termine pas par un caractre de souligne-
;              ment, alors elle est aussi considre comme une ligne vide  (c'est le cas des lignes de soulignement
;              se terminant par un espace, des lignes ne contenant que des espaces et des lignes rellement vides).
;              N.B.: chaque ligne doit se terminer par un CR/LF, y compris la dernire.  N.B.: il ne faut pas avoir
;              plusieurs vraies  lignes de soulignement  successives  ("vraies"  signifie  que la ligne contient au
;              moins un caractre de soulignement), sinon il y a risque de plantage.
;         _ Mot long nul.
;      . Meilleurs scores (nom + date + heure + score). Chaque score occupe 32 octets:
;         _ 24 octets: nom + octet nul (--> la longueur du nom est comprise entre 1 et 23).
;         _ 1 mot long: score (en hexa).
;         _ 1 mot long: date et heure (format XBIOS).
;\5
;   _ Codes d'une rgle:
;      . Les parties  0, A, B, C, P, Q et S  sont codes  dans le mme langage,  RUL,  un langage trs simple  mais
;        suffisant pour dcrire une rgle.  Comme ce langage est form uniquement de codes,  on utilisera gnrale-
;        ment un mini-compilateur.  On aurait pu dcrire une rgle en assembleur  (directement ou en passant par un
;        langage de haut niveau, mais RUL est plus simple, plus concis et indpendant de la machine.
;      . RUL travaille uniquement avec des expressions, qui renvoient toujours une valeur (mais qui peut tre ind-
;        termine,  suivant l'expression).  Ces valeurs et les variables sont des mots longs signs.  Les variables
;        forment en fait un tableau d'entiers V[0..63], dont certains ont une signification spciale: V[0] contient
;        le numro de la forme (de 1  255);  V[k], pour 1  k  4,  contient la couleur (de 1  6) du k-ime hexa-
;        gone  (V[k] peut tre utilis en lecture et en criture librement par l'utilisateur  si l'hexagone corres-
;        pondant n'existe pas);  V[k+4] contient le numro du motif (de 1  255) du k-ime hexagone  (ou utilisable
;        librement par l'utilisateur);  V[9] contient le numro du signal (de 1  255) lors de la phase B;  V[9+k],
;        pour 1  k  kmax, contient la k-ime valeur affiche (la valeur maximale de k dpend du nombre de valeurs
;        affiches),  et si la variable est ngative  alors  0 est affich.  V[18] est utilis  en phase B  (cf ci-
;        dessous).  Les autres variables  peuvent tre utilises librement par l'utilisateur.  Toutes les variables
;        sont initialises  0 au dbut du jeu.  Les variables 0  8 doivent tre assignes lors de la phase A,  et
;        ne doivent pas tre modifies lors des phases B et C.
;      . Certaines expressions n'ont pas de sens (par ex. division par 0)  ou sont interdites (par ex. modification
;        de V[0] en phase B). Elles ne doivent pas intervenir, sinon il y a risque de plantage ou de dysfonctionne-
;        ment. Attention aux dpassements de capacit, qui ne sont pas vrifis!
;      . Certains codes ne correspondent pas  un lment d'expression  (branchements,  retour de fonction...).  Du
;        point de vue de la pile d'expressions, ces codes seront ignors.  Une fonction est une suite d'expressions
;        se terminant par un code "retour de fonction";  sa valeur est celle de la dernire expression  (s'il n'y a
;        aucune expression, la valeur est indtermine).
;      . Boolens: 0: faux, -1: vrai.  Les offsets (pour les branchements) sont toujours sur 16 bits,  sauf pour le
;        code $46 (branchement conditionnel sur 8 bits); l'adresse de branchement est relative  celle de l'offset.
;      . Codes:
;         _ $80  $FF: constante x - $C0 (de -64  63).
;         _ $00  $3F: variable V[x].
;         _ $40 <expr> <expr>: addition x + y.
;         _ $41 <expr> <expr>: soustraction x - y.
;         _ $42 <expr> <expr>: multiplication.
;         _ $43 <expr> <expr>: division entire (quotient: valeur approche par dfaut en valeur absolue).
;         _ $44 <expr> <expr>: dcalage  gauche. Le nombre de dcalages doit tre compris entre 0 et 63.
;         _ $45 <expr> <expr>: dcalage  droite. Le nombre de dcalages doit tre compris entre 0 et 63.
;         _ $46 <expr> <octet>:  branchement relatif sur 8 bits si le rsultat de l'expression est non nul  (pas de
;           valeur).
;         _ $47 <expr> <expr>: modulo (y > 0). Rsultat compris entre 0 et y-1.
;         _ $48 <mot>: constante sur 16 bits (tendue en 32 bits).
;         _ $49 <mot long>: constante sur 32 bits.
;         _ $4A <expr> <expr>: == (rsultat: 0 ou -1).
;         _ $4B <expr> <expr>: != (rsultat: 0 ou -1).
;         _ $4C <expr> <expr>: < (rsultat: 0 ou -1).
;         _ $4D <expr> <expr>: > (rsultat: 0 ou -1).
;         _ $4E <expr> <expr>: <= (rsultat: 0 ou -1).
;         _ $4F <expr> <expr>: >= (rsultat: 0 ou -1).
;         _ $50 <offset>: fonction (branchement  un sous-programme), considre comme une expression.
;         _ $51: retour de fonction. La valeur de la fonction est celle de la dernire expression.
;         _ $52 <offset>: branchement relatif (pas de valeur).
;         _ $53 <expr> <offset>: branchement si le rsultat de l'expression est non nul (pas de valeur).
;         _ $54 <expr>: not logique.
;         _ $55 <expr> <expr>: and logique.
;         _ $56 <expr> <expr>: or logique.
;         _ $57 <expr> <expr>: xor logique.
;         _ $58: random sur 16 bits (tendu en 32 bits).
;         _ $59: random sur 32 bits.
;         _ $5A <expr>: valeur de la variable V[expr].
;         _ $5B <expr> <expr>:  affectation.  La variable concerne et l'opration  effectuer  sont donnes par la
;           valeur de l'expression x: si x est compris entre 0 et 63, il s'agit d'une simple affection (la variable
;           numro x reoit la valeur de l'expression y);  si x est compris entre -64 et -1,  y est ajout  la va-
;           leur de la variable x+64; si x est compris entre 64 et 127, y est retranch de la valeur de la variable
;           x-64. La nouvelle valeur de la variable concerne est renvoye.
;         _ $5C <expr>:  donnes concernant la forme suivante.  Si le radar est dsactiv,  0 est toujours renvoy.
;           Dans le cas contraire,  si 0  x  8, la valeur renvoye est celle de la variable V[x] aprs le dernier
;           appel de la phase A (i.e. celle que contiendra V[x]  l'apparition de la prochaine pice),  et si x < 0
;           ou x > 9, la valeur renvoye est toujours -1.
;         _ $5D: vrai (-1) ssi on est en mode pause du jeu (cf plus bas); sinon faux (0).
;         _ $5E <expr>:  si expr  0,  brancher la variable expr au timer si elle ne l'est pas encore  (la variable
;           sera dcrmente  chaque seconde); si une autre variable tait branche au timer, elle est dbranche.
;           Si expr < 0, dbrancher la variable du timer s'il y en avait une de branche. La valeur de l'expression
;           est renvoye.
;         _ $5F <expr>:  fixer  le temps approximatif  entre 2 descentes successives d'une pice,  en millisecondes
;           (doit tre compris entre 1 et 8191). La valeur de l'expression est renvoye.
;         _ $60 <expr> <octet n> [<mot> ... <mot>]:  valeur d'un lment d'un tableau de mots constants.  Le nombre
;           de mots entre les crochets  est gal  n (taille du tableau).  Les indices des lments du tableau vont
;           de 0  n-1. L'expression est value, on prend le rsultat modulo n, et on renvoie l'lment correspon-
;           dant du tableau (qui est tendu en mot long).
;         _ $61 <expr> <octet n> [<mot long> ... <mot long>]: idem, mais avec un tableau de mots longs constants.
;         _ $62 <expr> <octet n> [<offset> ... <offset>]: branchement relatif dpendant de la valeur de l'expr.
;         _ $63 <expr>: empiler la valeur de l'expression (attention! la pile est limite), qui est renvoye.
;         _ $64: valeur du sommet de la pile (mais on ne dpile pas).
;         _ $65: dpiler un mot long, qui est renvoy.
;         _ $66 <expr>: valeur absolue.
;         _ $67 <expr>: carr. L'argument doit tenir sur un mot.
;         _ $68: random sur 15 bits (entier positif ou nul).
;         _ $69: random sur 31 bits (entier positif ou nul).
;         _ $6A <expr> <expr>: minimum des valeurs des 2 expressions.
;         _ $6B <expr> <expr>: maximum des valeurs des 2 expressions.
;         _ $6C <expr> <expr> <expr>: double comparaison, avec y  z.  Si y  x  z, alors 0 est renvoy; si x < y,
;           alors -1 est renvoy; si x > z, alors 1 est renvoy. Note: si y > z, le rsultat est indtermin.
;         _ $6D: envoyer un message (cf "Fichiers de messages", message $0207). Si on veut transmettre des donnes,
;           il faut le faire par l'intermdiaire de la pile, et il ne faudra pas oublier de dpiler ces donnes. La
;           valeur est le rsultat renvoy par le fichier de messages.
;         _ $6E  $7F: cf ci-dessous (phase C).
;      . Diffrentes phases:
;         _ Chacune des phases consiste en une fonction pouvant modifier certaines variables et renvoyant un rsul-
;           tat (pris en compte uniquement en phases B et S).
;         _ Phase 0: il s'agit de l'initialisation, effectue uniquement au dbut du jeu.
;         _ Phase A: elle consiste  initialiser V[0]  V[8], et ventuellement  mettre  jour d'autres variables.
;           Attention!  elle peut tre appele juste aprs la phase B,  en cas d'activation du radar.  Dans ce cas,
;           les variables V[0]  V[8] sont sauves avant l'appel, et rcupres juste aprs.
;         _ Phase B: le numro du signal est dans V[9]. La commande $7C (cf phase C) permet de connatre l'emplace-
;           ment de l'hexagone de rfrence de la pice courante. Le rsultat renvoy indique le comportement de la
;           pice:  0 s'il ne se passe rien de particulier,  positif s'il s'agit d'une action simple,  ngatif s'il
;           s'agit d'une action  faisant passer en phase C  ou directement  en phase S (abandon).  Lorsque l'action
;           n'est pas possible, elle n'est pas effectue. Voici les diffrents rsultats accepts par cette version
;           de TETRHEX:
;            . 0: rien.
;            . +1: un cran vers le bas.
;            . +2: un cran en bas  gauche.
;            . +3: un cran en bas  droite.
;            . +4: rotation gauche (sens trigonomtrique).
;            . +5: rotation droite (sens des aiguilles d'une montre).
;            . +6: un cran vers la gauche (mme hauteur).
;            . +7: un cran vers la droite (mme hauteur).
;            . +8: pause/fin de pause.
;            . +9: activer/dsactiver le radar.
;            . +10: envoyer un message (cf "Fichiers de messages", message $0206).
;            . -1: abandon. Passage en phase S (pas de phase C).
;            . -2: drop (la pice tombe). Le nombre de dplacements vers le bas lors du drop est mis dans V[18].
;            . -3: explosion (toutes les pices sont dtruites).  Le nombre d'hexagones dtruits (y compris ceux de
;              la pice courante) est mis dans V[18].
;            . -4: dtruire la forme courante.
;         _ Phase C: V[9] contient le numro de la dernire action  (attention!  il s'agit bien de l'action  et non
;           pas du signal),  pouvant tre utile  pour certains bonus,  par exemple  quand on droppe la pice et que
;           l'on fait une ligne, et V[18] peut contenir un rsultat complmentaire (cf ci-dessus). A chaque case du
;           grand hexagone, on associe une valeur sur 32 bits, que seul TETRHEX a besoin de connatre;  la valeur 0
;           est associe aux cases inexistantes. On peut alors effectuer des oprations sur ces valeurs: $7F <expr>
;           <expr>,  o x est une valeur associe  une case (existante ou non),  et y un angle exprim en 6mes de
;           tour;  $7F x 6n: case voisine situe juste en dessous, $7F x 6n+1: en bas  droite, $7F x 6n+2: en haut
;            droite, $7F x 6n+3: au-dessus, $7F x 6n+4: en haut  gauche, et $7F x 6n+5: en bas  gauche. Si x est
;           une case inexistante, $7F x y aussi.  $7E x: couleur de l'hexagone situ dans la case x s'il y en a un,
;           0 si cette case est vide, -1 si cette case est inexistante.  Le test "> 0" permet de savoir s'il y a un
;           hexagone dans la case, le test "<> 0" permet de savoir si la case existe et est vide;  on utilisera par
;           exemple ce test  sur les cases de hauteur fixe et de colonne -8  8 (ou de -n+1  n-1)  pour savoir si
;           la ligne est pleine (dans les 2 cas, il peut y avoir des cases inexisantes). $7D x: idem pour le numro
;           de motif.  $7C n: nombre d'hexagones (de 1  4) dans la dernire pice  si n < 0,  valeur associe  la
;           case contenant l'hexagone de rfrence de la dernire pice si n = 0,  valeur associe  la case conte-
;           nant l'hexagone n de la dernire pice sinon (attention! n ne doit pas tre suprieur au nombre d'hexa-
;           gones de la pice en question).
;             A chaque case existante est associ un tableau de 8 bits appel marques.  Ces tableaux sont initiali-
;           ss  0 au dbut du jeu (cases non marques).  On peut effectuer des oprations de marquages; les cases
;           inexistantes sont toujours considres comme non marques.
;            . $7B x m: si 0  m  7, mettre la marque m sur la case x;  si m < 0, mettre toutes les marques sur x.
;              Renvoie la valeur x.
;            . $7A x m: idem, mais on enlve les marques.
;            . $79 x m: idem, mais on inverse les marques.
;            . $78 x m: renvoie un boolen indiquant si x a la marque m (0  m  7).
;             Il existe aussi des oprations de boucles, ou plutt des oprations utilisant des ensembles de cases,
;           permettant notamment de faire un peu de rcursivit (utiles pour la recherche de composantes connexes).
;           Ces oprations renvoient toujours la valeur de l'expression value sur le dernier lment,  qui est la
;           case inexistante (0).  Pour chaque case de l'ensemble (y compris la case inexistante), la case courante
;           est stocke dans V[n], et l'expression e est value. Ci-dessous, l'ensemble est donn priv de sa case
;           inexistante.
;            . $77 n e: ensemble = toutes les cases existantes du grand hexagone.
;            . $76 n e: ensemble = toutes les cases contenant un petit hexagone.
;            . $75 n x e: ensemble = toutes les cases existantes voisines de la case x (il y en a de 0  6).
;            . $74 n x e: idem, mais les cases doivent contenir un petit hexagone.
;             Le grand hexagone est muni de coordonnes. On note n la longueur, i.e. le nombre de cases, de l'un de
;           ses cts.  Les colonnes sont numrotes de -(n-1)  +(n-1).  Chaque case est repre par sa colonne et
;           sa hauteur (0: tout en bas, 1: une case au-dessus, etc...). On peut effectuer des conversions couple de
;           coordonnes <--> valeur associe  une case:
;            . $73 x: renvoie la colonne de la case x (indtermine si cette case est inexistante).
;            . $72 x: renvoie la hauteur de la case x (indtermine si cette case est inexistante).
;            . $71 c h: renvoie la valeur associe  la case de hauteur h situe dans la colonne c  (NB: cette case
;              peut tre inexistante).
;            . $70: renvoie n (nombre de cases des cts du grand hexagone).
;             Oprations de fin de la phase C:
;            . $6F expr m: dtruit les petits hexagones situs dans les cases ayant la marque m.  Le rsultat de la
;              premire expression (expr) est ignor.  Si au moins un hexagone a t dtruit,  alors  on recommence
;              l'valuation (boucle),  sinon on passe  l'expression qui suit.  Quand un hexagone est dtruit,  les
;              hexagones situs au-dessus descendent d'une case. Note: m doit tre compris entre 0 et 7.
;            . $6E expr m:  idem,  mais on ne boucle jamais.  Si m < 0,  tous les hexagones sont dtruits.  On doit
;              toujours avoir m  7.
;             N.B.:  ces deux oprations ne peuvent tre utilises qu'en phase C  (car le smaphore cran doit tre
;           activ).
;         _ Phase P: dbut du mode pause de la fentre (cf ci-dessous).
;         _ Phase Q: fin du mode pause de la fentre (cf ci-dessous).
;         _ Phase S: elle est uniquement appele en fin de partie et doit renvoyer le score final (nombre  0, i.e.
;           le MSB doit tre nul). Pendant cette phase, le timer n'est pas actif.
;         _ Pauses:  on distingue  2 types de pauses:  mode pause de la fentre  (pause force,  lorsque la fentre
;           passe en arrire-plan) et mode pause du jeu (dclench par l'action +6).
;            . Mode pause du jeu: on passe normalement dans ce mode pause lorsque l'on reoit le signal PAUS (si on
;              n'est pas encore en mode pause), en dclenchant l'action +8, mais ce n'est pas obligatoire.  On sort
;              de ce mode pause  en redclenchant l'action +8.  Les autres actions peuvent tre dclenches en mode
;              pause du jeu,  mais   part +8 (fin de pause) et -1 (abandon),  elles n'ont aucun effet.  Attention!
;              mme en mode pause on peut recevoir n'importe quel signal;  c'est  l'utilisateur de tester s'il est
;              en mode pause ou non avant de faire certaines oprations (comme une modification de variable).
;            . Mode pause de la fentre:  on passe dans ce mode pause quand la fentre passe en arrire-plan (si le
;              jeu se droule dans une fentre GEM, notamment sous MultiTOS).  A ce moment, la phase P est appele;
;              dans cette phase,  l'ventuelle variable branche au timer  peut tre dbranche  (non obligatoire).
;              Puis le jeu  est compltement arrt  (on ne reoit plus aucun signal),  mais le timer  est toujours
;              actif.  Lorsque la fentre repasse au premier plan,  on sort de ce mode pause,  sauf cas particulier
;              (pas assez de mmoire par exemple); en cas de problme, un message d'alerte est affich.  La phase Q
;              est alors appele; si une variable avait t dbranche du timer, elle peut tre rebranche. Puis le
;              signal PAUS est envoy s'il existe, de manire  ce que le jeu ne reprenne pas immdiatement; si les
;              signaux standard n'ont pas t redfinis, PAUS existe et vaut $0A. Attention! on peut passer en mode
;              pause de la fentre  n'importe quel moment.

;\6
;  Fichiers de messages (.MSG):
;  
;   _ Les fichiers de messages permettent  TETRHEX de communiquer avec l'extrieur. Plusieurs fichiers de messages
;     peuvent tre chargs; dans ce cas, ils forment une chane, le dernier fichier charg (i.e. le dernier fichier
;     dans la chane d'options) tant le plus prioritaire (cf ci-dessous). En fait, TETRHEX.PRG contient un fichier
;     de messages, appel fichier terminal (car c'est le moins prioritaire).
;\4
;   _ Protocole d'envoi de messages:  TETRHEX ou une routine d'un fichier de messages peut envoyer un message de la
;     faon suivante:  D0.W doit contenir le type du message,  et A0 un pointeur sur une structure, forme d'un mot
;     long qui est l'adresse de la routine du fichier de messages le plus prioritaire (adresse du fichier + 4),  et
;     d'autres donnes ventuelles dpendant du type du message. Au retour, D0.L doit contenir le rsultat, dont la
;     signification dpend du type du message envoy; les autres registres ne doivent pas tre modifis.  Lorsqu'un
;     fichier de messages reoit un message,  il doit trater le message s'il le peut (suivant le type du message),
;     et le passer au fichier de messages suivant. Cette opration peut ne pas tre effectue dans certains cas. Si
;     elle l'est,  elle se droule de la manire suivante:  D0.W, A0 et (A0).L doivent avoir les valeurs donnes au
;     dbut;  l'adresse de la routine du fichier suivant se trouve  l'adresse du fichier courant, i.e.  l'adresse
;     de la routine courante - 4;  connaissant l'adresse de la routine  appeler, on fait soit un branchement, soit
;     un appel de sous-programme (pour modifier le rsultat). Note: le fichier terminal renvoie 0 comme rsultat et
;     ne fait rien d'autre.
;\4
;   _ Voici les diffrents types de messages:
;      $0000: non spcifi (dpend du fichier de messages).
;      $0001: initialisation.  Message envoy aprs appl_init.  4(A0).W: identificateur de l'application.  6(A0).B:
;             flag d'affichage des messages d'erreur errflag.  Renvoie 0 si pas d'erreur;  si un nombre non nul est
;             renvoy, TETRHEX est quitt avec le mot de poids faible de ce nombre comme code de retour.
;      $0002: fin du programme. Message envoy avant appl_exit.
;      $0003: dbut de la prsentation.
;      $0004: affichage du menu (l'image de fond n'est pas encore affiche).  Renvoie un nombre non nul ssi il faut
;             librer l'image de fond (ce qui permet de la changer, cf message $0006).
;      $0005: menu affich (attente d'un vnement).
;      $0006: calcul de l'image de fond.  Si le rsultat est nul, cette image doit tre calcule par TETRHEX (image
;             par dfaut).  Dans le cas contraire, l'image de fond a t calcule par le fichier de messages, et le
;             rsultat est l'adresse de l'image.  L'image, sur laquelle sera affich ensuite le grand hexagone, est
;             forme de 7 plans 624 x 416 non entrelacs (format VDI), les valeurs des pixels tant comprises entre
;             0 et 95 (i.e. les deux bits de poids fort ne sont pas simultanment  1);  la palette (96 mots longs)
;             se trouve juste aprs l'image. N.B.: le bloc de mmoire contenant la nouvelle image de fond doit tre
;             rserv par le sous-programme du fichier de messages;  mais il ne pourra tre libr que par TETRHEX,
;             soit automatiquement  (car il ne reste plus beaucoup de mmoire),  soit  la demande de l'utilisateur
;             (CTRL-F ou clic droit), soit avec un message (cf message $0004).
;      $0007: nouveau fichier de rgle charg. 4(A0).L: adresse de ce fichier de rgle. Ce message est envoy juste
;             aprs le chargement d'un fichier de rgle,  y compris aprs celui du premier fichier (dans ce cas, ce
;             message est envoy entre $0001/$0003 et $0004).
;      $0008: aide sur TETRHEX. Ce message n'est envoy que si l'aide existe bien.
;      $0009: aide sur le fichier de rgle. Ce message n'est envoy que si l'aide existe bien.
;      $000A: entre du nom du joueur.
;      $000B: dbut du jeu. Message envoy avant l'valuation de la partie 0 de la rgle.
;      $000C: affichage des meilleurs scores.
;      $0100: passage en mode PAUSE. Message envoy aprs l'valuation ventuelle de la partie P de la rgle.
;      $0101: fin du mode PAUSE. Message envoy avant l'valuation ventuelle de la partie Q de la rgle.
;      $0200: non spcifi (dpend du fichier de messages). Message ayant un rapport avec le jeu.
;      $0201: dbut du jeu. 4(A0).L: pointeur de pile du jeu. 8(A0).L: pointeur sur les variables du jeu. 12(A0).L:
;             pointeur sur le fichier de rgle. Message envoy aprs l'valuation de la partie 0 de la rgle.
;      $0202: fin du jeu (game over). 4(A0).L: score.  Message envoy aprs l'valuation de la partie S de la rgle
;             (videmment) et avant la libration de la mmoire rserve au jeu (variables, pile, ...).
;      $0203: prochaine pice.  Les donnes concernant cette pice ne sont pas stockes dans la structure (A0), car
;             on peut y accder par l'intermdiaire des variables du jeu. Ce message est envoy avant l'affichage.
;      $0204: une pice vient d'tre affiche.
;      $0205: action. 4(A0).L: numro de l'action. Ce message est envoy juste aprs l'valuation de la partie B de
;             la rgle et la mise  jour des nombres, et avant l'excution de l'action.
;      $0206: message envoy par l'action +10. 4(A0).L: pointeur de pile du jeu GSP. Les donnes ont t mises dans
;             la pile du jeu.  Le mot long (GSP) contient le nombre de donnes (mots longs) empiles  (N.B.: ce mot
;             long n'est pas compris dans les donnes); ces donnes seront dpiles par TETRHEX juste aprs l'envoi
;             du message.
;      $0207: message envoy par l'interprteur RUL (commande 6D). 4(A0).L: pointeur de pile du jeu.
;      $0208: message envoy juste avant la phase A. Si le rsultat est non nul, la phase A ne sera pas excute et
;             le message $0209 ne sera pas envoy.
;      $0209: message envoy juste aprs la phase A.
;      $0300: lecture d'un signal. 4(A0).L: code de la touche si une touche a t frappe, sinon 0. Si aucun signal
;             n'est dtect et si la touche frappe n'est pas prise en compte, 0 doit tre renvoy (TETRHEX prendra
;             la touche en compte  et fera passer le signal ventuel   la partie B du fichier de rgle).  Si aucun
;             signal n'est dtect  et si la touche frappe ne correspond  aucun signal  ou ne doit pas tre prise
;             en compte, une valeur ngative doit tre renvoye. Si un signal est dtect (dernier cas),  cause de
;             la touche ventuelle ou d'une autre raison, le nom du signal (mot long) est renvoy.
;      $0301: mulation d'une touche de fonction.  Une valeur entre 1 et 20  est renvoye  pour muler la touche de
;             fonction correspondante.
;      $0302: mulation  d'un vnement  dans le menu principal.  Signification  des valeurs n  renvoyes:  0:  pas
;             d'vnement,  1: aide  sur TETRHEX,  2: aide  sur la rgle,  3: charger une rgle,  4: nom du joueur,
;             5: jouer,  6: meilleurs scores,  7: arrire-plan,  8: quitter,  16  19: tableau de n-10 hexagones de
;             ct,  -1  -20: meilleurs scores (touche de fonction F(-n)).
;      $0303: mulation d'un vnement pendant l'entre du nom du joueur. Signification des valeurs n renvoyes: 0:
;             pas d'vnement,  1  255: caractre  affichable ou non  (3: ctrl-C,  8: backspace,  13: return,  27:
;             escape), -1: flche droite, -2: flche vers le haut.
;      $0304: mulation de la touche Esc  la fin du jeu.  Un rsultat non nul  doit tre renvoy  pour revenir  au
;             menu principal.
;      $0400: message AES de type  128 (non pris en compte par Tetrhex). 4(A0).L: pointeur sur le tableau msg.
;      $0401: touche non prise en compte par Tetrhex dans le menu principal. 4(A0).W: tat des touches spciales du
;             clavier (cf evnt_button). 6(A0).W: code de la touche enfonce, scancode dans l'octet de poids fort et
;             code ASCII dans l'octet de poids faible (cf evnt_keybd).

;\7
;    Ŀ
;     Options 
;    

               OPT  O+  ;Optimise au maximum.
               MC68030  ;Processeur 68030.
               USER     ;Interdit l'utilisation des instructions privilgies.

;\7
;    Ŀ
;     Equivalences 
;    

;  Version:
REGISTERED     equ  -1                      ;-1: version spciale, 0: version non enregistre, 1: version enregistre.
vers           equ  1                       ;Version.
subvers        equ  $41                     ;Sous-version (en DCB).
thdate         equ  $19960202               ;Date ($YYYYMMDD).
subv1          equ  subvers>>4              ;1er chiffre de la sous-version.
subv2          equ  subvers&$F              ;2me chiffre de la sous-version.
;\4
;  Clavier:
ctrl           equ  2                       ;Cf evnt_button.
ctrl_c         equ  'C'&$1F                 ;Code ASCII de CTRL-C.
ctrl_f         equ  'F'&$1F                 ;Code ASCII de CTRL-F.
bs             equ  'H'&$1F                 ;Code ASCII de CTRL-H (backspace).
lf             equ  'J'&$1F                 ;Code ASCII de CTRL-J (line feed).
cr             equ  'M'&$1F                 ;Code ASCII de CTRL-M (carriage return: return/enter).
ctrl_q         equ  'Q'&$1F                 ;Code ASCII de CTRL-Q.
esc            equ  $1B                     ;Code ASCII de ESC.
f1             equ  $3B                     ;Scancode de la touche F1 (positif).
f10            equ  f1+9                    ;Scancode de la touche F10.
f11            equ  $54                     ;Scancode de la touche F11 (shift-F1).
f20            equ  f11+9                   ;Scancode de la touche F20 (shift-F10).
tab            equ  $0F                     ;Scancode de la touche TAB.
return         equ  $1C                     ;Scancode de la touche RETURN.
help           equ  $62                     ;Scancode de la touche HELP.
undo           equ  $61                     ;Scancode de la touche UNDO.
clrhome        equ  $47                     ;Scancode de la touche CLR-HOME.
downarrow      equ  $50                     ;Scancode de la flche gauche.
rightarrow     equ  $4D                     ;Scancode de la flche droite.
uparrow        equ  $48                     ;Scancode de la flche vers le haut.
numpad         equ  $63                     ;Scancode de la touche '(' du pav numrique.
crlf           equ  cr<<8+lf                ;CR/LF.
;\4
;  Traps:
gemdos         equ  1   ;Trap GEMDOS.
gem            equ  2   ;Trap GEM.
usr_trap       equ  8   ;Trap sur sup_switch.
bios           equ  13  ;Trap BIOS.
xbios          equ  14  ;Trap XBIOS.
;\4
;  GEMDOS:
Crawio         equ  $6  ;Crawio: teste si une touche a t enfonce.
Cconws         equ  $9  ;Cconws: crit une chane de caractres sur la sortie std.
Dsetdrv        equ  $0E ;Dsetdrv: fixe le disque courant.
Dgetdrv        equ  $19 ;Dgetdrv: retourne le disque courant.
Fsetdta        equ  $1A ;Fsetdta: fixe la nouvelle DTA.
d_length       equ  26  ;Offset du champ length de la DTA.
d_fname        equ  30  ;Offset du champ fname de la DTA.
Dsetpath       equ  $3B ;Dsetpath: fixe le chemin courant.
Fopen          equ  $3D ;Fopen: ouvre un fichier.
Fclose         equ  $3E ;Fclose: ferme un fichier.
Fread          equ  $3F ;Fread: lit dans un fichier.
Fwrite         equ  $40 ;Fwrite: crit dans un fichier.
Fseek          equ  $42 ;Fseek: positionnement dans un fichier.
Dgetpath       equ  $47 ;Dgetpath: retourne le chemin courant.
Malloc         equ  $48 ;Malloc: rserve un bloc de mmoire.
Mfree          equ  $49 ;Mfree: libre un bloc de mmoire.
Mshrink        equ  $4A ;Mshrink: libre de la mmoire.
Pterm          equ  $4C ;Pterm: fin du prg.
Fsfirst        equ  $4E ;Fsfirst: recherche le 1er fichier satisfaisant certaines conditions --> DTA.
;\4
;  BIOS:
_p_cookies     equ  $5A0  ;Adr. du ptr sur la cookie jar.
ikbd_dev       equ  $40000  ;Port clavier (n de priphrique * $10000).
Bconout        equ  3   ;Bconout: envoie un caractre  un priphrique.
Setexc         equ  5   ;Setexc: lit ou modifie un vecteur d'exception.
Kbshift        equ  11  ;Kbshift: avec paramtre le -1, lit l'tat des touches spciales du clavier.
;\4
;  XBIOS:
Logbase        equ  3   ;Logbase: renvoie l'adr. de l'cran logique.
Getrez         equ  4   ;Getrez: renvoie le code du mode graphique (sert  v_opnvwk).
Setscreen      equ  5   ;Setscreen: change de mode graphique et rinitialisation de la VDI.
Random         equ  17  ;Random: renvoie un nb alatoire sur 24 bits.
Gettime        equ  23  ;Gettime: renvoie la date et l'heure.
Offgibit       equ  29  ;Offgibit: annule certains bits du port A du sound chip.
Ongibit        equ  30  ;Ongibit: met  1 certains bits du port A du sound chip.
Xbtimer        equ  31  ;Xbtimer: lance ou arrte un timer.
Vsync          equ  37  ;Vsync: attend la prochaine interruption VBL.
Supexec        equ  38  ;Supexec: excute une routine en mode superuser.
Vsetmode       equ  88  ;Vsetmode: en mode lecture, renvoie le mode graphique courant.
VsetRGB        equ  93  ;VsetRGB: modifie la couleur des feutres.
VgetRGB        equ  94  ;VgetRGB: rcupre la couleur des feutres.
gpo            equ  6   ;Numro du bit General Purpose Output (GPO = 1 qd le haut-parleur interne est coup).
;\4
;  AES:
appl_init      equ  10
appl_exit      equ  19
appl_write     equ  12
evnt_mesag     equ  23
ac_close       equ  41  ;
ac_open        equ  40  ;
ap_term        equ  50  ;
wm_alliconify  equ  36  ;
wm_bottom      equ  33  ;
wm_closed      equ  22  ; Types de
wm_iconify     equ  34  ;
wm_moved       equ  28  ; message.
wm_ontop       equ  31  ;
wm_redraw      equ  20  ;
wm_topped      equ  21  ;
wm_untopped    equ  30  ;
wm_uniconify   equ  35  ;
evnt_multi     equ  25
mu_keybd       equ  $01 ;
mu_button      equ  $02 ; Paramtres pour
mu_mesag       equ  $10 ; evnt_multi.
mu_timer       equ  $20 ;
evnt_timer     equ  24
form_alert     equ  52
fsel_exinput   equ  91
graf_handle    equ  77
graf_mouse     equ  78
arrow          equ  0   ;
busy_bee       equ  2   ; Paramtres pour
m_off          equ  256 ; graf_mouse.
m_on           equ  257 ;
menu_register  equ  35
wind_calc      equ  108
wind_create    equ  100
wind_set       equ  105
wf_name        equ  2   ;
wf_currxywh    equ  5   ; Paramtres pour
wf_bottom      equ  25  ;
wf_iconify     equ  26  ; wind_set.
wf_uniconify   equ  27  ;
wind_open      equ  101
wind_update    equ  107
beg_update     equ  1   ; Paramtres pour
end_update     equ  0   ; wind_update.
wind_get       equ  104
wf_workxywh    equ  4   ;
wf_top         equ  10  ; Paramtres pour
wf_firstxywh   equ  11  ; wind_get.
wf_nextxywh    equ  12  ;
wind_close     equ  102
wind_delete    equ  103
;\4
;  VDI:
mfdb           RSSTRUCT                     ;--> MFDB.
               RSRESET
fd_addr        rs.l     1                   ;Ptr sur l'image (NULL si c'est l'cran).
fd_width       rs.w     1                   ;Largeur en pixels.
fd_height      rs.w     1                   ;Hauteur en pixels.
fd_wdwidth     rs.w     1                   ;Largeur en mots.
fd_stand       rs.w     1                   ;Format (0: plans entrelacs, 1: format VDI).
fd_planes      rs.w     1                   ;Nb de plans.
reserved1      rs.w     1                   ;Rserv (0).
reserved2      rs.w     1                   ;Rserv (0).
reserved3      rs.w     1                   ;Rserv (0).
               RSEND
;\4
v_opnvwk       equ  100 ;Open virtual workstation.
v_clsvwk       equ  101 ;Close virtual workstation.
v_clrwk        equ  3   ;Clear workstation.
v_pline        equ  6   ;Polyline.
v_fillarea     equ  9   ;Fill area.
v_ftext        equ  241 ;Output outline text.
v_gtext        equ  8   ;Output graphic text.
gdp            equ  11  ;Generalized Drawing Primitives.
v_justified    equ  10  ;Output justified text (GDP).
vqt_extent     equ  116 ;Inquire graphic text extent.
vqt_f_extent   equ  240 ;Inquire outline text extent.
vqt_fontinfo   equ  131 ;Inquire current face information.
vqt_width      equ  117 ;Inquire character cell width.
vr_recfl       equ  114 ;Filled rectangle.
vr_trnfm       equ  110 ;Transform form.
vro_cpyfm      equ  109 ;Copy raster, opaque.
replace        equ  3   ;Paramtre pour vro_cpyfm: S (mode replace).
sandd          equ  1   ;Paramtre pour vro_cpyfm: S and D.
trans          equ  7   ;Paramtre pour vro_cpyfm: S or D (mode transparent).
erase          equ  4   ;Paramtre pour vro_cpyfm: (not S) and D (mode erase).
vrt_cpyfm      equ  121 ;Copy raster, transparent.
vs_clip        equ  129 ;Set clipping rectangle.
vsf_color      equ  25  ;Set fill color index.
vsl_color      equ  17  ;Set polyline color index.
vst_color      equ  22  ;Set text color index.
vst_load_fonts equ  119 ;Load fonts.
vst_unload_fonts equ 120 ;Unload fonts.
vst_font       equ  21  ;Set text face.
vst_height     equ  12  ;Set character height, absolute mode.
vst_arbpt      equ  246 ;Set point size (outline font).
vst_setsize    equ  252 ;Set character width (outline font).
vst_alignment  equ  39  ;Set graphic text alignment.
vst_rotation   equ  13  ;Set graphic text angle.
vst_effects    equ  106 ;Set graphic text effects.
underline      equ  8   ;Paramtre pour vst_effects: soulignement.
vswr_mode      equ  32  ;Set writing mode.
md_trans       equ  2   ;Paramtre pour vswr_mode et vrt_cpyfm (mode transparent).
;\4
;  Timers:
timerA         equ  0   ;N du timer A pour XBIOS.
timerD         equ  3   ;N du timer D pour XBIOS.
btimrA         equ  5   ;N du bit correspondant au timer A dans ISRA.
btimrD         equ  4   ;N du bit correspondant au timer D dans ISRB.
isra           equ  $FFFFFA0F  ;Interrupt In Service Register A.
isrb           equ  $FFFFFA11  ;Interrupt In Service Register B.
;\4
;  Rsolutions graphiques:
vertflag       equ  $0100
overscan       equ  $0040
pal_flag       equ  $0020
vga_flag       equ  $0010
col80          equ  $0008
bps8           equ  3
vga_bit        equ  4
;\4
;  Divers:
stack_len      equ  $2000                   ;Taille de la pile: 8 Ko.
smagic         equ  'Smag'                  ;Mot long utilis pour dtecter les stack overflow.
strlen         equ  208                     ;Taille du buffer string.
nhdef          equ  9                       ;Nb de petits hex. par dfaut dans un ct du gd hex.
nhmin          equ  6                       ;Nb min. de petits hex. dans un ct du gd hex.
nhmax          equ  9                       ;Nb max. de petits hex. dans un ct du gd hex.
langlen        equ  31                      ;Longueur maxi de la liste des langages.
xvlp           equ  158                     ;Abscisse minimale de "V.L. presents".  Image initiale
yvlp           equ  60                      ;Ordonne minimale de "V.L. presents".  (monochrome).
dvlp           equ  xvlp&$F
               IFGE     dvlp-4
fvlp           equ  0
               ELSE
fvlp           equ  16
               ENDIF
wvlp           equ  xvlp&~$F-fvlp
nvlp           equ  (330-xvlp)/8
linlen         equ  60                      ;TETRHEX: une ligne fait 469 bits de long (60 octets). Multiple de 4.
nlines         equ  137                     ;TETRHEX: 137 lignes. Impair.
tetr1p         equ  linlen*nlines           ;TETRHEX: taille d'un plan en octets.
bufl1          equ  32000                   ;Taille du 1er buffer (cf ?fire).
buflen         equ  bufl1+tetr1p*8          ;Taille totale des 2 buffers.
fheight        equ  47                      ;Hauteur du bloc "TETRHEX x.xx" (cf prparation de l'cran de jeu).
pllen          equ  fheight*80              ;Taille d'un plan pour "TETRHEX x.xx" (cf prparation de l'cran de jeu).
fbufl          equ  3*(pllen+mfdb.SIZEOF)   ;Taille d'un mini-buffer (cf affichage du texte en plusieurs couleurs).
ctrend         equ  $7FFF
ctt            equ  2                       ;--> N/3 Hz.
nfire          equ  11
windx          equ  8                       ;Abscisse de l'intrieur de la fentre (zone de travail).
windy          equ  48                      ;Ordonne de l'intrieur de la fentre (zone de travail).
windw          equ  624                     ;Largeur de l'intrieur de la fentre (zone de travail).
windh          equ  416                     ;Hauteur de l'intrieur de la fentre (zone de travail).
wkind          equ  $400B                   ;Fentre: NAME + CLOSER + MOVER + SMALLER.
windl          equ  windw/8                 ;Taille d'une ligne de l'intrieur de la fentre en octets.
wplen          equ  windl*windh             ;Taille d'un plan de l'intrieur de la fentre en octets.
wdlen          equ  8*wplen                 ;Taille de l'intrieur de la fentre en octets.
px             equ  18                      ;Abscisse de la zone o sera affich "-- PAUSE --" en mode pause du jeu.
py             equ  8                       ;Ordonne de la zone o sera affich "-- PAUSE --" en mode pause du jeu.
pww            equ  14                      ;Largeur, en mots, de cette zone. 16|(pww+2).
ph             equ  48                      ;Hauteur de la zone o sera affich "-- PAUSE --" en mode pause du jeu.
plnlen         equ  2*(pww+2)               ;Taille d'une ligne d'un plan de la zone "-- PAUSE --" en octets.
ppllen         equ  plnlen*ph               ;Taille d'un plan de la zone "-- PAUSE --" en octets.
nmen           equ  8                       ;Nb max de lignes du menu.
fcolor         equ  16                      ;Index de la 1re couleur  tre modifie.
swcolor        equ  96                      ;Index de la couleur de "Shareware" et de "registered to".
srcolor        equ  97                      ;Index de la couleur du texte situ en dessous.
mfcolor        equ  98                      ;Index de la couleur du nom du fichier de rgle.
mtcolor        equ  99                      ;Index de la couleur du titre du menu.
mlcolor        equ  100                     ;Index de la couleur de la 1re ligne du menu.
kcolor         equ  239                     ;Index de la dernire couleur  tre modifie, une fois la prsentation termine.
lcolor         equ  251                     ;Index de la dernire couleur  tre modifie.
tcolor         equ  231                     ;Index de la couleur de l'heure.
dcolor         equ  230                     ;Index de la couleur de la date.
pcolor         equ  229                     ;Index de la couleur de "-- PAUSE --" (en mode pause du jeu).
gcolor         equ  228                     ;Index de la couleur de "game over".
hcolor         equ  239                     ;Index de la couleur de l'aide (tous les bits sauf 1 sont  1).
ycolor         equ  239                     ;Index de la couleur de "Votre nom:" et du nom (tous les bits sauf 1 sont  1).
smcolor        equ  224                     ;Index de la couleur de "F1-F20: scores." et "ESC: menu." (bits 0 et 1: nuls).
bcolor         equ  227                     ;Index de la couleur du tableau la plus lumineuse.
nind           equ  24                      ;Index, dans tcol, de la couleur du nom de la rgle.
angle          equ  300                     ;Angle de rotation pour l'affichage de "game over".
ysc0           equ  40                      ;Ordonne de la 1re ligne de score (par rapport  la zone de travail).
dysc           equ  36                      ;Distance entre 2 lignes de score successives.
ysc1           equ  ysc0+9*dysc             ;Ordonne de la dernire ligne de score.
xhex           equ  18                      ;Distance entre 2 colonnes (de petits hexagones) successives.
yhex           equ  20                      ;Distance entre 2 petits hexagones successifs d'une mme colonne.
hexw           equ  26                      ;Largeur totale du cadre d'un petit hexagone.
hexh           equ  22                      ;Hauteur totale du cadre d'un petit hexagone.
inhy           equ  18                      ;Hauteur d'un petit hexagone.
ky             equ  24                      ;Placement du gd hex.: centrage + dplacement de ky pixels vers le bas.
npix           equ  288                     ;Nb de pixels dans un petit hex.
xmen           equ  352                     ;Abscisse du texte du menu.
xxt            equ  360                     ;Limite gauche pour le texte lors du jeu (limite droite: windw-16).
pdeflen        equ  108                     ;Taille d'un motif dans la dfinition des motifs.
patpl          equ  21*4                    ;Taille d'un plan d'une img contenant un motif (21 lignes de 25 pixels).
patlen         equ  patpl*3                 ;Taille d'une img contenant un motif (21 lignes de 25 pixels, 3 plans).
shap_h         equ  81                      ;Nb de lignes d'une img contenant une forme.
shap_bw        equ  79+1                    ;Largeur, en pixels, d'une ligne d'une img contenant une forme (+ 1 colonne vide).
shap_ww        equ  (shap_bw+15)>>4+1       ;Largeur, en mots, d'une ligne d'une img contenant une forme (on ajoute un mot).
shapwln        equ  shap_h*shap_ww          ;Taille, en mots, d'un plan d'une img contenant une forme.
shaplen        equ  2*shapwln               ;Taille, en octets, d'un plan d'une img contenant une forme.
shposlen       equ  3+7*shapwln             ;Taille, en mots, d'un bloc offset + img contenant une forme.
sbkgrlen       equ  1+8*shapwln             ;Taille, en mots, de l'image contenant le fond, y compris le nb de lignes - 1.
simglen        equ  shposlen*6              ;Taille, en mots, des 6 img avec offsets.
ncmax          equ  (3*nhmax*(nhmax-1)+1)   ;Nb max d'hex. dans le gd hexagone.
hexlen         equ  inhy*8                  ;Taille, en mots longs, d'une image contenant une case.
hbklen         equ  hexlen*ncmax            ;Taille, en mots longs, de la zone hexbk.
rmdlen         equ  10*ncmax                ;Taille, en octets, de la zone rmd.hex.
tdrop          equ  2                       ;Tps en 1/96 s entre 2 descentes successives lors d'un drop.
sigdown        equ  1                       ;N du signal DOWN.
sigpaus        equ  10                      ;N du signal PAUS.
vcol           equ  1                       ;N de la variable contenant la couleur du 1er hex.
vpat           equ  5                       ;N de la variable contenant le motif du 1er hex.
vsig           equ  9                       ;N de la variable contenant le n du signal.
vact           equ  9                       ;N de la variable contenant le n de la dernire action avant la phase C.
vnum0          equ  10                      ;N de la variable contenant la 1re valeur  afficher.
vnum           equ  vnum0-1                 ;N de la variable prcdant celle contenant la 1re valeur  afficher.
vcpl           equ  18                      ;N de la variable contenant une info complmentaire lors de la phase C.
namelen        equ  24                      ;Longueur maxi du nom du joueur (octet nul compris).
sc_rank2       equ  12                      ;Abscisse  laquelle il faut afficher le chiffre des centaines du rang.
sc_rank1       equ  sc_rank2+16             ;Abscisse  laquelle il faut afficher le chiffre des dizaines du rang.
sc_rank0       equ  sc_rank1+16             ;Abscisse  laquelle il faut afficher le chiffre des units du rang.
sc_name        equ  76                      ;Abscisse  laquelle il faut afficher le nom du joueur.
sc_nlen        equ  224                     ;Longueur de la zone rserve au nom.
sc_score       equ  312                     ;Abscisse  laquelle il faut afficher le score.
sc_date1       equ  456                     ;Abscisse  laquelle il faut afficher le chiffre des dizaines de la date.
sc_date0       equ  sc_date1+16             ;Abscisse  laquelle il faut afficher le chiffre des units de la date.
sc_dm          equ  sc_date0+16             ;Abscisse  laquelle il faut afficher le sparateur date/mois.
sc_month1      equ  sc_dm+16                ;Abscisse  laquelle il faut afficher le chiffre des dizaines du mois.
sc_month0      equ  sc_month1+16            ;Abscisse  laquelle il faut afficher le chiffre des units du mois.
sc_my          equ  sc_month0+16            ;Abscisse  laquelle il faut afficher le sparateur mois/anne.
sc_year        equ  sc_my+16                ;Abscisse  laquelle il faut afficher l'anne.
hname          equ  20                      ;Hauteur des noms.
ynx1           equ  16                      ;
yny1           equ  12                      ; Coord. du rectangle affich lorsque
ynx2           equ  336                     ; le joueur doit entrer son nom.
yny2           equ  48                      ;
yndx           equ  ynx2-ynx1-16            ;Largeur de la zone de texte pour le nom du joueur.
hlpf           equ  92                      ;1re ligne de la zone de texte pour l'aide.
hlpl           equ  411                     ;Dernire ligne de la zone de texte pour l'aide.
hlpm           equ  8                       ;Taille des marges gauche et droite.
hlpw           equ  windw-2*hlpm            ;Largeur de la zone de texte pour l'aide.
hlpy           equ  16                      ;Diffrence entre les ordonnes de 2 lignes successives.
hlpn           equ  (hlpl-hlpf+1)/hlpy      ;Nb de lignes de texte pour l'aide.
dtx0           equ  9                       ;
dtx1           equ  88                      ;
dtx2           equ  17                      ; Valeurs utilises
dty0           equ  60                      ; pour  l'affichage
dty1           equ  80                      ; de la date  et de
dtz            equ  12                      ; l'heure.
dty2           equ  dty0+(dtz<<1)           ;
dty3           equ  dty1+(dtz<<1)           ;
;\4
;  Valeurs initiales des compteurs pour limiter le jeu  5 mn.

tps96a0        equ  300*96+17               ;Valeur initiale du 1er compteur (< $8000).
tps96b0        equ  300*96-29               ;Valeur initiale du 2nd compteur (< $8000).
;\2
breg           equ  24                      ;Place prise par les registres suivants.
REGS           reg  d0-d3/a1/a2             ;Registres utiliss par mk_tetrhex.
;\4
msg_init       equ  $0001                   ;Initialisation.
msg_exit       equ  $0002                   ;Fin du prg.
msg_pres       equ  $0003                   ;Dbut de la prsentation.
msg_menu1      equ  $0004                   ;Affichage du menu.
msg_menu2      equ  $0005                   ;Menu affich.
msg_bkgr       equ  $0006                   ;Calcul de l'img de fond.
msg_ldrul      equ  $0007                   ;Nouveau fichier de rgle charg.
msg_helpt      equ  $0008                   ;Aide sur TETRHEX.
msg_helpr      equ  $0009                   ;Aide sur le fichier de rgle.
msg_pname      equ  $000A                   ;Entre du nom du joueur.
msg_play1      equ  $000B                   ;Dbut du jeu.
msg_hisc       equ  $000C                   ;Affichage des meilleurs scores.
msg_pause      equ  $0100                   ;Passage en mode PAUSE.
msg_endp       equ  $0101                   ;Fin du mode PAUSE.
msg_rul        equ  $0200                   ;Offset des msg du jeu.
msg_play2      equ  $0201                   ;Dbut du jeu.
msg_gamov      equ  $0202                   ;Fin du jeu (game over).
msg_next       equ  $0203                   ;Prochaine pice.
msg_disp       equ  $0204                   ;Pice affiche.
msg_doact      equ  $0205                   ;Une action doit tre effectue.
msg_act10      equ  $0206                   ;Msg envoy par l'action +10.
msg_inrul      equ  $0207                   ;Msg envoy par l'interprteur RUL.
msg_preva      equ  $0208                   ;Msg envoy juste avant la phase A.
msg_nexta      equ  $0209                   ;Msg envoy juste aprs la phase A.
msg_sig        equ  $0300                   ;Signal?
msg_fct        equ  $0301                   ;Emulation de l'appui sur une touche de fct.
msg_wmenu      equ  $0302                   ;Emulation d'un vnement dans le menu principal.
msg_wname      equ  $0303                   ;Emulation d'un vnement pdt l'entre du nom du joueur.
msg_wesc       equ  $0304                   ;Emulation de la touche Esc  la fin du jeu.
msg_evnt       equ  $0400                   ;Msg de type  128 (non pris en compte par Tetrhex).
msg_mkey       equ  $0401                   ;Touche dans le menu principal non prise en compte par Tetrhex.
;\4
rul            RSSTRUCT                     ;--> header du fichier de rgle.
               RSRESET
magic          rs.l     1                   ;Mot long magique "RUL3".
pcol           rs.l     1                   ;Couleur de "-- PAUSE --" en mode pause du jeu (0, R, G, B). 
gcol           rs.l     1                   ;Couleur de "game over" (0, R, G, B).                        
ycol           rs.l     1                   ;Couleur de "Votre nom:" et du nom (0, R, G, B).             
ncol           rs.l     1                   ;Couleur du nom de la rgle (0, R, G, B).                    
high           rs.w     1                   ;Hauteur par dfaut du nom de la rgle.
name           rs.b     24                  ;Nom de la rgle, termin par un octet nul.
fntn           rs.w     1                   ;Identificateur de la fonte Speedo utilise pour afficher le nom de la rgle.
fntg           rs.w     1                   ;Identificateur de la fonte Speedo utilise pour afficher les noms des valeurs.
nptn           rs.b     1                   ;Nb de motifs.
nshp           rs.b     1                   ;Nb de formes.
nsig           rs.b     1                   ;Nb de signaux.
nhex           rs.b     1                   ;Nb de petits hexagones dans un ct du gd hexagone.
nsc6           rs.b     1                   ;Nb de scores pour 6 hexagones.
nsc7           rs.b     1                   ;Nb de scores pour 7 hexagones.
nsc8           rs.b     1                   ;Nb de scores pour 8 hexagones.
nsc9           rs.b     1                   ;Nb de scores pour 9 hexagones.
nms6           rs.b     1                   ;Nb maxi de scores pour 6 hexagones.
nms7           rs.b     1                   ;Nb maxi de scores pour 7 hexagones.
nms8           rs.b     1                   ;Nb maxi de scores pour 8 hexagones.
nms9           rs.b     1                   ;Nb maxi de scores pour 9 hexagones.
stkl           rs.l     1                   ;Taille de la pile.
sdef           rs.l     1                   ;Offset sur la dfinition des signaux.
vdef           rs.l     1                   ;Offset sur la dfinition des nb  afficher.
rul0           rs.l     1                   ;Offset sur la partie 0 de la rgle.
rulA           rs.l     1                   ;Offset sur la partie A de la rgle.
rulB           rs.l     1                   ;Offset sur la partie B de la rgle.
rulC           rs.l     1                   ;Offset sur la partie C de la rgle.
rulP           rs.l     1                   ;Offset sur la partie P de la rgle.
rulQ           rs.l     1                   ;Offset sur la partie Q de la rgle.
rulS           rs.l     1                   ;Offset sur la partie S de la rgle.
text           rs.l     1                   ;Offset sur le texte.
hisc           rs.l     1                   ;Offset sur les meilleurs scores.
               RSEND
;\6
sco            RSSTRUCT                     ;--> dfinition d'un lment du tableau des scores.
               RSRESET
name           rs.b     24                  ;Nom du joueur.
score          rs.l     1                   ;Score.
date           rs.l     1                   ;Date et heure.
               RSEND
;\4
nbr            RSSTRUCT                     ;--> dfinition d'un nb  afficher.
               RSRESET
max            rs.b     1                   ;Nb max de chiffres.
min            rs.b     1                   ;Nb min de chiffres.
txth           rs.b     1                   ;Hauteur du texte.
numh           rs.b     1                   ;Hauteur du nb.
txtc           rs.l     1                   ;Couleur du texte.                   
zerc           rs.l     1                   ;Couleur des "0" non significatifs.  
digc           rs.l     1                   ;Couleur des chiffres significatifs. 
pos            rs.b     1                   ;Position du nom par rapport au nb.
text           rs.b     0                   ;Texte (dans plusieurs langues).
               RSEND
;\5
;  Donnes concernant un nb  afficher:
;    Pendant le jeu,  jusqu' 8 nb (score, niveau, ...) peuvent tre affichs.  A chacun de ces nb,  on associe une
;  structure et des zones de mmoire servant  l'affichage.  Un nb peut avoir de 1  8 chiffres; chaque chiffre est
;  form par l'affichage de segments  (comme les caractres de code ASCII de 16  25).  Chaque segment  est en fait
;  form de 3 segments, de longueurs respectives ds, ds+1, ds. 2 chiffres conscutifs sont espacs de dg pixels. On
;  distingue les chiffres significatifs (1er chiffre non nul au chiffre des units) et les "0" non significatifs (
;  gauche du 1er chiffre non nul); si le nombre est nul, il n'y a aucun chiffre significatif.
;    On considre la partie rectangulaire minimale de la zone de travail contenant tous les pixels qui peuvent tre
;  modifis lors de l'affichage du nb.  On agrandit cette partie de l'image de fond  de 15 pixels vers la gauche et
;  vers la droite.  Cette image est stocke dans **pb  (*pb contient une struct. MFDB),  dans le format std VDI  (8
;  plans, non entrelacs);  note:  les bits ventuels situs  chaque fin de ligne,  servant  l'alignement sur les
;  mots, sont indtermins (car ils n'ont aucune importance).
;    Pour obtenir l'image stocke dans *pz,  on dcale l'image *pb de xd pixels vers la gauche, de manire  ce que
;  chaque mot de cette image corresponde  un mot de la destination (sur l'cran);  puis on affiche sur cette image
;  les "0" non significatifs  (leur nombre dpend  du nb de chiffres significatifs  et  du nb minimal de chiffres 
;  afficher).
;    Le masque est une image monochrome,  recalcule (en partie)   chaque fois que l'on doit afficher une nouvelle
;  valeur. Les bits  1 correspondent aux pixels affichs des chiffres significatifs.  Le masque invers est le NOT
;  du masque; il est recalcul juste aprs le masque et est situ en mmoire aprs celui-ci.
;    A chaque mode pause de la fentre (et  chaque fin de partie), la mmoire utilise par les images est libre.
;  Ces images devront donc tre entirement recalcules aprs chaque mode pause de la fentre.

num            RSSTRUCT                     ;--> nb  afficher.
               RSRESET
lv             rs.l     1                   ;Dernire valeur affiche, en DCB.
pt             rs.l     1                   ;Ptr sur le texte (dans la langue choisie).
at             rs.w     1                   ;Alignement du texte (code  stocker dans INTIN pour vst_alignment).
x0             rs.w     1                   ;Position gauche du rectangle de clipping pour le texte. 
x1             rs.w     1                   ;Position droite du rectangle de clipping pour le texte. 
xt             rs.w     1                   ;Abscisse  laquelle doit tre affich le texte.         
yt             rs.w     1                   ;Ordonne  laquelle doit tre affich le texte.         
xi             rs.w     1                   ;Abscisse du point suprieur gauche de l'image.          
yi             rs.w     1                   ;Ordonne du point suprieur gauche de l'image.          
th             rs.w     1                   ;Hauteur du texte.                                                            
nz             rs.w     1                   ;Nb minimal de chiffres  afficher.                                           
nd             rs.w     1                   ;Nb maximal de chiffres  afficher.                                           
ns             rs.w     1                   ;Nb de chiffres significatifs (du 1er chiffre non nul au chiffre des units). 
ds             rs.w     1                   ;Longueur d'un segment (entre 3 et 56).                                       
dg             rs.w     1                   ;Nb de pixels entre 2 chiffres conscutifs (entre 1 et 63).                   
dh             rs.w     1                   ;Hauteur des chiffres (= hauteur de l'image).                                 
ct             rs.w     1                   ;Index de la couleur du texte.                                                
cz             rs.w     1                   ;Index de la couleur des "0" non significatifs (situs  gauche).             
cs             rs.w     1                   ;Index de la couleur des chiffres significatifs.                              
ll             rs.w     1                   ;Largeur de l'image dcale, en octets.
pl             rs.l     1                   ;Taille d'un plan de l'image dcale.
xd             rs.l     1                   ;Dcalage vers la gauche (cf ci-dessus), de 0  15.
xl             rs.l     1                   ;Largeur de l'image + 30 (cf ci-dessus), en pixels.
pb             rs.l     1                   ;Ptr sur l'image de fond sauvegarde, non dcale.                
pz             rs.l     1                   ;Ptr sur l'image de fond avec les "0" non significatifs, dcale. 
pm             rs.l     1                   ;Ptr sur le masque (chiffres significatifs), dcal.              
               RSEND
;\4
;  Donnes sur la fonte n *sfontid (pour l'affichage des meilleurs scores).
;    Il n'existe pas de fct systme  permettant d'afficher du texte sur seulement 1 plan.  On doit donc stocker les
;  caractres en mmoire aprs les avoir affich  un moment convenable (praffichage), pour pouvoir faire soi-mme
;  l'affichage sur 1 plan. Le praffichage se fait lorsque la zone de travail est noire (et de couleur XBIOS -1) et
;  que les couleurs sont noires; ainsi, on ne s'aperoit pas de l'affichage des caractres. On pourrait prafficher
;  tous les caractres de la fonte, mais ceci prendrait trop de temps avec une fonte vectorielle.  On ne praffiche
;  donc que les caractres qui sont dans les meilleurs scores,  i.e. seulement les caractres dont on a besoin.  Si
;  le joueur doit crire son nom  un moment donn,  on peut afficher les caractres avec une fonction systme (sur
;  8 plans); mais qd les scores devront tre affichs, de nouveaux caractres pourront tre affichs. On devra donc
;  faire un test pour dtecter les nouveaux caractres stocker en mmoire.
;    Les caractres  sont stocks  ligne par ligne,  i.e. la 1re ligne de chaque caractre,  puis la 2me ligne de
;  chaque caractre, et ainsi de suite (en allant de bas en haut). Chaque ligne commence sur un nouvel octet. Qd un
;  caractre n'a pas t praffich,  on laisse l'espace ncessaire dans la table  (on connat la largeur de chaque
;  caractre, mme de ceux qui n'ont pas t praffichs).
;    Le flag de verrouillage sf.lock  est activ  lorsque la structure  ne doit pas tre libre,  i.e. lorsque les
;  meilleurs scores sont affichs au mme moment:  en effet, si on appuie sur une nouvelle touche de fonction,  des
;  caractres seront affichs.  Note: qd ce flag est dsactiv, la struct. est libre par CTRL-F (ou clic gauche),
;  ou lorsque la mmoire libre devient trop petite.
;    Le flag sf.newrule permet de savoir si une nouvelle rgle a t charge depuis la dernire fois que les scores
;  ont t affichs. Dans ce cas, il faut reparcourir la liste des scores.
;    Les mots sf.bottom et sf.top  servent  lors de l'affichage des caractres.  Le mot sf.llen  sert  calculer le
;  dbut des diffrentes lignes de la table.  La largeur de chaque caractre  (de code ASCII 32  255)  est stocke
;  dans sf.width  (on stocke 0 qd le caractre n'existe pas).  Les offsets des donnes correspondant aux caractres
;  sont stocks dans sf.offset: il s'agit d'offsets en bits par rapport au dbut de la ligne (comme la largeur d'un
;  caractre ne dpend pas de la ligne, l'offset est le mme pour chaque ligne).
;    Le tableau sf.flags permet de savoir  si un caractre est dj stock en mmoire ou s'il doit tre praffich.
;  On a un 0  si le caractre n'a pas t stock en mmoire et s'il ne se trouve pas dans les meilleurs scores  (il
;  ne doit donc pas tre praffich pour l'instant).  On a 1  si le caractre  n'a pas encore t stock en mmoire
;  mais se trouve dans les meilleurs scores (dans un nouveau score):  on devra le prafficher la prochaine fois que
;  les meilleurs scores seront affichs. On a un nb strictement ngatif si le caractre a t stock en mmoire.
;\4
sf             RSSTRUCT
               RSRESET
lock           rs.b     1                   ;Flag de verrouillage (ngatif: struct. ne doit pas tre libre). 
newrule        rs.b     1                   ;0 si une nouvelle rgle a t charge, ngatif sinon.             
bottom         rs.w     1                   ;Ecart de la Bottom line  la Base line.                           
top            rs.w     1                   ;Ecart de la Top line  la Base line.                              
llen           rs.w     1                   ;Largeur, en octets, d'une ligne dans la table.
width          rs.b     224                 ;Largeur des caractres, 0 si caractre inexistant.
flags          rs.b     224                 ;Ngatif si les donnes de la table sont valides pour ce caractre.
offset         rs.w     224                 ;Offset (en bits) du caractre dans la table, par rapport au dbut de la table.
               RSEND

;\6
;    Ŀ
;     Macros 
;    

msys           MACRO
               move.w   #\1,-(sp)           ;;Code de fct.
               trap     #\3                 ;;Appelle GEMDOS/BIOS/XBIOS.
               add.l    #\2,sp              ;;Nettoie la pile.
               ENDM
;\3
mgemdos        MACRO
               msys     \1,\2,gemdos
               ENDM
;\3
mbios          MACRO
               msys     \1,\2,bios
               ENDM
;\3
mxbios         MACRO
               msys     \1,\2,xbios
               ENDM
;\4
maes           MACRO
               lea      control(pc),a0

               IFEQ     \4

               IFEQ     \3-1

               IFEQ     \2-1
               move.w   #\1,(a0)+           ;;opcode.
               bsr      aes1                ;;Stocke 1, 1 et 0, et appelle l'AES.
               ELSE
               move.l   #\1<<16+\2,(a0)+    ;;opcode et int_in.

               IFEQ     \#-4
               bsr      aes2                ;;Stocke 1 et 0, et appelle l'AES.
               ELSE
               bra      aes2                ;;Stocke 1 et 0, appelle l'AES, et retour.
               ENDIF

               ENDIF

               ELSE
               move.l   #\1<<16+\2,(a0)+    ;;opcode et int_in.
               move.w   #\3,(a0)+           ;;int_out.

               IFEQ     \#-4
               bsr      aes3                ;;Stocke 0, et appelle l'AES.
               ELSE
               bra      aes3                ;;Stocke 0, appelle l'AES, et retour.
               ENDIF

               ENDIF

               ELSE
               move.l   #\1<<16+\2,(a0)+    ;;opcode et int_in.
               move.l   #\3<<16+\4,(a0)     ;;int_out et addrin.

               IFEQ     \#-4
               bsr      aes                 ;;Appelle l'AES.
               ELSE
               bra      aes                 ;;Appelle l'AES, et retour.
               ENDIF

               ENDIF

               ENDM
;\4
mvdi           MACRO
               lea      contrl(pc),a0

               IFEQ     \2
               move.w   #\1,(a0)+           ;;Code d'opration.
               clr.w    (a0)                ;;Taille de PTSIN.
               move.w   #\3,4(a0)           ;;Taille de INTIN.
               ELSE
               move.l   #\1<<16+\2,(a0)     ;;Code d'opration et taille de PTSIN.
               move.w   #\3,6(a0)           ;;Taille de INTIN.
               ENDIF

               IFNE     \1-v_opnvwk         ;;Si l'opcode n'est pas v_opnvwk:

               IFEQ     \#-3
               bsr      hvdi                ;;Stocke le handle graphique et appelle la VDI.
               ELSE
               bra      hvdi                ;;Stocke le handle graphique, appelle la VDI et retour.
               ENDIF

               ELSE                         ;;Si l'opcode est v_opnvwk:
               bsr      vdi                 ;;Appelle la VDI.
               ENDIF

               ENDM
;\4
intvdi         MACRO
               lea      contrl(pc),a0
               move.w   #\1,(a0)+           ;;Code d'opration.
               IFEQ     \#-1
               bsr      zero_vdi            ;;Appelle la VDI (taille de INTIN: 1, taille de PTSIN: 0).
               ELSE
               bra      zero_vdi            ;;Appelle la VDI (taille de INTIN: 1, taille de PTSIN: 0), et retour.
               ENDIF
               ENDM
;\4
xbrgb          MACRO
               pea      \2                  ;;Adr. du tableau des couleurs.
               move.w   #256,-(sp)          ;;Nb de pinceaux.
               clr.w    -(sp)               ;;N du 1er pinceau.
               mxbios   \1,10               ;;Appelle XBIOS: modifie/rcupre la couleur des pinceaux.
               ENDM
;\5
mcrawio        MACRO
               move.l   #$FF+Crawio<<16,-(sp)  ;;Fct Crawio avec paramtre $FF.
               trap     #gemdos             ;;Teste le clavier.
               addq.l   #4,sp               ;;Nettoie la pile.
               ENDM
;\4
dispstr        MACRO
               pea      \1                  ;;Empile l'adr. de la chane  afficher.
               mgemdos  Cconws,6            ;;Fct Cconws.
               ENDM
;\4
fre_mem        MACRO
               clr.w    -(sp)               ;;Dummy.
               mgemdos  Mshrink,12          ;;Fct Mshrink.
               ENDM
;\3
mvers          MACRO
               ascii    "TETRHEX \<$vers>.\<$subv1>\<$subv2>"
               ENDM

;\7
;    Ŀ
;     Initialisation 
;    

               TEXT

               bra      start               ;Dbut du prg.
;\6
;  Affiche la date et l'heure s'il le faut (registres modifis: D0-D7/A0-A6).

disp_date:     move.w   disptime(pc),d3     ; Branch. si on doit afficher
               bne.s    ddate_lbl0          ; la date ou l'heure.
ddate_rts:     rts                          ;Retour.
ddate_lbl0:    clr.w    d7                  ;
               move.w   d3,d0               ; D7.W = dtz  si 2 rectangles doivent
               lsr.w    #8,d0               ; tre affichs (affichage de la date
               and.w    d0,d3               ; ET de l'heure), D7.W = 0 si un seul
               bne.s    ddate_lbl1          ; rectangle doit tre affich.
               moveq    #dtz,d7             ;
ddate_lbl1:    lea      (dateflag,pc),a3    ;(A3).B: dateflag, 1(A3).L: lastdate.
               lea      intin-dateflag(a3),a6  ;A6: adr. du tableau INTIN.
               tas      (a3)+               ; Branch. si les rectangles sont dj affichs (le MSB est mis  1, pour
               bmi.s    ddate_lbl2          ; indiquer qu'ils seront affichs sauf si on passe en mode PAUSE).
               bsr      fill_col1           ;Couleur de remplissage: 1 (noir).
               bsr      beg_windupd         ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM...
               bmi.s    ddate_rts           ;Branch. si on est pass en mode PAUSE.
               moveq    #dty0,d4            ;
               moveq    #dty1,d6            ;
               add.w    d7,d4               ; Cadre du 1er rectangle.
               add.w    d7,d6               ;
               bsr      rect_datime         ;
               move.l   #(dtx0+1)<<16+(dty0+1),d0  ;
               move.l   #(dtx1-1)<<16+(dty1-1),d1  ;
               add.w    d7,d0                      ; 1er rectangle noir.
               add.w    d7,d1                      ;
               bsr      frect1                     ;
               moveq    #dty2,d4            ;
               moveq    #dty3,d6            ;
               sub.w    d7,d4               ; Cadre du 2nd rectangle.
               sub.w    d7,d6               ;
               bsr      rect_datime         ;
               move.l   #(dtx0+1)<<16+(dty2+1),d0  ;
               move.l   #(dtx1-1)<<16+(dty3-1),d1  ;
               sub.w    d7,d0                      ; 2nd rectangle noir.
               sub.w    d7,d1                      ;
               bsr      frect1                     ;
               bsr      end_windupd         ;Fin de mise  jour de la fentre si le jeu se droule dans une fentre GEM.
               clr.l    (a3)                ;Annule lastdate (dernire date/heure affiche).
ddate_lbl2:    mxbios   Gettime,2           ;D0.L: date et heure.
               cmp.l    (a3),d0             ; Branch. si la date/heure
               beq.s    ddate_rts           ; n'a pas chang.
               move.l   (a3),d1             ;Rcupre lastdate.
               movea.w  d0,a4               ;A4.W: heure.
               move.l   d0,(a3)             ;Met  jour lastdate.
               moveq    #-1,d5              ; Branch. avec D5.W < 0 si ni
               tst.l    d1                  ; la date,  ni l'heure  n'est
               beq.s    ddate_lbl3          ; affiche.
               moveq    #0,d5               ;
               lsr.w    #5,d0               ;
               lsr.w    #5,d1               ;
               cmp.w    d0,d1               ;
               beq.s    ddate_lbl3          ; D5.L = 0 si ni les heures et ni les minutes n'ont
               moveq    #24,d5              ;  tre raffiches, D5.L = 24 si les heures n'ont
               lsr.w    #6,d0               ; pas  tre raffiches, sinon D5.L = 48.
               lsr.w    #6,d1               ;
               cmp.w    d0,d1               ;
               beq.s    ddate_lbl3          ;
               moveq    #48,d5              ;
ddate_lbl3:    move.w   d7,d6               ;D6.W = dtz (date ou heure) ou 0 (date et heure).
               tst.b    dispdate(pc)        ; Branch. si on ne doit pas afficher la
               beq.s    disp_time0          ; date (on doit donc afficher l'heure).
               clr.w    d0                  ; Branch. si la date n'a pas
               cmp.l    d0,d1               ; chang (on ne la raffiche
disp_time0:    bcc      disp_time1          ; donc pas).
               swap     d0                  ; D7.W:
               move.w   d0,d7               ; date.
               bsr      beg_windupd         ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM...
               bmi      ddate_rts           ;Branch. si on est pass en mode PAUSE.
               tst.w    d5                  ; Branch. si une ancienne date n'est pas
               bmi.s    ddate_lbl4          ; affiche (on ne l'efface donc pas).
               bsr      fill_col1           ;Couleur de remplissage: 1 (noir).
               move.l   #dtx2<<16+(dty0+1),d0       ;
               move.l   #(dtx2+63)<<16+(dty1-1),d1  ;
               add.w    d6,d0                       ; Efface l'ancienne date.
               add.w    d6,d1                       ;
               bsr      frect1                      ;
ddate_lbl4:    moveq    #dcolor,d0          ; Index de la couleur de la date: dcolor.
               bsr      col_align           ; Alignement: gauche, base line.
               movea.l  a6,a0               ;Adr. de INTIN (o il faut stocker la chane  afficher).
               moveq    #10,d2              ;D2.W = 10 (pour ddate_calc).
               move.w   d7,d0               ;Rappel: D7.W = date (anne: 7 bits,  mois: 4 bits, jour: 5 bits).
               lsl.w    #7,d0               ; D0.W: mois dcal de D2 bits vers
               lsr.w    #2,d0               ; la gauche (entre 1 et 12).
               clr.w    d4                  ; D4.W: sparateur
               move.b   sepdate(pc),d4      ; de la date.
               bsr      ddate_calc1         ;Stocke le mois et le sparateur dans INTIN.
               move.w   d7,d0               ; D0.W: jour (entre
               andi.w   #$1F,d0             ; 1 et 31).
               bsr      ddate_calc2         ;Stocke le jour et le sparateur dans INTIN.
               move.w   d7,d0               ;
               moveq    #9,d1               ; D0.W: anne - 1980.
               lsr.w    d1,d0               ;
               moveq    #100,d1             ;
               addi.w   #80,d0              ;
ddate_loop:    sub.w    d1,d0               ; D0.W: anne % 100.
               bcc.s    ddate_loop          ;
               add.w    d1,d0               ;
               bsr      ddate_calc2         ;Stocke l'anne (et le sparateur, inutile) dans INTIN.
               lea      6(a6),a0            ;
               move.b   fmtdate(pc),d0      ;
               lsr.b    #1,d0               ; Intervertit le mois et
               bcc.s    ddate_lbl5          ; le jour  si  le format
               move.l   (a0),d1             ; de la date l'exige.
               move.l   (a6),(a0)           ;
               move.l   d1,(a6)             ;
ddate_lbl5:    moveq    #12,d4              ;D4.L = 12 (utile si l'anne ne doit pas tre affiche).
               tst.b    dispdate(pc)        ; Branch. si l'anne ne doit
               bpl.s    ddate_lbl6          ; pas tre affiche.
               clr.w    d4                  ;D4.L = 0 (car l'anne doit tre affiche).
               lsr.b    #1,d0               ;
               bcc.s    ddate_lbl6          ; Place l'anne au dbut
               move.l   (a0),d0             ; (avant  le mois  et le
               move.l   (a6),(a0)           ; jour)  si le format de
               move.l   6(a0),(a6)          ; la date l'exige.
               move.l   d0,6(a0)            ;
ddate_lbl6:    swap     d4                  ;D4.L = $C0000 (anne non affiche) ou 0 (anne affiche).
               moveq    #dty3-dty1,d3       ; Affiche la
               bsr.s    disp_datime         ; date.
disp_time1:    moveq    #0,d4               ;D4.L = 0 (utile si les secondes doivent tre affiches).
               tst.b    disptime(pc)        ; Branch. si on ne doit
               beq      ddate_rts           ; pas afficher l'heure.
               bmi.s    disp_time2          ; D4.L = $C0000 si les
               moveq    #12,d4              ; secondes  ne doivent
               swap     d4                  ; pas tre affiches.
disp_time2:    bsr      beg_windupd         ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM...
               bmi      ddate_rts           ;Branch. si on est pass en mode PAUSE.
               swap     d5                  ; Branch. si une ancienne heure n'est pas
               bmi.s    disp_time3          ; affiche (on ne l'efface donc pas).
               bsr      fill_col1           ;Couleur de remplissage: 1 (noir).
               move.l   #(dtx2+48)<<16+(dty2+1),d0  ;
               move.w   d6,d5                       ;
               sub.l    d5,d0                       ;
               add.l    d4,d0                       ; Efface l'ancienne
               move.l   #(dtx2+63)<<16+(dty3-1),d1  ; heure.
               sub.w    d6,d1                       ;
               sub.l    d4,d1                       ;
               bsr      frect1                      ;
disp_time3:    moveq    #tcolor,d0          ; Index de la couleur de l'heure: tcolor.
               bsr      col_align           ; Alignement: gauche, base line.
               movea.l  a6,a0               ;Adr. de INTIN (o il faut stocker la chane  afficher).
               move.w   a4,d0               ;Rappel: A4.W = heure (heures: 5 bits, minutes: 6 bits, secondes: 5 bits + bit nul).
               moveq    #11,d1              ; D0.W: heures (entre
               lsr.w    d1,d0               ; 0 et 23).
               tst.b    fmttime(pc)         ; Branch. si l'affichage des heures doit
               bne.s    disp_time4          ; se faire sur 24 heures: de 0  23.
               add.w    d1,d0               ;
               ext.l    d0                  ;
               divu.w   #12,d0              ; D0.W: heures entre 1 et 12.
               swap     d0                  ;
               addq.w   #1,d0               ;
disp_time4:    moveq    #10,d2              ;D2.W = 10 (pour ddate_calc).
               move.l   d4,d3               ;Sauve D4 ($C0000 ou 0).
               move.b   septime(pc),d4      ;D4.W: sparateur de l'heure.
               bsr.s    ddate_calc2         ;Stocke les heures et le sparateur dans INTIN.
               lsl.w    #5,d0               ; Stocke les minutes et le
               bsr.s    ddate_calc1         ; sparateur dans INTIN.
               lsl.w    d1,d0               ; Stocke les secondes (et le sparateur,
               bsr.s    ddate_calc1         ; inutile) dans INTIN.
               move.l   d3,d4               ;Rcupre D4 ($C0000 ou 0).
               clr.w    d3                  ;D3.W = 0 pour l'affichage de l'heure.
               neg.w    d6                  ;D6.W = -dtz (date ou heure) ou 0 (date et heure).
disp_datime:   movea.l  (a6),a5             ;Sauve les 2 premires valeurs de INTIN.
               moveq    #1,d7               ; Slectionne la fonte
               bsr      set_font1           ; n1 (fonte systme).
               moveq    #13,d7              ; Fixe la hauteur des caractres
               bsr      char_height         ; (hauteur normale).
               move.l   a5,(a6)             ;Rcupre les 2 premires valeurs de INTIN.
               moveq    #8,d0               ;
               move.l   d4,d1               ;
               beq.s    disp_datim2         ;
               moveq    #5,d0               ; Affiche la date
disp_datim2:   addi.l   #dtx2<<16+dty3-4,d1 ; ou l'heure.
               sub.w    d3,d1               ;
               add.w    d6,d1               ;
               bsr      disp_text           ;
               bra      end_windupd         ;Fin de mise  jour de la fentre si le jeu se droule dans une fentre GEM.
;\4
ddate_calc1:   lsr.w    d2,d0               ;
ddate_calc2:   ext.l    d0                  ;
               divu.w   d2,d0               ; Stocke 2 chiffres
               swap     d0                  ; dans INTIN.
               ori.l    #'0'<<16+'0',d0     ;
               move.l   d0,(a0)+            ;
               move.w   d4,(a0)+            ;Stocke le sparateur dans INTIN.
               move.w   a4,d0               ;Pour l'affichage de l'heure: met l'heure dans D0.
               rts                          ;Retour.
;\6
;  Affiche "Shareware".

               IFGE     REGISTERED
sw_disp:       move.w   wfontid(pc),d7      ; Slectionne la fonte de n *wfontid si SpeedoGDOS
               bsr      sfont_cb            ; est install. Affichage centr, base line.
               moveq    #swcolor,d0         ; Couleur de
               bsr      text_color          ; la ligne.
               lea      sw_fonthi(pc),a5    ;Adr. des hauteurs des caractres (0 --> hauteur pas encore dtermine).
               move.w   (a5),d7             ;Hauteur des caractres pour "Shareware", ou 0 si non dtermine.
               bne.s    sw_lbl1             ;Branch. si la hauteur des caractres a dj t dtermine.
               moveq    #60,d7              ;
sw_loop1:      subq.b   #4,d7               ;
               cmpi.b   #8,d7               ;
               beq.s    sw_lbl1             ;
               bsr      char_height         ; Dtermine la hauteur des caractres (min. 8).
               lea      shareware(pc),a0    ;
               bsr      text_extent         ;
               cmpi.w   #xmen-64,d0         ;
               bcc.s    sw_loop1            ;
sw_lbl1:       move.w   d7,(a5)+            ;Stocke la hauteur des caractres.
               bsr      char_height         ;Fixe la hauteur des caractres.
               lea      shareware(pc),a0      ;
               move.l   #(xmen/2)<<16+192,d1  ; Affiche le texte:
               bsr      copy_text             ; "Shareware".
               bsr      disp_text             ;
;\7
;  Effet sur le texte: pour chaque pixel n'appartenant pas au texte "Shareware", si un des 4 pixels situs en bas, en bas
;   droite,  droite, en haut  droite, appartient au texte,  alors le pixel courant est mis  la couleur 64 (noir).  On
;  va faire les calculs  sur un rectangle encadrant le texte (et ne contenant initialement que des pixels du texte et des
;  pixels du fond); un pixel de ce rectangle appartient au texte ou a t mis  la couleur 64 ssi son plan 7 est nul.  Le
;  rectangle aura pour longueur 16 * (xmen/16-1). Puisque l'criture se fera directement  l'cran, il faudra rserver de
;  la mmoire dans la pile  pour y stocker la ligne courante (partie haute) et la ligne situe en dessous (partie basse).
;  Comme on devra lire les pixels situs  gauche des pixels tests, on ne testera pas les pixels de la 1re colonne.
;\4
               moveq    #46,d1              ; Le point suprieur gauche du rectangle sur lequel on va
               moveq    #127,d6             ; faire les calculs  est l'extrmit gauche  du groupe de
               bsr      dsc_addrxy          ; 16 pixels (align) contenant le point (30=46-16,127).
               subq.l   #2,a1               ;A1: plan 7 de ce point.
               lea      -4*(xmen/16-1)(sp),sp  ;Rserve de la mmoire dans la pile pour 2 lignes du rectangle.
               movea.l  a1,a0                 ;
               lea      2*(xmen/16-1)(sp),a4  ;
               moveq    #xmen/16-2,d6         ; Stocke la 1re ligne (situe en haut) dans
sw_loop3:      move.w   (a0),(a4)+            ; la partie haute de la mmoire rserve.
               lea      16(a0),a0             ;
               dbf      d6,sw_loop3           ;
               moveq    #72,d7              ;D7.W: hauteur du rectangle - 1 (compteur).
sw_oouter:     lea      (a1,d4.l),a0        ;
               movea.l  sp,a4               ; Stocke  la ligne  situe en dessous
               moveq    #xmen/16-2,d6       ; de la ligne courante dans la partie
sw_loop4:      move.w   (a0),(a4)+          ; basse de la mmoire rserve (note:
               lea      16(a0),a0           ; A1 = adr de la ligne courante).
               dbf      d6,sw_loop4         ;
               movea.l  a1,a0               ;A0: adr. du 1er groupe de la ligne courante.
               moveq    #xmen/16-2,d6       ;D6.W: nb de groupes - 1 dans une ligne du rectangle (compteur).
               moveq    #14,d5              ;On ne teste pas les pixels de la 1re colonne --> on commence par le pixel 14.
sw_iouter:     move.w   (a4)+,d0            ;Lit le prochain groupe de 16 pixels (plan 7).
               cmpi.w   #-1,d0              ; Branch. s'ils sont tous  1, i.e.
               beq.s    sw_nextgroup        ; s'ils appartiennent tous au fond.
sw_oinner:     btst     d5,d0               ;Teste le pixel courant.
               bne.s    sw_nextpixel        ;Branch. s'il appartient au fond.
               addq.b   #1,d5               ;Incr. le n du pixel --> pixel situ  gauche.
               cmpi.b   #16,d5              ; Branch. si le pixel situ  gauche
               beq.s    sw_lbl3             ; n'est pas dans le mme groupe.
               pea      sw_lbl4(pc)         ;Adr.  laquelle il faudra se brancher aprs sw_test3 (--> 3 pixels  gauche).
sw_test3:      adda.l   d4,a0               ;A0: adr. du pixel situ en dessous.
               bsr.s    sw_test1            ;--> mise  la couleur 64 du pixel situ en dessous ?
               suba.l   d4,a0               ;A0: adr. du pixel courant.
sw_test2:      suba.l   d4,a0               ;A0: adr. du pixel situ au-dessus.
               bsr.s    sw_test1            ;--> mise  la couleur 64 du pixel situ au-dessus ?
               adda.l   d4,a0               ;A0: adr. du pixel courant. --> mise  la couleur 64 du pixel courant ?
sw_test1:      move.w   (a0),d1             ;
               bclr     d5,d1               ;
               beq.s    sw_rts              ;
               move.w   d1,(a0)             ;
               move.w   -(a0),d1            ;
               bset     d5,d1               ; Si le pixel (A0,D1) appartient au
               move.w   d1,(a0)             ; fond, i.e. si son plan 7 est  1,
               moveq    #5,d2               ; alors on le met  la couleur 64.
sw_iinner:     move.w   -(a0),d1            ;
               bclr     d5,d1               ;
               move.w   d1,(a0)             ;
               dbf      d2,sw_iinner        ;
               lea      14(a0),a0           ;
sw_rts:        rts                          ;Retour.
sw_lbl3:       clr.b    d5                  ;D5.B: n du pixel situ  gauche.
               lea      -16(a0),a0          ;A0: adr. du mot (plan 7) contenant le pixel situ  gauche.
               bsr.s    sw_test3            ;--> pixels situs en bas  gauche, en haut  gauche et  gauche.
               lea      16(a0),a0           ;A0: adr. du mot (plan 7) contenant le pixel courant.
               moveq    #16,d5              ;Rcupre l'ancienne valeur de D5 aprs l'incrmentation.
sw_lbl4:       subq.b   #1,d5               ;D5.B: n du pixel courant.
               bsr.s    sw_test2            ;--> pixel situ au-dessus.
sw_nextpixel:  dbf      d5,sw_oinner        ;Boucle (passe au pixel situ  droite).
sw_nextgroup:  lea      16(a0),a0           ;A0: adr. du mot suivant.
               moveq    #15,d5              ;D5.B: n du pixel suivant (MSB du mot suivant).
               dbf      d6,sw_iouter        ;Boucle (passe au groupe de 16 pixels suivant).
               movea.l  sp,a4                 ;
               lea      2*(xmen/16-1)(sp),a0  ; Recopie  la partie basse  de  la mmoire
               moveq    #xmen/16-2,d6         ; rserve (ligne suivante) dans la partie
sw_loop5:      move.w   (a4)+,(a0)+           ; haute (ligne courante).
               dbf      d6,sw_loop5           ;
               adda.l   d4,a1               ;A1: adr. de la ligne suivante.
               dbf      d7,sw_oouter        ;Boucle (passe  la ligne suivante).
               lea      4*(xmen/16-1)(sp),sp  ;Rcupre la mmoire rserve pour les 2 lignes.
               move.w   rfontid(pc),d7      ; Slectionne la fonte de n *rfontid
               bsr      set_font1           ; si SpeedoGDOS est install.
               moveq    #srcolor,d0         ; Couleur de la ligne = srcolor.
               bsr      col_align           ; Alignement: gauche, base line.
               move.w   (a5),d7             ;Hauteur des caractres pour le texte situ en dessous, ou 0 si non dtermine.
               bne.s    sw_lbl2             ;Branch. si la hauteur des caractres a dj t dtermine.
               IFNE     REGISTERED          ;
               lea      reg_name(pc),a0     ;
               moveq    #31,d0              ;
               clr.b    d1                  ;
               moveq    #-7,d7              ; S'il s'agit de la version
sw_decode:     move.b   (a0),d2             ; enregistre, on dcode le
               eor.b    d1,(a0)             ; nom  de la personne enre-
               eor.b    d7,(a0)+            ; gistre.
               move.b   d2,d1               ;
               muls.w   #-11,d7             ;
               dbf      d0,sw_decode        ;
               ENDIF                        ;
               moveq    #22,d7              ;
sw_loop2:      subq.b   #2,d7               ;
               cmpi.b   #6,d7               ;
               beq.s    sw_lbl2             ;
               bsr      char_height         ;
               IFNE     REGISTERED          ; Dtermine la hauteur maximale des caractres
               movea.l  alert_swrt+4(pc),a0 ; (min. 6)  pour que la 1re ligne ne soit pas
               ELSE                         ; trop longue.
               movea.l  alert_swl1+4(pc),a0 ;
               ENDIF                        ;
               bsr      text_extent         ;
               cmpi.w   #xmen-96,d0         ;
               bcc.s    sw_loop2            ;
sw_loop6:      IFNE     REGISTERED          ;
               lea      reg_name(pc),a0     ;
               ELSE                         ;
               movea.l  alert_swl2+4(pc),a0 ;
               ENDIF                        ; Dtermine la hauteur des
               bsr      text_extent         ; caractres (min. 6) pour
               cmpi.w   #xmen-96,d0         ; que la 2de ligne ne soit
               bcs.s    sw_lbl2             ; pas trop longue.
               subq.b   #2,d7               ;
               bsr      char_height         ;
               cmpi.b   #6,d7               ;
               bne.s    sw_loop6            ;
sw_lbl2:       move.w   d7,(a5)             ;Stocke la hauteur des caractres.
               bsr      char_height         ;Fixe la hauteur des caractres.
               moveq    #64,d0              ;Index de la couleur de remplissage: 64.
               bsr      fill_color          ;SET FILL COLOR INDEX.
               move.l   #40<<16+202,d0         ;
               move.l   #(xmen-40)<<16+226,d1  ; Affiche un rectangle noir  (couleur 64),
               add.w    d7,d1                  ; dans lequel on affichera les 2 lignes de
               add.w    d7,d1                  ; texte (sous "Shareware").
               bsr      frect1                 ;
               move.w   #xmen-96,d5         ;Longueur max. du texte  afficher (en pixels).
               lea      copy_text(pc),a4    ;Adr. de la routine de copie du texte.
               IFNE     REGISTERED          ;
               movea.l  alert_swrt+4(pc),a5 ;
               ELSE                         ;
               movea.l  alert_swl1+4(pc),a5 ; Affiche la 1re ligne.
               ENDIF                        ;
               move.l   #48<<16+208,d4      ;
               bsr.s    disp_justf0         ;
               IFNE     REGISTERED          ;
               lea      reg_name(pc),a5     ;
               ELSE                         ;
               movea.l  alert_swl2+4(pc),a5 ; Affiche la 2nde
               ENDIF                        ; ligne...
               move.l   #48<<16+216,d4      ;
               add.w    d7,d4               ;
disp_justf0:   add.w    d7,d4               ;
               movea.l  a5,a0               ;A0: adr. du texte  afficher.
               ENDIF
disp_justif:   jsr      (a4)                ; D0.W: longueur du texte en pixels
               bsr      call_extent         ; s'il n'est pas justifi.
               cmp.w    d0,d5               ; Branch. si c'est trop grand: on justifie,
               bls.s    disp_justf2         ; mme si la fonte est vectorielle.
no_justif:     movea.l  a5,a0               ;
               jsr      (a4)                ; Affiche le texte (non
               move.l   d4,d1               ; justifi), et retour.
               bra      disp_text           ;
disp_justf2:   move.l   #10001,(a6)+        ;Justification entre les lettres et entre les mots.
               movea.l  a5,a0               ;
               jsr      (a4)                ;
               subq.l   #4,a6               ;
               subq.w   #1,d0               ; Affiche le texte (justifi),
               lea      ptsin-intin(a6),a0  ; et retour.
               move.l   xy0(pc),(a0)        ;
               add.l    d4,(a0)+            ;
               bra      text_justif         ;
;\6
;  Calcul de la taille de la mmoire requise, sans compter le buffer.

start:         move.l   a0,d0               ;Teste si A0 est nul (A0 nul: application; A0 non nul: accessoire).
               lea      textlim(pc),a0      ;Adr. o on doit stocker les limites du prg TETRHEX (si application).
               beq.s    application         ;Branch. si A0 tait nul, i.e. s'il s'agit d'une application.
               lea      stack_end-textlim(a0),sp  ;Pointeur de pile.
               lea      acc_flag(pc),a1     ; Positionne
               st       (a1)                ; acc_flag.
               pea      alert_help+4(pc)    ;Chane vide (car pas de ligne de commande).
               bra.s    start2
application:   movea.l  4(sp),a5            ;Dbut de la Basepage.
               move.l   a5,(a0)+            ;Stocke la limite inf.
               move.l   12(a5),d0           ;Taille du segment TEXT
               add.l    20(a5),d0           ;+ taille du segment DATA
               add.l    28(a5),d0           ;+ taille du segment BSS (avec pile)
               addi.l   #$200,d0            ;+ Basepage (512 octets).
;\7
;  Calcul de l'adr. du nouveau SP.

               move.l   d0,d1               ; Longueur
               add.l    a5,d1               ; + adr.
               andi.b   #$FE,d1             ;On arrondit (--> adr. paire).
               move.l   d1,(a0)             ;Stocke la limite sup.
               movea.l  d1,sp               ;Nouveau ptr de pile.
;\6
;  Libre l'espace inutilis.

               move.l   d0,-(sp)            ;Taille de la mmoire requise.
               move.l   a5,-(sp)            ;Adr. de la zone.
               fre_mem                      ;Fct Mshrink du GEMDOS: libre l'espace inutilis.
               moveq    #-1,d7              ;D7.W = -1: code de retour en cas d'erreur.
               tst.l    d0                  ; Fin s'il y a eu
               bne.s    error9              ; une erreur.
;\3
;  Sauve l'adr. de la ligne de commande.

               pea      $81(a5)             ;Sauve l'adr. de la ligne de commande.
;\6
;  Inverse le drapeau "timer" si la touche shift gauche est enfonce.

start2:        move.l   #Kbshift<<16+$FFFF,-(sp)  ;Fct Kbshift, mode lecture (paramtre = -1).
               trap     #bios               ;Appelle BIOS: lit l'tat des touches spciales du clavier.
               addq.l   #4,sp               ;Nettoie la pile.
               btst     #1,d0               ;Touche shift gauche enfonce ?
               sne      d0                  ;
               lea      timer_flag(pc),a0   ; Si oui, on inverse le drapeau "timer".
               eor.b    d0,(a0)             ;
;\3
;  Nom du fichier de rgle par dfaut: "TETRHEX.RUL".

               bsr      rul_default         ;Stocke le nom du fichier de rgle par dfaut dans string.
;\6
;  Examine les cookies.

               pea      rd_p_cookies(pc)    ;Routine  appeler en mode superuser.
               mxbios   Supexec,6           ;Supexec: excute la routine en mode superuser --> ptr sur la cookie jar.
               tst.l    d0                  ;Y a-t-il une cookie jar ?
               beq      cookie_end          ;Non, branch.
               movea.l  d0,a0               ;Ptr sur la cookie jar (non nul).
               lea      windflag(pc),a6     ;A6: ptr sur windflag.
               bra.s    read_cookie         ;Branch. pour lire le prochain cookie.
cookie_loop:   cmpi.l   #'_CPU',d0          ; Branch. si le cookie
               bne.s    not_cpu             ; n'est pas "_CPU".
               cmpi.l   #20,(a0)+           ;
               bcc.s    read_cookie         ; C'est "_CPU". Si le processeur n'est pas au moins
               moveq    #3,d7               ; un 68020, on arrte (code de retour = 3).
error9:        bra      error               ;
not_cpu:       cmpi.l   #'_AKP',d0          ; Branch. si le cookie
               bne.s    not_akp             ; n'est pas "_AKP".
               move.l   (a0)+,d0            ;C'est "_AKP".
               lsr.w    #8,d0                    ; Stocke le code
               move.b   d0,langsys-windflag(a6)  ; de  la  langue
               bra.s    read_cookie              ; dans langsys.
not_akp:       cmpi.l   #'_IDT',d0          ; Branch. si le cookie
               bne.s    not_idt             ; n'est pas "_IDT".
               lea      fmtdate(pc),a5      ;(A5): fmtdate, -1(A5): fmttime, -2(A5): sepdate.
               bfextu   (a0){20:4},d0       ; Stocke le format
               move.b   d0,(a5)             ; de la date.
               bfextu   (a0){16:4},d0       ; Stocke le format
               move.b   d0,-(a5)            ; de l'heure.
               move.l   (a0)+,d0            ;Valeur du cookie.
               tst.b    d0                  ; Branch. si le sparateur de la date
               beq.s    read_cookie         ; n'est pas indiqu (octet nul).
               move.b   d0,-(a5)            ; Stocke le sparateur
               bra.s    read_cookie         ; de la date.
not_idt:       cmpi.l   #'MiNT',d0          ; Branch. si le cookie
               bne.s    not_mint            ; n'est pas "MiNT".
               tas      (a6)                ; C'est "MiNT". On active le drapeau windflag pour
               bra.s    next_cookie         ; que le jeu se droule dans une fentre GEM.
not_mint:      cmpi.l   #'LEDP',d0          ; Branch. si le cookie
               bne.s    not_ledp            ; n'est pas "LEDP".
               move.l   (a0)+,ledp_addr-windflag(a6)  ;Stocke l'adresse de la structure.
               bra.s    read_cookie         ;Branch. pour lire le prochain cookie.
not_ledp:      cmpi.l   #'OSBL',d0          ; Branch. si le cookie
               bne.s    next_cookie         ; n'est pas "OSBL".
               lea      chres_flag(pc),a5   ; C'est "OSBL". On interdit alors
               addq.b   #1,(a5)             ; le chgt de rsolution.
next_cookie:   addq.l   #4,a0               ;Adr. du cookie suivant.
read_cookie:   move.l   (a0)+,d0            ;Prochain cookie ou valeur nulle.
               bne.s    cookie_loop         ;Branch. si c'est un cookie.
cookie_end:    move.l   #smagic,bss_end-windflag(a6)  ;Stocke smagic au dbut de la pile (pour dtecter les stack overflow).
;\4
;  Change l'emplacement de la DTA.

               pea      dta-windflag(a6)    ; Nouvelle
               mgemdos  Fsetdta,6           ; DTA.
;\6
;  Dans la version shareware, on dcode les 2 parties.

               IFGE     REGISTERED
               IFNE     REGISTERED
               lea      reg_name(pc),a0     ;Dans la version enregistre, le nom de la personne enregistre sert  dcoder.
               ELSE
               lea      bfire(pc),a0        ;Dans la version non enregistre, le dbut de bfire sert  dcoder.
               ENDIF
               lea      patdef(pc),a1       ;Adr. de la 1re partie  dcoder.
               movea.l  a0,a2               ;(A0 ne doit pas tre modifi.)
               moveq    #23,d0              ;Nb d'octets  dcoder - 1.
               moveq    #5,d1               ;D1.W = 5.
decode1:       clr.w    d2                  ; Lit l'octet suivant de
               move.b   (a2)+,d2            ; la cl (nom ou bfire).
               muls.w   d1,d2               ;D2 = (5-i) * N(i).
               add.b    d2,(a1)+            ;Dcode un octet.
               subq.w   #1,d1               ;D1.W = 5-i.
               dbf      d0,decode1          ;Boucle (passe  l'octet suivant).
               lea      rlp_expl(pc),a1     ;Adr. de la 2de partie  dcoder.
               moveq    #rlp_end-rlp_expl-1,d0  ;Nb d'octets  dcoder - 1.
               moveq    #3,d1               ;D1.W = 3.
               moveq    #0,d4               ;D4.L = 0.
decode2:       clr.w    d2                  ; Lit l'octet suivant de
               move.b   (a0,d4.l),d2        ; la cl (nom ou bfire).
               muls.w   d1,d2               ;D2 = (i+3) * N(i mod 32).
               add.b    d2,(a1)+            ;Dcode un octet.
               addq.b   #1,d4               ; D4.L: numro de l'octet suivant
               andi.b   #31,d4              ; de la cl (mod 32).
               addq.w   #1,d1               ;D1.W = i+3.
               dbf      d0,decode2          ;Boucle (passe  l'octet suivant).
               ENDIF
;\6
;  Initialise la liste des langues.

               lea      (langsys,pc),a0     ; D4.W: langue utilise par
               clr.w    d4                  ; le systme.  A0:  ptr sur
               move.b   (a0)+,d4            ; la liste des langues.
               move.b   d4,(a0)+            ;1re langue: celle utilise par le systme.
               subq.b   #8,d4                   ;
               bhi.s    sto_0_3                 ; Puis, autre langue
               move.b   (optlc+8.w,pc,d4.w),d0  ; du  groupe  s'il y
               bmi.s    sto_0_3                 ; en a une.
               move.b   d0,(a0)+                ;
sto_0_3:       clr.b    (a0)+               ;Langue de code 0.
               move.w   #$03FF,(a0)         ;Langue de code 3, puis octet ngatif.
;\6
;  Si le 1er caractre de la ligne de commande qui n'est pas un sparateur n'est pas le '-' (qui indique une option),
;  on rajoute "-o ", "-r " ou "-s " devant la ligne de commande (si celle-ci n'est pas trop longue), suivant l'exten-
;  sion du nom du fichier qui doit suivre.  Ainsi on peut faire glisser un fichier d'options,  un fichier de rgle ou
;  un fichier de messages sur le nom du prg TETRHEX (au lieu de donner les options au clavier).

               move.l   (sp)+,a6            ;Rcupre l'adr. de la ligne de commande.
               movea.l  a6,a0               ;Adr. de la ligne de commande.
               moveq    #' ',d1             ;D1.B = ' '.
cmdl_loop1:    move.b   (a0)+,d0            ; Recherche le 1er caractre qui n'est pas un
               beq.s    read_cfg            ; sparateur.  Si  on a atteint  la fin de la
               cmp.b    d1,d0               ; ligne de commande, on se branche  read_cfg
               bls.s    cmdl_loop1          ; pour lire le fichier de configuration.
               cmpi.b   #'-',d0             ; Branch. si ce caractre est le
               beq.s    read_cfg            ; '-', qui indique une option.
cmdl_loop2:    tst.b    (a0)+               ; Recherche la fin de la
               bne.s    cmdl_loop2          ; ligne de commande.
               move.l   -5(a0),d0           ;Extension ventuelle.
               move.w   #'-o',d2            ;Option par dfaut.
               cmpi.l   #'.RUL',d0          ; Si c'est un nom de fichier
               bne.s    cmdl_lbl1           ; de rgle,  alors  on prend
               addq.b   #'r'-'o',d2         ; l'option '-r'.
cmdl_lbl1:     cmpi.l   #'.MSG',d0          ; Si c'est  un nom de fichier
               bne.s    cmdl_lbl2           ; de messages, alors on prend
               addq.b   #'s'-'o',d2         ; l'option '-s'.
cmdl_lbl2:     lea      3(a0),a1            ;
               lea      126(a6),a2          ;
               cmpa.l   a1,a2               ; Dcale la ligne de commande  de
               bcs.s    error3              ; 3 caractres  vers  la  droite.
cmdl_loop3:    move.b   -(a0),-(a1)         ; Erreur si elle est trop longue.
               cmpa.l   a0,a6               ;
               bne.s    cmdl_loop3          ;
               move.w   d2,(a0)+            ; Ajoute "-x " devant la ligne de commande, o x = 'o', 'r' ou 's'
               move.b   d1,(a0)             ; (selon l'extension du nom du fichier).
;\6
;  Lit le fichier de configuration.

read_cfg:      moveq    #0,d6               ;D6.L = 0: pas de fichier de configuration pour l'instant.
               clr.w    -(sp)                 ;
               pea      cfg_name(pc)          ;
               mgemdos  Fsfirst,8             ; D5: longueur du fichier de configuration. Branch. 
               tst.l    d0                    ; read_opt s'il n'y a pas de fichier de configuration
               bne.s    read_opt              ; ou si celui-ci a une longueur nulle.
               move.l   (dta+d_length,pc),d5  ;
               beq.s    read_opt              ;
               moveq    #126,d0             ; D0.L: taille de la mmoire  rserver (longueur du fichier
               add.l    d5,d0               ; de configuration + 126) pour la chane d'options.
               lea      cfg_name(pc),a3     ; Rserve de la mmoire et lit le fichier
               bsr      read_file           ; cfg_name. D6.L pointe sur ce fichier.
               add.l    d6,d5               ;Adr. de la fin du fichier.
               movea.l  d5,a0               ; Recopie la ligne de commande
cpy_cmdline:   move.b   (a6)+,(a0)+         ;  la fin  du fichier  (octet
               bne.s    cpy_cmdline         ; nul compris).
start_opt:     movea.l  d6,a6               ;Adr. de la nouvelle chane d'options.
;\6
;  Lit les options.

read_opt:      moveq    #10,d7              ;D7.W = 10: code de retour en cas d'erreur.
               lea      windflag(pc),a5     ;A5 pointe sur windflag.
               lea      timer_flag(pc),a4   ;A4 pointe sur timer_flag.
next_opt:      bsr.s    next_arg            ;Saute les sparateurs.
               beq      free_opt2           ;Branch. s'il n'y a plus d'option.
               cmpi.b   #'-',d0             ; Une option commence
error3:        bne      error               ; tjrs par '-'.
rd_1stchar:    move.b   (a6)+,d0            ;D0.B: 1er caractre suivant '-'.
               beq.s    error12             ;Erreur s'il n'y a plus de caractre.
               subi.b   #'v',d0             ; Branch. si ce n'est pas
               bne      not_optv            ; une option '-v'.
               move.b   (a6)+,d0            ;Lit le caractre situ aprs le 'v'.
error12:       beq      error               ;Erreur si fin de chane.
               cmpi.b   #'h',d0             ; Branch. si ce n'est
               bne.s    optv_noth           ; pas 'h'.
               move.b   (a6)+,d0            ;D0.B: caractre suivant '-vh'.
               lea      hcol8(pc),a0        ;Adr. o devront tre stockes les intensits  lire dans le cas de '-vhc'.
               cmpi.b   #'c',d0             ; Branch. si le caractre suivant
               beq.s    optvh               ; '-vh' est 'c' (option '-vhc').
               cmpi.b   #'w',d0             ; Erreur si le caractre suivant
               bne.s    error3              ; '-vh' n'est pas 'w'.
               addq.l   #hwhite-hcol8,a0    ;Adr. o devront tre stockes les intensits  lire (option '-vhw').
optvh:         moveq    #7,d3               ;D3.W: nb de valeurs  lire - 1 (compteur).
optv_hnext:    bsr      get_num0            ;Lit un nb.
               cmpi.l   #$FF,d0             ; Erreur si la valeur lue
               bhi.s    error3              ; est trop gde (> 255).
               move.b   d0,(a0)+            ;Stocke l'intensit dans le tableau.
               dbf      d3,optv_hnext       ;Boucle (passe  l'intensit suivante).
               bra.s    next_opt            ;Branch. pour lire la prochaine option.
optv_noth:     subi.b   #'r',d0             ; Branch. si ce n'est
               bne.s    optv_notr           ; pas 'r'.
               bsr.s    opt_pm              ; D0.B = 1 si on doit ajouter l'option,
               neg.b    d0                  ; D0.B = 0 si on doit l'enlever.
               move.b   d0,chres_flag-timer_flag(a4)  ;Option '-vr': on interdit le chgt de rsolution.
               bra.s    next_opt            ;Branch. pour lire la prochaine option.
optv_notr:     subq.b   #'s'-'r',d0         ; Branch. si ce n'est
               bne.s    optv_nots           ; pas 's'.
               bsr.s    opt_pm              ;D0.B = -1 si on doit ajouter l'option, D0.B = 0 si on doit l'enlever.
               move.b   d0,vsync_flag-windflag(a5)  ;Drapeau vsync_flag.
next_opt6:     bra.s    next_opt            ;Branch. pour lire la prochaine option.
;\4
next_arg0:     cmpi.b   #' ',(a6)+          ; Erreur si le prochain caractre
               bhi.s    error3              ; n'est pas un sparateur.
next_arg:      move.b   (a6)+,d0            ;
               beq.s    opt_rts             ; Recherche le prochain caractre qui n'est pas
               cmpi.b   #' ',d0             ; un sparateur (plac dans D0.B). Z = 1 ssi on
               bls.s    next_arg            ; est arriv  la fin de la chane.
opt_rts:       rts                          ;
;\5
optv_nots:     addq.b   #'s'-'l',d0         ; Branch. si ce n'est
               bne.s    error3              ; pas 's'.
               bsr.s    opt_pm              ;D0.B = -1 si on doit ajouter l'option, D0.B = 0 si on doit l'enlever.
               move.b   d0,ledp_flag-timer_flag(a4)  ;Stocke le drapeau de dsactivation de LED Panel.
               bra.s    next_opt6           ;Branch. pour lire la prochaine option.
;\4
opt_pm:        move.b   (a6),d0             ;Lit le caractre suivant (mais on ne modifie pas le ptr sur la chane).
               subi.b   #'-',d0             ; Branch. si c'est un '-':
               beq.s    opt_nextchar        ; on enlve l'option.
               addq.b   #'-'-'+',d0         ; Branch. si ce n'est ni '-', ni '+': on ajoute l'option,
               bne.s    opt_sne             ; mais on ne modifie pas le ptr sur la chane.
               moveq    #-1,d0              ;Z = 0.
opt_nextchar:  addq.l   #1,a6               ;Incr. le ptr sur la chane, car on a lu le caractre '-' ou '+'.
opt_sne:       sne      d0                  ;D0.B = -1 si on doit ajouter l'option, D0.B = 0 si on doit l'enlever.
               rts                          ;Retour (rsultat dans D0.B).
;\5
not_optv:      addq.b   #'v'-'u',d0         ; Branch. si ce n'est
               bne.s    not_optu            ; pas l'option '-u'.
               bsr.s    opt_pm              ;D0.B = -1 si on doit ajouter l'option, D0.B = 0 si on doit l'enlever.
               move.b   d0,pnam_flag-windflag(a5)  ;Drapeau pnam_flag.
               bra.s    next_opt6           ;Branch. pour lire la prochaine option.
;\4
not_optu:      cmpi.b   #'l'-'u',d0         ; Branch. si ce n'est
               bne      not_optl            ; pas l'option '-l'.
               moveq    #langlen,d3         ;Longueur de la liste des langues.
               lea      langsys-windflag(a5),a0  ; D4.W: langue utilise par
               clr.w    d4                       ; le systme.  A0:  ptr sur
               move.b   (a0)+,d4                 ; la liste des langues.
optl_next:     st       (a0)                ;Octet ngatif indiquant la fin de la liste des langues.
               bsr.s    next_arg            ;Saute les sparateurs.
free_opt2:     beq      free_opt            ;Branch. si fin de chane.
               cmpi.b   #'-',d0             ; Branch. si c'est une
               beq      rd_1stchar          ; nouvelle option.
               cmpi.b   #'?',d0             ; Branch. si ce n'est
               bne.s    optl_lbl1           ; pas '?'.
               move.b   d4,d0               ;C'est '?': langue utilise par le systme.
optl_sto:      subq.b   #1,d3               ; Branch. si la liste des
               beq.s    optl_lbl3           ; langues est pleine.
               move.b   d0,(a0)+            ;Stocke D0 dans la liste des langues.
               bra.s    optl_next           ;Branch. pour lire la prochaine langue.
optl_lbl3:     moveq    #1,d3               ;Liste des langues pleine.
               bra.s    optl_next           ;Branch. pour lire la prochaine langue.
optl_lbl1:     cmpi.b   #'*',d0             ; Branch. si ce n'est
               bne.s    optl_lbl2           ; pas '*'.
               subq.b   #1,d3               ; Branch. si la liste des
               beq.s    optl_lbl3           ; langues est pleine.
               move.b   d4,(a0)+            ;Stocke la langue du systme dans la liste des langues.
               subq.b   #8,d4               ;
               bhi.s    optl_next           ; Branch. si cette langue n'appartient
               move.b   optlc+8(pc,d4.w),d0 ; pas  un groupe de 2 langues.
               bmi.s    optl_next           ;
               bra.s    optl_sto            ;Branch. pour stocker l'autre langue du groupe.
optlc:         dc.b     3,8,7,0,-1,-1,-1,2,1,0
optl_lbl2:     bsr.s    get_num2            ;Lit un nb.
               moveq    #127,d1             ; Branch. pour stocker la
               cmp.l    d0,d1               ; langue  (si le code est
               bcc.s    optl_sto            ;  127).
error2:        bra      error               ;Erreur.
;\4
get_num0:      tst.b    (a6)                ; Erreur si fin
               beq.s    error2              ; de chane.
               cmpi.b   #' ',(a6)+          ; Erreur si le prochain caractre
               bhi.s    error2              ; n'est pas un sparateur.
get_num1:      bsr      next_arg            ;Prochain argument.
get_num2:      cmpi.b   #'$',d0             ; Branch. si le nb
               beq.s    get_hex             ; est en hexa.
               moveq    #0,d0               ;D0.L contiendra le nb.
               moveq    #0,d1               ;Annule les 24 bits de poids fort de D1.
               subq.l   #1,a6               ;A6 pointe sur le 1er chiffre du nb  lire.
               tst.b    (a6)                ; Branch. si fin
               beq.s    error2              ; de chane.
getnum_next:   move.b   (a6)+,d1            ;Lit le prochain caractre.
               cmpi.b   #' ',d1             ; Retour si c'est
               bls.s    getnum_end          ; un sparateur.
               subi.b   #'0',d1             ;
               bcs.s    error2              ; D1.L: valeur du chiffre (erreur
               cmpi.b   #9,d1               ; si ce n'est pas un chiffre).
               bhi.s    error2              ;
               muls.l   #10,d0              ;
               bvs.s    error2              ; Calcule le nb provisoire et boucle
               add.l    d1,d0               ; pour  lire  le  prochain caractre
               bvc.s    getnum_next         ; (erreur si overflow).
error5:        bra.s    error2              ;
;\2
getnum_end:    subq.l   #1,a6               ; Retour (A6 pointe sur le sparateur
               rts                          ; ou octet nul).
;\4
get_hex:       moveq    #0,d0               ;D0.L contiendra le nb.
gethex_loop:   move.b   (a6)+,d1            ;Lit le prochain caractre.
               cmpi.b   #' ',d1             ; Retour si c'est
               bls.s    getnum_end          ; un sparateur.
               subi.b   #'0',d1             ;D1.B: valeur du chiffre, si c'est un chiffre dcimal.
               bcs.s    error2              ;Erreur si le code ASCII est < '0'.
               cmpi.b   #9,d1               ; Branch. si c'est un
               bls.s    gethex_add          ; chiffre dcimal.
               cmpi.b   #'a'-'0',d1         ;
               bcs.s    gethex_upper        ; Transformation minuscule --> majuscule.
               subi.b   #'a'-'A',d1         ;
gethex_upper:  cmpi.b   #'A'-'0',d1         ;
               bcs.s    error2              ; Erreur si ce n'est pas
               cmpi.b   #'F'-'0',d1         ; une lettre de A  F.
               bhi.s    error2              ;
               subi.b   #'A'-'9'-1,d1       ;D1.B: valeur du chiffre hexa.
gethex_add:    lsl.l    #4,d0               ; Ajoute le chiffre
               or.b     d1,d0               ; hexa au nb.
               bra.s    gethex_loop         ;Boucle.
;\4
not_optl:      subq.b   #'w'-'u',d0         ; Branch. si ce n'est pas
               bne.s    not_optw            ; une option '-w'.
               move.b   (a6)+,d0            ;2me caractre de l'option.
               subi.b   #'w',d0             ; Branch. si le 2me caractre
               bne.s    optw_notw           ; n'est pas 'w'.
               tas      (a5)                ;C'est '-ww': active windflag.
next_opt2:     bra      next_opt            ;Branch. pour lire la prochaine option.
optw_notw:     addq.b   #'w'-'u',d0         ; Branch. si le 2me caractre
               bne.s    optw_notu           ; n'est pas 'u'.
               bsr      opt_pm              ;D0.B = -1 si on doit ajouter l'option, D0.B = 0 si on doit l'enlever.
               neg.b    d0                          ; Stocke 0  si le sm. d'cran ne doit pas tre activ,  +1 dans le cas
               move.b   d0,screen_sem-windflag(a5)  ; contraire (valable uniquement si le jeu se droule sur tout l'cran).
               bra.s    next_opt2           ;Branch. pour lire la prochaine option.
optw_notu:     addq.b   #'u'-'s',d0         ; Branch. si le 2me caractre
               bne.s    optw_nots           ; n'est pas 's'.
               clr.b    (a5)                ;C'est '-ws': dsactive windflag.
               bra.s    next_opt2           ;Branch. pour lire la prochaine option.
optw_nots:     addq.b   #'s'-'p',d0         ; Branch. si le 2me caractre
error6:        bne.s    error5              ; n'est pas 'p'.
               move.b   (a6)+,d0            ;Lit le 3me caractre.
               cmpi.b   #'c',d0             ; Branch. si le 3me caractre
               bne.s    optwp_notc          ; n'est pas 'c'.
               tas      winpos+4-windflag(a5)  ;*(winpos+4) < 0: fentre centre.
               bra.s    next_opt2           ;Branch. pour lire la prochaine option.
optwp_notc:    cmpi.b   #' ',d0             ; Erreur si ce n'est
               bhi.s    error5              ; pas un sparateur.
               lea      winpos(pc),a3       ;A3 = winpos.
               bsr.s    sto_winpos          ;Lit et stocke l'abscisse.
               tst.b    (a6)                ; Erreur si fin
               beq      error5              ; de chane.
               bsr.s    sto_winpos          ;Lit et stocke l'ordonne.
               move.b   #1,(a3)             ;*(winpos+4) > 0: position de la fentre donne par winpos.
               bra.s    next_opt2           ;Branch. pour lire la prochaine option.
sto_winpos:    bsr      get_num1            ;Lit un nb.
               cmpi.l   #$FFFF,d0           ; Erreur s'il est
               bhi.s    error6              ; > 65535.
               move.w   d0,(a3)+            ;Stocke le nb.
               rts                          ;Retour.
;\4
not_optw:      addq.b   #'w'-'t',d0         ; Branch. si ce n'est pas
               bne.s    not_optt            ; une option '-t'.
               move.b   (a6)+,d0            ;2me caractre de l'option.
               subi.b   #'a',d0             ; Branch. si le 2me caractre
               bne.s    optt_nota           ; n'est pas 'a'.
               st       (a4)                ;C'est '-ta': *timer_flag = -1 (timer A).
               bra.s    next_opt2           ;Branch. pour lire la prochaine option.
optt_nota:     subq.b   #'d'-'a',d0         ; Branch. si le 2me caractre
               bne.s    error6              ; n'est pas 'd'.
               clr.b    (a4)                ;C'est '-td': *timer_flag = 0 (timer D).
next_opt3:     bra.s    next_opt2           ;Branch. pour lire la prochaine option.
;\4
not_optt:      addi.b   #'t'-'i',d0         ; Branch. si ce n'est pas
               bne.s    not_opti            ; une option '-i'.
               bsr      next_arg0           ;Prochain argument (erreur s'il n'y a pas de sparateur).
               cmpi.b   #'o',d0             ; Erreur si le prochain caractre n'est pas 'o'
               bne.s    error6              ; (le paramtre doit tre "on" ou "off").
               move.b   (a6)+,d0            ;D0.B: 2me caractre du paramtre.
               moveq    #'f',d1             ;D1.B: 'f'.
               sub.b    d1,d0               ; Branch. si le 2me
               beq.s    opti_off            ; caractre est 'f'.
               subq.b   #'n'-'f',d0         ; Erreur si le 2me caractre
               bne.s    error6              ; n'est pas 'n'.
               move.l   #(Offgibit<<16)+($FF&~(1<<gpo)),-(sp)  ;Paramtre: on (on doit brancher le haut-parleur interne).
onoff_gibit:   trap     #xbios              ;Appel de Offgibit ou de Ongibit --> GPO = 0 (branch) ou 1 (coup).
               addq.l   #4,sp               ;Nettoie la pile.
               bra.s    next_opt3           ;Branch. pour lire la prochaine option.
opti_off:      cmp.b    (a6)+,d1            ; Erreur si le 3me caractre
error4:        bne.s    error6              ; n'est pas 'f'.
               move.l   #(Ongibit<<16)+(1<<gpo),-(sp)  ;Paramtre: off (on doit couper le haut-parleur interne).
               bra.s    onoff_gibit         ;Branch. pour couper le haut-parleur interne (appel de Ongibit --> GPO = 1).
;\4
not_opti:      addq.b   #'i'-'h',d0         ; Branch. si ce n'est pas l'option
               bne.s    not_opth            ; '-h' ou '-help'.
               tas      helpflag-windflag(a5)  ;Active le drapeau d'aide.
               cmpi.b   #'e',(a6)           ; Branch. si le caractre suivant 'h' n'est
               bne.s    next_opt3           ; pas 'e': il s'agit de l'option '-h'.
               addq.l   #1,a6               ;
               cmpi.b   #'l',(a6)+          ;
               bne.s    error4              ; Branch. pour lire la prochaine option, si
               cmpi.b   #'p',(a6)+          ; c'tait l'option '-help'. Sinon, erreur.
               bne.s    error4              ;
               bra.s    next_opt3           ;
;\4
not_opth:      addq.b   #'h'-'g',d0         ; Branch. si ce n'est pas
               bne.s    not_optg            ; l'option '-gdos'.
               cmpi.b   #'d',(a6)+          ;
               bne.s    error4              ;
               cmpi.b   #'o',(a6)+          ; Erreur si ce n'est pas
               bne.s    error4              ; l'option '-gdos'.
               cmpi.b   #'s',(a6)+          ;
error16:       bne.s    error4              ;
               st       gdosflag-windflag(a5)  ;Active le flag GDOS.
               bra.s    next_opt3           ;Branch. pour lire la prochaine option.
;\5
not_optg:      addq.b   #'g'-'e',d0         ; Branch. si ce n'est pas
               bne.s    not_opte            ; une option '-e'.
               bsr      opt_pm              ;D0.B = -1 si on doit ajouter l'option, D0.B = 0 si on doit l'enlever.
               move.b   d0,errflag-timer_flag(a4)  ;Drapeau errflag.
next_opt4:     bra.s    next_opt3           ;Branch. pour lire la prochaine option.
;\4
not_opte:      addq.b   #'e'-'b',d0         ; Branch. si ce n'est
               bne.s    not_optb            ; pas l'option '-b'.
               clr.b    d3                  ;D3.B sera non nul si les conditions sur les 6 nb ne sont pas respectes.
               moveq    #5,d2               ;D2.W: nb de nb  lire - 1 (compteur).
optb_loop1:    bsr      get_num0            ;Lit un nb.
               cmpi.l   #$FF,d0             ;
               shi      d4                  ; Si le nb est > 255, D3.B <> 0.
               or.b     d4,d3               ;
               move.w   d0,-(sp)            ;Empile le nb (16 bits seulement).
               moveq    #3,d4               ; Branch.  si c'est un des 3 premiers
               cmp.b    d2,d4               ; nb (pas de condition supplmentaire
               bls.s    optb_dbf            ; sur ce nb).
               mulu.w   d4,d0               ;
               cmp.w    6(sp),d0            ; Si le triple de ce nb est > au nb lu
               shi      d4                  ; 3 itrations auparavant, D3.B <> 0.
               or.b     d4,d3               ;
optb_dbf:      dbf      d2,optb_loop1       ;Boucle (lit le nb suivant).
               tst.b    d3                  ; Branch. si les conditions ne sont pas
               bne.s    next_opt4           ; respectes (on annule l'option).
               lea      hex_col+6(pc),a0    ;
               moveq    #5,d2               ;
optb_loop2:    move.w   (sp)+,d0            ; Recopie les nb dans hex_col.
               move.b   d0,-(a0)            ;
               dbf      d2,optb_loop2       ;
               bra.s    next_opt4           ;Branch. pour lire la prochaine option.
;\4
not_optb:      subi.b   #'m'-'b',d0         ; Branch. si ce n'est pas
               bne.s    not_optm            ; une option '-m'.
               move.b   (a6)+,d0            ;2me caractre de l'option.
               subi.b   #'a',d0             ; Branch. si le 2me caractre
               bne.s    optm_nota           ; n'est pas 'a'.
               clr.l    xmem-timer_flag(a4) ;La mmoire prise par l'image de fond ne sera jms libre.
               bra.s    next_opt4           ;Branch. pour lire la prochaine option.
optm_nota:     subq.b   #'f'-'a',d0         ; Branch. si le 2me caractre
error18:       bne.s    error16             ; n'est pas 'f'.
               moveq    #-1,d0                  ; La mmoire prise par l'image de fond
               move.l   d0,xmem-timer_flag(a4)  ; sera tjrs libre aprs affichage.
               bra.s    next_opt4           ;Branch. pour lire la prochaine option.
;\4
not_optm:      subq.b   #'n'-'m',d0         ; Branch. si ce n'est
               bne.s    not_optn            ; pas l'option '-n'.
               bsr      get_num0            ;Lit un nb n.
               moveq    #nhmin,d1           ;
               cmp.l    d0,d1               ;
               bhi.s    error19             ; Erreur si le nb n'est pas compris
               moveq    #nhmax,d1           ; entre nhmin et nhmax.
               cmp.l    d0,d1               ;
               bcs.s    error18             ;
               bsr      change_nhex         ;Change le nb de petits hexagones dans un ct du gd hexagone.
next_opt5:     bra.s    next_opt4           ;Branch. pour lire la prochaine option.
;\4
not_optn:      cmpi.b   #'c'-'n',d0         ; Branch. si ce n'est pas
               bne.s    not_optc            ; une option '-c'.
               move.b   (a6)+,d0            ;2me caractre de l'option.
               lea      col_time+1(pc),a3   ;A3: adr. o il faudra stocker la 1re composante, si option -ct.
               cmpi.b   #'t',d0             ; Branch. si le 2me
               beq.s    optc_dth            ; caractre est 't'.
               subq.l   #4,a3               ;A3: adr. o il faudra stocker la 1re composante, si option -cd.
               subi.b   #'d',d0             ; Branch. si le 2me
               beq.s    optc_dth            ; caractre est 'd'.
               subi.b   #'h'-'d',d0         ; Branch. si le 2me caractre
               bne.s    optc_noth           ; n'est pas 'h'.
               addq.l   #8,a3               ;A3: adr. o il faudra stocker la 1re composante, si option -ch.
optc_dth:      moveq    #2,d2               ;D2.W: nb de nb  lire - 1 (compteur).
optc_loop:     bsr      get_num0            ;Lit un nb.
               cmpi.l   #$FF,d0             ; S'il est compris
               bhi.s    optch_next          ; entre  0 et 255,
               move.b   d0,(a3)             ; on le stocke.
optch_next:    addq.l   #1,a3               ;Adr. o il faudra stocker la composante suivante.
               dbf      d2,optc_loop        ;Boucle.
               bra.s    next_opt5           ;Branch. pour lire la prochaine option.
optc_noth:     lea      col_icon(pc),a3     ;Ptr sur la couleur de l'icne.
               subq.b   #'i'-'h',d0         ; Branch. si le 2me
               beq.s    optc_getnum         ; caractre est 'i'.
               subq.b   #'p'-'i',d0         ; Erreur si le 2me caractre
error20:       bne.s    error18             ; n'est pas 'p'.
               subq.l   #col_icon-col_pause,a3  ;Ptr sur la couleur de "-- PAUSE --".
optc_getnum:   bsr      get_num0            ;Lit un nb.
               moveq    #15,d3              ;
               cmp.l    d3,d0               ; Erreur s'il est > 15.
error19:       bhi.s    error17             ;
               move.w   d0,(a3)             ;Stocke le nb.
next_opt7:     bra.s    next_opt5           ;Branch. pour lire la prochaine option.
;\4
not_optc:      subq.b   #'p'-'n',d0         ; Branch. si ce n'est
               bne.s    not_optp            ; pas l'option '-p'.
               bsr      next_arg            ;Prochain argument.
               beq.s    error13             ;Erreur si fin de chane.
               moveq    #'"',d1             ;
               cmp.b    d0,d1               ; Erreur  si le caractre  de dbut de
               beq.s    optp_rdname         ; chane n'est ni un guillemet, ni une
               moveq    #"'",d1             ; apostrophe. S'il n'y a pas d'erreur,
               cmp.b    d0,d1               ; D1 contient ce caractre.
               bne.s    error20             ;
optp_rdname:   lea      pname(pc),a0        ;A0: adr. o il faut stocker le nom du joueur.
               moveq    #namelen-1,d3       ;D3: longueur maxi du nom, octet nul non compris.
               moveq    #' ',d4             ;D4: espace (tout caractre de code ASCII < D4 ne convient pas).
optp_loop1:    cmp.b    (a6),d4             ; Erreur si fin de chane ou
error17:       bhi.s    error14             ; caractre non affichable.
               move.b   (a6),(a0)+          ;Stocke le caractre (note: le dernier caractre stock ici sera remplac par $00).
               cmp.b    (a6)+,d1            ; Passe au caractre suivant. On sort de la boucle si c'tait le caractre
               dbeq     d3,optp_loop1       ; de fin de chane ou si 'namelen' caractres viennent d'tre crits.
               beq.s    optp_end            ;Branch. si c'tait le caractre de fin de chane.
optp_loop2:    cmp.b    (a6),d4             ; Erreur si fin de chane ou
               bhi.s    error14             ; caractre non affichable.
               cmp.b    (a6)+,d1            ; Branch. si le caractre lu n'est pas le caractre
               bne.s    optp_loop2          ; de fin de chane (guillemet ou apostrophe).
optp_end:      clr.b    -(a0)               ;Remplace le dernier caractre (guillemet, apostrophe ou 24me) par l'octet nul.
               bra.s    next_opt7           ;Branch. pour lire la prochaine option.
;\4
not_optp:      subq.b   #'r'-'p',d0         ; Branch. si ce n'est
               bne.s    not_optr            ; pas l'option '-r'.
               lea      string(pc),a0       ;Adr. o il faut recopier le nom du fichier de rgle.
               tas      strlen-1(a0)        ;Active le drapeau.
               bsr.s    copy_fname          ;Recopie le nom du fichier de rgle dans string.
next_opt8:     bra.s    next_opt7           ;Branch. pour lire la prochaine option.
;\4
not_optr:      cmpi.b   #'f'-'r',d0         ; Branch. si ce n'est pas
               bne.s    not_optf            ; une option '-f'.
               move.b   (a6)+,d0            ;2me caractre de l'option.
               lea      tfontid-2(pc),a3    ;A3 contiendra l'adr. o devra tre stock le nb  lire.
               lea      optfc(pc),a0        ;Ptr sur la liste des 2mes caractres accepts.
               moveq    #-1,d3              ;
optf_loop:     move.b   (a0)+,d1            ;
error13:       beq.s    error8              ; D3: n du flag dans *outline, et A3: adr.
               addq.b   #1,d3               ; o doit tre stock  le nb  lire,  si le
               addq.l   #2,a3               ; 2me caractre convient; sinon erreur.
               cmp.b    d0,d1               ;
               bne.s    optf_loop           ;
               bsr      next_arg0           ;Prochain argument.
               lea      outline(pc),a0      ;Adr. des flags indiquant si la fonte est vectorielle.
               move.w   (a0),d2             ;D2.W: flags (0: fonte bitmap, 1: fonte vectorielle).
               moveq    #'+',d4             ;
               cmp.b    d4,d1               ; Branch. si c'est l'option '-f+'.
               beq.s    optf_lbl1           ;
               bset     d3,d2               ; Positionne le flag comme il faut:  la
               cmp.b    d4,d0               ; fonte est vectorielle ssi le prochain
               beq.s    optf_lbl2           ; caractre est un '+'. Si ce n'est pas
               bclr     d3,d2               ; un '+',  on revient  un caractre  en
optf_lbl1:     subq.l   #1,a6               ; arrire.
optf_lbl2:     move.w   d2,(a0)             ;Stocke les flags.
               bsr      get_num1            ;Lit un nb: n de la fonte.
               move.w   d0,(a3)             ;Stocke ce nb.
               bra.s    next_opt8           ;Branch. pour lire la prochaine option.
;\4
not_optf:      cmpi.b   #'d'-'r',d0         ; Branch. si ce n'est pas
               bne.s    not_optd            ; une option '-d'.
               move.b   (a6)+,d0            ;2me caractre de l'option.
               lea      optdisp-4(pc),a0    ;
               moveq    #5,d1               ; Recherche l'option correspondante
optd_loop:     addq.l   #4,a0               ;
               cmp.b    (a0)+,d0            ; (parmi les 6).
               dbeq     d1,optd_loop        ;
error14:       bne.s    error8              ;Erreur si option inexistante.
               lea      disptime(pc),a1     ;Adr. des drapeaux disptime et dispdate.
               move.l   (a0),d0             ;
               and.w    d0,(a1)             ; Met ces drapeaux
               swap     d0                  ;  jour.
               or.w     d0,(a1)             ;
next_opt9:     bra.s    next_opt8           ;Branch. pour lire la prochaine option.
;\4
fname2path:    lea      path(pc),a3         ; Adr. o il faut recopier
               movea.l  a3,a0               ; le nom du fichier.
copy_fname:    bsr      next_arg0           ;Prochain argument (erreur s'il n'y a pas de sparateur).
               beq.s    error8              ;Erreur si fin de chane.
               subq.l   #1,a6               ;A6 pointe sur le nom du fichier.
               move.w   #strlen-2,d0        ;Longueur maxi du nom du fichier.
cpfnam_loop:   move.b   (a6)+,(a0)          ;
               cmpi.b   #' ',(a0)+          ; Recopie le nom du fichier.
               dbls     d0,cpfnam_loop      ;
               bhi.s    error7              ;Erreur s'il est trop long.
               clr.b    -(a0)               ;Stocke un octet nul aprs le nom du fichier.
               subq.l   #1,a6               ;A6: adr. du caractre suivant le dernier caractre du nom du fichier.
               rts                          ;Retour.
;\2
error7:        moveq    #9,d7               ;D7.W = 9: code de retour.
error8:        bra      error               ;Erreur.
;\4
not_optd:      subq.b   #'s'-'r',d0         ; Branch. si ce n'est
               bne.s    not_opts            ; pas l'option '-s'.
               bsr.s    fname2path          ;Recopie le nom du fichier de messages dans path.
               IFNE     REGISTERED
               bsr.s    file_len            ;D5.L et D0.L: longueur du fichier.
               moveq    #4,d1               ;
               cmp.l    d0,d1               ; Erreur si elle est < 4.
               bhi.s    error8              ;
               move.l   d6,-(sp)            ;Sauve D6.
               bsr.s    read_file           ;Rserve de la mmoire et lit le fichier. D6.L pointe sur ce fichier.
               movea.l  d6,a0               ; Erreur si les 4 premiers
               cmpi.l   #'MSG1',(a0)        ; caractres du fichier ne
               bne.s    error8              ; sont pas 'MSG1'.
               lea      msg_addr-timer_flag(a4),a1  ;A1 = msg_addr: adr. du fichier de msg le + prioritaire.
               addq.l   #4,d6               ;D6.L: adr. de la routine du fichier de msg venant d'tre charg.
               move.l   (a1),(a0)           ;Stocke l'adr. du fichier de msg prcdent au dbut du fichier courant.
               move.l   d6,(a1)             ;Stocke l'adr. du fichier de msg courant dans msg_addr.
               move.l   (sp)+,d6            ;Rcupre D6.
               ENDIF
               bra.s    next_opt9           ;Branch. pour lire la prochaine option.
;\4
file_len:      clr.w    -(sp)               ;
               pea      (a3)                ;
               mgemdos  Fsfirst,8           ;
               tst.l    d0                  ; Si le fichier existe, D0.L et D5.L
               beq.s    flen_ok             ; contiennent  sa longueur.  Dans le
               tst.w    d7                  ; cas contraire,  si D7.W <> 0,  une
               bne.s    error8              ; erreur  est renvoye.  Le bit N du
               moveq    #-1,d0              ; CCR  est mis   1  ssi  le fichier
flen_rts:      rts                          ; n'existe pas.
flen_ok:       move.l   dta+d_length(pc),d5 ;
               move.l   d5,d0               ;
               rts                          ;
;\4
not_opts:      addq.b   #'s'-'o',d0         ; Erreur si ce n'est
error11:       bne.s    error8              ; pas l'option '-o'.
               bsr.s    fname2path          ;Recopie le nom du fichier dans path.
               bsr.s    free_d6             ;Libre l'ventuel bloc de mmoire rserv.
               pea      start_opt(pc)       ;Adr.  laquelle il faudra se brancher aprs load_file (--> lecture des options).
load_file:     moveq    #0,d6               ;D6.L = 0 (utile si D7.W = 0 et si le fichier n'existe pas).
               bsr.s    file_len            ;D5.L et D0.L: longueur du fichier.
               bmi.s    flen_rts            ;Retour avec N = 1 et D6.L = 0 si le fichier n'existe pas.
               addq.l   #1,d0               ;Taille de la mmoire  rserver (pour le fichier + un octet nul).
               bsr.s    read_file           ;Rserve de la mmoire et lit le fichier. D6.L pointe sur ce fichier.
               add.l    d6,d5               ; Stocke un octet
               movea.l  d5,a0               ; nul  la fin du
               clr.b    (a0)                ; fichier.
               rts                          ;Retour avec N = 0 (D6.L: ptr sur le fichier).
;\4
read_file:     bsr      call_malloc         ;Rserve de la mmoire pour le fichier.
               moveq    #1,d7               ; D6: adr. du bloc rserv.
               move.l   d0,d6               ; Erreur  si  pas assez  de
               beq.s    error8              ; mmoire.
               moveq    #-1,d7              ;D7.W = -1: code de retour en cas d'erreur.
               clr.w    -(sp)               ;
               pea      (a3)                ; Ouvre le fichier en lecture.
               mgemdos  Fopen,8             ;
               tst.l    d0                  ; Branch. s'il y a
               bmi.s    error11             ; eu une erreur.
               move.w   d0,d4               ;D4.W: handle du fichier.
               move.l   d6,-(sp)            ;
               move.l   d5,-(sp)            ; Lit entirement
               move.w   d4,-(sp)            ; le fichier.
               mgemdos  Fread,12            ;
               cmp.l    d0,d5               ; Branch. s'il y a
               bne.s    error11             ; eu une erreur.
               move.w   d4,-(sp)            ; Ferme le
               mgemdos  Fclose,4            ; fichier.
               tst.l    d0                  ; Branch. s'il y a
               bmi.s    error11             ; eu une erreur.
               rts                          ;Retour.
;\5
free_d6:       move.l   d6,d0               ;Adr. de la zone de mmoire rserve, si non nulle.
               beq.s    free_rts            ;Branch. si pas de mmoire rserve.
               bsr      call_mfree          ;Libre la mmoire.
error15:       bne.s    error11             ;Branch. s'il y a eu une erreur.
free_rts:      rts                          ;Retour.
;\4
free_opt:      bsr.s    free_d6             ;Libre l'ventuel bloc de mmoire rserv.
               lea      hcol8(pc),a0        ;
               lea      hwhite(pc),a1       ;
               moveq    #7,d0               ; Met  jour les intensits de hcol8:  on ajoute
hcol8_loop:    move.b   (a1)+,d1            ; chaque lment  de hwhite   l'lment corres-
               add.b    d1,(a0)+            ; pondant de hcol8, et si le rsultat est > 255,
               bcc.s    hcol8_next          ; on le remplace par 255.
               st       -1(a0)              ;
hcol8_next:    dbf      d0,hcol8_loop       ;
               lea      col_date(pc),a3     ;
               moveq    #2,d0               ; Les valeurs des couleurs de
dthcol_loop:   tst.l    (a3)+               ; la date,  de l'heure  et de
               bne.s    dthcol_next         ; l'aide qui sont nulles sont
               move.l   #$FFFFFF,-4(a3)     ; mises  max (blanc).
dthcol_next:   dbf      d0,dthcol_loop      ;
               tst.b    pnam_flag(pc)       ; Si la liste des meilleurs scores doit
               bpl.s    load_lng            ; tre inchange, le nom du joueur doit
               clr.b    pname-windflag(a5)  ; tre vide.
;\7
;  Charge le fichier TETRHEX.LNG, et met  jour les ptrs sur les textes (suivant la langue).
;  A4 ne doit pas tre modifi.
;  Syntaxe du fichier TETRHEX.LNG (\n correspond  un CR/LF):
;    TETRHEX.LNG = ("[" [0-9]+ "]\n" stat*)+
;    stat = " " char char char char ": " char+ "\n"
;    char = [\$20-\$FF]
;  N.B.: si la syntaxe est incorrecte, il y a un risque de plantage.
;\4
load_lng:      lea      lng_name(pc),a3     ;Ptr sur le nom du fichier.
               clr.w    d7                  ; Charge le fichier. N = 0 ssi le fichier existe
               bsr      load_file           ; (dans ce cas, D6.L pointe sur le fichier).
               bmi.s    lng_lbl0            ;Branch. si le fichier n'existe pas (D6.L = 0).
;\6
;    Calcule les ptrs sur les sections correspondant  chaque langues.

               moveq    #127,d0             ; Empile 128 mots longs nuls.  Le mot long ni ( partir du ptr
lng_loop1:     clr.l    -(sp)               ; de pile) contiendra un ptr sur le 1er stat correspondant  la
               dbf      d0,lng_loop1        ; langue i (ptr nul si pas de langue i).
               movea.l  d6,a0               ;A0: ptr sur le fichier de langue.
               moveq    #'[',d3             ;D3.B = '['.
               moveq    #11,d7              ;D7.W = 11: code de retour si le fichier de langue est incorrect.
lng_loop2:     cmp.b    (a0)+,d3            ; Erreur si le 1er caractre de
               bne.s    error15             ; la section n'est pas '['.
               clr.w    d0                  ;
lng_decloop:   move.b   (a0)+,d1            ;
               subi.b   #'0',d1             ;
               mulu.w   #10,d0              ; D0.W: n de la langue
               add.b    d1,d0               ; (entre 0 et 127).
               cmpi.b   #']',(a0)           ;
               bne.s    lng_decloop         ;
               addq.l   #1,a0               ;
               cmpi.w   #crlf,(a0)+         ; Erreur si les 2 caractres aprs
               bne.s    error15             ; ']' ne sont pas CR/LF.
               move.l   a0,(sp,d0.w*4)      ;Stocke le ptr sur la section dans le tableau cr au dbut.
               bra.s    lng_numlbl2
lng_stat:      cmp.b    d1,d3               ; Branch. s'il s'agit d'une
               beq.s    lng_loop2           ; nouvelle section.
lng_stloop:    cmpi.b   #lf,(a0)+           ; Il s'agit d'un stat. Recherche
               bne.s    lng_stloop          ; la fin de la ligne.
lng_numlbl2:   move.b   (a0),d1             ;D1.B: 1er caractre de la ligne suivante, ou 0 si c'est la fin du fichier.
               bne.s    lng_stat            ;Branch. si ce n'est pas 0: il y a une ligne suivante.
;\6
;    Met  jour les ptrs sur les chanes.

lng_lbl0:      lea      alerts+4(pc),a0     ;A0: ptr sur le 1er ptr.
               moveq    #(alert_help-alerts)/12-1,d0  ;D0.W: nb de textes - 1.
               move.l   a4,d1               ;D1.L: offset  ajouter  chaque ptr.
lng_loop3:     add.l    d1,(a0)+            ;Corrige le 1er ptr du texte courant (anglais).
               add.l    d1,(a0)             ;Corrige le 2nd ptr du texte courant (franais).
               addq.l   #8,a0               ;Adr. du 1er ptr du texte suivant.
               dbf      d0,lng_loop3        ;Boucle.
               lea      alerts(pc),a0       ;A0: dbut du tableau des alertes (et autres textes).
               clr.w    d2                  ;Annule l'octet de poids fort de D2.W.
               moveq    #(alert_help-alerts)/12,d0  ;D0.W: nb d'lments - 1, en comptant HELP.
lng_outer1:    lea      langlist(pc),a1     ;A1: liste des prfrences.
               move.l   (a0)+,d1            ;D1.L: titre du texte (4 lettres majuscules).
lng_inner1:    move.b   (a1)+,d2            ;D2.B: n de la prochaine langue.
               bmi.s    lng_lbl3            ;Branch. s'il n'y en a plus: le ptr sur la chane est inchang (--> anglais).
               bsr.s    lng_search          ;Cherche dans le fichier de langue si le texte en langue D2 est dfini.
               bne.s    lng_lbl1            ;Branch. s'il n'est pas dfini.
               move.l   a2,(a0)             ;Il est dfini: stocke le nouveau ptr sur la chane.
               bra.s    lng_lbl3            ;Passe au texte suivant.
;\4
lng_search:    tst.l    d6                  ; Retour avec Z = 0 s'il n'y a pas de fichier de langue
               beq.s    lsrch_clrz          ; (Z = 0 car le texte en langue D2 n'est pas dfini).
               move.l   (4.w,sp,d2.w*4),d3  ;D3: ptr sur le 1er stat. de la langue D2, ou 0 s'il n'y a pas de langue D2.
               beq.s    lsrch_clrz          ;Retour avec Z = 0 s'il n'y a pas de langue D2.
               movea.l  d3,a2               ;A2: ptr sur le 1er stat. de la langue D2.
               bra.s    lsrch_cmp
lsrch_outer:   cmp.l    (a2)+,d1            ; Si le titre du stat. courant  est celui
               addq.l   #2,a2               ; recherch, branch. avec Z = 1 et A2 ptr
               beq.s    lng_rts             ; sur la chane. Sinon, on continue.
lsrch_inner:   cmpi.b   #lf,(a2)+           ; Recherche la fin
               bne.s    lsrch_inner         ; de la ligne.
lsrch_cmp:     cmpi.b   #' ',(a2)+          ; Branch. si le 1er caractre de la prochaine ligne est ' '; sinon, la section
               beq.s    lsrch_outer         ; est termine et la chane n'est pas dfinie dans cette langue.
lsrch_clrz:    tst.b    d1                  ;Annule le bit Z du CCR (D1.B <> 0).
lng_rts:       rts                          ;Retour.
;\4
lng_lbl1:      tst.b    d0                  ; Branch. s'il s'agit de HELP: le nom du fichier d'aide
               beq.s    lng_inner1          ; ne peut tre dfini que dans le fichier de langue.
               cmpi.b   #2,d2               ; Branch. si la langue courante
               bne.s    lng_lbl2            ; n'est pas le franais.
               move.l   4(a0),(a0)          ;Stocke le ptr sur la chane franaise.
               bra.s    lng_lbl3            ;Passe au texte suivant.
lng_lbl2:      tst.b    d2                  ; Si la langue courante est l'anglais (0), on n'a pas  changer
               bne.s    lng_inner1          ; le ptr; dans le cas contraire, on passe  la langue suivante.
lng_lbl3:      addq.l   #8,a0               ;Ptr sur le titre du texte suivant.
               dbf      d0,lng_outer1       ;Boucle.
               tst.l    d6                  ; Branch. s'il n'y a pas
               beq.s    lang_end            ; de fichier de langue.
               lea      128*4(sp),sp        ;Libre la mmoire prise par les ptrs sur les sections du fichier de langue.
;\6
;    Retire de la mmoire les chanes non utilises, change le caractre de fin de chane (CR --> 0) et corrige les ptrs.

               movea.l  d6,a0               ;A0: ptr sur la source.
               movea.l  d6,a1               ;A1: ptr sur la destination.
               bra.s    lng_nxline          ;Branch. pour passer  la ligne suivante.
lng_outer2:    cmpi.b   #' ',(a0)           ; Branch. si le 1er caractre de la ligne n'est pas ' '
               bne.s    lng_nxline          ; (on ne recopie rien et on passe  la ligne suivante).
               addq.l   #7,a0               ;A0: ptr sur la chane.
               lea      alerts-4(pc),a2     ;A2: 1er ptr - 8.
               moveq    #(alert_help-alerts)/12,d0  ;D0.W: nb de ptrs - 1 (compteur).
lng_inner2a:   addq.l   #8,a2               ; Recherche parmi tous les
               cmpa.l   (a2)+,a0            ; ptrs  s'il y en a un qui
               dbeq     d0,lng_inner2a      ; est =  A0.
               bne.s    lng_nxline          ;Branch. si aucun ptr n'est =  A0: on ne recopie rien.
               move.l   a1,-(a2)            ;Corrige le ptr: remplace A0 par A1.
lng_inner2b:   move.b   (a0)+,(a1)+         ;
               cmpi.b   #cr,(a0)            ; Recopie la chane dans la destination.
               bne.s    lng_inner2b         ;
               clr.b    (a1)+               ;Stocke un octet nul (caractre de fin de chane).
lng_nxline:    cmpi.b   #lf,(a0)+           ; Recherche la fin
               bne.s    lng_nxline          ; de la ligne.
               tst.b    (a0)                ; Branch. s'il reste
               bne.s    lng_outer2          ; encore des lignes.
               suba.l   d6,a1               ;
               move.l   a1,-(sp)            ;
               bne.s    lng_lbl4            ;
               move.l   d6,d0               ; Libre l'espace inutilis ( cause
               bsr      call_mfree          ; d'un bug du TOS,  on est oblig de
               bra.s    lng_lbl5            ; considrer  le cas  o on ne garde
lng_lbl4:      move.l   d6,-(sp)            ; rien  part).
               clr.w    -(sp)               ;
               mgemdos  Mshrink,8           ;
lng_lbl5:      addq.l   #4,sp               ;
               moveq    #-1,d7              ;D7.W = -1: code de retour en cas d'erreur.
               tst.l    d0                  ; Branch. s'il y a
               bne      error               ; eu une erreur.
;\6
;  Construit le titre de la fentre...

lang_end:      lea      windtitle(pc),a0    ;A0: adr. o on doit stocker le titre de la fentre.
               lea      windname1(pc),a1    ;
wt_loop1:      move.b   (a1)+,(a0)+         ; Copie le dbut du titre: "TETRHEX" + version,
               bne.s    wt_loop1            ; indpendant de la langue choisie.
               subq.l   #1,a0               ;
               movea.l  alert_tetr+4(pc),a1 ;A1: ptr sur la suite du titre (dpendant de la langue).
wt_loop2:      cmpi.b   #'#',(a1)           ; Branch. si le prochain caractre
               bne.s    wt_lbl1             ; n'est pas '#'.
               lea      windname3(pc),a2    ;
wt_loop3:      move.b   (a2)+,(a0)+         ; C'est '#'. On recopie donc
               bne.s    wt_loop3            ; "Vincent Lefvre".
               subq.l   #1,a0               ;
               addq.l   #1,a1               ;
               bra.s    wt_loop2            ;Boucle tjrs.
wt_lbl1:       move.b   (a1)+,(a0)+         ;Recopie le caractre.
               bne.s    wt_loop2            ;Branch. si c'tait bien un caractre (non nul).
               subq.l   #1,a0               ;Dcr. A0, car ce n'tait pas un vrai caractre.
               move.w   #' (',(a0)+         ;Stocke " (".
               lea      10(a0),a1           ;A1: adr. des caractres situs aprs la date.
               move.b   #')',(a1)+          ;Stocke ")" (dernier caractre du titre si la fentre n'est pas en mode PAUSE).
               lea      pwtitle(pc),a2      ; Met  jour
               move.l   a1,(a2)             ; pwtitle.
               move.l   #'-- ',(a1)+        ;Stocke un octet nul et "-- ".
               movea.l  alert_paus+4(pc),a2 ;
wt_loop4:      move.b   (a2)+,(a1)+         ; Stocke "PAUSE" (dpendant de la langue).
               bne.s    wt_loop4            ;
               move.b   sepdate(pc),d0      ;D0.B: sparateur pour la date.
               move.b   fmtdate(pc),d1      ;D1.B: format de la date (cf cookie "_IDT").
               movea.l  a0,a1               ;A0 sera l'adr. o il faut stocker la date et le mois, A1... l'anne.
               ror.b    #2,d1               ; Branch. si l'anne doit se trouver
               bpl.s    sthd_lbl1           ; aprs la date et le mois.
               addq.l   #4,a0               ;
               move.b   d0,(a0)+            ; Met A0  jour et stocke le sparateur pour l'anne.
               bra.s    sthd_lbl2           ;
wr_digit:      rol.l    #4,d0               ;
               move.b   d0,(a1)             ; Ecrit le prochain chiffre
               andi.b   #$0F,(a1)           ; dans (A1) et incr. A1.
               ori.b    #'0',(a1)+          ;
               rts                          ;Retour.
sthd_lbl1:     addq.l   #5,a1               ; Met A1  jour et stocke le
               move.b   d0,(a1)+            ; sparateur pour l'anne.
sthd_lbl2:     move.b   d0,2(a0)            ;Stocke le sparateur entre la date et le mois.
               move.l   th_date(pc),d0      ;D0.L: $YYYYMMDD.
               bsr.s    wr_digit            ;
               bsr.s    wr_digit            ; Stocke l'anne
               bsr.s    wr_digit            ; (4 chiffres).
               bsr.s    wr_digit            ;
               lea      3(a0),a1            ;
               lsl.b    #1,d1               ; A0: adr. o il faut stocker la date.
               bmi.s    sthd_lbl3           ; A1: adr. o il faut stocker le mois.
               exg      a0,a1               ;
sthd_lbl3:     bsr.s    wr_digit            ; Stocke le mois
               bsr.s    wr_digit            ; (2 chiffres).
               movea.l  a0,a1               ;
               bsr.s    wr_digit            ; Stocke la date (2 chiffres).
               bsr.s    wr_digit            ;
;\6
;  Si le drapeau d'aide est actif, on envoie le fichier d'aide (s'il y en a un) sur la sortie std.

               tst.b    helpflag(pc)        ; Branch. si le drapeau d'aide
               bpl.s    not_help            ; n'est pas actif.
               dispstr  windtitle(pc)       ;Affiche "TETRHEX x.xx, crit par Vincent Lefvre (dd/mm/yyyy)".
               bsr.s    disp_endwt          ;Affiche ".\n".
               move.l   alert_help+4(pc),d0 ;D0.L: ptr sur le nom du fichier d'aide, ou 0 s'il n'y a pas de fichier d'aide.
               bne.s    load_hlpfile        ;Branch. s'il y a un fichier d'aide.
               move.l   alert_nhlp+4(pc),-(sp)  ; Affiche "Pas de fichier
help_end:      mgemdos  Cconws,6                ; d'aide".
               moveq    #12,d7              ;D7.W = 12: code de retour.
               pea      error(pc)           ;Affiche ".\n", et fin du prg.
disp_endwt:    dispstr  endwt(pc)           ;Affiche ".\n".
               rts                          ;Retour.
load_hlpfile:  movea.l  d0,a3               ;Ptr sur le nom du fichier.
               move.l   alert_hfnf+4(pc),-(sp)  ;Empile le ptr sur la chane  afficher au cas o le fichier n'existerait pas.
               clr.w    d7                  ; Charge le fichier. N = 0 ssi le fichier existe
               bsr      load_file           ; (dans ce cas, D6.L pointe sur le fichier).
               bmi.s    help_end            ;Branch. si le fichier n'existe pas (affiche "Fichier d'aide non trouv.\n").
disp_hlpfile:  dispstr  str_crlf(pc)        ;Saute une ligne.
               move.l   d6,(sp)             ;
               move.w   #Cconws,-(sp)       ; Affiche le fichier d'aide.
               trap     #gemdos             ;
               clr.w    (sp)                ; Fin du prg (sans
               trap     #gemdos             ; erreur).
;\4
               IFNE     REGISTERED
rul_msg:       move.l   a4,d7                  ; Stocke le ptr de pile du jeu dans la struct. rserve
               moveq    #msg_inrul-msg_rul,d0  ; aux msg, envoie le msg msg_inrul, et retour...
send_msgd7:    lea      struct_msg+4(pc),a0 ; Stocke D7.L dans la struct.
               move.l   d7,(a0)             ; rserve aux msg.
               bra.s    send_msgrul         ;Envoie le msg.
send_msgdisp:  moveq    #msg_disp-msg_rul,d0  ;Msg  envoyer.
send_msgrul:   addi.w   #msg_rul,d0         ;Ajoute  D0.W l'offset des msg du jeu.
send_msg0:     lea      struct_msg(pc),a0   ;A0: adr. de la struct.
send_msg1:     jmp      ([a0])              ;Envoi un msg.
               ENDIF
;\5
;  Met  jour num_timr.

not_help:      tst.b    (a4)                ;Timer utilis ?
               beq.s    timflag_end         ;Branch. si c'est le timer D qui est utilis.
               move.w   #timerA,num_timr-timer_flag(a4)  ;Change le n du timer.
;\6
;  Corrige l'index des fontes Speedo.

timflag_end:   lea      tfontid(pc),a0      ;Adr. du 1er identificateur.
               move.w   add_fid(pc),d0      ;Nb  ajouter aux identificateurs des fontes Speedo.
               move.w   outline(pc),d1      ;Flags indiquant si les fontes sont vectorielles.
               clr.b    d2                       ;
addfid_loop:   btst     d2,d1                    ;
               beq.s    addfid_next              ;
               add.w    d0,(a0)                  ; Ajoute D0 aux numros des
addfid_next:   addq.l   #2,a0                    ; fontes vectorielles.
               addq.b   #1,d2                    ;
               cmpi.b   #(add_fid-tfontid)/2,d2  ;
               bne.s    addfid_loop              ;
;\6
;  Rserve de la mmoire (servant  l'affichage) si le jeu se droule sur tout l'cran.
;  Interdit le chgt de rsolution si le jeu se droule dans une fentre GEM.

               lea      buffer(pc),a6       ;(A6): buffer, 4(A6): ap_id, ...
               move.b   acc_flag-timer_flag(a4),d0  ;D0.B: 0: application (.PRG ou .GTP), -1: accessoire (.ACC).
               or.b     d0,(a5)             ;(A5): 0: mode plein cran, -1: mode fentre GEM.
               bmi.s    no_res_chg          ;Branch. si le jeu se droule dans une fentre GEM.
               move.l   #buflen,d6          ;D6.L: taille du bloc de mmoire  rserver.
               move.l   d6,d0               ; Rserve le bloc
               bsr      call_malloc         ; de mmoire.
               moveq    #1,d7               ;D7.W = 1 (code de retour en cas d'erreur).
               move.l   d0,(a6)+            ;Stocke le ptr sur le bloc rserv. A6 pointe sur ap_id.
               beq.s    error10             ;Erreur si le bloc n'a pas pu tre rserv.
               movea.l  d0,a0               ;
clear_loop:    clr.b    (a0)+               ; Efface la zone de
               subq.l   #1,d6               ; mmoire rserve.
               bne.s    clear_loop          ;
               bra.s    init_aes
no_res_chg:    addq.b   #1,chres_flag-timer_flag(a4)  ;Interdit le chgt de rsolution.
               addq.l   #4,a6               ;A6 pointe sur ap_id.
;\7
;  Initialise l'AES.

init_aes:      maes     appl_init,0,1,0     ;Fonction APPL_INIT de l'AES.
               moveq    #-1,d7              ;D7.W = -1 (2 significations).
               cmp.w    d7,d0               ; Fin s'il y a eu une erreur
error10:       beq      error               ; (code de retour = -1).
               move.w   d0,(a6)+            ;Stocke l'identificateur de l'application. A6 pointe sur handle.
;\6
;  Envoie le msg d'initialisation.

               IFNE     REGISTERED
               lea      struct_msg+6(pc),a0 ;Adr. de la structure + 6.
               move.b   errflag(pc),(a0)    ;Stocke le flag d'affichage des msg d'erreur.
               move.w   d0,-(a0)            ;Stocke l'identificateur de l'application.
               move.l   msg_addr(pc),-(a0)  ;Stocke l'adr. de la routine la + prioritaire. A0: adr. de la struct.
               moveq    #msg_init,d0        ; Envoie le msg
               bsr      send_msg1           ; msg_init.
               move.l   d0,d7               ; Branch. s'il y a une erreur
               bne      exit2               ; (D7.W: code de retour).
               ENDIF
;\5
;  Rcupre le handle de la station de travail physique.

               maes     graf_handle,0,5,0   ;Fonction GRAF_HANDLE de l'AES.
               move.w   d0,d4               ;Handle de la station de travail physique.
               bra.s    open_vwks           ;Ouvre une station de travail virtuelle...
;\6
;  Change la rsolution graphique.

set_screen:    move.w   d0,-(sp)            ;Nouveau mode graphique.
               move.w   #3,-(sp)            ;Rsolution = 3 (i.e. rsolution Falcon).
               clr.l    -(sp)               ; --> c'est le GEM qui
               clr.l    -(sp)               ; s'occupe de tout.
               mxbios   Setscreen,14        ;Setscreen: nouveau mode graphique.
               rts                          ;Retour.
;\6
;  Change la rsolution pour avoir un mode 640x480x256.

change_res:    mvdi     v_clsvwk,0,0        ;CLOSE VIRTUAL WORKSTATION.
               lea      chres_flag(pc),a0   ;Drapeau de changement de rsolution.
               tst.b    (a0)                ; Fin si la rsolution a dj t change
               bne      chres_error         ; ou si on ne doit pas la changer.
               tas      (a0)                ;Met le MSB  1 pour indiquer que la rsolution va tre change.
               move.l   #ikbd_dev+18,-(sp)  ; Dsactive la souris; sinon, si on
               move.w   #Bconout,-(sp)      ; dplace la souris vers le bord de
               trap     #bios               ; l'cran, a plante.
               move.l   #Vsetmode<<16+$FFFF,(sp)  ;Fct Vsetmode, lecture (paramtre = -1).
               trap     #xbios              ;Appelle XBIOS: lit le mode graphique courant.
               addq.l   #6,sp               ;Nettoie la pile.
               move.w   d0,graphmode        ;Sauve le mode graphique courant.
               andi.w   #pal_flag|vga_flag,d0  ;Garde seulement les drapeaux "pal" et "vga".
               btst     #vga_bit,d0         ; Branch. si on
               bne.s    change_res2         ; est en VGA.
               ori.w    #vertflag|overscan,d0  ;Sinon, on se met en entrelac et overscan.
change_res2:   ori.w    #col80|bps8,d0      ;On se met en 80 colonnes et 256 couleurs.
               bsr.s    set_screen          ;Nouveau mode graphique.
;\6
;  Ouvre (sans effacer) une station de travail virtuelle.

open_vwks:     mxbios   Getrez,2            ;Getrez.
               lea      intin(pc),a0        ;Adr. du tableau INTIN.
               move.w   d0,(a0)+            ;Identificateur du device.
               moveq    #9,d0               ;Longueur du tableau INTIN - 2.
gi_loop:       move.w   #1,(a0)+            ;
               dbf      d0,gi_loop          ; Met les 9 mots suivants  1, et le dernier  2.
               addq.w   #1,-(a0)            ;
               mvdi     v_opnvwk,0,11       ;OPEN VIRTUAL SCREEN WORKSTATION.
               movea.l  a6,a5
               move.w   contrl+12(pc),(a5)+ ;Stocke le handle graphique.
               beq      vwks_error          ;Branch. si la station de travail n'a pas pu tre ouverte.
               lea      intout(pc),a0       ;Adr. du tableau INTOUT.
               move.w   (a0)+,d7            ;Abscisse maximale de l'cran.
               move.w   d7,(a5)+            ;Stocke l'abscisse maximale dans xx.
               move.w   d7,d6               ;D6.W: abscisse maximale.
               subi.w   #639,d7             ; Change la rsolution si la largeur
               bcs.s    change_res0         ; de l'cran est < 640.
               swap     d7                  ;Met l'abscisse - 639 dans le mot de poids fort.
               move.w   (a0),d7             ;Ordonne maximale de l'cran.
               move.w   d7,(a5)+            ;Stocke l'ordonne maximale dans yy.
               subi.w   #479,d7             ; Change la rsolution si la hauteur
               bcs.s    change_res0         ; de l'cran est < 480.
               lsr.l    #1,d7               ;D7 = (x0.w,y0.w).
               andi.l   #$7FF07FF0,d7       ;Alignement sur les mots.
               lea      xy0(pc),a2          ;A2: ptr sur xy0 (A2+4: ptr sur xlen).
               move.l   d7,(a2)+            ;Stocke l'offset (servira  centrer l'cran).
               cmp.w    #256,24(a0)         ; Change la rsolution si le nb de couleurs pouvant
change_res0:   bne      change_res          ; tre affiches simultanment est <> 256.
               addq.w   #1,d6               ; xlen: taille en octets d'une
               move.w   d6,(a2)             ; ligne de l'cran.
               move.w   (a0),d0             ;
               addq.w   #1,d0               ; D0.L: nb de pixels sur l'cran.
               mulu.w   d6,d0               ;
               move.l   d0,(a5)+            ;Stocke le nb de pixels dans scrn_len.
               moveq    #-2,d0              ;
               trap     #gem                ; *gdosflag = -1  si FSMGDOS
               cmpi.l   #'_FSM',d0          ; ou SpeedoGDOS est intall,
               seq      d0                  ; 0 sinon.
               or.b     d0,(a5)+            ;
get_logbase:   mxbios   Logbase,2           ;Logbase: renvoie l'adr. de l'cran logique.
               move.l   d0,addr_scr-windflag(a5)  ;Stocke cette adr. dans addr_scr.
;\8
;  Sauve la couleur des pinceaux.
;    Remarques: 1) pour les pinceaux, on appelle le XBIOS et non la VDI, car c'est
;         plus rapide et on peut changer toutes les couleurs  la fois.
;               2) pour les 16 premiers pinceaux et le pinceau 255, le code stock
;                  dans la mmoire cran ne correspond pas au n du pinceau.

               lea      RGB0(pc),a3         ;Adr. o les couleurs doivent tre stockes.
               xbrgb    VgetRGB,(a3)        ;Appelle XBIOS: sauve la couleur des pinceaux.
;\2
               tst.b    (a5)+               ; Branch. si le jeu se droule
               bpl      part1               ; sur tout l'cran.
;\6
;  On ouvre une fentre.

               bsr      load_fonts          ;Charge les fontes si SpeedoGDOS est install.
               lea      int_in(pc),a6           ;
               clr.w    (a6)+                   ; Calcule les coord. de
               move.w   #wkind,(a6)+            ; la fentre entire, 
               move.l   #windx<<16+windy,(a6)+  ; partir  de celles  de
               move.l   #windw<<16+windh,(a6)+  ; la zone de travail.
               bsr.s    wincalc                 ;
               beq.s    aes_error3          ;Branch. s'il y a eu une erreur.
               movem.w  int_out+2(pc),d4-d7 ;Coordonnes de la fentre entire.
               movem.w  xx(pc),d0/d1        ;D0: abscisse maxi, D1: ordonne maxi.
               sub.w    d6,d0               ; Abscisse et ordonne maxi du point
               sub.w    d7,d1               ; suprieur gauche de la fentre.
               lea      winpos+4(pc),a0
               movem.w  d6/d7,wind_wh-winpos-4(a0)  ;Stocke la largeur et la hauteur de la fentre.
               tst.b    (a0)                ;0: position fixe, < 0: centre, > 0: position dtermine par winpos.
               beq.s    winpos_cont         ;Branch. si c'est 0.
               bmi.s    winpos_ctr          ;Branch. si c'est < 0.
               subq.w   #1,d0               ; On enlve 1 aux abscisses et ordonnes maxi  cause du
               subq.w   #1,d1               ; bug de l'AES (msg de redraw envoy lors d'un move...).
               cmp.w    -(a0),d1            ; Branch. si l'ordonne demande
               bcs.s    winpos_cont         ; est trop gde.
               cmpi.w   #19,(a0)            ; Branch. si l'ordonne demande est
               bcs.s    winpos_cont         ; trop petite ( cause du menu).
               cmp.w    -(a0),d0            ; Branch. si l'abscisse demande
               bcs.s    winpos_cont         ; est trop gde.
               move.w   (a0)+,d4            ;
               move.w   (a0),d5             ; Nouvelle position.
               bra.s    winpos_cont         ;
wincalc:       maes     wind_calc,6,5,0,0   ;Calcule les coord. de la fentre ou de la zone de travail.
winpos_ctr:    lsr.w    #1,d0               ;
               lsr.w    #1,d1               ; Calcule la nouvelle position (on
               move.w   d0,d4               ; ajoute 8  l'ordonne  cause du
               move.w   d1,d5               ; menu, qui a une hauteur de 16).
               addq.w   #8,d5               ;
winpos_cont:   movem.w  d4-d7,-(a6)         ; Calcule les coord. de la zone
               move.l   #1<<16+wkind,-(a6)  ; de travail  partir de celles
               bsr.s    wincalc             ; de la fentre entire.
aes_error3:    beq.s    aes_error2b         ;Branch. s'il y a eu une erreur.
               lea      xy0-int_in(a6),a0   ;A0: xy0.
               move.l   int_out+2(pc),(a0)  ;Met  jour xy0 (coord. de la zone de travail).
               sub.w    (a0)+,d4              ; dxy: coord. de la fentre
               sub.w    (a0),d5               ; par rapport   la zone de
               movem.w  d4/d5,dxy-int_in(a6)  ; travail.
               movea.l  a6,a3               ;A3: INT_IN.
               pea      clear_colors(pc)    ;Adr.  laquelle il faudra se brancher aprs avoir ouvert la fentre.
               tst.b    acc_flag(pc)        ; Branch. si TETRHEX a t lanc
               beq.s    open_window         ; en tant qu'application.
               move.w   ap_id(pc),(a6)        ;
               lea      menu_title(pc),a0     ; Place TETRHEX x.xx dans la barre
               move.l   a0,addrin-int_in(a6)  ; de menu (accessoire).
               maes     menu_register,1,1,1   ;
               addq.w   #1,d0               ; Erreur si identificateur
aes_error2b:   beq      aes_error2          ; d'accessoire = -1.
wait_open:     lea      -16(sp),sp          ;Buffer pour evnt_mesag.
wtopen_loop:   move.l   sp,addrin-int_in(a3)  ;
               maes     evnt_mesag,0,1,1      ; Attend l'ouverture
               cmpi.w   #ac_open,(sp)         ; de l'accessoire.
               bne.s    wtopen_loop           ;
               lea      16(sp),sp           ;Libre le buffer.
open_window:   movem.l  d4-d7,-(sp)         ;Sauve les registres.
               movem.w  xy0-int_in(a3),d4/d5  ;
               add.w    dxy-int_in(a3),d4     ; D4/D5: coord. de la fentre.
               add.w    dxy+2-int_in(a3),d5   ;
               movem.w  wind_wh-int_in(a3),d6/d7  ;D6/D7: hauteur et largeur de la fentre.
               move.w   #wkind,d3           ; Cre une fentre dplaable
               movem.w  d3-d7,(a3)          ; avec une barre de titre, un
               maes     wind_create,5,1,0   ; closer et un smaller.
               bmi      window_error        ;Branch. si la fentre n'a pas pu tre ouverte.
               move.w   d0,whandle-int_in(a3)  ;Stocke le handle de la fentre.
               move.w   d0,d3               ;Handle de la fentre.
               bsr      set_title           ;Met le titre.
               beq.s    aes_error1          ;Branch. s'il y a eu une erreur.
               movem.w  d3-d7,(a3)          ; Ouvre la
               maes     wind_open,5,1,0     ; fentre.
               beq.s    aes_error1          ;Branch. s'il y a eu une erreur.
               movem.l  (sp)+,d4-d7         ;Rcupre les registres.
               rts                          ;Retour.
;\4
aes_error1:    lea      int_in(pc),a0       ;
               move.w   whandle(pc),(a0)    ; Dtruit la fentre.
               maes     wind_delete,1,1,0   ;
aes_error2:    moveq    #-1,d7              ;D7.W = -1: code de retour.
               movea.l  alert_aesr+4(pc),a5 ;Texte de la bote d'alerte  afficher.
               bra      alert               ;Affiche une bote d'alerte, et fin du prg.
;\4
clear_colors:  pea      game(pc)            ;Adr.  laquelle il faudra se brancher aprs chg_f2lcolor.
               lea      RGB+(lcolor+1)*4(pc),a0  ;Adr. de la couleur lcolor+1.
               move.w   #lcolor-fcolor,d0   ;Nb de couleurs - 1.
clrcol_loop:   clr.l    -(a0)               ; Annule les
               dbf      d0,clrcol_loop      ; couleurs.
chg_f2lcolor:  pea      RGB+fcolor*4(pc)    ;Adr. de la 1re couleur  modifier.
               move.l   #fcolor<<16+(lcolor-fcolor+1),-(sp)  ;1re couleur / nb de couleurs  modifier.
               mxbios   VsetRGB,10          ;Appelle XBIOS: modifie les couleurs.
               rts                          ;Retour.

;\7
;    Ŀ
;     Prsentation 
;    

;        Partie 1
;        
;  Prpare tout ce qui concerne le calcul de l'image de fond (pour le jeu) en tche de fond.

part1:         tas      (a5)                ;Active le drapeau multflag.
               tst.b    chres_flag(pc)      ; Cache  le curseur de la
               bmi.s    part1b              ; souris, si celle-ci n'a
               bsr      mouse_off           ; pas t dsactive.
part1b:        lea      ledp_addr(pc),a0    ;Adr. o a t stocke l'adr. de la structure LEDP ou 0.
               lea      ledp_flag(pc),a1    ;Adr. du flag LEDP.
               moveq    #0,d0               ;D0.L = 0.
               tst.b    (a1)                ; Branch. si LED Panel ne doit pas tre dsactiv (met l'adr. de la structure
               beq.s    part1c1             ;  0 pour indiquer que cette structure n'a pas t modifie).
               tst.l    (a0)                ; Branch. si LED Panel
               beq.s    part1c2             ; n'est pas prsent.
               moveq    #15,d0              ; D0: adr. de l'octet de la
               add.l    (a0),d0             ; structure  modifier.
               movea.l  d0,a2               ;
               move.b   (a2),(a1)           ; Sauve l'octet  modifier et dsactive LED Panel.
               bclr     #0,(a2)             ;
part1c1:       move.l   d0,(a0)             ;Stocke l'adr. de l'octet modifi, ou 0.
part1c2:       IFNE     REGISTERED
               moveq    #msg_pres,d0        ; Envoie le msg
               bsr      send_msg0           ; msg_pres.
               ENDIF
               lea      screen_sem(pc),a0   ;(A0) = 1 si le sm. d'cran doit tre activ, (A0) = 0 dans le cas contraire.
               neg.b    (a0)                ; Branch. si le smaphore d'cran ne doit pas tre activ
               beq.s    part1d              ; (--> (A0) < 0 ssi le smaphore d'cran est activ).
               lea      int_in(pc),a0       ;
               move.w   #beg_update,(a0)    ; Active le smaphore d'cran.
               bsr      wind_upd            ;
part1d:        moveq.l  #-1,d7              ;D7.L = -1 (cf Setexc, lecture).
               move.l   #Setexc<<16+$20+usr_trap,d6  ;N du vecteur et Setexc.
               move.l   d7,-(sp)            ;Empile -1 pour lire l'adr. de la routine appele par trap #usr_trap.
               move.l   d6,-(sp)            ;Empile le n du vecteur et Setexc.
               trap     #bios               ;Lit l'adr. de la routine d'exception.
               addq.l   #8,sp               ;Nettoie la pile.
               lea      trap_addr+2(pc),a0  ; Adr. de l'ancienne routine
               move.l   d0,(a0)             ; d'exception.
               pea      sup_switch(pc)      ;Adr. de la nouvelle routine appele par trap #usr_trap.
               move.l   d6,-(sp)            ;Empile le n du vecteur et Setexc.
               trap     #bios               ;Modifie l'adr. de la routine d'exception.
               addq.l   #8,sp               ;Nettoie la pile.
               bsr      gbkgr_resmem        ;Rserve de la mmoire et initialise quelques registres.
               lea      -stack_len/2(sp),a0 ;Ptr de pile - 4 de la routine gbkgr_start.
               move.l   #gbkgr_end,(a0)     ;Empile l'adr. de retour de cette routine.
               lea      bkgr_reg(pc),a2     ; Sauve les registres,
               movem.l  d0-d7/a0-a6,(a2)    ; le  ptr  de pile  et
               move.l   a0,60(a2)           ; l'adr. de la routine
               move.l   #gbkgr_start,66(a2) ; (PC de la routine).
;\7
;  Initialise les registres pour mk_tetrhex. Le dbut du calcul de l'image tetrhex s'effectuera pdt les boucles d'attente.

               move.l   #-145,d0            ;D0.L < 0 et D0.W < 0: 1re phase de calcul (dcompression des commandes).
               moveq    #0,d1               ;D1.L = 0: offset (en bits) du 1er code.
               lea      tetrhex(pc),a1      ;A1: adr. des codes (commandes compresses).
               lea      ([buffer.w,pc],bufl1.w),a2  ;A2: adr. o seront stockes les commandes (couleurs des hexagones).
               movem.l  REGS,-breg(a2)      ;Sauve les registres (seront rcuprs pdt les boucles d'attente).

;\7
;        Partie 2
;        
;  Efface l'cran (progressivement) en changeant la couleur des pinceaux. Utilisation du timer A ou D.
;  Puis l'cran est mis  la couleur 0.

               bsr      timer96             ;Lance le timer (96 Hz).
               lea      256*4(a6),a5        ;Adr. o les couleurs courantes doivent tre stockes.
               move.w   #255,d0             ;Nb de pinceaux - 1.
copy_colors:   move.l   (a6)+,(a5)+         ; Recopie les
               dbf      d0,copy_colors      ; couleurs.
               lea      counter(pc),a0      ; Compteur du
               move.w   d0,(a0)             ; timer = -1.
clr_outer:     lea      counter(pc),a0      ; Incr. le compteur du timer
               addq.w   #1,(a0)             ; de 1 (--> 96 Hz).
               movea.l  a6,a5               ;Adr. du tableau o les couleurs courantes ont t stockes.
               move.w   #256*4-1,d0         ;Nb d'octets - 1.
               clr.b    d7                  ;D7.B indiquera si toutes les couleurs ont une valeur nulle.
clr_inner:     clr.w    d1                  ;Annule l'octet de poids fort de D1.W.
               move.b   (a5),d1             ;D1.W: composante d'une couleur (R, G, B ou inutilise).
               mulu.w   #63,d1              ; Multiplie l'intensit
               lsr.w    #6,d1               ; par 63/64.
               move.b   d1,(a5)+            ;Stocke la nouvelle composante.
               or.b     d1,d7               ;Si elle est non nulle --> D7.B non nul.
               dbf      d0,clr_inner        ;Boucle pour chaque composante de toutes les couleurs.
               bsr      mk_tetrhex          ;Attend que le tps du timer soit coul et modifie la couleur des pinceaux.
               tst.b    d7                  ;Reste-t-il des couleurs de valeur non nulle ?
               bne.s    clr_outer           ;Oui, boucle.
               bsr      stop_timer          ;Arrte le timer.
               mvdi     v_clrwk,0,0         ;CLEAR WORKSTATION.

;\3
;        Partie 3
;        
;  Affiche le fond de l'cran. Utilisation du timer A ou D.
;\2
;    Des rectangles sont tracs de l'extrieur (couleur 1) vers le centre (couleur 52), la couleur tant
;    une fonction croissante, de drive dcroissante. Pour l'instant, toutes les couleurs sont noires.
;\5
;    L'index de la couleur du point de vue hardware ou XBIOS et celui du point
;    de vue de la VDI ne sont pas identiques. Voici la table de conversion :
;     XBIOS... $00 $01 $02 $03 $04 $05 $06 $07 $08 $09 $0A $0B $0C $0D $0E $0F $10 $11 ... $FD $FE $FF
;     VDI..... $00 $02 $03 $06 $04 $07 $05 $08 $09 $0A $0B $0E $0C $0F $0D $FF $10 $11 ... $FD $FE $01
;    Dans cette version, la VDI n'est pas utilise  ce niveau; mais elle pourrait l'tre dans une version ultrieure.
;\4
               lea      addr_scr(pc),a0     ;
               move.l   (a0)+,d0            ;
               moveq    #0,d1               ;
               move.w   (a0)+,d1            ;
               add.l    d1,d0               ; addr_win: adr. de l'cran "tetrhex"
               move.w   (a0)+,d1            ; (640 x 480 x 256), appel fentre.
               move.w   (a0)+,d2            ;
               mulu.w   d2,d1               ;
               add.l    d1,d0               ;
               move.l   d0,(a0)             ;
               movea.l  d0,a0               ;A0: adr. de la fentre.
               movea.w  xlen(pc),a3         ;A3.L: taille d'une ligne de l'cran systme en octets.
               move.w   #478,d2             ;D2.W: hauteur du rectangle - 2.
               move.w   #37,-(sp)           ;Nb de mots pris par une ligne horizontale - 3.
               moveq    #1,d4               ;D4.W: n du rectangle (sert pour calculer l'index de la couleur).
               moveq    #15,d5              ;D5.B: n du 1er bit dans le 1er mot.
               moveq    #0,d6               ;D6.B: n du dernier bit dans le dernier mot (= 15 - D5.B).
bkgr_outer1:   move.w   d4,d0               ;
               clr.b    d7                  ;
bkgr_inner1a:  addq.b   #1,d7               ; Calcule l'index de la couleur en fct de
               mulu.w   #15,d0              ; l'ordonne des pts situs en haut.
               lsr.w    #4,d0               ;
               bne.s    bkgr_inner1a        ;
               movea.l  a0,a1               ;Adr. du mot contenant le point situ en haut  gauche.
bkgr_inner1b:  lsr.b    #1,d7               ;Bit C du CCR: couleur du rectangle dans le prochain plan.
               bcc.s    bkgr_lbl2           ;Branch. si C = 0 (on ne trace rien).
               movea.l  a1,a4               ;Adr. du mot du plan courant contenant le pnt situ en haut  gauche.
               move.w   (sp),d3             ;Nb de mots pris par une ligne horizontale - 3.
               bsr.s    bkgr_horiz          ;Trace la ligne horizontale du haut.
               move.w   d2,d3               ;Longueur des lignes verticales situes strictement entre les cts horizontaux.
               move.b   d5,d0               ;
               move.b   d6,d1               ;
               addq.l   #1,a2               ; A4: adr. de l'octet  contenant le 2me
               subq.b   #8,d0               ; point situ tout  gauche. D0.B: n du
               bcc.s    bkgr_adda           ; bit correspondant  ce point. A2: adr.
               subq.l   #1,a2               ; de  l'octet  contenant  le  2me point
               addq.b   #8,d0               ; situ  tout  droite.  D1.B: n du bit
               addq.l   #1,a4               ; correspondant  ce point.
               subq.b   #8,d1               ;
               bra.s    bkgr_adda           ;
bkgr_horiz:    addq.b   #1,d5               ;Sous-prg traant une ligne horizontale.
               bfset    (a4){d6:d5}         ;Trace la partie correspondant au 1er mot.
               lea      16(a4),a2           ;Adr. du mot suivant.
               moveq    #-1,d0              ;D0.W = %111...11.
               moveq    #16,d1              ;Distance entre 2 mots successifs du mme plan.
bkgr_loop1:    move.w   d0,(a2)             ; Trace la partie situe
               adda.l   d1,a2               ; strictement  entre  le
               dbf      d3,bkgr_loop1       ; 1er et le dernier mot.
               bfset    (a2){0:d5}          ;Trace la partie correspondant au dernier mot.
               subq.b   #1,d5               ;Valeur initiale de D5.
               rts                          ;Retour.
bkgr_loop2:    bset     d0,(a4)             ;Trace le prochain point du ct gauche.
               bset     d1,(a2)             ;Trace le prochain point du ct droit.
bkgr_adda:     adda.l   a3,a4               ;Adr. du point suivant du ct gauche.
               adda.l   a3,a2               ;Adr. du point suivant du ct droit.
               dbf      d3,bkgr_loop2       ;Boucle...
               cmp.b    d1,d6               ; Corrige ventuellement la
               beq.s    bkgr_lbl1           ; valeur de A4 (--> adresse
               subq.l   #1,a4               ; paire).
bkgr_lbl1:     move.w   (sp),d3             ;Nb de mots pris par une ligne horizontale - 3.
               bsr.s    bkgr_horiz          ;Trace la ligne horizontale du bas.
               tst.b    d7                  ;Reste-t-il des plans o le rectangle doit tre trac ?
bkgr_lbl2:     addq.l   #2,a1               ;Plan suivant.
               bne.s    bkgr_inner1b        ;Boucle s'il reste encore des plans o le rectangle doit tre trac.
               addq.b   #1,d6               ;Incr. le n du dernier bit (l'abscisse diminue).
               subq.b   #1,d5               ;Dcr. le n du 1er bit (l'abscisse augmente).
               bcc.s    bkgr_lbl3           ;Branch. si ces bits restent dans le mme mot.
               moveq    #15,d5              ;
               clr.b    d6                  ; Passe au mot
               subq.w   #2,(sp)             ; suivant.
               lea      16(a0),a0           ;
bkgr_lbl3:     adda.l   a3,a0               ;Ligne suivante.
               addq.w   #1,d4               ;N du rectangle suivant.
               subq.w   #2,d2               ;La taille verticale diminue de 2.
               bcc      bkgr_outer1         ;Boucle (rectangle suivant).
               addq.l   #2,sp               ;Nettoie la pile.
;\6
;    Ensuite, on modifie progressivement la couleur des pinceaux (utilisation du timer), en commenant
;    par le centre (couleur 52).  A chaque pas,  on incr. de 4 l'intensit des couleurs bleu et rouge,
;    pour 32 pinceaux (ou moins, au dbut); voir prg ci-dessous pour + de dtails.

               bsr      timer96             ;Lance le timer (96 Hz).
               lea      RGB+52*4(pc),a6     ; Adr. de l'index de la couleur
               movea.l  a6,a5               ; du centre (index = 52).
               moveq    #51,d7              ;Nb de couleurs - 1.
               lea      counter(pc),a0      ; Annule le compteur du timer (utile
               clr.w    (a0)                ; qd on fait jouer un module .MOD).
bkgr_outer2:   lea      counter(pc),a0      ; Incr. le compteur du timer
               addq.w   #3,(a0)             ; de 3 (--> 32 Hz).
               moveq    #31,d0              ;Intensit maximale: (D0 + 1) * 4.
               movea.l  a6,a0               ;
bkgr_inner2:   add.l    #$040004,(a0)+      ; Incr. l'intensit de
               cmpa.l   a6,a5               ; certaines couleurs.
               dbcs     d0,bkgr_inner2      ;
               bsr      mk_tetrhex          ;Attend que le tps du timer soit coul et modifie la couleur des pinceaux.
               subq.l   #4,a6               ;Couleur prcdente.
               dbf      d7,bkgr_outer2      ;Boucle.
               bsr      stop_timer          ;Arrte le timer.
;\3
;    Ici, la couleur n a pour intensit 4n, si n  32. Pour 32  n  52, l'intensit de la couleur n est 128;
;    ces couleurs sont situes dans le rectangle de diagonale (58,58) - (581,421).  Les couleurs d'index > 32
;    sont celles situes dans le rectangle de diagonale (62,62) - (577,417).
;\7
;  Change les points de couleur d'index > 32 en pts de couleur d'index = 32 (i.e. on affiche un rectangle plein).

               moveq    #32,d0              ;Index de la couleur de remplissage: 32.
               bsr      fill_color          ;SET FILL COLOR INDEX.
               move.l   #$003E003E,d0       ; Affiche un rectangle plein
               move.l   #$024101A1,d1       ; de couleur 32 et de coord.
               bsr      frect1              ; (62,62) - (577,417).
;\6
;  Change les couleurs des pinceaux d'index compris entre 33 et 254 en couleur d'index = 32.

               lea      RGB+32*4(pc),a0     ; D0.L: valeur de la couleur d'index 32.
               move.l   (a0)+,d0            ; A0: adr. de la valeur de la couleur d'index 33.
               moveq    #-33-1,d1           ;D1.B: nb de couleurs  modifier (couleurs de 33  254).
colors_loop:   move.l   d0,(a0)+            ; Remplace la valeur de chaque couleur
               subq.b   #1,d1               ; d'index  33  par  la valeur  de  la
               bne.s    colors_loop         ; couleur d'index 32.
               bsr      chg_colors          ;Modifie la couleur des pinceaux.

;\8
;        Partie 4
;        
;  Affiche "Vincent Lefvre ... presents" (sans modifier la couleur des pinceaux --> on ne voit rien).

;    A l'adr. (image)  se situe une image monochrome compresse.  La dcompression s'effectue de la manire
;    suivante: on lit 1 par 1 les octets de (image). Un octet nul signifie une fin de ligne; s'il est suivi
;    d'un octet gal  1, la fin de l'image a t atteinte.  Octet n de 1  236: les n pixels suivants sont
;    teints. Octet n de 237  255: les 256 - n pixels suivants sont allums.

               lea      xlen(pc),a0            ;
               moveq    #0,d7                  ;
               move.w   (a0)+,d7               ; D7.L: longueur en octets d'une ligne de l'cran systme.
               moveq    #yvlp,d2               ; A4: adr. du 1er pixel o sera affiche l'image finale.
               mulu.w   d7,d2                  ;
               lea      ([a0],d2.l,wvlp.w),a4  ;
               IFEQ     fvlp                   ;
               lea      (a4,d7.w*4),a6         ; A6: adr. du 1er pixel
               ELSE                            ; o doit tre affiche
               lea      (fvlp.w,a4,d7.w*4),a6  ; l'image.
               ENDIF                           ;
               lea      image(pc),a5        ;A5: adr. de l'image compresse.
               moveq    #7,d4               ;D4.W: contiendra le nb final de lignes - 1, au maximum.
;\4
image_outer:   moveq    #dvlp,d6            ;D6.L: dplacement pour l'instruction BFSET.
               movea.l  a6,a0               ;Adr. du 1er mot de la ligne destination.
image_inner:   move.b   (a5)+,d1            ;Lit l'octet suivant de l'image compresse.
               beq.s    image_zero          ;Branch. s'il est nul: fin de ligne.
               cmpi.b   #236,d1             ; Branch. s'il faut tracer
               bhi.s    image_draw1         ; un segment.
               add.b    d1,d6               ;Dplacement (en bits),  $FF.
               move.l   d6,d2               ; Calcule l'adr. du mot o
               andi.b   #$F0,d2             ; se  trouve  le  prochain
               adda.l   d2,a0               ; pixel.
               andi.b   #$0F,d6             ;Nouveau dplacement (en bits),  15.
               bra.s    image_inner         ;Branch. pour lire l'octet suivant.
image_draw1:   neg.b    d1                  ;Taille du segment  tracer (= nb de bits  mettre  1).
image_draw2:   moveq    #16,d2              ; Nb de bits restants dans
               sub.b    d6,d2               ; le mot (A0), de 1  16.
               cmp.b    d2,d1               ; Branch. si le nb de bits restants
               bcc.s    image_draw3         ; est  au nb de bits  mettre  1.
               bfset    (a0){d6:d1}         ;Sinon, on met  1 les bits voulus.
               add.b    d1,d6               ;Met  jour le dplacement (en bits).
               bra.s    image_inner         ;Branch. pour lire l'octet suivant.
image_draw3:   bfset    (a0){d6:d2}         ;Met  1 les bits restants.
               clr.b    d6                  ;Nouveau dplacement: 0 (car le prochain bit est le 1er bit du mot suivant).
               sub.b    d2,d1               ;Met  jour le nb de bits  mettre  1.
               lea      16(a0),a0           ;Adr. du mot suivant (on saute 7 mots, car il y a 8 plans). CCR non affect.
               bne.s    image_draw2         ;Branch. s'il reste des bits  mettre  1.
               bra.s    image_inner         ;Branch. pour lire l'octet suivant.
image_zero:    adda.l   d7,a6               ;Adr. du 1er mot de la ligne suivante.
               addq.b   #1,d4               ;Incr. le nb maximal de lignes - 1.
               cmpi.b   #1,(a5)             ; Boucle s'il reste encore
               bne.s    image_outer         ; des lignes.
;\3
;    L'image monochrome vient d'tre dcompresse et affiche  l'cran (mais on ne voit rien,
;    car les valeurs des couleurs des pinceaux sont les mmes).  L'index de la couleur du fond
;    est 32; et pour l'instant, l'index de la couleur de l'image est 33.
;\6
;    Ensuite, on ajoute 2  l'index de la couleur des pixels voisins d'un pixel allum (chaque
;    pixel a 5 voisins:  lui-mme  et  ceux situs  juste au-dessus, au-dessous,  gauche et 
;    droite).  Puis on ajoute 4..., 8..., et 16...,  i.e.  les 5 premiers plans sont modifis.
;    Finalement, les index sont 63, 62, 60, 56 et 48 (en allant du centre vers l'extrieur).

               moveq    #3,d6               ;Nb final de couleurs - 2 (sans compter le fond): 63, 62, 60, 56, 48.
image_next:    move.w   d4,d5               ;Nb max. de lignes - 1.
               movea.l  a4,a6               ;Adr. du 1er mot de la 1re ligne (correspondant  la couleur prcdente).
image_nxlin:   movea.l  a6,a5               ;Adr. du 1er mot de la ligne en cours.
               moveq    #nvlp,d3            ;Nb de groupes de 16 pixels - 1 dans une ligne de l'image.
image_nxwrd:   move.w   (a5)+,d0            ;Lit le mot correspondant  la couleur prcdente.
               movea.l  a5,a0               ;Adr. du mot correspondant  la couleur courante.
               suba.l   d7,a0               ;Adr. du mot de la ligne prcdente, correspondant  la couleur courante.
               or.w     d0,(a0)             ;Allume les pixels situs juste au-dessus de la ligne courante.
               or.w     d0,(a5,d7.l)        ;Idem pour les pixels situs juste au-dessous.
               move.w   d0,d1               ;
               lsr.w    #1,d1               ; Idem pour les pixels situs
               bcc.s    image1              ; juste    droite  (rsultat
               tas      16(a5)              ; provisoire dans D1).
image1:        or.w     d0,d1               ;
               add.w    d0,d0               ;
               bcc.s    image2              ; Idem pour les
               ori.b    #1,-15(a5)          ; pixels situs
image2:        or.w     d1,d0               ;  gauche.
               or.w     d0,(a5)             ;
               lea      14(a5),a5           ;Saute 7 mots (correspondant aux autres plans).
               dbf      d3,image_nxwrd      ;Groupe de 16 pixels suivant.
               adda.l   d7,a6               ;Adr. du 1er mot de la ligne suivante (correspondant  la couleur prcdente).
               dbf      d5,image_nxlin      ;Ligne suivante.
               addq.l   #2,a4               ;Mot suivant (car on passe  la couleur suivante).
               dbf      d6,image_next       ;Prochaine couleur.
;\7
;    Ici, on modifie les 3 derniers plans (plans de poids fort). Pour chaque pixel, le nb form par ces 3 plans
;  est compris entre 1 et 6. L'index de la couleur de chaque pixel sera donc compris entre 32 et 223. La valeur
;  correspondant  ces 3 derniers plans est la + faible qd on se trouve en haut et au milieu de l'image.

               addq.l   #2,a4               ;A4: adr. du 1er mot de l'image correspondant au 1er des 3 plans.
               lea      4(a4),a5            ;A5: adr. du 1er mot de l'image correspondant au dernier des 3 plans.
               moveq    #3*nvlp+3,d6        ; D6.W: cte pour calculer le nb
               add.w    d4,d6               ; correspondant aux 3 plans, en
               divu.w   #9,d6               ; fct des coordonnes du pixel.
               clr.w    d5                  ;N de la ligne courante: 0 pour la 1re ligne.
               move.w   d4,-(sp)            ;Sauve le nb max. de lignes - 1.
img_nextlin:   movea.l  a4,a0               ;Adr. du 1er mot (corresp. au 1er des 3 plans) de la ligne.
               moveq    #nvlp,d3            ;N du mot courant (nvlp pour le 1er, 0 pour le dernier).
img_nextwrd:   moveq    #nvlp,d0            ;
               sub.w    d3,d0               ; D0.W = nvlp - 2 * (n du mot).
               sub.w    d3,d0               ;
               move.w   d0,d1               ; D1.W = D0.W + 1.
               addq.w   #1,d1               ;
               moveq    #1,d2               ;L'opration qui suit sera effectue pour X = D0 et pour X = D1 (cf instr. EXG).
img_loop1:     tst.w    d0                  ;
               bpl.s    img1                ; Valeur absolue de X.
               neg.w    d0                  ;
img1:          mulu.w   #3,d0               ;Multiplication par 3.
               add.w    d5,d0               ;Ajoute le n de la ligne courante.
               divu.w   d6,d0               ;Divise par la cte calcule au dbut.
               bne.s    img2                ; Si le rsultat est < 1,
               moveq    #1,d0               ; alors on prend 1.
img2:          cmp.b    #6,d0               ;
               bls.s    img3                ; Si le rsultat est > 6, alors on prend 6.
               moveq    #6,d0               ;
img3:          exg      d0,d1               ; Boucle (l'opration doit tre effectue pour X = D0 et pour X = D1).
               dbf      d2,img_loop1        ; Les rsultats (dans D0 et D1) sont compris entre 1 et 6.
               moveq    #2,d2               ;Nb de plans  modifier - 1.
img_loop2:     lsr.b    #1,d0               ; Modifie le 1er octet du mot courant
               scs      (a0)+               ; correspondant au plan courant.
               lsr.b    #1,d1               ; Idem pour le
               scs      (a0)+               ; 2nd octet.
               dbf      d2,img_loop2        ;Boucle (modifie le plan suivant).
               lea      10(a0),a0           ;Adr. du prochain mot (corresp. au 1er des 3 plans).
               dbf      d3,img_nextwrd      ;Boucle.
               adda.l   d7,a4               ;Adr. du 1er mot (corresp. au 1er des 3 plans) de la ligne suivante.
               addq.w   #1,d5               ;Incr. le n de la ligne courante.
               dbf      d4,img_nextlin      ;Prochaine ligne.
               move.l   d7,-(sp)            ;Sauve la longueur en octets d'une ligne de l'cran systme.
;\9
;  Modifie la couleur des pinceaux (l'image s'affiche progressivement).

;    Pour un index i de couleur donn, on note: p = int(i/32) le nb correspondant aux 3 derniers plans, n = 5-log2(32-mod(i,32))
;    la profondeur (0 pour le fond, 5 pour les pixels allums de l'image monochrome). Soit t, 1  t  190, le nb d'appels timer.
;    On pose: u = [(k-3*p)*t] ^ 2, avec k = 20 si p < 6, et k = 21 si p = 6;  x = int[ ( 1 + int[ (12*n*u) / (8192+u) ] ) / 2 ].
;    On a alors 0  x  30. La valeur (R,V,B) de la couleur sera: (128+4x,8x,128-4x).

               bsr      timer96             ;Lance le timer.
               moveq    #1,d7               ;D7.L = t (valeur initiale: t = 1).
img_timeloop:  moveq    #3,d1               ;
               move.b   d7,d0               ;
               lsr.b    #6,d0               ; Incr. le compteur du timer
               sub.b    d0,d1               ; de 3 - int[t/64].
               lea      counter(pc),a0      ;
               add.w    d1,(a0)             ;
               moveq    #6,d6               ;D6.L = p (valeur initiale: p = 6).
               moveq    #21,d3              ;D3.W = 21.
img_ploop:     move.w   d3,d5               ;
               sub.b    d6,d5               ; D5.W = (k - 3 * p) * t  3230,  avec
               sub.b    d6,d5               ;
               sub.b    d6,d5               ; k = 20 si p < 6, et k = 21 si p = 6.
               mulu.w   d7,d5               ;
               mulu.w   d5,d5               ;D5.L = u.
               moveq    #5,d4               ;D4.L = n (valeur initiale: n = 5).
img_nloop:     moveq    #12,d0              ;
               mulu.w   d4,d0               ; D0.L = 12 * n * u.
               mulu.l   d5,d0               ;
               moveq    #64,d1              ;
               lsl.w    #7,d1               ; D1.L = 8192 + u.
               add.l    d5,d1               ;
               divu.l   d1,d0               ;
               addq.b   #1,d0               ; D0.L = x.
               lsr.b    #1,d0               ;
               mulu.l   #$040800-$04,d0     ;D0 = (4x,8x,-4x).
               addi.l   #$800080,d0         ;D0 = (128+4x,8x,128-4x).
               moveq    #32,d1              ;D1.L = 32.
               move.b   d1,d2               ;D2.B = 32.
               lsr.b    d4,d2               ;D2.B = 2 ^ (5-n).
               sub.b    d2,d1               ;D1.L = 32 - 2^(5-n).
               move.b   d6,d2               ; D2.B =
               lsl.b    #5,d2               ; 32 * p.
               add.b    d2,d1               ;D1.L = 32*p + 32 - 2^(5-n): index de la couleur  modifier.
               lea      (RGB.w,pc,d1.l*4),a0  ; Stocke la valeur
               move.l   d0,(a0)               ; de la couleur.
               dbf      d4,img_nloop        ;Boucle tant que n  0.
               moveq    #20,d3              ;D3.W = 20.
               subq.b   #1,d6               ;Dcr. p.
               bne.s    img_ploop           ;Boucle tant que p > 0.
               bsr      mk_tetrhex          ;Attend que le tps du timer soit coul et modifie la couleur des pinceaux.
               addq.b   #1,d7               ;Incr. t.
               cmpi.b   #64,d7              ; Branch. si
               bls.s    img_timeloop        ; t  64.
               addq.b   #8,d7               ;Sinon, on ajoute encore 8 (pour aller + vite).
               cmpi.b   #190,d7             ; Boucle jusqu' ce
               bls.s    img_timeloop        ; que t > 190.
               bsr      stop_timer          ;Arrte le timer.
;\6
;    Met les 3 plans de poids fort  001, lorsque ceux-ci sont non nuls.
;  Lors de la modification, le nb doit tjrs tre compris entre 1 et 6, sinon la couleur physique risque d'tre modifie.

               move.l   (sp)+,d7            ;Longueur en octets d'une ligne de l'cran systme.
               move.w   (sp)+,d4            ;Nb max. de lignes - 1.
img_nxline:    movea.l  a5,a0               ;Adr. du 1er mot de la ligne courante du 8me plan.
               moveq    #nvlp,d3            ;Nb de mots - 1 dans une ligne.
img_nxword:    move.w   (a0),d0             ;8me plan.
               move.w   -(a0),d1            ;7me plan.
               eor.w    d0,d1               ; Si les 7me et 8me plans sont tous deux  1
               and.w    d1,(a0)             ; on annule le 7me plan (bit par bit).
               or.w     d1,d0               ;7me plan OR 8me plan.
               or.w     d0,-2(a0)           ;6me plan: 6me plan OR 7me plan OR 8me plan.
               clr.l    (a0)                ;Annule les 7me et 8me plans.
               lea      18(a0),a0           ;Adr. du mot suivant (du 8me plan).
               dbf      d3,img_nxword       ;Passe au mot suivant.
               adda.l   d7,a5               ;Adr. du 1er mot de la ligne suivante (du 8me plan).
               dbf      d4,img_nxline       ;Passe  la ligne suivante.
;\3
;    Les couleurs utilises par les bords et par "VL presents" sont comprise entre 0 et 63 (en fait, elles
;  ne sont pas toutes utilises), i.e. celles dont des 2 plans de poids fort sont nuls. La couleur du fond
;  est 32. La partie de l'cran situe dans le rectangle (58,184) - (581,421) a la couleur du fond.

;\6
;        Partie 5
;        
;  Affiche "TETRHEX".

;    Les couleurs 0  63 (bits 6 et 7 nuls) sont utilises pour ce qui a t affich prcdemment.  Les couleurs 64  127 (bit
;  7 nul, et bit 6  1) seront utilises par l'affichage des faisceaux [...fire] (cf listing). Les couleurs 128  255 (bit 7 
;  1) seront utilises pour l'affichage de TETRHEX et du cadre: 128  191 (bit 6  0) pour les couleurs intermdiaires, et 192
;   255 (bit 6  1) pour les couleurs du 1er plan.
;    L'image TETRHEX + cadre est forme d'hexagones pleins, et initialement compose de 3 couleurs:  couleur du fond,  couleur
;  intermdiaire et couleur du 1er plan.  La couleur du fond est la couleur 32  (cf parties prcdentes).  Les couleurs du 1er
;  plan et intermdiaire  dpendent en fait  de la position du point  sur l'cran;  pour chacune des deux,  il y a 64 pinceaux
;  possibles, suivants les valeurs des bits 0  5.  Ces bits sont regroups 2 par 2, ce qui donne 3 valeurs allant de 0  3. A
;  chaque groupe, on associe une direction et une couleur primaire:
;        Bits 4 et 5: direction -, couleur rouge.
;        Bits 2 et 3: direction /, couleur verte.
;        Bits 0 et 1: direction \, couleur bleue.
;    L'intensit de la couleur primaire  est la mme  suivant la direction associe,  et on a un dgrad  suivant la direction
;  perpendiculaire. Les intensits extrmes correspondent aux valeurs extrmes 0 et 3.  Dans une direction perpendiculaire, on
;  a successivement les valeurs 0, 1, 2, 3, 2, 1, 0, 1, 2, 3, 2, 1, 0, 1, 2, ...  L'intensit de base (intensit correspondant
;   la valeur 0) variera dans le temps de 0  254 par pas de 2. L'cart entre une intensit et la suivante variera aussi dans
;  le temps  de -16  +16.  Les 6 priodes de variation  sont des nombres premiers entre eux 2  2,  de faon  avoir  la plus
;  grande varit de couleurs possible au cours du temps.
;    Pdt l'affichage, les 64 couleurs intermdiaires (pinceaux) sont  la couleur du fond, pour viter l'affichage de couleurs
;  parasites. Un peu aprs la fin de l'affichage, une couleur intermdiaire prend, pour chaque couleur primaire, une intensit
;  gale au barycentre de celle de la couleur du 1er plan associe et de celle de la couleur du fond,  avec comme coefficients
;  respectifs 1/4 et 3/4. Ceci donne un lger effet de relief.
;\6
;    Modifie la couleur des pinceaux de 64  255.  Pour n compris entre 0 et 63, la valeur de la couleur de (G(n) + 64) XOR 32
;  est (128+2n,4n,128-2n), o G(n) est le code de Gray. Remarque: l'utilisation du code de Gray permettra de ne modifier qu'un
;  seul plan pour passer  la couleur suivante;  ainsi, non seulement les modifications de couleurs sont plus rapides, mais on
;  vite aussi l'apparition de couleurs parasites (comme ci-dessus).
;    Le bit 5 est invers pour la mme raison: le n de la couleur de fond ne doit diffrer de 32 que d'un seul bit.  On prend
;  donc 96 comme couleur de fond.
;    Les couleurs 128  255 (bit 7 gal  1) sont mises  la couleur du fond.

               lea      RGB+64*4(pc),a0     ;Adr. de la couleur 64.
               move.l   #$01010000,d0       ;Valeur de la couleur qui correspondrait  n = 64.
               moveq    #63,d1              ;Nb de couleurs  modifier - 1.
color_loop1:   move.w   d1,d2               ;
               lsr.b    #1,d2               ; Calcule le code de Gray.
               eor.b    d1,d2               ;
               eori.b   #32,d2              ;Inverse le bit 5.
               subi.l   #$000203FE,d0       ;Valeur de la prochaine couleur (dgrad).
               move.l   d0,(a0,d2.w*4)      ;Stocke la valeur de la couleur.
               dbf      d1,color_loop1      ;Boucle (dcrmente n).
               lea      64*4(a0),a0         ;Adr. de la couleur 128.
               moveq    #127,d1             ;Nb de couleurs  modifier - 1.
color_loop2:   move.l   d0,(a0)+            ; Modifie les couleurs 128 
               dbf      d1,color_loop2      ; 255 (--> couleur du fond).
               bsr      chg_colors          ;Modifie la couleur des pinceaux.
;\6
;  Calcule les adr. et n de bit des pts de dpart.
;  (A6 - 6n + 4): n du bit du point de dpart n n (1  n  nfire).
;  (A6 - 6n): adr. du point de dpart n n (1  n  nfire).

               link     a6,#-6*nfire        ;Rserve de la mmoire pour les pts de dpart.
               lea      sfire(pc),a0        ;Adr. du tableau des coordonnes des pts de dpart.
               movea.l  a6,a1               ;(A6 ne doit pas tre modifi.)
               moveq    #nfire-1,d7         ;Nb de pts - 1.
fire_loop:     moveq    #0,d0               ;Annule les 16 bits de poids fort de D0.
               move.w   (a0)+,d0            ;Abscisse (par rapport  la fentre).
               moveq    #7,d1               ;
               sub.b    d0,d1               ; Stocke le n du
               andi.b   #%111,d1            ; bit (de 0  7).
               move.w   d1,-(a1)            ;
               andi.b   #%11111000,d0       ;
               bclr     #3,d0               ; Offset de l'octet par rapport au 1er
               sne      d1                  ; octet de la ligne, sur la fentre.
               sub.b    d1,d0               ;
               move.w   (a0)+,d1            ;Ordonne (par rapport  la fentre).
               mulu.w   xlen(pc),d1         ;Multiplie par la longueur d'une ligne de l'cran systme (en octets).
               add.l    addr_win(pc),d1     ;Ajoute l'adr. de la fentre.
               add.l    d1,d0               ;--> Adr. du point de dpart.
               move.l   d0,-(a1)            ;On la stocke.
               dbf      d7,fire_loop        ;Boucle tant qu'il reste des pts de dpart.
;\6
;  Stocke dans le buffer l'adr. et le n de bit de chaque pnt  afficher.

               movea.l  buffer(pc),a5       ;A5 pointe sur le buffer.
               moveq    #0,d7               ;D7: adr. relative en bits de la prochaine commande.
               moveq    #84,d6              ;Nb de super-blocs de commandes - 1.
               moveq    #-14,d4             ;D4.L = -14 (D4.W et D4.B sont ngatifs).
unpack_outer:  movea.l  a6,a0               ;Adr. de fin du tableau des adr. des pts.
unpack_inner:  move.w   -(a0),d3            ;D3: n du bit du pnt courant.
               movea.l  -(a0),a3            ;A3: adr. du plan 0 du pnt courant.
               bra.s    unpack_cmd          ;Branch. pour lire la prochaine commande.
unpack_loop:   ext.w    d0                  ;D0.W: commande dcompacte.
               move.l   (cfire+12.w,pc,d0.w*4),d1  ;Composantes du dplacement (vecteur).
               move.w   d1,d2               ;
               muls.w   xlen(pc),d2         ; Modifie l'ordonne.
               adda.l   d2,a3               ;
               swap     d1                  ;D1.W: dplacement / abscisse.
               sub.b    d1,d3               ;Modifie le n du bit.
               bpl.s    unpack_pos          ;Branch. s'il est encore positif.
               addq.l   #1,a3               ;
               move.l   a3,d1               ; Il est ngatif: alors on passe  l'octet
               andi.b   #1,d1               ; suivant,  et on met le numro du bit  7
               bne.s    unpack_add8         ; (instr. addq.b #8,d3).
               suba.l   d4,a3               ;
unpack_add8:   addq.b   #8,d3               ;Ajoute 8 au n du bit.
               bra.s    unpack_write        ;Branchement...
unpack_pos:    subq.b   #8,d3               ; Branch. si le n du bit est diffrent de
               bne.s    unpack_add8         ; 8 (alors on reste dans le mme octet).
               subq.l   #1,a3               ;
               move.l   a3,d1               ; Sinon, on l'annule (instr. subq.b #8,d3
               andi.b   #1,d1               ; ci-dessus),  puis  on  passe   l'octet
               beq.s    unpack_write        ; prcdent.
               adda.l   d4,a3               ;
unpack_write:  bset     d3,12(a3)           ;Met  1 le plan 6 du nouveau pnt.
               move.w   d3,(a5)+            ;Stocke le n du bit du pnt dans le buffer.
               move.l   a3,(a5)+            ;Stocke l'adr. du pnt dans le buffer.
unpack_cmd:    bfextu   bfire(pc){d7:4},d0  ;Lit les 4 bits suivants (1 commande: 3 ou 4 bits).
               lsr.b    #1,d0               ;Dcalage vers la droite --> D0: 3 premiers bits de la commande.
               bne.s    unpack2             ;Branch. si c'est une commande sur 3 bits.
               bcc.s    unpack1             ; C'est une commande sur 4 bits, car les 3 premiers sont nuls.
               moveq    #8,d0               ; 0000 --> D0 = 0, 0001 --> D0 = 8.
unpack1:       addq.l   #1,d7               ; Incrmente D7 de 3 ou 4, i.e.
unpack2:       addq.l   #3,d7               ; passe  la commande suivante.
               subq.b   #3,d0               ; Boucle si ce n'est pas une
               bne.s    unpack_loop         ; commande de fin de bloc.
               move.l   a3,(a0)             ; Met  jour l'adr. et le n du
               move.w   d3,4(a0)            ; bit du pnt, dans le tableau.
               cmpa.l   a0,sp               ; Boucle si on n'est pas arriv
               bne.s    unpack_inner        ; au bas du tableau.
               move.w   d4,(a5)+            ;Stocke un mot ngatif dans le buffer: fin d'un super-bloc.
               dbf      d6,unpack_outer     ;Boucle: passe au prochain super-bloc.
               move.b   d4,(a5)             ;Stocke un mot ngatif dans le buffer: fin des commandes.
               unlk     a6                  ;Libre le tableau.
;\6
;  Effectue une permutation alatoire des 3 premiers nb situs  l'adr. freq, et des 3 suivants.
;  Prend des directions alatoires pour le rouge et le bleu.

               bsr      rand24              ;D0.L: nb alatoire sur 24 bits.
               move.b   d0,d2               ;Sauve les 2 bits de poids faible de D0.
               lsr.l    #2,d0               ;Divise D0.L par 4.
               divu.w   #36,d0              ;
               clr.w    d0                  ; D0.L: nb alatoire entre 0 et 35.
               swap     d0                  ;
               divu.w   #6,d0               ;--> 2 nb alatoires entre 0 et 6.
               lea      freq(pc),a0         ;Adr. des nb  permuter.
perm_loop:     lsr.b    #1,d0               ;Divise D0 par 2.
               bcc.s    perm2               ;
               move.l   (a0),d1             ; Si D0 tait impair, on effectue une
               swap     d1                  ; transposition des 2 premiers nb.
               move.l   d1,(a0)             ;
perm2:         move.w   (a0)+,d1            ;
               move.w   (a0),-2(a0)         ;
               move.w   2(a0),(a0)          ; Effectue D0 + 1 permutations
               move.w   d1,2(a0)            ; circulaires des 3 nb.
               subq.l   #2,a0               ;
               dbf      d0,perm2            ;
               addq.l   #6,a0               ; Passe aux 3 nb
               swap     d0                  ; suivants.
               tst.b    d0                  ; Boucle une seule
               bpl.s    perm_loop           ; fois.
               lea      18(a0),a0           ;A0: adr. de la direction du bleu.
               lsr.b    #1,d2               ;
               bcc.s    perm3               ; Direction alatoire (2).
               neg.w    (a0)                ;
perm3:         addq.l   #4,a0               ;A0: adr. de la direction du rouge.
               lsr.b    #1,d2               ;
               bcc.s    end_perm            ; Direction alatoire (2).
               neg.w    (a0)                ;
;\6
;  Termine les calculs de l'image "TETRHEX".

end_perm:      lea      counter(pc),a0      ; *counter = ctrend  0 (indique qu'on
               move.w   #ctrend,(a0)        ; veut terminer les calculs).
               bsr      mk_tetrhex          ;Termine les calculs.
               moveq    #4,d0               ; Lance le timer
               bsr      timer               ;  N = 192 Hz.
               lea      ([buffer.w,pc],bufl1+linlen*(nlines>>1)+(linlen>>1)-2.l),a0  ;Centre plan 0 source - 2 octets.
               move.w   xlen(pc),d7         ;Taille d'une ligne en octets sur l'cran de destination (physique).
               mulu.w   #302,d7             ;Taille de 302 lignes.
               lea      ([addr_win.w,pc],d7.l,304.w),a2  ;Adr. de destination correspondant  l'adr. source A0.
               move.w   #(linlen-4)>>1,-(sp)  ;Empile le nb d'octets (par ligne) restant  copier  gauche et  droite.
               clr.w    -(sp)               ;Empile 0.
;\6
;  Affiche TETRHEX.

               clr.w    d4                  ;D4.W = 0 (pour new_colors).
               lea      counter(pc),a1      ; Initialise le compteur
               move.w   #ctt,(a1)           ; du timer.
               moveq    #63,d7              ;Code de la couleur du 1er bloc  afficher.
               movea.l  buffer(pc),a5       ;A5 pointe sur le buffer.
fire_outer:    moveq    #ctt,d0             ;D0 = ctt = 2 --> 64 Hz.
               lea      countr2(pc),a1      ;Adr. du 2me compteur.
fire_loop0:    cmp.w    counter(pc),d0      ; Attend que le temps du timer
               beq.s    fire_loop0          ; soit coul (192 Hz).
               addq.l   #1,(a1)             ;Incr. le 2me compteur.
               movem.l  d0/d2/d3/a0/a2,-(sp)  ;Sauve les registres.
               move.l   (a1),d0             ;Valeur du 2me compteur.
               bsr      new_colors          ;Change ventuellement les couleurs, suivant la valeur de D0.
               movem.l  (sp)+,d0/d2/d3/a0/a2  ;Rcupre les registres.
               subq.b   #1,d0               ;Dcr. D0 (diviseur de frquence).
               bpl.s    fire_loop0          ;Boucle (64 Hz).
               lea      counter(pc),a1      ; counter = ctt = 2
               move.w   #ctt,(a1)           ; --> 64 Hz.
               movea.l  a5,a1               ;A1: adr. du prochain pnt.
               move.b   d7,d6               ;Code de la couleur du prochain bloc  afficher.
fire_inner:    moveq    #-2,d5              ;
               move.b   d6,d0               ;
               addq.b   #1,d0               ;
               or.b     #32,d0              ; D5.W = 2 * n du plan  modifier.
fire_loop1:    addq.w   #2,d5               ;
               lsr.b    #1,d0               ;
               bcc.s    fire_loop1          ;
               bra.s    fire_lbl1
fire_loop2:    movea.l  (a1)+,a3            ;Adr. du plan 0 du pnt courant.
               bchg     d3,(a3,d5.w)        ;Modifie la couleur du pnt.
fire_lbl1:     move.w   (a1)+,d3            ;D3: n du bit du pnt courant, ou mot ngatif.
               bpl.s    fire_loop2          ;Branch. si c'est un n de bit (sinon, fin du super-bloc).
               tst.b    d6                  ; Si le super-bloc a t mis  la couleur
               bne.s    fire_lbl2           ; du fond, alors on ne s'occupera plus de
               movea.l  a1,a5               ; ce super-bloc.
fire_lbl2:     tst.b    (a1)                ; Branch. s'il n'y a plus
               bmi.s    fire_lbl3           ; de super-bloc.
               addq.b   #1,d6               ;Incr. le code de couleur.
               cmpi.b   #64,d6              ; Passe au super-bloc suivant si on n'a pas
               bcs.s    fire_inner          ; atteint le code de couleur maximal.
fire_lbl3:     tst.b    d7                  ; Branch. si le code de la couleur du 1er
               bne      fire_subq           ; bloc  afficher n'est pas encore nul.
;\4
               moveq    #0,d3               ; D3.L = taille d'une ligne de
               move.w   xlen(pc),d3         ; l'cran systme en octets.
               tst.w    (sp)                ; Branch. si on a dj commenc
               bne.s    fire_tet1           ;  afficher TETRHEX.
               moveq    #2,d2               ;D2.B = 2 (cf fire_tet1).
               moveq    #4,d6               ;Paramtre pour fire_line (longueur d'une ligne).
               move.w   d6,-(sp)            ;Empile 4: longueur provisoire d'une ligne, en octets.
               bsr      fire_line           ;Affiche les 4 premiers octets (situs au centre).
               pea      (a0)                ; Sauve A0
               pea      (a2)                ; et A2.
               lea      linlen(a0),a0       ;Descend d'une ligne sur l'cran source (plan 0).
               move.w   xlen(pc),d6         ; Descend d'une ligne sur
               lea      (a2,d6.w),a2        ; l'cran systme.
               bra      fire_tet2           ;Branch. pour afficher des lignes au-dessous et au-dessus.
;\4
fire_tet1:     subq.b   #1,d2               ;
               bcc      fire_lbl4           ; On n'affiche la suite de TETRHEX qu'une fois sur 3.
               moveq    #2,d2               ;
               subq.w   #1,4(sp)            ;Dcr. le nb d'octets restants  copier  gauche et  droite.
               bmi      fire_lbl4           ;Branch. s'il ne reste plus rien  copier.
               subq.l   #1,a0               ;Dcr. A0 (on affiche un octet supplmentaire  gauche, et  droite).
               subq.l   #1,a2               ;
               move.l   a2,d0               ; A2: adr. correspondante
               andi.b   #1,d0               ;
               beq.s    fire_tet3           ; sur l'cran systme.
               lea      -14(a2),a2          ;
fire_tet3:     pea      (a0)                ; Sauve A0
               pea      (a2)                ; et A2.
               move.w   10(sp),d0           ;D0.W: nb de lignes dj affiches.
               move.w   8(sp),d5            ;Longueur d'une ligne en octets (sur l'cran source).
               addq.w   #1,d5               ;Distance entre les 2 octets  afficher (par ligne), sur l'cran source.
               move.w   d5,d1               ;
               lsr.w    #2,d1               ;
               lsl.w    #5,d1               ;
               addi.w   #15,d1              ; Idem, sur l'cran systme.
               btst     #1,d5               ;
               beq.s    fire_outr1          ;
               addq.w   #2,d1               ;
;\4
fire_outr1:    movea.l  a0,a1               ; Adr. de l'octet  gauche, sur
               adda.l   #7*tetr1p,a1        ; le plan 7 de l'cran source.
               lea      14(a2),a4           ;Idem, pour l'cran systme.
               lea      (a1,d5.w),a3        ; Idem, pour l'octet
               lea      (a4,d1.w),a6        ;  droite.
               moveq    #-1,d6              ;D6.W < 0: indique qu'on en est au plan 7 (plan affich le 1er).
fire_innr1:    move.b   (a1),(a4)           ;Affiche l'octet  gauche (sur le plan courant).
               addq.l   #2,a4               ;Plan suivant sur l'cran source pour l'octet  gauche.
               lea      tetr1p(a1),a1       ;Plan suivant sur l'cran systme pour l'octet  gauche.
               move.b   (a3),(a6)           ;
               addq.l   #2,a6               ; Idem, pour l'octet  droite.
               lea      tetr1p(a3),a3       ;
               tst.w    d6                  ; Boucle si on en tait au
               dbmi     d6,fire_innr1       ; plan 0, 1, 2, 3, 4 ou 5.
               bpl.s    fire_nxtline        ;Branch. si on en tait au plan 6 (plan affich le dernier).
               moveq    #6,d6               ;Nb de plans restant  afficher - 1.
               suba.l   #8*tetr1p,a1        ;Adr. de l'octet  gauche sur le plan 0 de l'cran source.
               lea      -16(a4),a4          ;Idem, pour l'cran systme.
               suba.l   #8*tetr1p,a3        ; Idem, pour l'octet
               lea      -16(a6),a6          ;  droite.
               bra.s    fire_innr1          ;Branch. pour afficher le plan 0.
;\4
fire_nxtline:  lea      linlen(a0),a0       ;Descend d'une ligne sur l'cran source.
               adda.l   d3,a2               ;Descend d'une ligne sur l'cran systme.
               dbf      d0,fire_outr1       ;Boucle (ligne suivante).
               addq.w   #2,8(sp)            ;Incr. la taille d'une ligne de 2 octets: on vient d'afficher 2 octets par ligne.
;\4
fire_tet2:     moveq    #2,d1               ;
               moveq    #0,d0               ;
               move.w   8(sp),d6            ;
               move.w   d6,d0               ; D1.W: nb de lignes  afficher
               divu.w   #3,d0               ;
               clr.w    d0                  ; en haut et en bas (2 ou 3).
               tst.l    d0                  ;
               seq      d0                  ;
               sub.b    d0,d1               ;
               move.w   d1,-(sp)            ;Sauve D1.
               add.w    d1,d1               ;Nb total de lignes  afficher.
               add.w    d1,12(sp)           ;Met  jour le nb de lignes affiches.
fire_loop3:    bsr      fire_line           ;Affiche une ligne en bas.
               lea      linlen(a0),a0       ;Ligne suivante (cran source).
               adda.l   d3,a2               ;Ligne suivante (cran systme).
               subq.w   #2,d1               ; Boucle tant qu'il reste encore
               bne.s    fire_loop3          ; des lignes  afficher en bas.
               move.w   (sp)+,d1            ;Rcupre D1.
               movea.l  (sp)+,a2            ;Rcupre A2.
               movea.l  (sp)+,a0            ;Rcupre A0.
fire_loop4:    lea      -linlen(a0),a0      ;Ligne suivante vers le haut (cran source).
               suba.l   d3,a2               ;Ligne suivante vers le haut (cran systme).
               bsr      fire_line           ;Affiche une ligne en haut.
               subq.w   #1,d1               ; Boucle tant qu'il reste encore
               bne.s    fire_loop4          ; des lignes  afficher en haut.
               bra.s    fire_lbl4
;\4
fire_subq:     subq.b   #1,d7               ;Dcr. le code de couleur du 1er super-bloc s'il n'est pas encore nul.
fire_lbl4:     tst.b    (a5)                ; Boucle s'il reste encore des super-blocs
               bpl      fire_outer          ; qui ne sont pas  la couleur du fond.
               addq.l   #6,sp               ;Nettoie la pile.
               lea      counter(pc),a6      ;(A6): counter, 2(A6): countr2.
               subi.w   #ctt,(a6)           ;Ramne counter  la rfrence 0.

;\7
;        Partie 6
;        
;  Libre la mmoire utilise par les buffers pour la prsentation. Vide le buffer clavier.
;  Attend l'appui d'une touche. Pdt ce tps, on continue de modifier les couleurs de TETRHEX.

               move.l   #fbufl,-(sp)        ;Taille du mini-buffer  garder.
               move.l   buffer(pc),-(sp)    ;Adr. du buffer.
               fre_mem                      ;Libre la zone mmoire utilise par les buffers servant  la prsentation.
               tst.l    d0                  ; Branch. s'il y a
               bne      gemdos_error        ; eu une erreur.
endpr_loop0:   mcrawio                      ;
               tst.w    d0                  ; Vide le buffer clavier.
               bne.s    endpr_loop0         ;
               moveq    #80,d6              ; D6.L = 160. Cf
               add.b    d6,d6               ; new_colors.
endpr_loop1:   tst.w    (a6)                ; Attend  que le temps
               bpl.s    endpr_loop1         ; du timer soit coul
               addq.w   #1,(a6)+            ; (192 Hz).
               addq.l   #1,(a6)             ;Incr. le compteur countr2.
               move.l   (a6),d0             ;D0 = *countr2 (pour la routine new_colors).
               bsr      new_colors          ;Changement ventuel de la couleur des pinceaux.
               subq.l   #2,a6               ;Corrige la valeur de A6.
               tst.b    d6                  ; Branch. si le changement
               beq.s    endpr_end           ; de couleurs est termin.
               tst.w    d4                  ; Si une touche a dj t enfonce,
               bne.s    endpr_loop1         ; on n'effectue pas de test.
               mcrawio                      ;Test le clavier (Crawio avec paramtre $FF).
               move.w   d0,d4               ;0 si aucune touche n'a t enfonce.
               bra.s    endpr_loop1         ;Branchement.

;\6
;        Partie 7
;        
;  Efface progressivement l'cran en changeant la couleur des pinceaux, puis efface la station de travail.

endpr_end:     moveq    #-1,d5              ;D5.B < 0 pour tout effacer en multipliant par 127/128.
               bsr      clr_colors3         ;Efface progressivement l'cran.

;\5
;    Ŀ
;     Prpare l'cran pour le jeu 
;    

;  Met la couleur de l'cran (i.e. de chaque pixel de l'cran systme)  64 (plan 6  1, les autres  0).
;\7
;  Note:  Pour l'instant, tous les plans sont  1: en effet, la couleur 1 de la VDI correspond  la couleur -1
;     du Xbios  (ou hardware).  Il faut donc annuler  les plans 0, 1, 2, 3, 4, 5 et 7.  On travaillera par
;         groupes de 16 pixels (--> 1 mot).  Il faut qu' chaque modification de plan, la couleur reste noire.
;         Sachant que les couleurs 64  lcolor (= 251) sont noires,  on commencera par annuler le plan 7, puis
;         on annulera les plans de 0  5 (dans n'importe quel ordre).

               movea.l  addr_scr(pc),a0     ;A0: adr. de l'cran logique.
               move.l   scrn_len(pc),d4     ;Nb de pixels sur l'cran.
               lsr.l    #4,d4               ;Nb de pixels sur l'cran / nb de bits dans un mot.
col64_loop:    clr.w    14(a0)              ;Annule 16 bits du plan 7.
               clr.l    (a0)+               ;
               clr.l    (a0)+               ; Annule 16 bits des plans de 0  5.
               clr.l    (a0)+               ;
               addq.l   #4,a0               ;Passe au groupe de 16 pixels suivant.
               subq.l   #1,d4               ; Boucle tant qu'on n'a pas atteint
               bne.s    col64_loop          ; la fin de l'cran.
;\6
;  Affiche 8 rectangles: { (7,55) ; (632,472) ; couleur 240 }  { (0,48) ; (639,479) ; couleur 247 }.

               moveq    #7,d3               ;
               moveq    #$37,d4             ; Coordonnes du + petit rectangle 
               move.w   #639-7,d5           ; afficher (rectangle intrieur).
               move.w   #479-7,d6           ;
               move.w   #240,d7             ;Index de la couleur du rectangle intrieur.
               lea      intin(pc),a4
endpr_loop4:   move.w   d7,(a4)             ;Index de la couleur du prochain rectangle.
               bsr      rectangle           ;Affiche le rectangle (D3,D4) - (D5,D6), incr. couleur et pnt infrieur droit.
               subq.w   #1,d4               ; Dcr. les coord. du point
               subq.w   #1,d3               ; suprieur gauche.
               bcc.s    endpr_loop4         ;Boucle (passe au rectangle suivant).
;\3
;  Charge les fontes si SpeedoGDOS est install.

               bsr      load_fonts          ;Charge les fontes si SpeedoGDOS est install.
;\6
;  Affiche TETRHEX suivi du n de version, en haut, en affichage centr, mode transparent, caractres
;  de 40 pixels de haut, couleur 248.  La fonte utilise est la fonte vectorielle d'index *tfontid si
;  elle existe et si SpeedoGDOS est install; sinon, on prend la fonte systme.

               lea      intin(pc),a6        ;A6: adr. du tableau INTIN.
               move.w   tfontid(pc),d7      ; Slectionne la fonte de n *tfontid si SpeedoGDOS
               bsr      sfont_cb            ; est install. Affichage centr, base line.
               moveq    #248,d0             ; Couleur du texte
               bsr      text_color          ; = 248.
               moveq    #40,d7              ; Hauteur des caractres:
               bsr      height_trans        ; 40. Mode transparent.
               bsr      sto_tetrhex         ;Stocke "TETRHEX x.xx" (ou x.xx est le n de version) dans le tableau INTIN.
               moveq    #12,d0              ; D0.W: largeur en pixels de
               bsr      call_extent         ; "TETRHEX x.xx".
               cmpi.w   #600,d0             ; Erreur si elle
               bhi      font_error          ; est trop gde.
               bsr      sto_tetrhex         ;Stocke "TETRHEX x.xx" dans le tableau INTIN.
               move.l   #320<<16+44,d1      ;Coord. relatives du texte  afficher.
               moveq    #12,d0              ; Affiche "TETRHEX x.xx"
               bsr      disp_text           ; en haut, centr.
;\6
;  Effectue une transformation du texte qui vient d'tre affich --> texte en 4 couleurs (sans compter le fond).

;  Explications:
;      On isole d'abord un plan, que l'on notera A (source). A partir de maintenant, on ne travaillera qu'avec des images
;     1 seul plan.  Chaque pixel a exactement 8 voisins; tant donne une image Z, on peut considrer les 8 images dca-
;    les d'un seul pixel Z1, Z2, ..., Z8.  On pose B = A1 | A2 | ... | A8, et C = B & !A.  L'image C est appele contour
;    extrieur 1 de A:  les pixels "allums" de C  sont les pixels "teints" de A  qui ont au moins un voisin allum.  On
;    pose D = C1 | C2 | ... | C8, et E = D & !C. Les pixels allums de E sont les pixels teints de C qui ont au moins un
;    voisin allum. On pose F = E & A (contour intrieur), G = E & !A (contour extrieur 2) et H = A & !F (intrieur).
;      On obtient ainsi 4 images "disjointes" H, F, C et G, d'o une seule image  4 couleurs, sans compter la couleur du
;    fond,  forme des 4 plans H, F, C et G. En fait, il suffit de calculer A, C, E et F et de les afficher dans l'ordre,
;    avec des couleurs diffrentes  (A: 248, C: 249, E: 250, F: 251).  L'intrieur aura alors la couleur 248,  le contour
;    intrieur la couleur 251, le contour extrieur 1 la couleur 249, et le contour extrieur 2 la couleur 250.
;\4
;  Algorithme:
;      On fixe d'abord la zone de l'cran qu'il faudra prendre en compte:  on considre les lignes de 0  46.  On rserve
;    ensuite 3 zones de mmoires X, Y et Z, qui pourront contenir chacune un plan d'une image.  On effectuera les calculs
;    sur ces zones de mmoire  l'aide de la fonction vro_cpyfm.  Les affichages sur l'cran seront effectus  l'aide de
;    la fonction vrt_cpyfm, en mode transparent (les pixels  modifier correspondent aux bits  1 de l'image sur 1 plan),
;    et avec une couleur de fond nulle.
;        1) On copie un des 5 plans de poids fort (tous gaux) de l'cran dans X, " la main": X = A.
;        2) X1 --> Y. Pour tout 2  i  8, (Xi | Y) --> Y. D'o Y = B. Puis (!X & Y) --> Y. D'o Y = C.
;        3) Y1 --> Z. Pour tout 2  i  8, (Yi | Z) --> Z. D'o Z = D. Puis (!Y & Z) --> Z. D'o Z = E.
;        4) Avec la fonction vrt_cpyfm, on affiche X, Y et Z sur l'cran.
;        5) (X & Z) --> Z. D'o Z = F.
;        6) Avec la fonction vrt_cpyfm, on affiche Z sur l'cran.

;\6
;  Cre les 3 struct. MFDB (chacune correspondant  une zone).

               movea.l  buffer(pc),a5       ; Adr. du buffer, o seront stockes les
               movea.l  a5,a0               ; struct. MFDB et les zones X, Y et Z.
               lea      3*mfdb.SIZEOF(a5),a1  ; Adr. o sera stocke
               movea.l  a1,a2                 ; la zone X.
               moveq    #1,d3               ;D3.W = 1 (2 significations: format VDI et nb de plans).
               moveq    #2,d4               ;Nb de struct. MFDB - 1 (i.e. nb de zones - 1).
endpr_loop5:   move.l   a1,(a0)+            ;Stocke l'adr. de la zone dans mfdb.fd_addr.
               move.w   #640,(a0)+          ;Stocke la largeur de la zone en pixels dans mfdb.fd_width.
               move.w   #fheight,(a0)+      ;Stocke la hauteur de la zone en pixels dans mfdb.fd_height.
               move.w   #40,(a0)+           ;Stocke la largeur de la zone en mots dans mfdb.fd_wdwidth.
               move.w   d3,(a0)+            ;Stocke 1 (format VDI) dans mfdb.fd_stand.
               move.w   d3,(a0)+            ;Stocke 1 (nb de plans) dans mfdb.fd_planes.
               clr.l    (a0)+               ;Rservs (0 et 0).
               clr.w    (a0)+               ;Rserv (0).
               lea      pllen(a1),a1        ;Adr. de la zone suivante.
               dbf      d4,endpr_loop5      ;Passe  la struct. MFDB suivante.
;\6
;  Recopie dans la zone X le plan 3 du bloc source situ sur l'cran, et efface les zones Y et Z.

               lea      pllen(a2),a1        ;Adr. de la zone Y.
               lea      pllen(a1),a3        ;Adr. de la zone Z.
               lea      xlen(pc),a4         ;
               moveq    #0,d0               ; D0.L: taille d'une ligne de l'cran systme
               move.w   (a4)+,d0            ; en octets.  A4: adresse  du pixel suprieur
               movea.l  (a4),a4             ; gauche du plan 3 de la fentre.
               addq.l   #6,a4               ;
               moveq    #fheight-1,d3       ;
endpr_outr3:   moveq    #39,d1              ;
               movea.l  a4,a0               ;
endpr_innr3:   move.w   (a0),(a2)+          ;
               clr.w    (a1)+               ; Recopie le plan 3 de la source dans la
               clr.w    (a3)+               ; zone X, et efface les zones Y et Z.
               lea      16(a0),a0           ;
               dbf      d1,endpr_innr3      ;
               adda.l   d0,a4               ;
               dbf      d3,endpr_outr3      ;
;\7
;  Calcul de C et E.

               moveq    #mfdb.SIZEOF,d3     ;Distance de la struct. MFDB de dest.  la struct. MFDB source.
               movea.l  a5,a3               ;Adr. de la struct. MFDB de la zone X.
               bsr      calc_outer          ;Calcule C (contour extrieur 1).
               adda.l   d3,a3               ;Adr. de la struct. MFDB de la zone Y.
               bsr      calc_outer          ;Calcule E (contour intrieur + contour extrieur 2).
;\6
;  Affiche A, C et E sur l'cran (dans cet ordre).

               suba.l   d3,sp               ;Met une struct. MFDB dans la pile (struct. dest.).
               movea.l  sp,a4               ;Adr. de cette struct. MFDB.
               clr.l    (a4)                ;Ptr nul --> cran.
               move.w   #248,d5             ;Index de la couleur de l'intrieur.
endpr_loop6:   bsr      xyz2screen          ;
               addq.b   #1,d5               ; Recopie A, C et E sur l'cran
               cmpi.b   #251,d5             ; (A: 248, C: 249, E: 250).
               bne.s    endpr_loop6         ;
;\6
;  Calcule F, et affiche F sur l'cran.

               suba.l   d3,a3               ;Adr. de la struct. MFDB de la zone X.
               suba.l   d3,a5               ;Adr. de la struct. MFDB de la zone Z.
               add.b    d3,d3               ;Distance entre ces 2 adr. (A5 - A3).
               moveq    #1,d0               ;
               moveq    #1,d1               ; Calcule F (rsultat
               moveq    #sandd,d2           ; dans la zone Z).
               bsr      calc_outaux2        ;
               bsr      xyz2screen          ;Affiche F sur l'cran.
               lea      mfdb.SIZEOF(sp),sp  ;Dpile la struct. MFDB de l'cran.
;\4
;  Nouvelle fentre.

               lea      xy0(pc),a0          ; Coord. du point suprieur gauche
               addi.l   #$80038,(a0)        ; de la nouvelle fentre.
;\4
;  Libre la mmoire utilise par le mini-buffer.

               move.l   a3,d0               ;Adr. du buffer.
               bsr      call_mfree2         ;Libre la mmoire.

;\9
;    Ŀ
;     Menu principal 
;    

;  Modifie l'emplacement de la DTA, charge le fichier de rgle, calcule la hauteur  laquelle il faudra afficher
;  "-- PAUSE --" en mode pause du jeu,  efface la zone de travail  --> couleur VDI = 1 (hardware/Xbios: -1),  et
;  affiche l'image de fond avec le gd hexagone (mais les couleurs restent noires).

game:          lea      dispflag(pc),a6     ; dispflag = 0 ssi le jeu se
               move.b   windflag(pc),(a6)   ; droule sur tout l'cran.
               bsr      load_rul            ;Charge le fichier de rgle.
               lea      intin(pc),a6        ;A6: adr. du tableau INTIN.
               move.w   pfontid(pc),d7      ; Slectionne la fonte de n *pfontid
               bsr      set_font1           ; si SpeedoGDOS est install.
               moveq    #40,d7              ;Hauteur de "-- PAUSE --" par dfaut.
pauseh_nexth:  bsr      paus_extent         ;D0.W: largeur du texte en pixels.
               cmpi.w   #16*pww,d0          ; Branch. si le texte n'est
               bls.s    pauseh_end          ; pas trop large.
               subq.b   #2,d7               ;Diminue la hauteur de 2.
               cmpi.b   #8,d7               ; Branch. si la hauteur
               bhi.s    pauseh_nexth        ; est > 8.
pauseh_end:    lea      pause_h(pc),a0      ; Stocke la hauteur  laquelle il
               move.w   d7,(a0)             ; faudra afficher "-- PAUSE --".
               bsr      wd_update           ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM...
               bsr      clr_window          ;Efface la zone de travail.
               bsr      end_windupd         ;Fin de mise  jour de la fentre si le jeu se droule dans une fentre GEM.
game2:         movea.l  sfont_addr(pc),a0   ;
               move.l   a0,d0               ; Dverrouille la struct.
               beq.s    game6               ; sf si elle existe.
               clr.b    sf.lock(a0)         ;
game6:         IFNE     REGISTERED
               moveq    #msg_menu1,d0       ; Envoie le msg
               bsr      send_msg0           ; msg_menu1.
               tst.l    d0                  ; Si le rsultat est non nul,
               beq.s    game7               ; on libre  la mmoire prise
               bsr      xmem_free           ; par l'img de fond.
game7:         ENDIF
               bsr      bkgr_image          ;Affiche l'img de fond (mais les couleurs restent noires).
;\6
;  Affiche le menu (mais toutes les couleurs restent noires).

               lea      intin(pc),a6        ;A6: adr. du tableau INTIN.
               bsr      sto_wcoord          ; Active le clipping sur
               bsr      clip_on             ; la zone de travail.
               moveq    #mtcolor,d0         ;Couleur du titre.
               bsr      stitle              ;Slectionne la fonte, l'alignement, le mode d'criture, la hauteur et la couleur.
               movea.l  alert_ment+4(pc),a0 ;
               move.l   #472<<16+108,d1     ; Affiche "Menu". Alignement: gauche, bottom.
               bsr      cdtxt_lbot          ;
               move.w   mfontid(pc),d7      ; Slectionne la fonte de n *mfontid
               bsr      set_font1           ; si SpeedoGDOS est install.
               IFGE     REGISTERED
               lea      tcol(pc),a0         ;Adr. du tableau tcol.
               move.l   #$FF6000,(a0)+      ;Stocke la couleur de "Shareware".
               move.l   #$FF3000,(a0)+      ;Stocke la couleur du texte situ en dessous.
               ELSE
               lea      tcol+8(pc),a0       ;Adr. du tableau tcol + 8.
               ENDIF
               move.l   #$FFFF00,(a0)+      ;Stocke la couleur jaune: [255,255,0] (couleur du nom du fichier).
               move.l   #$FFC0C0,(a0)+      ;Stocke la couleur [255,192,192] (couleur du titre du menu).
               move.l   #$FFF000,(a0)       ;Stocke la couleur [255,240,0] (couleur de la 1re ligne du menu).
               lea      menudata(pc),a3     ;A3: ptr sur les donnes concernant le menu (donnes nulles au dpart).
               moveq    #22,d7              ;Hauteur des caractres par dfaut: 22 (pourra diminuer).
menu_loop:     moveq    #2,d3               ;Utile lors de l'initialisation des donnes: cf ci-dessous (call_extent).
               move.w   (a3),d4             ;Hauteur des caractres, ou 0 si les donnes n'ont pas encore t initialises.
               beq.s    menu_lbl1           ;Branch. s'il faut initialiser les donnes.
               moveq    #mlcolor,d3         ;D3.W: index de la couleur du texte (mlcolor: couleur de la 1re ligne).
               move.w   d4,d7               ;Hauteur des caractres.
menu_lbl1:     bsr      char_height         ;Fixe la hauteur des caractres.
               move.l   #xmen<<16+160,d6    ;D6.L: coord. relatives de la 1re ligne de texte.
               lea      menu_key(pc),a5     ;Adr. des noms des touches.
               movea.l  alert_menu+4(pc),a4 ;A4: ptr sur la partie texte.
               moveq    #nmen-1,d5          ;Nb max. d'items - 1.
menu_outer:    move.b   d3,d0               ; Couleur de la ligne, si
               bsr      text_color          ; on affiche le texte.
               movea.l  a6,a0               ;Adr. du tableau INTIN.
               moveq    #1,d0               ;D0.W contiendra la longueur de la chane.
menu_inner3:   addq.b   #1,d0               ;
               clr.b    (a0)+               ; Stocke le nom de la
               move.b   (a5)+,(a0)+         ; touche dans INTIN.
               bne.s    menu_inner3         ;
               move.b   #':',-1(a0)         ; Le nom de la touche
               move.w   #' ',(a0)+          ; est suivi de ": ".
menu_inner4:   addq.b   #1,d0               ;
               clr.b    (a0)+               ; Stocke  le  reste
               move.b   (a4)+,(a0)+         ; de la chane dans
               bne.s    menu_inner4         ; INTIN.
               move.b   #'.',-(a0)          ;
               cmpi.b   #4,d5               ;
               bne.s    menu_cmp1           ; Branch. si la touche n'est pas "N"
               tst.b    pnam_flag(pc)       ; ou si l'option "-u" est inactive.
               bpl.s    menu_cmp1           ;
               addq.b   #1,d3               ;Incr. l'index de couleur.
               tst.w    d4                  ; Branch. si on doit afficher le texte (on n'affiche
               bne.s    menu_dbf2           ; rien du tout, on passe  la chane suivante).
               move.l   #$10000,-1(a3,d3.l) ; Ordonne min: 1, ordonne max: 0 --> rectangle
               addq.b   #7,d3               ; vide (la ligne correspondante ne doit pas tre
menu_dbf2:     bra.s    menu_dbf            ; affiche).
;\4
menu_cmp1:     cmpi.b   #1,d5               ; Si le jeu se droule sur tout l'cran
               bne.s    menu_tst            ; et si la touche est "Ctrl-TAB", alors
               tst.b    windflag(pc)        ; on ne doit pas  prendre en compte  la
               bpl.s    menu_dbf            ; ligne correspondante du menu.
;\4
menu_tst:      tst.w    d4                  ; Branch. si on doit
               bne.s    menu_text           ; afficher le texte.
               bsr      call_extent         ;Sinon, on teste si le texte est trop large.
               move.l   ptsout+4(pc),d2     ;Coord. relatives du point infrieur droit.   Attention! l'axe des y est
               move.l   ptsout+12(pc),d1    ;Coord. relatives du point suprieur gauche.  dirig vers le haut.
               sub.w    d6,d2               ;
               neg.w    d2                  ;
               sub.w    d6,d1               ;
               neg.w    d1                  ;
               movem.w  d1/d2,(a3,d3.l)     ; Stocke l'ordonne min, l'ordonne
               swap     d6                  ; max, l'abscisse min et l'abscisse
               swap     d1                  ; max  du  rectangle  encadrant  le
               swap     d2                  ; texte (coordonnes relatives  la
               add.w    d6,d1               ; fentre).
               add.w    d6,d2               ;
               movem.w  d1/d2,4(a3,d3.l)    ;
               swap     d6                  ;
               addq.b   #8,d3               ;
               cmpi.w   #windw-360,d0       ; Branch. s'il n'est
               bcs.s    menu_nxtline        ; pas trop large.
               cmpi.b   #8,d7               ; Branch. si on a atteint
               bls.s    menu_nxtline        ; la hauteur minimale.
               subq.b   #2,d7               ;Sinon, dcr. de 2 la hauteur du texte.
               bra      menu_loop           ;On recommence...
;\4
menu_text:     move.l   d6,d1               ; Affiche la
               bsr      disp_text           ; chane.
               lea      (tcol+16-4*mlcolor.w,pc,d3.w*4),a0
               addq.b   #1,d3               ;Incr. l'index de la couleur du texte.
               move.l   (a0)+,d0            ;Couleur de la ligne L venant d'tre affiche.
               subi.w   #$2000,d0           ;Enlve 32  la composante verte.
               move.l   d0,(a0)+            ;La prochaine ligne L+1 devra tre de cette couleur.
               move.l   d0,(a0)             ;La ligne suivante L+2 aussi au cas o L+1 ne serait pas affiche.
menu_nxtline:  addi.w   #36,d6              ; Incr. l'ordonne de 36 si la ligne
               tst.b    pnam_flag(pc)       ; correspondant  la touche N  n'est
               bmi.s    menu_dbf            ; pas affiche;  incr. l'ordonne de
               subq.w   #4,d6               ; 32 dans le cas contraire.
menu_dbf:      dbf      d5,menu_outer       ;Boucle (passe  la chane suivante).
menu_end:      move.w   d7,(a3)             ;Stocke la hauteur dans les donnes.
               tst.w    d4                  ;A-t-on affich le texte ou initialis les donnes ?
               beq      menu_loop           ;Branch. si on a initialis les donnes (maintenant, on affiche le texte).
;\4
               moveq    #22,d7              ; Fixe la hauteur des
               bsr      char_height         ; caractres  22.
               moveq    #mfcolor,d0         ; Couleur de
               bsr      text_color          ; la ligne.
               lea      string(pc),a1       ;Adr. contenant le nom du fichier de rgle.
               moveq    #2,d0               ;D0.W contiendra la longueur de la chane.
               bsr      menu_subr           ;Stocke "Fichier de rgle: " et le nom du fichier de rgle dans INTIN.
               subq.l   #2,a0               ; Stocke " ("
               move.l   #' '<<16+'(',(a0)+  ; dans INTIN.
               lea      ([rul_ptr.w,pc],rul.name.w),a1  ;A1: ptr sur le nom de la rgle.
menu_rulname:  addq.b   #1,d0               ;
               clr.b    (a0)+               ; Stocke le nom de la
               move.b   (a1)+,(a0)+         ; rgle dans INTIN.
               bne.s    menu_rulname        ;
               move.b   #')',-(a0)          ;Stocke ")" dans INTIN.
               tst.b    pname(pc)           ; Affiche  la chane   la position
               beq.s    menu_rul2           ; (32,48) si le nom de joueur n'est
               move.b   #32,d1              ; pas  vide,   la position (32,32)
menu_rul2:     bsr      disp_text           ; dans le cas contraire.
               tst.b    pname(pc)           ; Branch. si le nom de
               beq.s    menu_reg            ; joueur est vide.
               lea      pname(pc),a1        ;Adr. contenant le nom du joueur.
               clr.w    d0                  ;D0.W contiendra la longueur de la chane.
               bsr      menu_subr           ;Stocke "Joueur: " et le nom du joueur dans INTIN.
               move.b   #60,d1              ; Affiche la chane  la
               bsr      disp_text           ; position (32,60).
menu_reg:      IFGE     REGISTERED
               bsr      sw_disp             ;Affiche le texte correspondant  la version shareware.
               ENDIF
               bsr      no_clipping         ;Dsactive le clipping.
               bsr      end_windupd         ;Fin de mise  jour de la fentre si le jeu se droule dans une fentre GEM.
;\6
;  Affiche progressivement la zone de travail.

               bsr      chcol               ;Modifie progressivement les couleurs.
               beq      game2               ;Branch. si on est pass en mode PAUSE.
               lea      item(pc),a0         ; Annule item (cf ci-dessous:
               clr.w    (a0)+               ; tstm).
               st       (a0)                ;Rend le poids fort de bitem non nul.
               IFNE     REGISTERED
               moveq    #msg_menu2,d0       ; Envoie le msg
               bsr      send_msg0           ; msg_menu2.
               ENDIF
;\6
;  Attend un vnement.

wait_multi:    bsr      dmem_test           ;Libre la mmoire associe  l'affichage des nb s'il le faut.
               bsr      disp_date           ;Affiche la date et l'heure s'il le faut.
               IFNE     REGISTERED
               move.w   #msg_wmenu,d0       ; Envoie le msg
               bsr      send_msg0           ; msg_wmenu.
               tst.l    d0                  ; Branch. si pas
               beq.s    wait_multi0         ; d'vnement.
               move.w   d0,d6               ; Si -20  D0.L  -1, D6.W contient n-1
               not.w    d6                  ; pour muler la touche de fct Fn.
               moveq    #-20,d1             ; Branch.  si c'est un
               cmp.l    d0,d1               ; vnement "touche de
               bls      disp_scores         ; fct".
               moveq    #9,d1               ; Branch. si c'est un
               sub.l    d1,d0               ; vnement  "item de
               bcs      jmpitem0            ; menu".
               subq.l   #7,d0               ;
               bcs.s    wait_multi0         ; Branch.  chg_bsize  si c'est
               moveq    #4,d1               ; un vnement de changement de
               cmp.l    d0,d1               ; taille du tableau.
               bhi      chg_bsize           ;
               ENDIF
wait_multi0:   pea      tst_key(pc)         ;Adr.  laquelle il faudra se brancher aprs l'ventuel appel de read_msg1.
               lea      -16(sp),sp          ;Rserve de la mmoire pour les messages.
               bsr      xmem_test           ;Libre la mmoire utilise par l'image de fond, s'il n'en reste pas assez.
               moveq    #mu_timer,d0        ;Evnement  surveiller si le jeu se droule dans une fentre GEM,
                                            ;en plus de mu_keybd, mu_mesag et mu_button.
               move.w   delay(pc),d7        ;Paramtre pour mu_timer: temps d'attente en ms.
               bsr      wait_evnt           ;Attend un vnement.
               move.b   d0,d7               ;Masque des vnements ayant eu lieu.
               move.l   int_out+2(pc),d1    ;
               sub.l    xy0(pc),d1          ; Position du curseur de la souris:
               move.w   d1,d2               ; D1: abscisse, D2: ordonne.
               swap     d1                  ;
               move.l   int_out+8(pc),d6    ;Code d'une touche si l'vnement evnt_keybd a eu lieu.
               tst.b    windflag(pc)        ; Branch. si le jeu se droule
               bpl.s    tst_msg             ; sur tout l'cran.
               lea      menudata+2(pc),a0   ;Ptr sur le tableau des coord. des rectangles encadrant les items du menu.
               moveq    #nmen-1,d3          ;Nb d'items - 1.
tstm_loop:     cmp2.w   (a0),d2             ;
               bcs.s    tstm_next           ;
               cmp2.w   4(a0),d1            ; Si la souris est sur l'item n i (1  i  nmen),  alors
tstm_next:     addq.l   #8,a0               ; D3.W = -i. Si la souris n'est sur aucun item, D3.W = 0.
               dbcc     d3,tstm_loop        ;
               not.w    d3                  ;
               IFEQ     REGISTERED
               addq.w   #nmen-2,d3          ; Pour la version non enregistre: si la souris est sur l'item
               beq.s    tstm_lbl0           ; n nmen-2 (charger une rgle), on met D3.W  0, i.e. on fait
               subq.w   #nmen-2,d3          ; comme si la souris n'tait sur aucun item.
tstm_lbl0:     ENDIF
               lea      item(pc),a0         ;Ptr sur l'ancien D3.
               move.w   (a0),d2             ;D2: code de l'ancienne position de la souris.
               cmp.w    d2,d3               ; Branch. si la souris est reste
               beq.s    tst_msg             ; dans la mme zone.
               move.w   d3,(a0)             ;Stocke la nouvelle position.
               lea      bitem(pc),a0        ; La souris a chang de zone: on rend
               st       (a0)                ; le poids fort de bitem non nul.
               lea      RGB+mlcolor*4(pc),a0  ;Ptr sur la couleur du 1er item.
               lsl.w    #2,d2                                       ; Si un item tait en blanc,
               beq.s    tstm_lbl1                                   ; on  le remet   sa couleur
               move.l   (tcol+16+nmen*4.w,pc,d2.w),nmen*4(a0,d2.w)  ; initiale.
tstm_lbl1:     lsl.w    #2,d3                     ; Si la souris est sur
               beq.s    tstm_lbl2                 ; un item,  on met cet
               move.l   #$FFFFFF,nmen*4(a0,d3.w)  ; item en blanc.
tstm_lbl2:     move.w   d0,-(sp)            ;Sauve D0.
               pea      (a0)                     ;
               move.l   #mlcolor<<16+nmen,-(sp)  ; Modifie la couleur des items du menu.
               mxbios   VsetRGB,10               ;
               move.w   (sp)+,d0            ;Rcupre D0.
tst_msg:       lsl.b    #4,d0               ; N = 0 (utile pour le BMI ci-dessous). Branch.
               bcs      read_msg1           ; si l'vnement evnt_mesag a eu lieu.
               lea      20(sp),sp           ;Libre le buffer des messages et dpile l'adr. empile auparavant.
tst_key:       IFNE     REGISTERED
               bmi      game2               ;Branch. si on est pass en mode PAUSE (il faut tout rafficher).
               ELSE
               bmi.s    game3               ;Branch. si on est pass en mode PAUSE (il faut tout rafficher).
               ENDIF
               lsr.b    #1,d7               ; Branch. si l'vnement
               bcs.s    cmp_key             ; evnt_keybd a eu lieu.
tst_leftb:     lsr.b    #1,d7               ; Branch. si l'vnement evnt_button n'a pas eu
               bcc.s    wait_multi2         ; lieu (alors on attend un nouvel vnement).
               tst.w    bitem(pc)           ; Branch. si le bouton est pass de "relach" 
               bne.s    wait_multi2         ; "enfonc" ou si la souris a chang de zone.
               move.w   item(pc),d0         ;Item cliqu (si non nul).
               beq.s    wait_multi2         ;Branch. si le curseur de la souris n'tait pas sur un item.
jmpitem0:      move.w   (itemaddr.w,pc,d0.w*2),d1  ; Branch.  l'adr. correspondant
jmpitem:       jmp      jmpitem(pc,d1.w)           ;  l'item cliqu.
;\6
;  Une touche a t frappe.

cmp_key:       cmpi.b   #ctrl_q,d6          ; Branch. si ce n'est
               bne.s    cmp_key2            ; pas CTRL-Q.
quit:          tst.b    acc_flag(pc)        ; Fin du prg si TETRHEX a t lanc
               beq      term                ; en tant qu'application.
wait_multi2:   bra      wait_multi          ;Attend un nouvel vnement.
cmp_key2:      cmpi.b   #'N',d6             ;
chg_pname2:    beq      chg_pname           ; Branch. si c'est
               cmpi.b   #'n',d6             ; 'N' ou 'n'.
               beq.s    chg_pname2          ;
               IFNE     REGISTERED
               lea      struct_msg+4(pc),a0 ; Stocke le code de la touche (car il va tre modifi) dans la structure
               move.l   d6,(a0)             ; rserve aux msg, au cas o le msg msg_mkey devra tre envoy.
               ENDIF
               btst     #16+ctrl,d6         ; D6.B = -1 si touche CTRL enfonce,
               sne      d6                  ; D6.B = 0 sinon.
               IFNE     REGISTERED
               beq.s    test_undo           ;Branch. si la touche CTRL n'est pas enfonce.
               move.w   d6,d0               ; D0.W: scancode de la touche
               lsr.w    #8,d0               ; (poids fort nul).
               subi.b   #numpad+4,d0        ;
               bcc.s    test_tab            ; Branch. si ce n'est pas CTRL-(,),/,* (une
               addq.b   #4,d0               ; des 4 touches du pav numrique).
               bcc.s    test_tab            ;
chg_bsize:     addq.b   #6,d0               ;D0.W: nouveau nb de petits hex.
               cmp.b    nhex+1(pc),d0       ; Branch. si ce nb
               beq.s    wait_multi2         ; ne change pas.
               bsr      change_nhex         ;Change le nb de petits hex.
               bra      new_rule            ;Recharge la rgle.
               ENDIF
;\4
test_tab:      cmpi.w   #tab<<8+$FF,d6      ;
               IFNE     REGISTERED          ;
               bne.s    test_undo           ; Branch. si ce n'est
               ELSE                         ; pas la touche TAB.
               bne.s    test_func           ;
               ENDIF                        ;
bottom:        tst.b    windflag(pc)        ; Branch. si le jeu se droule sur tout l'cran
               bpl.s    wait_multi2         ; (on attend alors un nouvel vnement).
               moveq    #wm_bottom,d0       ;Type du message  s'envoyer: wm_bottom.
               bsr      send_message        ;On s'envoie le message wm_bottom.
               bsr      rdmsg_lbl3          ;Lit ce message (on le prend en compte), ou un autre!
               bpl.s    wait_multi2         ;Si on n'est pas pass en mode PAUSE, on attend un nouvel vnement.
game3:         bra      game2               ;Dans le cas contraire, on raffiche tout.
;\4
vsync1:        tst.b    vsync_flag(pc)      ; Retour immdiat si le drapeau
               beq.s    vsync_rts           ; vsync_flag est dsactiv.
vsync2:        mxbios   Vsync,2             ;Attend une interruption VBL.
vsync_rts:     rts                          ;Retour.

;\6
;    Ŀ
;     Changement du fichier de rgle (UNDO) 
;    

               IFNE     REGISTERED
test_undo:     cmpi.w   #undo<<8,d6         ; Branch. si ce n'est
               bne      test_func           ; pas la touche UNDO.
undo_key:      tst.b    chres_flag(pc)      ; Si la rsolution a t change, on ne peut pas appeler le slecteur
               bmi      wait_multi          ; de fichiers. On ne peut donc pas charger une nouvelle rgle.
               tst.b    windflag(pc)        ; Branch. si le jeu se droule
               bmi.s    select_rul          ; dans une fentre GEM.
               moveq    #64,d0              ; Rserve  un bloc de mmoire
               lsl.l    #4,d0               ; de 256*4 = 1024 octets pour
               bsr      test_malloc         ; modifier les couleurs.
               move.l   d0,-(sp)            ;Adr. du bloc de mmoire.
               lea      RGB0(pc),a0         ;Adr. des couleurs initiales.
               movea.l  d0,a1               ;
               moveq    #15,d1              ; Recopie les 16 premires
col16_loop1:   move.l   (a0)+,(a1)+         ; couleurs initiales.
               dbf      d1,col16_loop1      ;
               moveq    #256-16,d1          ;
col16_loop2:   clr.l    (a1)+               ; Les 240 autres couleurs
               subq.b   #1,d1               ; sont noires.
               bne.s    col16_loop2         ;
               move.l   d0,-(sp)            ;Adr. du tableau des couleurs.
               move.w   #256,-(sp)          ;Nb de pinceaux.
               clr.w    -(sp)               ;N du 1er pinceau.
               mxbios   VsetRGB,10          ;Appelle XBIOS: modifie la couleur des pinceaux.
               bsr.s    vsync2              ;Attend que le chgt de couleur se fasse au niveau hardware.
               mgemdos  Mfree,6             ;Libre le bloc de mmoire.
               bsr      mouse_on            ;Montre le curseur de la souris.
select_rul:    lea      path(pc),a3         ;Buffer o doit tre stock le chemin.
               mgemdos  Dgetdrv,2           ;Disque courant (0: A, 1: B, ...) ?
               movea.l  a3,a6               ;(A3 ne doit pas tre modifi.)
               addi.b   #'A',d0             ;Disque courant, en ASCII.
               move.b   d0,(a6)+            ; Stocke le disque
               move.b   #':',(a6)+          ; dans path.
               clr.w    -(sp)               ;
               pea      (a6)                ; Chemin courant associ au disque courant ?
               mgemdos  Dgetpath,8          ;
undo_loop1:    tst.b    (a6)+               ;
               bne.s    undo_loop1          ;
               subq.l   #1,a6               ; Ajoute le masque "*.RUL"
               move.w   #'\*',(a6)+         ; au chemin courant.
               move.l   #'.RUL',(a6)+       ;
               clr.b    (a6)                ;
               lea      addrin(pc),a0       ;Adr. du tableau ADDRIN.
               lea      file(pc),a4         ;Adr. o doit tre stock le nom du fichier.
               clr.b    (a4)                ;Pas de nom par dfaut.
               movea.l  alert_lrul+4(pc),a5 ;Titre pour le slecteur de fichiers.
               movem.l  a3-a5,(a0)          ;
               maes     fsel_exinput,0,2,3  ; Appelle le slecteur de fichiers.
               beq      mtos_err            ;
               pea      wait_multi(pc)      ;Adr.  laquelle il faudra se brancher  la fin.
               tst.w    int_out+2(pc)       ; Branch. si c'est le bouton "CANCEL"
               beq.s    undo_end            ; qui a t slectionn.
               clr.w    d0                  ;
               move.b   (a3),d0             ;
               subi.b   #'A',d0             ; Nouveau disque courant.
               move.w   d0,-(sp)            ;
               mgemdos  Dsetdrv,4           ;
               movea.l  a3,a6               ;
undo_loop2:    tst.b    (a6)+               ; A6: fin du chemin + 1.
               bne.s    undo_loop2          ;
undo_loop3:    clr.b    (a6)                ;
               cmpi.b   #'\',-(a6)          ; Efface le masque.
               bne.s    undo_loop3          ;
               clr.b    (a6)                ;Efface le dernier sparateur '\'.
               pea      2(a3)               ; Nouveau chemin
               mgemdos  Dsetpath,6          ; courant.
               tst.l    d0                  ; Branch. si ce chemin
               bne.s    undo_end            ; est inexistant.
               tst.b    (a4)                ; Branch. si aucun fichier
               beq.s    undo_end            ; n'a t slectionn.
               addq.l   #4,sp               ;On ne devra pas se brancher  wait_multi, mais  game2 (cf ci-dessous).
               lea      string(pc),a0       ;Adr. o il faut recopier le nom du fichier.
               tas      strlen-1(a0)        ;Active le drapeau indiquant qu'un fichier de rgle a t charg (cf load_rul).
undo_loop4:    move.b   (a4)+,(a0)+         ; Recopie le nom du fichier
               bne.s    undo_loop4          ; dans string.
               bsr.s    undo_end            ;Rcupre les couleurs (si le jeu ne se droule pas dans une fentre GEM).
new_rule:      bsr      free_rul            ;Libre l'ancien fichier de rgle et charge le nouveau.
               bra      game4               ;Efface progressivement l'cran et raffiche l'cran...
undo_end:      tst.b    windflag(pc)        ; Retour si le jeu se droule
               bmi.s    undo_rts            ; dans une fentre GEM.
               bsr      mouse_off           ;Cache le curseur de la souris.
               xbrgb    VsetRGB,RGB(pc)     ;Modifie la couleur des pinceaux.
undo_rts:      rts                          ;Retour.
               ENDIF

;\6
;    Ŀ
;     Affichage des meilleurs scores (F1-F20) 
;    

func_num:      cmpi.w   #f1<<8,d6           ;
               bcs.s    func_num_end        ;
               cmpi.w   #f10<<8,d6          ;
               bls.s    func_key            ;
               cmpi.w   #f11<<8,d6          ; Si la touche est une touche de
               bcs.s    func_num_end        ; fct Fx, N = 0 et D6.W = x - 1.
               cmpi.w   #f20<<8,d6          ; Sinon, N = 1.
               bhi.s    func_num_end        ;
               subi.w   #(f11-f10-1)<<8,d6  ;
func_key:      lsr.w    #8,d6               ;
               subi.b   #f1,d6              ;
               rts                          ;Retour (N = 0 et rsultat dans D6.W).
func_num_end:  moveq    #-1,d0              ; Retour avec N = 1
               rts                          ; et D6.W inchang.
;\4
hi_scores:     clr.w    d6                  ; On doit afficher les scores
               bra.s    disp_scores         ; du rang 1 au rang 10.
test_func:     bsr.s    func_num            ; Branch.  test_help si ce n'est pas une touche
               bmi      test_help           ; de fct. Si c'est la touche Fx, D6.W = x - 1.
;\6
;  Couleurs:
;   _ Plans 0 et 1: texte.
;   _ Plans 2 et 3: valeur dpendant uniquement de la position horizontale du point (dgrad 7 fausses couleurs).
;   _ Plans 4 et 5: valeur dpendant uniquement de la position verticale du point (dgrad 7 fausses couleurs).
;   _ Plan 6: toujours 0.
;   _ Plan 7: toujours 1.
;  Pour les plans 2  5: il y a 4 "vraies" couleurs (0, 1, 2, 3), et 3 "fausses"
;  couleurs obtenues en alternant deux vraies couleurs conscutives.
;\4
disp_scores:   IFNE     REGISTERED
               moveq    #msg_hisc,d0        ; Envoie le msg
               bsr      send_msg0           ; msg_hisc.
               ENDIF
               lea      fx(pc),a0           ; Sauve les dizaines du
               move.w   d6,(a0)             ; 1er rang  afficher.
               bsr      clr_colors1         ;Efface progressivement l'cran (la couleur XBIOS/hardware du fond est -1).
               bsr      wd_update           ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM...
               lea      intin(pc),a6        ;A6: adr. du tableau INTIN.
               bsr      hnh_sfontid         ;Fonte *sfontid. Fixe la hauteur des caractres  hname.
               lea      sfont_addr(pc),a3   ;A3: ptr sur l'adr. des donnes sur la fonte n *sfontid.
               movea.l  (a3),a4             ;A4: adr. des donnes sur la fonte n *sfontid, ou 0.
               move.l   a4,d0               ; Branch. si ces donnes
               bne      sf_names            ; existent.
               mvdi     vqt_fontinfo,0,0    ;Infos sur la fonte courante (et la hauteur courante).
               move.w   intout+2(pc),d1     ; D1.W: nb de caractres, plus prcisment =
               sub.w    d0,d1               ; plus grand code ASCII de la fonte  -  plus
               addq.w   #1,d1               ; petit code ASCII de la fonte + 1.
               movem.w  ptsout(pc),d2/d3    ;D2.W: largeur de cellule maxi, D3.W: cart de la Bottom line  la Base line.
               move.w   ptsout+18(pc),d4    ;D4.W: cart de la Top line  la Base line.
               mulu.w   d1,d2               ; D2.W: largeur maxi d'une ligne
               addq.w   #7,d2               ; comprenant tous les caractres
               lsr.w    #3,d2               ; de la fonte.
               move.w   d3,d0               ;
               add.w    d4,d0               ; D0.W et D6.W: hauteur de la
               addq.w   #1,d0               ; cellule d'un caractre.
               move.w   d0,d6               ;
               mulu.w   d2,d0               ;D1.L: taille maxi de l'ensemble des caractres.
               addi.l   #sf.SIZEOF,d0       ; Rserve un bloc de mmoire pour les
               move.l   d0,-(sp)            ; donnes  sur la fonte  n *sfontid,
               bsr      test_malloc         ; et empile sa taille.
               move.l   d0,(a3)             ;Stocke l'adr. de ce bloc.
               movea.l  d0,a4               ;A4: adr. de ce bloc.
               clr.w    d0                  ; Annule sf.newrule, et stocke
               movem.w  d0/d3/d4,(a4)       ; sf.bottom et sf.top.
               moveq    #0,d3               ;D3.W: contiendra l'offset de chaque caractre (en bits).
               moveq    #' ',d4             ;D4.L: contiendra les caractres (de 32  255).
sf_loop1:      clr.w    d5                  ;D5.W = 0 (utile si le caractre courant n'est pas dans la fonte).
               move.w   d4,(a6)             ; Largeur du caractre
               intvdi   vqt_width           ; courant?
               bmi.s    sf_sto              ;Branch. si le caractre n'est pas dans la fonte (--> largeur nulle).
               move.w   ptsout(pc),d5       ;D5.W: largeur du caractre.
sf_sto:        move.b   d5,sf.width-' '(a4,d4.l)  ;Stocke la largeur.
               move.w   d3,(sf.offset-2*32.w,a4,d4.l*2)  ;Stocke l'offset.
               add.w    d5,d3               ;Met  jour l'offset.
               addq.b   #1,d4               ; Boucle (passe au caractre
               bne.s    sf_loop1            ; suivant).
               addq.w   #7,d3               ; Stocke la longueur, en octets,
               lsr.w    #3,d3               ; d'une ligne forme de tous les
               move.w   d3,sf.llen(a4)      ; caractres.
               mulu.w   d6,d3               ; D3.L: taille de la partie du
               addi.l   #sf.SIZEOF,d3       ; bloc qui sera utilise.
               cmp.l    (sp)+,d3            ; Branch. si tout le
               beq.s    sf_cont             ; bloc est utilis.
               move.l   d3,-(sp)            ;
               move.l   a4,-(sp)            ; Fct Mshrink du GEMDOS: libre l'espace inutilis.
               fre_mem                      ;
               tst.l    d0                  ; Branch. s'il y a
               bne      gemdos_error        ; eu une erreur.
sf_cont:       lea      sf.flags(a4),a0     ;
               moveq    #224/4-1,d0         ; Annule le tableau sf.flags: par dfaut, les
sf_clrflags:   clr.l    (a0)+               ; donnes de la table ne sont pas valides.
               dbf      d0,sf_clrflags      ;
;\4
sf_names:      tas      sf.newrule(a4)      ;Met  1 le MSB de sf.newrule.
               bmi.s    sf_lbl0c            ;Branch. si la liste des scores a dj t parcourue.
               movea.l  rul_ptr(pc),a0      ;A0: adr. du fichier de rgle.
               move.l   rul.hisc(a0),d0     ;D0.L: offset de la liste des scores.
               beq.s    sf_lbl0c            ;Branch. s'il n'y a pas de score.
               move.l   rul.nsc6(a0),d1     ;Le nb de scores est =  la somme des 4 octets de D1.
               adda.l   d0,a0               ;A0: ptr sur la liste des scores.
               clr.w    d0                          ;
               tst.b    d1                          ;
               beq.s    sf_lbl0b                    ;
sf_loop2:      movea.l  a0,a1                       ;
               bra.s    sf_lbl0a                    ;
sf_inner3:     bset     #0,(sf.flags-32.w,a4,d0.w)  ; Pour chaque caractre des noms de la liste
sf_lbl0a:      move.b   (a1)+,d0                    ; des scores, on remplace les flags nuls par
               bne.s    sf_inner3                   ; un flag strictement positif.
               lea      sco.SIZEOF(a0),a0           ;
               subq.b   #1,d1                       ;
               bne.s    sf_loop2                    ;
sf_lbl0b:      lsr.l    #8,d1                       ;
               bne.s    sf_loop2                    ;
;\4
sf_lbl0c:      move.w   sf.bottom(a4),d6    ; D6.W: hauteur d'un
               add.b    sf.top+1(a4),d6     ; caractre - 1.
               moveq    #$7F,d0             ; Index de la couleur: $7F (on laisse tous
               bsr      text_color          ; les plans  1, sauf le plan 7).
               bsr      left_bottom         ;Alignement: gauche, bottom.
               bsr      dsc_addrwin         ;A1: adr. de la zone de travail; D2.L: longueur d'une ligne en octets.
               move.l   d2,d4               ; A3: adr. du plan 7  des
               lsl.l    #6,d4               ; pts de coord. relatives
               lea      46(a1,d4.l),a3      ; (32,64) et (32-D0,64).
               move.l   d2,d5               ;D5.L: longueur d'une ligne en octets.
               moveq    #32,d3              ; D3.W: 32 - D0, abscisse relative  laquelle il faudra afficher
               sub.b    d0,d3               ; les caractres (l'abscisse absolue est un multiple de 16).
               moveq    #' ',d4             ;D4.L: contiendra les caractres (de 32  255).
sf_outer:      lea      (sf.flags-32.w,a4,d4.l),a0  ;A0: ptr sur le flag correspondant au caractre D4.
               cmpi.b   #1,(a0)             ; Branch. si le flag est diffrent de 1,
               bne      sf_next             ; i.e. s'il est soit nul, soit ngatif.
               tas.b    (a0)                ;Le caractre va tre stock en mmoire --> flag ngatif.
               move.w   d4,(a6)             ;Stocke le caractre dans INTIN.
               lea      ptsin(pc),a0        ;
               move.l   xy0(pc),(a0)        ; Stocke les coord. absolues
               add.w    d3,(a0)+            ; dans PTSIN.
               addi.w   #64,(a0)            ;
               tst.b    sf.width-' '(a4,d4.l)  ; Branch. si le caractre n'est
               beq.s    sf_next                ; pas dans la fonte.
               mvdi     v_gtext,1,1         ;Affiche le caractre.
               movea.l  a3,a0               ;A0: adr. du plan 7 du point situ en bas  gauche.
               lea      sf.SIZEOF(a4),a1    ;A1: adr. o doivent tre stocks les caractres.
               move.w   d6,d1               ;D1.W: hauteur d'un caractre - 1 (compteur).
               moveq    #0,d2               ;Annule le mot de poids fort de D2.
               move.w   d3,-(sp)            ;Sauve D3.
sf_inner1:     move.b   sf.width-' '(a4,d4.l),d0  ;D0.B: largeur du caractre.
               move.w   (sf.offset-2*32.w,a4,d4.l*2),d2  ;D2.L: offset.
               movea.l  a0,a2               ;A2: adr. du plan 7 du point de la ligne courante situ  gauche.
               moveq    #16,d3              ;D3.L = 16 (taille d'un groupe de pixels).
               bra.s    sf_lbl2
sf_lbl1:       bfins    d7,(a1){d2:16}      ;Stocke les 16 pixels.
               sub.b    d3,d0               ;D0.B: nb de pixels restants dans la ligne courante (on enlve 16).
               add.w    d3,d2               ;D2.L: prochain offset (on ajoute 16).
sf_lbl2:       move.w   (a2),d7             ;Lit le prochain groupe de 16 pixels.
               not.w    d7                  ;On inverse les couleurs (car la couleur du fond est ici 1, et non pas 0).
               adda.l   d3,a2               ;Adr. du prochain groupe (on ajoute 16).
               cmp.b    d3,d0               ; Branch. s'il reste d'autres pixels
               bhi.s    sf_lbl1             ; dans la ligne courante.
               rol.w    d0,d7               ;Met les pixels  stocker dans les bits de poids faibles de D7.
               bfins    d7,(a1){d2:d0}      ;Stocke les D0.B derniers pixels.
               suba.l   d5,a0               ;Ligne prcdente (mmoire video), i.e. situe au-dessus.
               move.w   sf.llen(a4),d3      ; Ligne suivante dans le tableau
               lea      (a1,d3.w),a1        ; des caractres.
               dbf      d1,sf_inner1        ;Boucle (passe  la ligne situe au-dessus).
               move.w   (sp)+,d3            ;Rcupre D3.
               movea.l  a3,a0               ;
               move.w   d6,d1               ;
               moveq    #-1,d0              ;
sf_inner2:     move.w   d0,(a0)             ;
               move.w   d0,16(a0)           ; Efface le caractre.
               move.w   d0,32(a0)           ;
               move.w   d0,48(a0)           ;
               suba.l   d5,a0               ;
               dbf      d1,sf_inner2        ;
sf_next:       addq.b   #1,d4               ; Boucle (passe au caractre
               bne      sf_outer            ; suivant).
;\4
               tas      sf.lock(a4)         ;Verrouille les donnes sur la fonte n *sfontid.
               bsr.s    dsc_addrwin         ;--> D0, D1, D2, D3, A1.
dsc_outer:     moveq    #windw/16-1,d4      ;D4.W: nb de groupes de 16 pixels - 1 (compteur).
               movea.l  a1,a0               ;A0: adr. (paire) du 1er groupe (plan 0) de la ligne courante.
dsc_inner:     lea      12(a0),a0           ;
               bsr.s    dsc_clr             ; Annule les 16 bits des plans 6, 0
               lea      -12(a0),a0          ; et 1  (on commence  par le plan 6
               bsr.s    dsc_clr             ; pour viter  d'avoir des couleurs
               addq.l   #2,a0               ; parasites sur l'cran).
               pea      dsc_cont(pc)        ;
dsc_clr:       bfclr    (a0){d0:d1}         ; Annule les 16 pixels  partir du pixel d'abscisse
               tst.b    d0                  ; D0  par rapport  (A0).  Seul le plan de (A0) est
               beq.s    dsc_rts             ; modifi. Note: puisque la couleur VDI tait 1, la
               bfclr    16(a0){0:d0}        ; couleur XBIOS/hardware  tait -1,  donc  tous les
dsc_rts:       rts                          ; bits sont  1 par dfaut.
;\4
dsc_addrwin:   lea      addr_scr(pc),a0     ;A0: [addr_scr, xy0, xlen].
               movea.l  (a0)+,a1            ;A1: adr. de l'cran.
               movem.w  (a0),d0-d2          ;D0.L: x0, D1.L: y0, D2.L: xlen.
               mulu.w   d2,d1               ;
               move.l   d0,d3               ; A1:  adr.  du point
               andi.b   #$F0,d3             ; suprieur gauche de
               add.l    d3,d1               ; la zone de travail.
               adda.l   d1,a1               ;
               andi.w   #$F,d0              ;D0: abscisse relativement aux groupes de 16 pixels.
               moveq    #16,d1              ; D1: longueur du segment allant de ce point
               sub.b    d0,d1               ; au point le +  droite du groupe.
               move.l   #windh-1,d3         ;D3.L: ordonne par rapport  la ligne la + basse (compteur).
               rts                          ;Retour.
;\4
dsc_cont:      addq.l   #2,a0               ;A0: adr. du plan 2 (groupe courant).
               move.l   d4,d7               ;
               divu.w   #12,d7              ; D7.B = D4 mod 12.
               swap     d7                  ;
               move.b   d7,d6               ; D6.B = (D4 mod
               addq.b   #1,d6               ; 12) + 1.
               cmpi.b   #6,d7               ; D7.B  [0, 1, 2, 3, 4, 5, 6, 6, 5, 4, 3, 2](D4 mod 12) mod 8.
               bls.s    dsc_lbl1            ; D6.B  [1, 2, 3, 4, 5, 6, 7, 5, 4, 3, 2, 1](D4 mod 12) mod 8.
               neg.b    d7                  ;
               addq.b   #5,d7               ; En considrant uniquement les bits 1 et 2, on a:
               neg.b    d6                  ; D7: [0, 0, 1, 1, 2, 2, 3, 3, 2, 2, 1, 1].
               addq.b   #5,d6               ; D6: [0, 1, 1, 2, 2, 3, 3, 2, 2, 1, 1, 0].
dsc_lbl1:      movea.l  d4,a2               ;Sauve D4.
               lsr.b    #2,d7               ;
               scs      d4                  ; D4.W = $0000 si D7[1] = 0,
               ext.w    d4                  ; D4.W = $AAAA si D7[1] = 1.
               andi.w   #$AAAA,d4           ;
               lsr.b    #1,d7               ;
               scs      d5                  ; D5.W = $0000 si D7[2] = 0,
               ext.w    d5                  ; D5.W = $AAAA si D7[2] = 1.
               andi.w   #$AAAA,d5           ;
               lsr.b    #2,d6               ;
               scs      d7                  ; D7.W = $0000 si D6[1] = 0,
               ext.w    d7                  ; D7.W = $5555 si D6[1] = 1.
               andi.w   #$5555,d7           ;
               or.w     d7,d4               ;D4.W = $AAAA * D7[1] + $5555 * D6[1].
               lsr.b    #1,d6               ;
               scs      d7                  ; D7.W = $0000 si D6[2] = 0,
               ext.w    d7                  ; D7.W = $5555 si D6[2] = 1.
               andi.w   #$5555,d7           ;
               or.w     d7,d5               ;D5.W = $AAAA * D7[2] + $5555 * D6[2].
               bfins    d4,(a0){d0:d1}      ;
               bfins    d5,2(a0){d0:d1}     ;
               tst.b    d0                  ;
               beq.s    dsc_lbl2            ; Stocke D4.W/D5.W sur
               lsr.w    d1,d4               ; les plans 2 et 3.
               lsr.w    d1,d5               ;
               bfins    d4,16(a0){0:d0}     ;
               bfins    d5,18(a0){0:d0}     ;
dsc_lbl2:      addq.l   #4,a0               ;A0: adr. du plan 4 (du groupe courant).
               move.l   d3,d7               ;
               lsr.w    #4,d7               ; D7.B = (D3/16) mod 12 (D3 est divis par 16
               divu.w   #12,d7              ; car on considre des groupes de 16 lignes).
               swap     d7                  ;
               btst     #0,d3               ; Incr. D7 si le n de la ligne est pair  (ceci revient 
               seq      d6                  ; considrer D7.B ou D6.B calculs pour les groupes hori-
               sub.b    d6,d7               ; zontaux, suivant que la ligne est impaire ou paire).
               cmpi.b   #6,d7               ;
               bls.s    dsc_lbl3            ; On refait le mme calcul que
               neg.b    d7                  ; ci-dessus (avec D6 et D7).
               addq.b   #5,d7               ;
dsc_lbl3:      lsr.b    #2,d7               ; Annule les 16 bits du plan 4 si
               bcs.s    dsc_lbl4            ; D7[1] = 0 (si D7[1] = 1, on les
               bsr      dsc_clr             ; laisse  1).
dsc_lbl4:      addq.l   #2,a0               ;A0: adr. du plan 5 (du groupe courant).
               lsr.b    #1,d7               ; Annule les 16 bits du plan 5 si
               bcs.s    dsc_lbl5            ; D7[1] = 0 (si D7[1] = 1, on les
               bsr      dsc_clr             ; laisse  1).
dsc_lbl5:      addq.l   #6,a0               ;A0: adr. du plan 0 du groupe suivant.
               move.l   a2,d4               ;Rcupre D4.
               dbf      d4,dsc_inner        ;Boucle (passe au groupe de 16 pixels suivant).
               adda.l   d2,a1               ;Adr. du 1er groupe de la ligne suivante.
               dbf      d3,dsc_outer        ;Boucle sur toutes les lignes de la zone de travail.
;\4
               move.w   mfontid(pc),d7      ; Slectionne la fonte de n *mfontid
               bsr      set_font1           ; si SpeedoGDOS est install.
               moveq    #22,d7              ;Hauteur initiale des caractres: 22 - 2 = 20.
dsc_loop:      subq.b   #2,d7               ;Dcr. de 2 la hauteur des caractres.
               bsr      char_height         ;Fixe la hauteur des caractres.
               lea      hisc_scores(pc),a0  ;
               bsr      text_extent         ;
               move.w   d0,d5               ; D0.W: somme des tailles, en octets,
               lea      hisc_menu(pc),a0    ; des 2 chanes  afficher.
               bsr      text_extent         ;
               add.w    d5,d0               ;
               cmpi.w   #windw-128,d0       ; Branch. si elle n'est
               bls.s    dsc_dispsm          ; pas trop gde.
               cmpi.b   #8,d7               ; Branch. pour dcr. la hauteur des
               bne.s    dsc_loop            ; caractres, si elle est > 8.
dsc_dispsm:    moveq    #smcolor,d0         ; Couleur du texte: smcolor (224);
               bsr      text_color          ; note: les bits 0 et 1 sont nuls.
               lea      hisc_scores(pc),a0    ;
               bsr      copy_text             ; Affiche la 1re chane  gauche:
               move.l   #48<<16+(windh-8),d1  ; "F1-F20: scores.".
               bsr      disp_text             ;
               bsr      right_btm           ;Alignement: droite, bottom.
               lea      hisc_menu(pc),a0              ;
               bsr      copy_text                     ; Affiche la 2de chane 
               move.l   #(windw-48)<<16+(windh-8),d1  ; droite: "ESC: menu.".
               bsr      disp_text                     ;
               move.w   fx(pc),d5           ;Rcupre les dizaines du 1er rang  afficher (0  19).
;\6
;  Chiffre: 21 lignes x 12 colonnes (4 colonnes entre 2 chiffres). Segment: 3 vrais segments 6-8-6.
;  Rang: 3 chiffres (au maximum). Score: 8 chiffres. Les caractres du nom sont affichs en mode XOR.
;  Ligne: |  rang    nom....  score    date  |
;          12 44  20  224   12 124  20 156 12

fk_write:      clr.w    d7                  ;D7.W = 0 (utile si D5 = 9).
               moveq    #1,d0               ;D0.W = 1 (utile si 9  D5  18).
               cmpi.b   #9,d5               ; Branch. si les rangs affichs sont
               bcs.s    fk_lbl4             ; tous < 100, i.e. si D5 < 9.
               beq.s    fk_disp100          ;Branch. si seul le dernier rang affich est  100.
               moveq    #9,d7               ;D7.W = 9: on affiche 10 chiffres (au lieu de 1).
               cmpi.b   #19,d5              ; Si D5 = 19, on commence par
               bne.s    fk_disp100          ; afficher 2  (car le dernier
               moveq    #2,d0               ; rang est 200).
fk_disp100:    move.w   #ysc1,d6            ;D6.W: ordonne de la dernire ligne  afficher.
fk_loop100:    moveq    #sc_rank2,d1        ;D1.W: abscisse  laquelle il faut afficher le chiffre.
               bsr      dsc_dispdgt         ;Affiche le chiffre D0.W (1 ou 2): chiffre des centaines du rang.
               subi.w   #dysc,d6            ;Ordonne de la ligne situe au-dessus.
               moveq    #1,d0               ;Le prochain chiffre  afficher est 1.
               dbf      d7,fk_loop100       ;Boucle (affiche le chiffre des centaines de la ligne prcdente).
fk_lbl4:       movea.l  rul_ptr(pc),a0      ;A0: adr. du fichier de rgle.
               lea      rul.nsc6(a0),a3     ;A3: adr. du nb de scores pour 6 petits hex.
               moveq    #0,d0               ;D0.L = 0 (contiendra le nb de scores pour n < nhex petits hex.).
               move.w   nhex(pc),d1         ;Nb de petits hex. (6  9).
               subq.b   #7,d1               ;Nb de nb de scores  ajouter - 1.
               bcs.s    fk_lbl8             ;Branch. s'il n'y a rien  ajouter (--> D0 = 0), i.e. si nhex = 6.
               clr.w    d2                  ;Annule l'octet de poids fort de D2.W.
fk_loopsco:    move.b   (a3)+,d2            ;
               add.w    d2,d0               ; D0.L: nb de scores pour n < nhex petits hex.
               dbf      d1,fk_loopsco       ;
fk_lbl8:       moveq    #10,d4              ; D4.W: 1er rang 
               mulu.w   d5,d4               ; afficher - 1.
               cmp.b    (a3),d4             ; Branch. s'il n'y a aucun
               bcc.s    fk_lbl9             ; score  afficher.
               add.w    d4,d0               ; D0.L: offset du 1er score  afficher par
               lsl.w    #5,d0               ; rapport au dbut de la liste des scores.
               lea      ([rul.hisc.w,a0],a0.l),a4  ;Adr. de la liste des scores.
               adda.l   d0,a4               ;A4: adr. du 1er score  afficher.
fk_lbl9:       moveq    #ysc0,d6            ;Ordonne de la 1re ligne de score.
               clr.w    d7                  ;D7.W = 0 (contiendra le chiffre des units du rang  afficher).
               move.w   d4,-(sp)            ;Empile D4.
fk_loopxx:     addq.b   #1,d7               ;
               cmpi.b   #10,d7              ; D7.W: chiffre des units
               bne.s    fk_lbl5             ; du rang  afficher.
               clr.b    d7                  ;
fk_lbl5:       move.w   d7,d0               ;
               moveq    #sc_rank0,d1        ; Affiche le chiffre des units.
               bsr      dsc_dispdgt         ;
               move.b   d5,d0               ;
               tst.b    d7                  ; D0.B: nb de dizaines
               bne.s    fk_lbl6             ; du rang  afficher.
               addq.b   #1,d0               ;
fk_lbl6:       extb.l   d0                  ;
               divu.w   #10,d0              ; D0.B: chiffre des dizaines du rang  afficher.
               swap     d0                  ;
               beq.s    fk_lbl7             ;Branch. si le rang est < 10 (on n'affiche pas le chiffre des dizaines).
               moveq    #sc_rank1,d1        ; Affiche le chiffre
               bsr      dsc_dispdgt         ; des dizaines.
fk_lbl7:       move.w   (sp),d4             ;
               cmp.b    (a3),d4             ; Branch. s'il n'y a pas de score  afficher.
               bcc      fk_lbl10            ;
               addq.w   #1,(sp)             ;Incr. le rang  afficher - 1.
               move.l   sco.score(a4),d0    ;D0.L: score  afficher.
               moveq    #8,d1               ;D1.B: nb de chiffres  afficher.
               bsr      hex2dec             ;Convertit le score en DCB.
               movem.w  d5-d7,-(sp)         ;Sauve D5, D6 et D7.
               move.l   d0,d7               ;D7.L: nb  afficher en DCB.
               moveq    #7,d5               ;D5.W: nb de chiffres - 1 (compteur).
fk_innersco:   rol.l    #4,d7               ;Met le prochain chiffre  afficher dans le quartet de poids faible de D7.
               move.b   d7,d0               ; D0.W: chiffre
               andi.w   #$F,d0              ;  afficher.
               move.w   #sc_score+7*16,d1   ;
               move.w   d5,d2               ; D1.W: abscisse  laquelle il faut afficher
               lsl.b    #4,d2               ; le chiffre; D1 = sc_score' - 16 * D5.
               sub.w    d2,d1               ;
               bsr      dsc_dispdgt         ;Affiche le chiffre D0.W  l'abscisse D1.W et  l'ordonne D6.W.
               dbf      d5,fk_innersco      ;Boucle (passe au chiffre suivant).
               move.w   sco.date(a4),d7     ;D7.W: date (format GEMDOS).
               move.w   #sc_date1,d1        ;D1.W: abscisse  laquelle il faut afficher le chiffre des dizaines.
               moveq    #$1F,d0             ; Affiche le chiffre des
               bsr      dsc_dispxx          ; dizaines du jour.
               swap     d5                  ; D0.W: chiffre
               move.w   d5,d0               ; des units.
               move.w   #sc_date0,d1        ;D1.W: abscisse  laquelle il faut afficher le chiffre des units.
               bsr      dsc_dispdgt         ;Affiche le chiffre des units du jour.
               moveq    #10,d0              ;
               move.w   #sc_dm,d1           ; Affiche un '-' entre le jour et le mois.
               bsr      dsc_dispdgt         ;
               lsr.w    #5,d7               ;Supprime le jour dans D7.
               move.w   #sc_month1,d1       ;D1.W: abscisse  laquelle il faut afficher le chiffre des dizaines.
               moveq    #$F,d0              ; Affiche le chiffre des
               bsr      dsc_dispxx          ; dizaines du mois.
               swap     d5                  ; D0.W: chiffre
               move.w   d5,d0               ; des units.
               move.w   #sc_month0,d1       ;D1.W: abscisse  laquelle il faut afficher le chiffre des units.
               bsr      dsc_dispdgt         ;Affiche le chiffre des units du mois.
               moveq    #10,d0              ;
               move.w   #sc_my,d1           ; Affiche un '-' entre le mois et l'anne.
               bsr      dsc_dispdgt         ;
               lsr.w    #4,d7               ;D7.W: anne par rapport  1980 (de 0  127).
               addi.w   #1980,d7            ;D7.W: anne (de 1980  2107).
               moveq    #0,d0               ;
               move.w   d7,d0               ;
               moveq    #4,d1               ; D7.W: anne en DCB.
               bsr      hex2dec             ;
               move.w   d0,d7               ;
               moveq    #3,d5               ;D5.W: nb de chiffres - 1 (compteur).
fk_inneryr:    rol.w    #4,d7               ;Met le prochain chiffre  afficher dans le quartet de poids faible de D7.
               move.b   d7,d0               ; D0.W: chiffre
               andi.w   #$F,d0              ;  afficher.
               move.w   #sc_year+3*16,d1    ;
               move.w   d5,d2               ; D1.W: abscisse  laquelle il faut afficher
               lsl.b    #4,d2               ; le chiffre; D1 = sc_year' - 16 * D5.
               sub.w    d2,d1               ;
               bsr      dsc_dispdgt         ;Affiche le chiffre D0.W  l'abscisse D1.W et  l'ordonne D6.W.
               dbf      d5,fk_inneryr       ;Boucle (passe au chiffre suivant).
               move.w   #sc_name,d1         ;Abscisse  laquelle il faut afficher le nom du joueur.
               move.l   a3,-(sp)            ;Sauve A3.
               movea.l  sfont_addr(pc),a3   ;A3: ptr sur les donnes concernant la fonte n *sfontid.
               add.w    sf.bottom(a3),d6    ;Ordonne  laquelle il faut afficher la Bottom line.
               bsr      dsc_addrxy          ;--> D1, D4, A1.
               movea.l  a4,a5               ;A5: ptr sur le nom du joueur.
               move.w   #sc_nlen,d7         ;D7.W: longueur de la zone rserve au nom.
               clr.w    d0                  ;Annule l'octet de poids fort de D0.W.
               clr.w    d2                  ;Annule l'octet de poids fort de D2.W.
               moveq    #0,d3               ;Annule le mot de poids fort de D3.
               bra.s    fk_lbl16
fk_loopname:   move.b   sf.width-' '(a3,d0.w),d2  ;D2.W: largeur du caractre.
               cmp.b    d2,d7               ; Branch. si le caractre est trop large (i.e. s'il sort de la zone
               bcs.s    fk_namend           ; rserve au nom du joueur); dans ce cas, on ne l'affiche pas.
               sub.b    d2,d7               ;Pts restant de la zone rserve au nom aprs affichage de ce caractre.
               lea      sf.SIZEOF(a3),a0    ;A0: adr. o sont stocks tous les caractres.
               move.w   sf.bottom(a3),d6    ; D6.W: hauteur
               add.w    sf.top(a3),d6       ; du caractre.
               movea.l  a1,a2               ;A2: adr. du point infrieur gauche du caractre (plan 7).
               movem.w  d1/d2/d7,-(sp)      ;Empile D7, D2 et D1 (dans cet ordre).
fk_innernam:   movem.w  (sp),d1/d2          ;Rcupre D1 et D2.
               move.w   (sf.offset-2*32.w,a3,d0.w*2),d3  ;D3: offset du segment source.
               movea.l  a2,a6               ;A6: adr. du point de gauche de la ligne courante.
fk_lbl13:      moveq    #16,d5              ; D5.B: nb de pts restant dans le groupe courant (la largeur du prochain ensemble
               sub.b    d1,d5               ;  recopier ne doit pas tre >  ce nb  cause de l'entrelacement des plans).
               cmp.b    d2,d5               ; Si le nb de pts restant du caractre est < D5,  on remplace D5 par
               bls.s    fk_lbl14            ; ce nb. Dans le cas contraire, on aura  la prochaine tape D1 = 0,
               move.b   d2,d5               ; et on devra encore recopier des pts sur le groupe suivant.
fk_lbl14:      bfextu   (a0){d3:d5},d7      ; Recopie
               bfins    d7,(a6){d1:d5}      ; D5 pts.
               add.w    d5,d3               ;Met  jour l'offset du segment source.
               add.b    d5,d1               ;
               cmpi.b   #16,d1              ; Met  jour  l'adr. du groupe de 16 pixels et
               bne.s    fk_lbl15            ; l'abscisse du point suivant par rapport  ce
               clr.b    d1                  ; groupe.
               lea      16(a6),a6           ;
fk_lbl15:      sub.b    d5,d2               ;Met  jour le nb de pts de la ligne qu'il reste  recopier.
               bne.s    fk_lbl13            ;Branch. s'il reste encore des pts de la ligne  recopier.
               move.w   sf.llen(a3),d3      ; Ligne suivante
               lea      (a0,d3.w),a0        ; de la source.
               suba.l   d4,a2               ;Ligne prcdente (mmoire video).
               dbf      d6,fk_innernam      ;Boucle (passe  la ligne situe au-dessus).
               addq.l   #4,sp               ;Dpile D1 et D2 (mais on laisse D1 inchang).
               move.w   (sp)+,d7            ;Rcupre D7.
               adda.l   d4,a2               ; A1: adr. (plan 7) du point infrieur gauche du caractre
               suba.l   a2,a6               ; suivant  (note:  D1: abscisse de ce point par rapport au
               adda.l   a6,a1               ; dbut du groupe de 16 pixels).
fk_lbl16:      move.b   (a5)+,d0            ;D0.W: prochain caractre du nom du joueur, ou 0 si fin du nom.
               bne.s    fk_loopname         ;Branch. pour afficher ce caractre si D0 <> 0.
fk_namend:     move.w   sf.bottom(a3),d0    ; A1: adr. du point de la Base
               mulu.w   d4,d0               ; line  situ   droite du nom
               suba.l   d0,a1               ; que l'on vient d'afficher.
               movea.l  (sp)+,a3            ;Rcupre A3.
               ext.l    d7                  ;Il reste D7.L pts avant la fin de la zone rserve au nom.
               divu.w   #6,d7               ;Divise D7 par 6 (priode des pts  afficher).
               move.w   d7,d6               ;D6.W: nb de pts  afficher.
               beq.s    fk_lbl20            ;Branch. s'il n'y a rien  afficher.
               swap     d7                  ;D7.B: nb de pts avant la prochaine priode (1 priode = 000011).
               neg.l    d4                  ;D4.L = - taille d'une ligne en octets.
               moveq    #16,d0              ;D0.L = 16.
               clr.b    d2                  ;D2.B = 0.
               moveq    #7,d3               ;D3.B = 7.
fk_innerpts:   addq.b   #4,d7               ;Ajoute 4  D7 (4 premiers chiffres de la priode: 0).
               add.b    d7,d1               ;
               cmp.b    d0,d1               ; Dplacement de D7 pts
               bcs.s    fk_lbl17            ; vers la droite  (mise
               sub.b    d0,d1               ;  jour de A1 et D1).
               adda.l   d0,a1               ;
fk_lbl17:      cmpi.b   #15,d1              ; Branch. si les 2 prochaines colonnes
               bne.s    fk_lbl18            ; font partie d'un seul groupe.
               bset     d2,1(a1)            ;Affiche le point infrieur gauche du carr.
               bset     d2,1(a1,d4.l)       ;Affiche le point infrieur droit du carr.
               bset     d3,16(a1)           ;Affiche le point suprieur gauche du carr.
               bset     d3,16(a1,d4.l)      ;Affiche le point suprieur droit du carr.
               bra.s    fk_lbl19
fk_lbl18:      bfset    (a1){d1:2}          ;Affiche un segment horizontal de 2 pts.
               bfset    (a1,d4.l){d1:2}     ;Affiche un segment de 2 pts sur la ligne situe au-dessus.
fk_lbl19:      moveq    #2,d7               ;D7.B = 2 (car on vient d'afficher des segments horizontaux de 2 pts).
               subq.b   #1,d6               ; Boucle (passe au prochain
               bne.s    fk_innerpts         ; carr 2 x 2  afficher).
fk_lbl20:      movem.w  (sp)+,d5-d7         ;Rcupre D5, D6 et D7.
               lea      sco.SIZEOF(a4),a4   ;Score suivant.
fk_lbl10:      addi.w   #dysc,d6            ;Ordonne de la ligne suivante.
               tst.b    d7                  ; Boucle (passe au
               bne      fk_loopxx           ; rang suivant).
               addq.l   #2,sp               ;Dpile D4.
               bsr      end_windupd         ;Fin de mise  jour de la fentre si le jeu se droule dans une fentre GEM.
;\6
;  Modification des couleurs 128  191, et smcolor (224).
;   _ Si r est le nb form par la valeur des plans 2 et 3, alors l'intensit finale de rouge vaut 4r+48.
;   _ Si b est le nb form par la valeur des plans 4 et 5, alors l'intensit finale de bleu vaut 4b+48.

               bsr      timer96             ;Lance le timer (96 Hz).
               move.b   RGB+188*4+1(pc),d4  ;D4.B = 0 ssi le fond (plans 2  5) est noir.
               clr.w    d7                  ;D7.W = 0 (compteur allant de 0  16).
               pea      game2(pc)           ;Empile game2 (utile si on passe en mode PAUSE pdt la modif. des couleurs).
               lea      counter(pc),a5      ;(A5).W: compteur du timer.
               clr.w    (a5)                ;Annule le compteur du timer.
fk_outer1:     lea      RGB+191*4+3(pc),a0  ;A0: composante bleue de la dernire couleur  modifier (191).
               moveq    #63,d6              ;D6.W: index de la couleur  modifier - 128 (varie de 63  0).
fk_inner1:     moveq    #16,d2              ;D2.W = 16 (valeur maxi de D7).
               tst.b    d4                  ; Branch. si les couleurs du fond (plans 2  5) sont
               bne.s    fk_lbl1             ; bonnes: elles ne doivent pas tre modifies.
               move.b   d7,d2               ;D2.W = D7.
fk_lbl1:       move.w   d6,d0               ;
               lsr.b    #4,d0               ; D0.W = b + 12.
               addi.b   #12,d0              ;
               mulu.w   d2,d0               ; D0.W = D2 * (b+12) / 4
               lsr.b    #2,d0               ; (composante bleue).
               move.w   d6,d1               ;
               andi.b   #%001100,d1         ; D1.W = 4r + 48.
               addi.b   #48,d1              ;
               mulu.w   d2,d1               ; D1.W = D2 * (r+12) / 4
               lsr.w    #4,d1               ; (composante rouge).
               move.w   d7,d2               ;
               btst     #1,d6               ; D2.W =
               bne.s    fk_lbl2             ;  si D6 mod 4 == %00: 16.
               moveq    #16,d2              ;  si D6 mod 4 == %01: 16 - D7.
fk_lbl2:       btst     #0,d6               ;  si D6 mod 4 == %10: D7.
               beq.s    fk_lbl3             ;  si D6 mod 4 == %11: 0.
               sub.b    d7,d2               ;
fk_lbl3:       mulu.w   d2,d0               ;
               lsr.w    #4,d0               ; Composante bleue: D2 * D0 / 16.
               move.b   d0,(a0)             ;
               moveq    #16,d0              ;
               sub.b    d2,d0               ; Composante verte:
               mulu.w   #15,d0              ; 15 * (16 - D2).
               move.b   d0,-(a0)            ;
               mulu.w   d2,d1               ;
               lsr.w    #4,d1               ; Composante rouge: D2 * D1 / 16.
               move.b   d1,-(a0)            ;
               subq.l   #2,a0               ;Adr. de la composante bleue de la couleur prcdente.
               dbf      d6,fk_inner1        ;Boucle tant qu'il reste des couleurs  modifier.
               tst.b    d4                  ; Branch. si les couleurs du fond (et des 2
               bne.s    fk_chcolwait        ; chanes affiches en bas) sont bonnes.
               move.w   d7,d0               ; D0 = D7 - 4
               subq.b   #4,d0               ; ( 12).
               bls.s    fk_chcolwait        ;Branch. si D7  4 (la couleur des chanes reste noire).
               moveq    #12,d1              ;
               mulu.w   d0,d1               ; D0.B = 16 (D7 - 4), D1.B = 12 (D7 - 4).
               lsl.b    #4,d0               ;
               lea      RGB+smcolor*4+1(pc),a0  ;Adr. de la composante rouge de la couleur de la chane.
               move.b   d0,(a0)+            ;Intensit de rouge: 16 (D7 - 4).
               move.b   d1,(a0)+            ;Intensit de vert: 12 (D7 - 4).
               move.b   d1,(a0)             ;Intensit de bleu: 12 (D7 - 4).
fk_chcolwait:  bsr      read_message        ;Prend en compte les messages ventuels concernant la fentre.
               bmi      stop_timer          ;Branch. si on est pass en mode PAUSE (on revient au menu).
               tst.w    (a5)                ; Branch. tant que le compteur du
               bpl.s    fk_chcolwait        ; timer n'a pas t dcrment.
               addq.w   #1,(a5)             ;Incr. le compteur du timer.
               bsr      chg_f2lcolor        ;Change la couleur des pinceaux.
               addq.b   #1,d7               ;Incr. le compteur D7.
               cmpi.b   #16,d7              ; Boucle tant que
               bls      fk_outer1           ; D7  16.
               addq.l   #4,sp               ;Dpile game2 (on n'en a pas eu besoin).
               bsr      stop_timer          ;Arrte le timer.
;\6
;  Recopie le plan 0 sur le plan 1, change les couleurs et annule le plan 0.

               bsr      beg_windupd         ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM...
               bmi      game2               ;Branch. si on est pass en mode PAUSE (on revient au menu).
               bsr      dsc_addrwin         ;--> D0, D1, D2, D3, A1.
fk_outer2:     movea.l  a1,a0               ;Adr. du groupe contenant le 1er pixel de la ligne courante.
               bfextu   (a0){d0:d1},d4      ; Recopie les D1 pixels de la zone de
               bfins    d4,2(a0){d0:d1}     ; travail appartenant  ce groupe.
               moveq    #windw/16-2,d4      ;D4.W: nb de groupes de 16 pixels - 2 (compteur).
fk_inner2:     lea      16(a0),a0           ; Recopie un groupe
               move.w   (a0),2(a0)          ; en entier.
               dbf      d4,fk_inner2        ;Boucle (passe au groupe suivant).
               tst.b    d0                  ;
               beq.s    fk_lbl12            ; Si D0 <> 0, on recopie les D0
               bfextu   16(a0){0:d0},d4     ; derniers pixels de la ligne.
               bfins    d4,18(a0){0:d0}     ;
fk_lbl12:      adda.l   d2,a1               ;Ligne suivante.
               dbf      d3,fk_outer2        ;Boucle (passe  la ligne suivante).
;\4
               lea      RGB+129*4(pc),a0    ;
               moveq    #15,d0              ;
fk_loopexg:    move.l   (a0)+,d1            ; Echange les valeurs des couleurs
               move.l   (a0),-4(a0)         ; d'index  %10xxxx01 et %10xxxx10,
               move.l   d1,(a0)+            ; o xxxx varie de 0  15.
               addq.l   #8,a0               ;
               dbf      d0,fk_loopexg       ;
               bsr      chg_f2lcolor        ;Change la couleur des pinceaux.
;\4
               bsr      dsc_addrwin         ;--> D0, D1, D2, D3, A1.
fk_outer3:     movea.l  a1,a0               ;Adr. du groupe contenant le 1er pixel de la ligne courante.
               bfclr    (a0){d0:d1}         ;Annule le plan 0 des D1 pixels de la zone de travail appartenant  ce groupe.
               moveq    #windw/16-2,d4      ;D4.W: nb de groupes de 16 pixels - 2 (compteur).
fk_inner3:     lea      16(a0),a0           ; Annule le plan 0
               clr.w    (a0)                ; d'un groupe.
               dbf      d4,fk_inner3        ;Boucle (passe au groupe suivant).
               tst.b    d0                  ; Si D0 <> 0, on annule le
               beq.s    fk_lbl11            ; plan 0  des  D0 derniers
               bfclr    16(a0){0:d0}        ; pixels de la ligne.
fk_lbl11:      adda.l   d2,a1               ;Ligne suivante.
               dbf      d3,fk_outer3        ;Boucle (passe  la ligne suivante).
               bsr      end_windupd         ;Fin de mise  jour de la fentre si le jeu se droule dans une fentre GEM.
;\6
;  Attend un vnement.

fk_wait_mti:   bsr      dmem_test           ;Libre la mmoire associe  l'affichage des nb s'il le faut.
               IFNE     REGISTERED
               move.w   #msg_fct,d0         ; Envoie le msg
               bsr      send_msg0           ; msg_fct.
               move.l   d0,d6               ;
               subq.l   #1,d6               ; Branch. si un nb entre 1 et
               moveq    #20,d0              ; 20  a t renvoy;  dans ce
               cmp.l    d0,d6               ; cas, D6.W = ce nb - 1.
               bcs.s    fk_funckey          ;
               ENDIF
               pea      fk_tst_key(pc)      ;Adr.  laquelle il faudra se brancher aprs l'ventuel appel de read_msg1.
               lea      -16(sp),sp          ;Rserve de la mmoire pour les messages.
               bsr      xmem_test           ;Libre la mmoire utilise par l'image de fond, s'il n'en reste pas assez.
               moveq    #mu_timer,d0        ; On va surveiller l'vnement mu_timer
               clr.w    d7                  ; et on met le temps d'attente  0.
               bsr      wait_evnt           ;Attend un vnement.
               move.b   d0,d7               ;Masque des vnements ayant eu lieu.
               move.w   int_out+10(pc),d6   ;Code d'une touche si l'vnement evnt_keybd a eu lieu.
               lsl.b    #4,d0               ; N = 0 (utile pour le BMI ci-dessous). Branch.
               bcs      read_msg1           ; si l'vnement evnt_mesag a eu lieu.
               lea      20(sp),sp           ;Libre le buffer des messages et dpile l'adr. empile auparavant.
fk_tst_key:    bmi.s    game5               ;Branch. si on est pass en mode PAUSE (on revient au menu).
               lsr.b    #1,d7               ; Branch. si l'vnement evnt_keybd n'a pas
               bcc.s    fk_wait_mti         ; eu lieu (on attend un nouvel vnement).
               cmpi.b   #esc,d6             ; Branch. si c'est la touche
               beq      game4               ; ESC (on revient au menu).
               clr.b    d6                  ;Annule le code ASCII.
               bsr      func_num            ; Attend un nouvel vnement si ce n'est pas une touche
               bmi.s    fk_wait_mti         ; de fct. Si c'est la touche Fx, D6.W = x - 1.
fk_funckey:    cmp.b    d5,d6               ; Attend un nouvel vnement si l'utilisateur
               beq.s    fk_wait_mti         ; veut afficher les mmes scores.
               bsr      beg_windupd         ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM...
game5:         bmi      game2               ;Branch. si on est pass en mode PAUSE (on revient au menu).
               move.b   d6,d5               ;Dizaines du 1er rang  afficher.
               bra      fk_write            ;Branch. pour afficher les scores.
;\5
;  Version enregistre uniquement: nom cod de la personne enregistre.

               IFGT     REGISTERED
reg_name:      dcb.b    32,0                ;Nom cod de la personne enregistre.
               ENDIF
;\4
dsc_addrxy:    lea      addr_scr(pc),a0     ;A0: [addr_scr, xy0, xlen].
               movea.l  (a0)+,a1            ;A1: adr. de l'cran.
               movem.w  (a0),d2-d4          ;D2.L: x0, D3.L: y0, D4.L: xlen.
               add.w    d6,d3               ;
               mulu.w   d4,d3               ;
               add.w    d1,d2               ; A1:  adr.  du groupe de 16 pixels
               move.l   d2,d1               ; contenant le point (xc,yc). D1.L:
               andi.b   #$F0,d2             ; abscisse absolue de ce point.
               add.l    d2,d3               ;
               adda.l   d3,a1               ;
               andi.w   #$F,d1              ;D1.L: abscisse du point (xc,yc) par rapport au groupe de 16 pixels.
               rts                          ;Retour.
;\6
;  dsc_dispdgt: affiche un chiffre ou un '-' sur le plan 0. Registres modifis: D0, D1, D2, D3, D4, A0, A1, A2.
;    D0.W: chiffre  afficher (0  9), ou '-' (10).
;    D1.W: abscisse xc (par rapport  la zone de travail).
;    D6.W: ordonne yc (par rapport  la zone de travail).

dsc_dispxx:    move.b   d7,d5               ; D5.L: nb de 2 chiffres
               and.l    d0,d5               ;  afficher.
               divu.w   #10,d5              ; Mot de poids fort de D0: chiffre des units;
               move.w   d5,d0               ; mot de poids faible: chiffre des dizaines.
dsc_dispdgt:   move.b   (segd.w,pc,d0.w),d0 ;D0.B: segments  afficher (1 segment --> 1 bit).
               bsr.s    dsc_addrxy          ;--> D1, D4, A1.
               bsr.s    dscdd_lbl5          ;Affiche les segments horizontaux de gauche (s'ils doivent l'tre).
               addq.b   #2,d1               ;
               cmpi.b   #$10,d1             ; A1: adr. du groupe de 16 pixels contenant
               bcs.s    dscdd_lbl1          ; le point (xc+2,yc).  D1.L: abscisse de ce
               subi.b   #$10,d1             ; point par rapport au groupe.
               lea      16(a1),a1           ;
dscdd_lbl1:    rol.b    #3,d0               ; Branch. si le segment horizontal situ
               bpl.s    dscdd_lbl2          ; en bas ne doit pas tre affich.
               movea.l  a1,a0               ; Affiche le segment horizontal
               bsr      dscdd_hseg          ; situ en bas.
dscdd_lbl2:    rol.b    #3,d0               ; Branch. si le segment horizontal situ
               bpl.s    dscdd_lbl3          ; au milieu ne doit pas tre affich.
               moveq    #-9,d2              ; Affiche le segment horizontal
               bsr.s    dscdd_hs0           ; situ au milieu.
dscdd_lbl3:    rol.b    #3,d0               ; Branch. si le segment horizontal situ
               bpl.s    dscdd_lbl4          ; en haut ne doit pas tre affich.
               moveq    #-18,d2             ; Affiche le segment horizontal
               bsr.s    dscdd_hs0           ; situ en haut.
dscdd_lbl4:    addq.b   #7,d1               ;
               cmpi.b   #$10,d1             ; A1: adr. du groupe de 16 pixels contenant
               bcs.s    dscdd_lbl5          ; le point (xc+9,yc).  D1.L: abscisse de ce
               subi.b   #$10,d1             ; point par rapport au groupe.
               lea      16(a1),a1           ;
dscdd_lbl5:    rol.b    #3,d0               ; Branch. si le segment vertical situ en bas
               bpl.s    dscdd_lbl6          ;  gauche/droite ne doit pas tre affich.
               moveq    #-2,d2              ; Affiche le segment vertical situ
               bsr.s    dscdd_vseg          ; en bas  gauche/droite.
dscdd_lbl6:    rol.b    #3,d0               ; Branch. si le segment vertical situ en haut
               bpl.s    dscdd_rts           ;  gauche/droite ne doit pas tre affich.
               moveq    #-11,d2             ; A0: adr. du groupe  contenant  le point
dscdd_vseg:    muls.w   d4,d2               ; infrieur gauche du rectangle contenant
               lea      (a1,d2.l),a0        ; le segment  afficher.
;\7
;  Affiche un segment vertical sur le plan 0. Registres modifis: poids fort de D0, D2, D3, A0, A2.
;  Soit P le point infrieur gauche du rectangle contenant le segment  afficher.
;    D1.L: abscisse du point P par rapport au groupe de 16 pixels contenant ce point.
;    D4.L: taille, en octets, d'une ligne de l'cran systme.
;    A0: adr. du groupe de 16 pixels contenant le point P.

               moveq    #-7,d2              ; D2.L: offset du point suprieur gauche du rectangle
               muls.w   d4,d2               ; par rapport au point infrieur gauche.
               movea.l  a0,a2               ;(On ne doit pas modifier A0 tout de suite.)
               addq.b   #1,d1               ;D1.L: abscisse des points situs en haut et en bas par rapport au groupe.
               cmpi.b   #$10,d1             ; Si ces points ne font pas partie des groupes contenant les points
               bne.s    dscvs_lbl1          ; infrieur gauche et suprieur gauche,  i.e. si D1 = 16,  alors on
               lea      14(a2),a2           ; ajoute 14  A2 ( cause de l'entrelacement des plans).
dscvs_lbl1:    bfset    (a2){d1:1}          ;Affiche le point situ tout en bas.
               bfset    (a2,d2.l){d1:1}     ;Affiche le point situ tout en haut.
               subq.b   #1,d1               ;Rcupre la valeur initiale de D1.
               moveq    #5,d2               ;D2.W: nb de segments horizontaux de 3 pixels  afficher - 1 (compteur).
               cmpi.b   #$E,d1              ; Branch. si les 3 pixels ne font
               bcc.s    dscvs_lbl2          ; pas partie du mme groupe.
dscvs_loop1:   suba.l   d4,a0               ;Ligne prcdente.
               bfset    (a0){d1:3}          ;Affiche un segment horizontal de 3 pixels.
               dbf      d2,dscvs_loop1      ;Boucle (passe au segment situ au-dessus).
dscdd_rts:     rts                          ;Retour.
dscvs_lbl2:    moveq    #$10,d3             ; D3.B = 16 - D1: longueur de la partie
               sub.b    d1,d3               ; du segment appartenant au 1er groupe.
               move.w   d0,-(sp)            ;Sauve D0.W.
               moveq    #3,d0               ; D0.B = 3 - D3: longueur de la partie du
               sub.b    d3,d0               ; segment appartenant au 2nd groupe.
dscvs_loop2:   suba.l   d4,a0               ;Ligne prcdente.
               bfset    (a0){d1:d3}         ;Affiche le dbut du segment horizontal.
               bfset    16(a0){0:d0}        ;Affiche la fin du segment horizontal (appartenant au groupe suivant).
               dbf      d2,dscvs_loop2      ;Boucle (passe au segment situ au-dessus).
               move.w   (sp)+,d0            ;Rcupre D0.W.
               rts                          ;Retour.
;\2
dscdd_hs0:     muls.w   d4,d2               ; A0: adr. du groupe contenant le point infrieur gauche
               lea      (a1,d2.l),a0        ; du rectangle contenant le segment  afficher.
;\7
;  Affiche un segment horizontal sur le plan 0. Registres modifis: D2, D3, A0, A2.
;  Soit P le point infrieur gauche du rectangle contenant le segment  afficher.
;    D1.L: abscisse du point P par rapport au groupe de 16 pixels contenant ce point.
;    D4.L: taille, en octets, d'une ligne de l'cran systme.
;    A0: adr. du groupe de 16 pixels contenant le point P.

dscdd_hseg:    moveq    #-2,d2              ; D2.L: offset du point suprieur gauche du rectangle
               muls.w   d4,d2               ; par rapport au point infrieur gauche.
               movea.l  a0,a2               ;(On ne doit pas modifier A0 tout de suite.)
               addq.b   #1,d1               ;D1.L: abscisse des points situs  gauche des segments du bas et du haut.
               cmpi.b   #$10,d1             ; Si ces points ne font pas partie des groupes contenant les points infrieur
               bne.s    dschs_lbl1          ; gauche et suprieur gauche,  i.e.  si D1 = 16,  alors on ajoute 14  A2  (
               lea      14(a2),a2           ; cause de l'entrelacement des plans), et on se branche  dschs_lbl2 (car les
               bra.s    dschs_lbl2          ; segments du bas et du haut sont entirement contenu dans un seul groupe).
dschs_lbl1:    cmpi.b   #11,d1              ; Branch. si les segments du bas et du haut sont
               bcs.s    dschs_lbl2          ; entirement contenu dans un seul groupe.
               moveq    #$10,d3             ; D3.B = 16 - D1: longueur de la partie
               sub.b    d1,d3               ; du segment appartenant au 1er groupe.
               bfset    (a2){d1:d3}         ;Affiche le dbut du segment du bas.
               bfset    (a2,d2.l){d1:d3}    ;Affiche le dbut du segment du haut.
               not.b    d3                  ; D3.B = 6 - D3: longueur de la partie du
               addq.b   #7,d3               ; segment appartenant au 2nd groupe.
               bfset    16(a2){0:d3}        ;Affiche la fin du segment du bas.
               bfset    16(a2,d2.l){0:d3}   ;Affiche la fin du segment du haut.
               bra.s    dschs_lbl3          ;Branch. pour afficher le segment du milieu.
dschs_lbl2:    bfset    (a2){d1:6}          ;Affiche le segment du bas.
               bfset    (a2,d2.l){d1:6}     ;Affiche le segment du haut.
dschs_lbl3:    subq.b   #1,d1               ;Rcupre la valeur initiale de D1.
               suba.l   d4,a0               ;Ligne prcdente.
               cmpi.b   #9,d1               ; Branch. si le segment du milieu n'est pas
               bcc.s    dschs_lbl4          ; entirement contenu dans un seul groupe.
               bfset    (a0){d1:8}          ;Affiche le segment du milieu.
               rts                          ;Retour.
dschs_lbl4:    moveq    #$10,d3             ; D3.B = 16 - D1: longueur de la partie
               sub.b    d1,d3               ; du segment appartenant au 1er groupe.
               bfset    (a0){d1:d3}         ;Affiche le dbut du segment du milieu.
               moveq    #8,d2               ; D2.B = 8 - D3: longueur de la partie du
               sub.b    d3,d2               ; segment appartenant au 2nd groupe.
               bfset    16(a0){0:d2}        ;Affiche la fin du segment du milieu.
               rts                          ;Retour.
;\6
;    Ŀ
;     Changement du nom du joueur (N) 
;    

;   _ Seuls les caractres affichables (code ASCII  32) sont accepts comme caractres du nom.
;   _ Un CR (touche RETURN ou ENTER) valide le nom.
;   _ BACKSPACE efface le dernier caractre (s'il y en a un).
;   _ ESCAPE efface tout.
;   _ La flche droite permet de rcuprer le dernier caractre effac: utile au dbut, aprs BACKSPACE et aprs ESCAPE.
;   _ La flche vers le haut permet de rcuprer le nom en entier (quivaut  plusieurs flches vers la droite).
;   _ CTRL-C met fin  l'entre du nom et renvoie un nom vide (mme s'il n'est pas accept).
;\2
;  Note: au dbut, le nom est vide. Mais en fait un ESCAPE a t simul sur le nom du joueur
;  courant. On peut donc rcuprer ce nom en appuyant plusieurs fois sur la flche droite.
;\4
rect_datime:   moveq    #dtx0,d3            ; Complte les coordonnes pour afficher le rectangle
               moveq    #dtx1,d5            ; correspondant  la date ou l'heure.
               move.w   #bcolor,(a6)        ;Couleur du cadre: couleur la plus lumineuse du tableau.
rectd3456:     intvdi   vsl_color           ;SET POLYLINE COLOR INDEX.
               lea      ptsin+20(pc),a0     ;
               movem.w  d3/d4,-(a0)         ; Stocke  les coordonnes
               movem.w  d3/d6,-(a0)         ; du rectangle  afficher
               movem.w  d4-d6,-(a0)         ; relatives  la fentre.
               movem.w  d3-d5,-(a0)         ;
               move.l   xy0(pc),d2          ;
               moveq    #4,d0               ; Ajoute l'offset
endpr_inner:   add.l    d2,(a0)+            ; D2.L = (x0,y0).
               dbf      d0,endpr_inner      ;
               mvdi     v_pline,5,0,0       ;POLYLINE.
;\5
rectangle:     bsr.s    rectd3456           ;Affiche le rectangle (D3,D4) - (D5,D6).
               addq.w   #1,d7               ;Index de la prochaine couleur.
               addq.w   #1,d6               ; Incr. les coord. du point
               addq.w   #1,d5               ; infrieur droit.
               rts                          ;Retour.
;\4
chg_pname:     moveq    #127,d5             ;D5.B (non sign) > 23: le nom vide est accept.
               pea      game4(pc)           ;Empile l'adr. de retour.
chg_pname3:    IFNE     REGISTERED
               moveq    #msg_pname,d0       ; Envoie le msg
               bsr      send_msg0           ; msg_pname.
               ENDIF
               lea      intin(pc),a6        ;A6: adr. du tableau INTIN.
               moveq    #0,d4               ;D4.L: longueur du nom.
               movea.l  d4,a5               ;A5 = 0: aucune partie de la fentre n'est stocke en mmoire.
               lea      pname(pc),a4        ;A4: adr. o il faut stocker le nom du joueur.
               subq.l   #8,sp               ;Rserve de la place pour les abscisses du curseur (cf ci-dessous).
;\6
;  D4.L: longueur du nom (de 0  23).
;  D5.B: 0 si le nom vide n'est pas accept, 127 s'il est accept. Si le MSB de D5.B est  1, c'est que l'utilisateur
;        a appuy sur la flche vers le haut: on simule plusieurs appuis sur la flche droite; le MSB redeviendra nul
;        qd la fin du nom aura t rencontre (caractre nul).  Pdt que le MSB est  1, l'ancienne valeur de D5.B n'a
;        aucune importance, car l'entre du nom ne peut se terminer que lorsque le MSB est nul.
;  A4: adr. o il faut stocker le provhain caractre du nom du joueur.
;  A5: image 1 plan de "Votre nom: " + nom du joueur, ou 0 si ce texte tient entirement dans la fentre.
;  A6: adr. du tableau INTIN.
;  (SP).W: abscisse du curseur relative  la fentre.
;  2(SP).W: abscisse minimale du curseur (i.e. qd le nom est vide).
;  4(SP).L: abscisse du curseur par rapport au dbut du texte.
;\4
chg_pname4:    moveq    #-1,d6              ;D6.W = -1.
chg_pname5:    bsr      wd_update           ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM...
               bsr      fill_col1           ;
               move.l   #ynx1<<16+yny1,d0   ; Affiche un rectangle noir de coord. (ynx1,yny1) - (ynx2,yny2)
               move.l   #ynx2<<16+yny2,d1   ; (couleur VDI 1, couleur XBIOS -1).
               bsr      frect1              ;
               movem.w  d4-d6,-(sp)         ;Sauve D4, D5 et D6.
               moveq    #ynx1-3,d3          ;
               moveq    #yny1-3,d4          ; D3/D4: coord. du point suprieur gauche.
               move.w   #ynx2-3,d5          ; D5/D6: coord. du point infrieur droit.
               moveq    #yny2-3,d6          ;
               move.w   #224,d7             ;D7: index de couleur.
cpn_rect:      move.w   d7,(a6)             ;Stocke l'index de couleur dans INTIN.
               bsr.s    rectangle           ;Affiche le rectangle (D3,D4) - (D5,D6), incr. couleur et pnt infrieur droit.
               addq.w   #1,d4               ; Incr. les coord. du point
               addq.w   #1,d3               ; suprieur gauche.
               cmpi.b   #228,d7             ; Boucle (on affiche au
               bne.s    cpn_rect            ; total 4 rectangles).
               moveq    #ycolor,d0          ; Couleur du texte = ycolor. Alignement:
               bsr      col_align           ; gauche, base line.
               move.w   mfontid(pc),d7      ; Slectionne la fonte de n *mfontid si SpeedoGDOS est
               bsr      hname_height        ; install. Fixe la hauteur des caractres  hname.
               move.l   a5,d0               ; Branch. si
               beq.s    cpn_disp            ; A5 = 0.
               lea      6(sp),a3            ;A3: adr. o se trouvent les abscisses du curseur.
               bsr      cpn_redisp          ;Affiche le texte.
               bsr      hnh_sfontid         ;Fonte *sfontid. Fixe la hauteur des caractres  hname.
               bra.s    cpn_lbl3            ;Branch. pour attendre un nouvel vnement.
cpn_disp:      clr.l    6(sp)               ; Abscisses du curseur:
               clr.l    10(sp)              ; 0 pour l'instant.
               movea.l  alert_name+4(pc),a0 ;A0: chane "Votre nom: ".
               move.l   a0,d4               ;Sauve A0 dans D4.
               bsr      text_extent         ;D0.W: taille de la chane en pixels.
               cmpi.w   #yndx,d0            ; Branch. si elle
               bhi.s    cpn_lbl2            ; est trop gde.
               move.w   d0,6(sp)            ;
               move.w   d0,8(sp)            ; Remplace l'abscisse du curseur 0 par D0.
               move.w   d0,12(sp)           ;
               movea.l  d4,a0               ;Rcupre A0.
               bsr      copy_text                   ;
               move.l   #(ynx1+8)<<16+(yny2-10),d1  ; Affiche la chane.
               bsr      disp_text                   ;
cpn_lbl2:      bsr      hnh_sfontid         ;Fonte *sfontid. Fixe la hauteur des caractres  hname.
               lea      6(sp),a3            ;A3: adr. o sont stockes les abscisses du curseur.
               moveq    #0,d4                 ;
               bra.s    cpn_cmp               ;
cpn_loop:      move.b   (pname.w,pc,d4.l),d6  ; Affiche le nom (NB: (SP).W doit contenir
               bsr      disp_char             ; la valeur de D4 qui a t sauve).
cpn_cmp:       cmp.w    (sp),d4               ;
               bne.s    cpn_loop              ;
cpn_lbl3:      movem.w  (sp)+,d4-d6         ;Rcupre D4, D5 et D6.
               cmpi.w   #bs,d6              ; Branch.  cpn_bksp2 ou  cpn_char2 si la touche (backspace
               beq      cpn_bksp2           ; ou caractre affichable)  n'avait pas t  prise en compte
               bpl      cpn_char2           ; parce que la fentre tait pass en arrire plan.
cpn_wmti0:     bsr      end_windupd         ;Fin de mise  jour de la fentre si le jeu se droule dans une fentre GEM.
cpn_waitmti:   bsr      dmem_test           ;Libre la mmoire associe  l'affichage des nb s'il le faut.
               clr.w    d6                  ;Annule l'octet de poids fort de D6.W.
               pea      cpn_tstkey(pc)      ;Adr.  laquelle il faudra se brancher aprs l'ventuel appel de read_msg1.
               lea      -16(sp),sp          ;Rserve de la mmoire pour les messages.
               clr.b    d0                  ;Annule D0.B: pas d'evnt_mesag si le MSB de D5.B est  1.
               moveq    #1,d7               ;Met le bit 0 de D7  1: evnt_keybd simul si le MSB de D5.B est  1 ou msg_wname.
               tst.b    d5                  ; Branch. si le MSB de D5.B est  1: on
               bmi.s    cpn_uparrow         ; simule l'appui sur la flche droite.
               IFNE     REGISTERED
               move.w   #msg_wname,d0       ; Envoie le msg
               bsr      send_msg0           ; msg_wname.
               tst.l    d0                  ; Branch. si pas
               beq.s    cpn_wmti2           ; d'vnement.
               bpl.s    cpn_pos             ;Branch. si D0.L > 0.
               addq.l   #2,d0               ;D0.L < 0. On ajoute 2.
               beq.s    cpn_uparrow0        ;Branch. si on avait D0 = -2 (flche vers le haut). D7 = 1 et D0 = 0.
               bpl.s    cpn_rightarr        ;Branch. si on avait D0 = -1 (flche droite). D7 = 1 et D0 = 1.
cpn_pos:       move.b   d0,d6               ;D6.W: caractre mul si D0.L < 256.
               lsr.l    #8,d0               ; Branch. si on avait D0.L < 256
               beq.s    cpn_tstmsg          ; (maintenant, on a D0.L = 0).
               ENDIF
cpn_wmti2:     bsr      xmem_test           ;Libre la mmoire utilise par l'image de fond, s'il n'en reste pas assez.
               bsr      wait_evnt0          ;Attend un vnement.
               move.b   d0,d7               ;Masque des vnements ayant eu lieu.
               move.w   int_out+10(pc),d1   ;D1.W: scancode + code ASCII de la touche.
               move.b   d1,d6               ;D6.W: code ASCII d'une touche si l'vnement evnt_keybd a eu lieu.
               cmpi.w   #uparrow<<8,d1      ; Branch. si ce n'est pas
               bne.s    cpn_tstright        ; la flche vers le haut.
cpn_uparrow0:  tas      d5                  ;Met  1 le MSB de D5.B.
cpn_uparrow:   move.b   (a4),d6             ;D6.B: caractre sous le curseur.
               bne.s    cpn_tstmsg          ;Branch. s'il est non nul (il s'agit d'un vrai caractre).
               lsr.b    #1,d5               ;Fin du nom. On remet le MSB de D5.B  0 sans modifier les autres bits (tous =).
cpn_tstright:  cmpi.w   #rightarrow<<8,d1   ; Si c'est la flche droite, on simule l'appui sur la touche correspondante
               bne.s    cpn_tstmsg          ; au caractre (A4)  (qui est sous le curseur).  Ce caractre  est  soit un
cpn_rightarr:  move.b   (a4),d6             ; caractre affichable (code ASCII  32), soit le caractre nul.
cpn_tstmsg:    lsl.b    #4,d0               ; N = 0 (utile pour le BMI ci-dessous). Branch.
               bcs      read_msg1           ; si l'vnement evnt_mesag a eu lieu.
               lea      20(sp),sp           ;Libre le buffer des messages et dpile l'adr. empile auparavant.
cpn_tstkey:    bmi      chg_pname4          ;Branch. si on est pass en mode PAUSE.
               lsr.b    #1,d7               ; Branch. si l'vnement evnt_keybd n'a pas
               bcc.s    cpn_waitmti         ; eu lieu (on attend un nouvel vnement).
               cmpi.b   #' ',d6             ; Branch. si c'est un caractre affichable
               bcc      cpn_char            ; (i.e. de code ASCII  32).
               subq.b   #ctrl_c,d6          ; Branch. si c'est
               beq.s    cpn_ctrlc           ; CTRL-C.
               subq.b   #bs-ctrl_c,d6       ; Branch. si c'est
               beq      cpn_bksp            ; BACKSPACE.
               cmpi.b   #esc-bs,d6          ; Branch. si
               beq.s    cpn_esc             ; c'est ESC.
               subq.b   #cr-bs,d6           ;
               IFNE     REGISTERED          ;
               bne      cpn_waitmti         ; Branch. si ce n'est
               ELSE                         ; pas RETURN/ENTER.
               bne.s    cpn_waitmti         ;
               ENDIF                        ;
               cmp.b    d4,d5               ;
               IFNE     REGISTERED          ; Branch. si D4.B et D5.B sont tous
               beq      cpn_waitmti         ; les 2 nuls  (si D5.B <> 0,  alors
               ELSE                         ; D5.B > 23,  et D4.B <> D5.B):  le
               beq.s    cpn_waitmti         ; nom vide n'est pas accept.
               ENDIF                        ;
cpn_end:       clr.b    (a4)                ;Octet nul: caractre de fin de nom.
               addq.l   #8,sp               ;Dpile les abscisses du curseur.
               move.l   a5,d0               ; Libre la mmoire contenant
               bne      call_mfree2         ; l'image du nom du joueur si
               rts                          ; elle existe. Retour.
cpn_ctrlc:     suba.l   d4,a4               ; Renvoie un nom vide
               bra.s    cpn_end             ; (A4 = pname).
cpn_esc:       suba.l   d4,a4               ;A4 = pname: dbut de nom.
               clr.b    d4                  ;D4.L = 0 (longueur nulle).
               movea.l  sp,a0               ;
               move.w   (a0)+,d7            ; D7.W = 0  ssi tout le texte est
               move.w   (a0)+,(sp)          ; visible. Remet les abscisses du
               sub.l    (a0)+,d7            ; curseur  la valeur min.
               move.w   (sp),-(a0)          ;
               bsr      beg_windupd         ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM...
               bmi.s    cpn_tstkey          ;Branch. si on est pass en mode PAUSE.
               moveq    #yny1+1,d0          ;D0.L: 0.W et ordonne du point suprieur gauche du rectangle  effacer.
               move.l   #(ynx2-9)<<16+(yny2-4),d1  ;D1.L: coord. du point infrieur droit du rectangle  effacer.
               tst.w    d7                  ; Branch. si une partie du
               bne.s    cpn_lbl4            ; texte n'est pas visible.
               moveq    #ynx1+8,d2          ; Abscisse du point suprieur gauche
               add.w    (sp),d2             ; du rectangle  effacer.
               bsr      frect0              ;Efface le texte, sauf "Votre nom: " (s'il est affich).
               bra      cpn_wmti0           ;Branch. pour attendre un nouvel vnement.
cpn_lbl4:      moveq    #ynx1+1,d2          ;Abscisse du point suprieur gauche du rectangle  effacer.
               bsr      frect0              ;Efface entirement le texte.
               movea.l  sp,a3               ;A3: adr. o se trouvent les abscisses du curseur.
               pea      cpn_wmti0(pc)       ;Adr.  laquelle il faudra se brancher aprs cpn_redisp.
cpn_redisp:    move.w   6(a3),d0            ; A2: adr. du 1er pixel  recopier sur l'cran
               sub.w    (a3),d0             ; (note:  comme les dcalages se font tjrs par
               lsr.w    #3,d0               ; multiple de 16,  ce pixel  a pour abscisse 0
               lea      8(a5,d0.w),a2       ; par rapport  (A2)).
               move.w   d4,-(sp)            ;Sauve D4 (on n'a pas besoin de sauver le mot de poids fort, car il restera nul).
               bsr      cpn_addrxy          ;--> A1, D1.L, D4.L, D0.W.
cpn_outer2:    movea.l  a1,a0               ;Adr. du 1er groupe de la ligne courante (plan 4).
               moveq    #0,d7               ;D7.L: dplacement par rapport  A2 (initialement 0, cf ci-dessus).
               move.w   d1,-(sp)            ;Sauve D1.
               move.w   (a3),-(sp)          ;Empile la largeur du rectangle  recopier.
cpn_inner2:    moveq    #16,d2              ; D2.W: longueur du segment du groupe allant de l'abscisse D1
               sub.b    d1,d2               ;  l'abscisse 15 (abscisse maxi du groupe).
               cmp.w    (sp),d2             ; D2.W:  longueur du
               bls.s    cpn_lbl11           ; segment  recopier
               move.w   (sp),d2             ; (= min(D2,(SP))).
cpn_lbl11:     sub.w    d2,(sp)             ;Met  jour le nb de pixels de la ligne courante restant  recopier.
               bfextu   (a2){d7:d2},d3      ; Recopie le segment
               bfins    d3,(a0){d1:d2}      ; sur l'cran.
               add.w    d2,d7               ;Met  jour l'abscisse de la destination.
               lea      16(a0),a0           ;Groupe suivant.
               clr.b    d1                  ;D1.L = 0: le segment suivant commence  partir du 1er pixel du groupe.
               tst.w    (sp)                ; Boucle s'il reste au moins
               bne.s    cpn_inner2          ; 1 pixel  recopier.
               addq.l   #2,sp               ;Dpile ce qui servait de longueur restante.
               move.w   (sp)+,d1            ;Rcupre D1.
               adda.l   (a5),a2             ;Ligne suivante du bloc (A5).
               adda.l   d4,a1               ;Ligne suivante de la mmoire video.
               dbf      d0,cpn_outer2       ;Boucle (passe  la ligne suivante).
               move.w   (sp)+,d4            ;Rcupre D4.
               rts                          ;Retour.
cpn_bksp:      tst.b    d4                  ; Branch. s'il n'y a aucun caractre
               beq      cpn_waitmti         ; (BACKSPACE ne fait donc rien).
               bsr      beg_windupd         ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM...
               bmi      chg_pname5          ;Branch. si on est pass en mode PAUSE.
cpn_bksp2:     move.b   -(a4),d6            ;D6.B: caractre  effacer.
               subq.b   #1,d4               ;Dcr. la longueur du nom.
               bsr      cpn_extent          ;D0.W: largeur du caractre  effacer.
               moveq    #ynx1+8,d1          ; D1.W et D2.W: abscisse o est affiche
               moveq    #ynx1+8,d2          ; la partie visible du texte.
               add.w    (sp),d1             ;D1.W: abscisse du curseur (relative  la zone de travail) avant le backspace.
               sub.w    d0,(sp)             ;Met  jour l'abscisse du curseur relative  la fentre.
               add.w    (sp),d2             ;D2.W: abscisse du curseur (relative  la zone de travail) aprs le backspace.
               sub.w    d0,6(sp)            ;Met  jour l'abscisse du curseur par rapport au dbut du texte.
               moveq    #yny1+1,d0          ;
               swap     d1                  ; Efface  le
               move.w   #yny2-4,d1          ; caractre.
               bsr      frect0              ;
cpn_bsloop:    move.w   6(sp),d0            ; D0.W: dcalage actuel
               sub.w    (sp),d0             ; (en pixels).
               beq      cpn_wmti0           ;Branch. s'il n'y a pas de dcalage.
               cmpi.w   #yndx-16,(sp)       ; Branch. s'il ne reste pas assez de place pour
               bhi      cpn_wmti0           ; dcaler le texte de 16 pixels vers la droite.
;\6
;  Il faut dcaler le texte de 16 pixels vers la droite.

               lsr.w    #3,d0               ; A2: adr. du 1er pixel du
               lea      8-2(a5,d0.w),a2     ; bloc (A5)  recopier.
               moveq    #16,d0              ; Met  jour l'abscisse du curseur relative
               add.w    d0,(sp)             ;  la fentre: on ajoute 16.
               move.w   d4,-(sp)            ;Sauve D4 (on n'a pas besoin de sauver le mot de poids fort, car il restera nul).
               move.w   d6,-(sp)            ; A1: adr. du groupe de 16 pixels  contenant  le point situ
               move.w   #ynx2-8,d1          ;  droite  du point suprieur droit  du rectangle englobant
               move.w   4(a5),d6            ; le texte. D1.L: abscisse de ce point par rapport au groupe
               bsr      dsc_addrxy          ; de 16 pixels (de 0  15). D4.L: longueur, en octets, d'une
               move.w   (sp)+,d6            ; ligne de l'cran systme.
               move.w   6(a5),d0            ;D0.W: hauteur des caractres - 1.
               addq.l   #8,a1               ;On considre le plan 4.
               moveq    #16,d2              ; D2.B: longueur de la partie du rectangle
               sub.b    d1,d2               ; situe sur le 1er groupe de pixels.
cpn_bsline:    movea.l  a1,a0               ;A0: adr. du 1er groupe de la ligne courante (plan 4).
               tst.b    d1                  ;
               beq.s    cpn_lbl9a           ;
               bfextu   -16(a0){0:d1},d3    ;
               bfins    d3,(a0){0:d1}       ;
cpn_lbl9a:     lea      -16(a0),a0          ; Dcale la ligne courante du rectangle
               moveq    #yndx/16-3,d3       ; englobant le texte  de 16 pixels vers
cpn_bsinner:   move.w   -16(a0),(a0)        ; la droite.
               lea      -16(a0),a0          ;
               dbf      d3,cpn_bsinner      ;
               bfextu   -16(a0){d1:d2},d3   ;
               bfins    d3,(a0){d1:d2}      ;
               move.w   (a2),d3             ;D3.W: 16 pixels  stocker  gauche de la ligne ( cause du dcalage  droite).
               tst.b    d1                  ;
               beq.s    cpn_lbl9b           ;
               bfins    d3,(a0){0:d1}       ; Stocke les 16 pixels.
               lsr.w    d1,d3               ;
cpn_lbl9b:     bfins    d3,-16(a0){d1:d2}   ;
               adda.l   (a5),a2             ;Ligne suivante du bloc (A5).
               adda.l   d4,a1               ;Ligne suivante de la mmoire video.
               dbf      d0,cpn_bsline       ;Boucle (passe  la ligne suivante).
               move.w   (sp)+,d4            ;Rcupre D4.
               bra      cpn_bsloop          ;Branch. pour tester si le texte doit  nouveau tre dcal vers la droite.
cpn_extent:    pea      call_extent(pc)     ;--> D0.W: largeur du caractre D6.B.
cpn_chard6:    move.w   d6,(a6)             ;
               moveq    #1,d0               ; (A6).W: caractre. D0.W = 1.
               rts                          ;
cpn_char:      cmpi.b   #23,d4              ; Branch. s'il y a dj 23 caractres (on
               beq      cpn_waitmti         ; ne peut plus ajouter de caractre).
               bsr      beg_windupd         ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM...
               bmi      chg_pname5          ;Branch. si on est pass en mode PAUSE.
cpn_char2:     move.b   d6,(a4)+            ;Stocke le caractre.
               movea.l  sp,a3               ;A3: adr. o sont stockes les abscisses du curseur.
               pea      cpn_wmti0(pc)       ;Adr.  laquelle il faudra se brancher aprs disp_char.
disp_char:     addq.b   #1,d4               ;Incr. la longueur du nom.
disp_char1:    bsr.s    cpn_extent          ;D0.W: largeur du caractre  afficher.
               move.w   (a3),d1             ;D1.W: abscisse du curseur relative  la fentre.
               move.w   d1,d2               ; D2.W: abscisse relative  la fentre
               add.w    d0,d2               ; aprs affichage du caractre.
               cmpi.w   #yndx,d2            ; Branch. si cette abscisse est trop gde: on
               bhi.s    cpn_lbl5            ; doit dcaler le texte vers la gauche.
               move.l   a5,d7               ; Branch. si l'img contenant le texte n'a pas encore t sauve dans
               beq.s    disp_char2          ; un bloc de mmoire: on effectue alors seulement un affichage.
               move.w   d1,d3               ;Sauve l'abscisse du curseur relative  la fentre avant affichage dans D3.
               move.l   4(a3),d7            ;Sauve l'abscisse par rapport au dbut du texte dans D7.
               pea      cpn_lbl7(pc)        ;Adr. o il faut se brancher aprs disp_char2.
disp_char2:    move.w   d2,(a3)             ;Stocke la nouvelle abscisse.
               add.w    d0,6(a3)            ;Met  jour l'abscisse par rapport au dbut du texte.
               bsr.s    cpn_chard6          ;
               addi.w   #ynx1+8,d1          ; (A6).W: caractre  afficher.
               swap     d1                  ; D0.W = 1. D1.L: coord.
               move.w   #yny2-10,d1         ;
disp_text:     lea      ptsin(pc),a0        ;Adr. o il faut stocker les coord. du texte.
               move.l   xy0(pc),(a0)        ; Stocke les coord.
               add.l    d1,(a0)             ; absolues.
disp_text2:    lea      contrl(pc),a0       ;Adr. du tableau CONTRL.
               move.w   fgtext(pc),(a0)+    ;Code d'opration: v_ftext ou v_gtext.
               move.w   #1,(a0)             ;Taille de PTSIN.
               move.w   d0,4(a0)            ;Taille de INTIN.
               bra      hvdi                ;Affiche le texte.
;\6
;  On doit dcaler le texte vers la gauche, car il n'y a plus assez de place dans la fentre
;  pour afficher le caractre. On effectue donc un dcalage de 16 pixels vers la gauche.

cpn_lbl5:      move.l   a5,d0               ; Branch. si le bloc de mmoire devant
               bne.s    cpn_lbl6            ; contenir le texte a dj t cr.
               mvdi     vqt_fontinfo,0,0    ;Infos sur la fonte courante (et la hauteur courante).
               moveq    #23,d7              ;Longueur maxi du nom.
               mulu.w   ptsout(pc),d7       ;Multiplie par la largeur maxi d'un caractre.
               add.w    2(a3),d7            ;Ajoute la largeur du texte affich en plus du nom.
               addq.w   #7,d7               ; Conversion longueur en pixels
               lsr.w    #3,d7               ; --> longueur en octets.
               move.w   ptsout+18(pc),d0    ;Ecart de la Top line  la Base line.
               move.b   d0,d3               ;Sauve cette valeur.
               add.w    ptsout+2(pc),d0     ;Ajoute l'cart de la Bottom line  la Base line.
               move.w   d0,-(sp)            ;Sauve cette valeur (= hauteur - 1).
               addq.b   #1,d0               ;D0.W: hauteur des caractres.
               mulu.w   d7,d0               ;Multiplie par le nb de lignes.
               addq.w   #8,d0               ;Ajoute 8 (pour les donnes supplmentaires).
               bsr      test_malloc         ;Rserve de la mmoire pour le texte.
               movea.l  d0,a5               ;A5: adr. de ce bloc de mmoire.
               move.l   d7,(a5)+            ;Stocke la longueur d'une ligne en octets au dbut de ce bloc.
               moveq    #yny2-10,d0         ;Ordonne de la Base line relative  la zone de travail.
               sub.b    d3,d0               ; Stocke l'ordonne de la Top line
               move.w   d0,(a5)+            ; relative  la zone de travail.
               move.w   (sp)+,(a5)          ;Stocke la hauteur - 1 des caractres.
               subq.l   #6,a5               ;A5: adr. du bloc.
               move.w   (a3),d0             ; D0.W: abscisse du curseur. D1.W: abscisse o
               clr.w    d1                  ; est affich le texte (0). D7.L: 0 (on stocke
               moveq    #0,d7               ; le texte depuis la 1re colonne).
               bsr.s    cpn_lbl8            ;Recopie le texte dans le bloc.
cpn_lbl6:      subi.w   #16,(a3)            ;Enlve 16  l'abscisse du curseur relative  la fentre.
               move.w   d4,-(sp)            ;Sauve D4 (on n'a pas besoin de sauver le mot de poids fort, car il restera nul).
               bsr.s    cpn_addrxy          ;--> A1, D1.L, D4.L, D0.W.
               moveq    #16,d2              ; D2.B: longueur de la partie du rectangle
               sub.b    d1,d2               ; situe sur le 1er groupe de pixels.
cpn_shift16:   movea.l  a1,a0               ;A0: adr. du 1er groupe de la ligne courante (plan 4).
               bfextu   16(a0){d1:d2},d3    ;
               bfins    d3,(a0){d1:d2}      ;
               moveq    #yndx/16-3,d3       ;
cpn_inner0:    lea      16(a0),a0           ; Dcale  la ligne courante
               move.w   16(a0),(a0)         ; du rectangle englobant le
               dbf      d3,cpn_inner0       ; texte  de 16 pixels  vers
               tst.b    d1                  ; la gauche.
               beq.s    cpn_nxline          ;
               bfextu   32(a0){0:d1},d3     ;
               bfins    d3,16(a0){0:d1}     ;
cpn_nxline:    adda.l   d4,a1               ;Ligne suivante.
               dbf      d0,cpn_shift16      ;Boucle (passe  la ligne suivante).
               move.w   (sp)+,d4            ;Rcupre D4.
               move.l   #(ynx2-24)<<16+(yny1+1),d0  ; Efface le rectangle
               move.l   #(ynx2-9)<<16+(yny2-4),d1   ; restant  (16 pixels
               bsr      frect1                      ; de large).
               bra      disp_char1          ;Branch. pour afficher le caractre.
;\4
cpn_addrxy:    move.w   d6,-(sp)            ; A1: adr. du groupe de 16 pixels  contenant le point
               moveq    #ynx1+8,d1          ; suprieur gauche  du rectangle  englobant le texte.
               move.w   4(a5),d6            ; D1.L: abscisse de ce point par rapport au groupe de
               bsr      dsc_addrxy          ; 16 pixels  (de 0  15).  D4.L: longueur, en octets,
               move.w   (sp)+,d6            ; d'une ligne de l'cran systme.
               move.w   6(a5),d0            ;D0.W: hauteur des caractres - 1.
               addq.l   #8,a1               ;On considre le plan 4.
               rts                          ;Retour.
;\3
cpn_lbl7:      move.w   d3,d1               ;D1.W: abscisse du curseur relative  la fentre avant affichage.
               move.w   (a3),d0             ; D0.W: largeur
               sub.w    d1,d0               ; du caractre.
;\6
;  Recopie la partie du texte situe dans l'intervalle d'abscisses [D1,D1+D0[ (relatives  la fentre). Les donnes
;  source sont prises dans la mmoire video et sont stockes dans le bloc (A5)  l'abscisse D7.L (offset en bits).

cpn_lbl8:      movem.w  d0/d4/d6,-(sp)      ;Sauve les registres (pas besoin de sauver le poids fort de D4: il restera nul).
               addi.w   #ynx1+8,d1          ;D1.W: abscisse relative  la zone de travail.
               move.w   4(a5),d6            ; A1: adr. du groupe contenant le point suprieur gauche. D1.L: abscisse de
               bsr      dsc_addrxy          ; ce point par rapport au groupe  (de 0  15).  D4.L: longueur,  en octets,
               move.w   6(a5),d0            ; d'une ligne de l'cran systme. D0.W: hauteur des caractres - 1.
               addq.l   #8,a1               ;On considre le plan 4.
               lea      8(a5),a2            ;A2: adr. de la 1re ligne dans le bloc (A5).
cpn_outer1:    move.w   (sp),d6             ;D6: largeur du rectangle  recopier (ancien D0).
               movea.l  a1,a0               ;Adr. du 1er groupe de la ligne courante (plan 4).
               move.w   d1,-(sp)            ;Sauve D1.
cpn_inner1:    moveq    #16,d2              ; D2.W: longueur du segment du groupe allant de l'abscisse D1
               sub.b    d1,d2               ;  l'abscisse 15 (abscisse maxi du groupe).
               cmp.w    d2,d6               ; D2.W:  longueur du
               bcc.s    cpn_lbl10           ; segment  recopier
               move.w   d6,d2               ; (= min(D2,D6)).
cpn_lbl10:     sub.w    d2,d6               ;Met  jour le nb de pixels de la ligne courante restant  recopier.
               bfextu   (a0){d1:d2},d3      ; Recopie le
               bfins    d3,(a2){d7:d2}      ; segment.
               add.w    d2,d7               ;Met  jour l'abscisse de la destination.
               lea      16(a0),a0           ;Groupe suivant.
               clr.b    d1                  ;D1.L = 0: le segment suivant commence  partir du 1er pixel du groupe.
               tst.w    d6                  ; Boucle s'il reste au moins
               bne.s    cpn_inner1          ; 1 pixel  recopier.
               move.w   (sp)+,d1            ;Rcupre D1.
               sub.w    (sp),d7             ;Rcupre D7.
               adda.l   (a5),a2             ;Ligne suivante du bloc (A5).
               adda.l   d4,a1               ;Ligne suivante de la mmoire video.
               dbf      d0,cpn_outer1       ;Boucle (passe  la ligne suivante).
               movem.w  (sp)+,d0/d4/d6      ;Rcupre les registres.
               rts                          ;Retour.
;\6
;    Ŀ
;     Aide sur TETRHEX ou sur le fichier de rgle (HELP / shift-HELP) 
;    

test_help:     cmpi.w   #help<<8,d6         ; Branch. si ce n'est
               bne      test_return         ; pas la touche HELP.
               swap     d6                  ;D6.B: tat des touches spciales.
               tst.b    d6                  ; Branch. s'il y a au moins une
               bne.s    test_sh_help        ; touche spciale d'enfonce.
help_key:      move.l   alert_help+4(pc),d0 ;D0.L: ptr sur le nom du fichier d'aide, ou 0 s'il n'y a pas de fichier d'aide.
               beq.s    wait_multi3         ;Branch. s'il n'y a pas de fichier d'aide (on attend un nouvel vnement).
               movea.l  d0,a3               ; Charge le fichier.  N = 0  ssi le
               clr.w    d7                  ; fichier existe (dans ce cas, D6.L
               bsr      load_file           ; pointe sur le fichier).
               bmi      wait_multi          ;Branch. si le fichier n'existe pas.
               IFNE     REGISTERED
               moveq    #msg_helpt,d0       ; Envoie le msg
               bsr      send_msg0           ; msg_helpt.
               ENDIF
               movea.l  d6,a4               ;A4: ptr sur le texte  afficher.
               moveq    #'',d5             ;D5.B: caractre de soulignement.
               move.l   d6,-(sp)            ;Sauve l'adr. du fichier d'aide.
               bsr.s    disp_help           ;Affiche l'aide.
               move.l   (sp)+,d0            ; Libre le bloc de mmoire
               bsr      call_mfree2         ; pris par le fichier.
               bra      game4               ;Retour au menu.
;\4
test_sh_help:  subq.b   #3,d6               ; Branch. si une autre touche spciale
               bhi      tst_leftb           ; qu'une touche shift est enfonce.
shift_help:    movea.l  rul_ptr(pc),a3      ;A3: ptr sur le fichier de rgle.
               move.l   rul.text(a3),d0     ;D0.L: offset sur le texte.
wait_multi3:   beq      wait_multi          ;Branch. s'il n'y a pas de texte.
               adda.l   d0,a3               ;A3: ptr sur les textes (1re langue).
               IFNE     REGISTERED
               moveq    #msg_helpr,d0       ; Envoie le msg
               bsr      send_msg0           ; msg_helpr.
               ENDIF
               moveq    #127,d1             ;D1.L: rang temp. de la langue choisie pour l'aide, dans la liste des langues.
shhelp_outer:  move.b   4(a3),d0            ;D0.B: code de la langue courante.
               lea      langlist(pc),a0     ;
               movea.l  a0,a1               ;
shhelp_inner:  tst.b    (a0)                ; A0:  rang  de  la langue  courante
               bmi.s    shhelp_lbl1         ; (0: 1re langue), ou nb de langues
               cmp.b    (a0)+,d0            ; s'il la langue courante  n'est pas
               bne.s    shhelp_inner        ; dans la liste des prfrences.
               subq.l   #1,a0               ;
shhelp_lbl1:   suba.l   a1,a0               ;
               cmp.l    a0,d1               ; Branch. si la langue courante a un rang   la langue
               bls.s    shhelp_lbl2         ; de + petit rang parmi les langues dj parcourues.
               move.l   a0,d1               ;D1.L: nouveau rang.
               lea      7(a3),a4            ;A4: ptr sur le texte.
shhelp_lbl2:   adda.l   (a3),a3             ;A3: langue suivante.
               tst.l    (a3)                ; Branch. s'il reste encore
               bne.s    shhelp_outer        ; des langues.
               move.b   -2(a4),d5           ;D5.B: caractre de soulignement.
               pea      game4(pc)           ;Aprs disp_help, il faudra retourner au menu.
;\6
;  Affiche l'aide. A4 pointe sur le texte (suivi d'un octet nul). D5.B: caractre de soulignement.

disp_help:     move.w   d5,-(sp)            ; Sauve  les
               move.l   a4,-(sp)            ; registres.
               bsr      clr_colors1         ;Efface progressivement l'cran.
               movea.l  (sp)+,a3            ; Rcupre les registres.
               move.w   (sp)+,d5            ; A4 --> A3.
               clr.w    d7                  ;D7.W contiendra la largeur du texte.
               moveq    #0,d6               ;D6.L contiendra le nb de lignes.
               movea.l  a3,a0               ;A0 pointe sur le texte.
dhlp_outer1:   clr.b    d0                  ;D0.B contiendra la largeur de la ligne.
               moveq    #-1,d1              ;D1.B: drapeau. Non nul ssi il s'agit d'une ligne de soulignement (ou ligne vide).
               bra.s    dhlp_lbl1           ;Branch. pour lire le 1er caractre de la ligne.
;\3
dhlp_error:    moveq    #13,d7              ;D7.W = 13: code de retour.
               movea.l  alert_bhlp+4(pc),a5 ;Texte de la bote d'alerte  afficher.
               bra      alert4              ;Affiche une bote d'alerte, et fin du prg.
;\4
dhlp_inner1:   addq.b   #1,d0               ;Incr. la largeur de la ligne.
               bmi.s    dhlp_error          ;Erreur si la ligne est trop longue ( 128).
               cmpi.b   #' ',d2             ;
               beq.s    dhlp_lbl1           ; Erreur si le caractre n'est pas affichable
               bcs.s    dhlp_error          ; (code ASCII < 32). Si le caractre n'est ni
               cmp.b    d2,d5               ; un espace, ni le caractre de soulignement,
               beq.s    dhlp_lbl1           ; alors D1.B <> 0.
               clr.b    d1                  ;
dhlp_lbl1:     move.b   (a0)+,d2            ;D2.B: prochain caractre.
               beq.s    dhlp_error          ;Erreur s'il est nul: le texte doit se terminer par un CR/LF.
               cmpi.b   #cr,d2              ; Boucle si ce n'est pas CR (ce
               bne.s    dhlp_inner1         ; n'est pas une fin de ligne).
               cmp.b    d0,d7               ;
               bcc.s    dhlp_lbl3           ; Met  jour la largeur du texte.
               move.b   d0,d7               ;
dhlp_lbl3:     tst.b    d1                  ;
               beq.s    dhlp_lbl4           ; Si ce n'est pas une ligne de soulignement ou si
               cmp.b    -2(a0),d5           ; la ligne ne se termine pas  par le caractre de
               beq.s    dhlp_lbl5           ; soulignement, incr. le nb de lignes.
dhlp_lbl4:     addq.l   #1,d6               ;
dhlp_lbl5:     cmpi.b   #lf,(a0)+           ; Erreur si le caractre
               bne.s    dhlp_error          ; suivant n'est pas LF.
               tst.b    (a0)                ; Boucle s'il reste encore
               bne.s    dhlp_outer1         ; des caractres.
;\4
;  On va rserver un bloc de mmoire,  qui contiendra un tableau dont chaque lment occupe 8 octets et est associ  une ligne
;  du texte. Voici la struct. d'un lment:
;   _ 1 mot long: adr. de la ligne.
;   _ 1 octet: ngatif si c'est une ligne vide (ou ligne de soulignement ne se terminant pas par le caractre de soulignement),
;              nul si c'est une ligne non vide non souligne,  strictement positif si c'est une ligne souligne  (partiellement
;              ou totalement).
;   _ 1 octet: nul ssi la ligne est justifie (i.e. sa longueur est =  la largeur du texte).   N'ont un sens que si
;   _ 1 octet: non nul ssi la ligne est indente (contient le nb d'espaces situs  gauche).    le  1er octet  n'est
;   _ 1 octet: non nul ssi il y a une marge droite (contient le nb d'espaces situs  droite).  pas ngatif.
;\4
               move.l   d6,d0               ;
               lsl.l    #3,d0               ; Rserve un bloc de mmoire (8 octets
               bsr      test_malloc         ; par ligne). A5: adr. du bloc.
               movea.l  d0,a5               ;
               movea.l  a3,a0               ;A0 pointe sur le texte.
               movea.l  a5,a1               ;A1 pointe sur le tableau  remplir.
dhlp_outer2:   movea.l  a0,a2               ;Sauve le ptr sur le dbut de la ligne.
               move.b   d7,d0               ;D0.B contiendra 0 ssi la longueur de la ligne est =  la largeur du texte.
               moveq    #-1,d1              ;D1.B: drapeau. Non nul ssi il s'agit d'une ligne de soulignement (ou ligne vide).
               moveq    #0,d4               ;D4.L: contiendra les donnes sur les marges gauche et droite.
               bra.s    dhlp_lbl9           ;Branch. pour lire le 1er caractre de la ligne.
dhlp_inner2:   subq.b   #1,d0               ;Dcr. le nb max de caractres restants.
               cmpi.b   #' ',d2             ; Branch. si le caractre
               bne.s    dhlp_lbl7           ; n'est pas un espace.
               addq.b   #1,d4               ;Incr. le nb d'espaces (dans la squence d'espaces conscutifs).
               bra.s    dhlp_lbl9           ;Branch. pour lire le caractre suivant.
dhlp_lbl7:     tst.l    d4                  ; S'il s'agit du premier caractre <> de l'espace,  on
               bmi.s    dhlp_lbl8           ; fait un NOT sur la longueur de la squence d'espaces
               not.w    d4                  ; (ventuellement vide) --> mot ngatif,  et on met ce
               swap     d4                  ; mot dans le poids fort de D4.
dhlp_lbl8:     clr.b    d4                  ;Annule la longueur de la squence d'espaces courante.
               cmp.b    d2,d5               ; Annule D1.B  (--> ce n'est pas une ligne
               beq.s    dhlp_lbl9           ; de soulignement) si le caractre courant
               clr.b    d1                  ; n'est pas le caractre de soulignement.
dhlp_lbl9:     move.b   (a0)+,d2            ;D2.B: prochain caractre.
               cmpi.b   #cr,d2              ; Boucle si ce n'est pas CR (ce
               bne.s    dhlp_inner2         ; n'est pas une fin de ligne).
               tst.b    d1                  ; Branch. si ce n'est pas une
               beq.s    dhlp_lbl12          ; ligne de soulignement.
               tst.l    d4                  ; Si c'est une vraie ligne de soulign., i.e. si la ligne contient au moins un ca-
               bpl.s    dhlp_lbl11          ; ractre de soulign. (i.e. s'il n'y a pas que des esp.),  on fait passer le flag
               addq.b   #1,-4(a1)           ; de soulign. de la ligne prc. de 0  1 (si le texte est correctement crit).
dhlp_lbl11:    cmp.b    -2(a0),d5           ; Branch. s'il ne s'agit pas d'une nouvelle ligne, i.e. si
               beq.s    dhlp_lbl13          ; la ligne se termine par le caractre de soulignement.
dhlp_lbl12:    move.l   a2,(a1)+            ;Stocke l'adr. de la ligne dans le tableau.
               move.b   d1,(a1)+            ;Stocke -1 si la ligne est vide (ligne de soulignement), 0 sinon.
               move.b   d0,(a1)+            ;Stocke le flag de justification (nul ssi la ligne est justifie).
               swap     d4                  ;
               not.b    d4                  ; Stocke la taille de la marge gauche (indentation).
               move.b   d4,(a1)+            ;
               swap     d4                  ; Stocke la taille de
               move.b   d4,(a1)+            ; la marge droite.
dhlp_lbl13:    addq.l   #1,a0               ;Saute le LF.
               tst.b    (a0)                ; Boucle s'il reste encore
               bne.s    dhlp_outer2         ; des caractres.
;\4
               moveq    #0,d4               ;D4.L: n de la 1re ligne  afficher.
dhlp_disp1:    move.w   d7,-(sp)            ;Sauve D7.
               move.l   d6,-(sp)            ;Sauve D6.
dhlp_disp2:    bsr      wd_update           ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM.
               lea      intin(pc),a6        ;A6: adr. du tableau INTIN.
               moveq    #hcolor,d0          ;Couleur du titre et du texte (seul le bit 4 est nul).
               bsr      stitle              ;Slectionne la fonte, l'alignement, le mode d'criture, la hauteur et la couleur.
               movea.l  alert_hlpt+4(pc),a0   ;
               move.l   #(windw/2)<<16+64,d1  ; Affiche "Aide". Alignement: gauche, bottom.
               bsr      cdtxt_lbot            ;
               move.w   hfontid(pc),d7      ; Slectionne la fonte de n *hfontid
               bsr      set_font1           ; si SpeedoGDOS est install.
               moveq    #13,d7              ; Fixe la hauteur des
               bsr      char_height         ; caractres  13.
               lea      RGB+hcolor*4(pc),a0 ;
               move.l   col_help(pc),(a0)   ; --> couleur du texte.
               bsr      chg_f2lcolor        ;
               move.l   (sp)+,d6            ;Rcupre D6.
               move.w   (sp)+,d7            ;Rcupre D7.
;\6
;  D4.L: n de la 1re ligne affiche.
;  D5.B: caractre de soulignement.
;  D6.L: nb de lignes.
;  D7.W: largeur du texte (0  127).
;  A5: adr. du tableau contenant les donnes sur les lignes (cf + haut).
;  A6: adr. du tableau INTIN.
;\4
               moveq    #127,d0             ;D0.L (sign)  hlpn.
dhlp_text:     movem.l  d4-d6/a5,-(sp)      ;Sauve D4, D5, D6 et A5.
               move.w   d7,-(sp)            ;Sauve D7.
               clr.b    d5                  ;
               move.l   d0,d6               ; D5.B = 0  si D0 est positif,
               bpl.s    dhlp_lbl15          ; D5.B = -1 si D0 est ngatif.
               not.b    d5                  ; D6.L = abs(D0).
               neg.l    d6                  ;
dhlp_lbl15:    moveq    #hlpn,d0            ;
               cmp.l    d0,d6               ; D6.W: nb de nouvelles
               bls.s    dhlp_nlines         ; lignes  afficher.
               move.w   d0,d6               ;
;\6
;  On doit dplacer les lignes en commun (vers le haut ou vers le bas, suivant la valeur de D5.B).

dhlp_nlines:   bsr      dsc_addrwin         ;--> D0, D1, D2, A1.
               addq.l   #8,a1               ;On se place sur le plan 4 (seul plan  modifier).
               moveq    #hlpf,d3            ; Si on doit dplacer les lignes vers le haut (i.e. si D5.B = -1),
               tst.b    d5                  ; alors D2.L = largeur d'une ligne,  et D3.W = hlpf (1re ligne de
               bne.s    dhlp_lbl16          ; la zone rserve au texte).  Si on doit dplacer les lignes vers
               neg.l    d2                  ; le bas  (i.e. si D5.B = 0),  alors D2.L = - largeur d'une ligne,
               move.w   #-hlpl,d3           ; et D3.W = -hlpl (dernire ligne de la zone rserve au texte).
dhlp_lbl16:    muls.w   d2,d3               ; A1: adr. de la 1re ou de la dernire ligne (suivant la valeur de D5.B),
               adda.l   d3,a1               ; i.e. adr. de destination de la ligne  dplacer en premier.
               move.w   d6,d3               ;
               lsl.w    #4,d3               ; A0: adr. (source) de la ligne
               muls.w   d2,d3               ;  dplacer en premier.
               lea      (a1,d3.l),a0        ;
               moveq    #hlpn,d3            ;
               sub.b    d6,d3               ; D3.W: nb de lignes  dplacer.
               lsl.w    #4,d3               ;
               moveq    #16,d4              ;D4.L = 16 (distance entre 2 mots successifs d'un mme plan).
               bra.s    dhlp_dbf
dhlp_outer3:   bfextu   (a0){d0:d1},d7      ;
               bfins    d7,(a1){d0:d1}      ;
               lea      16(a0),a2           ;
               lea      16(a1),a3           ;
               moveq    #windw/16-2,d7      ;
dhlp_inner3:   move.w   (a2),(a3)           ;
               adda.l   d4,a2               ; Recopie une ligne.
               adda.l   d4,a3               ;
               dbf      d7,dhlp_inner3      ;
               tst.b    d0                  ;
               beq.s    dhlp_lbl17          ;
               bfextu   (a2){0:d0},d7       ;
               bfins    d7,(a3){0:d0}       ;
dhlp_lbl17:    adda.l   d2,a0               ;Adr. de la prochaine ligne  dplacer.
               adda.l   d2,a1               ;Adr. de la prochaine ligne de destination.
dhlp_dbf:      dbf      d3,dhlp_outer3      ;Boucle tant qu'il reste des lignes  dplacer.
               move.w   d6,d3               ; D3.W: nb de lignes
               lsl.w    #4,d3               ;  effacer.
dhlp_outer4:   bfset    (a1){d0:d1}         ;
               lea      16(a1),a3           ;
               moveq    #windw/16-2,d7      ;
dhlp_inner4:   move.w   #-1,(a3)            ;
               adda.l   d4,a3               ; Efface une ligne.
               dbf      d7,dhlp_inner4      ;
               tst.b    d0                  ;
               beq.s    dhlp_lbl18          ;
               bfset    (a3){0:d0}          ;
dhlp_lbl18:    adda.l   d2,a1               ;Adr. de la prochaine ligne  effacer.
               subq.w   #1,d3               ; Boucle tant qu'il reste
               bne.s    dhlp_outer4         ; des lignes  effacer.
               move.w   (sp)+,d7            ;Rcupre D7.
               move.l   (sp),d4             ;Rcupre D4, mais on le laisse dans la pile.
;\8
;  On doit afficher les nouvelles lignes.
;    _ D4, D5, D6 et A5 ont t sauvs dans la pile (ils seront dpils  la fin de l'affichage).
;    _ D4.L: 1re ligne affiche.
;    _ D5.B: -1 si les lignes doivent tre affiches en bas de l'cran, 0 si elles doivent tre affiches en haut.
;    _ D6.W: nb de lignes  afficher.
;    _ D7.W: largeur du texte (0  127).
;    _ A5: ptr sur le tableau.
;    _ A6: INTIN.
;\4
               cmp.w    10(sp),d6           ; Si D6.W (nb de lignes  afficher)  est > au nb de lignes du
               bls.s    dhlp_lbl19          ; texte, on remplace l'ancienne valeur par le nb de lignes du
               move.w   10(sp),d6           ; texte (on affiche le texte en entier).
dhlp_lbl19:    subq.w   #1,d6               ;D6.W: nb de lignes  afficher - 1 (compteur pour le DBF).
               lea      (a5,d4.l*8),a4      ;A4: ptr sur l'lment du tableau correspondant  la 1re ligne affiche.
               moveq    #hlpf+15,d4         ;D4.W: ordonne de la 1re ligne affiche.
               tst.b    d5                  ; Branch. si les nouvelles lignes doivent tre affiches en haut (i.e.
               beq.s    dhlp_outer5         ; si la 1re nouvelle ligne  afficher est la 1re ligne affiche).
               moveq    #hlpn-1,d1          ; D1.L: nb de lignes
               sub.w    d6,d1               ; dj affiches.
               lsl.w    #3,d1               ;Multiplie D1.L par 8 (taille d'un lment du tableau).
               adda.l   d1,a4               ;A4: ptr sur l'lm. du tableau correspondant  la 1re nouvelle ligne  afficher.
               add.w    d1,d1               ;D1.L = 16 x nb de lignes dj affiches.
               add.w    d1,d4               ;D4.W: ordonne de la 1re nouvelle ligne  afficher.
;\7
;  Au dbut de la boucle ( chaque passage):
;    _ D4.W: ordonne o on doit afficher la ligne courante.
;    _ D6.W: nb de lignes restant  afficher - 1 (compteur pour le DBF).
;    _ D7.W: largeur du texte (0  127).
;    _ A4: ptr sur l'lment du tableau correspondant  la ligne courante.
;    _ A5: ptr sur le tableau.
;    _ A6: INTIN.
;\4
dhlp_outer5:   move.b   7(sp),d5            ;D5.B: caractre de soulignement.
               movea.l  (a4)+,a3            ;A3: ptr sur le texte de la ligne (n'a de sens que si la ligne est non vide).
               tst.b    (a4)                ; Branch. si la ligne
               bmi      dhlp_nxline         ; est vide.
               moveq    #hlpm,d3            ;D3.W: marge gauche.
               move.w   #hlpw,d2            ;D2.W: largeur de la zone rserve au texte.
               lea      2(a4),a0            ;A0 = A4 + 2 (A4 ne doit pas tre modifi).
               moveq    #0,d1               ; D0.W et D1.L: taille, en
               move.b   (a0)+,d1            ; caractres,  de la marge
               move.w   d1,d0               ; gauche supplmentaire.
               mulu.w   d2,d0               ; D0.W: taille, en pixels, de la
               divu.w   d7,d0               ; marge gauche supplmentaire.
               add.w    d0,d3               ;D3.W: taille, en pixels, de la marge gauche (par rapport  la zone de travail).
               move.w   d7,d0               ;
               sub.b    (a0),d0             ; D2.W: largeur restante (= largeur totale - largeur
               sub.b    -(a0),d0            ; des marges), en pixels; cette valeur ne dpend pas
               mulu.w   d0,d2               ; du nb de caractres de la ligne.
               divu.w   d7,d2               ;
               adda.l   d1,a3               ;A3: adr. du 1er caractre de la ligne diffrent de l'espace.
               movea.l  a3,a2               ;
dhlp_innr5a:   cmpi.b   #cr,(a2)+           ; A2: adr. du LF (de fin de ligne).
               bne.s    dhlp_innr5a         ;
               subq.l   #1,a2               ;A2: adr. du CR.
               movea.l  a2,a1               ;A1: adr. du CR.
dhlp_innr5b:   cmpi.b   #' ',-(a2)          ; A2: adr. du dernier caractre de la
               beq.s    dhlp_innr5b         ; ligne qui n'est pas un espace.
;\4
;    On va afficher une ligne (qui n'est pas vide).  Pour cela, on va dcouper la ligne en plusieurs morceaux, appels
;    sous-chanes (alternance des parties soulignes et non soulignes); si la ligne n'est pas du tout souligne, il y
;    aura une seule sous-chane. A chaque sous-chane, on associe un bloc de 8 octets.  On va empiler un mot long nul,
;    puis chaque bloc de 8 octets (un bloc ne commence jms par un mot long nul). Voici la struct. d'un bloc:
;      _ 1 mot long: ptr sur la sous-chane.
;      _ 1 mot: nb de caractres - 1. Ce mot est invers (NOT) si la sous-chane est souligne (--> mot ngatif).
;      _ 1 mot: largeur,  en pixels,  du rectangle o on devra afficher la sous-chane (mot positif) si cette-dernire
;        est justifie.  NOT(largeur) (mot ngatif) si elle ne doit pas tre justifie (alignement  gauche);  dans ce
;        cas,  la largeur peut tre incorrecte s'il s'agit du dernier bloc  (en particulier, pour une ligne non justi-
;        fie et non souligne, la largeur sera la mme que pour une ligne justifie, mais ne servira  rien).
;\4
;    Registres:
;      _ D1.W: nb de caractres dans la marge gauche.
;      _ D2.W: largeur de la zone rserve  la ligne courante, marges non comprises.
;      _ D3.W: abscisse relative o il faut afficher la ligne ( partir du caractre (A3)).
;      _ D4.W: ordonne o on doit afficher la ligne courante.
;      _ D5.B: caractre de soulignement.
;      _ D6.W: nb de lignes restant  afficher - 1 (compteur pour le DBF).
;      _ D7.W: largeur du texte (0  127).
;      _ A0: ptr sur l'lment courant du tableau + 5.
;      _ A1: adr. du CR de la ligne courante.
;      _ A2: adr. du dernier caractre de la ligne qui n'est pas un espace.
;      _ A3: adr. du 1er caractre de la ligne courante diffrent de l'espace (i.e. 1er caractre suivant la marge gauche).
;      _ A4: ptr sur l'lment courant du tableau + 4.
;      _ A5: ptr sur le tableau.
;      _ A6: INTIN.
;\4
               clr.l    -(sp)               ;Empile un ptr nul (indiquera la fin des donnes que l'on va empiler).
               tst.b    (a4)                ; Branch. si la ligne n'est pas souligne (ni partiellement, ni totalement):
               beq.s    dhlp_lbl21          ; A1 pointe sur un CR (quivaut  une ligne de soulignement vide).
               addq.l   #1,a1               ;A1 pointe sur le LF (caract. prcdant le 1er caract. de la ligne de soulign.).
               move.w   d1,d0               ;
dhlp_innr5c:   cmpi.b   #cr,(a1)+           ; A1 pointe sur le caractre de la ligne de soulignement situ sous le
               dbeq     d0,dhlp_innr5c      ; 1er caractre de la ligne courante qui n'est pas un espace,  sauf si
               bne.s    dhlp_lbl21          ; on a rencontr un CR auparavant, auquel cas A1 pointe sur ce CR.
               subq.l   #1,a1               ;
dhlp_lbl21:    clr.w    d1                  ;D1.W contiendra la somme des longueurs en pixels des sous-chanes (non justifies).
;\6
;      Lit une sous-chane.

dhlp_innr5d:   subq.l   #8,sp               ;Rserve 8 octets pour les donnes correspondant  la sous-chane courante.
               move.l   a3,(sp)             ;Stocke le ptr sur la sous-chane.
               movem.w  d1/d6/d7,-(sp)      ;Sauve les registres D1, D6 et D7.
               moveq    #' ',d6             ;D6.B: code ASCII de l'espace.
               moveq    #cr,d7              ;D7.B: code ASCII du CR (fin de ligne).
               moveq    #-1,d0              ;D0.W contiendra le nb de caractres - 1 de la sous-chane.
               movea.l  a6,a0               ;A0: adr. du tableau INTIN (o on doit stocker les caractres pour extent).
               moveq    #' ',d1             ; Si la sous-chane courante commence
               cmp.b    (a3),d1             ; par un espace, alors elle n'est pas
               beq.s    dhlp_loop           ; souligne: D1.B = espace.
               move.b   (a1),d1             ;D1.B: caract. de la ligne de soulign., situ sous le 1er caract. de la ss-chn.
               cmp.b    d1,d5               ; Si c'est le caract. de soulignement, alors D1.B = caract. de
               beq.s    dhlp_loop           ; soulignement (sous-chane souligne).  Sinon,  D1.B = espace
               moveq    #' ',d1             ; (sous-chane non souligne).
dhlp_loop:     cmp.b    (a1),d1             ; Branch. si le prochain caractre de la ligne de soulignement est = D1.B (le
               beq.s    dhlp_lbl24          ; prochain caractre de la ligne courante fera partie de la sous-chane).
               cmp.b    (a3),d6             ; Branch. si le prochain caract. de la ligne courante est un espace (ce caract.
               beq.s    dhlp_lbl22          ; fera partie de la sous-chane, mais pourra tre retir par la suite).
               cmp.b    (a1),d7             ; Fin de la sous-chane, sauf si la
               bne.s    dhlp_lbl23          ; ligne de soulignement n'a plus de
               cmp.b    d1,d6               ; caractre  et  si  la sous-chane
               bne.s    dhlp_lbl23          ; courante n'est pas souligne.
dhlp_lbl22:    cmp.b    (a1),d7             ; A1 pointe sur le caractre suivant de la ligne de
               beq.s    dhlp_lbl25          ; soulignement,  sauf  s'il n'y a plus de caractre
dhlp_lbl24:    addq.l   #1,a1               ; (A1 pointe alors sur le CR).
dhlp_lbl25:    cmp.b    (a3),d6             ;
               bne.s    dhlp_wrchar         ;
               cmpa.l   a0,a6               ;
               beq.s    dhlp_wrchar         ; Stocke le caractre courant dans INTIN et incr.
               cmp.b    -1(a0),d6           ; D0.W,  sauf si c'est un espace et si le dernier
               beq.s    dhlp_nxchar         ; caractre ventuel stock est aussi un espace.
dhlp_wrchar:   clr.b    (a0)+               ;
               move.b   (a3),(a0)+          ;
               addq.w   #1,d0               ;
dhlp_nxchar:   addq.l   #1,a3               ;A3 pointe sur le caractre suivant.
               cmpa.l   a2,a3               ; Boucle si on n'a pas dpass le dernier caractre
               bls.s    dhlp_loop           ; de la ligne diffrent de l'espace.
;\6
;      Sous-chane termine. Si la sous-chane est souligne, on retire l'espace
;      situ  la fin (il fera partie de la sous-chane suivante).

dhlp_lbl23:    cmp.b    d1,d5               ; Branch. si la sous-chane
               bne.s    dhlp_lbl26          ; n'est pas souligne.
               cmp.b    -(a0),d6            ; Branch. si le dernier caractre
               bne.s    dhlp_lbl26          ; stock n'est pas un espace.
               subq.w   #1,d0               ;Retire l'espace situ  la fin (1 seul espace est stock dans INTIN).
               subq.l   #1,a3               ;Revient sur le dernier espace lu.
               cmp.b    (a1),d7             ; Revient sur le dernier caractre lu de
               beq.s    dhlp_lbl26          ; la ligne de soulignement, sauf si on a
               subq.l   #1,a1               ; atteint la fin de cette ligne.
dhlp_lbl26:    move.w   d0,10(sp)           ;Stocke le nb de caractres - 1 de la sous-chane.
               cmp.b    d1,d5               ;
               bne.s    dhlp_lbl27          ; Si la sous-chane est souligne, on inverse ce mot.
               not.w    10(sp)              ;
dhlp_lbl27:    addq.w   #1,d0               ;D0.W: nb de caractres de la sous-chane.
               movem.l  d2/a1/a2,-(sp)      ; D0.W: longueur, en pixels, de
               bsr      call_extent         ; la sous-chane  (si  celle-ci
               movem.l  (sp)+,d2/a1/a2      ; n'est pas justifie).
               movem.w  (sp)+,d1/d6/d7      ;Rcupre les registres D1, D6 et D7.
               move.w   d0,6(sp)            ;Stocke la longueur de la sous-chane non justifie (sera modifie + tard).
               add.w    d0,d1               ;Met  jour D1.W (somme des longueurs des sous-chanes non justifies).
               cmpa.l   a2,a3               ; Branch. tant qu'on n'a pas atteint la fin de la ligne
               bls      dhlp_innr5d         ; courante (passe  la sous-chane suivante).
;\6
;      On va mettre  jour le 4me mot de chaque bloc.

               movea.l  sp,a3               ;A3: adr. du dernier bloc (situ le + en bas).
               tst.b    1(a4)               ; Branch. si la ligne
               beq.s    dhlp_lbl28          ; est justifie.
               cmp.w    d1,d2               ; Branch. si la somme des longueurs des sous-chanes est >  la largeur
               bcs.s    dhlp_lbl28          ; de la zone rserve  la ligne: la ligne sera alors justifie.
dhlp_innr5e:   addq.l   #6,a3               ; Aucune des sous-chanes  n'est
               not.w    (a3)+               ; justifie;  on prend  donc  le
               tst.l    (a3)                ; complment (ngatif) des 4mes
               bne.s    dhlp_innr5e         ; mots de chaque bloc.
               bra.s    dhlp_lbl29          ;Branch. pour afficher les sous-chanes.
;\4
dhlp_lbl28:    clr.w    d5                  ;D5.W contiendra la somme des longueurs des sous-chanes justifies.
dhlp_innr5f:   movea.l  (a3)+,a0            ;
               move.w   (a3)+,d0            ; Branch.  dhlp_lbl36 si la sous-chane
               bpl.s    dhlp_lbl35          ; ne contient pas d'espace: dans ce cas,
               not.w    d0                  ; la sous-chane  ne sera pas justifie,
dhlp_lbl35:    cmpi.b   #' ',(a0)+          ; car les espaces de justification ne se
               dbeq     d0,dhlp_lbl35       ; situeront qu'entre les mots.
               bne.s    dhlp_lbl36          ;
               move.w   (a3),d0             ; Multiplie  la longueur  de la sous-chane non justifie
               mulu.w   d2,d0               ; par la largeur de la zone rserve  la ligne courante,
               divu.w   d1,d0               ; et divise  par la somme  des longueurs des sous-chanes
               move.w   d0,(a3)             ; non justifies.
dhlp_lbl36:    add.w    (a3)+,d5            ;Met  jour D5 (somme des longueurs des sous-chanes justifies).
               tst.l    (a3)                ; Boucle tant qu'il
               bne.s    dhlp_innr5f         ; reste des blocs.
               sub.w    d5,d2               ; Corrige de 4me mot du bloc corresp.  la 1re ss-chn, de faon  ce que la somme
               add.w    d2,-2(a3)           ; des longueurs des ss-chn justifies soit =  la largeur de la zone rserve.
;\6
;      Affiche les sous-chanes.

dhlp_lbl29:    lea      4(a3),a5            ;A5: ptr de pile avant l'empilement du ptr nul et des blocs.
dhlp_innr5g:   move.w   -(a3),d5            ;D5.W: longueur en pixels de la sous-chane, ou son complment si non justifie.
               move.w   -(a3),d0            ;D0.W: nb de caractres - 1, ou son complment si la sous-chane est souligne.
               bpl.s    dhlp_lbl30          ;Branch. si la sous-chane n'est pas souligne.
               move.w   #underline,(a6)     ; Effet: sou-
               intvdi   vst_effects         ; lignement.
               move.w   (a3),d0             ; D0.W: nb de caractres
               not.w    d0                  ; - 1.
dhlp_lbl30:    movea.l  -(a3),a0            ;A0: ptr sur la sous-chane.
               movea.l  a6,a1               ;A1: adr. du tableau INTIN.
               tst.w    d5                  ; Si la sous-chane est justifie,  on stocke 2 flags
               bmi.s    dhlp_lbl31          ; dans INTIN (avant le texte): wflag = 1 et cflag = 0
               move.w   #1,(a1)+            ; (justification entre les mots,  mais pas  entre les
               clr.w    (a1)+               ; caractres).
dhlp_lbl31:    move.w   d0,d1               ;
               clr.b    d2                  ;
dhlp_oinner:   clr.b    (a1)+               ;
               cmpi.b   #' ',d2             ;
               bne.s    dhlp_lbl34          ; Stocke la sous-chane dans INTIN, en
dhlp_iinner:   cmp.b    (a0)+,d2            ; transformant les squences d'espaces
               beq.s    dhlp_iinner         ; en un seul espace.
               subq.l   #1,a0               ;
dhlp_lbl34:    move.b   (a0)+,d2            ;
               move.b   d2,(a1)+            ;
               dbf      d1,dhlp_oinner      ;
               lea      ptsin(pc),a0        ;A0: adr. du tableau PTSIN.
               move.l   xy0(pc),(a0)        ;
               add.w    d3,(a0)+            ; Stocke les coord. absolues.
               add.w    d4,(a0)+            ;
               tst.w    d5                  ; Branch. si la sous-chane
               bmi.s    dhlp_lbl32          ; n'est pas justifie.
               pea      dhlp_lbl33(pc)      ;Adr.  laquelle il faut se brancher aprs text_justif.
text_justif:   move.w   d5,(a0)+            ;Stocke cette longueur (pour la justification).
               clr.w    (a0)                ;Stocke 0.
               addq.w   #3,d0               ;D0.W: nb de caractres + 2 (2 flags de justification).
               lea      contrl(pc),a0       ;Adr. du tableau CONTRL.
               move.w   #gdp,(a0)+          ;Code d'opration: gdp (Generalized Drawing Primitives).
               move.w   #2,(a0)             ;Taille de PTSIN.
               move.w   d0,4(a0)            ;Taille de INTIN.
               move.w   #v_justified,8(a0)  ;Sous-opcode: v_justified.
               bra      hvdi                ;Affiche le texte (justifi).
dhlp_lbl32:    addq.w   #1,d0               ;D0.W: nb de caractres.
               bsr      disp_text2          ;Affiche le texte (non justifi).
               not.w    d5                  ;D5.W: longueur de la sous-chane.
dhlp_lbl33:    add.w    d5,d3               ;Abscisse o il faudra afficher la sous-chane suivante.
               clr.w    (a6)                ; Pas d'effet (annule le soulignement
               intvdi   vst_effects         ; ventuel).
               cmpa.l   a3,sp               ; Boucle s'il reste des sous-chanes
               bne      dhlp_innr5g         ;  afficher.
               movea.l  a5,sp               ;Libre le tableau et le ptr nul.
dhlp_nxline:   addi.w   #hlpy,d4            ;Ordonne de la ligne suivante.
               addq.l   #4,a4               ;Ptr sur l'lment du tableau correspondant  la ligne suivante.
               dbf      d6,dhlp_outer5      ;Boucle tant qu'il reste des lignes  afficher.
;\6
;  Fin de l'affichage. On va rcuprer D4, D5, D6 et A5, dsactiver le smaphore cran, et attendre un vnement.

               movem.l  (sp)+,d4-d6/a5      ;Rcupre D4, D5, D6 et A5.
               bsr      end_windupd         ;Fin de mise  jour de la fentre si le jeu se droule dans une fentre GEM.
dhlp_wmti1:    move.w   d7,-(sp)            ;Sauve D7.
               move.l   d6,-(sp)            ;Sauve D6.
dhlp_wmti2:    bsr      dmem_test           ;Libre la mmoire associe  l'affichage des nb s'il le faut.
               pea      dhlp_tstkey(pc)     ;Adr.  laquelle il faudra se brancher aprs l'ventuel appel de read_msg1.
               lea      -16(sp),sp          ;Rserve de la mmoire pour les messages.
               bsr      xmem_test           ;Libre la mmoire utilise par l'image de fond, s'il n'en reste pas assez.
               bsr      wait_evnt0          ;Attend un vnement.
               move.b   d0,d7               ;Masque des vnements ayant eu lieu.
               move.l   int_out+8(pc),d6    ;Code d'une touche si l'vnement evnt_keybd a eu lieu.
               lsl.b    #4,d0               ; N = 0 (utile pour le BMI ci-dessous). Branch.
               bcs      read_msg1           ; si l'vnement evnt_mesag a eu lieu.
               lea      20(sp),sp           ;Libre le buffer des messages et dpile l'adr. empile auparavant.
dhlp_tstkey:   bmi      dhlp_disp2          ;Branch. si on est pass en mode PAUSE.
               lsr.b    #1,d7               ; Branch. si l'vnement evnt_keybd n'a pas
               bcc.s    dhlp_wmti2          ; eu lieu (on attend un nouvel vnement).
               move.l   d6,d3               ;D3.L: code de la touche.
               move.l   (sp)+,d6            ;Rcupre D6.
               move.w   (sp)+,d7            ;Rcupre D7.
               move.l   a5,d0               ;D0.L: adr. du bloc de mmoire rserv au dbut (utile si c'est la touche ESC).
               cmpi.b   #esc,d3             ; Branch. si c'est la touche ESC
               beq      call_mfree2         ; (libre la mmoire, retour).
               lsr.w    #8,d3               ;D3.B: scancode de la touche.
               subi.b   #clrhome,d3         ; Branch. si ce n'est
               bne.s    dhlp_tstarr         ; pas CLR-HOME.
               swap     d3                  ;D3.B: tat des touches spciales.
               lsl.b    #6,d3               ; Branch. si aucune des 2 touches shift n'est
               beq.s    dhlp_home           ; enfonce (on affiche le dbut du texte).
               move.l   d6,d0               ;Une des 2 touches shift est enfonce.
               bra.s    dhlp_move5          ;Branch. pour afficher la fin du texte.
dhlp_tstarr:   moveq    #-1,d0              ; Branch.  avec D0.L = -1
               subq.b   #uparrow-clrhome,d3 ; si c'est la flche vers
               beq.s    dhlp_move1          ; le haut.
               subq.b   #downarrow-uparrow,d3  ; Branch. si ce n'est pas la flche vers le
               bne.s    dhlp_wmti1             ; bas (on attend un nouvel vnement).
               moveq    #1,d0               ;D0.L = 1.
;\6
;  D0.L: direction (1: vers le bas, -1: vers le haut).

dhlp_move1:    swap     d3                  ;D3.B: tat des touches spciales.
               roxr.b   #2,d3               ; Si une des 2 touches shift
               bmi.s    dhlp_move2          ; est enfonce, multiplie D0
               bcc.s    dhlp_move3          ; par  le nb de lignes  dans
dhlp_move2:    muls.w   #hlpn,d0            ; une page.
dhlp_move3:    lsr.b    #1,d3               ; Si la touche ctrl  est
               bcc.s    dhlp_move4          ; enfonce, multiplie D0
               lsl.b    #2,d0               ; par 4.
dhlp_move4:    add.l    d4,d0               ;D0.L: 1re ligne  afficher (valeur signe).
               bpl.s    dhlp_move5          ; Si cette valeur est ngative, D0.L = 0
dhlp_home:     moveq    #0,d0               ; (on affiche le dbut du texte).
dhlp_move5:    move.l   d6,d1               ;
               subi.l   #hlpn,d1            ;
               bcc.s    dhlp_move6          ; Si D0.L est trop grand, D0.L = max(nb de
               moveq    #0,d1               ; lignes dans le texte - nb de lignes dans
dhlp_move6:    cmp.l    d0,d1               ; une page,0): on affiche la fin du texte.
               bcc.s    dhlp_move7          ;
               move.l   d1,d0               ;
dhlp_move7:    exg      d0,d4               ;D4.L: 1re ligne  afficher. D0.L: ancienne 1re ligne.
               sub.l    d4,d0               ;D0.L: dplacement (positif: vers le haut, ngatif: vers le bas).
               beq      dhlp_wmti1          ;Branch. s'il n'y a pas de dplacement.
               move.l   d0,-(sp)            ;Sauve D0.
               bsr      beg_windupd         ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM.
               movem.l  (sp)+,d0            ;Rcupre D0 (CCR non affect).
               bpl      dhlp_text           ;Branch. si on n'est pas pass en mode PAUSE.
               bra      dhlp_disp1          ;Branch. pour tout rafficher.

;\6
;    Ŀ
;     Jeu (RETURN) 
;    

test_return:   cmpi.w   #return<<8,d6       ;Est-ce la touche RETURN?
               IFNE     REGISTERED
               beq.s    play                ;Oui, branch. au jeu.
               move.w   #msg_mkey,d0        ; Envoie le msg msg_mkey (le code de la touche a dj
               bsr      send_msg0           ; t stocke dans la structure rserve aux msg).
               bra      tst_leftb           ;Branch. pour tester si l'vnement mu_button a eu lieu.
               ELSE
               bne      tst_leftb           ;Non, branch. pour tester si l'vnement mu_button a eu lieu.
               ENDIF
;\4
vlen           equ      4*64                ;Taille mmoire occupe par les variables du jeu.
gd             RSSTRUCT                     ;Structure situe aprs les variables: donnes supplmentaires.
               RSSET    vlen                ;A5 pointera sur les variables, donc varlen(A5) pointera sur cette structure.
array          rs.l     1                   ;Ptr sur le tableau du jeu (1re case).
x00            rs.l     1                   ;Ptr sur la case (0,0).
xref           rs.l     1                   ;Ptr sur l'hex. de rfrence.
x1             rs.l     1                   ;Ptr sur l'hex. 1. 
x2             rs.l     1                   ;Ptr sur l'hex. 2.  Mis  jour  chaque
x3             rs.l     1                   ;Ptr sur l'hex. 3.  dpl./rotation.
x4             rs.l     1                   ;Ptr sur l'hex. 4. 
xtmp           rs.l     4                   ;Ptrs temporaires sur les hex. 1, 2, 3, 4.
psa            rs.b     4*6                 ;Tableau des positions des hex. par rapport  l'hex. de rf. (pice courante).
paddr          rs.l     1                   ;Adr. du bloc contenant le fond de la zone o est affich "-- PAUSE --".
bkgr           rs.l     1                   ;Adr. de la mm. video  partir de laquelle l'img de fond a t prise, ou 0. 
nbh            rs.w     1                   ;Nb d'hex. - 1 dans la pice.                                                
ind            rs.w     1                   ;Index de la position courante dans la liste, de 0  5 (initialement 0).     
rot            rs.b     1                   ;Priode des rotations (0: pas de rotation possible).                        
wpaus          rs.b     1                   ;Drapeau actif qd on vient de sortir du mode pause de la fentre (0: inactif).
pause          rs.b     1                   ;Drapeau de pause (0: pas de pause, -1: mode pause).   
wuflag         rs.b     1                   ;Drapeau de validit de l'affichage du tableau de jeu. 
act            rs.l     1                   ;N de la dernire action (utile pour la phase C).
downt          rs.w     1                   ;Temps, en 1/96 s, entre 2 descentes successives d'une pice.
drop           rs.l     1                   ;Drapeau "drop" (contient le nb de drops).
arad           rs.l     1                   ;Adr. de la mm. video o est stocke l'img du radar.
radar          rs.b     1                   ;Drapeau "radar" (0: inactif, -1: actif).             
next           rs.b     9                   ;Donnes sur la pice suivante si le radar est actif. 
nexpl          rs.l     1                   ;Nb d'hex. dtruits lors de l'action "explode".
npix           rs.w     1                   ;Nb de pixels restant  effacer, ou -1.
flg            rs.l     inhy                ;Masque des pixels restant  effacer.
pix            rs.w     npix                ;Tableau contenant la liste des pixels  effacer.
dflags         rs.w     shap_h              ;Tableau des flags de modification.
sbkgr          rs.w     sbkgrlen            ;Nb de lignes - 1 et image contenant le fond.
sbkgr2         rs.w     sbkgrlen            ;Idem pour le radar OU copie temporaire de l'img contenant le fond.
simg           rs.w     simglen             ;6 images contenant la pice en cours, avec offsets (2 mots par image).
hexbk          rs.l     hbklen              ;Sauvegarde du fond des 3n-3n+1 hex. (1 mot long par ligne et par plan).
imrad          rs.w     shposlen            ;Image contenant la pice suivante (si radar actif).
               RSEND                        ;Fin de la structure.
gd.hex         equ      gd.simg+2
;\4
hex            RSSTRUCT                     ;--> case.
               RSRESET
col            rs.b     1                   ;Couleur.
pat            rs.b     1                   ;Motif.
marks          rs.b     1                   ;Marques.
exist          rs.b     1                   ;Drapeau d'existence.
               RSEND                        ;Fin de la structure.
hex.free       equ      0                   ;Drapeau de case libre.
;\4
play:          IFNE     REGISTERED
               moveq    #msg_play1,d0       ; Envoie le msg
               bsr      send_msg0           ; msg_play1.
               ENDIF
               bsr      clr_colors1         ;Efface progressivement l'cran.
               IFNE     REGISTERED
               movea.l  rul_ptr(pc),a6      ;A6: ptr sur le fichier de rgle.
               ELSE
               lea      rul_ptr(pc),a0      ; A6: ptr sur le fichier
               movea.l  (a0),a6             ; de rgle.
               move.w   #tps96b0,tps96b-rul_ptr(a0)  ;Initialise le 2nd compteur pour limiter le jeu  5 mn.
               ENDIF
               moveq    #64,d7              ;Nb de variables...
               add.l    rul.stkl(a6),d7     ;+ taille de la pile.
               lsl.l    #2,d7               ;Multiplie par 4 (car ce sont des mots longs).
               move.w   nh2(pc),d6          ; D6.L: taille du
               lsr.w    #1,d6               ; tableau du jeu:
               mulu.w   d6,d6               ; 4(2n-1)^2.
               move.l   #gd.SIZEOF-vlen,d0  ; Ajoute la taille des donnes
               add.l    d0,d7               ; supplmentaires.
               add.l    d7,d6               ; Rserve de la mmoire pour les variables,
               move.l   d6,d0               ; les donnes supplmentaires,  la pile  et
               bsr      test_malloc         ; le tableau du jeu.
               movea.l  d0,a5               ;A5: ptr sur les variables.
               lea      (a5,d7.l),a4        ;A4: ptr de pile (il s'agit de la pile du jeu).
               move.l   a4,gd.array(a5)     ;gd.array(A5): ptr sur le tableau du jeu (1re case).
               move.w   nh3(pc),d4          ; gd.x00(A5): ptr sur la
               lea      (a4,d4.w),a0        ; case (0,0)  du tableau
               move.l   a0,gd.x00(a5)       ; du jeu.
               tas      gd.wpaus(a5)        ;Active le drapeau de non attente de pause.
               clr.b    gd.pause(a5)        ;Dsactive le drapeau de pause.
               clr.w    gd.radar(a5)        ;Annule gd.radar (radar dsactiv) et gd.next[0] (prochaine pice non dtermine).
               tas      gd.wuflag(a5)       ;Active le drapeau de validit de l'affichage du tableau de jeu.
               movea.l  a5,a0               ;
               moveq    #63,d0              ; Annule les
clr_vars:      clr.l    (a0)+               ; variables.
               dbf      d0,clr_vars         ;
               move.w   d0,gd.npix(a5)      ;gd.npix(A5) = -1 (l'ordre d'effacement des pixels n'est pas encore calcul).
;\6
;  Initialise le tableau du jeu.

               movea.l  a4,a0               ;Dbut du tableau du jeu.
               move.w   nh4(pc),d1          ;Nb de colonnes - 1 (compteur).
               move.b   d1,d7               ;D7.B: nb d'hex. - 1 dans la colonne la + haute.
               move.b   nhex+1(pc),d2       ;Nb de cases existantes dans la 1re colonne.
clrhex_outr:   clr.b    d3                  ;D3.B: compteur (nb de cases initialises dans la colonne).
clrhex_innr1:  clr.l    (a0)+               ;
               subq.b   #1,hex.exist-4(a0)  ; Initialise les cases existantes
               addq.b   #1,d3               ; de  la colonne:  les 3 premiers
               cmp.b    d3,d2               ; octets  0, le 4me  -1.
               bne.s    clrhex_innr1        ;
               bra.s    clrhex_lbl1         ;
clrhex_innr2:  addq.b   #1,d3               ; Initialise les cases inexis-
               clr.l    (a0)+               ; tantes de la colonne  (les 4
clrhex_lbl1:   cmp.b    d7,d3               ; octets  0).
               bls.s    clrhex_innr2        ;
               cmp.b    d7,d2               ; S'il y avait 2n-1 cases existantes, on change le signe
               bls.s    clrhex_lbl2         ; de D0.B,  car il faut maintenant  dcrmenter le nb de
               moveq    #1,d0               ; cases existantes au lieu de l'incrmenter.
clrhex_lbl2:   sub.b    d0,d2               ;Incr. ou dcr. le nb de cases existantes.
               dbf      d1,clrhex_outr      ;Boucle pour initialiser la prochaine colonne.
;\5
;  Note: chaque case du tableau du jeu occupe un mot long.  Puisque les colonnes n'ont pas toutes le mme nb de cases,
;    le tableau contient des cases inexistantes.  Le mot long correspondant  ces cases est tjrs nul.  Le mot long
;        correspondant aux cases existantes n'est jms nul, et contient les donnes suivantes. 1er octet: couleur (0 si
;        case vide). 2me octet: motif (0 si case vide). 3me octet: flags. 4me octet: -1. La case de colonne c et de
;        hauteur h est situe  l'adr. x00 + nh2*c + 4*h, o x00 est l'adr. de la case (0,0).
;\3
;  A4: ptr de pile du jeu.
;  A5: ptr sur les variables.
;  A6: ptr sur le fichier de rgle.
;\4
               moveq    #rul.rul0,d0        ; Initialisation des variables
               bsr      eval_rul            ; (partie 0 de la rgle).
               bsr      disp_game           ;Affiche l'cran de jeu.
               bsr      timer96             ;Lance le timer  96 Hz.
               lea      struct_msg+4(pc),a0 ; Stocke les donnes sur le jeu dans
               movem.l  a4-a6,(a0)          ; la struct. rserve aux msg.
               IFNE     REGISTERED
               moveq    #msg_play2-msg_rul,d0  ; Envoie le msg
               bsr      send_msgrul            ; msg_play2.
               ELSE
               move.w   #tps96a0,tps96a-struct_msg-4(a0)  ;Initialise le 1er compteur pour limiter le jeu  5 mn.
               ENDIF
;\6
;  Prochaine pice.

next_shape:    lea      counter(pc),a0      ; Annule le compteur
               clr.w    (a0)                ; du timer.
               clr.l    gd.drop(a5)         ;Dsactive le drapeau "drop".
               tst.b    gd.radar(a5)        ; Branch. si le radar
               bne.s    rula                ; est actif.
               clr.l    (a5)                ;Annule le n de la forme (utile si gd.next <> 0).
               tst.b    gd.next(a5)         ; Si gd.next <> 0, on n'excute pas la partie A de la rgle car la
               bne.s    next_shape2         ; prochaine pice est dj dtermine et le radar est inactif.
rula:          IFNE     REGISTERED
               moveq    #msg_preva-msg_rul,d0  ; Envoie le msg
               bsr      send_msgrul            ; msg_preva.
               tst.l    d0                  ; Branch. si le rsultat est non nul
               bne.s    next_shape2         ; (on n'excute pas la phase A).
               ENDIF
               moveq    #rul.rulA,d0        ; Dtermination de la prochaine
               bsr      eval_rul            ; pice (partie A de la rgle).
               IFNE     REGISTERED
               moveq    #msg_nexta-msg_rul,d0  ; Envoie le msg
               bsr      send_msgrul            ; msg_nexta.
               ENDIF
next_shape2:   tst.b    gd.next(a5)         ; Si gd.next <> 0, on affiche la pice suivante
               beq.s    next_shape3         ; (radar)  et on change les donnes concernant
               bsr      radar_on1           ; la pice courante et la suivante.
next_shape3:   move.l   (a5),d7             ;D7.L: n de la forme (entre 1 et 255).
               lea      gd.psa(a5),a1       ;A1: ptr sur le tableau des positions.
               lea      ([shap_def.w,pc],d7.l*8,-8.w),a0  ;Ptr sur la df. de la forme D7.
               move.b   (a0)+,d6            ;D6.B: nb de petits hexagones dans la pice.
               move.b   (a0)+,d2            ;D2.B: drapeau de rotation.
               move.w   (a0)+,d3            ;D3.W: offset sur les positions des hex. si ce drapeau est > 0.
               move.l   (a0),(a1)           ;Stocke la position initiale des hex. dans gd.psa (utile si unique position).
               move.b   d2,d1               ; D1.W: drapeau
               ext.w    d1                  ; de rotation.
               beq.s    nxshap_lbl2         ;Branch. si la pice ne peut pas tourner (D1.W: nb de positions - 1).
               bpl.s    nxshap_lbl1         ;Branch. si les positions sont df. dans le fichier de rgle.
               clr.w    d1                  ;Les rotations s'effectuent autour de l'hex. de rf...
               move.l   (a0),d0             ;D0.L: position initiale.
shrot_outer:   move.l   d0,(a1)+            ;Stocke la prochaine position dans le tableau gd.psa[].
               moveq    #3,d2               ;Nb max. d'hex. - 1.
shrot_inner:   rol.l    #8,d0               ;Position du prochain hex.
               tst.b    d0                  ; Branch. si c'est l'hexagone de
               beq.s    shrot_next          ; rfrence (il ne bouge pas).
               cmpi.b   #6,d0               ; Branch. si c'est un voisin
               bls.s    shrot_lbl1          ; de l'hex. de rfrence.
               addq.b   #2,d0               ;Rotation de 1/6 tour.
               cmpi.b   #18,d0              ;
               bls.s    shrot_next          ; Le rsultat doit tre compris
               subq.b   #6,d0               ; entre 7 et 18.
               bra.s    shrot_lbl2          ;
shrot_lbl1:    addq.b   #1,d0               ;Rotation de 1/6 tour.
shrot_lbl2:    subq.b   #6,d0               ;
               bhi.s    shrot_next          ; Le rsultat doit tre compris entre 1 et 6.
               addq.b   #6,d0               ;
shrot_next:    dbf      d2,shrot_inner      ;Boucle.
               addq.b   #1,d1               ;Incr. le nb de positions diffrentes.
               cmp.l    gd.psa(a5),d0       ; Boucle tant qu'on n'est pas retomb
               bne.s    shrot_outer         ; sur la position initiale.
               move.b   d1,d2               ;D2.B: nb de positions diffrentes (priode des rotations).
               subq.b   #1,d1               ;D1.W: nb de positions - 1 (servira de compteur pour un DBF).
               bra.s    nxshap_lbl2         ;Branch. pour le calcul des images...
;\5
nxshap_lbl1:   subq.b   #1,d1               ;D1.W: nb de positions - 1 (servira de compteur pour un DBF).
               lea      -2(a0,d3.w),a3      ;Adr. o se trouvent les positions dans le fichier de rgle.
               move.w   d1,d3               ;
nxshap_loop:   move.l   (a3)+,(a1)+         ; Recopie ces positions dans gd.psa.
               dbf      d3,nxshap_loop      ;
;\4
nxshap_lbl2:   move.b   d2,gd.rot(a5)       ;Stocke le nb de positions diffrentes (priode des rotations) ou 0.
               lea      gd.simg(a5),a3      ;Adr. o doivent tre stockes les images de la pice courante.
               movea.l  a3,a1               ;
               move.w   #(simglen>>1)-1,d2  ; Efface les
clr_img:       clr.l    (a1)+               ; images.
               dbf      d2,clr_img          ;
               pea      gd.psa(a5)          ;Empile l'adr. des positions des hex.
;\6
;  Pour chaque position de la pice ( une translation prs),  on va calculer le masque (un bit nul pour chaque point
;  visible de la pice), l'image de la pice sur les 6 premiers plans et l'offset de cette image par rapport  l'hex.
;  de rfrence. Il y a au plus 6 positions diffrentes. Attention! les hex. formant la pice sont ordonns.

next_pos:      move.l   ([sp]),d5           ;Position des hex. par rapport  l'hex. de rf.
               addq.l   #4,(sp)             ;Incr. l'adr. des positions.
               bsr      shape_image         ;Calcule le masque et l'img pour la position courante.
               lea      2+shaplen*7(a3),a3  ;Adr. o devront tre stockes les donnes pour la position suivante.
               dbf      d1,next_pos         ;Boucle (prochaine position).
               addq.l   #4,sp               ;Dpile l'adr. des positions des hex.
               ext.w    d6                  ; D6.W: nb d'hex. - 1
               subq.b   #1,d6               ; dans la pice.
               lea      gd.bkgr(a5),a0      ;A0 = [gd.bkgr, gd.nbh, gd.ind].
               clr.l    (a0)+               ;Pas d'image de fond sauvegarde.
               move.w   d6,(a0)+            ;Stocke le nb d'hex. - 1.
               clr.w    (a0)                ;Angle de rotation (index dans le tableau): initialement 0.
;\6
;  Dtermine la position de dpart de l'hex. de rfrence.

               move.l   gd.psa(a5),d0       ;Position initiale des hex. par rapport  l'hex. de rf.
               move.w   d6,d4               ;Nb d'hex. - 1 dans la pice.
               clr.w    d1                  ;D1.W contiendra 0, 1 ou 2 suivant la forme de la pice.
               moveq    #0,d3               ;Annule les 24 bits de poids fort de D3.
shape_pos:     rol.l    #8,d0               ; D3.L: position du
               move.b   d0,d3               ; prochain hex.
               add.b    d3,d3                    ; D2: l'hex. de rf. doit tre  la hauteur nh4-D2
               bfextu   hexstart-1(pc){d3:2},d2  ; pour que l'hex. courant soit tout en haut.
               cmp.w    d1,d2               ;
               bls.s    shpos_next          ; D1 = max(D1,D2).
               move.w   d2,d1               ;
shpos_next:    dbf      d4,shape_pos        ;Boucle (passe au prochain hex.).
               move.w   nh4(pc),d2          ; D2: hauteur de l'hex.
               sub.w    d1,d2               ; de rf. au dpart.
               lea      ([gd.x00.w,a5],d2.w*4),a0  ;A0: ptr sur l'hex. de rfrence.
               move.l   a0,gd.xref(a5)      ;Stocke la position de l'hex. de rfrence.
;\4
;  Teste si toutes les cases correspondant aux hex. sont libres et met  jour x1, x2, x3, x4.

               bsr      test_hex            ; Branch. si une des cases, au moins, n'est pas libre. Dans le
               bne      game_over           ; cas contraire, gd.x1, gd.x2, gd.x3 et gd.x4 sont mis  jour.
;\6
;  Les cases sont libres; la partie n'est donc pas termine. On envoie alors le msg msg_next.

               IFNE     REGISTERED
               moveq    #msg_next-msg_rul,d0  ; Envoie le msg
               bsr      send_msgrul           ; msg_next.
               ENDIF
;\6
;  Met  jour le compteur du timer.

shape_down:    moveq    #tdrop,d0           ;
               tst.b    gd.drop+3(a5)       ; Met  jour  le compteur du timer:  on ajoute
               bne.s    shape_down2         ; gd.downt si le drapeau "drop" est dsactiv,
               move.w   gd.downt(a5),d0     ; tdrop si le drapeau "drop" est activ, temps
shape_down2:   lea      counter(pc),a0      ; en 1/96 s entre 2 descentes successives).
               add.w    d0,(a0)             ;
               IFEQ     REGISTERED
               sub.w    d0,tps96b-counter(a0)  ;Dcr. le 2nd compteur pour limiter le jeu  5 mn.
               bmi      game_over           ;Fin de la partie si le compteur a dpass 0.
               ENDIF
;\5
;  Affichage de la pice (aprs effacement ventuel de l'ancienne).

;    Active le smaphore cran, car on va faire des lectures/critures sur la zone de travail.

disp_shape:    bsr      pl_bwupd            ;Active le smaphore cran si le jeu se droule dans une fentre GEM.
;\5
;    Rcupre l'ancien fond si une pice est affiche.

               lea      gd.sbkgr(a5),a1     ;A1: adr. o a t stocke l'img de fond.
               bsr      restore_bkgr        ;Rcupre l'ancien fond si une pice est affiche.
               pea      tst_counter(pc)     ;Adr.  laquelle il faudra se brancher aprs avoir affich la pice.
;\6
;    Calcule les coord. relatives du point o doit tre affiche l'image (stocke dans
;    gd.simg), sauve le fond, affiche la pice et dsactive le smaphore cran.

               IFNE     REGISTERED
               pea      send_msgdisp(pc)    ;Adr.  laquelle il faudra se brancher aprs subr_dispsh + end_windupd.
               ENDIF
               pea      end_windupd(pc)     ;Adr.  laquelle il faudra se brancher aprs avoir affich la pice.
subr_dispsh:   bsr      coord_simg          ;D4.W/D5.W: coord. relatives o doit tre affiche l'img.
               lea      gd.sbkgr(a5),a2     ;A2: adr. o il faut stocker l'img de fond.
               lea      gd.bkgr(a5),a3      ;A3: adr. o il faut stocker l'adr. de l'img de fond dans la mm. video.
               clr.w    d7                  ;D7.W = 0.
               bra      savbg_dispsh        ;Sauve le fond et affiche la pice.
;\6
;  Action +10.

act_mesg:      IFNE     REGISTERED
               move.l   a4,d7                  ; Stocke le ptr de pile du jeu GSP
               moveq    #msg_act10-msg_rul,d0  ; dans la struct. rserve aux msg
               bsr      send_msgd7             ; et envoie le msg msg_act10.
               ENDIF
               move.l   (a4)+,d0            ;D0.L: nb de donnes (mots longs)  dpiler.
               lea      (a4,d0.l*4),a4      ;Dpile les donnes.
;\6
;  Attend un signal.

wait_sig:      tst.b    gd.drop+3(a5)       ;
               IFNE     REGISTERED          ;
               bne      tst_counter         ; Branch. si le drapeau
               ELSE                         ; "drop" est activ.
               bne.s    tst_counter         ;
               ENDIF                        ;
               lea      bksh_flag(pc),a0    ; Voir la note
               tas      (a0)                ; bksh_flag.
               moveq    #sigpaus,d0         ;
               tas      gd.wpaus(a5)        ;
               IFNE     REGISTERED          ; Active le drapeau de non attente de pause, et
               bpl.s    send_sig2           ; s'il tait dsactiv  (i.e. si gd.wpaus = 0),
               ELSE                         ; on envoie le signal PAUS.
               bpl.s    send_signal         ;
               ENDIF                        ;
               movem.l  a4-a6,-(sp)         ;Sauve les registres.
               bsr      disp_date           ;Affiche la date et l'heure s'il le faut.
               movem.l  (sp)+,a4-a6         ;Rcupre les registres.
               pea      sig_tstkey1(pc)     ;Adr.  laquelle il faudra se brancher aprs l'ventuel appel de read_msg1.
               lea      -16(sp),sp          ;Rserve de la mmoire pour les messages.
               moveq    #mu_timer,d0        ; On va surveiller l'vnement mu_timer
               clr.w    d7                  ; et on met le temps d'attente  0.
               bsr      wait_evnt           ;Attend un vnement.
               move.b   d0,d7               ;Masque des vnements ayant eu lieu.
               move.l   int_out+8(pc),d6    ;Code d'une touche si l'vnement evnt_keybd a eu lieu.
               lsl.b    #4,d0               ; N = 0 (utile pour le BMI ci-dessous). Branch.
               bcs      read_msg1           ; si l'vnement evnt_mesag a eu lieu.
               lea      20(sp),sp           ;Libre le buffer des messages et dpile l'adr. empile auparavant.
sig_tstkey1:   lea      bksh_flag(pc),a0    ; Voir la note bksh_flag
               sf       (a0)                ; (CCR non affect).
               IFNE     REGISTERED          ;
               bmi      ret_pause           ;
               ELSE                         ; Branch. si on est pass en mode PAUSE.
               bmi.s    ret_pause           ;
               ENDIF                        ;
               exg      d6,d7               ;D7.L: code de la touche s'il y a eu un vnement evnt_keybd.
               ror.b    #1,d6               ;D6.B < 0 ssi il y a eu un vnement evnt_keybd.
               bmi.s    send_msgsig         ; D7.L: code de la touche s'il y a eu
               moveq    #0,d7               ; un vnement evnt_keybd, 0 sinon.
send_msgsig:   IFNE     REGISTERED
               move.w   #msg_sig-msg_rul,d0 ; Stocke le code de la touche (0 si pas d'evnt_keybd) dans
               bsr      send_msgd7          ; la struct. rserve aux msg et envoie le msg msg_sig.
               ENDIF
               move.b   rul.nsig(a6),d1     ;D1.B: nb de signaux.
               lea      ([rul.sdef.w,a6],a6.l),a0  ;A0: adr. du nom du 1er signal.
               IFNE     REGISTERED
               move.l   d0,d2               ; Branch. si le fichier de msg n'a pas dtect de
               beq.s    kbd_sig             ; signal et s'il n'a pas examin le clavier.
               bmi.s    tst_counter         ;Branch. si le fichier de msg n'a pas dtect de signal.
               moveq    #1,d0               ;D0.L = 1 (n du 1er signal).
cmp_signame:   cmp.l    (a0),d2             ; Branch. si c'est
send_sig2:     beq.s    send_signal         ; le signal D0.
               addq.l   #8,a0               ;Adr. du nom du prochain signal.
               addq.w   #1,d0               ;N du prochain signal.
               subq.b   #1,d1               ; Boucle (passe au
               bne.s    cmp_signame         ; signal suivant).
               bra.s    tst_counter         ;Signal non reconnu.
               ENDIF
kbd_sig:       tst.b    d6                  ; Branch. si l'vnement evnt_keybd
               bpl.s    tst_counter         ; n'a pas eu lieu.
               addq.l   #4,a0               ;A0: adr. du code du 1er signal.
               lsr.l    #8,d7               ;D7.W: tat des touches spciales + scancode.
               moveq    #1,d0               ;D0.L = 1 (n du 1er signal).
cmp_sig:       cmp.w    (a0),d7             ; Branch. si c'est
               beq.s    send_signal         ; le signal D0.
               addq.l   #8,a0               ;Adr. du code du prochain signal.
               addq.w   #1,d0               ;N du prochain signal.
               subq.b   #1,d1               ; Boucle (passe au
               bne.s    cmp_sig             ; signal suivant).
tst_counter:   bsr      rm_pixel            ;Calcule une tape de l'ordre d'effacement des pixels.
               tst.w    counter(pc)         ;
               IFNE     REGISTERED          ; Branch. si le temps
               bpl      wait_sig            ; du timer  avant  la
               ELSE                         ; prochaine  descente
               bpl.s    wait_sig            ; n'est pas coul.
               ENDIF                        ;
               tst.b    gd.drop+3(a5)       ; Branch. si le drapeau
               bne      act_drop2           ; "drop" est activ.
               moveq    #sigdown,d0         ;Signal  envoyer: sigdown (un cran vers le bas).
send_signal:   move.l   d0,vsig*4(a5)       ;Stocke le n du signal dans V[vsig].
               moveq    #rul.rulB,d0        ; Partie B de
               bsr      eval_rul            ; la rgle.
               move.l   d0,gd.act(a5)       ;Stocke le n de l'action.
               bsr      update_nbrs         ;Met  jour l'affichage des nb.
               move.l   gd.act(a5),d7       ;Rcupre le n de l'action.
               IFNE     REGISTERED
               moveq    #msg_doact-msg_rul,d0  ; Stocke le n de l'action dans la struct. rserve
               bsr      send_msgd7             ; aux msg et envoie le msg msg_doact.
               ELSE
               tst.w    tps96a(pc)          ; Fin de la partie si le 1er compteur (pour
               bmi      game_over           ; limiter le jeu  5 mn) a dpass 0.
               ENDIF
               tst.b    gd.pause(a5)        ; Branch. si on est
               bne.s    pause_doact         ; en mode pause.
               move.w   (act.w,pc,d7.l*2),d0  ; Effectue l'action
act0:          jmp      act0(pc,d0.w)         ; demande.
;\3
ret_pause:     bsr      restore_win         ;Rcupre le tableau de jeu.
               bsr      end_windupd         ;Dsactive le smaphore cran.
               bra.s    tst_counter         ;On revient dans la boucle...
;\6
;  Actions si on est en mode pause du jeu.

pause_doact:   addq.b   #1,d7               ; Branch. si c'est l'action
               beq      game_over           ; -1 (abandon).
               cmpi.b   #9,d7               ; Branch. si ce n'est pas l'action +8 (fin de pause), car
               bne.s    wait_sig2           ; les autres actions ne sont pas prises en compte.
;\6
;  Action: sortie du mode pause du jeu.

               bsr.s    sr_pause            ;Inv. le drapeau de pause. D0/D1/D2/A1/A2: ...
rpbkg_nxline:  move.l   d0,d3               ;
               movea.l  a1,a0               ;
rpbkg_outer:   movea.l  a2,a3               ;
               moveq    #7,d4               ;
rpbkg_inner:   bfextu   (a3){d3:16},d7      ;
               move.w   d7,(a0)+            ;
               lea      ppllen(a3),a3       ; Rcupre le fond de la zone o
               dbf      d4,rpbkg_inner      ; est affich "-- PAUSE --".
               addi.w   #16,d3              ;
               cmpi.w   #16*(pww+1),d3      ;
               bcs.s    rpbkg_outer         ;
               lea      plnlen(a2),a2       ;
               adda.l   d2,a1               ;
               dbf      d1,rpbkg_nxline     ;
               bsr.s    free_pblk           ;Dsactive le smaphore cran et libre le bloc contenant
                                            ;le fond de la zone o tait affich "-- PAUSE --".
               lea      counter(pc),a0      ; Annule le compteur
               clr.w    (a0)                ; du timer.
wait_sig2:     bra      wait_sig            ;Attend un nouveau signal...
;\6
sr_pause2:     clr.b    gd.pause(a5)        ;Sort provisoirement du mode pause du jeu (note: smaphore cran actif).
               addq.l   #4,sp               ;Dpile l'adr. de retour.
               pea      wait_sig(pc)        ;Adr. o il faudra se brancher aprs le sous-prg suivant.
free_pblk:     bsr      end_windupd         ;Dsactive le smaphore cran si le jeu se droule dans une fentre GEM.
               move.l   gd.paddr(a5),d0     ; Libre le bloc de mmoire contenant le fond de la zone
               bra      call_mfree2         ; o tait (devait tre) affich "-- PAUSE --".
;\4
sr_pause:      bsr      pl_bwupd            ;Active le smaphore cran si le jeu se droule dans une fentre GEM.
               bmi.s    sr_pause2           ;Branch. si on est pass en mode PAUSE (de la fentre).
               not.b    gd.pause(a5)        ;Inverse le drapeau de pause.
               movea.l  gd.paddr(a5),a2     ;A2: adr. du bloc o est (doit tre) stock le fond de la zone "-- PAUSE --".
               lea      addr_scr(pc),a0     ;
               movea.l  (a0)+,a1            ;
               moveq    #px,d0              ;
               add.w    (a0)+,d0            ;
               moveq    #py,d1              ; A1: adr. dans la mmoire video  du
               add.w    (a0)+,d1            ; 1er mot  de la zone  o est  (doit
               moveq    #0,d2               ; tre) affich "-- PAUSE --". D2.L:
               move.w   (a0),d2             ; taille, en octets,  d'une ligne de
               mulu.w   d2,d1               ; l'cran systme.
               move.b   d0,d3               ;
               andi.b   #$F0,d0             ;
               add.l    d0,d1               ;
               adda.l   d1,a1               ;
               moveq    #16,d0              ; D0.L: nb de bits (de 1  16)
               andi.b   #$F,d3              ; du 1er mot, appartenant  la
               sub.b    d3,d0               ; zone "-- PAUSE --".
               moveq    #ph-1,d1            ;Hauteur de la zone - 1.
               rts                          ;Retour.
;\6
;  Action: passage en mode pause du jeu.

act_paus:      move.l   #8*ppllen,d0        ; Rserve un bloc de mmoire pour le fond de la zone o
               bsr      test_malloc         ; sera affich "-- PAUSE --". Attention! on stockera 16
               move.l   d0,gd.paddr(a5)     ; pixels en plus  gauche et  droite.
               bsr.s    sr_pause            ;Inv. le drapeau de pause. D0/D1/D2/A1/A2: ...
               lea      -16(a1),a1          ;Adr. du 1er mot  rcuprer.
spbkg_nxline:  movea.l  a1,a0               ;
               move.l   d0,d6               ;
               moveq    #0,d5               ;
spbkg_outer:   movea.l  a2,a3               ;
               moveq    #7,d4               ;
spbkg_inner:   move.w   (a0)+,d7            ;
               bfins    d7,(a3){d5:d6}      ;
               lea      ppllen(a3),a3       ;
               dbf      d4,spbkg_inner      ;
               add.w    d6,d5               ;
               moveq    #16,d6              ; Sauve le fond de la zone o sera affich
               cmpi.w   #16*(pww+1),d5      ; "-- PAUSE --", plus 16 pixels supplmen-
               bcs.s    spbkg_outer         ; taires (sur chaque ligne)   droite et 
               move.b   d5,d6               ; gauche.  Les plans  sont situs  les uns
               neg.b    d6                  ; aprs les autres.
               movea.l  a2,a3               ;
               moveq    #7,d4               ;
spbkg_loop:    bfextu   (a0){0:d6},d7       ;
               addq.l   #2,a0               ;
               bfins    d7,(a3){d5:d6}      ;
               lea      ppllen(a3),a3       ;
               dbf      d4,spbkg_loop       ;
               lea      plnlen(a2),a2       ;
               adda.l   d2,a1               ;
               dbf      d1,spbkg_nxline     ;
               move.l   a6,-(sp)            ;Sauve A6.
               lea      intin(pc),a6        ;A6: adr. du tableau INTIN.
               move.w   pfontid(pc),d7      ; Slectionne la fonte de n *pfontid si SpeedoGDOS
               bsr      sfont_cb            ; est install. Alignement: centr, base line.
               move.w   pause_h(pc),d7      ; Fixe la hauteur
               bsr      char_height         ; des caractres.
               moveq    #pcolor,d0          ; Index de la
               bsr      text_color          ; couleur.
               lea      ptsin(pc),a0        ; Praffiche "-- PAUSE --", i.e. on n'affiche rien, mais on stocke les
               clr.l    (a0)+               ; caractres dans les buffers s'il s'agit d'une fonte vectorielle.  Le
               clr.l    (a0)                ; fait  de ne rien afficher  vite d'avoir  des parasites  sur l'cran
               bsr.s    disp_gp             ; (car les plans sont modifis les uns aprs les autres).
               bsr      vsync1              ;Attend une interruption VBL si le drapeau vsync_flag est activ.
               lea      ptsin(pc),a0        ;Adr. du tableau PTSIN.
               move.l   xy0(pc),d0          ;Coord. de la zone de travail.
               move.l   d0,(a0)             ; Stocke les coord. du point infrieur
               addi.l   #px<<16+py,(a0)+    ; gauche du rectangle de clipping.
               move.l   d0,(a0)                            ; Stocke les coord. du point suprieur
               addi.l   #(px+16*pww-1)<<16+(py+ph-1),(a0)  ; droit du rectangle de clipping.
               bsr.s    disp_gp             ;Active le clipping et affiche "-- PAUSE --".
               movea.l  (sp)+,a6            ;Rcupre A6.
               bsr      no_clipping         ;Dsactive le clipping.
               bsr      end_windupd         ;Dsactive le smaphore cran si le jeu se droule dans une fentre GEM.
               bra      wait_sig2           ;Attend un nouveau signal...
;\4
disp_gp:       bsr      clip_on             ;Active le clipping.
               bsr      sto_pause           ;Stocke "-- PAUSE --" dans INTIN. D0.W: nb de caractres.
               move.l   #(px+8*pww)<<16+(py+44),d1  ;Coord. o il faut afficher le texte.
               bra      disp_text           ;Affiche le texte, et retour.
;\6
;  Actions: drop & un cran vers le bas.

act_drop:      lea      counter(pc),a0      ; Annule le compteur
               clr.w    (a0)                ; du timer.
act_drop2:     addq.b   #1,gd.drop+3(a5)    ;Active le drapeau "drop" et met  jour le nb de drops.
act_down:      lea      rlp_down(pc),a3     ; Evalue la fct RUL: 7F 7C C0 C0 51 (ptr sur la case situe
               bsr      eval_fct            ; en dessous de la case contenant l'hex. de rf.).
               tst.l    d0                  ; Branch. si cette case
               beq.s    actdown_lbl1        ; n'existe pas.
               move.l   gd.xref(a5),d4      ;Sauve le ptr sur l'hex. de rf. dans D4.
               move.l   d0,gd.xref(a5)      ;Nouvelle case contenant l'hex. de rf.
               bsr      test_hex            ;Teste si la pice peut descendre.
               beq      shape_down          ;Branch. si la case peut descendre (on affiche la nouvelle position...).
               move.l   d4,gd.xref(a5)      ;Restocke l'ancien ptr (car la pice ne descend pas).
;\6
;    La pice ne peut plus descendre. On la stocke dans le tableau.

actdown_lbl1:  lea      7(a5),a1            ; Stocke  les donnes
               moveq    #-1,d7              ; concernant la pice
               bsr      op_hex              ; dans le tableau.
               move.l   gd.drop(a5),d0      ; S'il  y  a eu  un drop,
               beq.s    actdown_lbl2        ; on stocke la hauteur de
               move.l   d0,vcpl*4(a5)       ; descente dans V[vcpl].
;\6
;    Affiche la pice "enfonce".

actdown_lbl2:  bsr      pl_bwupd            ;Active le smaphore cran si le jeu se droule dans une fentre GEM.
               bmi      shape_end2          ;Branch. si on est pass en mode PAUSE (note: smaphore cran actif).
               bsr      radar_off1          ;Efface l'ventuelle img du radar.
               lea      counter(pc),a0      ; Annule le compteur
               clr.w    (a0)                ; du timer.
               moveq    #2,d7               ;D7.W: nb d'img intermdiaires  afficher (compteur).
actdown_outr:  move.w   gd.ind(a5),d0             ;
               mulu.w   #2*shposlen,d0            ; A3: ptr sur le masque.
               lea      (gd.simg+6.w,a5,d0.l),a3  ;
               movea.l  a3,a0               ;
               move.w   #shapwln-1,d0       ; Annule le
actdown_inn1:  clr.w    (a0)+               ; masque.
               dbf      d0,actdown_inn1     ;
               bsr      pos_nbh             ;D5.L: positions des hex., D6.W: nb d'hex. - 1 dans la pice.
actdown_inn2:  moveq    #0,d0               ;
               rol.l    #8,d5               ; D0.L: position du prochain hex.
               move.b   d5,d0               ;
               movem.w  (hexpos.w,pc,d0.l*4),d0/d1  ;Coord. par rapport  l'hex. de rfrence.
               sub.w    -6(a3),d0           ; D0/D1: coord. par rapport au point
               sub.w    -4(a3),d1           ; suprieur gauche de l'image.
               moveq    #3,d2               ; Dcalage par rapport
               sub.b    d7,d2               ;  l'img initiale.
               add.w    d2,d0               ; D0.L: abscisse - 1 du pixel
               addq.w   #5,d0               ; gauche  de la 1re ligne de
               ext.l    d0                  ; l'hex.
               add.w    d2,d1               ;
               mulu.w   #2*shap_ww,d1       ; A0: adr. de l'ordonne D1 du masque.
               lea      (a3,d1.l),a0        ;
               move.w   (hexmad-2.w,pc,d7.w*2),d2  ; A2: liste des abscisses & longueurs
               lea      (hex_sh0-30.w,pc,d2.w),a2  ; des lignes d'un hex.
               moveq    #inhy-1,d2          ; D2.W: nb de
               add.b    d7,d2               ; lignes - 1.
actdown_lp1:   move.b   (a2)+,d1            ;Abscisse relative & longueur de la ligne courante.
               move.b   d1,d5               ;
               asr.b    #5,d5               ; D0.L: abscisse de la ligne courante.
               add.b    d5,d0               ;
               andi.b   #%00011111,d1       ;D1.B: longueur de la ligne courante.
               bfset    (a0){d0:d1}         ;Met  1 les bits du masque.
               lea      2*shap_ww(a0),a0    ;Adr. de la ligne suivante du masque.
               dbf      d2,actdown_lp1      ;Boucle (passe  la ligne suivante).
               dbf      d6,actdown_inn2     ;Boucle (passe  l'hex. suivant).
               bsr      coord_simg          ; L'img contenant la forme doit tre affiche 
               add.b    xy0+1(pc),d4        ; l'abscisse D4.B sur l'img de fond.  A0 pointe
               andi.b   #$F,d4              ; sur le nb de lignes - 1.
               lea      gd.sbkgr(a5),a1     ;
               lea      gd.sbkgr2(a5),a2    ;
               move.w   (a1)+,(a2)+         ; Recopie l'img de fond (avec le nb de
               movea.l  a2,a3               ; lignes - 1)  dans sbkgr2.  A2 pointe
               move.w   #(sbkgrlen>>1)-1,d0 ; sur l'img de destination.
actdown_inn3:  move.l   (a1)+,(a3)+         ;
               dbf      d0,actdown_inn3     ;
               moveq    #2*shap_ww,d0       ;
               moveq    #3,d1               ; A0: adr. de la 1re
               sub.b    d7,d1               ; ligne  du masque  
               mulu.w   d1,d0               ; prendre en compte.
               lea      2(a0,d0.l),a0       ;
               moveq    #$F,d3              ; D3.B: n du 1er bit du 1er mot de l'img
               sub.b    d4,d3               ; contenant le fond  prendre en compte.
               moveq    #$F,d4              ; D4.B: n du 1er bit du 1er mot
               sub.b    d1,d4               ; du masque  prendre en compte.
               moveq    #shap_h-4,d2        ; D2.W: nb de
               add.b    d7,d2               ; lignes - 1.
actdown_inn4:  movem.l  d3/d4/a2,-(sp)      ;Sauve D3, D4 et A2.
               moveq    #shap_ww-2,d1       ;D1.W: nb de mots - 2 dans une ligne du masque (compteur).
actdown_lpo:   move.w   (a0),d0             ;Lit un mot du masque.
actdown_lpi:   btst     d4,d0               ;Teste le prochain bit du masque.
               beq.s    actdown_lbl3        ;Branch. s'il est nul (on laisse le pixel du fond correspondant tel quel).
               movea.l  a0,a1               ; A0 et A2 ne doivent
               movea.l  a2,a3               ; pas tre modifis.
               moveq    #5,d5               ;D5.W: nb de plans - 1 de l'img source (compteur).
actdown_lp2:   lea      shaplen(a1),a1      ;Adr. du mot sur le plan suivant de l'img source.
               move.w   (a1),d6             ;
               btst     d4,d6               ;
               beq.s    actdown_lbl5        ;
               move.w   (a3),d6             ; Met le bit de la destination
               bset     d3,d6               ;  0 ou  1 suivant que celui
               bra.s    actdown_lbl6        ; de la source est  0 ou  1.
actdown_lbl5:  move.w   (a3),d6             ;
               bclr     d3,d6               ;
actdown_lbl6:  move.w   d6,(a3)+            ;
               dbf      d5,actdown_lp2      ;Boucle (passe au plan suivant).
               move.w   (a3),d6             ;
               bclr     d3,d6               ;
               move.w   d6,(a3)+            ; Pour les plans 6 et 7 de la destination, le bit
               move.w   (a3),d6             ; correspondant est toujours nul (couleur < 64).
               bclr     d3,d6               ;
               move.w   d6,(a3)             ;
actdown_lbl3:  subq.b   #1,d3               ;N du bit suivant ( droite) de l'img de fond.
               bcc.s    actdown_lbl4        ;Branch. si ce bit est situ dans le mme mot.
               moveq    #$F,d3              ; Sinon, on prend le MSB (bit 15) et l'adr.
               lea      16(a2),a2           ; du groupe de 16 pixels suivant.
actdown_lbl4:  subq.b   #1,d4               ;N du bit suivant ( droite) du masque (img source).
               bcc.s    actdown_lpi         ;Branch. (boucle) si ce bit est situ dans le mme mot.
               moveq    #$F,d4              ;Sinon, on prend le MSB (bit 15).
               addq.l   #2,a0               ;Adr. du prochain mot du masque.
               dbf      d1,actdown_lpo      ;Boucle (passe au mot suivant).
               addq.l   #2,a0               ;Saute le dernier mot de la ligne du masque (tjrs nul).
               movem.l  (sp)+,d3/d4/a2      ;Rcupre D3, D4 et A2.
               lea      16*shap_ww(a2),a2   ;Adr. de la ligne suivante de la copie de l'img contenant le fond (sbkgr2).
               dbf      d2,actdown_inn4     ;Boucle (passe  la ligne suivante).
               lea      counter(pc),a0      ;
actdown_wait:  tst.w    (a0)                ; Attend que le temps du
               bpl.s    actdown_wait        ; timer soit coul.
               addq.w   #8,(a0)             ;
               lea      gd.sbkgr2(a5),a1    ; Affiche l'img de fond avec
               bsr      restore_bkgr        ; la pice "enfonce".
               dbf      d7,actdown_outr     ;Boucle pour afficher l'img suivante.
;\6
;    Excute la phase C et met  jour l'affichage des nb.

shape_end:     clr.l    gd.bkgr(a5)         ;Il n'y a plus de pice affiche.
               move.l   gd.act(a5),vact*4(a5)  ;Stocke le n de la dernire action dans V[vact].
               moveq    #rul.rulC,d0        ; Partie C de
               bsr      eval_rul            ; la rgle.
               bsr      end_windupd         ;Dsactive le smaphore cran si le jeu se droule dans une fentre GEM.
               bsr      update_nbrs         ;Met  jour l'affichage des nb.
;\6
;    Dplace la fentre s'il le faut, et passe  la pice suivante.

               pea      next_shape(pc)      ;Adr.  laquelle il faut se brancher aprs move_wind0.
move_wind0:    tst.b    windflag(pc)        ; Retour si le jeu se droule
               bpl.s    mw_rts              ; sur tout l'cran.
               move.w   whandle(pc),d3      ;D3.W: handle de la fentre.
move_wind:     lea      bksh_flag(pc),a0    ;
move_wind2:    tst.b    (a0)+               ; Branch. si la fentre ne
               bmi.s    mw_rts              ;
               tst.b    (a0)                ; doit pas tre dplace.
               bpl.s    mw_rts              ;
               clr.b    (a0)+               ;Dsactive le 2nd drapeau, car on dpl. la fentre.
               lea      int_in(pc),a1       ;
               move.w   d3,(a1)+            ;
               move.w   #wf_currxywh,(a1)+  ; Dplace la
               move.l   (a0)+,(a1)+         ; fentre.
               move.l   (a0),(a1)           ;
               bsr      wset                ;
               bsr      bra_fredmem         ;Libre les blocs de mmoire associs aux images dcales et aux masques.
get_xywh:      lea      int_in(pc),a0       ;
               move.w   d3,(a0)+            ; Rcupre les coord. de la zone de
               move.w   #wf_workxywh,(a0)   ; travail de la fentre (car elle a
               bsr      window_get          ; pu changer de position).
               beq      mtos_err            ;
               lea      xy0(pc),a0          ; Stocke les coord. du point
               move.l   int_out+2(pc),(a0)  ; suprieur gauche dans xy0.
mw_rts:        rts                          ;Retour.
;\6
;  Action: dtruire la forme courante.

act_exsh:      bsr.s    bwu_resbkgr         ;Active le smaphore cran et rcupre l'ancien fond.
shape_end2:    pea      shape_end(pc)       ;Adr.  laquelle il faut se brancher aprs avoir effac l'img du radar.
radar_off1:    tst.b    gd.radar(a5)        ; Retour si le radar
               beq.s    mw_rts              ; est dsactiv.
radar_off2:    lea      gd.sbkgr2(a5),a1    ;
               move.l   gd.arad(a5),d0      ; Efface l'img du radar,
               clr.w    d4                  ; et retour.
               bra      restore_bkg2        ;
;\6
;  Action: tout dtruire.

act_expl:      bsr.s    bwu_resbkgr         ;Active le smaphore cran et rcupre l'ancien fond.
               moveq    #1,d0               ;
               add.b    gd.nbh+1(a5),d0     ; gd.nexpl = nb d'hex. de la pice courante.
               move.l   d0,gd.nexpl(a5)     ;
               lea      rlp_expl(pc),a3     ; Dtruit tous
               bsr      eval_fct            ; les hex.
               move.l   gd.nexpl(a5),vcpl*4(a5)  ;Stocke le nb d'hex. dtruits dans V[vcpl].
               bra.s    shape_end2          ;Branch. pour effacer l'img du radar et excuter la phase C.
;\3
bwu_resbkgr:   bsr.s    pl_bwupd            ;Active le smaphore cran si le jeu se droule dans une fentre GEM.
               lea      gd.sbkgr(a5),a1     ;A1: adr. o a t stocke l'img de fond.
               bra      restore_bkgr        ;Rcupre l'ancien fond si une pice est affiche.
;\6
;  Active le smaphore cran si le jeu se droule dans une fentre GEM et teste si on revient du mode PAUSE.

pl_bwupd:      bsr      beg_windupd         ;Active le smaphore cran si le jeu se droule dans une fentre GEM.
               bpl.s    mw_rts              ;Retour si on n'est pas pass en mode PAUSE.
restore_win:   clr.b    gd.wpaus(a5)        ;Dsactive le drapeau de non attente de pause.
               clr.w    gd.pause(a5)        ;Dsactive les drapeaux gd.pause et gd.wuflag (validit du tableau de jeu).
reswin_again:  bsr      disp_game           ;Raffiche l'cran de jeu (sauf les petits hex.).
               bsr      beg_windupd         ;Active le smaphore cran si le jeu se droule dans une fentre GEM.
               bmi.s    reswin_again        ;Branch. si on est pass en mode PAUSE.
               tas      gd.wuflag(a5)       ;Active le drapeau de validit du tableau de jeu.
               bmi.s    mw_rts              ;Branch. s'il tait dj actif (pas besoin de rafficher les petits hex.).
;\6
;  Raffiche les petits hex., la pice courante ventuelle et l'img du radar ventuelle. Retour avec N = 1.

               bsr      coord_dl            ;A0: tableau de jeu, D4/D5: coord. case en bas  gauche, D2: nb de colonnes - 1.
               movem.l  a4/a6,-(sp)         ;Sauve A4 et A6.
reswin_outer:  move.w   nh4(pc),d3          ;D3.W: nb de cases (existantes ou non) par colonne - 1 (compteur).
               movem.w  d2/d5,-(sp)         ;Sauve D2 et D5 (ordonne de la + basse case).
reswin_inner:  move.w   d5,-(sp)            ;Sauve D5 (ordonne de la case courante).
               move.b   (a0)+,d0            ;D0.B: n de la couleur (0 si pas d'hex.).
               beq      reswin_lbl1         ;Branch. s'il n'y a pas d'hex. dans la case courante.
               addq.b   #1,d0               ;D0.B: n de la couleur + 1.
               move.w   d4,d1                      ;
               andi.b   #$F0,d1                    ;
               lea      ([addr_scr.w,pc],d1.w),a1  ; A1: adr. de la case dans
               move.w   xlen(pc),d2                ; la mmoire video.
               mulu.w   d2,d5                      ;
               adda.l   d5,a1                      ;
               lea      gd.sbkgr2(a5),a2    ;A2: adr. o il faut recopier le fond.
               movea.l  a1,a3               ;
               moveq    #inhy-1,d5          ;
resw_nxlin1:   moveq    #2,d6               ;
resw_outer1:   moveq    #7,d7               ;
resw_inner1:   move.w   (a3)+,(a2)          ; Recopie le fond  (img de
               lea      6*inhy(a2),a2       ; destination: 8 plans non
               dbf      d7,resw_inner1      ; entrelacs).
               lea      2-8*6*inhy(a2),a2   ;
               dbf      d6,resw_outer1      ;
               lea      -3*16(a3,d2.w),a3   ;
               dbf      d5,resw_nxlin1      ;
               lea      gd.sbkgr2(a5),a2    ;A2: adr. o a t stock le fond.
               clr.w    d1                                     ;
               move.b   (a0),d1                                ; A3: adr. de la ligne 3 du motif (les 3 premires lignes
               mulu.w   #patlen,d1                             ; n'apparaissent que qd la pice n'est pas enfonce).
               lea      ([patterns.w,pc],d1.l,12-patlen.w),a3  ;
               lea      hex_abs(pc),a6      ;A6: tableau des abscisses des lignes du motif (non nulles car pice enfonce).
               moveq    #0,d1               ;
               move.b   d4,d1               ; D1.L: 1re abscisse dans
               andi.b   #$F,d1              ; la destination.
               addq.b   #5,d1               ;
               lea      hex_sh0(pc),a4      ;A4: tableau des abscisses/longueurs des lignes.
               moveq    #inhy-1,d5          ;D5.W: nb de lignes - 1 (compteur).
resw_nxlin2:   move.b   (a4)+,d2            ;Element suivant du tableau des abscisses/longueurs des lignes.
               move.b   d2,d6               ;
               asr.b    #5,d6               ; D1.L: abscisse de la ligne courante.
               add.b    d6,d1               ;
               andi.b   #%00011111,d2       ;D2.B: longueur de la ligne courante.
               moveq    #2,d7               ;
resw_loop1:    moveq    #0,d6               ;
               move.b   (a6),d6             ;
               bfextu   (a3){d6:d2},d6      ;
               bfins    d6,(a2){d1:d2}      ; Recopie la ligne courante du motif
               lea      patpl(a3),a3        ; dans l'image (plans 0, 1, 2).
               lea      6*inhy(a2),a2       ;
               dbf      d7,resw_loop1       ;
               addq.l   #1,a6               ;
               lea      4-3*patpl(a3),a3    ;
               moveq    #2,d7               ;
resw_loop2:    ror.b    #1,d0               ;
               smi      d6                  ;
               extb.l   d6                  ; Recopie les plans 3, 4, 5 (couleur).
               bfins    d6,(a2){d1:d2}      ;
               lea      6*inhy(a2),a2       ;
               dbf      d7,resw_loop2       ;
               bfclr    (a2){d1:d2}         ;Annule les points de l'hex. sur le plan 6.
               bfclr    6*inhy(a2){d1:d2}   ;Annule les points de l'hex. sur le plan 7.
               rol.b    #3,d0               ;D0.B: n de la couleur + 1.
               lea      6-6*6*inhy(a2),a2   ;A2: adr. de la ligne suivante du plan 0 de l'img.
               dbf      d5,resw_nxlin2      ;Boucle (passe  la ligne suivante).
               move.w   xlen(pc),d2         ;
               lea      gd.sbkgr2(a5),a2    ;
               moveq    #inhy-1,d5          ;
resw_nxlin3:   moveq    #2,d6               ;
resw_outer3:   moveq    #7,d7               ;
resw_inner3:   move.w   (a2),(a1)+          ; Recopie l'img dans
               lea      6*inhy(a2),a2       ; la mmoire video.
               dbf      d7,resw_inner3      ;
               lea      2-8*6*inhy(a2),a2   ;
               dbf      d6,resw_outer3      ;
               lea      -3*16(a1,d2.w),a1   ;
               dbf      d5,resw_nxlin3      ;
reswin_lbl1:   addq.l   #3,a0               ;Adr. de la case suivante.
               moveq    #-yhex,d5           ; Ordonne de la
               add.w    (sp)+,d5            ; case suivante.
               dbf      d3,reswin_inner     ;Boucle (passe  la case situe au-dessus).
               movem.w  (sp)+,d2/d5         ;Rcupre D2 et D5 (ordonne de la + basse case).
               addi.w   #xhex,d4            ;Abscisse de la colonne suivante.
               moveq    #yhex/2,d3          ;
               cmp.b    nhex+1(pc),d2       ; Ordonne de la case la
               bcc.s    reswin_lbl2         ; + basse  de la colonne
               moveq    #-yhex/2,d3         ; suivante.
reswin_lbl2:   add.w    d3,d5               ;
               dbf      d2,reswin_outer     ;Boucle (passe  la colonne suivante).
               movem.l  (sp)+,a4/a6         ;Rcupre A4 et A6.
;\3
               tst.l    gd.bkgr(a5)         ;
               beq.s    disp_radar          ; Affiche la pice courante ventuelle.
               bsr      subr_dispsh         ;
;\3
disp_radar:    tst.b    gd.radar(a5)        ;
               beq.s    set_n               ; Affiche l'img du radar ventuelle.
               bsr      radar_on4           ;
;\2
set_n:         moveq    #-1,d0              ;N = 1.
               rts                          ;Retour avec N = 1.
;\6
;  Table des actions.

               dc.w     act_exsh-act0       ;Dtruire la forme courante.
               dc.w     act_expl-act0       ;Explosion.
               dc.w     act_drop-act0       ;Drop.
               dc.w     game_over-act0      ;Abandon.
act:           dc.w     wait_sig-act0       ;Ne rien faire.
               dc.w     act_down-act0       ;Aller un cran vers le bas.
               dc.w     act_ldwn-act0       ;Aller un cran en bas  gauche.
               dc.w     act_rdwn-act0       ;Aller un cran en bas  droite.
               dc.w     act_rotl-act0       ;Rotation gauche.
               dc.w     act_rotr-act0       ;Rotation droite.
               dc.w     act_left-act0       ;Aller un cran vers la gauche (mme hauteur).
               dc.w     act_righ-act0       ;Aller un cran vers la droite (mme hauteur).
               dc.w     act_paus-act0       ;Pause.
               dc.w     act_radr-act0       ;Radar.
               dc.w     act_mesg-act0       ;Envoi du msg msg_act10.
;\5
;  Pour une position donne de la pice ( une translation prs),  on va calculer le masque (un bit nul pour chaque point
;  visible de la pice), l'img de la pice sur les 6 premiers plans et l'offset de cette img par rapport  l'hex. de rf.
;      D5.L: positions des hex. par rapport  l'hex. de rf.
;      D6.B: nb de petits hex.
;      A3: adr. o il faut stocker les donnes.
;\6
;    Calcul et stockage de l'offset.

shape_image:   move.l   d5,d0               ;Positions des hex. par rapport  l'hex. de rf.
               moveq    #127,d2             ; D2 et D3 contiendront l'offset du point > gauche
               moveq    #127,d3             ; de l'image par rapport  l'hex. de rfrence.
               move.b   d6,d7               ;Nb de petits hex.
calc_offset:   rol.l    #8,d0               ;
               move.b   d0,d4               ; Position du prochain hex.
               ext.w    d4                  ;
               lea      (hexpos.w,pc,d4.w*4),a0  ;A0: ptr sur l'offset (dx,dy) correspondant.
               cmp.w    (a0)+,d2            ;
               ble.s    clco_lbl1           ; D2 = min(D2,dx).
               move.w   -2(a0),d2           ;
clco_lbl1:     cmp.w    (a0),d3             ;
               ble.s    clco_lbl2           ; D3 = min(D3,dy).
               move.w   (a0),d3             ;
clco_lbl2:     subq.b   #1,d7               ; Boucle (passe au
               bne.s    calc_offset         ; prochain hex.).
               subq.w   #1,d2               ;Dcr. l'abscisse: on laisse une colonne vide (pour l'ext. de signe + tard).
               move.w   d2,(a3)+            ; Stocke l'offset juste
               move.w   d3,(a3)+            ; avant le masque.
;\9
;    Calcul et stockage du masque et de l'image.                                                 0
;        Le calcul s'effectue hex. par hex.  On doit commencer par les hex. situs           0       1
;      en bas  droite, car les hex. sont en 3D et on regarde en bas  droite.  On       0       1       2
;      procde donc par range (cf ci-contre); on commence par la 4, et on termine           1       2
;      par la 0. L'hex. de rfrence est celui situ au centre.                          1       2       3
;                                                                                            2       3
               movea.l  a3,a0               ; (A3) contiendra le nb de lignes           2       3       4
               clr.w    (a0)+               ; utilises de l'img - 1.                       3       4
               move.w   #shapwln-1,d0       ; Met  tous les bits du masque   1  (on            4
set_mask:      move.w   #-1,(a0)+           ; annulera + tard ceux qui correspondent
               dbf      d0,set_mask         ;  un bit d'un petit hex.).
               moveq    #4,d4               ;N de la 1re range.
create_img:    movem.l  d1/d5/d6/a4/a6,-(sp)  ;Sauve les registres.
crimg_loop:    moveq    #0,d0               ;
               rol.l    #8,d5               ; D0.L: position du prochain hex.
               move.b   d5,d0               ;
               cmp.b    (hexlin.w,pc,d0.l),d4  ; Branch. s'il n'est pas
               bne      crimg_nxhex            ; dans la bonne range.
               movem.w  (hexpos.w,pc,d0.l*4),d0/d1  ;Coord. par rapport  l'hex. de rfrence.
               subq.l   #4,a3               ; D0/D1: coord. par rapport
               sub.w    (a3)+,d0            ; au point suprieur gauche
               sub.w    (a3)+,d1            ; de l'image.
               cmp.w    (a3),d1             ;
               bls.s    crimg_lbl1          ; (A3) = max{(A3),D1}.
               move.w   d1,(a3)             ;
crimg_lbl1:    addq.w   #6,d0               ; D0.L: abscisse du pixel gauche
               ext.l    d0                  ; de la 1re ligne de l'hex.
               mulu.w   #2*shap_ww,d1       ; A0: adr. de l'ordonne D1
               lea      2(a3,d1.l),a0       ; du masque.
               move.w   10(sp),d2           ;
               sub.b    d6,d2               ; D2.W: (n de l'hex. - 1) x 4.
               lsl.b    #2,d2               ;
               move.b   vcol*4+3(a5,d2.w),d3  ; D3.B: couleur de l'hex. + 1 (de 2
               addq.b   #1,d3                 ;  7): valeur des plans 3, 4, 5.
               move.w   vpat*4+2(a5,d2.w),d1  ;D1.W: n du motif (de 1  255).
               mulu.w   #patlen,d1          ;Multiplie D1 par la taille d'une image contenant un motif.
               lea      ([patterns.w,pc],d1.l,-patlen.w),a2  ;A2: adr. de l'image contenant le motif courant.
               lea      hexmask(pc),a1      ;Liste des abscisses & longueurs des lignes d'un hex.
               moveq    #inhy+3-1,d2        ;D2.W: nb de lignes - 1.
crimg_inner:   move.b   (a1)+,d1            ;Abscisse relative & longueur de la ligne courante.
               move.b   d1,d7               ;
               asr.b    #5,d7               ; D0.L: abscisse de la ligne courante.
               add.b    d7,d0               ;
               andi.b   #%00011111,d1       ;D1.B: longueur de la ligne courante.
               bfclr    (a0){d0:d1}         ;Annule les bits du masque.
               movea.l  a0,a4               ;Adr. de la ligne courante du masque.
               movea.l  a2,a6               ;Adr. de la ligne courante du plan 0 du motif.
               move.b   #3,d5               ;D5.B = 3 (nb de plans du motif). NB: les autres octets de D5 sont inchangs.
crimg_pl012:   lea      shaplen(a4),a4      ;
               bfextu   (a6){0:d1},d7       ;
               bfins    d7,(a4){d0:d1}      ; Recopie la ligne courante du motif
               lea      patpl(a6),a6        ; dans l'image (plans 0, 1, 2).
               subq.b   #1,d5               ;
               bne.s    crimg_pl012         ;
               addq.b   #3,d5               ;D5.B = 3.
crimg_pl345:   lea      shaplen(a4),a4      ;
               ror.b    #1,d3               ;
               smi      d7                  ;
               extb.l   d7                  ; Recopie les plans 3, 4, 5 (couleur).
               bfins    d7,(a4){d0:d1}      ;
               subq.b   #1,d5               ;
               bne.s    crimg_pl345         ;
               rol.b    #3,d3               ;Rcupre D3 (couleur + 1).
               addq.l   #4,a2               ;Adr. de la ligne suivante du motif.
               lea      2*shap_ww(a0),a0    ;Adr. de la ligne suivante du masque.
               dbf      d2,crimg_inner      ;Boucle (passe  la ligne suivante).
crimg_nxhex:   subq.b   #1,d6               ; Boucle (passe au
               bne      crimg_loop          ; prochain hex.).
               movem.l  (sp)+,d1/d5/d6/a4/a6  ;Rcupre les registres.
               dbf      d4,create_img       ;Boucle (passe  la range suivante).
               addi.w   #inhy+3-1,(a3)      ;(A3).W: nb de lignes - 1 de la pice.
               rts                          ;Retour.
;\6
;  Echange V[0..8] et gd.next[0..8].

exg_shapes:    lea      gd.next(a5),a0      ;
               movea.l  a5,a1               ;
               moveq    #8,d0               ;
exgsh_loop:    addq.l   #3,a1               ; Echange les donnes se trouvant dans V[0] 
               move.b   (a1),d1             ; V[8] et celles se trouvant dans gd.next.
               move.b   (a0),(a1)+          ;
               move.b   d1,(a0)+            ;
               dbf      d0,exgsh_loop       ;
radar_rts:     rts                          ;Retour.
;\6
;  Action: radar on/off.

act_radr:      pea      tst_counter(pc)     ;Adr.  laquelle il faut se brancher aprs le sous-prg suivant.
               not.b    gd.radar(a5)        ;Change l'tat du radar.
               bne.s    radar_on0           ;Branch. si le radar est maintenant actif.
               bsr      pl_bwupd            ;Active le smaphore cran si le jeu se droule dans une fentre GEM.
               bmi.s    bra_endwupd         ;Branch. si on est pass en mode PAUSE.
               bsr      radar_off2          ;Efface l'img du radar.
bra_endwupd:   bra      end_windupd         ;Fin de mise  jour de la fentre si le jeu se droule dans une fentre GEM.
;\4
radar_on0:     tst.b    gd.next(a5)         ; Branch. si la prochaine pice est dj dtermine (c'est le
               bne.s    radar_on3           ; cas qd on dsactive, puis ractive immdiatement le radar).
               bsr.s    exg_shapes          ;Recopie les donnes concernant la pice courante dans gd.next.
               moveq    #rul.rulA,d0        ; Dtermination de la prochaine
               bsr      eval_rul            ; pice (partie A de la rgle).
radar_on1:     tst.b    gd.radar(a5)        ; Branch. si le radar
               beq.s    radar_on2           ; n'est pas actif.
               move.l   (a5),d0             ;D0.L: n de la forme.
               lea      ([shap_def.w,pc],d0.l*8,-8.w),a0  ;Ptr sur la df. de la forme D0.
               move.b   (a0),d6             ;D6.B: nb de petits hex. dans la pice.
               move.l   4(a0),d5            ;D5.L: positions des hex. par rapport  l'hex. de rf.
               lea      (gd.imrad,a5),a3    ;A3: adr. o il faut stocker les donnes.
               movea.l  a3,a0               ;
               move.w   #shposlen-1,d0      ; Annule la zone qui contiendra
radar_clr:     clr.w    (a0)+               ; le masque et l'img.
               dbf      d0,radar_clr        ;
               bsr      shape_image         ;Calcule le masque et l'img de la pice suivante.
radar_on2:     bsr.s    exg_shapes          ;Echange V[0..8] et gd.next[0..8].
radar_on3:     tst.b    gd.radar(a5)        ; Retour si le radar
               beq.s    radar_rts           ; n'est pas actif.
               bsr      pl_bwupd            ;Active le smaphore cran si le jeu se droule dans une fentre GEM.
               bmi.s    bra_endwupd         ;Branch. si on n'est pas pass en mode PAUSE.
               pea      end_windupd(pc)     ;Il faudra dsactiver le smaphore cran aprs avoir affich l'img du radar.
radar_on4:     lea      (gd.imrad+4,a5),a0  ;A0: ptr sur le nb de lignes - 1 de l'img.
               moveq    #82+ky,d5           ;
               move.w   nhex(pc),d4         ;
               mulu.w   #10,d4              ; D4.W: 93 + 20n (abscisse).
               sub.w    d4,d5               ; D5.W: 82 + ky - 10n (ordonne).
               add.w    d4,d4               ;
               addi.w   #93,d4              ;
               lea      gd.sbkgr2(a5),a2    ;A2: adr. o il faut stocker l'img de fond.
               lea      gd.arad(a5),a3      ;A3: adr. o il faut stocker l'adr. de l'img de fond dans la mm. video.
               moveq    #1,d7               ;D7.W <> 0.
;\8
;  Sauve le fond.
;      D4.W: abscisse relative  la zone de travail o doit tre affiche l'img.
;      D5.W: ordonne relative  la zone de travail o doit tre affiche l'img.
;      D7.W: flag de sauvegarde des flags de modification.
;      A0: ptr sur le nb de lignes - 1 de l'img.
;      A2: adr. o il faut stocker l'img de fond.
;      A3: adr. o il faut stocker l'adr. de l'img de fond dans la mm. video.

savbg_dispsh:  lea      xlen(pc),a1         ;(A1): xlen, -4(A1): xy0, -8(A1): addr_scr.
               moveq    #0,d0               ; D0.L: taille d'une ligne de
               move.w   (a1),d0             ; l'cran systme en octets.
               add.w    -(a1),d5            ;D5.W: ordonne absolue o doit tre affiche l'image.
               add.w    -(a1),d4            ;D4.W: abscisse absolue o doit tre affiche l'image.
               mulu.w   d0,d5               ;
               add.l    -(a1),d5            ;
               move.w   d4,d2               ; D5.L: adr. o il faut prendre l'img de fond.
               andi.l   #$FFF0,d2           ;
               add.l    d2,d5               ;
               move.l   d5,(a3)             ;Stocke cette adr.
               movea.l  d5,a3               ;Cette adr. sera utilise pour l'affichage.
               move.w   (a0),d2             ;D2: nb de lignes - 1 (compteur).
               move.w   d2,(a2)+            ;Stocke le nb de lignes - 1 juste avant l'img de fond.
savbg_outer:   movea.l  d5,a1               ;
               moveq    #4*shap_ww-1,d3     ; Sauve une ligne de
savbg_inner:   move.l   (a1)+,(a2)+         ; l'img de fond.
               dbf      d3,savbg_inner      ;
               add.l    d0,d5               ;Adr. de la ligne suivante sur l'img source.
               dbf      d2,savbg_outer      ;Boucle (passe  la ligne suivante).
;\8
;  Affiche la pice.
;      D0.L: taille d'une ligne de l'cran systme en octets.
;      D4.W: abscisse relative  la zone de travail o doit tre affiche l'image.
;      D7.W: flag de sauvegarde des flags de modification.
;      A0: ptr sur le nb de lignes - 1 de l'img.
;      A3: adr.  partir de laquelle il faut afficher l'image.

               lea      gd.dflags(a5),a2    ;A2 pointe sur le tableau des flags de modification.
               andi.b   #$F,d4              ; D1.L:  nb de bits du 1er mot
               moveq    #16,d1              ; qu'il faut prendre en compte
               sub.b    d4,d1               ; (entre 1 et 16).
               move.w   (a0)+,d2            ;D2: nb de lignes - 1 (compteur).
dispsh_outer:  movea.l  a3,a1               ;Adr. du segment courant de l'cran.
               movem.w  d0-d2/d7,-(sp)      ;Sauve les registres, 6(SP) = D7.
               move.l   #$FFFF,-(sp)        ;Empile $FFFF.W (les bits nuls indiqueront les mots modifis) et un mot nul.
               moveq    #0,d0               ;D0.L = 0 (offset en bits par rapport au dbut de la ligne du masque).
dispsh_inner:  movem.l  (a1)+,d2-d5         ;Lit le mot courant de l'cran dans chacun des 8 plans --> 4 mots longs.
               bfexts   (a0){d0:d1},d6      ; Lit une partie du masque (si D1 <> 16, alors le bit de signe
               move.w   d6,d7               ; est = 1  cause de la colonne vide laisse lors du calcul du
               swap     d7                  ; masque et de l'image).  Duplique cette partie du masque (mot
               move.w   d6,d7               ; de poids faible) sur le poids fort.
               addq.w   #1,(sp)             ;Incr. le nb de fois que l'on passe dans la boucle interne.
               addq.w   #1,d6               ;C = 0 si le mot devra tre modifi.
               roxr.w   2(sp)               ;Insre le flag de modification dans (SP).
               bmi.s    dispsh_lbl1         ;Branch. si pas de modification.
               and.l    d7,d2               ; Applique le masque  sur chacun
               and.l    d7,d3               ; des plans.  Les points du fond
               and.l    d7,d4               ; visibles sont ceux qui ne font
               and.l    d7,d5               ; pas partie de la pice.
               bfextu   1*shaplen(a0){d0:d1},d7  ;
               swap     d7                       ;
               bfextu   2*shaplen(a0){d0:d1},d6  ;
               move.w   d6,d7                    ;
               or.l     d7,d2                    ;
               bfextu   3*shaplen(a0){d0:d1},d7  ;
               swap     d7                       ; Ajoute les points de l'image
               bfextu   4*shaplen(a0){d0:d1},d6  ; (plans 0  5, les plans 6 et
               move.w   d6,d7                    ; 7 restant nuls).
               or.l     d7,d3                    ;
               bfextu   5*shaplen(a0){d0:d1},d7  ;
               swap     d7                       ;
               bfextu   6*shaplen(a0){d0:d1},d6  ;
               move.w   d6,d7                    ;
               or.l     d7,d4                    ;
               movem.l  d2-d5,-16(a1)       ;Stocke le rsultat sur l'cran.
dispsh_lbl1:   add.b    d1,d0               ;Met  jour l'offset.
               moveq    #16,d1              ;Largeur  considrer: 16 (mot).
               cmpi.b   #shap_bw,d0         ; Boucle si on n'a pas trait
               bcs.s    dispsh_inner        ; toute la ligne.
               move.w   (sp)+,d0            ;Nb de fois qu'on est pass dans la boucle interne.
               move.w   (sp)+,d1            ;Flags de modification de la ligne.
               tst.w    6(sp)               ; Branch. si on ne doit pas sauver les flags de
               bne.s    dispsh_lbl2         ; modification (affichage de l'img du radar).
               rol.w    d0,d1               ; Sauvegarde des flags de modification. Le 1er se trouve
               move.w   d1,(a2)+            ; dans le bit 0, le 2me dans le bit 1, etc...
dispsh_lbl2:   movem.w  (sp)+,d0-d2/d7      ;Rcupre les registres.
               lea      2*shap_ww(a0),a0    ;Ligne suivante (masque et image).
               adda.l   d0,a3               ;Adr. de la ligne suivante sur l'cran.
               dbf      d2,dispsh_outer     ;Boucle (passe  la ligne suivante).
               rts                          ;Retour.
;\6
;  Action: rotation droite.

act_rotr:      lea      gd.rot(a5),a0       ; Branch.  si la pice ne
               move.b   (a0),d0             ; peut pas tourner. D0.B:
               beq.s    tstcntr3            ; priode des rotations.
               move.w   -(a0),d3            ;D3.W: index de la pice dans le tableau des positions.
               subq.w   #1,(a0)             ;
               bcc.s    act_rot             ; Dcr. cet index modulo
               ext.w    d0                  ; la priode, et branch.
               add.w    d0,(a0)             ;  act_rot.
               bra.s    act_rot             ;
;\6
;  Action: rotation gauche (pice suivante dans le tableau).

act_rotl:      lea      gd.rot(a5),a0       ; Branch.  si la pice ne
               move.b   (a0),d0             ; peut pas tourner. D0.B:
               beq.s    tstcntr3            ; priode des rotations.
               move.w   -(a0),d3            ;D3.W: index de la pice dans le tableau des positions.
               addq.w   #1,(a0)             ;
               ext.w    d0                  ; Incr. cet index modulo
               clr.w    d2                  ; la priode.
               cas.w    d0,d2,(a0)          ;
act_rot:       move.w   (a0),d1             ;Nouvel index.
               move.l   (gd.psa.w,a5,d1.w*4),d0  ;Nouvelles positions des hex.
               bsr.s    test_hex            ;Teste si la pice peut tourner.
               beq      disp_shape          ;Branch. si elle a pu tourner (on affiche la nouvelle position).
               move.b   d3,gd.ind+1(a5)     ;Sinon, rcupre l'ancien index.
tstcntr3:      bra.s    tstcntr2            ;Attend un nouveau signal.
;\4
;  Action: un cran vers la droite (mme hauteur).

act_righ:      lea      rlp_righ(pc),a3     ;Fct RUL  valuer (cf fin du fichier).
               bra.s    act_move            ;Branch. pour le dplacement de la pice.
;\4
;  Action: un cran vers la gauche (mme hauteur).

act_left:      lea      rlp_left(pc),a3     ;Fct RUL  valuer (cf fin du fichier).
               bra.s    act_move            ;Branch. pour le dplacement de la pice.
;\4
;  Action: un cran en bas  droite.

act_rdwn:      lea      rlp_rdwn(pc),a3     ;Fct RUL  valuer: 7F 7C C0 C1 51.
               bra.s    act_move            ;Branch. pour le dplacement de la pice.
;\6
;  Action: un cran en bas  gauche.

act_ldwn:      lea      rlp_ldwn(pc),a3     ;Fct RUL  valuer: 7F 7C C0 C5 51.
act_move:      link     a4,#-4              ;Sauve A4, A4 = SP (nouveau ptr de pile), SP += 4 (pile de taille 1).
               bsr      eval_fct            ;Evalue la fct RUL.
               addq.l   #4,sp               ;Libre la mmoire prise par la pile RUL provisoire.
               movea.l  (sp)+,a4            ;Rcupre l'ancien ptr de pile RUL.
               tst.l    d0                  ; Branch. si la nouvelle case contenant
               beq.s    tstcntr2            ; l'hex. de rf. n'existe pas.
               move.l   gd.xref(a5),d4      ;Sauve le ptr sur l'hex. de rf. dans D4.
               move.l   d0,gd.xref(a5)      ;Nouvelle case contenant l'hex. de rf.
               bsr.s    test_hex            ;Teste si la pice peut se dplacer dans la direction voulue.
               beq      disp_shape          ;Branch. si la case peut se dplacer (on affiche la nouvelle position...).
               move.l   d4,gd.xref(a5)      ;Restocke l'ancien ptr (car la pice ne peut pas se dplacer).
tstcntr2:      bra      tst_counter         ;Attend un nouveau signal.
;\4
;  Note bksh_flag: La fentre ne doit pas tre dplace pdt qu'une pice est provisoirement affiche  l'cran, car le
;  """"""""""""""  fond  ne pourrait pas tre facilement raffich   cause de l'entrelacement des plans  (il faudrait
;                  dplacer des parties de mots).  Le drapeau bksh_flag est activ lorsque la fentre ne peut pas tre
;                  dplace.  Quand on reoit un message wm_moved alors que ce drapeau est activ, on active un second
;                  drapeau (bksh_flag+1)  et on sauve les coord. de destination.  Si un autre message wm_moved arrive,
;                  le 1er est alors annul. On ne pourra dplacer la fentre que qd le 1er drapeau sera dsactiv. Les
;                  tests sont effectus dans le cas suivant: aprs la stabilisation de la pice courante.
;\8
;  Routine op_hex. Registres modifis: D0  D2, D5, D6, A0  A3.
;  Entre: D7.B: 0: teste si toutes les cases correspondant aux hex. existent et sont libres.
;                   Sortie: Z = 1 ssi toutes les cases existent et sont libres.
;             <> 0: Stocke les donnes de la pice dans le tableau.
;          A1: A5+gd.xtmp si D7.B = 0, A5+7 si D7.B <> 0.
;          A4  A6: cf interprteur RUL.

pos_nbh:       move.w   gd.ind(a5),d6            ; D5.L: positions des hex. par rapport
               move.l   (gd.psa.w,a5,d6.w*4),d5  ;  l'hex. de rfrence.
               move.w   gd.nbh(a5),d6       ;D6.W: nb d'hex. - 1 dans la pice.
               rts                          ;Retour.
;\4
test_hex:      lea      gd.xtmp(a5),a1      ;A1: adr. o il faut stocker temporairement les ptrs sur les nouvelles cases.
               clr.b    d7                  ;D7.B = 0 (cf ci-dessus).
op_hex:        bsr.s    pos_nbh             ;D5.L: positions des hex., D6.W: nb d'hex. - 1 dans la pice.
tsthex_loop:   rol.l    #8,d5               ;D5.B: position de l'hex. suivant.
               subq.l   #8,sp               ;Rserve 8 octets pour le mini-prg en RUL.
               movea.l  sp,a0               ;Adr. o doit tre stock ce mini-prg.
               move.w   #$7CC0,d0           ;Fct $7C 0: case contenant l'hex. de rf.
               tst.b    d5                  ; Branch. si D5.B = 0 (on teste la
               beq.s    tsthex_end1         ; case contenant l'hex. de rf.).
               moveq    #$7F,d1             ;Fct $7F: adr. d'une case voisine.
               move.b   d1,(a0)+            ;Stocke $7F.
               subq.b   #6,d5               ; Branch. si
               bls.s    tsthex_1to6         ; D5.B  6.
               move.b   d1,(a0)+            ;Stocke $7F.
               move.w   d0,(a0)+            ;Stocke $7C 0.
               lsr.b    #1,d5               ;
               scc      d0                  ; Stocke les 2 arguments y des
               addi.b   #$C0,d5             ; fct $7F suivant la valeur de
               move.b   d5,(a0)+            ; D5.B, puis $51, et value le
               add.b    d0,d5               ; mini-prg...
               bra.s    tsthex_end0         ;
tsthex_1to6:   addi.b   #$C5,d5             ;D5.B  6.
               move.w   d0,(a0)+            ;Stocke $7C 0.
tsthex_end0:   move.b   d5,(a0)+            ;Stocke l'argument y de la fct $7F extrieure.
               bra.s    tsthex_end2         ;Branch. pour stocker $51 et valuer le mini-prg...
tsthex_end1:   move.w   d0,(a0)+            ;Stocke $7C 0.
tsthex_end2:   move.b   #$51,(a0)           ;Fct $51: fin de fct.
               movea.l  sp,a3               ;Adr. du mini-prg en RUL.
               move.l   a1,-(sp)            ;Sauve A1.
               bsr      eval_fct            ;Evalue le mini-prg (rsultat dans D0.L: ptr sur la case contenant l'hex.).
               movea.l  (sp)+,a1            ;Rcupre A1.
               addq.l   #8,sp               ;Libre les 8 octets rservs pour le mini-prg.
               movea.l  d0,a0               ;A0: ptr sur la case.
               tst.b    d7                  ; Branch. si D7.B = 0, i.e.
               beq.s    tsthex_end3         ; s'il s'agit d'un test.
               move.b   (a1),(a0)+          ; Recopie dans le tableau les
               move.b   16(a1),(a0)         ; donnes  concernant  l'hex.
               addq.l   #4,a1               ; courant (couleur et motif).
               dbf      d6,tsthex_loop      ;Boucle (hex. suivant).
               rts                          ;Retour.
;\4
tsthex_end3:   move.l   d0,(a1)+            ;Stocke temporairement le ptr sur la case (0 si la case n'existe pas).
               subq.l   #1,d0               ; Branch. si D0.L = 0, i.e. si la case
               bcs.s    tsthex_rts          ; n'existe pas (retour avec Z = 0).
               tst.b    hex.free(a0)        ;Case libre ?
               dbne     d6,tsthex_loop      ;Boucle si oui.
               bne.s    tsthex_rts          ;Non, branch. (retour avec Z = 0).
               movem.l  gd.xtmp(a5),d0-d3   ; Toutes les cases existent et sont libres. Alors on stocke les
               movem.l  d0-d3,gd.x1(a5)     ; nouvelles positions des hex. (CCR non modifi --> Z = 1).
tsthex_rts:    rts                          ;Retour (rsultat dans le bit Z du CCR).
;\6
;    Rcupre l'ancien fond si une pice est affiche (A1: adr. de l'img de fond, i.e. sbkgr ou sbkgr2).
;        Note: les flags de modification servent d'une part  optimiser, et d'autre part  rcuprer
;          le bon fond (car certaines parties pourraient se chevaucher avec l'img du radar).

restore_bkgr:  move.l   gd.bkgr(a5),d0      ; Retour si pas d'img de
               beq.s    tsthex_rts          ; fond sauvegarde.
               lea      gd.dflags(a5),a2    ;A2 pointe sur le tableau des flags de modification.
               moveq    #-1,d4              ;D4.W < 0.
restore_bkg2:  moveq    #0,d1               ; D1.L: taille d'une ligne de
               move.w   xlen(pc),d1         ; l'cran systme en octets.
               move.w   (a1)+,d2            ;D2: nb de lignes - 1 (compteur).
resbg_outer:   tst.w    d4                  ; Si D4.W = 0, i.e. si on rcupre le fond sous l'img
               beq.s    resbg_lbl1          ; du radar,  D4.W reste nul.  Sinon, on met dans D4.W
               move.w   (a2)+,d4            ; les flags de modification de la ligne.
resbg_lbl1:    movea.l  d0,a0               ;Adr. de la ligne courante dans la mmoire video.
               moveq    #shap_ww-1,d3       ;Nb de groupes de 16 pixels - 1.
resbg_inner:   lsr.w    #1,d4               ; Branch. si on ne doit pas rcuprer le mot courant (pcq il n'a pas t
               bcs.s    resbg_lbl2          ; modifi  l'affichage de la pice). Ce n'est jms le cas qd D4.W = 0.
               move.l   (a1)+,(a0)+         ; Rcupre un mot
               move.l   (a1)+,(a0)+         ; (en fait 8, car
               move.l   (a1)+,(a0)+         ; il y a 8 plans)
               move.l   (a1)+,(a0)+         ; du fond.
               bra.s    resbg_lbl3          ;Branch. pour passer au groupe suivant.
resbg_lbl2:    lea      16(a0),a0           ; On ne transfre rien du tout,
               lea      16(a1),a1           ; mais on incr. les registres.
resbg_lbl3:    dbf      d3,resbg_inner      ;Boucle (passe au groupe de 16 pixels suivant).
               add.l    d1,d0               ;Adr. de la ligne suivante sur l'cran.
               dbf      d2,resbg_outer      ;Boucle (passe  la ligne suivante).
               rts                          ;Retour.
;\6
;    Abscisse minimale de la case (0,0) ("trou"): 147 + 2n        coord. relatives  la zone de travail; n: nb
;    Ordonne minimale de la case (0,0) ("trou"): 182 + ky + 20n  de petits hex. dans un cts du gd hex.

coord_simg:    move.l   gd.xref(a5),d0      ; D0 = (c,h) de l'hex.
               bsr      x_to_ch             ; de rfrence.
               add.w    d0,d0               ;D0.W = 2h.
               move.w   nhex(pc),d4         ;D4.W = n.
               add.w    d4,d4               ;D4.W = 2n.
               move.w   d4,d5               ;D5.W = 2n.
               sub.w    d0,d5               ;D5.W = 2(n-h).
               swap     d0                  ;D0.W = c.
               move.w   d0,d1               ;
               bmi.s    coordsimg2          ; D1.W = -|c|.
               neg.w    d1                  ;
coordsimg2:    add.w    d1,d5               ;D5.W = 2(n-h) - |c|.
               muls.w   #yhex/2,d5          ;D5.W = yhex(n-h) - |c|*yhex/2.
               addi.w   #182+ky,d5          ;D5.W = 192 + ky + yhex(n-h) - |c|*yhex/2: ordonne min. de l'hex. de rf.
               addi.w   #147,d4             ;D4.W = 147 + 2n.
               muls.w   #xhex,d0            ;D0.W = c*xhex.
               add.w    d0,d4               ;D4.W = 147 + 2n + c*xhex: abscisse minimale de l'hex. de rf.
               move.w   gd.ind(a5),d0       ;Angle de rotation de la pice en 1/6 tour (de 0  5), ou index dans le tableau.
               mulu.w   #2*shposlen,d0          ; A0: ptr sur l'offset
               lea      (gd.simg.w,a5,d0.l),a0  ; et l'image.
               add.w    (a0)+,d4            ; Coord. relatives  la zone de travail du
               add.w    (a0)+,d5            ; point o doit tre affiche l'image.
               rts                          ;Retour (rsultat dans D4.W, D5.W et A0).
;\4
stitle:        bsr.s    text_color          ;Slectionne la couleur du titre.
               move.w   efontid(pc),d7      ; Slectionne la fonte de n *efontid si SpeedoGDOS
               bsr      sfont_cb            ; est install. Alignement: centr, base line.
               moveq    #56,d7              ; Fixe la hauteur des
height_trans:  bsr      char_height         ; caractres  56.
trans_mode:    move.w   #md_trans,(a6)      ; Mode trans-
               intvdi   vswr_mode,0         ; parent.
;\3
text_color:    clr.b    (a6)                ;
               move.b   d0,1(a6)            ; Couleur du texte: D0.B.
               intvdi   vst_color,0         ;
;\3
col_align:     bsr.s    text_color          ;Fixe la couleur du texte.
               clr.l    (a6)                ; Alignement: gauche,
               bra      alignment           ; base line.
;\6
;  Fin du jeu.

game_over:     bsr      pl_bwupd            ;Active le smaphore cran si le jeu se droule dans une fentre GEM.
               lea      intin(pc),a6        ;A6: adr. du tableau INTIN.
               move.w   ofontid(pc),d7      ; Slectionne la fonte de n *ofontid
               bsr      set_font1           ; si SpeedoGDOS est install.
               move.w   nhex(pc),d7         ; Fixe la hauteur des carac-
               subq.b   #1,d7               ; tres   4(n-1),  o n est
               lsl.b    #2,d7               ; le nb de petits hex.  dans
               bsr      char_height         ; un ct du gd hex.
               moveq    #gcolor,d0          ; Index de la couleur
               bsr.s    text_color          ; de la ligne.
               lea      ptsin(pc),a0        ; Rect. de clipping: (0,0)-(0,0), i.e. on n'affiche rien; ms on va stocker les caract.
               clr.l    (a0)+               ; dans les buffers  (pour une fonte vect.).  Le fait de ne rien afficher vite d'avoir
               clr.l    (a0)                ; des parasites sur l'cran, car les plans sont modifis les uns aprs les autres.
               bsr      disp_go             ;Praffichage de "game over" (utile en cas de fonte vectorielle).
               bsr      vsync1              ;Attend une interruption VBL si le drapeau vsync_flag est activ.
               bsr      sto_wcoord          ;Rectangle de clipping: zone de travail.
               bsr      disp_go             ;Affiche "game over" et dsactive le clipping.
               bsr      end_windupd         ;Dsactive le smaphore cran si le jeu se droule dans une fentre GEM.
               bsr      move_wind0          ;Dplace la fentre s'il le faut.
               bsr      stop_timer          ;Arrte le timer.
               movea.l  rul_ptr(pc),a6      ;A6: ptr sur le fichier de rgle.
               lea      varflag(pc),a0      ; Dbranche l'ventuelle
               clr.b    (a0)                ; variable du timer.
               moveq    #rul.rulS,d0        ; Partie S de
               bsr      eval_rul            ; la rgle.
               move.l   d0,d7               ;D7.L: score.
               IFNE     REGISTERED
               moveq    #msg_gamov-msg_rul,d0  ; Stocke le score dans la struct. rserve
               bsr      send_msgd7             ; aux msg et envoie le msg msg_gamov.
               ENDIF
               move.l   a5,d0               ; Libre la mmoire associe
               bsr      call_mfree2         ; au jeu (variables...).
               lea      gameflag(pc),a0     ; Dsactive le drapeau de jeu (sert
               clr.b    (a0)                ; pour l'arrt du timer).
               clr.b    d6                  ;D6.B = 0: la liste des scores pourra tre agrandie. D6 est utilis ci-dessous.
               cmp.b    pnam_flag(pc),d6    ; Branch. si pnam_flag = -1, i.e. si la liste des meilleurs scores doit
               bne.s    game_over2b         ; tre inchange (dans ce cas, C = 1, et le branch. suivant sera pris).
               move.w   nhex(pc),d0         ;Nb de petits hex. dans un ct du gd hex.
               lea      rul.nsc6-nhmin(a6,d0.w),a4  ;A4: adr. o est stock le nb de scores (pour nhex petits hex.).
               move.b   4(a4),d1            ;Nb max de scores.
               beq.s    game_over2b         ;Branch. si le nb max. de scores est nul (pas de stockage du score du joueur).
               cmp.b    (a4),d1             ; Branch. si le nb de scores sauvs est diffrent (i.e. <)
               bne.s    add_score           ; du nb max de scores: le score du joueur doit tre sauv.
               lea      rul.nsc6(a6),a0     ;
               clr.w    d2                  ; D3.L: nb de scores sauvs pour tout
               moveq    #0,d3               ; nb de petits hex.   nhex,  i.e. le
gamov_loop:    move.b   (a0)+,d2            ; plus petit score  pour  nhex petits
               add.w    d2,d3               ; hex. est  au rang D3.L - 1  dans la
               cmpa.l   a4,a0               ; liste entire.
               bls.s    gamov_loop          ;
               lea      ([rul.hisc.w,a6],a6.l),a0  ;Adr. de la liste des scores, qui n'est pas vide.
               lsl.w    #5,d3               ;Multiplie D3.W par 32 (taille d'un lment du tableau des scores).
               cmp.l    -8(a0,d3.l),d7      ; Branch. si le score du joueur est  au plus petit
game_over2b:   bls      game_over2          ; score: le score du joueur ne doit pas tre sauv.
               moveq    #1,d6               ;D6.B <> 0: le liste des scores ne sera pas agrandie.
add_score:     mxbios   Gettime,2           ; D5.L: date
               move.l   d0,d5               ; et heure.
               lea      pname(pc),a5        ;A5: adr. du nom du joueur.
               move.b   (a5),d4             ; Branch. s'il y a un nom de joueur (le joueur
               bne.s    add_score2a         ; n'a donc pas besoin de l'entrer au clavier).
AS_REG         reg      d4-d7/a4-a6         ;Registres  sauver.
               movem.l  AS_REG,-(sp)        ;Sauve les registres.
               clr.b    d5                  ;D5.B = 0: le nom vide n'est pas accept (sauf en cas de CTRL-C).
               bsr      chg_pname3          ;Nom du joueur...
               movem.l  (sp)+,AS_REG        ;Rcupre les registres.
               tst.b    (a5)                ; Branch. s'il n'y a pas de nom de joueur (CTRL-C
               beq      game8               ; a t appuy): le score n'est pas sauv.
;\8
;  Rappel (pour l'ajout du score):
;   D4.B: 1er caractre du nom (ou 0) avant que le joueur ait ventuellement entr son nom.
;   D5.L: date et heure (format XBIOS).
;   D6.B: 0 ssi la liste des scores doit tre agrandie.
;   D7.L: score du joueur.
;   A4: ptr sur le nb de scores.
;   A5: ptr sur le nom du joueur.
;   A6: ptr sur le fichier de rgle.
;\4
add_score2a:   move.b   d4,-(sp)            ;Sauve D4.
               movea.l  sfont_addr(pc),a0   ;A0: adr. des donnes sur la fonte n *sfontid, ou 0.
               move.l   a0,d0               ; Branch. si ces donnes
               beq.s    add_score2b         ; n'existent pas.
               movea.l  a5,a1                       ;
               clr.w    d0                          ;
               bra.s    addsco_lbl1                 ; Pour chaque caractre du nom, les flags
addsco_loop0:  bset     #0,(sf.flags-32.w,a0,d0.w)  ; nuls correspondant deviennent positifs.
addsco_lbl1:   move.b   (a1)+,d0                    ;
               bne.s    addsco_loop0                ;
add_score2b:   lea      rul.nsc6(a6),a0     ;
               clr.w    d0                  ;
               moveq    #0,d1               ;
               bra.s    addsco_cmpa1        ;
addsco_loop1:  move.b   (a0)+,d0            ;
               add.w    d0,d1               ;
addsco_cmpa1:  cmpa.l   a0,a4               ;
               bne.s    addsco_loop1        ; D1.L:  nb de scores sauvs  pour n < nhex petits hex.  D2.L:
               move.l   d1,d2               ; nb total de scores sauvs  si la liste des scores  doit tre
               lea      rul.nsc9+1(a6),a2   ; agrandie,  nb de scores sauvs - 1 pour n  nhex petits hex.
               tst.b    d6                  ; dans le cas contraire (-1 car le dernier score pour n = nhex
               beq.s    addsco_loop2        ; petits hex. sera retir). Poids fort de D0.W: 0.
               lea      1(a0),a2            ;
               subq.w   #1,d2               ;
addsco_loop2:  move.b   (a0)+,d0            ;
               add.w    d0,d2               ;
               cmpa.l   a0,a2               ;
               bne.s    addsco_loop2        ;
               lsl.w    #5,d1               ;Multiplie D1 par 32 (taille d'un lment du tableau des scores).
               lea      ([rul.hisc.w,a6],a6.l),a0  ;Adr. de la liste des scores.
               lea      (a0,d1.l),a3        ;A3: adr. du 1er score de la liste pour n = nhex petits hex.
               move.b   (a4),d0             ;D0.W: nb de scores pour n = nhex petits hex.
               beq.s    add_score3          ;Branch. s'il est nul (--> A3: adr. o il faut stocker le score).
               subq.b   #1,d0               ;Dcr. le nb de scores (pour le dbhi).
addsco_loop3:  cmp.l    sco.score(a3),d7    ; Recherche le 1er score < D7. On s'arrte qd on a trouv ce score (A3 contient
               lea      sco.SIZEOF(a3),a3   ; alors l'adr. de l'lment suivant)  ou qd il n'y a plus de score (A3 contient
               dbhi     d0,addsco_loop3     ; alors l'adr. de l'lment suivant le dernier score).
               bls.s    add_score3          ;Branch. si on n'a pas trouv de score < D7.
               lea      -sco.SIZEOF(a3),a3  ;On a trouv un score < D7. A3: adr. de cet lment.
add_score3:    lsl.w    #5,d2               ; A0: adr. du dernier lment  modifier
               adda.l   d2,a0               ; du tableau des scores.
               lea      sco.SIZEOF(a0),a2   ;A2: adr. de fin de cet lment.
               move.l   a2,d4               ; D4.L: taille de la partie
               sub.l    a3,d4               ; du tableau  modifier.
               bra.s    addsco_cmpa2        ; Dcale les lments de (A3)  (A0)  vers le
addsco_loop4:  move.l   -(a0),-(a2)         ; haut de la mmoire.  A la fin de la boucle,
addsco_cmpa2:  cmpa.l   a0,a3               ; A0 = A3: adr. o il faut stocker le nouveau
               bne.s    addsco_loop4        ; score, et A2: adr. de fin de cet lment.
addsco_loop5:  move.b   (a5)+,(a0)+         ; Stocke le nom du joueur
               bne.s    addsco_loop5        ; dans le tableau.
               move.l   d5,-(a2)            ;Stocke la date et l'heure dans le tableau.
               move.l   d7,-(a2)            ;Stocke le score dans le tableau.
               IFNE     REGISTERED
               pea      (a3)                ;Empile l'adr. de la partie modifie du tableau (servira pour le Fwrite).
               suba.l   a6,a3               ;A3: offset de la partie modifie du tableau par rapport au dbut du fichier.
               move.w   #1,-(sp)            ;Mode d'ouverture: criture uniquement.
               pea      string(pc)          ;Nom du fichier (avec chemin).
               mgemdos  Fopen,6             ;Ouvre le fichier (on laisse un mot dans la pile).
               move.l   d0,d7               ;D7.W: handle du fichier.
               bmi.s    gemdos_err3         ;Branch. s'il y a eu une erreur lors de l'ouverture du fichier.
               clr.w    (sp)                ;
               move.w   d7,-(sp)            ; Positionnement dans le fichier sur la partie du tableau
               move.l   a3,-(sp)            ;  modifier (on laisse un mot long dans la pile).
               mgemdos  Fseek,6             ;
               tst.l    d0                  ; Branch. s'il y a
               bmi.s    gemdos_err3         ; eu une erreur.
               move.l   d4,(sp)             ;
               move.w   d7,-(sp)            ; Ecriture de la partie modifie du tableau.
               mgemdos  Fwrite,12           ;
               tst.l    d0                  ; Branch. s'il y a
               bmi.s    gemdos_err3         ; eu une erreur.
               tst.b    d6                  ; Branch. si la liste des scores
               bne.s    add_score4          ; n'a pas t agrandie.
               addq.b   #1,(a4)             ;Incr. le nb de scores pour n = nhex petits hex.
               pea      (a4)                ;Empile l'adr. o se trouve ce nb (servira pour le Fwrite).
               suba.l   a6,a4               ;A4: offset de cet emplacement par rapport au dbut du fichier.
               clr.w    -(sp)               ;
               move.w   d7,-(sp)            ; Positionnement dans le fichier sur cet emplacement
               move.l   a4,-(sp)            ; (on laisse un mot long dans la pile).
               mgemdos  Fseek,6             ;
               tst.l    d0                  ; Branch. s'il y a
               bmi.s    gemdos_err3         ; eu une erreur.
               moveq    #1,d0               ;
               move.l   d0,(sp)             ; Ecriture du nouveau nb de scores
               move.w   d7,-(sp)            ; pour n = nhex petits hex.
               mgemdos  Fwrite,12           ;
               tst.l    d0                  ; Branch. s'il y a
               bmi.s    gemdos_err3         ; eu une erreur.
add_score4:    move.w   d7,-(sp)            ;Handle du fichier.
               mgemdos  Fclose,4            ;Ferme le fichier.
               tst.l    d0                  ; Branch. s'il y a
gemdos_err3:   bmi      gemdos_error        ; eu une erreur.
               ELSE
               tst.b    d6                  ; Branch. si la liste des scores
               bne.s    add_score4          ; n'a pas t agrandie.
               addq.b   #1,(a4)             ;Incr. le nb de scores pour n = nhex petits hex.
add_score4:    ENDIF
               lea      pname(pc),a0        ; Si le joueur a entr son nom,
               move.b   (sp)+,(a0)          ; on restocke un nom vide.
               beq.s    game8               ;Branch. si le joueur a entr son nom (pas besoin d'attendre ESC).
;\4
game_over2:    IFNE     REGISTERED
               move.w   #msg_wesc,d0        ; Envoie le msg
               bsr      send_msg0           ; msg_wesc.
               tst.l    d0                  ;Doit-on revenir au menu principal?
               bne.s    game8               ;Branch. si oui.
               ENDIF
               pea      sig_tstkey2(pc)     ;Adr.  laquelle il faudra se brancher aprs l'ventuel appel de read_msg1.
               lea      -16(sp),sp          ;Rserve de la mmoire pour les messages.
               moveq    #mu_timer,d0        ;Evnement  surveiller si le jeu se droule dans une fentre GEM,
                                            ;en plus de mu_keybd, mu_mesag et mu_button.
               move.w   delay(pc),d7        ;Paramtre pour mu_timer: temps d'attente en ms.
               bsr      wait_evnt           ;Attend un vnement.
               move.b   d0,d7               ;Masque des vnements ayant eu lieu.
               move.l   int_out+8(pc),d6    ;Code d'une touche si l'vnement evnt_keybd a eu lieu.
               lsl.b    #4,d0               ; N = 0 (utile pour le BMI ci-dessous). Branch.
               bcs      read_msg1           ; si l'vnement evnt_mesag a eu lieu.
               lea      20(sp),sp           ;Libre le buffer des messages et dpile l'adr. empile auparavant.
sig_tstkey2:   lea      bksh_flag(pc),a0    ; Voir la note bksh_flag
               sf       (a0)                ; (CCR non affect).
               bmi.s    game8               ;Branch. si on est pass en mode PAUSE.
               lsr.b    #1,d7               ; Branch. si l'vnement evnt_keybd
               bcc.s    game_over2          ; n'a pas eu lieu.
               lsr.l    #8,d6               ;D6.W: tat des touches spciales + scancode.
               cmp.w    gend_key(pc),d6     ; Branch. si ce n'est pas
               bne.s    game_over2          ; la touche gend_key.
game8:         IFEQ     REGISTERED
               bsr      test10              ;Fin du prg si 10 parties ont t joues.
               ENDIF
game4:         bsr      clr_colors1         ;Efface progressivement l'cran.
               bra      game2               ;Retour au menu.
;\8
;  dmem_test: libre tous les blocs de mmoire contenant les images associes aux nb si le bit 0 de backflag
;             est  0  (ce bit est  1 qd les images non dcales sont "valides"; il est annul qd on change
;             de rgle ou qd on libre la mmoire utilise par l'image du fond).
;  free_dmem: libre les blocs de mmoire contenant les images dcales associes aux nb (c'est le cas qd la
;             fentre est dplace ou iconifie).

dmem_test:     clr.b    d3                  ;D3.B = 0: drapeau indiquant qu'il s'agit de dmem_test.
free_dmem:     movea.l  rul_ptr(pc),a0      ;A0: ptr sur le fichier de rgle.
               tst.b    d3                  ; Branch. s'il ne s'agit
               bne.s    free_dmem2          ; pas de dmem_test.
               lea      backflag(pc),a1     ; Branch.  si le bit 0 de
               btst     d3,(a1)             ; backflag est  1 (il ne
               bne.s    dmem_rts            ; faut rien librer).
free_dmem2:    move.w   ([rul.vdef.w,a0],a0.l),d0  ;D0.W: nb de valeurs affiches.
               beq.s    dmem_end            ;Branch. s'il n'y en a aucune.
               move.l   numdata(pc),d1      ; Branch. si les blocs de mmoire
               beq.s    dmem_rts            ; ont dj t librs.
               movea.l  d1,a3               ;Adr. des donnes sur les nb.
dmem_loop:     move.w   d0,-(sp)            ;Sauve D0.
               bsr.s    free_pbpzpm         ;Libre certaines images associes au nb courant.
               addq.l   #num.SIZEOF-num.pm,a3  ;Adr. des donnes sur le nb suivant.
               move.w   (sp)+,d0            ;Rcupre D0.
               subq.b   #1,d0               ; Boucle (passe au
               bne.s    dmem_loop           ; nb suivant).
dmem_end:      tst.b    d3                  ; Retour s'il ne s'agit
               bne.s    dmem_rts            ; pas de dmem_test.
               lea      numdata(pc),a3      ;
               move.l   (a3),d0             ; Libre le bloc de mmoire contenant
               clr.l    (a3)                ; les struct. num  et  annule  le ptr
call_mfree2:   bsr.s    call_mfree          ; correspondant.
               bne      gemdos_error        ;
dmem_rts:      rts                          ;Retour.
;\4
call_mfree:    move.l   d0,-(sp)            ;Empile l'adr. du bloc de mmoire  librer.
               mgemdos  Mfree,6             ;Libre le bloc de mmoire.
               tst.l    d0                  ;Teste s'il y a eu une erreur (rsultat dans Z).
               rts                          ;Retour.
;\4
free_pbpzpm:   lea      num.pb(a3),a3       ;A3: [num.pb, num.pz, num.pm].
               tst.b    d3                  ;
               bne.s    dmem_pz             ; S'il s'agit de dmem_test  (i.e. s'il faut
               move.l   (a3),d0             ; tout librer), alors on libre la mmoire
               bsr.s    call_mfree2         ; associe  l'img non dcale.
               clr.l    (a3)                ;
dmem_pz:       addq.l   #4,a3               ;
               move.l   (a3),d0             ; Libre  la mmoire  associe   l'image
               beq.s    dmem_pm             ; dcale et annule le ptr correspondant,
               bsr.s    call_mfree2         ; si cela n'avait pas dj t fait.
               clr.l    (a3)                ;
dmem_pm:       addq.l   #4,a3               ;
               move.l   (a3),d0             ; Libre  la mmoire  associe  au masque  et au
               beq.s    dmem_next           ; masque invers et annule le ptr correspondant,
               bsr.s    call_mfree2         ; si cela n'avait pas dj t fait.
               clr.l    (a3)                ;
dmem_next:     rts                          ;Retour.

;\6
;    Ŀ
;     Affichage de l'cran de jeu 
;    

disp_game:     movem.l  a4-a6,-(sp)         ;Sauve les registres.
disp_again:    bsr.s    dmem_test           ;Libre la mmoire associe  l'affichage des nb s'il le faut.
               lea      hbk_addr(pc),a0     ;
               lea      (gd.hexbk,a5),a1    ; Met  jour hbk_addr (pour bkgr_image).
               move.l   a1,(a0)             ;
               lea      hbk_req(pc),a0      ; Annule hbk_req, car on doit
               clr.b    (a0)                ; mettre  jour gd.hexbk.
               bsr      bkgr_image          ;Annule la valeur des couleurs de la fentre et affiche l'image de fond.
               movea.l  8(sp),a5            ;A5: ptr sur le fichier de rgle.
               lea      intin(pc),a6        ;A6: ptr sur le tableau INTIN.
               tas      gameflag-intin(a6)  ;Active le drapeau de jeu (sert pour l'arrt du timer).
               movea.l  a5,a4               ; A4: ptr sur la dfinition
               adda.l   rul.vdef(a5),a4     ; des nb  afficher.
               lea      backflag(pc),a0     ; Met  1 le bit 0 de backflag pour indiquer qu'il ne faut pas librer
               bset     #0,(a0)             ; la mmoire associe  l'affichage des nb (bit de validit).
               beq.s    disp_resmem         ;Branch. s'il tait  0, i.e. si la mmoire n'a pas encore t rserve.
               movem.l  a4-a6,-(sp)         ;Sauve les registres.
               movem.l  12(sp),a4-a6        ; Mise  jour des valeurs
               bsr      update_nbrs         ;  afficher.
               movem.l  (sp)+,a4-a6         ;Rcupre les registres.
               bra      disp_lbl1           ;Branch. pour l'affichage (aprs calcul des img dcales et des masques).
;\6
;    Calcul de la hauteur et des coordonnes du nom de la rgle...

disp_resmem:   move.w   nfontid(pc),d7      ; Slectionne la fonte de n *nfontid
               bsr      set_font1           ; si SpeedoGDOS est install.
               bra.s    disp_lbl3
;\2
text_extent:   pea      call_extent(pc)     ; Appelle successivement copy_text
               bra.s    copy_text           ; et call_extent (puis retour).
;\4
cpy_rulname:   bsr      char_height         ;Fixe la hauteur des caractres (D7).
               lea      rul.name(a5),a0     ;Ptr sur le nom de la rgle.
copy_text:     moveq    #-1,d0              ;D0.W contiendra le nb de caractres.
               movea.l  a6,a1               ;Adr. du tableau INTIN.
crn_loop:      addq.w   #1,d0               ;
               clr.b    (a1)+               ; Met le nb de caractres dans D0.W
               move.b   (a0)+,(a1)+         ; et recopie la chane dans INTIN.
               bne.s    crn_loop            ;
               rts                          ;Retour avec le nb de caractres dans D0.
;\4
disp_loop1:    bsr.s    cpy_rulname         ; Fixe la hauteur des caractres et calcule
               bsr      call_extent         ; la largeur de la chane en pixels.
               cmpi.w   #windw-324,d0       ; Branch. si la chane n'est
               bls.s    disp_lbl2           ; pas trop longue.
               subq.w   #4,rul.high(a5)     ;La chane est trop longue. Alors on diminue la hauteur des caractres de 4.
disp_lbl3:     move.w   rul.high(a5),d7     ; Branch. si la hauteur est > 10 (pour tester
               cmpi.w   #10,d7              ; la longueur de la chane);  sinon on laisse
               bhi.s    disp_loop1          ; la hauteur comme elle est.
;\6
;    Calcul de la hauteur max des nb et de leur texte, de manire  ce qu'il n'y ait pas de chevauchement...

disp_lbl2:     move.w   (a4),d6             ;Nb de nb  afficher.
               beq      disp_lbl1           ;Branch. s'il n'y en a aucun.
disp_lbl9:     move.w   #windh-24,d5        ; Hauteur de la partie devant contenir
               sub.w    d7,d5               ; les nb avec leur texte.
               move.w   d6,d1               ;D1.W: compteur.
disp_loop2:    bsr.s    disp_nbdef          ;A3: ptr sur la dfinition du nb D1.
               clr.w    d2                  ;Annule les 8 bits de poids fort de D2.W.
               move.b   nbr.txth(a3),d2     ;Hauteur du texte.
               cmpi.b   #10,d2              ;
               bcc.s    disp_lbl7           ; Si elle est < 10, on
               moveq    #10,d2              ; la prend gale  10.
               move.b   d2,nbr.txth(a3)     ;
disp_lbl7:     clr.w    d3                  ;Annule les 8 bits de poids fort de D3.W.
               move.b   nbr.numh(a3),d3     ;Hauteur du nb.
               cmpi.b   #19,d3              ;
               bcc.s    disp_lbl8           ; Si elle est < 19, on
               moveq    #19,d3              ; la prend gale  19.
               move.b   d3,nbr.numh(a3)     ;
disp_lbl8:     tst.b    nbr.pos(a3)         ;
               beq.s    disp_lbl4           ;
               cmp.w    d2,d3               ; D2: somme des 2 hauteurs + 4 si
               bls.s    disp_lbl5           ; le nom  est situ  au-dessus du
               moveq    #-4,d2              ; nb, sinon max des 2 hauteurs.
disp_lbl4:     addq.w   #4,d2               ;
               add.w    d3,d2               ;
disp_lbl5:     sub.w    d2,d5               ;Soustrait  D5 la hauteur prise par le nom et le nb.
               subq.b   #1,d1               ;Nb prcdent.
               bne.s    disp_loop2          ;Boucle.
               ext.l    d5                  ; D5.W: interligne
               divs.w   d6,d5               ; (si > 0).
               cmpi.w   #10,d5              ;Interligne min: 10 pixels.
               bge.s    disp_lbl6           ;Branch. si l'interligne D5 est   l'interligne min.
               move.w   d6,d1               ;D1.W: compteur.
disp_loop3:    bsr.s    disp_nbdef          ;A3: ptr sur la dfinition du nb D1.
               subq.b   #1,nbr.txth(a3)     ;Retranche 1  la hauteur du texte.
               subq.b   #1,nbr.numh(a3)     ;Retranche 1  la hauteur du nb.
               subq.b   #1,d1               ;Nb prcdent.
               bne.s    disp_loop3          ;Boucle.
               bra.s    disp_lbl9           ;Recommence le calcul de l'interligne, avec des hauteurs + petites.
;\3
disp_nbdef:    move.w   (a4,d1.w*2),d0      ; A3: ptr sur la dfinition
               lea      2(a4,d0.w),a3       ; du nb D1.
               rts                          ;Retour.
;\6
;  hex2dec: conversion d'un nb hexa. D0 en DCB. Autres registres modifis: D1, D2, D3.
;  Si D0 < 0, on renvoie 0. Si D0  10^D1.B, on renvoie 10^D1.B - 1 (en DCB).

d0_zero:       moveq    #0,d0               ; Renvoie 0, car le
               rts                          ; nb est ngatif.
hex2dec:       move.l   d0,d3               ;Nb  convertir en dcimal.
               bmi.s    d0_zero             ;Branch. s'il est ngatif (on renvoie 0).
               moveq    #0,d0               ;D0.L contiendra le rsultat.
               move.w   d1,-(sp)            ;Nb max. de chiffres dcimaux.
               moveq    #7,d1               ;Nb de chiffres dcimaux - 1 dans un mot long.
h2d_loop:      moveq    #0,d2               ; Divise D3 par 10 --> reste
               divu.l   #10,d2:d3           ; dans D2, quotient dans D3.
               or.b     d2,d0               ; Ajoute le chiffre
               ror.l    #4,d0               ;  D0.
               dbf      d1,h2d_loop         ;Boucle (passe au chiffre dcimal suivant).
               move.w   (sp),d1             ; D1.B: nb max. de
               lsl.b    #2,d1               ; chiffres * 4.
               moveq    #1,d2               ;
               lsl.l    d1,d2               ; D2.L = DCB(10^D1.B) - 1.
               subq.l   #1,d2               ;
               tst.b    d3                  ; Branch. si le nb
               bne.s    h2d_toohigh         ; est > 99999999.
               cmp.l    d0,d2               ; Branch. si le nb n'est pas
               bcc.s    h2d_end             ; trop gd (D0 < 10^D1.B).
h2d_toohigh:   move.l   #$99999999,d0       ;D0.L = DCB(10^8 - 1).
               and.l    d2,d0               ;D0.L = DCB(10^D1.B - 1).
h2d_end:       addq.l   #2,sp               ;Dpile le nb max. de chiffres dcimaux.
               rts                          ;Retour.
;\6
;    Cration des struct. num et calcul des coordonnes pour chaque nb...

disp_lbl6:     moveq    #num.SIZEOF,d0      ; Rserve un bloc de
               mulu.w   d6,d0               ; mmoire  pour  les
               bsr      test_malloc         ; struct. num.
               lea      numdata(pc),a0      ; Stocke l'adr. du bloc de
               move.l   d0,(a0)             ; mmoire dans numdata.
               movea.l  d0,a2               ;Adr. du bloc de mmoire.
               moveq    #1,d1               ;D1.W: compteur (de 1  D6).
               move.w   rul.high(a5),d4     ; Ordonne  laquelle est affich
               addq.w   #8,d4               ; le nom de la rgle.
disp_outr1:    bsr.s    disp_nbdef          ;A3: ptr sur la dfinition du nb D1.
               add.w    d5,d4               ;Ajoute l'interligne.
               move.l   ([4.w,sp],d1.w*4,vnum*4.w),d0  ;D0.L: valeur du nb (variable V[vnum+D1]).
               move.w   d1,-(sp)            ;Sauve D1.
               move.b   nbr.max(a3),d1      ;D1.B: nb max. de chiffres (pour hex2dec).
               bsr.s    hex2dec             ;Convertit D0.L en DCB.
               move.w   (sp)+,d1            ;Rcupre D1.
               move.l   d0,num.lv(a2)       ;Stocke cette valeur dans num.lv.
               moveq    #0,d2               ;Annule les 24 bits de poids fort de D2.
               lea      num.th(a2),a0       ;A0: num.[th, nz, nd, ns, ds, dg, dh, ct, cz, cs].
               move.b   nbr.txth(a3),d2     ; Stocke la hauteur du
               move.w   d2,(a0)+            ; texte dans num.th.
               move.b   nbr.min(a3),d2      ; Stocke le nb min de chiffres
               move.w   d2,(a0)+            ;  afficher dans num.nz.
               move.b   nbr.max(a3),d2      ; Stocke le nb max de chiffres
               move.w   d2,(a0)+            ;  afficher dans num.nd.
               moveq    #35,d2              ;
               bfffo    d0{0:32},d0         ; Stocke  le nb de chiffres significatifs
               sub.b    d0,d2               ; (i.e. du 1er chiffre non nul au chiffre
               lsr.b    #2,d2               ; des units) dans num.ns.
               move.w   d2,(a0)+            ;
               move.b   nbr.numh(a3),d0     ; D0.W et D2.W: hauteur
               move.w   d0,d2               ; du nb.
               subi.w   #9,d0               ; Stocke la longueur
               lsr.w    #1,d0               ; d'un segment  dans
               move.w   d0,(a0)+            ; num.ds.
               lsr.w    #2,d2               ; Stocke la distance en 2 chiffres
               move.w   d2,(a0)+            ; conscutifs dans num.dg.
               addq.b   #8,d0               ;D0.W: longueur d'un segment + 8, = largeur d'un chiffre.
               move.w   d0,d3               ;
               add.w    d2,d3               ; Stocke la largeur
               mulu.w   num.nd(a2),d3       ; de  l'image  dans
               sub.w    d2,d3               ; num.xl.
               move.w   d3,num.xl(a2)       ;
               add.b    d0,d0               ;D0.W: 2 x longueur d'un segment + 16.
               subq.b   #7,d0               ; Stocke la hauteur du nb dans num.dh
               move.w   d0,(a0)+            ; (2 x longueur d'un segment + 9).
               moveq    #95,d0              ; Stocke l'index de la couleur
               add.b    d1,d0               ; du texte  associ  D1  dans
               move.w   d0,(a0)+            ; num.ct.
               addq.b   #8,d0               ; Stocke l'index de la couleur des "0"
               move.w   d0,(a0)+            ; non significatifs de D1 dans num.cz.
               addq.b   #8,d0               ; Stocke l'index de la couleur des chiffres
               move.w   d0,(a0)             ; significatifs de D1 dans num.cs.
               moveq    #-1,d0              ;D0.L = 2^32-1 (+ gd nb existant).
               lea      nbr.text(a3),a1     ;Ptr sur les textes (dans chaque langue).
               bra.s    disp_lbl10
disp_innr1:    move.b   (a1)+,d3            ;Code de la langue du texte.
               lea      langlist(pc),a0     ;Liste des codes par prfrence.
disp_loop4:    cmp.b    (a0),d3             ;
               beq.s    disp_lbl11          ; Recherche la langue
               tst.b    (a0)+               ; dans la liste.
               bpl.s    disp_loop4          ;
disp_lbl11:    cmp.l    a0,d0               ; Si cette langue  est avant  celles
               bls.s    disp_lbl12          ; rencontres auparavant (pour le nb
               move.l   a1,num.pt(a2)       ; D1), alors elle est provisoirement
               move.l   a0,d0               ; choisie.
disp_lbl12:    adda.l   d2,a1               ;Saute le texte (il ne nous intresse pas pour le moment).
disp_lbl10:    move.b   (a1)+,d2            ;Longueur du texte (si c'est non nul).
               bne.s    disp_innr1          ;Branch. s'il reste encore des textes.
               move.w   d1,-(sp)            ;Sauve D1.
               lea      num.x0(a2),a0       ;A0: [num.x0, num.x1, num.xt, num.yt, num.xi, num.yi].
               clr.w    num.at(a2)          ;Position du texte si le texte doit tre affich  gauche ou  droite du nb.
               move.w   num.th(a2),d1       ;D1.W: hauteur du texte.
               move.w   num.dh(a2),d2       ;D2.W: hauteur du nb.
               move.w   num.xl(a2),d3       ;D3.W: largeur du nb.
               move.b   nbr.pos(a3),d0      ;Position du texte ?
               beq.s    disp_lbl13          ;Branch. si le texte doit tre au-dessus du nb.
               cmp.w    d1,d2               ;
               bls.s    disp_lbl14          ; D1 = max(hauteur du texte , hauteur du nb).
               move.w   d2,d1               ;
disp_lbl14:    add.w    d1,d4               ;D4: ordonne o doit tre affich le texte.
               tst.b    d0                  ; Branch. si le texte doit
               bmi.s    disp_lbl16          ; tre affich  droite.
               move.w   #xxt-4,(a0)+        ;
               move.w   #windw-35,d1        ;
               sub.w    d3,d1               ;
               move.w   d1,(a0)+            ; Texte affich
               move.w   #xxt,(a0)+          ;
               move.w   d4,(a0)+            ;  gauche.
               addq.w   #4,d1               ;
               move.w   d1,(a0)+            ;
               bra.s    disp_lbl18          ;
disp_lbl16:    addi.w   #xxt+16,d3          ;
               move.w   d3,(a0)+            ;
               move.w   #windw-16,(a0)+     ; Texte affich
               addq.w   #4,d3               ;
               move.w   d3,(a0)+            ;  droite.
               move.w   d4,(a0)+            ;
               move.w   #xxt-15,(a0)+       ;
disp_lbl18:    subq.w   #1,d2               ;
               move.w   d4,(a0)             ; Texte affich  gauche
               sub.w    d2,(a0)             ; ou  droite.
               bra.s    disp_lbl15          ;
disp_lbl13:    addq.b   #1,num.at+1(a2)     ;Position du texte centre: 1 (pour vst_alignment).
               add.w    d1,d4                  ;
               move.w   #xxt,(a0)+             ;
               move.w   #windw-16,(a0)+        ;
               move.w   #(xxt+windw-16)>>1,d1  ;
               move.w   d1,(a0)+               ;
               move.w   d4,(a0)+               ; Texte affich
               addq.w   #4,d4                  ;
               lsr.w    #1,d3                  ; au-dessus.
               sub.w    d3,d1                  ;
               subi.w   #15,d1                 ;
               move.w   d1,(a0)+               ;
               move.w   d4,(a0)                ;
               add.w    d2,d4                  ;
disp_lbl15:    move.w   d4,-(sp)            ;Sauve D4.
               addi.w   #30,num.xl(a2)      ;Largeur de l'image = largeur du nb + 30.
               move.w   num.xl(a2),d0       ;
               addi.w   #15,d0              ; D0.W: place mmoire prise par une ligne.
               andi.b   #$F0,d0             ;
               mulu.w   num.dh(a2),d0       ;Taille de l'image (en octets).
               moveq    #mfdb.SIZEOF,d3     ;D3.L: taille d'une struct. MFDB.
               add.l    d3,d0               ;Taille du bloc de mmoire  rserver.
               movea.l  a2,a3               ;Adr. de la struct. num.
               move.l   d0,d4               ;Taille du bloc de mmoire  rserver.
               bsr      test_malloc         ;Rserve un bloc de mmoire pour la sauvegarde du fond.
               move.l   d0,num.pb(a3)       ;Adr. du bloc rserv, si non nulle.
               move.l   d4,d0               ; Rserve encore un bloc de mmoire (pour
               bsr      test_malloc         ; l'image en format device-specific).
               move.l   d0,-(sp)            ;Sauve l'adr. de ce bloc.
               move.l   d0,-(sp)            ;Empile l'adr. du 2nd bloc rserv.
               move.l   num.pb(a3),-(sp)    ;Empile l'adr. du 1er bloc rserv.
               moveq    #1,d1               ;Compteur et format (cf ci-dessous).
disp_loop8:    move.l   (sp)+,d0            ;Dpile l'adr. du 1er/2nd bloc rserv.
               movea.l  d0,a0               ;Adr. du bloc = adr. de la struct. MFDB.
               add.l    d3,d0               ; Stocke l'adr. de l'image
               move.l   d0,(a0)+            ; dans mfdb.fd_addr.
               move.w   num.xl(a3),d2       ;Largeur de l'image en pixels.
               move.w   d2,(a0)+            ;Stocke la largeur de l'image en pixels dans mfdb.fd_width.
               move.w   num.dh(a3),(a0)+    ;Stocke la hauteur de l'image en pixels dans mfdb.fd_height.
               addi.w   #15,d2              ; Stocke la largeur de
               lsr.w    #4,d2               ; l'image en mots dans
               move.w   d2,(a0)+            ; mfdb.fd_wdwidth.
               move.w   d1,(a0)+            ;Stocke le format (1 ou 0) dans mfdb.fd_stand.
               move.w   #8,(a0)+            ;Stocke le nb de plans dans mfdb.fd_planes.
               clr.l    (a0)+               ;Rservs (0 et 0).
               clr.w    (a0)                ;Rserv (0).
               dbf      d1,disp_loop8       ;Boucle (on considre 2 struct. MFDB).
               suba.l   d3,sp               ;Empile une 3me struct. MFDB.
               clr.l    (sp)                ;Annule mfdb.fd_addr, car il s'agit de l'cran.
               lea      intin(pc),a0          ;
               move.w   #replace,(a0)         ;
               lea      ptsin(pc),a0          ;
               move.l   num.xi(a3),d0         ;
               move.l   d0,d1                 ;
               add.l    xy0(pc),d1            ;
               move.l   d1,(a0)+              ;
               swap     d0                    ;
               add.w    num.xl(a3),d0         ;
               subq.w   #1,d0                 ;
               swap     d0                    ; Recopie  la  zone  (num.xi,num.yi) -
               move.w   num.dh(a3),d1         ; (num.xi+num.xl-1,num.yi+num.dh-1) de
               subq.w   #1,d1                 ; l'cran  (coord. relatives)  dans la
               add.w    d1,d0                 ; 2me zone rserve.
               add.l    xy0(pc),d0            ;
               move.l   d0,(a0)+              ;
               clr.l    (a0)+                 ;
               move.w   num.xl(a3),(a0)       ;
               subq.w   #1,(a0)+              ;
               move.w   d1,(a0)               ;
               bsr      cpyfm                 ;
               move.l   sp,(a1)+              ;
               move.l   mfdb.SIZEOF(sp),(a1)  ;
               bsr      one_vdi               ;
               adda.l   d3,sp               ;Dpile la struct. MFDB srce.
               lea      contrl(pc),a0       ;
               move.w   #vr_trnfm,(a0)+     ;
               clr.l    (a0)+               ; Transforme  l'image au
               clr.w    (a0)                ; format device-specific
               addq.l   #8,a0               ; (2nd bloc) en image au
               move.l   (sp),(a0)+          ; format VDI (1er bloc).
               move.l   num.pb(a3),(a0)     ;
               bsr      hvdi                ;
               move.l   (sp)+,d0            ; Libre l'image au format device-specific
               bsr      call_mfree2         ; et sa struct. MFDB.
               move.w   gfontid(pc),d7      ; Slectionne la fonte de n *gfontid
               bsr      set_font1           ; si SpeedoGDOS est install.
               bra.s    disp_lbl20          ;Branch. (on va tester si le texte n'est pas trop large).
;\4
disp_cpytxt:   movea.l  a6,a2               ;Adr. du tableau INTIN.
               movea.l  num.pt(a3),a0       ;Ptr sur le texte.
               clr.w    d0                  ; Nb de carac-
               move.b   -2(a0),d0           ; tres.
               move.b   d0,d1               ;
disp_loop7:    clr.b    (a2)+               ; Recopie le
               move.b   (a0)+,(a2)+         ; texte dans
               subq.b   #1,d1               ; INTIN.
               bne.s    disp_loop7          ;
               rts                          ;Retour.
;\4
disp_loop9:    bsr      char_height         ;Slectionne la hauteur du texte.
               bsr.s    disp_cpytxt         ;Recopie le texte associ au nb dans le tableau INTIN.
               bsr      call_extent         ;D0.W: largeur du texte en pixels.
               move.w   num.x1(a3),d1       ; D1.W: largeur max. (largeur
               sub.w    num.x0(a3),d1       ; du rectangle de clipping).
               cmp.w    d0,d1               ; Branch. si le texte n'est
               bcc.s    disp_lbl19          ; pas trop large.
               subq.w   #2,num.th(a3)       ;Diminue de 2 la hauteur du texte.
disp_lbl20:    move.w   num.th(a3),d7       ;Hauteur du texte.
               cmpi.w   #9,d7               ; Branch. si elle est > 9, pour tester la largeur
               bhi.s    disp_loop9          ; du texte (8 est la hauteur min.).
disp_lbl19:    move.w   (sp)+,d4            ;Rcupre D4.
               move.w   (sp)+,d1            ;Rcupre D1.
               clr.l    num.pz(a3)          ;Image dcale avec les "0": inexistante.
               clr.l    num.pm(a3)          ;Bloc mmoire contenant le masque: inexistant.
               lea      num.SIZEOF(a3),a2   ;Adr. de la struct. num suivante.
               addq.b   #1,d1               ;Nb suivant.
               cmp.b    d1,d6               ; Boucle s'il reste
               bcc      disp_outr1          ; encore des nb.
;\6
;    Affichage (mais les couleurs restent noires)...

disp_lbl1:     move.w   nfontid(pc),d7      ; Slectionne la fonte de n *nfontid si SpeedoGDOS
               bsr      sfont_cb            ; est install. Alignement: centr, base line.
               moveq    #96+nind,d0         ; Index de la couleur
               bsr      text_color          ; du nom la rgle.
               lea      ptsin(pc),a0        ; Rect. de clipping: (0,0) - (0,0), i.e. on n'affiche rien;  mais on va
               clr.l    (a0)+               ; stocker les caractres dans les buffers (pour une fonte vectorielle).
               clr.l    (a0)                ; Le fait de ne rien afficher  vite d'avoir des parasites sur l'cran,
               bsr      clip_on             ; car les plans sont modifis les uns aprs les autres.
               bsr      disp_rn             ;Praffiche le nom de la rgle.
               move.w   #320,d0             ; Active le clipping: partie de la
               move.w   #windw-4,d1         ; zone de travail  comprise  entre
               bsr      set_clipping        ; x0 = 320 et x1 = windw-4.
               bsr      vsync1              ;Attend une interruption VBL si le drapeau vsync_flag est activ.
               bsr      disp_rn             ;Affiche le nom de la rgle.
               bsr      no_clipping         ;Dsactive le clipping.
;\5
               move.w   (a4),d6             ;Nb de valeurs  afficher.
               beq.s    disp_lbl17          ;Branch. s'il n'y en a aucune.
               move.w   gfontid(pc),d7      ; Slectionne la fonte de n *gfontid
               bsr      set_font1           ; si SpeedoGDOS est install.
               movea.l  numdata(pc),a3      ;Ptr sur le tableau contenant les donnes sur les nb.
;\4
               move.l   a4,-(sp)            ;Sauve A4.
disp_loop6:    lea      intin+2(pc),a6      ;
               clr.w    (a6)                ; Alignement (horizontal: dpend de
               move.w   num.at(a3),-(a6)    ; num.at, vertical: base line).
               bsr      alignment           ;
               move.w   num.th(a3),d7       ; Hauteur:
               bsr      char_height         ; num.th.
               move.b   num.ct+1(a3),d0     ; Couleur du
               bsr      text_color          ; texte.
               movem.w  num.x0(a3),d0/d1    ;D0.W: num.x0, D1.W: num.x1.
               move.w   d1,d5               ;
               sub.w    d0,d5               ; D5.W: longueur max. du texte (en pixels).
               subq.w   #8,d5               ;
               bsr.s    set_clipping        ;Clipping: limites gauches et droites donnes par num.x0 et num.x1.
               move.l   num.xt(a3),d4       ;Coord. relatives du texte.
               lea      disp_cpytxt(pc),a4  ;Routine de copie du texte  afficher dans le tableau INTIN.
               bsr      disp_justif         ;Affiche le texte.
               bsr      no_clipping         ;Dsactive le clipping.
               bsr      update_num          ;Affiche la valeur.
;\4
               lea      num.SIZEOF(a3),a3   ;Donnes correspondant au nb suivant.
               subq.b   #1,d6               ; Boucle tant qu'il reste
               bne.s    disp_loop6          ; encore des nb.
               movea.l  (sp)+,a4            ;Rcupre A4.
disp_lbl17:    bsr      end_windupd         ;Fin de mise  jour de la fentre si le jeu se droule dans une fentre GEM.
;\6
;    Modification des couleurs...

               lea      tcol(pc),a0         ;Adr. o il faut stocker les couleurs des textes associs aux valeurs.
               move.l   rul.ncol(a5),4*nind(a0)  ;Couleur du nom de la rgle.
               move.w   (a4),d6             ;Nb de valeurs  afficher.
               beq.s    disp_end            ;Branch. s'il n'y en a aucune.
               lea      4*8(a0),a1          ;Adr. o il faut stocker les couleurs des "0" non significatifs.
               lea      4*8(a1),a2          ;Adr. o il faut stocker les couleurs des chiffres significatifs.
               moveq    #1,d1               ;N du 1er nb.
disp_loop5:    bsr      disp_nbdef          ;A3: ptr sur la dfinition du nb D1.
               addq.l   #nbr.txtc,a3        ;A3: [nbr.txtc, nbr.zerc, nbr.digc].
               move.l   (a3)+,(a0)+         ;Recopie la couleur du texte associ au nb n D1.
               move.l   (a3)+,(a1)+         ;Recopie la couleur des "0" non significatifs.
               move.l   (a3)+,(a2)+         ;Recopie la couleur des chiffres significatifs.
               addq.b   #1,d1               ;N du nb suivant.
               cmp.b    d1,d6               ; Boucle jusqu'au
               bcc.s    disp_loop5          ; dernier nb.
disp_end:      bsr      chcol               ;Modifie progressivement les couleurs...
               beq      disp_again          ;Branch. si on est pass en mode PAUSE.
               movem.l  (sp)+,a4-a6         ;Rcupre les registres.
               rts                          ;Retour.
;\6
;  Active le clipping sur la partie de la zone de travail comprise entre x0 = D0 et x1 = D1.

set_clipping:  lea      ptsin(pc),a0        ;Adr. o il faut stocker les coord. du rectangle de clipping.
               move.l   xy0(pc),d2          ;Coord. du point suprieur gauche de la zone de travail.
               swap     d2                  ;
               add.w    d2,d1               ;
               add.w    d0,d2               ;
               swap     d2                  ; Stocke les coord. du rectangle
               move.l   d2,(a0)+            ; de clipping.
               move.w   d1,(a0)+            ;
               addi.w   #windh-1,d2         ;
               move.w   d2,(a0)             ;
clip_on:       lea      intin(pc),a0        ;
               move.w   #1,(a0)             ; Active le clipping et retour.
               mvdi     vs_clip,2,1,0       ;
;\6
disp_rn:       move.w   rul.high(a5),d7     ; Fixe la hauteur des caractres et recopie
               bsr      cpy_rulname         ; le nom de la rgle dans INTIN.
               move.l   #(320+windw)<<15,d1 ;
               addq.w   #8,d7               ; Coord.
               move.w   d7,d1               ;
               bra      disp_text           ;Affiche le nom de la rgle, et retour.
;\6
;  Met  jour l'affichage des nb.

update_nbrs:   movea.l  numdata(pc),a0      ;Tableau o sont stockes les donnes concernant l'affichage des nb.
               move.w   ([rul.vdef.w,a6],a6.l),d6  ;D6.W: nb de valeurs affiches.
               lea      vnum0*4(a5),a1      ;
               move.w   d6,d4               ;
               beq.s    updn_rts            ;
               subq.b   #1,d4               ;
updn_loop1:    move.l   (a1)+,d0            ; Retour  si  aucune des valeurs
               move.b   num.nd+1(a0),d1     ; en DCB n'a t modifie depuis
               bsr      hex2dec             ; le dernier affichage.
               cmp.l    num.lv(a0),d0       ;
               lea      num.SIZEOF(a0),a0   ;
               dbne     d4,updn_loop1       ;
               beq.s    updn_rts            ;
               move.w   d6,-(sp)            ;Sauve D6.
               bsr      pl_bwupd            ;Active le smaphore cran si le jeu se droule dans une fentre GEM.
               move.w   (sp)+,d6            ;Rcupre D6.
               movea.l  numdata(pc),a3      ;Tableau o sont stockes les donnes concernant l'affichage des nb.
               clr.w    d7                  ;N du nb  afficher (1er nb: 0) * 4.
               movem.l  a4/a6,-(sp)         ;Sauve A4 et A6.
updn_loop2:    move.l   vnum0*4(a5,d7.w),d0 ;D0.L: valeur  afficher (en hexa).
               move.b   num.nd+1(a3),d1     ;D1.B: nb max. de chiffres dcimaux.
               bsr      hex2dec             ;D0.L: valeur  afficher, en DCB.
               cmp.l    num.lv(a3),d0       ; Branch. si la valeur en DCB n'a pas t
               beq.s    updn_next           ; modifie (pas besoin de rafficher).
               move.w   d7,-(sp)            ;Sauve D7.
               moveq    #35,d2              ;
               bfffo    d0{0:32},d1         ; D2.B: nb de chiffres
               sub.b    d1,d2               ; significatifs.
               lsr.b    #2,d2               ;
               move.l   d0,num.lv(a3)       ;Stocke la valeur en DCB du nb.
               cmp.b    num.ns+1(a3),d2     ; Branch. si le nb de chiffres significatifs n'a pas
               beq.s    updn_update         ; chang (pas besoin de recalculer l'img dcale).
               move.b   d2,num.ns+1(a3)     ;Stocke le nb de chiffres significatifs.
               move.l   a3,-(sp)            ;Sauve A3.
               moveq    #1,d3               ; Libre la mmoire associe  l'img
               bsr      free_pbpzpm         ; dcale et aux masques.
               movea.l  (sp)+,a3            ;Rcupre A3.
updn_update:   bsr.s    update_num          ;Mise  jour des img et affichage.
               move.w   (sp)+,d7            ;Rcupre D7.
updn_next:     lea      num.SIZEOF(a3),a3   ;Donnes sur le nb suivant.
               addq.b   #4,d7               ;N du nb suivant * 4.
               subq.b   #1,d6               ; Boucle (passe au
               bne.s    updn_loop2          ; nb suivant).
               bsr      end_windupd         ;Fin de mise  jour de la fentre si le jeu se droule dans une fentre GEM.
               movem.l  (sp)+,a4/a6         ;Rcupre A4 et A6.
updn_rts:      rts                          ;Retour.
;\2
update_num:    tst.l    num.pz(a3)          ; Branch. si l'image dcale avec
               bne      disp_lbl21          ; les "0" est dj calcule.
;\5
               move.w   num.xi(a3),d4       ;
               add.w    xy0(pc),d4          ;
               neg.b    d4                  ; Met num.xd  jour. D4.W = num.xd.
               andi.w   #$F,d4              ;
               move.w   d4,num.xd(a3)       ;
               move.w   num.xl(a3),d0       ;Largeur, en pixels, de l'image non dcale.
               moveq    #0,d5               ;
               move.w   d0,d5               ; D5.L:  largeur, en
               addi.w   #15,d5              ; octets, de l'image
               lsr.w    #4,d5               ; non dcale.
               add.w    d5,d5               ;
               sub.w    d4,d0               ; D3.W: largeur, en mots,
               lsr.w    #4,d0               ; de l'image dcale avec
               move.w   d0,d3               ; les "0".
               add.w    d0,d0               ; Largeur, en octets,
               move.w   d0,num.ll(a3)       ; de l'image dcale.
               mulu.w   num.dh(a3),d0       ; Taille d'un plan de
               move.l   d0,num.pl(a3)       ; l'image dcale.
               lsl.l    #3,d0               ;Taille totale de l'image dcale.
               bsr      test_malloc         ;Rserve un bloc de mmoire pour cette image.
               move.l   d0,num.pz(a3)       ;Stocke le ptr sur ce bloc.
               movea.l  d0,a0               ;Ptr sur l'image dcale  calculer.
               movea.l  ([num.pb.w,a3]),a1  ;Ptr sur l'image non dcale.
               move.w   num.dh(a3),d2       ; D2.W: nb total de lignes, en comptant
               lsl.w    #3,d2               ; qu'il y a 8 lignes par plan.
               move.w   d3,-(sp)            ;Empile la largeur en mots de l'image dcale.
disp_outr2:    movea.l  a1,a2               ;Ptr sur la prochaine ligne de l'image non dcale.
               move.w   (sp),d3             ;Largeur en mots de l'image dcale.
               move.w   (a2)+,d0            ;1er mot de l'image non dcale.
               lsl.w    d4,d0               ;Dcale ce mot (les D4 premiers bits sont perdus).
disp_innr2:    moveq    #0,d1               ;Annule le mot de poids fort de D1.
               move.w   (a2)+,d1            ;Mot suivant de l'image non dcale.
               lsl.l    d4,d1               ;Dcalage: une partie se trouve dans le mot fort, l'autre dans le mot faible.
               swap     d1                  ; Ajoute la partie gauche de ce mot 
               add.w    d1,d0               ; la partie droite du mot prcdent.
               move.w   d0,(a0)+            ;Stocke le nouveau mot dans l'image dcale.
               swap     d1                  ; Place la partie droite
               move.w   d1,d0               ; dans D0.W.
               subq.b   #1,d3               ; Boucle (mot suivant de
               bne.s    disp_innr2          ; l'image dcale).
               adda.l   d5,a1               ;Ptr sur la ligne suivante de l'image non dcale.
               subq.w   #1,d2               ; Boucle (ligne
               bne.s    disp_outr2          ; suivante).
               addq.l   #2,sp               ;Nettoie la pile.
;\4
               move.w   num.nz(a3),d3       ; D3.W: nb de "0" non significatifs
               sub.w    num.ns(a3),d3       ;  afficher (si > 0).
               bls      disp_lbl21          ;Branch. s'il n'y a pas de "0" non significatif  afficher.
               movea.l  num.pz(a3),a0       ;A0: ptr sur l'image dcale (1er plan), o il faut dessiner les "0".
               move.w   num.cz(a3),d7       ;D7.W: index de la couleur des "0" non significatifs.
               move.w   num.ds(a3),d5       ;D5.W: longueur d'un segment.
               movea.w  num.ll(a3),a1       ;A1: largeur, en octets, de l'image dcale.
               ori.w    #$100,d7            ;Met  1 le bit 8 de D7 (sert  savoir qd on a atteint le dernier plan).
               bra      disp_lbl22
;\4
dvseg2:        move.w   a1,d1               ; Descend  de 3 lignes,  car
               mulu.w   #3,d1               ; on ne trace pas le segment
               adda.l   d1,a0               ; horizontal du milieu.
dvseg:         move.w   d0,-(sp)            ;Sauve D0.  [ Entre: D0.L, D4.L, D5.W, A0, A1 ]
               move.l   a0,-(sp)            ;Sauve A0.
               addq.w   #5,d0               ; Abscisse du segment
               add.w    d5,d0               ; vertival de droite.
               bsr.s    vseg                ;Trace le segment vertical de droite.
               movea.l  (sp)+,a0            ;Rcupre A0.
               move.w   (sp)+,d0            ;Rcupre D0. Trace le segment vertical de gauche.
vseg:          suba.l   a1,a0               ;
               bsr.s    vseg_point          ; Dessine le 1er point.
               adda.l   a1,a0               ;
               move.b   d5,d1               ;Longueur du segment.
vseg_loop:     bfins    d4,(a0){d0:3}       ;
               adda.l   a1,a0               ; Dessine la partie intrieure
               subq.b   #1,d1               ; du segment.
               bne.s    vseg_loop           ;
vseg_point:    addq.w   #1,d0               ;
               bfins    d4,(a0){d0:1}       ; Dessine un point (le 1er ou le dernier).
               subq.w   #1,d0               ;
               rts                          ;Retour.
;\4
hseg2:         bsr.s    hseg                ;Trace le segment horizontal du haut.
               bsr.s    dvseg               ;Trace les 2 segments verticaux du haut.
               bsr.s    dvseg2              ;Trace les 2 segments verticaux du bas.
                                            ;Trace le segment horizontal du bas.
hseg:          addq.w   #4,d0               ; Trace le 1er  [ Entre: D0.L, D4.L, D5.W, A0, A1 ]
               bsr.s    hseg_elem           ; segment.
               addq.w   #3,d0               ;
               addq.b   #2,d5               ; Trace le 2me segment.
               bsr.s    hseg_elem           ;
               addq.w   #5,d0               ; Trace le 3me segment... (NB: D0 n'a
               subq.b   #2,d5               ; globalement pas t modifi).
hseg_elem:     movea.l  a0,a2               ;A2: adr. de la ligne o il faut tracer le segment de longueur D5.
               cmpi.b   #32,d5              ; Branch. si
               bls.s    hseg_leq32          ; D5  32.
               bfins    d4,(a2){d0:32}      ; 32 < D5  64. On trace les
               addq.l   #4,a2               ; 32 premiers pixels.
hseg_leq32:    bfins    d4,(a2){d0:d5}      ;Trace les D5 mod 32 (entre 1 et 32) derniers pixels.
               adda.l   a1,a0               ;Adr. de la ligne suivante.
               subq.w   #4,d0               ;Corrige D0.
               rts                          ;Retour.
;\4
disp_xx:       move.w   num.nd(a3),d0       ;
               sub.w    d2,d0               ;
               move.w   num.dg(a3),d2       ; D0.L: abscisse du 1er chiffre  afficher par
               add.w    d5,d2               ; rapport   l'image dcale.  D2.W:  distance
               addq.w   #8,d2               ; sparant  les pixels correspondants  de deux
               mulu.w   d2,d0               ; chiffres conscutifs.
               sub.w    num.xd(a3),d0       ;
               addi.w   #15,d0              ;
               rts                          ;Retour (rsultat dans D0.L et D2.W).
;\4
disp_nplane:   extb.l   d4                  ;Chaque bit de D4.L est =  la couleur  stocker dans le plan.
               move.w   num.nz(a3),d2       ; D0.L: abscisse du 1er "0"  afficher par rapport  l'image dcale. D2.W:
               bsr.s    disp_xx             ; distance sparant les pixels correspondants de 2 chiffres conscutifs.
               move.w   d3,-(sp)            ;Sauve D3.
               move.l   a0,-(sp)            ;Sauve A0.
disp_nzero:    movea.l  (sp),a0             ;Rcupre A0.
               bsr.s    hseg2               ;Trace les segments.
               add.w    d2,d0               ;Abscisse relative  l'image dcale du prochain "0".
               subq.b   #1,d3               ; Boucle tant qu'il reste
               bne.s    disp_nzero          ; des "0"  afficher.
               addq.l   #4,sp               ;Dpile A0 (mais on ne le rcupre pas).
               move.w   (sp)+,d3            ;Rcupre D3.
disp_lbl22:    lsr.w    #1,d7               ; D4.B = 0 si la couleur  stocker dans le prochain
               scs      d4                  ; plan est 0, D4.B = -1 si la couleur est 1.
               bne.s    disp_nplane         ;Boucle tant qu'il reste des plans.
;\4
disp_lbl21:    move.l   num.pm(a3),d0       ;Ptr sur le masque, si non nul.
               bne.s    disp_lbl23          ;Branch. si la zone de mmoire a dj t rserve.
               move.l   num.pl(a3),d0       ; Taille du bloc de mmoire pour le
               add.l    d0,d0               ; masque et le masque invers.
               bsr      test_malloc         ;Rserve un bloc de mmoire pour le masque et le masque invers.
               move.l   d0,num.pm(a3)       ;Stocke le ptr sur ce bloc.
disp_lbl23:    move.l   num.pl(a3),d1       ;
               movea.l  d0,a0               ;
disp_loop10:   clr.w    (a0)+               ; Annule le masque.
               subq.l   #2,d1               ;
               bne.s    disp_loop10         ;
;\4
               move.w   d6,-(sp)            ;Sauve D6.
               move.w   num.ns(a3),d6       ; Branch. si pas de chiffre
               beq.s    disp_lbl24          ; significatif.
               movea.l  d0,a0               ;A0: adr. du masque.
               move.w   num.ds(a3),d5       ;D5.W: longueur d'un segment.
               movea.w  num.ll(a3),a1       ;A1: largeur, en octets, de l'image dcale.
               move.w   d6,d2               ; D0.L: abs. du 1er chiffre significatif  afficher par rapport  l'image dcale.
               bsr.s    disp_xx             ; D2.W: distance sparant les pixels correspondants de 2 chiffres conscutifs.
               move.l   num.lv(a3),d7       ;Valeur  afficher.
               lsl.b    #2,d6               ; Met le dernier "0" non significatif dans
               ror.l    d6,d7               ; le quartet de poids faible de D7.
disp_loop11:   rol.l    #4,d7               ;Chiffre  afficher dans le quartet de poids faible de D7.
               move.b   d7,d3               ;
               andi.w   #$F,d3              ; D3.B: liste des segments  afficher.
               move.b   segd(pc,d3.w),d3    ;
               lea      segpos-2(pc),a4     ;Tableau des positions des segments; lment -1.
               bra.s    disp_lbl27          ;Branch. pour afficher les segments...
;\9
;   --0--
;  |     |
;  1     2
;  |     |
;   --3--
;  |     |
;  4     5
;  |     |
;   --6--
;\3
segd:          dc.b     %1110111,%0100100,%1011101,%1101101,%0101110  ;0  4.
               dc.b     %1101011,%1111011,%0100111,%1111111,%1101111  ;5  9.
               dc.b     %0001000,0                                    ;- et rien ('-' est utilis par dsc_dispdgt).
;\4
disp_segon:    movea.l  a0,a6               ;Sauve A0.
               move.w   (a4),d1             ;Position du segment.
               bmi.s    disp_lbl28          ;Branch. si c'est un segment vertical.
               move.w   d5,d4               ;
               addq.b   #3,d4               ;
               mulu.w   d4,d1               ;
               move.w   a1,d4               ;
               mulu.w   d4,d1               ; Trace le segment horizontal.
               adda.l   d1,a0               ;
               moveq    #-1,d4              ;
               bsr      hseg                ;
               bra.s    disp_lbl29          ;
disp_lbl28:    move.w   d0,-(sp)            ;C'est un segment vertical. Sauve D0.
               tst.b    d1                  ; Branch. si c'est un segment
               bpl.s    disp_lbl30          ; vertical de gauche.
               addq.w   #5,d0               ; Abscisse du segment
               add.w    d5,d0               ; vertival de droite.
disp_lbl30:    moveq    #3,d4               ;Ordonne relative si c'est un segment du haut.
               add.b    d1,d1               ; Branch. si c'est un
               bpl.s    disp_lbl31          ; segment du haut.
               move.w   d5,d4               ; Calcule l'ordonne relative
               addq.b   #6,d4               ; pour un segment du bas.
disp_lbl31:    move.w   a1,d1               ;
               mulu.w   d4,d1               ;
               adda.l   d1,a0               ; Trace le segment vertical.
               moveq    #-1,d4              ;
               bsr      vseg                ;
               move.w   (sp)+,d0            ;Rcupre D0.
disp_lbl29:    movea.l  a6,a0               ;Rcupre A0.
disp_lbl27:    addq.l   #2,a4               ;Adr. de l'lment suivant du tableau des positions.
               lsr.b    #1,d3               ;C: couleur du segment suivant.
               bcs.s    disp_segon          ;Branch. si le segment est allum.
               bne.s    disp_lbl27          ;Branch. s'il reste des segments allums.
               add.w    d2,d0               ;Abscisse relative du chiffre suivant.
               subq.b   #4,d6               ; Boucle tant qu'il reste des chiffres
               bne.s    disp_loop11         ; significatifs  afficher.
disp_lbl24:    move.w   (sp)+,d6            ;Rcupre D6.
;\4
               movea.l  num.pm(a3),a0       ;A0: adr. du masque.
               move.l   num.pl(a3),d5       ;D5.L: taille du masque en octets.
               lea      (a0,d5.l),a1        ;A1: adr. du masque invers.
               move.l   d5,d0               ;
               movea.l  a0,a2               ;
               movea.l  a1,a4               ;
disp_loop12:   move.w   (a2)+,(a4)          ; Calcule le masque invers.
               not.w    (a4)+               ;
               subq.l   #2,d0               ;
               bne.s    disp_loop12         ;
               move.l   num.xi(a3),d0       ;Coord. relatives de l'image non dcale.
               add.l    xy0(pc),d0          ;Coord. absolues de l'image non dcale.
               move.w   d0,d1               ;D1.W: ordonne absolue de l'image (dcale ou non).
               swap     d0                  ; D0.W: abscisse absolue
               add.w    num.xd(a3),d0       ; de l'image dcale.
               lea      ([addr_scr.w,pc],d0.w),a4  ;
               moveq    #0,d4                      ; A4: adr. o il faut recopier le point suprieur
               move.w   xlen(pc),d4                ; gauche  de l'image dcale.  D4.L: taille d'une
               mulu.w   d4,d1                      ; ligne de l'cran systme, en octets.
               adda.l   d1,a4                      ;
               movea.l  num.pz(a3),a6       ;A6: adr. de l'image dcale.
               move.b   num.cs+1(a3),d0     ;D0.B: couleur des chiffres significatifs.
               move.b   num.dh+1(a3),d7     ;D7.B: compteur (nb de lignes).
disp_outr3:    move.w   num.ll(a3),d3       ; D3.W: largeur en mots d'une ligne
               lsr.w    #1,d3               ; de l'image dcale (1 plan).
               move.l   a4,-(sp)            ;Sauve A4.
disp_innr3:    movea.l  a6,a2               ;Adr. du mot courant du 1er plan de l'image dcale.
               moveq    #7,d2               ;Nb de plans - 1 (compteur).
disp_loop13:   move.w   (a2),d1             ;Mot courant de l'image dcale (plan courant).
               ror.b    #1,d0               ;N: couleur dans le plan courant.
               bpl.s    disp_lbl25          ;
               or.w     (a0),d1             ; Si couleur = 0: on efface certains pts.
               bra.s    disp_lbl26          ; Si couleur = 1: on allume certains pts.
disp_lbl25:    and.w    (a1),d1             ;
disp_lbl26:    move.w   d1,(a4)+            ;Stocke le mot rsultat dans la destination.
               adda.l   d5,a2               ;Adr. du mot courant du prochain plan de l'image dcale.
               dbf      d2,disp_loop13      ;Boucle: passe au prochain plan.
               addq.l   #2,a0               ;Adr. du mot suivant du masque.
               addq.l   #2,a1               ;Adr. du mot suivant du masque invers.
               addq.l   #2,a6               ;Adr. du mot suivant du 1er plan de l'image dcale.
               subq.w   #1,d3               ; Boucle: passe au groupe
               bne.s    disp_innr3          ; de 16 pixels suivant.
               movea.l  (sp)+,a4            ;Rcupre A4.
               adda.l   d4,a4               ;Adr. de la ligne suivante (destination).
               subq.b   #1,d7               ; Boucle: passe  la
               bne.s    disp_outr3          ; ligne suivante.
test10_rts:    rts                          ;Retour.

;\6
;    Ŀ
;     Fin du programme 
;    

               IFEQ     REGISTERED
test10:        lea      sfire+1(pc),a0      ; (sfire+1).b = 65 - 7 * nb
               subq.b   #7,(a0)             ; de parties joues.
               bpl.s    test10_rts          ;Retour si moins de 10 parties ont t joues.
               ENDIF
term:          tst.b    windflag(pc)        ; Branch. si le jeu se droule
               bmi.s    term2               ; dans une fentre GEM.
               moveq    #1,d5               ; Efface progressivement
               bsr      clr_colors2         ; l'cran.
term2:         clr.w    d7                  ;Code de retour = 0 (pas d'erreur).
               bsr      end0                ;Libre ce qui est associ  la VDI, rcupre l'ancien mode graphique.
exit:          IFNE     REGISTERED
               moveq    #msg_exit,d0        ; Envoie le msg
               bsr      send_msg0           ; msg_exit.
               ENDIF
               tst.b    acc_flag(pc)        ; Branch. s'il s'agit d'une application
               beq.s    exit2               ; (et non d'un accessoire).
               lea      int_in(pc),a6       ;
inf_loop:      clr.l    (a6)                ;
               subq.l   #1,(a6)             ; Boucle infinie.
               maes     evnt_timer,2,1,0    ;
               bra.s    inf_loop            ;
exit2:         maes     appl_exit,0,1,0     ;Fonction APPL_EXIT de l'AES.
               tst.b    windflag(pc)        ; Branch. si le jeu se droule
               bmi.s    error               ; dans une fentre GEM.
trap_addr:     move.l   #$E00FB6,-(sp)      ;Adr. de l'ancienne routine appele par trap #usr_trap.
               move.l   #Setexc<<16+$20+usr_trap,-(sp)  ;Empile le n du vecteur d'exception et Setexc.
               trap     #bios               ;Appelle BIOS: remet l'adr. de l'ancienne routine.
               addq.l   #8,sp               ;Nettoie la pile.
               move.l   ledp_addr(pc),d0    ;
               beq.s    error               ; Rcupre la structure LED Panel
               movea.l  d0,a0               ; si elle a t modifie.
               move.b   ledp_flag(pc),(a0)  ;
;\6
;  Fin du programme.

error:         move.w   d7,-(sp)            ;Code de retour (0 si pas d'erreur).
               beq.s    prg_term            ;Branch. si pas d'erreur.
               tst.b    errflag(pc)         ; Branch. si le flag d'affichage
               beq.s    prg_term            ; des msg d'erreur est inactif.
               dispstr  tetrhex_str(pc)     ;Affiche "tetrhex: ".
               move.w   (text_err+2,pc,d7.w*2),d0  ; A0: adr. de la chn
               lea      (text_err,d0.w),a0         ;  afficher.
               pea      (a0)                ;Empile cette adr. pour Cconws.
bar2space:     cmpi.b   #'|',(a0)           ;
               bne.s    b2s_tst             ; Convertit les '|'
               move.b   #' ',(a0)+          ;
b2s_tst:       tst.b    (a0)+               ; en espaces.
               bne.s    bar2space           ;
               move.l   #$0D0A0000,-1(a0)   ;Ajoute un CR/LF.
               move.w   #Cconws,-(sp)       ; Affiche
               trap     #gemdos             ; la chn.
prg_term:      move.w   #Pterm,-(sp)        ;Fct Pterm.
               trap     #gemdos             ;Appelle GEMDOS (fin du prg).
;\7
;  Arrte le timer (au cas o il ne le serait pas encore), rcupre la couleur des pinceaux si le
;  jeu se droule dans une fentre GEM, dtruit la fentre (idem), libre la mmoire associe aux
;  fontes, ferme la station de travail virtuelle, et rcupre l'ancien mode graphique.

end0:          bsr      stop_timer          ;Arrte le timer.
               tst.b    windflag(pc)        ; Branch. si le jeu se droule
               bpl.s    end_prg0            ; sur tout l'cran.
               lea      int_in(pc),a6       ;             
               move.w   whandle(pc),(a6)    ; Ferme la    si le jeu se droule dans
               maes     wind_close,1,1,0    ; fentre.   
               move.w   whandle(pc),(a6)    ; Dtruit la  une fentre GEM.
               maes     wind_delete,1,1,0   ; fentre.   
               bra.s    end_prg1
;\5
;  Stack overflow.

stk_overflow:  moveq    #14,d7              ;D7.W = 14: code de retour.
               movea.l  alert_stck+4(pc),a5 ;Texte de la bote d'alerte  afficher.
               bra.s    alert4              ;Affiche une bote d'alerte, et fin du prg.
;\6
;  Mmoire insuffisante.

insuf_mem:     moveq    #1,d7               ;D7.W = 1: code de retour.
               movea.l  alert_imem+4(pc),a5 ;Texte de la bote d'alerte  afficher.
alert4:        bsr.s    end0                ;Libre ce qui est associ  la VDI, rcupre l'ancien mode graphique.
               bra      alert               ;Affiche une bote d'alerte, et fin du prg.
;\4
end_prg0:      tst.b    screen_sem(pc)      ; Branch. si le smaphore
               bpl.s    end_restcol         ; d'cran est inactif.
               lea      int_in(pc),a0       ; Fct wind_update avec
               move.w   #end_update,(a0)    ; END_UPDATE.
               lea      control(pc),a0      ; Appelle la fct wind_update.  Evidemment,  on
               move.w   #wind_update,(a0)+  ; ne teste pas s'il y a une erreur, car le prg
               bsr      aes1                ; pourrait entrer dans une boucle infinie.
end_restcol:   pea      RGB0(pc)            ;Adr. de la 1re couleur.
               move.w   #256,-(sp)          ;Nb de couleurs.
               clr.w    -(sp)               ;N de la 1re couleur.
               mxbios   VsetRGB,10          ;Appelle Xbios: rcupre la couleur des pinceaux.
;\6
end_prg1:      tst.b    gdosflag(pc)        ;
               beq.s    end_prg2            ; Libre la mmoire associe aux
               lea      intin(pc),a0        ; fontes charges, si SpeedoGDOS
               clr.w    (a0)                ; est install.
               intvdi   vst_unload_fonts    ;
end_prg2:      mvdi     v_clsvwk,0,0        ;CLOSE VIRTUAL WORKSTATION.
;\6
;  Rcupre l'ancien mode graphique (s'il a t chang).

chg_res:       tst.b    chres_flag(pc)      ; Branch. si le mode graphique
               bpl.s    chres_rts           ; n'a pas t chang.
               move.w   graphmode(pc),d0    ; Rcupre l'ancien
               bsr      set_screen          ; mode graphique.
               move.l   #ikbd_dev+8,-(sp)   ; Ractive la
               mbios    Bconout,6           ; souris.
chres_rts:     rts                          ;Retour.
;\5
;  Changement de rsolution impossible.

chres_error:   moveq    #2,d7               ;D7.W = 2: code de retour.
               movea.l  alert_chrs+4(pc),a5 ; Rcupre l'ancien mode graphique, ractive la souris,
               bra.s    alert               ; affiche une bote d'alerte et termine le prg.
;\6
;  Ouverture d'une station de travail virtuelle impossible.

vwks_error:    moveq    #4,d7               ;D7.W = 4: code de retour.
               movea.l  alert_vwks+4(pc),a5 ;Texte de la bote d'alerte  afficher.
alert:         bsr.s    chg_res             ;Rcupre l'ancien mode graphique et ractive la souris.
               moveq    #arrow,d0           ; Souris: forme
               bsr      mgr_mouse           ; d'une flche.
               lea      int_in(pc),a0       ; Stocke  le n de l'unique bouton
               move.w   #1,(a0)             ; (bouton par dfaut) dans int_in.
               lea      string(pc),a6       ;Adr. du buffer o doit tre recopie la chane.
               move.l   a6,addrin-int_in(a0)  ;Stocke cette adr. dans addrin.
               move.l   #'[1][',(a6)+       ;
               move.l   #'TETR',(a6)+       ;
               move.l   #'HEX:',(a6)+       ;
               move.b   #'|',(a6)+          ;
alert_loop:    move.b   (a5)+,(a6)+         ; Ecrit dans le buffer string:
               bne.s    alert_loop          ; [1][TETRHEX:|"chane".][OK].
               subq.l   #1,a6               ;
               move.w   #'.]',(a6)+         ;
               move.l   #'[OK]',(a6)+       ;
               clr.b    (a6)                ;
               maes     form_alert,1,1,1    ;Fct FORM_ALERT de l'AES.
               bra      exit                ;Fin du prg (code de retour dans D7).
;\6
;  Impossible de crer une fentre.

window_error:  moveq    #5,d7               ;D7.W = 5: code de retour.
               movea.l  alert_wind+4(pc),a5 ;Texte de la bote d'alerte  afficher.
alert3:        mvdi     v_clsvwk,0,0        ;CLOSE VIRTUAL SCREEN WORKSTATION.
               bra.s    alert               ;Affiche une bote d'alerte, et fin du prg.
;\5
;  Problme de fonte.

font_error:    moveq    #6,d7               ;D7.W = 6: code de retour.
               movea.l  alert_font+4(pc),a5 ;Texte de la bote d'alerte  afficher.
               bra.s    alert3              ;Ferme la station de travail, affiche une bote d'alerte, et fin du prg.

;\7
;    Ŀ
;     Premire cl 
;    

               IFGT     REGISTERED
key1:          dcb.b    32,0                ;Premire cl.
               ENDIF

;\7
;    Ŀ
;     Interprteur RUL 
;    

;  Point d'entre: eval_rul.
;    D0: en entre: offset par rapport au dbut du fichier .RUL de l'offset du prg RUL.
;        en sortie: valeur de retour.
;    A4: ptr de pile du prg en RUL.
;    A5: ptr sur les variables.
;    A6: ptr sur le fichier de rgle.
;\6
;  Sous-prg eval_expr:
;    Registres librement utiliss: D1, D2, A0, A1, A2.
;    D0: en entre: valeur de retour de la dernire expr. (s'il y en a eu une).
;        en sortie: valeur de retour de l'expr.
;    A3: compteur du prg en RUL.
;    A4, A5, A6: cf eval_rul.
;\4
;  Evalue une expr. sur les cases voisines non vides d'une case fixe.

rul_setns:     move.w   #-1,-(sp)           ; Empile un nb non nul: les cases doivent
               bra.s    rul_setnbr          ; contenir un petit hexagone.
;\6
;  Evalue une expr. sur les cases voisines d'une case fixe.

rul_setna:     clr.w    -(sp)               ;Empile 0: on considre toutes les cases voisines.
rul_setnbr:    bsr      get_2expr           ;Lit 2 expr.: n de la variable et adr. de la case.
               pea      (a5,d0.l*4)         ;Empile l'adr. de cette variable.
               move.l   d1,-(sp)            ;Empile l'adr. de la case de rfrence.
               moveq    #5,d1               ;D1.L: va de 5  0 (les 6 directions).
rul_setnblp:   move.l   d1,-(sp)            ;Sauve le n de la direction.
               move.l   d0,-(sp)            ;Sauve la valeur de la dernire expr.
               move.l   8(sp),d0            ;Adr. de la case de rfrence.
               bsr      rul_xnbr0           ;D0.L: adr. de la case voisine dans la direction D1.
               tst.l    d0                  ; Branch. si cette case
               beq.s    rul_setnbn1         ; n'existe pas.
               tst.w    16(sp)              ;
               beq.s    rul_setnbev         ; Branch.  rul_setnbn1
               movea.l  d0,a0               ; si  l'expr.  ne  doit
               tst.b    (a0)                ; pas tre value.
               beq.s    rul_setnbn1         ;
rul_setnbev:   move.l   d0,([12.w,sp])      ;Stocke l'adr. de la case dans la variable.
               move.l   (sp)+,d0            ;Rcupre la valeur de la dernire expr.
               move.l   a3,-(sp)            ;Sauve l'adr. de l'expr.  valuer.
               bsr.s    eval_expr2          ;Evalue l'expr.
               movea.l  (sp)+,a3            ;Rcupre l'adr. de l'expr.  valuer.
               bra.s    rul_setnbn2         ;Branch. car la valeur de la dernire expr. a dj t rcupre.
rul_setnbn1:   move.l   (sp)+,d0            ;Rcupre la valeur de la dernire expr.
rul_setnbn2:   move.l   (sp)+,d1            ;Rcupre le n de la direction.
               dbf      d1,rul_setnblp      ;Boucle (prochaine direction).
               addq.l   #4,sp               ; Evalue l'expr. sur la
               bra.s    rul_setend          ; case inexistante.
;\4
rul_speed:     bsr.s    eval_expr2          ;
               moveq    #96,d1              ;
               mulu.w   d0,d1               ; Fixe  le temps  entre 2 descentes successives
               divu.w   #1000,d1            ; d'une pice (on ajoute 1/96 s, et on arrondit
               addq.w   #1,d1               ; par dfaut au 1/96 s prs).
               move.w   d1,gd.downt(a5)     ;
               rts                          ;
;\4
;  Evalue une expr. sur l'ensemble des cases non vides.

rul_setes:     move.w   #-1,-(sp)           ; Empile un nb non nul: les cases doivent
               bra.s    rul_setexist        ; contenir un petit hexagone.
;\6
;  Evalue une expr. sur l'ensemble des cases du gd hexagone.

rul_setea:     clr.w    -(sp)               ;Empile 0: on considre toutes les cases.
rul_setexist:  bsr.s    eval_expr2          ;Lit une expr.: n de la variable qui contiendra l'adr. de la case.
               pea      (a5,d0.l*4)         ;Empile l'adr. de cette variable.
               movea.l  gd.array(a5),a0     ;Adr. du tableau du jeu (1re case).
               move.w   nh2(pc),d1          ; D1.W: nb total de
               lsr.b    #2,d1               ; cases,  y compris
               mulu.w   d1,d1               ; les inexistantes.
rul_setexlp:   pea      4(a0)               ;Empile l'adr. de la case suivante.
               tst.l    (a0)                ; Branch. si la case
               beq.s    rul_setexnx         ; n'existe pas.
               tst.w    8(sp)               ;
               beq.s    rul_setexev         ; Branch.  rul_setexnx si l'expr.
               tst.b    (a0)                ; ne doit pas tre value.
               beq.s    rul_setexnx         ;
rul_setexev:   move.l   a0,([4.w,sp])       ;Stocke l'adr. de la case dans la variable.
               move.l   a3,-(sp)            ;Sauve l'adr. de l'expr.  valuer.
               move.w   d1,-(sp)            ;Sauve le nb de cases restantes.
               bsr.s    eval_expr           ;Evalue l'expr.
               move.w   (sp)+,d1            ;Rcupre le nb de cases restantes.
               movea.l  (sp)+,a3            ;Rcupre l'adr. de l'expr.  valuer.
rul_setexnx:   movea.l  (sp)+,a0            ;Adr. de la case suivante.
               subq.w   #1,d1               ;Dcr. le nb de cases restantes.
               bne.s    rul_setexlp         ;Boucle tant qu'il reste des cases.
rul_setend:    movea.l  (sp)+,a0            ;
               clr.l    (a0)                ; Evalue l'expr. sur la
               addq.l   #2,sp               ; case inexistante.
eval_expr2:    bra.s    eval_expr           ;
;\4
rul_timer:     bsr.s    eval_expr2          ;Lit une expr.
               lea      varflag(pc),a0      ;A0: adr. de varflag.
               tst.l    d0                  ;Doit-on brancher ou dbrancher une variable?
               spl      (a0)                ;Met  jour varflag (CCR non affect).
               bmi.s    rultimer_rts        ;Branch. si la variable doit tre dbranche.
               lea      (a5,d0.l*4),a1      ;A1: adr. de la variable  brancher au timer.
               move.l   a1,varaddr-varflag(a0)  ;Stocke l'adr. de la variable dans varaddr.
rultimer_rts:  rts                          ;Retour.
;\2
rul_pause:     move.b   gd.pause(a5),d0     ; Renvoie vrai (-1) ssi
               bra.s    rul_extb1           ; on est en mode pause.
;\6
;  Conversion adresse --> hauteur.

rul_x2h:       bsr.s    rul_x2ch            ;Mot de poids fort de D0: 4h.
               swap     d0                  ;D0.B = 4h.
               lsr.b    #2,d0               ;D0.B = h.
               bra.s    rul_extb1           ;Renvoie h (mot long).
;\6
;  Conversion adresse --> colonne.

rul_x2c:       bsr.s    rul_x2ch            ;D0.B = c + n - 1.
               sub.b    nhex+1(pc),d0       ;D0.B = c - 1.
               addq.b   #1,d0               ;D0.B = c.
               bra.s    rul_extb1           ;Renvoie c (mot long).
;\6
rul_x2ch:      bsr.s    eval_expr           ;Lit une expr.: adr. de la case.
rul_2ch:       sub.w    gd.x00+2(a5),d0     ;D0.W: 4c(2n-1) + 4h (peut tre ngatif).
               add.w    nh3(pc),d0          ;D0.W: 4(c+n-1)(2n-1) + 4h, avec 0  4h < 4(2n-1).
               ext.l    d0                  ; On divise par nh2 = 4(2n-1). Poids faible:
               divu.w   nh2(pc),d0          ; c + n - 1. Poids fort: reste 4h.
               rts                          ;Retour.
;\2
rul_xpat:      move.w   #hex.pat,-(sp)      ; Renvoie le n du motif de l'hexagone x, 0 si la
               bra.s    rul_xinfo           ; case est vide, -1 si elle est inexistante.
;\6
;  Renvoie la couleur de l'hexagone x, sinon 0.

rul_xcol:      move.w   #hex.col,-(sp)      ;Empile 0 (couleur: offset 0 par rapport au dbut des infos de la case x).
rul_xinfo:     bsr.s    eval_expr           ;Lit une expr.: adr. de la case, ou 0 si inexistante.
               move.w   (sp)+,d1            ;Offset de la donne  lire par rapport au dbut des infos de la case x.
               movea.l  d0,a0               ;Adr. de la case x.
               subq.l   #1,d0               ; Branch. (renvoie -1) si la
               bcs.s    rul_xcolrts         ; case est inexistante.
               moveq    #0,d0               ; D0.L: donne (couleur ou
               move.b   (a0,d1.w),d0        ; motif, 0 si case vide).
rul_xcolrts:   rts                          ;Retour.
;\6
;  Point d'entre de l'interprteur.

eval_rul:      movea.l  a6,a3               ; A3: ptr sur le
               adda.l   (a6,d0.l),a3        ; prg en RUL.
eval_fct:      pea      eval_fct(pc)        ;Empile l'adr. de retour de eval_expr (i.e. boucle infinie).
eval_expr:     move.b   (a3)+,d1            ;D1.B: commande RUL.
               bpl.s    not_const           ;Branch. si ce n'est pas une cte.
               subi.b   #$C0,d1             ; C'est une cte comprise
               move.b   d1,d0               ; entre -64 et 63.
rul_extb1:     extb.l   d0                  ;On l'tend sur 32 bits.
               rts                          ;Retour.
;\6
rul_fct:       move.w   (a3)+,d1            ;Offset de la fct  valuer.
               pea      (a3)                ;Sauve l'adr. de retour RUL.
               lea      -2(a3,d1.w),a3      ;Adr. de la fct RUL.
               bsr.s    eval_fct            ;Evalue la fct (rsultat dans D0).
               movea.l  (sp)+,a3            ;Rcupre l'adr. de retour RUL.
               rts                          ;Retour.
;\3
rul_bra:       move.w   (a3)+,d1            ;
rul_bra2:      lea      -2(a3,d1.w),a3      ; Branch. relatif.
               bra.s    eval_expr           ;
;\5
rul_readexpr:  move.l   d0,-(sp)            ;Sauve la valeur de l'expr. prcdente.
               bsr.s    eval_expr           ;Evalue une expr.
               move.l   d0,d2               ;Valeur de cette expr.
               move.l   (sp)+,d0            ;Rcupre la valeur de l'expr. prcdente.
               rts                          ;Retour.
;\5
rul_if16:      bsr.s    rul_readexpr        ;D2: valeur de l'expr. suivante.
               move.w   (a3)+,d1            ;Offset (en cas de branch.).
               tst.l    d2                  ;Valeur de l'expr. de test = 0 ?
               beq.s    eval_expr           ;Oui, excute la prochaine commande.
               bra.s    rul_bra2            ;Non, branch. relatif.
;\4
rul_if8:       bsr.s    rul_readexpr        ;D2: valeur de l'expr. suivante.
               move.b   (a3)+,d1            ;Offset (en cas de branch.).
               tst.l    d2                  ;Valeur de l'expr. de test = 0 ?
               beq.s    eval_expr           ;Oui, excute la prochaine commande.
               ext.w    d1                  ;
               addq.w   #1,d1               ; Non, branch. relatif.
               bra.s    rul_bra2            ;
;\5
rul_abs:       bsr.s    eval_expr           ;
               tst.l    d0                  ;
               bpl.s    rul_absrts          ; Valeur abs.
               neg.l    d0                  ;
rul_absrts:    rts                          ;
;\3
rul_sq:        bsr.s    eval_expr           ;
               muls.w   d0,d0               ; Carr.
               rts                          ;
;\3
rul_not:       bsr.s    eval_expr           ;
               not.l    d0                  ; Not logique.
               rts                          ;
;\3
rul_push:      bsr.s    eval_expr           ;
               move.l   d0,-(a4)            ; Empile la valeur d'une expr.
               rts                          ;
;\5
not_const:     ext.w    d1                  ;D1.W: commande RUL sur 16 bits.
               cmpi.b   #$40,d1             ; Branch. si c'est
               bcs.s    read_var            ; une variable.
               move.w   cmd-$80(pc,d1.w*2),d1  ;D1.W: offset du sous-prg de commande par rapport  cmd.
               jmp      cmd(pc,d1.w)        ;Branch. au sous-prg de commande.
;\6
rul_rcl:       bsr.s    eval_expr           ;Evalue une expr. (sera le n de la variable).
               move.l   d0,d1               ;N de la variable  lire.
read_var:      move.l   (a5,d1.w*4),d0      ;Renvoie la valeur de la variable.
               IFEQ     REGISTERED          ; Dans la version non enregistre,
rul_msg:       ENDIF                        ; rul_msg: RTS.
               rts                          ;Retour.
;\4
rul_refx:      bsr.s    eval_expr           ;Lit une expr. x.
               tst.l    d0                  ; Branch. si x < 0: on renvoie
               bmi.s    rul_nhexsh          ; le nb d'hex. de la pice.
               move.l   (gd.xref.w,a5,d0.l*4),d0  ; Adr. de l'hex. x de la pice
               rts                                ; courante (0: hex. de rf.).
rul_nhexsh:    move.w   gd.nbh(a5),d0       ;
               addq.b   #1,d0               ; Renvoie le nb d'hex.
               ext.l    d0                  ; de la pice.
               rts                          ;
;\4
rul_array:     bsr      eval_expr           ;Lit une expr.: indice.
               moveq    #0,d1               ; D1.L: taille n
               move.b   (a3)+,d1            ; du tableau.
               move.l   d1,-(sp)            ;Sauve la taille du tableau.
               bsr      rul_mod0            ;D0.L: indice entre 0 et n-1.
               move.l   (sp)+,d1            ;Rcupre la taille du tableau.
               rts                          ;Retour.
;\6
;  Element d'un tableau de constantes sur 16 bits.

rul_arr16:     bsr.s    rul_array           ;D0.L: indice entre 0 et n-1, D1.L: taille du tableau.
               move.w   (a3,d0.l*2),d0      ;D0.W: Elment du tableau.
               ext.l    d0                  ;Elment du tableau sur 32 bits.
               lsl.l    #1,d1               ;D1.L: taille du tableau en octets.
rul_arrend:    adda.l   d1,a3               ;A3: fin du tableau.
               rts                          ;Retour.
;\6
;  Element d'un tableau de constantes sur 32 bits.

rul_arr32:     bsr.s    rul_array           ;D0.L: indice entre 0 et n-1, D1.L: taille du tableau.
               move.l   (a3,d0.l*4),d0      ;D0.L: Elment du tableau.
               lsl.l    #2,d1               ;D1.L: taille du tableau en octets.
               bra.s    rul_arrend          ;A3: fin du tableau. Retour.
;\6
;  Table de branchements 16 bits.

rul_arrbra:    move.l   d0,-(sp)            ;Sauve la valeur de la dernire expr.
               bsr.s    rul_array           ;D0.L: indice entre 0 et n-1.
               lea      (a3,d0.l*2),a3      ;Adr. de l'lment du tableau.
               move.w   (a3),d0             ;Offset.
               lea      (a3,d0.w),a3        ;Nouvelle valeur du compteur du prg RUL.
               move.l   (sp)+,d0            ;Rcupre la valeur de la dernire expr.
               rts                          ;Retour.
;\4
cmd:           dc.w     rul_add-cmd,rul_sub-cmd,rul_mul-cmd,rul_div-cmd
               dc.w     rul_asl-cmd,rul_asr-cmd,rul_if8-cmd,rul_mod-cmd
               dc.w     rul_c16-cmd,rul_c32-cmd,rul_equ-cmd,rul_ne-cmd
               dc.w     rul_less-cmd,rul_high-cmd,rul_leq-cmd,rul_geq-cmd
               dc.w     rul_fct-cmd,rul_rtn-cmd,rul_bra-cmd,rul_if16-cmd
               dc.w     rul_not-cmd,rul_and-cmd,rul_or-cmd,rul_xor-cmd
               dc.w     rul_rand16-cmd,rul_rand32-cmd,rul_rcl-cmd,rul_sto-cmd
               dc.w     rul_next-cmd,rul_pause-cmd,rul_timer-cmd,rul_speed-cmd
               dc.w     rul_arr16-cmd,rul_arr32-cmd,rul_arrbra-cmd,rul_push-cmd
               dc.w     rul_read-cmd,rul_pull-cmd,rul_abs-cmd,rul_sq-cmd
               dc.w     rul_rand15-cmd,rul_rand31-cmd,rul_min-cmd,rul_max-cmd
               dc.w     rul_cmp2-cmd,rul_msg-cmd,rul_end-cmd,rul_remove-cmd
               dc.w     rul_nhex-cmd,rul_ch2x-cmd,rul_x2h-cmd,rul_x2c-cmd
               dc.w     rul_setns-cmd,rul_setna-cmd,rul_setes-cmd,rul_setea-cmd
               dc.w     rul_mtst-cmd,rul_mchg-cmd,rul_mclr-cmd,rul_mset-cmd
               dc.w     rul_refx-cmd,rul_xpat-cmd,rul_xcol-cmd,rul_xnbr-cmd
;\2
rul_rtn:       addq.l   #4,sp               ; Retour de fct (i.e. on dpile l'adr. eval_fct). Attention! si cette
               rts                          ; commande est mal situe, une mauvaise adr. peut tre dpile.
;\4
rul_next:      bsr      eval_expr           ;Lit une expr.
               tst.b    gd.radar(a5)        ; Branch. si le radar est dsactiv
               beq.s    rul_zero            ; (on renvoie 0).
               tst.l    d0                  ;
               bmi.s    rul_flag            ; Branch. si D0 n'est pas compris
               subq.l   #8,d0               ; entre 0 et 8 (on renvoie -1).
               bhi.s    rul_flag            ;
               moveq    #0,d0                     ; Renvoie la donne qui
               move.b   (gd.next+8.w,a5,d0.l),d0  ; correspondra  V[D0].
               rts                          ;Retour.
;\6
;  Met une ou toutes les marques sur une case.

rul_setall:    smi      (a0)                ;Met toutes les marques.
               rts                          ;Retour.
rul_mset:      bsr.s    rul_mark            ;A0: ptr sur les flags de la case x, D0: x, D1: marque.
               bmi.s    rul_setall          ;Branch. s'il faut mettre toutes les marques.
               subq.b   #8,d1               ;
               bcc.s    rul_mtaset          ; Branch. s'il s'agit d'un "test and set".
               addq.b   #8,d1               ;
               bset     d1,(a0)             ;Met la marque y.
               rts                          ;Retour.
rul_mtaset:    bset     d1,(a0)             ;Met la marque y.
               sne      d0                  ; D0.L: rsultat
               bra.s    rul_extb3           ; du test.
;\6
;  Enlve une ou toutes les marques d'une case.

rul_clrall:    clr.b    (a0)                ;Enlve toutes les marques.
               rts                          ;Retour.
rul_mclr:      bsr.s    rul_mark            ;A0: ptr sur les flags de la case x, D0: x, D1: marque.
               bmi.s    rul_clrall          ;Branch. s'il faut enlever toutes les marques.
               subq.b   #8,d1               ;
               bcc.s    rul_mtaclr          ; Branch. s'il s'agit d'un "test and clr".
               addq.b   #8,d1               ;
               bclr     d1,(a0)             ;Enlve la marque y.
               rts                          ;Retour.
rul_mtaclr:    bclr     d1,(a0)             ;Enlve la marque y.
               sne      d0                  ; D0.L: rsultat
               bra.s    rul_extb3           ; du test.
;\6
;  Change une ou toutes les marques d'une case.

rul_chgall:    not.b    (a0)                ;Change toutes les marques.
               rts                          ;Retour.
rul_mchg:      bsr.s    rul_mark            ;A0: ptr sur les flags de la case x, D0: x, D1: marque.
               bmi.s    rul_chgall          ;Branch. s'il faut changer toutes les marques.
               subq.b   #8,d1               ;
               bcc.s    rul_mtachg          ; Branch. s'il s'agit d'un "test and chg".
               addq.b   #8,d1               ;
               bchg     d1,(a0)             ;Change la marque y.
               rts                          ;Retour.
rul_mtachg:    bchg     d1,(a0)             ;Change la marque y.
               sne      d0                  ; D0.L: rsultat
               bra.s    rul_extb3           ; du test.
;\7
;  Teste si une case est marque.

rul_mtst:      bsr.s    rul_mark            ;
               btst     d1,(a0)             ; Teste si la case x a la
rul_flag:      sne      d0                  ; marque  y;  renvoie  un
rul_extb3:     extb.l   d0                  ; boolen (-1 ou 0).
               rts                          ;
;\6
rul_mark:      bsr.s    get_2expr           ;Lit 2 expr.: case x et marque y.
               tst.l    d0                  ; Si la case est inexistante, on renvoie
               beq.s    rul_rtn             ; tjrs 0 (2 rts successifs).
               movea.l  d0,a0               ; Ptr sur les flags
               addq.l   #hex.marks,a0       ; de la case x.
               tst.l    d1                  ;Teste le signe de D1 (si ngatif, on devra considrer toutes les marques).
               rts                          ;Retour.
;\6
;  Conversion coordonnes --> adresse.

rul_zero:      moveq    #0,d0               ; D0.L = 0: case
               rts                          ; inexistante.
rul_ch2x:      bsr.s    get_2expr           ;Lit 2 expr.
rul_ch2x2:     move.w   d0,d2               ;
               ext.l    d2                  ; Branch. si le n de colonne ne tient
               cmp.l    d0,d2               ; pas sur un mot. D2.L: n de colonne.
               bne.s    rul_zero            ;
               tst.w    d2                  ;
               bpl.s    rul_ch2x3           ; D2.L: val. absolue du n de colonne.
               neg.l    d2                  ;
rul_ch2x3:     cmp.w    nhex(pc),d2         ; Branch. si la val. absolue du
               bcc.s    rul_zero            ; n de colonne est trop gd.
               neg.w    d2                  ; D2.L: hauteur de la case la
               add.w    nh4(pc),d2          ; + haute de la colonne.
               cmp.l    d1,d2               ; Branch. si la case demande
               bcs.s    rul_zero            ; est trop haute.
               muls.w   nh2(pc),d0          ;
               add.l    gd.x00(a5),d0       ; Renvoie l'adr.
               lsl.b    #2,d1               ; de la case.
               add.l    d1,d0               ;
               rts                          ;Retour.
;\3
rul_add:       bsr.s    get_2expr           ;
               add.l    d1,d0               ; Addition.
               rts                          ;
;\3
rul_sub:       bsr.s    get_2expr           ;
               sub.l    d1,d0               ; Soustraction.
               rts                          ;
;\3
rul_mul:       bsr.s    get_2expr           ;
               muls.l   d1,d0               ; Multiplication.
               rts                          ;
;\3
rul_div:       bsr.s    get_2expr           ;
               divs.l   d1,d0               ; Division entire.
               rts                          ;
;\3
rul_and:       bsr.s    get_2expr           ;
               and.l    d1,d0               ; And logique.
               rts                          ;
;\3
rul_or:        bsr.s    get_2expr           ;
               or.l     d1,d0               ; Or logique.
               rts                          ;
;\3
rul_xor:       bsr.s    get_2expr           ;
               eor.l    d1,d0               ; Xor logique.
               rts                          ;
;\3
rul_asl:       bsr.s    get_2expr           ;
               asl.l    d1,d0               ; Dcalage  gauche.
               rts                          ;
;\3
rul_asr:       bsr.s    get_2expr           ;
               asr.l    d1,d0               ; Dcalage  droite.
               rts                          ;
;\6
get_2expr:     bsr      eval_expr           ;
               move.l   d0,-(sp)            ; Lit  2 expressions.
               bsr      eval_expr           ; Leurs valeurs  sont
               move.l   d0,d1               ; places respective-
               move.l   (sp)+,d0            ; ment dans D0 et D1.
               rts                          ;
;\5
rul_equ:       bsr.s    get_2expr           ;
               cmp.l    d1,d0               ; D0.B: test ==.
               seq      d0                  ;
rul_extb2:     extb.l   d0                  ;Extension 8 bits --> 32 bits.
               rts                          ;Retour.
;\4
rul_less:      bsr.s    get_2expr           ;
               cmp.l    d1,d0               ; D0.B: test <.
               slt      d0                  ;
               bra.s    rul_extb2           ;Extension  32 bits et retour.
;\4
rul_high:      bsr.s    get_2expr           ;
               cmp.l    d1,d0               ; D0.B: test >.
               sgt      d0                  ;
               bra.s    rul_extb2           ;Extension  32 bits et retour.
;\3
rul_ne:        bsr.s    rul_equ             ;Test ==.
rul_nenot:     not.l    d0                  ;Inverse le rsultat --> test !=.
               rts                          ;Retour.
;\2
rul_geq:       bsr.s    rul_less            ;Test <.
               bra.s    rul_nenot           ;Inverse le rsultat --> test . Retour.
;\2
rul_leq:       bsr.s    rul_high            ;Test >.
               bra.s    rul_nenot           ;Inverse le rsultat --> test . Retour.
;\6
;  Modulo.

rul_mod:       bsr.s    get_2expr           ;Lit 2 expr. x et y.
rul_mod0:      tst.l    d0                  ; Branch. si
               bmi.s    rul_modneg          ; x < 0.
rul_modpos:    bfffo    d1{0:32},d2         ;D2: nb de 0  gauche du 1er 1 de poids fort.
               lsl.l    d2,d1               ;Dcale D1  gauche de faon  ce que le MSB de D1 soit  1.
rul_modloop:   cmp.l    d1,d0               ;
               bcs.s    rul_mod2            ;
               sub.l    d1,d0               ; Calcule le modulo.
rul_mod2:      lsr.l    #1,d1               ;
               dbf      d2,rul_modloop      ;
               addx.l   d1,d1               ;Rcupre la valeur initiale de D1.
               rts                          ;Retour.
;\6
rul_modneg:    neg.l    d0                  ;
               bsr.s    rul_modpos          ; Calcule x%y (rsultat  0).
               neg.l    d0                  ;
               beq.s    rul_modrts          ;Branch. si rsultat nul.
               add.l    d1,d0               ;Sinon, on ajoute y --> rsultat entre 1 et y-1.
rul_modrts:    rts                          ;Retour.
;\4
rul_min:       bsr.s    get_2expr           ;
               cmp.l    d1,d0               ; Minimum de
               bgt.s    rul_d1              ; 2 expr.
               rts                          ;
;\4
rul_max:       bsr.s    get_2expr           ;
               cmp.l    d1,d0               ; Maximum de
               blt.s    rul_d1              ; 2 expr.
               rts                          ;
;\4
rul_sto:       bsr.s    get_2expr           ;Lit 2 expr.
               lsl.w    #2,d0               ;Multiplie la 1re valeur par 4.
               lea      (a5,d0.l),a0        ;Adr. de la variable si 0  D0 < $100 (sinon dcalage de $100).
               bmi.s    rul_stoadd          ;Branch. si c'est un +=.
               cmpi.w   #$100,d0            ; Branch. si c'est
               bcc.s    rul_stosub          ; un -=.
               move.l   d1,(a0)             ;Stocke la valeur de la 2de expr.
rul_d1:        move.l   d1,d0               ;C'est aussi la valeur de retour.
               rts                          ;Retour.
;\6
x_to_ch:       bsr      rul_2ch             ;
               sub.w    nhex(pc),d0         ; Mot de poids fort de
               addq.w   #1,d0               ; D0: c.  Mot de poids
               swap     d0                  ; faible de D0: h.
               lsr.b    #2,d0               ;
x2ch_rts:      rts                          ;Retour.
;\6
;  Adr. d'une case voisine.

rul_xnbr:      bsr      get_2expr           ;Lit 2 expr.: adr. de la case courante et direction (modulo 6).
rul_xnbr0:     tst.l    d0                  ; Branch. si la case est inexistante
               beq.s    x2ch_rts            ; (renvoie 0).
               divs.w   #6,d1               ; D1.W: direction (nb compris
               swap     d1                  ; entre -5 et 5).
               tst.w    d1                  ;
               bpl.s    rul_xnbr2           ; D1.W: direction (entre 0 et 6).
               addq.w   #6,d1               ;
rul_xnbr2:     bsr.s    x_to_ch             ;D0.L = (c,h).
               moveq    #1,d2               ; Mot de poids fort de D2: 1,
               swap     d2                  ; mot de poids faible: 0.
               subq.b   #1,d1               ; Branch. suivant
               bcs.s    rul_dir_dd          ; la direction:
               beq.s    rul_dir_rd          ; 0: rul_dir_dd (hexagone situ au-dessous).
               subq.w   #2,d1               ; 1: rul_dir_rd (hexagone en bas  droite).
               bcs.s    rul_dir_ru          ; 2: rul_dir_ru (hexagone en haut  droite).
               beq.s    rul_dir_uu          ; 3: rul_dir_uu (hexagone situ au-dessus).
               subq.w   #1,d1               ; 4: rul_dir_lu (hexagone en haut  gauche).
               beq.s    rul_dir_lu          ; 5: pas de branch. (hexagone en bas  gauche).
               sub.l    d2,d0               ;Dcr. le n de colonne.
               bpl.s    rul_xnbr3           ;Branch. s'il est maintenant  0 (la hauteur reste alors la mme).
rul_dir_dd:    subq.w   #1,d0               ;Dcr. la hauteur.
rul_xnbr3:     move.w   d0,d1               ; D1.L:
               ext.l    d1                  ; hauteur.
               swap     d0                  ; D0.L: n de
               ext.l    d0                  ; colonne.
               bra      rul_ch2x2           ;Branch. pour finir de calculer l'adr. de la nouvelle case.
rul_dir_rd:    tst.l    d0                  ; Si  le n de colonne
               bmi.s    rul_dir_rd2         ; est  0, on dcr. la
               subq.w   #1,d0               ; hauteur.
rul_dir_rd2:   add.l    d2,d0               ;Incr. le n de colonne.
               bra.s    rul_xnbr3           ;Branch. pour calculer l'adr. de la nouvelle case.
rul_dir_ru:    tst.l    d0                  ; Branch. si le n de colonne est  0 (on incr.
               bpl.s    rul_dir_rd2         ; alors seulement le n de colonne).
               addq.w   #1,d0               ;Sinon, on incr. la hauteur...
               bra.s    rul_dir_rd2         ;et le n de colonne. Puis on calcule l'adr. de la nouvelle case.
rul_dir_lu:    sub.l    d2,d0               ;Dcr. le n de colonne.
               bmi.s    rul_xnbr3           ;Branch. s'il est maintenant < 0 (la hauteur reste alors la mme).
rul_dir_uu:    addq.w   #1,d0               ;Incr. la hauteur.
               bra.s    rul_xnbr3           ;Branch. pour calculer l'adr. de la nouvelle case.
;\3
rul_stoadd:    add.l    d1,$100(a0)         ;Effectue "var += D1".
               move.l   $100(a0),d0         ;Valeur du rsultat.
               rts                          ;Retour.
;\3
rul_stosub:    sub.l    d1,-$100(a0)        ;Effectue "var -= D1".
               move.l   -$100(a0),d0        ;Valeur du rsultat.
               rts                          ;Retour.
;\2
rul_nhex:      move.w   nhex(pc),d0         ; Nb de petits hexagones dans
               bra.s    rul_extl            ; un ct du gd hexagone.
;\3
rul_c16:       move.w   (a3)+,d0            ;
rul_extl:      ext.l    d0                  ; Cte sur 16 bits (tendue sur 32 bits).
               rts                          ;
;\2
rul_c32:       move.l   (a3)+,d0            ; Cte  sur
               rts                          ; 32 bits.
;\2
rand24:        mxbios   Random,2            ; Renvoie un nb alatoire
               rts                          ; sur 24 bits.
;\2
rul_rand16:    bsr.s    rand24              ; Random sur
               bra.s    rul_extl            ; 16 bits.
;\6
rul_rand32:    bsr.s    rand24              ;
               move.w   d0,-(sp)            ;
               bsr.s    rand24              ; Random sur
               swap     d0                  ; 32 bits.
               move.w   (sp)+,d0            ;
               rts                          ;
;\3
rul_rand15:    bsr.s    rand24              ;
               andi.w   #$7FFF,d0           ; Random sur 15 bits (positif).
               bra.s    rul_extl            ;
;\3
rul_rand31:    bsr.s    rul_rand32          ;
               lsr.l    #1,d0               ; Random sur 31 bits (positif).
               rts                          ;
;\2
rul_read:      move.l   (a4),d0             ; Lit le nb situ sur le
               rts                          ; sommet de la pile.
;\2
rul_pull:      move.l   (a4)+,d0            ; Dpile
               rts                          ; un nb.
;\4
rul_cmp2:      bsr      eval_expr           ;Lit une expr.
               move.l   d0,-(sp)            ;Sauve la valeur x.
               bsr      get_2expr           ;Lit 2 expr. y et z.
               move.l   (sp)+,d2            ;Rcupre x, qui est mis dans D2.
               cmp.l    d0,d2               ;
               slt      d0                  ; D0.L = (x < y) - (x > z), i.e. en
               cmp.l    d1,d2               ; supposant que y  z, on renvoie 0
               sgt      d1                  ; si  y  x  z,  on renvoie -1  si
               sub.b    d1,d0               ; x < y, et on renvoie 1 si x > z.
               extb.l   d0                  ;
               rts                          ;Retour.
;\5
rul_remove:    pea      (a3)                ;Sauve le compteur de prg.
               bsr.s    rul_end             ;Dtruit des petits hex.
               movea.l  (sp)+,a3            ;Rcupre le compteur de prg (CCR non affect).
               bne.s    rul_remove          ;Boucle si au moins un petit hex. a t dtruit.
               rts                          ;Retour.
;\4
RULEND_REGS    reg      d3-d7/a3/a6         ;Registres  sauver.
rul_end:       bsr      get_2expr           ;Lit 2 expr. (D1.B: marque des hex.  dtruire).
               movem.l  RULEND_REGS,-(sp)   ;Sauve les registres.
               lea      rulend_rm(pc),a6    ;
               move.w   d1,-(sp)            ; Dtruit les hex. marqus D1,
               bsr.s    scan_array          ; qui n'est pas modifi.
               movem.w  (sp)+,d1            ;
               beq.s    rulend_end          ;Branch. si aucun hex. n'est  dtruire (Z = 1).
               lea      rulend_mv(pc),a6    ; Dplace les hex.
               bsr.s    scan_array          ; vers le bas.
               subq.w   #1,gd.npix(a5)      ;gd.npix(A5) = -1 (on devra recalculer l'ordre d'effacement des pixels). Z = 0.
rulend_end:    movem.l  (sp)+,RULEND_REGS   ;Rcupre les registres (CCR non affect).
rulend_rts1:   rts                          ;Retour (rsultat dans le bit Z du CCR).
;\4
coord_dl:      movea.l  gd.array(a5),a0     ;A0: adr. du tableau du jeu.
               move.w   #165,d4             ;
               moveq    #10,d5              ; D4.W: abscisse min.  des cases de la 1re
               move.w   nhex(pc),d7         ; colonne:  165 - 16n.  D5.W: ordonne min.
               mulu.w   d7,d5               ; de la case la + basse de la 1re colonne:
               addi.w   #192+ky,d5          ; 192 + ky + 10n.  (Coord. par rapport  la
               lsl.b    #4,d7               ; zone de travail).
               sub.b    d7,d4               ;
               add.w    xy0(pc),d4          ;D4.W: abscisse min. absolue.
               add.w    xy0+2(pc),d5        ;D5.W: ordonne min. absolue.
               move.w   nh4(pc),d2          ;D2.W: nb de colonnes - 1 (compteur).
               rts                          ;Retour.
;\4
scan_array:    bsr.s    coord_dl            ;A0: tableau de jeu, D4/D5: coord. case en bas  gauche, D2: nb de colonnes - 1.
               lea      gd.hex(a5),a1       ;A1: adr. de la zone o il faut stocker les donnes.
               clr.w    d6                  ;D6.W: index de la case existante courante.
               clr.b    d7                  ;D7.B contiendra le nb d'hex.  dtruire.
rulend_outer:  move.w   nh4(pc),d3          ;D3.W: nb de cases (existantes ou non) par colonne - 1 (compteur).
               clr.w    gd.hex-2(a5)        ;Cf rulend_mv.
               move.w   d5,-(sp)            ;Sauve D5 (ordonne de la + basse case).
rulend_inner:  jsr      (a6)                ;Sous-prg.
               subi.w   #yhex,d5            ;Ordonne de la case suivante.
               tst.l    (a0)+               ; Incr. l'index D6 si la
               beq.s    rulend_lbl1         ; case existe.  A0: adr.
               addq.b   #1,d6               ; de la case suivante.
rulend_lbl1:   dbf      d3,rulend_inner     ;Boucle (passe  la case situe au-dessus).
               move.w   (sp)+,d5            ;Rcupre D5 (ordonne de la + basse case).
               addi.w   #xhex,d4            ;Abscisse de la colonne suivante.
               moveq    #yhex/2,d3          ;
               cmp.b    nhex+1(pc),d2       ; Ordonne de la case la
               bcc.s    rulend_lbl2         ; + basse  de la colonne
               moveq    #-yhex/2,d3         ; suivante.
rulend_lbl2:   add.w    d3,d5               ;
               dbf      d2,rulend_outer     ;Boucle (passe  la colonne suivante).
               tst.b    d7                  ; Branch. s'il n'y a aucun hex.
               beq.s    rulend_rts1         ;  dtruire/dplacer (Z = 1).
;\6
;  Efface/remplace les hex. se trouvant dans rmd.hex. D7.B: nb d'hex. concerns.
;    Les effacements/remplacements des hex. sont effectus simultanment pixel par pixel. L'ordre
;    dans lequel les pixels sont modifis est alatoire, mais il est le mme pour chaque hex.

move_hex:      bsr      rm_pixel            ; Finit de calculer l'ordre dans lequel
               bne.s    move_hex            ; les pixels seront effacs.
               lea      gd.pix+2*npix(a5),a3  ;A3: adr. o sont stockes les coord. des pixels.
               moveq    #0,d4               ;Annule les 24 bits de poids fort de D4.
               moveq    #0,d1               ;Annule les 24 bits de poids fort de D1.
               move.l   #8<<16+npix,-(sp)   ;(SP).W = 8 (cf ci-dessous); 2(SP).W: nb de pixels dans un petit hex. (compteur).
               lea      counter(pc),a2      ; Annule le compteur
               clr.w    (a2)                ; du timer.
mvhex_nxtpix:  subq.w   #1,(sp)             ;
               bne.s    mvhex_lbl3          ;
               addq.w   #8,(sp)             ;
               lea      counter(pc),a2      ; On attend 1/96 s tous les 8 pixels.
mvhex_wait:    tst.w    (a2)                ;
               beq.s    mvhex_wait          ;
               addq.w   #1,(a2)             ;
mvhex_lbl3:    moveq    #0,d0               ; D0.L: n de la ligne contenant
               move.b   -(a3),d0            ; le pixel  modifier.
               move.b   -(a3),d1            ;D1.L: abscisse du pixel (par rapport au pixel le +  gauche de l'hex.).
               move.w   xlen(pc),d2         ; D2.L: valeur  ajouter  l'adr. de la 1re ligne pour
               mulu.w   d0,d2               ; obtenir l'adr. de la ligne contenant le pixel.
               lsl.w    #5,d0               ;Multiplie D0.L par 32 (taille totale d'une ligne en octets).
               lea      gd.hex(a5),a2       ;A2: adr. o sont stockes les donnes concernant les hex.
               move.b   d7,d6               ;D6.B: nb d'hex.  effacer/remplacer (compteur).
mvhex_nxthex:  movea.l  (a2)+,a0            ;Adr. de la 1re ligne de l'hex.  effacer/remplacer.
               move.b   (a2)+,d4            ;Abscisse relative au pixel le +  gauche de l'hex.
               adda.l   d2,a0               ;
               add.b    d1,d4               ;
               move.l   d4,d5               ; (A0){D4:1}: bit  modifier
               andi.b   #$0F,d4             ; du 1er plan.
               andi.b   #$F0,d5             ;
               adda.l   d5,a0               ;
mvhex_lbl1:    move.b   (a2)+,d5            ;D5.B: 0 si effacement, > 0 si rempl. par l'hex. situ D5 cases au-dessus.
               beq.s    mvhex_remove        ;Branch. si effacement.
               addq.l   #4,a2               ;Saute le mot long suivant (utile seulement en cas de remplacement).
               ext.w    d5                  ;
               muls.w   #-yhex,d5           ; A1: adr. du pixel
               muls.w   xlen(pc),d5         ; de l'hex. source.
               lea      (a0,d5.l),a1        ;
               moveq    #7,d3               ;
mvhex_nxtpl1:  bfextu   (a1){d4:1},d5       ;
               bfins    d5,(a0){d4:1}       ; Recopie un pixel
               addq.l   #2,a1               ; sur les 8 plans.
               addq.l   #2,a0               ;
               dbf      d3,mvhex_nxtpl1     ;
               bra.s    mvhex_lbl2
mvhex_remove:  movea.l  (a2)+,a1            ;Adr. de l'img contenant le fond.
               adda.l   d0,a1               ;A1: adr. de la ligne du fond contenant le pixel source.
               moveq    #7,d3               ;
mvhex_nxtpl2:  bfextu   (a1){d1:1},d5       ;
               bfins    d5,(a0){d4:1}       ; Recopie un pixel
               addq.l   #4,a1               ; sur les 8 plans.
               addq.l   #2,a0               ;
               dbf      d3,mvhex_nxtpl2     ;
mvhex_lbl2:    subq.b   #1,d6               ; Boucle (passe  l'hex.
               bne.s    mvhex_nxthex        ; suivant).
               subq.w   #1,2(sp)            ; Boucle (passe au
               bne.s    mvhex_nxtpix        ; pixel suivant).
               move.l   (sp)+,d0            ;Nettoie la pile et annule le bit Z du CCR.
mvhex_rts:     rts                          ;Retour.
;\6
;  Calcule une tape de l'ordre d'effacement/remplacement des pixels.

rm_pixel:      move.w   gd.npix(a5),d5      ;Nb de pixels restant  effacer, ou -1.
               beq.s    mvhex_rts           ;Branch. s'il n'y a plus rien  faire.
               bpl.s    rm_pixel2           ;Branch. si ce n'est pas -1.
               lea      hmask(pc),a0          ; Masque d'un petit hex.:
               lea      gd.flg+4*inhy(a5),a1  ;
               moveq    #inhy-1,d0            ; 00000011111111110000000000000000
               moveq    #0,d1                 ; 00000111111111111000000000000000
mvhex_loop1:   move.b   (a0)+,d1              ; 00001111111111111100000000000000
               move.b   (a0)+,d2              ; 00001111111111111100000000000000
               clr.l    -(a1)                 ; 00011111111111111110000000000000
               bfset    (a1){d1:d2}           ; 00111111111111111111000000000000
               dbf      d0,mvhex_loop1        ; 00111111111111111111000000000000...
               move.w   #npix,gd.npix(a5)   ;Nb de pixels dans un petit hex.
               rts                          ;Retour avec Z = 0.
;\4
rm_pixel2:     moveq    #64,d3              ;Nb max. de fois que la boucle interne doit tre excute.
mvhex_loop2:   subq.b   #1,d3               ;Dcr. le compteur de la boucle interne.
               bcs.s    rmpix_end           ;Branch. si la boucle ne doit plus tre excute.
               bsr      rul_rand15          ;D0.L: nb alatoire sur 15 bits.
               divu.w   #inhy,d0            ; D4.W: n de la ligne
               swap     d0                  ; sur laquelle il faut
               move.w   d0,d4               ; choisir un pixel.
               bsr      rul_rand15          ;D0.L: nb alatoire sur 15 bits.
               clr.w    d1                        ;
               lea      (hmask+1.w,pc,d4.w*2),a0  ; D1.W: largeur de la ligne.
               move.b   (a0),d1                   ;
               divu.w   d1,d0               ; D0.L: abscisse du pixel
               clr.w    d0                  ; choisi, par rapport aux
               swap     d0                  ; pixels  les +   gauche
               add.b    -(a0),d0            ; de l'hex.
               bfclr    (gd.flg.w,a5,d4.w*4){d0:1}  ;Efface le bit du masque correspondant au pixel choisi.
               beq.s    mvhex_loop2         ;Branch. si le pixel a dj t choisi.
               lea      (gd.pix-2.w,a5,d5.w*2),a0
               move.b   d0,(a0)+            ;Stocke l'abscisse du pixel.
               move.b   d4,(a0)             ;Stocke l'ordonne du pixel (n de la ligne).
               subq.w   #1,d5               ;Dcr. le nb de pixels restant  effacer.
               bne.s    mvhex_loop2         ;Boucle (cherche un pixel non encore pris).
rmpix_end:     move.w   d5,gd.npix(a5)      ;Stocke le nb de pixels restant  effacer.
rmpix_rts:     rts                          ;Retour (Z = 1 ssi il ne reste plus de pixel  effacer).
;\4
rulend_rm:     tst.b    hex.free(a0)        ;
               beq.s    rmpix_rts           ; Retour si la case est
               tst.b    d1                  ; vide ou si elle n'est
               bmi.s    rulend_rm2          ; pas marque (on ne la
               btst     d1,hex.marks(a0)    ; dtruit pas).
               beq.s    rmpix_rts           ;
rulend_rm2:    addq.b   #1,gd.nexpl+3(a5)   ;Incr. le nb d'hex.  dtruire.
               clr.w    -(sp)               ;(SP) = 0: case  effacer.
rulend_mvrm:   addq.b   #1,d7               ;Incr. le nb d'hex.  effacer/remplacer.
               movea.l  addr_scr(pc),a2     ;
               move.w   xlen(pc),d0         ;
               mulu.w   d5,d0               ;
               adda.l   d0,a2               ; Stocke  l'adr.  de la case
               moveq    #0,d0               ; sur la mmoire cran (adr.
               move.w   d4,d0               ; du 1er mot).
               andi.b   #$F0,d0             ;
               adda.l   d0,a2               ;
               move.l   a2,(a1)+            ;
               move.b   d4,(a1)             ; Stocke le dplacement (0  15) par rapport 
               andi.b   #$0F,(a1)+          ; cette adr. pour atteindre l'abscisse min.
               move.w   (sp)+,d0            ; Stocke 0 si la case est  effacer, n > 0 si on
               move.b   d0,(a1)+            ; doit mettre l'hex. situ n cases au-dessus.
               move.w   #4*hexlen,d0           ;
               mulu.w   d6,d0                  ; Stocke l'adr. de l'img contenant
               lea      (gd.hexbk,a5,d0.l),a2  ; le fond de la case.
               move.l   a2,(a1)+               ;
rulend_rts2:   rts                          ;Retour.
;\4
rulend_mv:     tst.l    (a0)                ; Retour si la case
               beq.s    rulend_rts2         ; n'existe pas.
               tst.b    hex.free(a0)        ;
               beq.s    rulend_mv2          ;
               tst.b    d1                  ; Incr. (gd.hex-1)  s'il y a
               bmi.s    rulend_mvinc        ; un hex. dans la case et si
               btst     d1,hex.marks(a0)    ; celle-ci est marque.
               beq.s    rulend_mv2          ;
rulend_mvinc:  addq.b   #1,gd.hex-1(a5)     ;
rulend_mv2:    move.w   gd.hex-2(a5),d0     ;D0.W: nb d'hex. dtruits dans la colonne jusqu' la case courante ("trous").
               beq.s    rulend_rts2         ;Retour s'il n'y en a aucun (le contenu de la case reste le mme).
               movea.l  a0,a2               ;A2 contiendra l'adr. de la case  dplacer dans la case courante.
               move.w   d3,-(sp)            ;Sauve D3.
rulend_mloop:  subq.b   #1,d3               ;Dcr. le nb de cases (existantes ou non) situes au-dessus.
               bcs.s    rulend_mv3          ;Branch. s'il n'y a plus de case --> on doit vider la case courante.
               addq.l   #4,a2               ;Prochaine case vers le haut.
               tst.b    hex.free(a2)        ;
               beq.s    rulend_mv5          ; Boucle s'il y a un
               tst.b    d1                  ; hex.  dans la case
               bmi.s    rulend_mloop        ; et si celle-ci est
               btst     d1,hex.marks(a2)    ; marque.
               bne.s    rulend_mloop        ;
rulend_mv5:    subq.b   #1,d0               ;Dcr. le nb de trous.
               bne.s    rulend_mloop        ;Branch. si la case A2 se retrouve en dessous de la case courante.
               tst.b    hex.free(a2)        ; Branch. si la case courante
               beq.s    rulend_mv3          ; doit tre efface.
               move.w   (a2),(a0)           ;La case A2 se retrouve dans la case courante.
               move.w   a2,d0               ; La case A2 se situe D0.B
               sub.w    a0,d0               ; cases  au-dessus  de  la
               lsr.b    #2,d0               ; case courante.
               bra.s    rulend_mv4
rulend_mv3:    tst.b    hex.free(a0)        ; Branch. si le contenu de la case ne
               beq.s    rulend_mv6          ; change pas (la case reste vide).
               clr.w    (a0)                ; La case courante doit
               clr.b    d0                  ; tre efface.
rulend_mv4:    move.w   (sp),d3             ;Rcupre D3.
               move.w   d0,(sp)             ;Empile D0.
               bra      rulend_mvrm         ;Branch. pour stocker les donnes sur la modification de la case.
rulend_mv6:    move.w   (sp)+,d3            ; Rcupre D3,
               rts                          ; et retour.

;\7
;    Ŀ
;     Seconde cl 
;    

               IFGT     REGISTERED
key2:          dcb.b    24,0                ;Seconde cl.
               ENDIF

;\6
;    Ŀ
;     Sous-programmes pour la prsentation 
;    

;  Routine d'attente (calculs pdt ce temps).
;  Registres modifis: D0  D6, A0  A4.
;\6
;  Algorithme:
;   _ Rcuprer les registres pour les calculs.
;   _ Rpter:
;       S'il reste des calculs  effectuer:
;           Excuter une tape de calcul (suivant la valeur de D0.L).
;         sinon:
;           Si le timer n'est pas en marche (i.e. *counter = ctrend), retour.
;      jusqu' ce que le temps du timer soit coul.
;   _ Sauver les registres.
;   _ Modifier la couleur des pinceaux.
;   _ Retour.
;\4
;  Phases de calcul, suivant la valeur de D0, aprs incrmentation de D0.W :
;    1re phase de calcul: D0.W < 0.
;    2me phase de calcul: D0.W  0 et D0.L < 0.
;       Phases suivanetes: D0.L  0, et D1.L: adr. relative de la routine.
;\5
;  Rcupre les registres utiliss pour les calculs.

mk_tetrhex:    lea      ([buffer.w,pc],bufl1-breg.w),a0  ;Adr. o se trouvent les registres.
               movem.l  (a0),REGS           ;Rcupre les registres.
               moveq    #linlen,d5          ;D5.L = linlen.
;\4
;  Dbut de l'tape de calcul.

mkth_outer:    addq.w   #1,d0               ; Branch. si la 1re phase de
               bpl.s    mkth2               ; calcul a t termine.
;\7
;  1re phase de calcul: dcompresse les commandes.
;    -D0.W contient le nb de codes restants.
;    A1 contient l'adr. o sont stocks les codes.
;    D1.L contient l'offset (en bits) du prochain code.
;    A2 contient l'adr. o doit tre stockes la prochaine commande.

               bfextu   (a1){d1:3},d2       ; Lit les 3 bits
               addq.w   #3,d1               ; suivants.
               lsr.b    #1,d2               ;Garde 2 bits et met le 3me dans C.
               beq.s    mkth_com3           ;Branch. si le code faisait 3 bits de long.
               subq.w   #1,d1               ;Dcr. D1 (il n'en faisait que 2).
mkth_com2:     cmpi.b   #1,d2               ; Branch. si
               beq.s    mkth_copy           ; code = 01.
               ror.b    #1,d2               ; Stocke une commande (0: couleur du fond, >0: couleur
               move.b   d2,(a2)+            ; intermdiaire, <0: couleur 1er plan).
               bra.s    wait_timer          ;Fin de l'tape de calcul.
mkth_copy:     bfextu   (a1){d1:10},d2      ; Lit l'offset (par rapport
               add.w    #10,d1              ;  la 1re commande).
               bfextu   (a1){d1:8},d3       ; Lit le nb de commandes
               addq.w   #8,d1               ;  recopier - 1.
               lea      breg(a0,d2.l),a3    ;Adr. de la 1re commande  recopier.
mkth_inner1:   move.b   (a3)+,(a2)+         ; Recopie les
               dbf      d3,mkth_inner1      ; commandes.
               bra.s    wait_timer          ;Fin de l'tape de calcul.
mkth_com3:     bcs.s    mkth_com2           ;Branch. si code = 001 (--> stockage de la commande 0).
               bfextu   (a1){d1:6},d2       ; Lit le nb de fois - 1 que la commande
               addq.w   #6,d1               ; suivante devra tre crite.
               bfexts   (a1){d1:2},d3       ; Lit la commande
               addq.w   #2,d1               ; (0, 1 ou -1).
mkth_inner2:   move.b   d3,(a2)+            ; Copie D2 - 1 fois
               dbf      d2,mkth_inner2      ; la commande D3.
;\7
;  Fin de l'tape de calcul.

wait_timer:    tst.w    counter(pc)         ; Branch. tant que le tps du
               bpl.s    mkth_outer          ; timer n'est pas coul.
               movem.l  REGS,(a0)           ;Sauve les registres.
chg_colors:    xbrgb    VsetRGB,RGB(pc)     ;Appelle XBIOS: modifie la couleur des pinceaux.
               rts                          ;Retour.
;\2
mkth2:         tst.l    d0                  ; Branch. si les calculs
               bpl.s    mkth4               ; sont termins.
;\6
;  2me phase de calcul: calcule les plans 6 et 7.
;    D0.W  0.  D0.W = 0 ssi c'est la 1re fois qu'on excute une tape de cette phase.

               tst.w    d0                  ; Branch. si au moins un hexagone
               bne.s    mkth3               ; a dj t recopi.
               lea      breg(a0),a1         ;A1: adr. de la couleur du prochain hexagone.
               clr.w    d1                  ;D1.W: abscisse (coordonnes semi-hexagonales).
               clr.w    d2                  ;D2.W: ordonne (coordonnes semi-hexagonales).
;\9
;   Les contours des hexagones sont invisibles (couleur du fond).                                 Hexagone :   *****
;                                                                                                     *******
;   A1: adr. de la couleur du prochain hexagone.                                        h   h   h   h   h     *******
;   D1.W: abscisse (coordonnes semi-hexagonales) du prochain hexagone. 0  D1  66.      h   h   h   h      *********
;   D2.W: ordonne (coordonnes semi-hexagonales) du prochain hexagone.                 h   h   h   h   h   ***********
;     0  D2  16 si D1 est pair, 0  D2  15 si D1 est impair.                           h  {H}  h   h      *********
;   Exemple ( droite) pour {H}: D1 = 3, D2 = 1.                                        h   h   h   h   h     *******
;                                                                                                             *******
;   Le point le +  gauche du contour du 1er hexagone occupe le bit numro 5.                                  *****
;\4
mkth3:         tst.b    (a1)                ;Couleur de l'hexagone.
               beq.s    mkth3_lbl2          ;Branch. si c'est la couleur du fond (il n'y a rien  crire).
               move.w   d2,d4               ;Ordonne de l'hexagone en coordonnes semi-hexagonales.
               mulu.w   d5,d4               ;
               add.w    d4,d4               ; 4 * D4.L:  ordonne de la 1re ligne du
               btst     #0,d1               ; contour de l'hexagone multiplie par la
               beq.s    mkth3_lbl1          ; longueur d'une ligne en octets.
               add.w    d5,d4               ;
mkth3_lbl1:    lea      (breg+7*tetr1p,a0,d4.l*4),a3  ;A3: adr. de la 1re ligne de l'hexagone dans le plan 7.
mkth3_draw:    move.w   d1,d4               ; D4.L: abscisse des
               mulu.w   #7,d4               ; pts  de l'hexagone
               addq.l   #5,d4               ; les +  gauche.
               lea      hexag(pc),a4        ;Adr. d'un tableau (cf ci-dessous).
               moveq    #6,d6               ;Nb de lignes - 1 de l'intrieur de l'hexagone.
mkth3_loop:    add.w    (a4)+,d4            ;D4.L: abscisse du point le plus  gauche de la ligne courante de l'hexagone.
               move.b   (a4)+,d3            ;D3.B: largeur du segment  tracer.
               adda.l   d5,a3               ;Adr. de la ligne suivante.
               bfset    (a3){d4:d3}         ;Trace un segment.
               dbf      d6,mkth3_loop       ;Boucle (trace 7 segments).
               lea      -tetr1p-7*linlen(a3),a3  ;Adr. de la 1re ligne du contour de l'hexagone dans le plan prcdent.
               tas      (a1)                ;Doit-on tracer aussi l'hexagone dans le plan prcdent?
               bpl.s    mkth3_draw          ;Oui, branchement.
mkth3_lbl2:    addq.l   #1,a1               ;Adr. du prochain hexagone.
               addq.b   #1,d2               ;Incr. l'ordonne.
               moveq    #16,d4              ;
               btst     #0,d1               ; D4.B: ordonne
               sne      d3                  ; maximale.
               add.b    d3,d4               ;
               cmp.b    d4,d2               ; Branch. si l'ordonne maximale
               bls.s    mkth3_lbl3          ; n'a pas t dpasse.
               clr.b    d2                  ;Ordonne = 0.
               addq.b   #1,d1               ;Incr. l'abscisse.
mkth3_lbl3:    cmpa.l   a1,a2               ; Branch. s'il reste encore
               bne      wait_timer          ; des hexagones.
               moveq    #0,d0               ;D0.L  0: il ne reste plus d'hexagone.
               moveq    #0,d1               ;D1.L = 0 (on passe  la 3me phase de calcul).
               movea.l  a0,a1               ; A1: adr. du plan 5
               adda.l   #breg+5*tetr1p,a1   ; (= fin du plan 4).
               lea      3*tetr1p(a1),a2     ;A2: adr. de fin du plan 7.
               move.w   #nlines-1,d2        ;D2.W: n de la dernire ligne.
               bra.s    wait_timer2         ;Branch. (fin de l'tape de calcul).
;\2
mkth4:         clr.b    d0                  ;D0.L = 0.
               jmp      mkth5(pc,d1.l)      ;Branch.  la phase de calcul correspondant  D1.
;\6
;  3me phase de calcul: calculs des plans 4 et 5.

mkth5:         moveq    #4,d5               ;D5 = 4.
               btst     d5,d2               ; D3.L = %1...1  si le n de
               seq      d3                  ; la ligne divis par 16 est
               extb.l   d3                  ; pair. Sinon, D3.L = 0.
               move.l   d2,d4               ;
               divu.w   #3,d4               ; D4.L = %1...1  si le n de
               btst     d5,d4               ; la ligne divis par 48 est
               sne      d4                  ; impair. Sinon, D4.L = 0.
               extb.l   d4                  ;
               moveq    #(linlen>>2)-1,d5   ;Nb de mots longs - 1 dans une ligne.
mkth5_loop:    move.l   -(a2),d6            ; On met un bit du plan 4  1 ssi
               and.l    d3,d6               ; le bit correspondant  du plan 7
               move.l   d6,-(a1)            ; est  1 et si la ligne est  1.
               move.l   (a2),d6             ; On met un bit du plan 5  0
               not.l    d6                  ; ssi le bit correspondant du
               or.l     d4,d6               ; plan 7  est   1  et  si la
               move.l   d6,tetr1p(a1)       ; ligne est  0.
               dbf      d5,mkth5_loop       ;Boucle sur chacun des mots longs de la ligne.
               dbf      d2,wait_timer       ;Ligne prcdente. Branch. s'il reste encore des lignes.
               move.l   #mkth6-mkth5,d1     ;Pas de ligne prcdente --> 4me phase de calcul.
               lea      breg+2*tetr1p(a0),a1  ;A1: adr. du plan 2.
               lea      tetr1p(a1),a2       ;A2: adr. du plan 3.
               move.w   #nlines-1,d2        ;D2.W: n de la dernire ligne.
               moveq    #0,d3               ;D3.L = 0 (offset de dpart).
wait_timer2:   bra      wait_timer          ;Fin de l'tape de calcul.
;\6
;  4me phase de calcul: dbut des calculs des plans 2 et 3.

mkth6:         bsr.s    mkth_line           ;Calcule la prochaine ligne (plans 2 et 3).
               addq.b   #1,d3               ; Calcule l'offset correspondant  la ligne suivante
               sub.b    d6,d3               ; (ajoute 1 ou 2, dans les proportions 1/4 - 3/4).
               cmp.b    d4,d3               ; S'il est  192 (= D4),  alors
               bcs.s    mkth6_dbf           ; on lui retranche 192 (priode
               sub.b    d4,d3               ; de 192 bits).
mkth6_dbf:     dbf      d2,wait_timer       ;Ligne suivante. Branch. s'il reste encore des lignes.
               move.l   #mkth7-mkth5,d1     ;Pas de ligne suivante --> 5me phase de calcul.
               lea      breg(a0),a1         ;A1: adr. du plan 0.
               lea      tetr1p(a1),a2       ;A2: adr. du plan 1.
               move.w   #nlines-1,d2        ;D2.W: n de la dernire ligne.
               bra.s    wait_timer2         ;Fin de l'tape de calcul.
;\6
;  5me phase de calcul: dbut des calculs des plans 0 et 1.

mkth7:         bsr.s    mkth_line           ;Calcule la prochaine ligne (plans 0 et 1).
               subq.b   #1,d3               ; Calcule l'offset  correspondant  la ligne suivante
               add.b    d6,d3               ; (retranche 1 ou 2, dans les proportions 1/4 - 3/4).
               bpl.s    mkth7_dbf           ; S'il est ngatif, alors on lui ajoute
               add.b    d4,d3               ; 192 (priode de 192 bits).
mkth7_dbf:     dbf      d2,wait_timer       ;Ligne suivante. Branch. s'il reste encore des lignes.
               move.l   #mkth8a-mkth5,d1    ;Pas de ligne suivante --> 6me phase de calcul.
               lea      breg(a0),a1         ;A1: adr. du plan 0.
               movea.l  a1,a2               ; A2: adr. du
               adda.l   #7*tetr1p,a2        ; plan 7.
               moveq    #4,d3               ;Nb de plans  mettre  jour.
               bra.s    mkth8b
;\6
;  Calcul de la prochaine ligne, pour les 4me et 5me phase. Calcul de D6. D4.B = 120.

mkth_line:     move.l   d3,d4               ;Offset du bit le plus  gauche.
               moveq    #(linlen>>2)-1,d5   ;Taille d'une ligne en mots longs - 1.
mkthln_loop:   bfextu   cinc1(pc){d4:32},d6 ; Stocke les 32 bits suivants
               move.l   d6,(a1)+            ; sur le plan 0 ou 2.
               bfextu   cinc2(pc){d4:32},d6 ; Idem, sur le
               move.l   d6,(a2)+            ; plan 1 ou 3.
               addi.b   #32,d4              ;
               cmpi.b   #192,d4             ; Calcule le prochain offset
               bcs.s    mkthln_dbf          ; (priode de 192 bits).
               subi.b   #192,d4             ;
mkthln_dbf:    dbf      d5,mkthln_loop      ;Boucle tant que la ligne n'est pas termine.
               move.b   d2,d6               ; D6.B = 0 si D2 est
               andi.b   #%11,d6             ; un multiple  de 4,
               sne      d6                  ; sinon D6.B = -1.
               move.b   #192,d4             ;D4.B = 192.
flin_rts:      rts                          ;Retour.
;\6
;  6me phase de calcul: fin des calculs des plans 0, 1, 2 et 3.

mkth8a:        moveq    #(linlen>>2)-1,d5   ;Taille d'une ligne en mots longs - 1.
mkth8_loop:    move.l   (a2)+,d4            ; Effectue (plan courant) <-- (plan
               and.l    d4,(a1)+            ; courant) AND (plan 7).
               dbf      d5,mkth8_loop       ;Boucle tant que la ligne n'est pas termine.
               dbf      d2,wait_timer       ;Ligne suivante. Branch. s'il reste encore des lignes.
               lea      -tetr1p(a2),a2      ;A2: adr. du plan 7.
mkth8b:        move.w   #nlines-1,d2        ;D2.W: nb de lignes - 1.
               dbf      d3,wait_timer       ;Plan suivant. Branch. si on n'en tait pas au plan 3.
               move.l   #mkth_end-mkth5,d1  ;Fin des calculs.
               bra.s    wait_timer3         ;Fin de l'tape de calcul.
;\6
;  Calculs termins. Attention! aucun registre ne doit tre modifi.

mkth_end:      cmpi.w   #ctrend,counter     ; Branch. si le timer n'est pas en marche (on
               beq.s    flin_rts            ; voulait seulement terminer les calculs).
               bsr      usr_switch          ; Calcule l'image de fond jusqu' ce
wait_timer3:   bra      wait_timer          ; que le tps du timer soit coul.

;\8
;  Recopie une ligne de l'cran source (calcul prcdemment, cf mk_tetrhex) vers l'cran systme.
;    A0: adr. du pixel le plus  gauche de la ligne  recopier, sur le plan 0 de l'cran source.
;    A2: idem, mais sur l'cran systme.
;    D6.W: taille de la ligne en octets (i.e. nb de pixels / 8).
;  On commence par recopier le plan 7, puis le plan 0, jusqu'au plan 6 (pour viter l'affichage de couleurs parasites).
;  Registres modifis: D0, D5, A1, A3, A4, A6.

fire_line:     movea.l  a0,a1               ; A1: adr. du 1er pixel sur
               adda.l   #7*tetr1p,a1        ; le plan 7 (cran source).
               lea      14(a2),a4           ;A4: idem, sur l'cran systme.
               moveq    #-1,d0              ;D0.W = -1: indique qu'on en est au plan 7.
flin_outer:    movea.l  a1,a3               ;Adr. du 1er pixel sur le plan courant (cran source).
               movea.l  a4,a6               ;Idem, sur l'cran systme.
               move.w   d6,d5               ;Taille d'une ligne en octets.
               btst     #1,d6               ; Branch. si la ligne commence sur le 1er octet
               beq.s    flin_inner          ; d'un mot, en ce qui concerne l'cran systme.
               move.b   (a3)+,(a6)          ; Sinon, on recopie le 1er octet
               lea      15(a6),a6           ; de la ligne...
               subq.w   #2,d5               ;... et on enlve 2  la taille de la ligne (pour le dernier octet: cf ci-dessous).
flin_inner:    move.w   (a3)+,(a6)          ; Recopie le mot
               lea      16(a6),a6           ; suivant.
               subq.w   #2,d5               ;Dcr. la taille de la ligne de 2 (1 mot = 2 octets).
               bne.s    flin_inner          ;Boucle.
               btst     #1,d6               ;
               beq.s    flin_nextp          ; Recopie l'ventuel octet restant.
               move.b   (a3),(a6)           ;
flin_nextp:    lea      tetr1p(a1),a1       ;Passe au plan suivant (cran source).
               addq.l   #2,a4               ;Passe au plan suivant (cran systme).
               tst.w    d0                  ; Boucle si l'ancien plan n'tait
               dbmi     d0,flin_outer       ; ni le 6, ni le 7.
               bpl.s    flin_rts            ;Branch. si l'ancien plan tait le 6 (c'est termin).
               moveq    #6,d0               ;L'ancien plan tait le 7. D0 = 6: nb de plans restants - 1.
               movea.l  a0,a1               ;
               movea.l  a2,a4               ; Passe au plan 0.
               bra.s    flin_outer          ;

;\8
;  Changement de couleurs ventuel. Registres modifis: D0  D3, A0  A2.
;      S'il doit y avoir un changement de couleur, les couleurs du 1er plan sont tjrs
;    modifies.  Les couleurs intermdiaires ne sont modifies que si l'affichage est
;    compltement termin (pour viter l'affichage de couleurs parasites).
;      Si D4.W <> 0,  on doit tout mettre progressivement  la couleur du fond.  Dans
;    ce cas, les registres D5, D6 et D7 peuvent aussi tre modifis.

new_colors:    lea      freq(pc),a0         ;Tableau des 6 priodes.
               moveq    #5,d2               ;Nb de valeurs  modifier ventuellement - 1.
newc_loop1:    move.l   d0,d1               ;
               divu.w   (a0)+,d1            ; Branch.  si countr2 (D0) n'est pas divisible
               clr.w    d1                  ; par la prochaine priode (i.e. on ne modifie
               tst.l    d1                  ; pas la valeur associe).
               bne.s    newc_dbf1           ;
               lea      10(a0),a0           ;A0 pointe sur la valeur  modifier.
               move.w   12(a0),d3           ;D3: nb  ajouter  la valeur (2).
               add.w    d3,(a0)             ;Ajoute D3  la valeur.
               move.w   (a0),d1             ;D1.W: nouvelle valeur.
               cmpi.b   #3,d2               ; Branch. s'il s'agit du 1er
               bcs.s    newc_lbl2           ; groupe de 3 valeurs.
               tst.w    d1                  ;C'est le 2nd groupe: la valeur absolue de la valeur doit tre  16.
               bpl.s    newc_lbl1           ; D1.W: valeur
               neg.w    d1                  ; absolue.
newc_lbl1:     cmpi.w   #16,d1              ; Si elle est > 16, on annule la modification, et
               bra.s    newc_lbl3           ; on change la direction de l'incrmentation.
newc_lbl2:     tst.w    d1                  ;C'est le 1er groupe: la valeur doit tre comprise entre 0 et 255.
               bmi.s    newc_lbl4           ;Branch. si elle est ngative (on annule la modification...).
               cmpi.w   #255,d1             ;Elle est positive: si elle est > 255, on annule la modification...
newc_lbl3:     bls.s    newc_lbl5           ;Branch. si la valeur est bien dans l'intervalle voulu.
newc_lbl4:     sub.w    d3,(a0)             ;Sinon, on annule la modification...
               neg.w    12(a0)              ;... et on change la direction de l'incrmentation.
newc_lbl5:     lea      -10(a0),a0          ;Corrige la valeur de A0.
newc_dbf1:     dbf      d2,newc_loop1       ;Boucle.
;\4
               moveq    #2,d0               ;Nb de couleurs primaires - 1.
newc_outer:    moveq    #3,d1               ;2 plans par couleur primaire --> 3 + 1 possibilits.
               move.w   6(a0),d3            ;D3: intensit de la couleur quand les 2 plans sont nuls.
newc_inner:    move.b   d3,d2               ; Stocke la prochaine intensit dans D2 (tableau de
               ror.l    #8,d2               ; 4 octets, chaque octet tant une intensit).
               add.w    (a0),d3             ;
               bmi.s    newc_lbl7           ;
               cmp.w    #$100,d3            ; Calcule la prochaine intensit
               bcs.s    newc_dbf2           ; (qui doit tre comprise  entre
               move.w   #$FF,d3             ; 0 et 255).
               bra.s    newc_dbf2           ;
newc_lbl7:     clr.w    d3                  ;
newc_dbf2:     dbf      d1,newc_inner       ;Boucle --> D2: tableau des 4 intensits.
               addq.l   #2,a0               ;Prochaine couleur.
               move.l   d2,-(sp)            ;Empile le tableau.
               dbf      d0,newc_outer       ;Boucle (prochaine couleur).
;\4
               lea      RGB+256*4(pc),a1    ;Fin du tableau des couleurs des pinceaux.
               moveq    #63,d0              ;Nb de couleurs du 1er plan (= nb de couleurs intermdiaires).
newc_loop2:    move.b   d0,d1               ;Code de la couleur (--> pinceau 192 + D0).
               lsr.b    #2,d1               ;
               move.b   d1,d2               ;
               lsr.b    #2,d2               ;
               andi.w   #%11,d2             ; Modifie les intensits des 3 couleurs primaires,
               move.b   0(sp,d2.w),-(a1)    ; suivant la valeur  des 6 bits de poids faible du
               andi.w   #%11,d1             ; n du pinceau  (rouge: bits 4 et 5, vert: bits 2
               move.b   4(sp,d1.w),-(a1)    ; et 3, bleu: bits 0 et 1).
               move.b   d0,d1               ;
               andi.w   #%11,d1             ;
               move.b   8(sp,d1.w),-(a1)    ;
               movea.l  a1,a2               ;Adr. de l'intensit du rouge.
               clr.b    -(a1)               ;Tjrs 0.
               moveq    #64,d3              ; Si  countr2 < D3 = 512,  on
               lsl.w    #3,d3               ; ne change pas  les couleurs
               cmp.l    countr2(pc),d3      ; intermdiaires (pour viter
               bhi.s    newc_dbf3           ; les parasites).
               move.b   (a2)+,d3            ;Intensit du rouge (couleur du 1er plan).
               lsr.b    #2,d3               ; On fait la moyenne avec l'intensit de rouge pour la couleur
               addi.b   #96,d3              ; du fond (128), avec des coefficients gaux  1/4 - 3/4.
               move.b   d3,-64*4-1(a2)      ;Stockage comme intensit de rouge pour la couleur intermdiaire.
               move.b   (a2)+,d3            ;Intensit du vert (couleur du 1er plan).
               lsr.b    #2,d3               ;On fait la moyenne avec l'intensit de vert pour la couleur du fond (0).
               move.b   d3,-64*4-1(a2)      ;Stockage comme intensit de vert pour la couleur intermdiaire.
               move.b   (a2),d3             ;Intensit du bleu (couleur du 1er plan).
               lsr.b    #2,d3               ; On fait la moyenne avec l'intensit de
               addi.b   #96,d3              ; bleu pour la couleur du fond (128).
               move.b   d3,-4*64(a2)        ;Stockage comme intensit de bleu pour la couleur intermdiaire.
newc_dbf3:     dbf      d0,newc_loop2       ;Boucle.
               lea      12(sp),sp           ;Libre les 3 tableaux de 4 octets.
               lea      RGB+33*4(pc),a1     ;
               movea.l  a1,a2               ; Sauve les couleurs des
               moveq    #30,d0              ; pinceaux utiliss pour
newc_loop3:    move.l   (a2)+,-(sp)         ; "V.L. presents".
               dbf      d0,newc_loop3       ;
               tst.w    d4                  ; Branch. si on ne doit pas tout
               beq.s    newc_end2           ; mettre  la couleur du fond.
               cmpi.l   #520,(a6)           ; Branch. s'il faut attendre encore un peu avant
               bcs.s    newc_end2           ; de tout mettre  la couleur du fond.
               sub.l    #$10000,d6          ;
               bcc.s    newc_end1           ; Dcr. D6.B 1 fois sur 5.
               add.l    #$4FFFF,d6          ;
newc_end1:     moveq    #30,d7              ;Nb de couleurs  modifier - 1.
               move.w   d6,d5               ;
               sub.w    #32,d5              ; D5.W = max(D6 - 32 , 0)
               bcc.s    newc_lbl8           ; (coef. barycentrique).
               clr.w    d5                  ;
newc_lbl8:     bsr.s    newc_bkgr           ;Modifie les couleurs.
               cmpi.w   #128,d6             ; Branch. si D6  128 (on ne modifie
               bcc.s    newc_end2           ; pas les couleurs de "TETRHEX").
               lea      RGB+128*4(pc),a1    ;Adr. de la 1re couleur  modifier.
               moveq    #127,d7             ;Nb de couleurs  modifier - 1.
               move.w   d6,d5               ;D5.W = D6 < 128.
               bsr.s    newc_bkgr           ;Modifie les couleurs.
newc_end2:     bsr      chg_colors          ;Change la couleur des pinceaux.
               tst.b    d6                  ; Branch. si D6.B = 0 (fin): on ne doit pas rcuprer
               beq.s    newc_end3           ; les anciennes couleurs de "V.L. presents".
               lea      RGB+64*4(pc),a2     ;
               moveq    #30,d0              ; Rcupre les anciennes couleurs
newc_loop4:    move.l   (sp)+,-(a2)         ; de "V.L. presents".
               dbf      d0,newc_loop4       ;
               rts                          ;Retour.
newc_end3:     lea      31*4(sp),sp         ;Dpile les anciennes couleurs.
               rts                          ;Retour.
;\4
newc_bkgr:     addq.l   #1,a1               ;Adr. de l'intensit en rouge de la prochaine couleur.
               clr.w    d0                  ; D0.W: intensit en rouge
               move.b   (a1),d0             ; de la prochaine couleur.
               mulu.w   d5,d0               ;
               lsr.w    #7,d0               ; D0.B: barycentre entre cette intensit, coef. D5.W, et
               add.b    #128,d0             ; celle de la couleur du fond (128), coef. 128 - D5.
               sub.b    d5,d0               ;
               move.b   d0,(a1)+            ;Remplace l'intensit initiale par le barycentre.
               clr.w    d0                  ;
               move.b   (a1),d0             ; Idem pour l'intensit en
               mulu.w   d5,d0               ; vert  (intensit  de  la
               lsr.w    #7,d0               ; couleur du fond: 0).
               move.b   d0,(a1)+            ;
               clr.w    d0                  ;
               move.b   (a1),d0             ;
               mulu.w   d5,d0               ; Idem pour l'intensit en
               lsr.w    #7,d0               ; bleu  (intensit  de  la
               add.b    #128,d0             ; couleur du fond: 128).
               sub.b    d5,d0               ;
               move.b   d0,(a1)+            ;
               dbf      d7,newc_bkgr        ;Boucle (couleur suivante).
fonts_rts:     rts                          ;Retour.

;\8
;    Ŀ
;     Sous-programmes concernant l'affichage de texte 
;    

;  Slectionne la fonte Speedo n D7 si SpeedoGDOS est install. Registres modifis: D0, D1, D2, D7, A0, A1, A2, A6.

set_font1:     tst.b    gdosflag(pc)        ; Retour si SpeedoGDOS
               beq.s    fonts_rts           ; n'est pas install.
               move.l   #v_ftext<<16+vqt_f_extent,d0  ;Code des fct  appeler pour afficher du texte avec une fonte vect.
               bsr.s    set_font2           ;Slectionne la fonte SpeedoGDOS.
               cmp.w    d0,d7               ; Retour, si elle a bien
               beq.s    fonts_rts           ; t slectionne.
               move.l   #v_gtext<<16+vqt_extent,d0  ;Code des fct  appeler pour afficher du texte avec une fonte bitmap.
               moveq    #1,d7               ;N de la fonte systme.
set_font2:     lea      fgtext(pc),a0       ; Stocke les codes des fct  appeler
               move.l   d0,(a0)             ; pour afficher du texte.
               move.w   d7,(a6)             ; Slectionne la fonte
               intvdi   vst_font,0          ; de n D7, et retour.
;\4
sto_tetrhex:   lea      windname1(pc),a0    ;
               moveq    #11,d0              ;
               movea.l  a6,a1               ; Stocke "TETRHEX x.xx" (ou x.xx est le
stoth_loop:    clr.b    (a1)+               ; n de version) dans le tableau INTIN.
               move.b   (a0)+,(a1)+         ;
               dbf      d0,stoth_loop       ;
               rts                          ;Retour.
;\4
sto_pause:     movea.l  alert_paus+4(pc),a0 ;
               movea.l  a6,a1               ;
               moveq    #5,d0               ;
               move.l   #'-'<<16+'-',d1     ;
               moveq    #' ',d2             ;
               move.l   d1,(a1)+            ; Stocke  "-- PAUSE --"  dans le
               move.w   d2,(a1)+            ; tableau INTIN (ou l'quivalent
stpaus_loop:   addq.b   #1,d0               ; dans la langue choisie).
               clr.b    (a1)+               ;
               move.b   (a0)+,(a1)+         ;
               bne.s    stpaus_loop         ;
               move.b   d2,-1(a1)           ;
               move.l   d1,(a1)             ;
               rts                          ;Retour.

;\6
;    Ŀ
;     Sous-programmes pour la prparation de l'cran de jeu 
;    

calc_outer:    moveq    #1,d0               ; Effectue  un OR  avec le voisin
               clr.w    d1                  ; situ au-dessus (ici, il s'agit
               bsr.s    calc_outaux1        ; en fait d'un remplacement).
               moveq    #2,d0               ; Effectue un OR avec
               clr.w    d1                  ; le voisin  situ en
               bsr.s    calc_outaux1        ; haut  droite.
               moveq    #2,d0               ; Effectue un OR avec
               moveq    #1,d1               ; le voisin  situ  
               bsr.s    calc_outaux1        ; droite.
               moveq    #2,d0               ; Effectue un OR avec
               move.w   d0,d1               ; le voisin  situ en
               bsr.s    calc_outaux1        ; bas  droite.
               moveq    #1,d0               ; Effectue un OR avec
               moveq    #2,d1               ; le voisin situ au-
               bsr.s    calc_outaux1        ; dessous.
               clr.w    d0                  ; Effectue un OR avec
               moveq    #2,d1               ; le voisin  situ en
               bsr.s    calc_outaux1        ; bas  gauche.
               clr.w    d0                  ; Effectue un OR avec
               moveq    #1,d1               ; le voisin  situ  
               bsr.s    calc_outaux1        ; gauche.
               clr.w    d0                  ; Effectue un OR avec
               clr.w    d1                  ; le voisin  situ en
               bsr.s    calc_outaux1        ; haut  gauche.
               moveq    #1,d0               ;
               move.w   d0,d1               ; Efface dans la destination les pts correspondant
               moveq    #erase,d2           ; aux pts  1 de la source.
               bra.s    calc_outaux2        ;
;\5
cpyfm:         lea      contrl(pc),a0       ;A0: adr. du tableau contrl.
               move.w   #vro_cpyfm,(a0)+    ;Opcode.
               move.w   #4,(a0)             ;Taille du tableau PTSIN.
               lea      12(a0),a1           ;Adr. o il faut stocker les ptrs sur les struct. MFDB.
               rts                          ;Retour.
;\4
calc_outaux1:  moveq    #trans,d2           ;Opration logique: OR (transparent).
calc_outaux2:  move.w   d2,intin            ;Stocke l'opration logique dans le tableau INTIN.
               bsr.s    cpyfm               ; Stocke l'opcode, la taille
               move.l   a3,(a1)+            ; du tableau PTSIN,  et  les
               move.l   a3,(a1)             ; ptrs  sur les struct. MFDB
               add.l    d3,(a1)             ; srce et dest.
               lea      ptsin(pc),a2        ;A2: adr. du tableau PTSIN.
               move.w   d0,(a2)+                  ;
               move.w   d1,(a2)+                  ; Stocke les coord.
               move.l   -4(a2),(a2)               ; du bloc source.
               addi.l   #637<<16+fheight-3,(a2)+  ;
               pea      one_vdi(pc)         ;Routine  appeler aprs le prochain RTS (appel de la VDI).
sto_coord:     moveq    #1,d0               ;
               move.w   d0,(a2)+            ; Sommet suprieur gauche: (1;1).
               move.w   d0,(a2)+            ;
               move.l   #638<<16+fheight-2,(a2)+  ;Sommet infrieur droit: (xmax-1;ymax-1).
               rts                          ;Retour.
;\6
;  Affiche une zone (X, Y ou Z) sur l'cran.

xyz2screen:    lea      contrl(pc),a0       ;Adr. du tableau contrl.
               move.w   #vrt_cpyfm,(a0)+    ;Opcode.
               move.w   #4,(a0)             ;Taille du tableau PTSIN.
               move.w   #3,4(a0)            ;Taille du tableau INTIN.
               move.l   a5,12(a0)           ;Adr. de la struct. MFDB source.
               move.l   a4,16(a0)           ;Adr. de la struct. MFDB dest.
               lea      intin(pc),a1        ; Remplit le tableau INTIN:
               move.w   #md_trans,(a1)+     ; _ mode d'criture transparent,
               move.w   d5,(a1)+            ; _ couleur du 1er plan D5,
               clr.w    (a1)                ; _ couleur du fond 0.
               lea      ptsin(pc),a2        ;Adr. du tableau PTSIN.
               bsr.s    sto_coord           ;Stocke les coord. du bloc source.
               move.l   xy0(pc),d0          ;
               move.l   d0,(a2)             ; Stocke les coord. du bloc dest.
               addq.w   #1,(a2)+            ; (=  coord.  du  bloc  source  +
               addq.w   #1,(a2)+            ; coord.  du pnt suprieur gauche
               move.l   -8(a2),(a2)         ; de la fentre).
               add.l    d0,(a2)             ;
               adda.l   d3,a5               ;Adr. de la struct. MFDB suivante.
               bra      hvdi                ;Affiche la zone sur l'cran.

;\9
;    Ŀ
;     Sous-programmes de gestion des vnements 
;    

;  Attend un vnement. Si le jeu se droule dans une fentre GEM, le fait d'appuyer sur CTRL-F ou de cliquer sur le
;  bouton droit de la souris libre la mmoire prise par l'image de fond (si elle n'a pas t libre auparavant).
;  N.B.: l'vnement evnt_button est renvoy (bit 1 de D0) qd le bouton gauche a chang d'tat.

wait_evnt0:    clr.w    d0                  ;Pas d'autre vnement  surveiller en + de mu_keybd, mu_mesag et mu_button.
wait_evnt:     lea      int_in(pc),a0       ;Adr. du tableau INT_IN.
               moveq    #mu_keybd|mu_button|mu_mesag,d1  ; Evnements  surveiller si le jeu se droule dans une fentre
               tst.b    windflag(pc)                     ; GEM: mu_keybd, mu_mesag et mu_button. Evnements  surveiller
               bmi.s    wevnt_lbl1                       ; si le jeu se droule  sur tout l'cran:  mu_keybd et mu_mesag
               moveq    #mu_keybd|mu_mesag,d1            ; (note: il ne faut pas surveiller mu_button, sinon a plante).
wevnt_lbl1:    or.b     d1,d0               ;Ajoute les vnements  surveiller parmi mu_keybd, mu_mesag et mu_button.
               move.w   d0,(a0)+            ;Stocke les vnements  surveiller dans INTIN[0].
               move.w   #$101,(a0)+         ; Pour  les boutons  de la
               move.w   #%11,(a0)+          ; souris, on attend qu'ils
               move.w   bstate(pc),(a0)     ; changent d'tat.
               move.w   d7,22(a0)           ; Temps d'attente en ms
               clr.w    24(a0)              ; pour evnt_timer.
               lea      4(sp),a1                ; Stocke le ptr sur le buffer
               move.l   a1,addrin-int_in-6(a0)  ; des messages dans ADDRIN.
               maes     evnt_multi,16,7,1   ;Attend un vnement.
               IFNE     REGISTERED
               btst     #4,d0               ; Branch. si pas
               beq.s    wevnt_lbl2          ; d'evnt_mesag.
               move.w   d0,d2               ;Sauve D0 dans D2.
               lea      struct_msg+4(pc),a0 ; Stocke l'adr. du tableau
               lea      4(sp),a1            ; msg  dans  la  structure
               move.l   a1,(a0)             ; rserve aux msg.
               move.w   #msg_evnt,d0        ; Envoie le msg
               bsr      send_msg0           ; msg_evnt.
               move.w   d2,d0               ;Rcupre D0.
wevnt_lbl2:    ENDIF
               tst.b    windflag(pc)        ; Retour si le jeu se droule sur tout l'cran (dans ce cas, la mmoire prise
               bpl.s    wevnt_rts           ; par l'img de fond n'est jms libre, et on ne tient pas compte des clics).
               btst     #0,d0               ; Branch. si pas
               beq.s    tst_button          ; d'evnt_keybd.
               moveq    #ctrl_f,d1          ;
               cmp.b    int_out+11(pc),d1   ; Si c'est CTRL-F qui a t frapp, on libre
               bne.s    tst_button          ; la mmoire prise par l'img de fond.
               bsr.s    free_xmem           ;
tst_button:    bclr     #1,d0               ; Retour, si pas
               beq.s    wevnt_rts           ; d'evnt_button.
               lea      bstate(pc),a0       ; D1: dernier tat
               move.w   (a0),d1             ; des boutons.
               move.w   int_out+6(pc),(a0)+ ;Met  jour l'tat des boutons.
               add.b    -(a0),d1            ;
               lsr.b    #1,d1               ; Met  1 le bit 1 de D0 si l'tat du bouton
               bcc.s    tst_rightb          ; gauche a chang (il a t annul + haut).
               bset     #1,d0               ;
               btst     #0,(a0)             ; Si l'tat du bouton gauche  a chang:  si le bouton
               sne      bitem-bstate(a0)    ; a t enfonc,  on annule le poids fort de bitem et
               beq.s    tst_rightb          ; on rend le poids faible non nul; si le bouton a t
               clr.b    bitem-bstate-1(a0)  ; relach, on annule le poids faible de bitem.
tst_rightb:    btst     #1,(a0)             ; Retour si le bouton droit
               beq.s    wevnt_rts           ; n'est pas enfonc.
free_xmem:     move.w   d0,-(sp)            ;Sauve D0.
               bsr      xmem_free           ;Libre la mmoire prise par l'image de fond.
               move.w   (sp)+,d0            ;Rcupre D0.
wevnt_rts:     rts                          ;Retour (D0: masque des vnements).
;\6
;  Mise  jour d'une fentre avant un redraw complet...

wd_update:     bsr.s    read_message        ;Prend en compte les messages ventuels concernant la fentre.
               bsr.s    beg_windupd         ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM.
               bmi.s    wd_update           ;Branch. si on revient d'un mode PAUSE (N.B.: la fentre est tjrs efface).
wdupd_rts:     rts                          ;Retour.
;\5
;  Prise en compte de messages ventuels concernant la fentre. Registres modifis: D0  D3, A0  A3.
;  Au retour, N = 1 ssi on est pass en mode PAUSE.

read_message:  tst.b    windflag(pc)        ; Branch. si le jeu se droule
               bpl.s    wdupd_rts           ; sur tout l'cran.
;\6
;    On s'envoie un message  soi-mme, car on ne veut pas que evnt_multi bloque tout.

               clr.w    d0                  ;Type du message  envoyer: 0.
               pea      rdmsg_lbl2(pc)      ;Adr. o il faut se brancher aprs l'excution du sous-prg send_message.
send_message:  lea      -16(sp),sp          ;Rserve de la mmoire dans la pile pour le buffer des messages.
               lea      int_in(pc),a0           ;
               move.w   ap_id(pc),(a0)+         ;
               move.w   #16,(a0)                ;
               move.l   sp,addrin-int_in-2(a0)  ; On s'envoie un message
               move.w   d0,(sp)                 ; de type D0   soi-mme
               move.w   ap_id(pc),2(sp)         ; (de taille std).
               clr.w    4(sp)                   ;
               maes     appl_write,2,1,1        ;
               beq.s    mtos_err5               ;
sendmsg_end:   lea      16(sp),sp           ;Libre le buffer des messages.
sendmsg_rts:   rts                          ;Retour.
;\6
;    Note: si on est pass en mode PAUSE, il faudrait normalement tester si le message qu'on s'est envoy
;      a bien t lu, mais le contraire est tellement peu probable qu'on ne le fait pas.

rdmsg_lbl1:    bmi.s    sendmsg_rts         ;Branch. si on est pass en mode PAUSE.
rdmsg_lbl2:    pea      rdmsg_lbl1(pc)      ;Empile l'adr.  laquelle il faut se brancher aprs read_msg1.
rdmsg_lbl3:    lea      -16(sp),sp          ;Rserve de la mmoire dans la pile pour le buffer des messages.
rdmsg_lbl4:    bsr      wait_evnt0          ;Attend un evnt (on est sr qu'il y en a au moins un: le msg qu'on s'est envoy).
               lsl.b    #3,d0               ; Si aucun message n'a t
               bpl.s    rdmsg_lbl4          ; reu, on attend encore.
               tst.w    (sp)                ;
               bne.s    read_msg1b          ; Branch. si ce n'est pas
               move.w   ap_id(pc),d0        ; un message  de type nul
               cmp.w    2(sp),d0            ; qu'on s'est envoy.
read_msg1b:    bne      read_msg1           ;
               addq.l   #4,sp               ; Dpile l'adr. empile auparavant (adr. de retour de read_msg1),
               bra.s    sendmsg_end         ; libre le buffer des messages, et retour.
;\6
;  Mise  jour de la fentre si le jeu se droule dans une fentre GEM. Registres modifis: D0  D3, A0  A3.

beg_windupd:   tst.b    windflag(pc)        ; Retour si le jeu se droule
               bpl.s    begwupd_rts         ; sur tout l'cran.
beg_windupd2:  lea      int_in(pc),a3       ;A3: adr. du tableau int_in.
               move.w   #beg_update,(a3)+   ; Fct wind_update avec
               bsr      wind_upd            ; BEG_UPDATE.
               tst.b    ([pwtitle.w,pc])    ; Branch. si on est
               bne.s    mouse_off           ; en mode PAUSE.
               move.w   whandle(pc),d3      ;D3: handle de la fentre de TETRHEX.
               bsr.s    topped_wind         ; Branch. si la fentre situe au 1er plan n'est
               bne.s    not_topped          ; pas celle de TETRHEX (passage en mode PAUSE).
mouse_off:     move.w   #m_off,d0           ; Cache le curseur
               bsr      mgr_mouse           ; de la souris.
               clr.b    d0                  ;N = 0: fentre au 1er plan.
begwupd_rts:   rts                          ;Retour.
;\6
;  Teste si la fentre situe au 1er plan est celle de TETRHEX. A3: int_in+2.

topped_wind:   move.w   #wf_top,(a3)        ;
               move.w   d3,-(a3)            ; Handle de la fentre
               bsr.s    window_get          ; situe au 1er plan ?
mtos_err5:     beq      mtos_err            ;
               cmp.w    int_out+2(pc),d3    ;Z = 1 ssi c'est la fentre de TETRHEX.
               rts                          ;Retour.
window_get:    maes     wind_get,2,5,0,0
;\6
;  Efface la fentre (zone de travail).

clr_window:    bsr      fill_col1           ;SET FILL COLOR INDEX, avec la couleur 1 (noir).
clr_wind2:     bsr.s    beg_windupd         ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM.
               bpl      clr_wind3           ;Branch. si on ne revient pas d'un mode PAUSE (fentre pas encore efface).
clrwin_rts:    rts                          ;Retour.
;\6
;  Libre la mmoire utilise par l'image de fond, s'il n'en reste pas assez.

xmem_test:     moveq    #-1,d0              ; D0.L: taille du + gd bloc
               bsr      call_malloc         ; de mmoire dispo.
               cmp.l    xmem(pc),d0         ; Retour si ce bloc
               bcc.s    clrwin_rts          ; est assez gd.
xmem_free:     lea      backflag(pc),a0     ;
               tst.b    (a0)                ; Annule  les drapeaux backflag  et
               bpl.s    xmem_free2          ; libre le bloc de mmoire rserv
               clr.b    (a0)+               ; pour l'image de fond s'il n'a pas
               move.l   (a0),d0             ; t libr auparavant.
               bsr.s    call_mfree3         ;
xmem_free2:    lea      sfont_addr(pc),a1   ;A1: ptr sur l'adr. des donnes sur la fonte n *sfontid.
               move.l   (a1),d0             ;D0.L: adr. des donnes sur la fonte n *sfontid, ou 0.
               beq.s    clrwin_rts          ;Retour si ces donnes n'existent pas.
               movea.l  d0,a0               ;
               tst.b    sf.lock(a0)         ; Libre ces donnes  si elles
               bmi.s    clrwin_rts          ; ne sont pas verrouilles, et
               clr.l    (a1)                ; retour.
call_mfree3:   bra      call_mfree2         ;
;\6
;  Lit un message. Registres modifis: D0  D3, A0  A3 (passage ventuel en mode PAUSE).
;  Au retour, N = 1 ssi on est pass en mode PAUSE.

read_msg1:     moveq    #%011,d3            ; Bit 31 de D3: 0 (fentre non iconifie). Bit 30: 1 (fentre
               ror.l    #3,d3               ; au 1er plan). Bit 29: 1 (on n'est pas en mode PAUSE).
               move.w   whandle(pc),d3      ;D3: handle de la fentre de TETRHEX.
               bra.s    read_msg2           ;Suite...
;\3
;  Annule provisoirement la mise  jour, car la fentre n'est pas au 1er plan.

not_topped:    bsr      wind_endupd         ;Fct wind_update avec END_UPDATE.
;\6
;  Passage en mode PAUSE.

               tst.b    gameflag(pc)        ;
               bpl.s    pause_mode          ; Evalue la partie P de la rgle
               moveq    #rul.rulP,d0        ; si gameflag est activ.
               bsr      eval_rul            ;
pause_mode:    ext.l    d3                  ;Annule les 3 MSB de D3: fentre non iconifie, ni au 1er plan, mode PAUSE.
               bsr      ptitle              ;Titre normal + PAUSE, index de la couleur de remplissage: 1 (noir).
               lea      -16(sp),sp          ;Rserve de la mmoire pour le buffer des messages (cf evnt_multi).
wait_topped:   bsr      wait_evnt0          ;Attend un vnement (message, clic, ou frappe d'une touche du clavier).
               lsl.b    #3,d0               ; Branch. si aucun message n'a
               bpl.s    wait_topped         ; t reu (on attend encore).
               btst     #29,d3              ; Si on est en mode PAUSE et s'il ne reste
               bne.s    read_msg2           ; pas beaucoup de mmoire, alors on libre
               bsr.s    xmem_test           ; la mmoire occupe par l'image de fond.
;\9
;  Lecture d'un message. Registres modifis: D0  D3, A0  A3.
;    (SP): buffer pour le message; (SP).W: type du message.
;    D3.W: handle de la fentre.
;    Bit 31 de D3:  1 quand la fentre est iconifie.
;    Bit 30 de D3:  1 quand la fentre est au 1er plan.
;    Bit 29 de D3:  1 quand on n'est pas en mode PAUSE.

read_msg2:     lea      int_in(pc),a3       ;A3: adr. du tableau int_in.
               cmpi.w   #wm_ontop,(sp)      ; Branch. si la fentre est
               beq      wind_ontop          ; revenue au 1er plan.
               cmpi.w   #ap_term,(sp)       ; Branch. si l'application doit se terminer
term3:         beq      term                ; (shut down): fin du prg.
               cmpi.w   #ac_close,(sp)      ; Branch. si ce n'est
               bne.s    read_msg3           ; pas AC_CLOSE.
wait_open2:    bsr      bra_fredmem         ;Libre les blocs de mmoire associs aux images dcales et aux masques.
               bsr      set_pause           ;Passage en mode PAUSE.
               move.w   d3,(a3)             ; Dtruit la
               maes     wind_delete,1,1,0   ; fentre.
               bsr      wait_open           ;Attente de la rouverture de l'accessoire.
               bra      pause_end
;\4
read_msg3:     cmpi.w   #wm_closed,(sp)     ; Branch. si ce n'est pas
               bne.s    read_msg4           ; un clic sur le CLOSER.
               tst.b    acc_flag(pc)        ; Branch. si TETRHEX a t lanc en tant
               beq.s    term3               ; qu'application --> fin du prg.
               move.w   d3,(a3)             ; Ferme la
               maes     wind_close,1,1,0    ; fentre.
               bra.s    wait_open2          ;Libre les blocs, mode PAUSE, attente de la rouverture de l'accessoire.
;\4
read_msg4:     cmpi.w   #wm_redraw,(sp)     ; Branch. si ce n'est pas
               bne      not_redraw          ; le message REDRAW.
               btst     #29,d3              ; Branch. si on n'est pas en mode
               bne.s    redraw_first        ; PAUSE (on annule le redraw).
               bsr      beg_windupd2        ;Mise  jour de la fentre. Il est trs rare que N = 1.
               bmi      pause_wait          ;Branch. si on n'est pas en mode PAUSE et si la fentre n'est pas au 1er plan.
redraw_first:  move.w   #wf_firstxywh,-(sp) ;Fct  appeler en premier.
redraw_loop:   lea      int_in(pc),a0       ;Adr. du tableau int_in.
               move.w   d3,(a0)+            ;Handle de la fentre.
               move.w   (sp),(a0)           ;Mode (wf_firstxywh ou wf_nextxywh).
               bsr      window_get          ; Renvoie les coord. du
               beq      mtos_err            ; rectangle  effacer.
               lea      int_out+2(pc),a0    ;Adr. o sont stokes les coord. du rectangle.
               move.l   (a0)+,d0            ;Coord. du point suprieur gauche.
               tst.l    (a0)                ; Branch. s'il n'y a
               beq      redraw_end          ; plus de rectangle.
               btst     #29,d3              ; Branch. si on n'est
               bne.s    redraw_next         ; pas en mode PAUSE.
               lea      ptsin(pc),a1        ;
               move.l   d0,(a1)+            ;
               swap     d0                  ;
               add.w    (a0)+,d0            ; Stocke les coordonnes du
               subq.w   #1,d0               ; rectangle dans PTSIN.
               swap     d0                  ;
               add.w    (a0),d0             ;
               subq.w   #1,d0               ;
               move.l   d0,(a1)             ;
               movea.l  (a1),a3             ; Coordonnes VDI
               move.l   -(a1),-(sp)         ; du rectangle.
               bsr      clip_on             ;Set clipping rectangle.
               lea      ptsin(pc),a0        ;
               move.l   (sp)+,(a0)+         ; Efface  le
               move.l   a3,(a0)+            ; rectangle.
               bsr      frect2              ;
               tst.l    d3                  ; Branch. si la fentre est iconifie
               bmi      draw_icon           ; (alors on dessine un hexagone).
               move.l   a6,-(sp)            ;Sauve A6.
               lea      intin(pc),a6        ;A6: adr. du tableau INTIN.
               cmpi.w   #wf_nextxywh,(sp)   ; Branch. si on a dj slectionn la fonte,
               beq.s    disp_pause          ; la hauteur, la couleur et l'alignement.
               move.l   d7,-(sp)            ;Sauve D7.
               move.w   pfontid(pc),d7      ; Slectionne la fonte de n *pfontid si SpeedoGDOS
               bsr.s    sfont_cb            ; est install. Affichage centr, base line.
               move.b   col_pause+1(pc),d0  ; Couleur du texte
               bsr      text_color          ; = *col_pause.
               bsr      trans_mode          ;Mode transparent.
               moveq    #64,d7              ;Hauteur maxi des caractres: 64.
prev_height:   bsr.s    paus_extent         ;D0.W: largeur du texte en pixels.
               subq.b   #8,d7               ; Si le texte est trop long,
               cmpi.w   #windw,d0           ; alors  on recommence  avec
               bcc.s    prev_height         ; une hauteur + petite.
               move.l   (sp)+,d7            ;Rcupre D7.
disp_pause:    bsr      sto_pause           ;Copie "-- PAUSE --" dans le tableau INTIN. D0.W: nb de caractres.
               movea.l  (sp)+,a6            ;Rcupre A6.
               move.l   #(windw/2)<<16+(windh/2+32),d1  ;Coord. relatives du texte  afficher.
               bsr      disp_text           ;Affiche "-- PAUSE --", centr.
clip_off:      bsr      fill_col1           ;SET FILL COLOR INDEX, avec la couleur 1 (noir).
               bsr      no_clipping         ;Dsactive le rectangle de clipping.
redraw_next:   move.w   #wf_nextxywh,(sp)   ;Fct  appeler ensuite.
               bra      redraw_loop         ;Passe au rectangle suivant.
;\4
paus_extent:   bsr      char_height         ;Fixe la hauteur des caractres.
               bsr      sto_pause           ;Copie "-- PAUSE --" dans le tableau INTIN. D0.W: nb de caractres.
call_extent:   lea      contrl(pc),a0
               move.w   extent(pc),(a0)+    ;Code d'opration: vqt_extent ou vqt_f_extent.
               clr.w    (a0)                ;Taille de PTSIN.
               move.w   d0,4(a0)            ;Taille de INTIN.
               bsr      vdi                 ;Renvoie les coordonnes du rectangle encadrant le texte.
               move.w   ptsout+4(pc),d0     ; D0.W: largeur en
               sub.w    ptsout(pc),d0       ; pixels du texte.
               rts                          ;Retour.
;\5
cdtxt_lbot:    bsr      copy_text           ;Recopie la chane dans INTIN.
dtxt_lftbot:   bsr      disp_text           ;Affiche la chane.
left_bottom:   moveq    #3,d0               ; Alignement: gauche, bottom. On prend cet alignement
               move.l   d0,(a6)             ; de manire   ce que  les rsultats  donns  par la
               bra.s    alignment           ; fonction "inquire text extent" soient corrects.
;\4
sfont_cb:      bsr      set_font1           ;Slectionne la fonte D7 si SpeedoGDOS est install.
center_base:   clr.l    (a6)                ; INTIN[0] = 1 (centr),
               addq.w   #1,(a6)             ; INTIN[1] = 0 (base
alignment:     mvdi     vst_alignment,0,2,0 ; line).
;\6
set_redraw:    lea      redraw_flag(pc),a0  ; Active le flag
               tas      (a0)                ; de redraw.
               bmi.s    not_redraw          ;Branch. s'il tait dj actif.
               lea      16(sp),sp           ; Sinon, sortie fictive du mode PAUSE
               bra      out_pause           ; aprs libration du buffer des msg.
;\4
redraw_end:    addq.l   #2,sp               ;Dpile la fct appele.
               btst     #29,d3              ; Branch. si on n'est
               bne.s    set_redraw          ; pas en mode PAUSE.
               bsr      end_windupd2        ;Fin de la mise  jour de la fentre.
               lea      redraw_flag(pc),a0  ; Active le flag
               tas      (a0)                ; de redraw.
;\4
not_redraw:    cmpi.w   #wm_moved,(sp)      ; Branch. si la fentre
               bne.s    not_moved           ; n'a pas t dplace.
               lea      8(sp),a0            ;Ptr sur l'abscisse du point suprieur gauche de la position demande.
               lea      xx(pc),a1           ;Ptr sur l'abscisse maxi de l'cran.
               bsr.s    max_coord           ; Corrige les coord. de la position demande de manire
               bsr.s    max_coord           ;  ce que toute la fentre soit sur l'cran.
               lea      bksh_flag(pc),a1    ;Cf note bksh_flag.
               tst.b    (a1)+               ; Branch. si le drapeau bksh_flag est dsactiv
               beq.s    move_allowed        ; (alors on peut dplacer la fentre).
               tas      (a1)+               ;Dplacement de fentre interdit --> active le 2nd drapeau.
               move.l   -(a0),(a1)          ;Sauve les coord. de destination.
               bra.s    bra_pausend
;\3
move_allowed:  bsr.s    bra_fredmem         ;Libre les blocs de mmoire associs aux images dcales et aux masques.
               moveq    #wf_currxywh,d0     ; Dplace la
               bra.s    window_set          ; fentre.
;\4
max_coord:     move.w   (a1)+,d0            ;D0: abscisse/ordonne maxi de l'cran.
               move.w   (a0)+,d1            ;D1: abscisse/ordonne du point suprieur gauche de la position demande.
               bmi.s    mcoord_sub          ;On l'annule si elle est ngative (c'est possible sous Winx).
               add.w    2(a0),d1            ; D1: abscisse/ordonne + 2 du point infrieur
               addq.w   #1,d1               ; droit de la position demande.
               sub.w    d0,d1               ; Si elle est >  l'abscisse/ordonne maxi, on modifie l'abscisse/ordonne
               bls.s    mcoord_rts          ; du point suprieur gauche  de manire    ce que  l'abscisse/ordonne du
mcoord_sub:    sub.w    d1,-2(a0)           ; point infrieur droit + 2 soit =  l'abscisse/ordonne maxi de l'cran.
mcoord_rts:    rts                          ;Retour.
;\5
bra_fredmem:   movem.l  d3/a3,-(sp)         ;Sauve D3 et A3.
               moveq    #1,d3               ; Libre les blocs de mmoire associs
               bsr      free_dmem           ; aux images dcales et aux masques.
               movem.l  (sp)+,d3/a3         ;Rcupre D3 et A3.
               rts                          ;Retour.
;\2
not_moved:     cmpi.w   #wm_iconify,(sp)    ; Branch. si ce n'est pas une
               bne.s    not_iconify         ; iconification simple.
;\4
iconify:       bset     #31,d3              ;Met le MSB de D3  1: fentre iconifie.
               bne.s    bra_pausend         ;Branch. si elle a dj t iconifie.
               bsr.s    bra_fredmem         ;Libre les blocs de mmoire associs aux images dcales et aux masques.
               bsr.s    set_pause           ;Passage en mode PAUSE.
               clr.b    d0                  ; Titre de la fentre:
               bsr      set_name            ; seulement "TETRHEX".
               moveq    #wf_iconify,d0      ;Iconification.
window_set:    move.w   d3,(a3)+            ;Handle de la fentre.
               move.w   d0,(a3)+            ;Mode: iconify, uniconify ou currxywh.
               move.l   8(sp),(a3)+         ; Nouvelles coordonnes de la
               move.l   12(sp),(a3)+        ; fentre (aprs opration).
               bsr      wset                ;Effectue un wind_set.
               beq.s    mtos_err2           ;Branch. s'il y a eu une erreur.
               tst.l    d3                  ; Branch. si la fentre
               bmi.s    bra_pausend         ; est iconifie.
               bsr      get_xywh            ; Met xy0
bra_pausend:   bra      pause_end           ;  jour.
;\2
not_iconify:   cmpi.w   #wm_alliconify,(sp) ; Branch. si c'est une iconification
               beq.s    iconify             ; multiple (alliconify).
;\4
               cmpi.w   #wm_uniconify,(sp)  ; Branch. si ce n'est pas
               bne.s    not_unicon          ; une dsiconification.
               bclr     #31,d3              ;Annule le MSB de D3: fentre non iconifie.
               beq.s    bra_pausend         ;Branch. si elle a dj t dsiconifie.
               bsr      set_title           ;Titre de la fentre: en entier.
               moveq    #wf_uniconify,d0    ;Dsiconification.
               bra.s    window_set          ;Branch. pour dsiconifier la fentre.
;\4
not_unicon:    cmpi.w   #wm_bottom,(sp)     ; Branch. si ce n'est
               bne.s    not_bottom          ; pas bottom.
               move.w   d3,(a3)+            ;
               move.w   #wf_bottom,(a3)     ; Met la fentre de TETRHEX
               bsr      wset                ; au bas de la liste.
               beq.s    mtos_err2           ;
               bsr      topped_wind         ; Branch. si la fentre de TETRHEX est reste au
               beq.s    bra_pausend         ; 1er plan (i.e. il n'y a qu'une seule fentre).
untopped:      bclr     #30,d3              ;Annule le bit 30 de D3: la fentre n'est plus au 1er plan.
pause_wait:    pea      pause_end(pc)       ;Adr. o il faut se brancher aprs set_pause.
set_pause:     bclr     #29,d3              ;Annule le bit 29 de D3: passage en mode PAUSE.
               beq      mcoord_rts          ;Retour si on tait dj en mode PAUSE.
               lea      bksh_flag(pc),a0    ; Dsactive le drapeau bksh_flag, car on passe
               clr.b    (a0)                ; en mode PAUSE (cf note bksh_flag).
               bsr      move_wind2          ;Dpl. la fentre si bksh_flag+1 est activ.
ptitle:        IFNE     REGISTERED
               move.w   #msg_pause,d0       ; Envoie le msg
               bsr      send_msg0           ; msg_pause.
               ENDIF
               moveq    #wm_redraw,d0       ; On s'envoie le message wm_redraw  soi-mme pour
               bsr      send_message        ; effacer ensuite la partie visible de la fentre.
               movea.l  pwtitle(pc),a0      ; Titre normal +
               move.b   #' ',(a0)           ; "-- PAUSE".
               bsr      set_title           ; Met le
mtos_err2:     beq      mtos_err            ; titre.
fill_col1:     moveq    #1,d0               ;Index de la couleur de remplissage: 1 (noir).
fill_color:    lea      contrl(pc),a0       ;
               move.w   d0,intin-contrl(a0) ;
               move.w   #vsf_color,(a0)+    ; SET FILL COLOR
zero_vdi:      clr.w    (a0)                ; INDEX.
one_vdi:       move.w   #1,4(a0)            ;
hvdi:          move.w   handle(pc),10(a0)   ;
vdi:           move.l   #vdipb,d1           ;Bloc de paramtres VDI.
               move.w   #$73,d0             ;Code pour VDI.
               trap     #gem                ;Appel GEM.
               move.w   intout(pc),d0       ;Valeur de retour.
               rts                          ;Retour.
;\2
not_bottom:    cmpi.w   #wm_untopped,(sp)   ; Branch. si une autre fentre a t toppe (la fentre
               beq.s    untopped            ; de TETRHEX n'est donc plus au 1er plan).
;\4
               cmpi.w   #wm_topped,(sp)     ; Branch. si la fentre n'a pas t toppe
               bne.s    pause_end           ; (i.e. le message n'est pas reconnu).
               move.w   d3,(a3)+            ;
               move.w   #wf_top,(a3)        ; Toppe la fentre
               bsr.s    wset                ; de TETRHEX.
mtos_err3:     beq.s    mtos_err2           ;
wind_ontop:    bset     #30,d3              ;Met  1 le bit 30 de D3: fentre au 1er plan.
pause_end:     tst.l    d3                  ; Branch. si la fentre
               bmi      wait_topped         ; est iconifie.
               btst     #30,d3              ; Branch. si la fentre
               bne.s    pause_end2          ; est au 1er plan.
               lea      int_in+2(pc),a3     ; Fentre au
               bsr      topped_wind         ; 1er plan ?
               bne      wait_topped         ;Branch. si ce n'est pas celle de TETRHEX.
pause_end2:    lea      16(sp),sp           ;Libre le buffer. Remarque: N = 0.
               btst     #29,d3              ; Branch. si on n'est pas pass en
               bne.s    not_paused          ; mode PAUSE (retour avec N = 0).
               bsr      chg_f2lcolor        ;Rcupre les couleurs.
               IFNE     REGISTERED
               move.w   #msg_endp,d0        ; Envoie le msg
               bsr      send_msg0           ; msg_endp.
               ENDIF
               tst.b    gameflag(pc)        ;
               bpl.s    pause_end3          ; Evalue la partie Q de la rgle
               moveq    #rul.rulQ,d0        ; si gameflag est activ.
               bsr      eval_rul            ;
pause_end3:    movea.l  pwtitle(pc),a0      ; Titre de la fentre:
               clr.b    (a0)                ; normal.
               bsr.s    set_title           ; Met le
mtos_err4:     beq.s    mtos_err3           ; titre.
;\5
;  Maintenant, on n'est plus en mode PAUSE.

out_pause:     bsr      clr_wind2           ;Efface la zone de travail.
               moveq    #-1,d0              ;N = 1.
not_paused:    rts                          ;Retour.
;\6
;  Met le titre de la fentre de TETRHEX (handle dans D3).

set_title:     moveq    #' ',d0             ;D0.B = ' ' --> titre en entier.
set_name:      lea      windtitle(pc),a0    ;A0: ptr sur le titre de la fentre.
               move.b   d0,7(a0)            ;Titre en entier (D0 = ' ') ou seulement "TETRHEX" (D0 = 0).
               lea      int_in(pc),a1       ;
               move.w   d3,(a1)+            ; Met le titre,
               move.w   #wf_name,(a1)+      ;
               move.l   a0,(a1)             ; et retour.
wset:          maes     wind_set,6,1,0,0    ;
;\6
;  Dessine un hexagone dans l'icne de la fentre.

draw_icon:     move.w   col_icon(pc),d0     ;Index de la couleur de remplissage: 6 (jaune).
               bsr      fill_color          ;SET FILL COLOR INDEX.
               lea      int_in(pc),a0       ;
               move.w   d3,(a0)+            ; Rcupre les coord.
               move.w   #wf_workxywh,(a0)   ; de  l'intrieur  de
               bsr      window_get          ; l'icne.
               beq.s    mtos_err4           ;
               movea.l  d3,a3               ;Sauve D3.
               movem.w  int_out+2(pc),d0-d3 ;Coord. AES de l'intrieur de l'icne.
               lsr.w    #1,d2               ;Largeur / 2.
               lsr.w    #1,d3               ;Hauteur / 2.
               add.w    d2,d0               ;
               swap     d0                  ; D0.L: coord. du centre
               add.w    d3,d1               ; de l'icne.
               move.w   d1,d0               ;
               cmp.w    d2,d3               ; D2.W: rayon du + gd cercle
               bcc.s    draw_icon2          ; contenu   l'intrieur  de
               move.w   d3,d2               ; l'icne.
draw_icon2:    move.l   a3,d3               ;Rcupre D3.
               lsr.w    #1,d2               ; Demi-rayon de l'hexagone
               subq.w   #3,d2               ;  dessiner.
               move.w   d2,d1               ;
               mulu.w   #113512>>3,d1       ; D3.W = R.sqrt(3)/2 (on a
               swap     d1                  ; sqrt(3)*65536  113512).
               rol.l    #3,d1               ;
               lea      ptsin(pc),a0        ;Adr. du tableau PTSIN, o seront stocks les 6 sommets de l'hexagone.
               move.l   d0,(a0)             ;
               add.w    d2,(a0)+            ; ( x0 + R/2 , y0 - R.sqrt(3)/2 ).
               sub.w    d1,(a0)+            ;
               move.l   d0,(a0)             ;
               sub.w    d2,(a0)+            ; ( x0 - R/2 , y0 - R.sqrt(3)/2 ).
               sub.w    d1,(a0)+            ;
               move.l   d0,(a0)             ;
               sub.w    d2,(a0)             ; ( x0 - R ,
               sub.w    d2,(a0)             ; y0 )
               addq.l   #4,a0               ;
               move.l   d0,(a0)             ;
               sub.w    d2,(a0)+            ; ( x0 - R/2 , y0 + R.sqrt(3)/2 ).
               add.w    d1,(a0)+            ;
               move.l   d0,(a0)             ;
               add.w    d2,(a0)+            ; ( x0 + R/2 , y0 + R.sqrt(3)/2 ).
               add.w    d1,(a0)+            ;
               move.l   d0,(a0)             ;
               add.w    d2,(a0)             ; ( x0 + R , y0 ).
               add.w    d2,(a0)             ;
               mvdi     v_fillarea,6,0      ;Dessine l'hexagone rempli.
               bra      clip_off            ;Retour  redraw...

;\5
;    Ŀ
;     Calcul de l'image de fond 
;    

gbkgr_start:   movem.w  d5-d7,-(sp)         ;Sauve les paramtres pour l'affichage du gd hexagone.
;\6
;  Calcul des plans 0  3 de l'image de fond:  dgrad de couleurs de 0  30.  Soit c la couleur et n le nb form par les
;  4 bits de poids faible (plans de 0  3) de la couleur relle  stocker. Si c est pair, alors n = c/2. Si c est impair,
;  alors un point sur 2 est de couleur [c/2], et un point sur 2 de couleur [(c+1)/2] (suivant la parit de x+y).

               movea.l  d0,a6               ;Adr. du bloc de mmoire, qui contiendra l'image du fond.
               movea.l  a6,a0               ;A0: adr. du plan 0.
               lea      wplen(a0),a1        ;A1: adr. du plan 1.
               lea      wplen(a1),a2        ;A2: adr. du plan 2.
               lea      wplen(a2),a3        ;A3: adr. du plan 3.
               move.w   #windh-1,d6         ;D6.W: windh - 1 - ordonne (ordonne: de 0  windh-1).
gbkgr_outer:   moveq.l  #0,d4               ;D4.L: offset (abscisse du prochain point).
               suba.l   a5,a5               ;A5: couleur (ce n'est pas une adresse!).
               moveq    #1,d3               ; D3.L =
               swap     d3                  ; 65536.
               move.w   #575+windh,d2       ; D2.W = 576 +
               sub.w    d6,d2               ; ordonne.
gbkgr_inner:   move.w   #windw+100,d0       ;
               tst.w    d2                  ;
               beq.s    gbkgr_windw         ;
               move.l   d3,d7               ; D7.W  =  min [ (65536 + 4096 c) / max(576 - 25 c + y , 1) , windw + 100 ]  o
               divu.w   d2,d7               ;
               bvs.s    gbkgr_windw         ; c est la valeur de la couleur (de 0  30) et y l'ordonne (de 0  windh-1).
               cmp.w    d0,d7               ;
               bls.s    gbkgr_lbl1          ;
gbkgr_windw:   move.w   d0,d7               ;
gbkgr_lbl1:    subi.w   #100,d7             ;
               bcc.s    gbkgr_lbl2          ; D7.W  =  max ( D7.W - 100 , 0 ).
               clr.w    d7                  ;
gbkgr_lbl2:    move.w   d7,d1               ;D4  D7-1: segment  tracer.
               sub.w    d4,d1               ;D1.W: longueur du segment  tracer.
               beq      gbkgr_next          ;Branch. s'il n'y a rien  tracer.
               lea      -16(sp),sp          ; SP contiendra un tableau 4 mots longs (valeurs
               movea.l  sp,a4               ;  stocker pour chacun des plans 0, 1, 2 et 3).
               moveq    #3,d5               ;D5.W: longueur du tableau - 1.
               move.l   a5,d0               ;N de la couleur actuelle (de 0  30).
               lsr.b    #1,d0               ;Divise par ce n par 2.
               bcc.s    gbkgr_even          ;Branch. si le n tait pair.
               move.w   d6,-(sp)            ;Sauve D6.
               move.w   d1,-(sp)            ;Sauve D1.
               eor.b    d6,d7               ; Le n est impair --> on doit stocker 2 couleurs
               move.l   #$55555555,d6       ; successives  entrelaces.  La valeur  du bit de
               lsr.b    #1,d7               ; poids faible  dpend de la parit de x + y,  o
               bcc.s    gbkgr_odd           ; x  est  l'abscisse  du dernier point   stocker
               add.l    d6,d6               ; (D7 - 1) et y son ordonne (windh - 1 - D6).
gbkgr_odd:     move.b   d0,d1               ;D0.B: [couleur / 2].
               addq.b   #1,d1               ;D1.B: [(couleur+1) / 2].
gbkgr_loop1:   lsr.b    #1,d0               ; D7.L = %00...000 si la valeur du prochain
               scs      d7                  ; bit de D0 est 0,  D7.L = %11...111  si la
               extb.l   d7                  ; valeur du prochain bit de D0 est 1.
               and.l    d6,d7               ;AND avec le masque des points de couleur D0.
               not.l    d6                  ;Inverse le masque.
               move.l   d7,(a4)             ;Stocke la valeur provisoire dans le tableau.
               lsr.b    #1,d1               ; D7.L = %00...000 si la valeur du prochain
               scs      d7                  ; bit de D1 est 0,  D7.L = %11...111  si la
               extb.l   d7                  ; valeur du prochain bit de D1 est 1.
               and.l    d6,d7               ;AND avec le masque des points de couleur D1.
               not.l    d6                  ;Inverse le masque.
               add.l    d7,(a4)+            ;Valeur dfinitive des 32 derniers bits du segment  stocker.
               dbf      d5,gbkgr_loop1      ;Passe au plan suivant.
               move.w   (sp)+,d1            ;Rcupre D1.
               move.w   (sp)+,d6            ;Rcupre D6.
               bra.s    gbkgr_lbl3          ;Branch. pour stocker les valeurs du tableau dans l'image.
gbkgr_even:    lsr.b    #1,d0               ; D7.L = %00...000 si la valeur du prochain bit
               scs      d7                  ; de la couleur est 0,  D7.L = %11...111  si la
               extb.l   d7                  ; valeur du prochain bit de la couleur est 1.
               move.l   d7,(a4)+            ;Stocke D7.L dans le tableau.
               dbf      d5,gbkgr_even       ;Passe au plan suivant.
gbkgr_lbl3:    move.w   d1,d7               ;D1.W: nb de bits restant  copier dans l'image.
               andi.b   #31,d7              ;
               bne.s    gbkgr_lbl4          ; Si 32 | D1.W, alors D7.W = 32, sinon D7.W = D1.W % 32.
               moveq    #32,d7              ;
gbkgr_lbl4:    movea.l  sp,a4               ;Adr. du tableau.
               move.l   (a4)+,d0            ;
               bfins    d0,(a0){d4:d7}      ;
               move.l   (a4)+,d0            ; Recopie  les D7 bits de poids
               bfins    d0,(a1){d4:d7}      ; faible  de  chaque valeur  du
               move.l   (a4)+,d0            ; tableau dans chacun des plans
               bfins    d0,(a2){d4:d7}      ; 0, 1, 2, 3 de l'image.
               move.l   (a4)+,d0            ;
               bfins    d0,(a3){d4:d7}      ;
               add.w    d7,d4               ;Nouvel offset (abscisse du prochain point  stocker).
               sub.b    d7,d1               ;D1.W: nb de bits restants  copier dans l'image (multiple de 32).
               bne.s    gbkgr_lbl3          ;Boucle tant qu'il reste des points  copier.
               movea.l  a4,sp               ;Libre la mmoire occupe par le tableau.
gbkgr_next:    addi.l   #4096,d3            ;D3 += 4096 (car c est incrment, cf formule).
               subi.w   #25,d2              ;D2 -= 25 (car c est incrment, cf formule).
               bcc.s    gbkgr_lbl5          ; Si D2 < 0, on
               clr.w    d2                  ; le met  0.
gbkgr_lbl5:    addq.l   #1,a5               ;A5: n de la couleur suivante.
               cmpi.w   #windw,d4           ; Passe  la couleur suivante s'il
               bne      gbkgr_inner         ; reste des pixels dans la ligne.
               moveq    #windl,d4           ;D4.L: longueur d'une ligne en octets.
               adda.l   d4,a0               ;A0: adr. du 1er de la prochaine ligne du plan 0.
               adda.l   d4,a1               ;A1: adr. du 1er de la prochaine ligne du plan 1.
               adda.l   d4,a2               ;A2: adr. du 1er de la prochaine ligne du plan 2.
               adda.l   d4,a3               ;A3: adr. du 1er de la prochaine ligne du plan 3.
               dbf      d6,gbkgr_outer      ;Ligne suivante (D6: windh - 1 - ordonne).
;\6
;  Calcule les plans 4, 5, 6: valeur de 0  5.

ap4            equr  a5 ;Adr. du plan 4.
ap5            equr  a4 ;Adr. du plan 5.
ap6            equr  a2 ;Adr. du plan 6.
dp4            equr  d0 ;Mot qu'il faudra stocker dans le plan 4.
dp5            equr  d1 ;Mot qu'il faudra stocker dans le plan 5.
dp6            equr  d2 ;Mot qu'il faudra stocker dans le plan 6.
;\4
               movea.l  a3,ap4              ;Adr. du plan 4.
               move.w   #3*wdlen>>5-1,d7    ;D7.W: taille de 3 plans en mots longs - 1.
gbkgr_loop2:   clr.l    (a3)+               ; Annule les plans
               dbf      d7,gbkgr_loop2      ; 4, 5 et 6.
               bsr      pl456_calc0         ;A l'abscisse x, il y a T[x,5-n] pts de luminosit n.
               lea      wplen(ap4),ap5      ;Adr. du plan 5.
               pea      (ap5)               ;Sauve l'adr. de fin du plan 4.
               lea      wplen(ap5),ap6      ;Adr. du plan 6.
pl456_outr1:   clr.b    d7                  ;Drapeau.
               movea.l  a3,a0               ;Adr. du tableau.
               moveq    #windw/16,d6        ;Nb de mots dans une ligne.
               bra.s    pl456_clrd1
pl456_innr1:   moveq    #4,d3               ;Nb de valeurs de luminosit - 1.
pl456_tst1:    tst.b    (a0)+               ; Recherche la 1re
               dbne     d3,pl456_tst1       ; valeur non nulle.
               beq.s    pl456_next1         ;Branch. si toutes les valeurs (pour cette abscisse) sont nulles.
               addq.b   #1,d3               ;D3.L: luminosit (entre 1 et 5).
               subq.b   #1,-(a0)            ;Dcr. le nb de pts ayant la luminosit D3.
               adda.l   d3,a0               ;Adr. du 1er lment correspondant  l'abscisse suivante.
               tas      d7                  ;Positionne le drapeau.
               lsr.b    #1,d3               ;
               bcc.s    pl456_lbl1          ;
               bset     d5,dp4              ;
pl456_lbl1:    lsr.b    #1,d3               ; Stocke la luminosit
               bcc.s    pl456_lbl2          ; dans les 3 mots.
               bset     d5,dp5              ;
pl456_lbl2:    beq.s    pl456_next1         ;
               bset     d5,dp6              ;
pl456_next1:   dbf      d5,pl456_innr1      ;Abscisse suivante (branch. si le prochain bit est encore dans le mme mot).
               move.w   dp4,(ap4)+          ; Stocke les mots
               move.w   dp5,(ap5)+          ; dans  les plans
               move.w   dp6,(ap6)+          ; 4, 5, 6.
pl456_clrd1:   moveq    #15,d5              ;N du MSB d'un mot.
               clr.w    dp4                 ; Mots qu'il faudra stocker
               clr.w    dp5                 ; dans  les  plans  4, 5, 6
               clr.w    dp6                 ; (nuls pour l'instant).
               dbf      d6,pl456_innr1      ;Boucle (prochain mot de la ligne courante).
               tst.b    d7                  ; Boucle (passe  la ligne suivante) tant que
               bne.s    pl456_outr1         ; le tableau n'est pas compltement nul.
;\4
               bsr      pl456_calc0         ;A l'abscisse windw-1-x, il y a T[x,5-n] pts de luminosit n.
               movea.l  (sp)+,ap4           ;Adr. de fin du plan 4.
               lea      wplen(ap4),ap5      ;Adr. de fin du plan 5.
               lea      wplen(ap5),ap6      ;Adr. de fin du plan 6.
pl456_outr2:   clr.b    d7                  ;Drapeau.
               movea.l  a3,a0               ;Adr. du tableau.
               moveq    #windw/16,d6        ;Nb de mots dans une ligne.
               bra.s    pl456_clrd2
pl456_innr2:   moveq    #4,d3               ;Nb de valeurs de luminosit - 1.
pl456_tst2:    tst.b    (a0)+               ; Recherche la 1re
               dbne     d3,pl456_tst2       ; valeur non nulle.
               beq.s    pl456_next2         ;Branch. si toutes les valeurs (pour cette abscisse) sont nulles.
               addq.b   #1,d3               ;D3.L: luminosit (entre 1 et 5).
               subq.b   #1,-(a0)            ;Dcr. le nb de pts ayant la luminosit D3.
               adda.l   d3,a0               ;Adr. du 1er lment correspondant  l'abscisse prcdente.
               tas      d7                  ;Positionne le drapeau.
               lsr.b    #1,d3               ;
               bcc.s    pl456_lbl3          ;
               bset     d5,dp4              ;
pl456_lbl3:    lsr.b    #1,d3               ; Stocke la luminosit
               bcc.s    pl456_lbl4          ; dans les 3 mots.
               bset     d5,dp5              ;
pl456_lbl4:    beq.s    pl456_next2         ;
               bset     d5,dp6              ;
pl456_next2:   addq.b   #1,d5               ; Abscisse prcdente (branch. si
               cmpi.b   #16,d5              ; le prochain bit est encore dans
               bne.s    pl456_innr2         ; le mme mot).
               move.w   dp4,-(ap4)          ; Stocke les mots
               move.w   dp5,-(ap5)          ; dans  les plans
               move.w   dp6,-(ap6)          ; 4, 5, 6.
pl456_clrd2:   clr.b    d5                  ;N du LSB d'un mot.
               clr.w    dp4                 ; Mots qu'il faudra stocker
               clr.w    dp5                 ; dans  les  plans  4, 5, 6
               clr.w    dp6                 ; (nuls pour l'instant).
               dbf      d6,pl456_innr2      ;Boucle (prochain mot de la ligne courante).
               tst.b    d7                  ; Boucle (passe  la ligne suivante) tant que
               bne.s    pl456_outr2         ; le tableau n'est pas compltement nul.
;\5
;  Dessine le grand hexagone en monochrome.

               movem.w  (sp)+,d5-d7         ;Rcupre les donnes concernant le gd hexagone.
               movea.l  a6,a5               ; Adr. de la zone o doit tre dessin
               adda.l   #7*wplen,a5         ; le gd hexagone en monochrome.
;\5
;    D7.W: nb n de petits hexagones dans un ct du gd hexagone.
;    D6.W: hauteur du bloc qui contiendra le gd hexagone.
;    D5.W: largeur, en mots, de ce bloc.
;    A6: adr. de l'img de fond.
;    A5: adr. o doit tre dessin le gd hex. en monochrome.
;\4
draw_hex:      move.w   d6,d0               ;
               mulu.w   d5,d0               ;
               movea.l  a5,a0               ; Efface cette zone
clr_hex:       clr.w    (a0)+               ; de mmoire.
               subq.w   #1,d0               ;
               bne.s    clr_hex             ;
               ext.l    d5                  ; D5.L: taille d'une
               add.w    d5,d5               ; ligne en octets.
               move.w   d7,d4               ;
               add.b    d4,d4               ; D4.W: compteur (de 2n-1  1).
               subq.b   #1,d4               ;
               moveq    #0,d3               ;D3.L: offset (en bits) de la prochaine colonne de petits hexagones.
clrhex_outer:  move.w   d4,d2               ;
               sub.w    d7,d2               ;
               bpl.s    clrhex_abs          ;
               neg.w    d2                  ; A4: adr. de la 1re ligne
clrhex_abs:    move.w   d2,d0               ; de la colonne actuelle.
               mulu.w   #yhex/2,d0          ;
               mulu.w   d5,d0               ;
               lea      (a5,d0.l),a4        ;
               lea      pattern1(pc),a3     ;Adr. du motif du petit hexagone.
               move.w   d7,d1               ;
               add.b    d1,d1               ; D1.W: nb de petits
               subq.b   #2,d1               ; hexagones - 1.
               sub.b    d2,d1               ;
clrhex_inner:  move.l   (a3)+,d0            ;Prochaine ligne du motif.
               bfins    d0,(a4){d3:hexw}    ;Stocke la ligne.
               adda.l   d5,a4               ;Adr. de la ligne suivante de destination.
               tst.l    (a3)                ; Boucle jusqu' la
               bne.s    clrhex_inner        ; fin du motif.
               lea      pattern2(pc),a3     ;Adr. de la 3me ligne du motif.
               dbf      d1,clrhex_inner     ;Boucle pour dessiner le petit hexagone suivante.
               addi.w   #xhex,d3            ;Offset de la colonne suivante.
               subq.b   #1,d4               ; Boucle (dessine la
               bhi.s    clrhex_outer        ; colonne suivante).
;\8
;  Recopie le gd hexagone sur l'image de fond, en 3D:  pour p allant de 3  0,  il est recopi en
;  mode transparent, en couleur 227-p,  partir d'un point de coord. (X-p,Y-p) de la destination.
;  La couleur 227 sera blanche, et les couleurs 226, 225 et 224 seront grises (dgrad).

;    Calcule l'abscisse et l'ordonne du bloc, pour p = 3.

               lsr.w    #1,d5               ;D5.W: largeur d'une ligne source en mots.
               move.w   #windh+2*ky,d4      ; D4.W: Y-3, o Y est
               sub.w    d6,d4               ; l'ordonne  du bloc
               lsr.w    #1,d4               ; pour p = 0.
               moveq    #20,d3              ;
               sub.w    d5,d3               ; D3.W: (X-3)/16, o X est l'abscisse
               addq.w   #3,d3               ; du bloc pour p = 0.
               lsr.b    #1,d3               ;
;\3
               moveq    #3,d7               ;D7.W: p (compris entre 0 et 3).
cpy_hex:       moveq    #227&$7F,d2         ; D2.B: couleur de l'hexagone
               sub.b    d7,d2               ; sans compter le plan 7.
;\6
;    Recopie le gd hexagone dans la couleur D2 (mod 128). On commence par le plan 0 et on termine par le plan 6.

               lea      (a6,d3.w*2),a4      ;
               moveq    #windl,d0           ; A4: adr. du plan 0 o doit
               mulu.w   d4,d0               ; tre recopi le 1er mot.
               adda.l   d0,a4               ;
               moveq    #6,d1               ;Nb de plans - 1.
               movem.w  d3/d4/d7,-(sp)      ;Sauve les registres.
cpyhex_plane:  lsr.b    #1,d2               ; D0.W = %xxx...xxx,  o  1-x  est  la
               scc      d0                  ; valeur  stocker dans le plan actuel
               ext.w    d0                  ; pour chaque point de l'hexagone.
               movea.l  a5,a3               ;Adr. du bloc source (contenant l'hexagone).
               movea.l  a4,a2               ;Adr. du plan actuel de la destination.
               move.w   d6,d4               ;Hauteur du bloc source (contenant l'hexagone).
cpyhex_outr1:  movea.l  a2,a1               ;Adr. de la ligne actuelle de la destination.
               move.b   d5,d3               ;Nb de mots dans une ligne du bloc source.
cpyhex_innr1:  move.w   (a1),d7             ;Mot courant de la destination.
               eor.w    d0,d7               ; Annule ou met  1 les bits correspondant
               or.w     (a3)+,d7            ; aux pts de l'hexagone, suivant la valeur
               eor.w    d0,d7               ; de D0.
               move.w   d7,(a1)+            ;Stocke le rsultat dans la destination.
               subq.b   #1,d3               ; Boucle pour copier le prochain
               bne.s    cpyhex_innr1        ; mot de la ligne.
               lea      windl(a2),a2        ;Adr. de la ligne suivante de la destination.
               subq.w   #1,d4               ; Boucle pour copier la prochaine
               bne.s    cpyhex_outr1        ; ligne du plan actuel.
               lea      wplen(a4),a4        ;Adr. du plan suivant de la destination.
               dbf      d1,cpyhex_plane     ;Boucle pour copier le prochain plan.
               movem.w  (sp)+,d3/d4/d7      ;Rcupre les registres.
;\6
;    Dcale le gd hexagone d'un cran vers la droite, i.e. incr. l'abscisse.

               movea.l  a5,a0               ;Adr. du bloc contenant le gd hexagone.
               move.w   d6,d1               ;D1.W: nb de lignes de ce bloc.
cpyhex_outr2:  move.w   d5,d0               ; D0.W: nb de mots - 1 dans une ligne
               subq.w   #1,d0               ; de ce bloc. Annule le bit X du CCR.
cpyhex_innr2:  roxr     (a0)+               ; Effectue un dcalage d'une ligne de
               dbf      d0,cpyhex_innr2     ; l'hexagone source vers la droite.
               subq.w   #1,d1               ; Passe  la ligne suivante
               bne.s    cpyhex_outr2        ; (pour le dcalage).
;\4
;    Boucle: passe au p prcdent.

               addq.w   #1,d4               ;Incr. l'ordonne.
               dbf      d7,cpy_hex          ;Boucle.
;\3
;    Retour (l'image est entirement calcule).

               rts                          ;Retour.
;\7
;  Sous-prg utilis pour le calcul des plans 4, 5, 6 de l'image de fond.
;  Registres non modifis: A3, A5 et A6.  A3: adr. du tableau.
;  Au retour, on obtient un tableau de windw tableaux de 5 octets:
;    Pour 0  x  windw-1 et 1  n  5:  l'abscisse x, il y a T[x,5-n] pts de luminosit n.

pl456_calc0:   bsr.s    pl456_calc1         ;A l'abscisse x, il y a T[x,5-n] pts de luminosit  n.
               movea.l  a3,a0               ;Adr. du tableau.
               move.w   #windw-1,d0         ;Nb d'abscisses possibles - 1.
pl456_c0outr:  move.l   (a0),d1             ; Pour n allant de 4  1, on
               sub.l    d1,1(a0)            ; fait: T[x,n] -= T[x,n-1].
               moveq    #4,d1               ;
pl456_c0innr:  tst.b    (a0)+               ; Lorsqu'un lment du
               bne.s    pl456_c0dbf         ; tableau est nul,  on
               addq.b   #1,-1(a0)           ; le met  1.
pl456_c0dbf:   dbf      d1,pl456_c0innr     ;
               dbf      d0,pl456_c0outr     ;Boucle (prochaine abscisse).
               rts                          ;Retour.
;\7
;  Sous-prg utilis pour le calcul des plans 4, 5, 6 de l'image de fond.
;  Registres non modifis: A3, A5 et A6.  A3: adr. du tableau.
;  Au retour, on obtient un tableau de windw tableaux de 5 octets:
;    Pour 0  x  windw-1 et 1  n  5:  l'abscisse x, il y a T[x,n] pts de luminosit  n.

pl456_calc1:   movea.l  a3,a0               ;
               move.w   #windw-1,d0         ;
pl456_c1loop:  move.l   #$03040506,(a0)+    ; Initialise le tableau.
               move.b   #$07,(a0)+          ;
               dbf      d0,pl456_c1loop     ;
               bsr      rand24              ;Renvoie dans D0 un nb alatoire sur 24 bits.
               move.w   d0,d7               ;D7.W: nb alatoire sur 16 bits.
               move.b   d7,d6               ;
               add.b    d6,d6               ; D6.W: nb alatoire
               ext.w    d6                  ; entre -64 et 63.
               asr.b    #1,d6               ;
               addi.w   #windw/3,d6         ;D6.W: abscisse du 1er gd pic.
               asr.w    #8,d7               ;D7.W: nb alatoire entre -64 et 63.
               addi.w   #2*windw/3,d7       ;D7.W: abscisse du 2nd gd pic.
               swap     d0                  ; D0.W: nb alatoire
               andi.w   #$3F,d0             ; entre 0 et 63.
               move.w   d6,d1               ;
               lsr.w    #2,d1               ; Petit pic (hauteur:
               moveq    #42,d2              ; 42  105).
               bsr.s    pl456_calc3         ;
               move.w   d6,d1               ;
               lsr.w    #1,d1               ; Moyen pic (hauteur:
               moveq    #77,d2              ; 77  140).
               bsr.s    pl456_calc3         ;
               move.w   d6,d1               ;
               mulu.w   #3,d1               ; Petit pic (hauteur:
               lsr.w    #2,d1               ;
               moveq    #103,d2             ; 40  103).
               bsr.s    pl456_calc2         ;
               move.w   d6,d1               ;
               moveq    #127,d2             ; 1er gd pic (hauteur: 127  190).
               bsr.s    pl456_calc3         ;
               move.w   d7,d1               ;
               mulu.w   #3,d1               ;
               add.w    d6,d1               ; Petit pic (hauteur:
               lsr.w    #2,d1               ; tjrs 62).
               moveq    #62,d2              ;
               bsr.s    pl456_calc4         ;
               move.w   d6,d1               ;
               add.w    d7,d1               ;
               lsr.w    #1,d1               ; Petit/moyen pic (hauteur:
               move.w   d6,d2               ; 36  130).
               lsr.w    #2,d2               ;
               bsr.s    pl456_calc3         ;
               move.w   d6,d1               ;
               mulu.w   #3,d1               ;
               add.w    d7,d1               ; Petit pic (hauteur:
               lsr.w    #2,d1               ; 28  91).
               moveq    #28,d2              ;
               bsr.s    pl456_calc3         ;
               move.w   d7,d1               ;
               move.w   #196,d2             ; 2nd gd pic (hauteur: 133  196).
               bsr.s    pl456_calc2         ;
               moveq    #0,d1               ;
               add.w    d7,d7               ;
               move.w   d7,d1               ;
               addi.w   #windw,d1           ; Petit/moyen/grand pic
               moveq    #3,d2               ;
               divu.w   d2,d1               ; (hauteur: 8  197).
               mulu.w   d0,d2               ;
               addq.w   #8,d2               ;
               bsr.s    pl456_calc4         ;
               moveq    #0,d1               ;
               move.w   d7,d1               ;
               addi.w   #5*windw,d1         ; Petit pic (hauteur:
               divu.w   #7,d1               ; 29  92)...
               moveq    #92,d2              ;
pl456_calc2:   sub.w    d0,d2               ;
               bra.s    pl456_calc4
pl456_calc3:   add.w    d0,d2
pl456_calc4:   move.w   d1,d3               ;Abscisse du pic.
               mulu.w   #5,d3               ; Ptr sur le 1er lment du
               lea      (a3,d3.l),a0        ; tableau  correspondant  
               movea.l  a0,a1               ; cette abscisse.
               move.w   d1,d3               ;Abscisse gauche.
               move.w   d1,d4               ;Abscisse droite.
               clr.w    d1                  ;|x-x0| (0 pour l'instant).
               add.w    d2,d2               ; D2.L: 2 fois
               ext.l    d2                  ; la hauteur.
               movem.w  d6/d7,-(sp)         ;Sauve les registres.
pl456_c2outr:  moveq    #5,d5               ;Luminosit n maxi.
pl456_c2innr:  move.w   d5,d6               ;
               add.b    d6,d6               ;         2 . hauteur
               add.w    d1,d6               ; D7.B = ------------- .
               move.l   d2,d7               ;         |x-x0| + 2n
               divu.w   d6,d7               ;
               moveq    #8,d6               ;
               sub.b    d5,d6               ; Branch. si D7.B est  
               cmp.b    d6,d7               ; la valeur minimale 8-n.
               bls.s    pl456_c2lbl2        ;
               bset     #31,d5              ;Positionne le drapeau.
               tst.w    d3                  ; Branch. si l'abscisse
               bmi.s    pl456_c2lbl1        ; gauche est < 0.
               cmp.b    (a0),d7             ; Stocke dans le tableau  le max de D7 et
               bls.s    pl456_c2lbl1        ; de la valeur de l'lment correspondant
               move.b   d7,(a0)             ;  l'abscisse gauche.
pl456_c2lbl1:  cmpi.w   #windw,d4           ; Branch. si l'abscisse
               bcc.s    pl456_c2lbl2        ; droite est  windw.
               cmp.b    (a1),d7             ; Stocke dans le tableau  le max de D7 et
               bls.s    pl456_c2lbl2        ; de la valeur de l'lment correspondant
               move.b   d7,(a1)             ;  l'abscisse droite.
pl456_c2lbl2:  addq.l   #1,a0               ;Incr. A0, car on dcr. n.
               addq.l   #1,a1               ;Incr. A1, car on dcr. n.
               subq.b   #1,d5               ;Dcr. la luminosit n.
               bne.s    pl456_c2innr        ;Boucle tant que n > 0.
               lea      -10(a0),a0          ;Met  jour A0.
               addq.w   #1,d1               ;Incr. |x-x0|.
               subq.w   #1,d3               ;Dcr. l'abscisse gauche.
               addq.w   #1,d4               ;Incr. l'abscisse droite.
               tst.l    d5                  ; Boucle si le drapeau
               bmi.s    pl456_c2outr        ; est positionn.
               movem.w  (sp)+,d6/d7         ;Rcupre les registres.
               rts                          ;Retour.
;\6
;  L'image de fond a t entirement calcule en tche de fond.

gbkgr_end:     lea      backflag(pc),a0     ; Indique que les calculs
               tas      (a0)                ; sont termins.
               clr.b    multflag-backflag(a0)  ;Indique qu'il n'y a plus de calcul en tche de fond.
gbkgr_loop:    bra.s    gbkgr_loop          ;Boucle qui sera interrompue par le timer.

;\6
;  Rserve un bloc de mmoire, form de 2 parties:
;   _ Une qui contiendra le fond de la zone de travail (plans 0  6).
;   _ L'autre qui contiendra le grand hexagone (1 seul plan).
;  D5.W: largeur, en mots, du bloc qui contiendra le gd hexagone.
;  D6.W: hauteur de ce bloc.
;  D7.W: nb n de petits hexagones dans un ct du gd hexagone.
;\6
gbkgr_resmem:  bsr.s    gbkgr_begin         ;Calcule D5, D6, D7, et la mmoire  rserver pour le gd hexagone.
               addi.l   #7*wplen,d0         ;Ajoute la taille de 7 plans, pour le fond de la zone de travail.
               bsr.s    test_malloc         ;Rserve un bloc de mmoire de D0.L octets.
               lea      backaddr(pc),a0     ; Stocke l'adr. de la zone
               move.l   d0,(a0)             ; rserve dans backaddr.
               rts                          ;Retour.
;\4
gbkgr_begin:   move.w   nhex(pc),d7         ;Nb n de petits hexagones dans un ct du gd hexagone.
               moveq    #2*yhex,d6          ; 40 n - 18 = 20 (2n-1) + 2:
               mulu.w   d7,d6               ; hauteur  du grand hexagone
               subi.w   #2*yhex-hexh,d6     ; (monochrome).
               moveq    #2*xhex,d5          ; 36 (n-1) + 26 + 3 + 15: largeur + 3 + 15
               mulu.w   d7,d5               ; du gd hexagone (3: il y aura 3 dcalages
               addi.w   #hexw-2*xhex+18,d5  ; vers la droite, 15: un mot = 16 bits).
               lsr.w    #4,d5               ;Largeur en mots du gd hexagone.
               move.w   d5,d0               ; Largeur en octets
               add.w    d0,d0               ; du gd hexagone.
               mulu.w   d6,d0               ;Taille totale en octets du gd hexagone.
               move.l   #5*windw,d1         ;Taille de la mmoire utilise pour le calcul des plans 4, 5, 6.
               cmp.l    d0,d1               ;
               bls.s    gbbegin_rts         ; D0.L: + gde des 2 tailles.
               move.l   d1,d0               ;
gbbegin_rts:   rts                          ;Retour.
;\4
test_malloc:   bsr.s    call_malloc         ;Rserve un bloc de D0.L octets.
               tst.l    d0                  ; Branch. si mmoire
               beq      insuf_mem           ; insuffisante.
               rts                          ;Retour sans erreur.
;\3
call_malloc:   move.l   d0,-(sp)            ;
               mgemdos  Malloc,6            ; Rserve un bloc de D0.L octets.
               rts                          ;

;\8
;    Ŀ
;     Affichage de l'image de fond 
;    

;  bkgr_image: annule la valeur des couleurs de la fentre et affiche l'image de
;  fond (mais les couleurs restent noires). Le smaphore cran reste activ.

bkgr_again:    bsr      end_windupd         ;Fin de mise  jour de la fentre si le jeu se droule dans une fentre GEM.
;\7
;  Annule la valeur de toutes les couleurs de la fentre.

bkgr_image:    lea      RGB+240*4(pc),a0    ;Adr. de la couleur 240.
               move.w   #240-fcolor,d0      ;Nb de valeurs  annuler.
clr_windcol:   clr.l    -(a0)               ; Annule la valeur
               dbf      d0,clr_windcol      ; des couleurs.
               bsr      chg_f2lcolor        ;Change la couleur des pinceaux.
;\6
;  Ici, on calcule l'image de fond si elle n'est pas en mmoire.

               lea      backflag(pc),a1        ; Met backflag  1 (car on va rserver
               clr.b    dateflag-backflag(a1)  ; de la mmoire pour l'image de fond),
               tas      (a1)+                  ; et dateflag  0.
               bmi.s    disp_img            ;Branch. si l'img de fond tait dj en mmoire.
               IFNE     REGISTERED
               moveq    #msg_bkgr,d0        ; Envoie le msg
               bsr      send_msg0           ; msg_bkgr.
               tst.l    d0                  ;L'img de fond a-t-elle t calcule par le fichier de msg?
               sne      backtype-backaddr(a1) ;Si oui, stocke -1 dans backtype; sinon stocke 0.
               bne.s    other_bkgr          ;Branch. si l'img de fond a t calcule par le fichier de msg.
               bsr      gbkgr_resmem        ;Rserve de la mmoire...
               ELSE
               bsr.s    gbkgr_resmem        ;Rserve de la mmoire...
               ENDIF
               bsr      gbkgr_start         ;Calcul de l'img de fond.
               bra.s    disp_img            ;Branch. pour afficher l'img de fond.
other_bkgr:    move.l   d0,(a1)             ;Stocke l'adr. de l'img dans backaddr...
               movea.l  d0,a6               ;... et dans A6 (pour draw_hex).
               bsr.s    gbkgr_begin         ;Calcule D5, D6, D7, et la mmoire  rserver pour le gd hexagone.
               bsr.s    test_malloc         ;Rserve un bloc de mmoire pour le gd hexagone.
               movea.l  d0,a5               ;Adr. de ce bloc de mmoire (pour draw_hex).
               bsr      draw_hex            ;Dessine le gd hexagone sur l'img de fond.
;\6
;  Affiche l'image de fond (plans 0  6, en commanant par les plans de poids fort).

disp_img:      bsr      wd_update           ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM...
               lea      backflag(pc),a0     ;(A0): backflag, 1(A0): backaddr, 5(A0): addr_scr, 9(A0): xy0, 13(A0): xlen.
               tst.b    (a0)+               ; Branch. si l'image de fond n'est plus
               bpl.s    bkgr_again          ; en mmoire (il faut tout recalculer).
               movea.l  (a0)+,a6            ;A6: adr. de l'image source.
               movea.l  (a0)+,a5            ;Adr. de l'cran logique.
               moveq    #0,d4               ; D4.L: abscisse du point suprieur gauche
               move.w   (a0)+,d4            ; de la fentre (zone de travail).
               move.w   (a0)+,d1            ;Ordonne de ce point.
               moveq    #0,d3               ; D3.L: longueur d'une
               move.w   (a0),d3             ; ligne en octets.
               mulu.w   d3,d1               ; A5: adresse du mot du plan 6
               add.l    d4,d1               ; contenant le point suprieur
               andi.b   #$F0,d1             ; gauche  de la fentre  (zone
               lea      12(a5,d1.l),a5      ; de travail).
               andi.w   #$F,d4              ;D4.L: n du bit en partant de la gauche.
               moveq    #6,d0               ;D0.W: n du 1er plan  recopier.
cpyfm_loop:    movea.l  a5,a0               ;Adr. du mot du plan D0 contenant le point suprieur gauche de la fentre.
               move.w   #wplen,d1           ;Taille d'un plan en octets.
               mulu.w   d0,d1               ; A4: adr. du plan D0
               lea      (a6,d1.l),a4        ; de l'image source.
               moveq    #0,d5               ;Offset (en bits) du 1er point du plan D0.
               move.w   #windh-1,d1         ;Nb de lignes - 1 (compteur).
cpyfm_outer:   movea.l  a0,a1               ;Adr. du mot du plan D0 contenant le point  gauche de la ligne actuelle.
               moveq    #16,d7              ; D7.L: nb de bits  recopier
               sub.b    d4,d7               ; dans le 1er mot.
               bfextu   (a4){d5:d7},d6      ; Recopie les D7 premiers bits dans les
               bfins    d6,(a1){d4:d7}      ; bits de poids faible du 1er mot.
               lea      16(a1),a1           ;Adr. du mot suivant de la destination (mme plan).
               add.l    d7,d5               ;Nouvel offset (source).
               move.w   #windw,d2           ;Largeur d'une ligne (en bits).
               sub.w    d7,d2               ;D2.W: nb de bits restant  recopier.
               moveq    #16,d7              ;D7.L = 16.
               sub.w    d7,d2               ;D2.W + 16: nb de bits restant  recopier.
cpyfm_inner:   bfextu   (a4){d5:d7},d6      ;D6.W: 16 bits suivants (source).
               add.l    d7,d5               ;Nouvel offset (source).
               move.w   d6,(a1)             ;Recopie les 16 bits dans la destination.
               adda.l   d7,a1               ;Adr. du mot suivant de la destination (mme plan).
               sub.w    d7,d2               ;D2.W + 16: nb de bits restant  recopier.
               bhi.s    cpyfm_inner         ;Boucle tant qu'il reste strictement + de 16 bits  recopier.
               add.b    d2,d7               ;D7.L: nb de bits restant  recopier.
               bfextu   (a4){d5:d7},d6      ; Recopie les bits restants dans les bits
               bfins    d6,(a1){0:d7}       ; de poids fort du mot de destination.
               add.l    d7,d5               ;Nouvel offset (source).
               adda.l   d3,a0               ;Adr. du mot du plan D0 contenant le point  gauche de la ligne suivante.
               dbf      d1,cpyfm_outer      ;Passe  la ligne suivante.
               subq.l   #2,a5               ;Adr. du plan prcdent dans la destination.
               dbf      d0,cpyfm_loop       ;Passe au plan prcdent (dernier plan: plan 0).
;\7
;  Sauvegarde le fond des cases si ce n'est pas dj fait. Attention au format de stockage!
;    Les images sont stockes les unes  la suite des autres dans *hbk_addr, colonne par colonne en commenant par le bas.
;    Pour chaque image,  on stocke les 8 plans de la 1re ligne (8 mots longs),  puis les 8 plans de la 2me ligne (8 mots
;    longs),  et ainsi de suite.  Les 2 bits les +  gauche de la case sont stocks dans les MSB des mots longs.  Certains
;    bits n'appartenant pas  la case sont stocks en mme temps que ceux de la case, mais cela n'a pas d'importance.

               lea      hbk_req(pc),a0      ; Active le drapeau
               tas      (a0)                ; hbk_req.
               movea.l  hbk_addr(pc),a0     ;Adr. o il faut stocker les donnes.
               bmi.s    dispimg_end         ;Branch. si le drapeau tait dj activ.
               movea.l  a0,a1               ;
               move.w   #hbklen-1,d0        ; Efface la zone
clr_hexbk:     clr.l    (a1)+               ; hexbk.
               dbf      d0,clr_hexbk        ;
               movea.l  backaddr(pc),a1     ;A1: adr. de l'img du fond.
               move.w   nhex(pc),d0         ;
               move.w   d0,d4               ;
               moveq    #10,d2              ;
               mulu.w   d0,d2               ; D1.L: abscisse min. de la + basse case ("trou")
               addi.w   #192+ky,d2          ; de la 1re colonne:  165 - 16n.  D2.W: ordonne
               move.l   #165,d1             ; min. de cette case:  192 + ky + 10n.  D3.W: -1.
               lsl.b    #4,d0               ; D4.W: nb d'hex. dans un ct du gd hex.
               sub.b    d0,d1               ;
               moveq    #-1,d3              ;
hexbk_outer1:  neg.w    d3                  ;Change de direction (vers le bas, puis vers le haut).
hexbk_outer2:  move.w   d2,-(sp)            ;Sauve l'ordonne min. de la + basse case de la colonne.
               move.w   d4,d0               ;D0.W: nb d'hex. dans la colonne courante (compteur).
hexbk_inner:   move.w   #windl,d7           ; A2: adr.  de la ligne de l'img
               mulu.w   d2,d7               ; source contenant la 1re ligne
               lea      (a1,d7.l),a2        ; de l'hex. courant.
               moveq    #inhy-1,d6          ;D6.W: nb de lignes - 1 dans un hex. (compteur).
hexbk_nextln:  movea.l  a2,a3               ;A3: adr. du 1er plan de la ligne courante de l'img source.
               moveq    #6,d5               ;D5.W: nb de plans - 1 (compteur): 6 (le plan 7 est tjrs  1).
hexbk_nextpl:  bfextu   (a3){d1:32},d7      ; Recopie les 7 premiers
               move.l   d7,(a0)+            ; plan  d'une  ligne  de
               lea      wplen(a3),a3        ; l'hex.  (+  qq  autres
               dbf      d5,hexbk_nextpl     ; pts, sans importance).
               moveq    #-1,d5              ; Stocke -1 (tous les pts
               move.l   d5,(a0)+            ; du plan 7 sont  1).
               lea      windl(a2),a2        ;A2: adr. de la ligne suivante de l'img source.
               dbf      d6,hexbk_nextln     ;Boucle (passe  la ligne suivante).
               subi.w   #yhex,d2            ;D2.W: ordonne de l'hex. situ en-dessus.
               subq.b   #1,d0               ; Boucle (passe  l'hex.
               bne.s    hexbk_inner         ; situ en-dessus).
               move.w   (sp)+,d2            ;Rcupre l'ordonne min. de la case la + haute de la colonne.
               addi.w   #xhex,d1            ;Abscisse de la colonne suivante.
               moveq    #yhex/2,d0          ; Calcule l'ordonne min.
               muls.w   d3,d0               ; de  la + basse case  de
               add.w    d0,d2               ; la colonne suivante.
               add.w    d3,d4               ;Nb d'hex. dans la colonne suivante.
               cmp.b    nh4+1(pc),d4        ; Branch. si c'est la colonne du
               bhi.s    hexbk_outer1        ; milieu (on change de sens).
               cmp.b    nhex+1(pc),d4       ; Boucle s'il reste encore
               bcc.s    hexbk_outer2        ; des colonnes.
;\3
;  Libre la mmoire utilise par l'image de fond, s'il n'en reste pas assez.

dispimg_end:   bra      xmem_test           ;Libre la mmoire utilise par l'image de fond, s'il n'en reste pas assez.

;\7
;    Ŀ
;     Charge un nouveau fichier de rgle (libre l'ancien) 
;    

free_rul:      lea      backflag(pc),a0     ; Libre les blocs de mmoire
               bclr     #0,(a0)             ; associs   l'affichage des
               bsr      dmem_test           ; nb, s'il y en a.
               move.l   patterns(pc),d0     ; Libre le bloc de mmoire
               bsr      call_mfree2         ; contenant les motifs.
               move.l   rul_ptr(pc),d0      ; Libre l'ancien fichier
               bsr      call_mfree2         ; de rgle.
;\9
;    Ŀ
;     Charge un fichier de rgle 
;    

;  Charge le fichier de rgle dont le nom se trouve dans string. Le ptr sera stock dans rul_ptr.
;  Tous les registres sont modifis.

load_rul:      clr.w    -(sp)               ;Attributs: n'importe lesquels.
               lea      string(pc),a6       ; Adr. o se trouve le nom du fichier
               pea      (a6)                ;  rechercher (avec chemin).
               mgemdos  Fsfirst,8           ;Recherche le fichier.
               tst.l    d0                  ; Branch. si le fichier de
               beq.s    rul_found           ; rgle a t trouv.
               moveq    #7,d7               ;D7.W = 7: code de retour en cas d'erreur.
               movea.l  alert_ruln+4(pc),a5 ;Texte de la bote d'alerte  afficher si on recherchait "TETRHEX.RUL".
               tst.b    string+strlen-1(pc) ; Branch. si on recherchait
               beq      alert4              ; le fichier "TETRHEX.RUL".
               pea      load_rul(pc)        ;Adr. o il faut se brancher aprs rul_default.
rul_default:   lea      string(pc),a0       ; Dsactive le drapeau: on
               clr.b    strlen-1(a0)        ; recherche "TETRHEX.RUL".
               move.l   #'TETR',(a0)+       ; Nom du fichier de
               move.l   #'HEX.',(a0)+       ; rgle par dfaut:
               move.l   #'RUL'<<8,(a0)      ; "TETRHEX.RUL".
loadrul_rts:   rts                          ;Retour.
;\6
;  Positionnement par rapport au dbut du fichier et lecture d'une partie du fichier.

seek_read:     clr.w    -(sp)               ;Mode: par rapport au dbut du fichier.
               move.w   d6,-(sp)            ;Handle du fichier.
               move.l   d0,-(sp)            ;Offset.
               mgemdos  Fseek,6             ;Appelle GEMDOS: positionnement. Laisse un mot long dans la pile (cf ci-dessous).
               tst.l    d0                  ; Branch. s'il y a
               bmi.s    gemdos_error        ; eu une erreur.
               move.l   a5,(sp)             ;
               move.l   d5,-(sp)            ; Lit D5 octets du fichier
               move.w   d6,-(sp)            ; (sont placs dans (A5)).
               mgemdos  Fread,12            ;
               tst.l    d0                  ; Retour si pas
               bpl.s    loadrul_rts         ; d'erreur.
;\5
;  Erreur GEMDOS.

gemdos_error:  moveq    #-1,d7              ;D7.W = -1: code de retour.
               movea.l  alert_gmds+4(pc),a5 ;Texte de la bote d'alerte  afficher.
               bra      alert4              ;Affiche une bote d'alerte, et fin du prg.
;\6
;    Un fichier a t trouv, et A6 = string. Garde le chemin et recopie le nom du fichier
;     la suite (dans string); cette opration est due  l'utilisation possible de jokers.

rul_found:     movea.l  a6,a4               ;A4: contiendra l'adr.  laquelle il faudra recopier le nom du fichier.
               movea.l  a6,a5               ;A5: parcourra string pour recherche les sparateurs '\'.
rul_loop1:     cmpi.b   #'\',(a5)           ;
               bne.s    rul_lbl1            ;
               addq.l   #1,a5               ; A4: adr.  laquelle il faut
               movea.l  a5,a4               ; recopier le nom du fichier.
rul_lbl1:      tst.b    (a5)+               ;
               bne.s    rul_loop1           ;
               lea      dta+d_fname(pc),a0  ;Adr. du nom du fichier (dans la DTA).
               lea      string+strlen-1(pc),a1  ;Adr. du dernier caractre du buffer + 1 (adr. du drapeau).
rul_loop2:     cmpa.l   a4,a1               ;
               bls      toolong_fn          ; Recopie le nom du fichier.
               move.b   (a0)+,(a4)+         ; Erreur s'il est trop long.
               bne.s    rul_loop2           ;
;\6
;    On a tjrs A6 = string. Rserve un bloc de mmoire pour le fichier et charge le fichier.

               move.l   dta+d_length(pc),d7 ;D7.L: longueur du fichier.
               moveq    #rul.SIZEOF,d0      ;
               cmp.l    d0,d7               ; Erreur si elle est < sizeof(rul).
               bcs.s    bad_rulfile         ;
               clr.w    -(sp)               ;Mode d'ouverture: lecture uniquement.
               pea      (a6)                ;Nom du fichier (avec chemin).
               mgemdos  Fopen,8             ;Ouvre le fichier.
               move.l   d0,d6               ;D6.W: handle du fichier.
gemdos_err2:   bmi.s    gemdos_error        ;Branch. s'il y a eu une erreur lors de l'ouverture du fichier.
               lea      tcol(pc),a5         ;A5: tcol.
               moveq    #rul.nsc6,d0        ; Stocke dans tcol  le nb de scores
               moveq    #8,d5               ; et le nb max de scores pour 6, 7,
               bsr.s    seek_read           ; 8, 9 petits hex.
               move.l   4(a5),d0            ; La somme des 4 octets de D0 est gale
               sub.l    (a5)+,d0            ; au nb de scores encore inexistants.
               clr.l    (a5)                ; Annule les 8 octets  partir de tcol (notamment
               clr.l    -(a5)               ; les 4 de poids fort). A5: tcol.
               movep.l  d0,1(a5)            ;Les 4 mots  partir de tcol contiennent les valeurs des 4 octets de D0.
               moveq    #0,d0               ;
               move.w   (a5)+,d0            ; D0.L: somme de ces 4 mots
               add.w    (a5)+,d0            ; (=  nb  de scores  encore
               add.w    (a5)+,d0            ; inexistants).
               add.w    (a5),d0             ;
               lsl.w    #5,d0               ;D0.L: place prise par les scores encore inexistants.
               add.l    d7,d0               ;Ajoute la taille du fichier.
               bsr      test_malloc         ;Rserve de la mmoire pour le fichier et les scores encore inexistants.
               move.l   d0,rul_ptr-string(a6)  ;Stocke l'adr. du bloc de mmoire rserv dans rul_ptr.
               movea.l  d0,a5               ;A5: adr. du bloc de mmoire rserv.
               moveq    #0,d0               ;
               move.l   d7,d5               ; Lit le fichier en entier (il est stock dans (A5)).
               bsr      seek_read           ;
               move.w   d6,-(sp)            ;Handle du fichier.
               mgemdos  Fclose,4            ;Ferme le fichier.
               tst.l    d0                  ; Branch. s'il y a
               bmi.s    gemdos_err2         ; eu une erreur.
;\4
;  Teste s'il s'agit bien d'un fichier de rgle.

               cmpi.l   #'RUL3',rul.magic(a5)  ; Branch. si les 4 premiers
               beq.s    rul_init               ; octets sont "RUL3".
;\5
;  Erreur: mauvais format de fichier de rgle.

bad_rulfile:   moveq    #8,d7               ;D7.W = 8: code de retour.
               movea.l  alert_brul+4(pc),a5 ;Texte de la bote d'alerte  afficher.
               bra      alert4              ;Affiche une bote d'alerte, et fin du prg.
;\6
;  Initialise la valeur de rul.fntn (fonte utilise pour afficher le nom de la rgle).

rul_init:      lea      rul.fntn(a5),a0     ;A0 = [rul.fntn, rul.fntg].
               tst.w    (a0)                ;
               bne.s    rul_lbl2            ; Initialise la valeur de rul.fntn.
               move.w   nfontid(pc),(a0)    ;
;\6
;  Initialise la valeur de rul.fntg (fonte utilise pour afficher les textes associs aux nb affichs pdt le jeu).

rul_lbl2:      addq.l   #rul.fntg-rul.fntn,a0  ;(A0) = rul.fntg.
               tst.w    (a0)                ;
               bne.s    rul_lbl3            ; Initialise la valeur de rul.fntg.
               move.w   gfontid(pc),(a0)    ;
;\3
rul_lbl3:      lea      col_gp(pc),a0       ;(A0): col_gp, 4(A0): col_go, 8(A0): col_gy.
               movem.l  rul.pcol(a5),d0-d2  ; Met  jour ces
               movem.l  d0-d2,(a0)          ; 3 valeurs.
;\7
;  Envoie le msg msg_ldrul: nouveau fichier de rgle charg.

               IFNE     REGISTERED
               move.l   a5,struct_msg+4-col_gp(a0)  ;Stocke l'adr. du fichier de rgle dans la struct. rserve aux msg.
               moveq    #msg_ldrul,d0       ; Envoie le msg
               bsr      send_msg0           ; msg_ldrul.
               ENDIF
;\6
;  Rserve de la mmoire et calcule les img contenant les motifs (21 lignes de 25 pixels, 3 plans). Attention! chaque ligne est
;  aligne  gauche (et non pas positionne comme sur une img bitmap). Le ptr sur ce bloc de mmoire est stock dans patterns.

               clr.w    d0                  ; D0.W: nb de
               move.b   rul.nptn(a5),d0     ; motifs.
               mulu.w   #patlen,d0          ;Multiplie par la place mmoire que prendra un motif.
               move.l   d0,-(sp)            ;Empile la taille du bloc de mmoire  rserver.
               bsr      test_malloc         ;Rserve de la mmoire pour les images qui contiendront les motifs.
               move.l   (sp)+,d1            ;Rcupre la taille de ce bloc de mmoire.
               lea      patterns(pc),a0     ; Stocke l'adr. de ce bloc de
               move.l   d0,(a0)             ; mmoire dans patterns.
               movea.l  d0,a0               ;Adr. de ce bloc de mmoire.
patt_clear:    clr.l    (a0)+               ;
               subq.l   #4,d1               ; Efface ce bloc de mmoire.
               bne.s    patt_clear          ;
               movea.l  d0,a3               ;Adr. de ce bloc de mmoire.
               move.b   rul.nptn(a5),d2     ;Nb de motifs.
               lea      rul.SIZEOF(a5),a4   ;Ptr sur la dfinition des motifs.
patt_outer:    moveq    #0,d4               ;D4.L contient un offset en bits par rapport  A4.
               movea.l  a3,a0               ;Adr. du plan 0 du prochain motif.
               lea      patpl(a0),a1        ;Adr. du plan 1 du prochain motif.
               lea      patpl(a1),a2        ;Adr. du plan 2 du prochain motif.
               lea      patdef(pc),a6       ;Adr. des commandes pour construire l'image du motif.
               clr.b    d7                  ;D7.B = 0: cf ci-dessous.
               moveq    #0,d0               ;D0.L contient un offset en bits par rapport  A6.
               moveq    #20,d1              ;Nb de lignes - 1.
patt_inner:    moveq    #0,d3               ;D3.L contient un offset en bits par rapport  A0/A1/A2, 0 pour l'instant.
               bra.s    patt_lbl1           ;Branch. pour lire l'intensit du prochain pixel (si elle est fixe).
patt_loop1:    addq.w   #2,d0               ;Met D0  jour.
               moveq    #1,d6               ; Ecrit un
               bsr.s    patt_write          ; pixel.
patt_lbl1:     bfextu   (a6){d0:2},d5       ;D5: intensit du pixel suivant, si D5 <> 0 (alors 1  D5  3).
               bne.s    patt_loop1          ;Branch. s'il s'agit bien d'une intensit.
               addq.w   #2,d0               ;Met D0  jour.
               bfexts   (a6){d0:2},d5       ;Lit la dernire commande de la ligne courante.
               cmpi.b   #-2,d5              ; Branch. si ce n'est pas -2
               bne.s    patt_lbl6           ; (i.e. c'est -1, 0 ou 1).
               addq.b   #1,d7               ; Branch.  si c'est
               cmpi.b   #4,d7               ; le dbut du motif
               beq.s    patt_lbl5           ; lui-mme.
               move.b   d7,d5               ; Sinon, crit 10 pixels de mme intensit
               moveq    #10,d6              ; (1 la 1re fois, 2 la 2me, et 3 la 3me
               pea      patt_next(pc)       ; fois) et passe  la ligne suivante.
patt_write:    lsr.b    #1,d5               ;
               bcc.s    patt_lbl2           ;
               bfset    (a0){d3:d6}         ;
patt_lbl2:     lsr.b    #1,d5               ;
               bcc.s    patt_lbl3           ; Ecrit D6 pixels (1  D6  32)
               bfset    (a1){d3:d6}         ; d'intensit D5.
               tst.b    d5                  ;
patt_lbl3:     beq.s    patt_lbl4           ;
               bfset    (a2){d3:d6}         ;
patt_lbl4:     add.b    d6,d3               ;
               rts                          ;Retour.
patt_lbl5:     moveq    #13,d7              ;Aprs les 2 additions suivantes, D7.W = 9.
patt_lbl6:     add.b    d5,d7               ; D7.W: nb de pixels du motif lui-mme
               add.b    d5,d7               ; - 1 dans la ligne courante.
               move.w   d7,-(sp)            ;
patt_loop2:    bfextu   (a4){d4:3},d5       ;
               addq.l   #3,d4               ; Ecrit ces
               moveq    #1,d6               ; pixels un
               bsr.s    patt_write          ; par un.
               dbf      d7,patt_loop2       ;
               move.w   (sp)+,d7            ;
patt_next:     addq.w   #2,d0               ;Met D0  jour.
               addq.l   #4,a0               ;Ligne suivante du plan 0.
               addq.l   #4,a1               ;Ligne suivante du plan 1.
               addq.l   #4,a2               ;Ligne suivante du plan 2.
               dbf      d1,patt_inner       ;Boucle (ligne suivante).
               lea      patlen(a3),a3       ;Adr. du plan 0 du motif suivant.
               lea      pdeflen(a4),a4      ;Ptr sur la dfinition du motif suivant.
               subq.b   #1,d2               ; Boucle (motif
               bne      patt_outer          ; suivant).
;\2
               lea      shap_def(pc),a0     ; Stocke le ptr sur la dfinition
               move.l   a4,(a0)             ; des formes.
;\6
;  Annule sf.newrule.

               movea.l  sfont_addr(pc),a0   ;A0: adr. des donnes sur la fonte n *sfontid, ou 0.
               move.l   a0,d0               ; Branch. si ces donnes
               beq.s    rul_lbl4            ; n'existent pas.
               clr.b    sf.newrule(a0)      ;Annule sf.newrule.
;\7
;  Met  jour le nb de petits hex. dans un ct du gd hex.

rul_lbl4:      clr.w    d0                  ; D0.W: nb de petits hex. dans un
               move.b   rul.nhex(a5),d0     ; ct du gd hex., si non nul.
               beq.s    rul_rts             ;Retour si ce nb est fix par l'utilisateur.
               cmp.b    nhex+1(pc),d0       ; Retour si le nb de petits
               beq.s    rul_rts             ; hex. ne change pas.
;\6
;  Change le nb de petits hex. dans un ct du gd hex.

change_nhex:   lea      nhex(pc),a0         ; Stocke n dans
               move.w   d0,(a0)+            ; nhex.
               move.w   d0,d1               ;D1.W = n.
               subq.b   #1,d0               ;D0.W = n-1.
               lsl.b    #3,d1               ;D1.W = 8n.
               subq.b   #4,d1               ;D1.W = 4(2n-1).
               move.w   d1,(a0)+            ;Stocke 4(2n-1) dans nh2.
               mulu.w   d0,d1               ; Stocke 4(n-1)(2n-1)
               move.w   d1,(a0)+            ; dans nh3.
               add.b    d0,d0               ; Stocke 2n-2
               move.w   d0,(a0)             ; dans nh4.
               bra      xmem_free           ;Libre la mmoire rserve pour l'image du fond.
;\5
;  Erreur interne: nom de fichier trop long.

toolong_fn:    moveq    #9,d7               ;D7.W = 9: code de retour.
               movea.l  alert_tlfn+4(pc),a5 ;Texte de la bote d'alerte  afficher.
               bra      alert4              ;Affiche une bote d'alerte, et fin du prg.

;\8
;    Ŀ
;     Sous-programmes divers 
;    

;  Sous-prg utilis lors de l'affichage du menu.

menu_subr:     movea.l  a6,a0               ;Adr. du tableau INTIN.
menu_inner1:   addq.b   #1,d0               ;
               clr.b    (a0)+               ; Stocke "Fichier de rgle"
               move.b   (a4)+,(a0)+         ;
               bne.s    menu_inner1         ; / "Joueur" dans INTIN.
               subq.l   #2,a0               ;
               move.l   #':'<<16+' ',(a0)+  ;Stocke ": " dans INTIN.
menu_inner2:   addq.b   #1,d0               ;
               clr.b    (a0)+               ; Stocke le nom du fichier de rgle
               move.b   (a1)+,(a0)+         ; / du joueur dans INTIN.
               bne.s    menu_inner2         ;
               move.l   #32<<16+48,d1       ;Position par dfaut o il faudra afficher le nom du fichier de rgle.
rul_rts:       rts                          ;Retour.
;\6
;  disp_go: affiche (ou praffiche) "game over".

right_btm:     move.l   #$20003,(a6)        ; Alignement: droite,
               bra      alignment           ; bottom.
disp_go:       bsr      clip_on             ;Active le clipping.
               bsr.s    right_btm           ;Alignement: droite, bottom.
               move.w   #3600-angle,d7      ; Angle de rotation:
               bsr.s    set_angle           ; 30 vers le bas.
               move.l   #'g'<<16+'a',(a6)   ; Texte:
               move.l   #'m'<<16+'e',4(a6)  ; "game".
               move.w   nhex(pc),d0           ;
               moveq    #-6,d1                ;
               muls.w   d0,d1                 ; Calcule  les coord. du point o
               lsl.w    #4,d0                 ; sera affich "game" (attention!
               swap     d1                    ; en alignement  droite).
               move.w   d0,d1                 ;
               addi.l   #180<<16+(248+ky),d1  ;
               moveq    #4,d0               ;D0.W: nb de caractres.
               move.l   d1,-(sp)            ;Sauve les coord.
               bsr      dtxt_lftbot         ;Affiche "game". Alignement: gauche, bottom.
               move.w   #angle,d7           ; Angle de rotation:
               bsr.s    set_angle           ; 30 vers le haut.
               move.l   #'o'<<16+'v',(a6)   ; Texte:
               move.l   #'e'<<16+'r',4(a6)  ; "over".
               move.l   (sp)+,d1            ;Rcupre les coord. de "game".
               move.w   nhex(pc),d0         ;
               lsl.w    #4,d0               ;
               subi.w   #44,d0              ; D1.L: coord.
               swap     d1                  ; de "over".
               add.w    d0,d1               ;
               swap     d1                  ;
               moveq    #4,d0               ;D0.W: nb de caractres.
               bsr      disp_text           ;Affiche "over".
               bsr.s    angle0              ;Angle de rotation: 0 (normal).
;\3
no_clipping:   lea      intin(pc),a0        ; Dsactive le
               clr.w    (a0)                ; rectangle de
               mvdi     vs_clip,0,1,0       ; clipping.
;\4
set_angle:     bsr.s    rotation            ;Fixe l'angle de rotation  D7.
               ext.l    d0                  ; Retour si l'angle
               beq.s    cookies_rts         ; fix est nul.
               divu.w   #900,d0             ; Retour  si l'angle fix n'est pas un multiple
               swap     d0                  ; de 90,  i.e. l'angle a t accept  (cas des
               tst.w    d0                  ; fontes vectorielles). Sinon, on fixe un angle
               bne.s    cookies_rts         ; nul (fontes bitmap).
angle0:        clr.w    d7                  ;Fixe un angle nul.
rotation:      move.w   d7,(a6)             ; Fixe l'angle
               mvdi     vst_rotation,0,1,0  ; de rotation.
;\4
;  Renvoie le ptr sur la cookie jar (routine excute en mode superuser).

rd_p_cookies:  move.l   _p_cookies.w,d0     ;Ptr sur la cookie jar.  Routine excute en
cookies_rts:   rts                          ;Retour.                 mode superuser.
;\4
hnh_sfontid:   move.w   sfontid(pc),d7      ;Fonte n *sfontid.
hname_height:  bsr      set_font1           ;Slectionne la fonte D7 si SpeedoGDOS est install.
               moveq    #hname,d7           ;Hauteur des caractres: hname.
char_height:   lea      ptsin(pc),a0        ;
               clr.w    (a0)+               ; Slectionne la hauteur de la
               move.w   d7,(a0)             ; fonte bitmap: D7, et retour.
               mvdi     vst_height,1,0,0    ;
;\6
;  Efface progressivement les couleurs (3 pts d'entre).

clr_colors1:   clr.b    d5                  ;D5.B = 0: on n'efface pas tout...
clr_colors2:   moveq    #4,d0               ; Lance le timer
               bsr      timer               ;  192 Hz.
               lea      counter(pc),a6      ;A6: adr. du compteur.
               clr.w    (a6)                ;Annule le compteur.
clr_colors3:   moveq    #134,d6             ;
               tst.b    d5                  ; D6.B: compteur (nb de fois qu'il
               bpl.s    clcol_outer         ; faut passer dans la boucle).
               moveq    #192,d6             ;
clcol_outer:   addq.w   #1,(a6)             ;
clcol_loop2:   bsr      usr_switch          ; Attend que le tps du
               tst.w    (a6)                ; timer soit coul.
               bpl.s    clcol_loop2         ;
               tst.b    d5                  ; Branch. si on n'efface que les
               beq.s    clcol_ftoh          ; couleurs de fcolor+1  kcolor.
               moveq    #1,d0               ;1re couleur  modifier: couleur 1.
               move.w   #255,d7             ;Nb de couleurs  modifier: 255.
               bra.s    clcol_decr          ;Diminue l'intensit des couleurs...
clcol_ftoh:    moveq    #fcolor+1,d0        ;1re couleur  modifier: fcolor+1.
               move.w   #kcolor-fcolor,d7   ;Nb de couleurs  modifier.
clcol_decr:    lea      (RGB.w,pc,d0.w*4),a5  ;Adr. de la 1re couleur  modifier.
               pea      (a5)                ;
               move.w   d7,-(sp)            ; Empile les param. pour VsetRGB.
               move.w   d0,-(sp)            ;
               lsl.w    #2,d7               ;Nb d'octets  modifier (4 par couleur).
clcol_loop3:   clr.w    d0                  ;
               move.b   (a5),d0             ;
               moveq    #126,d1             ;
               tst.b    d5                  ;
               bpl.s    clcol_mul           ; Multiplie l'intensit de chaque
               moveq    #127,d1             ; couleur  par 63/64 si D5.B  0,
clcol_mul:     mulu.w   d1,d0               ; et par 127/128 si D5.B < 0.
               lsr.w    #7,d0               ;
               move.b   d0,(a5)+            ;
               subq.w   #1,d7               ;
               bne.s    clcol_loop3         ;
               mxbios   VsetRGB,10          ;Change la couleur des pinceaux.
               subq.b   #1,d6               ; Boucle, jusqu' ce que toutes
               bne.s    clcol_outer         ; les couleurs soient noires.
clcol_gbkgr:   bsr      usr_switch          ;
               tst.b    multflag(pc)        ; Finit de calculer l'image de fond.
               bne.s    clcol_gbkgr         ;
               bsr      stop_timer          ;Arrte le timer.
               bsr      fill_col1           ;SET FILL COLOR INDEX, avec la couleur 1 (noir).
               bsr      wd_update           ;Mise  jour de la fentre si le jeu se droule dans une fentre GEM...
               lea      ptsin(pc),a0        ;Ptr sur PTSIN (o il faut stocker les coord. du rectangle).
               tst.b    d5                  ; Branch. s'il faut seulement
               beq.s    clr_wind3           ; effacer la zone de travail.
               clr.l    (a0)+               ; Stocke les coordonnes du
               move.l   xx(pc),(a0)         ; rectangle (tout l'cran).
               bra.s    clcol_frect         ;Branch. pour effacer l'cran.
clr_wind3:     bsr.s    sto_wcoord          ;Stocke les coord. de la zone de travail.
clcol_frect:   bsr.s    frect2              ;FILLED RECTANGLE.
;\6
;  Fin de mise  jour de la fentre si le jeu se droule dans une fentre GEM. Registres modifis: D0  D2, A0  A2.

end_windupd:   tst.b    windflag(pc)        ; Retour si le jeu se droule
               bpl.s    stowc_rts           ; sur tout l'cran.
end_windupd2:  bsr      mouse_on            ;Montre le curseur de la souris.
wind_endupd:   lea      redraw_flag(pc),a0  ; Dsactive le flag
               clr.b    (a0)                ; de redraw.
               lea      int_in(pc),a0       ; Fct wind_update avec
               move.w   #end_update,(a0)    ; END_UPDATE...
wind_upd:      lea      control(pc),a0      ;
               move.w   #wind_update,(a0)+  ; Appelle la fct wind_update.
               bsr      aes1                ;
               bne.s    stowc_rts           ;Branch. si pas d'erreur.
;\5
;  Erreur AES.

mtos_err:      movea.l  alert_aesr+4(pc),a5 ;Texte de la bote d'alerte  afficher.
               moveq    #-1,d7              ;D7.W = -1: code de retour.
               bra      alert4              ;Affiche une bote d'alerte, et fin du prg.
;\4
frect0:        swap     d2                  ; Le mot de poids fort de D0 tant
               or.l     d2,d0               ; nul, on stocke D2.W dans ce mot.
frect1:        bsr.s    rect_coord          ;Stocke les coord. D0/D1 du rect. dans PTSIN.
frect2:        mvdi     vr_recfl,2,0,0      ;FILLED RECTANGLE.
;\4
sto_wcoord:    moveq    #0,d0                        ; Coord. relatives de
               move.l   #(windw-1)<<16+(windh-1),d1  ; la zone de travail.
rect_coord:    lea      ptsin(pc),a0        ;
               add.l    xy0(pc),d0          ; Stocke les coord. absolues
               add.l    xy0(pc),d1          ; du rect. dans PTSIN.
               movem.l  d0/d1,(a0)          ;
stowc_rts:     rts                          ;Retour.
;\6
;  Affiche progressivement l'image de fond et le texte ventuel.

;  Couleurs:
;      _ 0  15: couleurs systme. Ne pas les modifier.
;      _ 16  63: couleurs des petits hexagones.
;      _ 96  127: couleurs du texte (menu...).
;      _ 128  223: image du fond:
;         . Cas d'une image calcule par TETRHEX (backtype = 0):
;            _ Plan 7: toujours 1.
;            _ Plans 0, 1, 2, 3: 0  15 (dgrad, 31 couleurs).
;            _ Plans 4, 5, 6: 0  5 (luminosit).
;         . Cas d'une image calcule par le fichier de msg (backtype = -1): palette situe aprs l'image.
;      _ 224  227: hexagone (luminosit croissante).
;      _ 228: couleur de "game over".
;      _ 229: couleur de "-- PAUSE --".
;      _ 230: couleur de la date.
;      _ 231: couleur de l'heure.
;      _ 239: couleur de "Votre nom:".
;\7
;    Si le jeu se droule sur tout l'cran:
;      _ 64: noir.
;      _ 240  247: rectangles (240: intrieur, 247: extrieur).
;      _ 248: TETRHEX, intrieur.
;      _ 249: TETRHEX, contour extrieur 1.
;      _ 250: TETRHEX, contour extrieur 2.
;      _ 251: TETRHEX, contour intrieur.
;\4
;  Modifie progressivement la palette (couleurs 122  251). Couleur initiale: noir (valeur 0).
;  Couleurs finales [R,V,B] o chaque composante est comprise entre 0 et 255:
;    _ 8 + 8n + p (1  n  6, 0  p  7): C(n,p) = h(p)[n2,n1,n0].
;    _ 96 + n (0  n  31): M(n) = [tcol[4n+1],tcol[4n+2],tcol[4n+3]].
;    _ 128 + 16n + p (0  n  5, 0  p  15): B(n,p) = (n+6)[12,0,20-p] + n[p,32,7+p] si backtype = 0.
;    _ 128 + n (0  n  95): B'(n) = ??? (la palette est situe juste aprs l'image) si backtype = -1.
;    _ 227 - n (0  n  3): H(n) = [S(R)-n.D(R),S(G)-n.D(G),S(B)-n.D(B)].
;  Si le jeu se droule sur tout l'cran:
;    _ 240 + n (0  n  7): R(n) = [16(n+6),0,0].
;    _ 251 - A[n] (0  n  3): T(n) = [48(n+1),64n,0], o A = {1, 2, 0, 3}.
;\2
;  Couleurs intermdiaires: t1.R(n)/32, t1.T(n)/32, t2.H(n)/32, t2.C(n,p)/32, t2.M(n)/32,
;                           t3.B(0,p)/24 + t4.n.[12+p,32,27]/32 ou t4.B'(n)/32.

chcol:         lea      tt1-1(pc),a6        ;
               clr.w    d4                  ; A6 = tt1 - 1  si  le jeu se
               lea      dispflag(pc),a5     ; droule sur tout l'cran et
               tas      (a5)                ; si TETRHEX  n'a pas  encore
               bpl.s    chcol2              ; t  affich.  A6 = tt2 - 1
               addq.l   #tt2-tt1,a6         ; dans le cas contraire.
               moveq    #32,d4              ;
chcol2:        moveq    #4,d3               ;D3.L = 4 (offset en bits pour le calcul de t1, t2, t3, t4).
               clr.w    d5                  ;t2 = 0.
               clr.w    d6                  ;t3 = 0.
               clr.w    d7                  ;t4 = 0.
               bsr      timer96             ;Lance le timer (96 Hz).
               clr.b    d0                  ;D0.B = dt (bit 3: dt1, bit 2: dt2, bit 1: dt3, bit 0: dt4).
               lea      counter(pc),a5      ;(A5).W: compteur du timer. 2(A5).B: compteur auxiliaire.
               clr.l    (a5)                ;Annule les 2 compteurs.
chcol_outer:   movea.l  d3,a4               ;Sauve D3.
               lsr.b    #1,d0               ;
               scs      d1                  ;
               sub.b    d1,d7               ;
               lsr.b    #1,d0               ;
               scs      d1                  ;
               sub.b    d1,d6               ; (t1,t2,t3,t4)
               lsr.b    #1,d0               ; += dt.
               scs      d1                  ;
               sub.b    d1,d5               ;
               cmpi.b   #32,d4              ;
               beq.s    chcol_lbl1          ;
               add.b    d0,d4               ;
chcol_lbl1:    lea      RGB+252*4+1(pc),a0  ;Adr. de la composante rouge de la couleur 252.
               moveq    #3,d3               ;D3.W = 3.
               moveq    #3,d0               ;
chcol_inner1:  clr.w    d2                  ;
               move.b   (tth.w,pc,d0.w),d2  ;
               subq.l   #2,a0               ;
               move.w   d2,d1               ;
               add.b    d1,d1               ;
               mulu.w   d4,d1               ; Calcule les valeurs des
               move.b   d1,-(a0)            ; couleurs de 248  251.
               addq.b   #1,d2               ;
               mulu.w   d3,d2               ;
               mulu.w   d4,d2               ;
               lsr.w    #1,d2               ;
               move.b   d2,-(a0)            ;
               dbf      d0,chcol_inner1     ;
               moveq    #7,d0               ;
chcol_inner2:  subq.l   #3,a0               ;
               move.w   d0,d1               ;
               addq.b   #6,d1               ; Calcule les valeurs des
               mulu.w   d4,d1               ; couleurs de 240  247.
               lsr.w    #1,d1               ;
               move.b   d1,-(a0)            ;
               dbf      d0,chcol_inner2     ;
               lea      RGB+pcolor*4(pc),a0 ;Adr. de la couleur pcolor.
               lea      col_gp(pc),a1       ;(A1): col_gp, 4(A1): col_go, 8(A1): col_gy, 12(A1): col_date, 16(A1): col_time.
               move.l   (a1)+,(a0)          ;Couleur de "-- PAUSE --".
               move.l   (a1)+,-(a0)         ;Couleur de "game over".
               move.l   (a1)+,(ycolor-gcolor)*4(a0)  ;Couleur de "Votre nom:" et du nom.
               move.l   (a1)+,(dcolor-gcolor)*4(a0)  ;Couleur de la date.
               move.l   (a1),(tcolor-gcolor)*4(a0)  ;Couleur de l'heure.
               moveq    #3,d0               ;
               move.l   hex_col-1(pc),d1    ;
chcol_oinnr3:  moveq    #2,d2               ;
chcol_iinnr3:  clr.w    d3                  ;
               move.b   d1,d3               ;
               ror.l    #8,d1               ;
               mulu.w   d5,d3               ; Calcule les valeurs des
               lsr.w    #5,d3               ; couleurs de 224  227.
               move.b   d3,-(a0)            ;
               dbf      d2,chcol_iinnr3     ;
               subq.l   #1,a0               ;
               lsr.l    #8,d1               ;
               sub.l    hex_col+2(pc),d1    ;
               dbf      d0,chcol_oinnr3     ;
               IFNE     REGISTERED
               tst.b    backtype(pc)        ;
               beq.s    chcol_stdimg        ; Branch. si l'img du fond est une img calcule par
               tst.b    backflag(pc)        ; TETRHEX ou si l'img du fond n'est pas en mmoire.
               bpl.s    chcol_stdimg        ;
               moveq    #95,d0              ;D0.W: nb de couleurs - 1 (compteur pour le DBF).
               lea      ([backaddr,pc],7*wplen+96*4.l),a1  ;A1: fin de la palette o il faut lire les couleurs.
chcol_oinnr7:  moveq    #2,d2               ;
chcol_iinnr7:  clr.w    d3                  ;
               move.b   -(a1),d3            ;
               mulu.w   d7,d3               ; Calcule  les valeurs  des couleurs
               lsr.w    #5,d3               ; de 128  223.  Note: l'img de fond
               move.b   d3,-(a0)            ; se trouve en mmoire et elle a t
               dbf      d2,chcol_iinnr7     ; calcule par le fichier de msg.
               subq.l   #1,a0               ;
               subq.l   #1,a1               ;
               dbf      d0,chcol_oinnr7     ;
               bra.s    chcol_lbl2          ;Branch. pour modifier les couleurs de 96  127.
               ENDIF
chcol_stdimg:  moveq    #5,d0               ;
chcol_oinnr4:  moveq    #15,d1              ;
               move.w   d0,d2               ;
               mulu.w   d7,d2               ;
chcol_iinnr4:  moveq    #20,d3              ;
               sub.b    d1,d3               ;
               mulu.w   d6,d3               ;
               lsr.w    #2,d3               ;
               move.b   d3,-(a0)            ;
               moveq    #27,d3              ;
               mulu.w   d2,d3               ; Calcule les valeurs "standard" des couleurs de 128  223.
               lsr.w    #5,d3               ; Note:  soit l'img de fond est prsente et il s'agit d'une
               add.b    d3,(a0)             ; img calcule par TETRHEX, soit l'img de fond ne se trouve
               move.b   d2,-(a0)            ; pas  en mmoire  (dans ce cas,  ces couleurs  ne sont pas
               moveq    #12,d3              ; utilises).
               add.b    d1,d3               ;
               mulu.w   d2,d3               ;
               lsr.w    #5,d3               ;
               add.b    d6,d3               ;
               add.b    d6,d3               ;
               add.b    d6,d3               ;
               move.b   d3,-(a0)            ;
               subq.l   #1,a0               ;
               dbf      d1,chcol_iinnr4     ;
               dbf      d0,chcol_oinnr4     ;
;\6
;  D3.W  $FF, A0: adr. de la couleur 128.

chcol_lbl2:    moveq    #31,d0              ;
               lea      tcol+4*32(pc),a1    ;
chcol_oinnr5:  moveq    #2,d1               ;
chcol_iinnr5:  move.b   -(a1),d3            ;
               mulu.w   d5,d3               ; Calcule les valeurs
               lsr.w    #5,d3               ; des couleurs  de 96
               move.b   d3,-(a0)            ;  127.
               dbf      d1,chcol_iinnr5     ;
               subq.l   #1,a0               ;
               subq.l   #1,a1               ;
               dbf      d0,chcol_oinnr5     ;
               lea      RGB+64*4(pc),a0     ;
               move.w   #6,-(sp)            ;
chcol_oinnr6:  lea      hwhite+8(pc),a1     ;
               moveq    #7,d1               ;
chcol_iinnr6:  subq.l   #1,a1               ;
               move.w   (sp),d3             ;
               moveq    #2,d0               ;
chcol_iiinnr:  clr.w    d2                  ;
               move.b   (a1),d2             ;
               lsr.b    #1,d3               ; Calcule les valeurs
               bcc.s    chcol_lbl3          ; des couleurs  de 16
               move.b   hcol8-hwhite(a1),d2 ;  63.
chcol_lbl3:    mulu.w   d5,d2               ;
               lsr.w    #5,d2               ;
               move.b   d2,-(a0)            ;
               dbf      d0,chcol_iiinnr     ;
               subq.l   #1,a0               ;
               dbf      d1,chcol_iinnr6     ;
               subq.w   #1,(sp)             ;
               bne.s    chcol_oinnr6        ;
               addq.l   #2,sp               ;
chcol_wait:    bsr      read_message        ;Prend en compte les messages ventuels concernant la fentre.
               bmi.s    stop_timer0         ;Branch. si on est pass en mode PAUSE (il faut tout rafficher).
               tst.w    (a5)                ; Branch. tant que le compteur du
               bpl.s    chcol_wait          ; timer n'a pas t dcrment.
               addq.w   #1,(a5)+            ;Incr. le compteur du timer. (A5): compteur auxiliaire.
               bsr      chg_f2lcolor        ;Change la couleur des pinceaux.
               move.l   a4,d3               ;Rcupre D3.
               subq.b   #1,(a5)             ;Dcr. le compteur auxiliaire.
               bcc.s    chcol_lbl4          ;Branch. s'il tait non nul.
               addq.b   #4,(a5)             ;Valeur du compteur auxiliaire: 3.
               addq.b   #4,d3               ;Prochain offset.
chcol_lbl4:    subq.l   #2,a5               ;(A5): compteur du timer.
               bfextu   (a6){d3:4},d0       ;D0.B = dt.
               bne      chcol_outer         ;Boucle si non nul.
               bsr.s    stop_timer0         ;Arrte le timer si le drapeau de jeu est inactif.
               moveq    #-1,d0              ;Z = 0.
               rts                          ;Retour.

;\9
;    Ŀ
;     Timer 
;    

;  Arrte le timer utilis (A ou D).

stop_timer0:   tst.b    gameflag(pc)        ; Si le drapeau de jeu est actif,
               bmi.s    stoptim_rts         ; on n'arrte pas le timer.
stop_timer:    clr.l    -(sp)               ;
               clr.l    -(sp)               ; Arrte le
               move.w   num_timr(pc),-(sp)  ; timer.
               mxbios   Xbtimer,12          ;
               clr.b    d0                  ;Z = 1.
stoptim_rts:   rts                          ;Retour.
;\6
;  Lance le timer A ou D (96 Hz, ou indiqu par D0.W).

timer96:       moveq    #6,d0               ;D0.W = 6 --> 96 Hz.
timer:         pea      timer_rout(pc)      ;Routine du timer.
               clr.w    -(sp)               ;Data Register = 0.
               move.w   d0,-(sp)            ;Control Register = D0.
               move.w   num_timr(pc),-(sp)  ;N du timer.
               mxbios   Xbtimer,12          ;Lance le timer.
switch_rts:    rts                          ;Retour.
;\6
;  Passe  la routine de calcul de l'image de fond en tche de fond (partie utilisateur).

usr_switch:    tst.b    windflag(pc)        ; Pas de calcul en tche de fond si le jeu se droule
               bmi.s    switch_rts          ; dans une fentre GEM, notamment sous MultiTOS.
               tst.b    backflag(pc)        ; Retour si les calculs
               bmi.s    switch_rts          ; sont termins.
               movem.l  d0-d7/a0-a6,-(sp)   ;Sauve les registres.
               trap     #usr_trap           ;Passe  la routine sup_switch.
mainpc:        movem.l  (sp)+,d0-d7/a0-a6   ;Rcupre les registres.
               rts                          ;Retour.
;\6
;  Routine timer (appele en interruption).

               SUPER                        ;Autorise les instructions privilgies.
timer_rout:    move.l   a0,-(sp)            ;Sauve A0.
               lea      bss_end(pc),a0      ;
               cmpi.l   #smagic,(a0)        ; S'il y a eu un stack overflow et
               beq.s    timer_rout1         ; si  cette routine  a t appele
               btst     #5,(sp)             ;  partir  du  mode  utilisateur,
               bne.s    timer_rout1         ; alors  l'erreur "stack overflow"
               lea      stk_overflow(pc),a0 ; est dclenche au retour.
               move.l   a0,2(sp)            ;
timer_rout1:   lea      varflag(pc),a0      ;A0 pointe sur varflag.
               IFEQ     REGISTERED
               subq.w   #1,tps96a-varflag(a0)  ;Dcr. le compteur pour limiter le jeu  5 mn.
               ENDIF
               subq.w   #1,counter-varflag(a0)  ;Dcr. le compteur.
               tst.b    (a0)+               ; Branch. si on ne doit pas
               bpl.s    timer_rout2         ; dcr. de variable du jeu.
               subq.b   #1,(a0)             ;Dcr. le compteur varcntr (diviseur de frquence).
               bpl.s    timer_rout2         ;Branch. s'il est  0.
               addi.b   #96,(a0)+           ;Rinitialise le compteur varcntr.
               subq.l   #1,([a0])           ;Dcr. la variable ( la frquence de 1 Hz).
timer_rout2:   btst     #5,4(sp)            ; Branch. si on vient du mode superuser (doit arriver trs
               bne.s    timer_rout3         ; rarement), car on ne doit pas switcher dans ce cas.
               movea.l  6(sp),a0            ; Branch. si le PC tait en dehors des limites du prg TETRHEX (dans
               cmp2.l   textlim(pc),a0      ; ce cas, on ne switche pas), ce qui signifie qu'un autre processus
               bcs.s    timer_rout3         ; tourne en tche de fond (devrait se produire trs rarement).
               tas      bkgr_mult           ; Met bkgr_mult  1, car on repasse au prg principal au cas o on tait
               bmi.s    timer_rout3         ; en train de calculer l'image de fond (calcul en tche de fond).
               movea.l  (sp),a0             ;Rcupre A0 (mais on ne dpile rien).
               movem.l  d0-d7/a0-a6,bkgr_reg  ;
               lea      bkgr_reg+60(pc),a2    ;
               movea.l  usp,a0                ; Sauve  les  registres  de
               movea.l  (a2),a1               ; donnes et d'adr., le SP,
               move.l   a0,(a2)+              ; le CCR et le PC.  Adr. de
               move.l   a1,usp                ; retour:  mainpc.  Pas  de
               movem.w  4(sp),d0-d2           ; registre  rcuprer pour
               movem.w  d0-d2,(a2)            ; le moment.
               lea      mainpc(pc),a0         ;
               move.l   a0,6(sp)              ;
timer_rout3:   movea.l  (sp)+,a0            ;Rcupre A0.
               tst.b    timer_flag(pc)      ; Branch. si c'est le timer A
               bne.s    timerA_rout         ; qui est utilis.
               bclr     #btimrD,isrb        ;Efface l'interruption en service (timer D).
               rte                          ;Retour.
timerA_rout:   bclr     #btimrA,isra        ;Efface l'interruption en service (timer A).
               rte                          ;Retour.
;\6
;  Passe  la routine de calcul de l'image de fond en tche de fond (partie superviseur).

sup_switch:    lea      bkgr_mult(pc),a2    ; Annule bkgr_mult, car on passe  la routine
               clr.b    (a2)                ; de calcul de l'image de fond.
               lea      bkgr_reg+64(pc),a2  ;      
               movem.w  (a2),d0-d2          ;      
               movem.w  d0-d2,(sp)          ;       Rcupre les registres
               movea.l  -(a2),a0            ;       de donnes  et d'adr.,
               movea.l  usp,a1              ;       le ptr de pile, le CCR
               move.l   a0,usp              ;       et le PC.
               move.l   a1,(a2)             ;      
               movem.l  bkgr_reg(pc),d0-d7/a0-a6  ;
               rte                          ;Retour (mais aprs avoir switch!).
               USER                         ;Interdit les instructions privilgies.

;\7
;    Ŀ
;     Segment DATA 
;    

               DATA
version:       dc.b     vers,subvers        ;Version de TETRHEX.
th_date:       dc.l     thdate              ;Date ($YYYYMMDD).
;\6
;  Les donnes suivantes peuvent tre modifies  l'aide d'un diteur de secteurs.

timer_flag:    dc.b     0                   ;Ce flag est sert  dterminer le timer utilis (A ou D). 0: D, -1: A.
chres_flag:    dc.b     0                   ;Drapeau de changement de rsolution (0: chgt autoris, 1: chgt interdit).
ledp_flag:     dc.b     0                   ;Drapeau de dsactivation de LED Panel.
acc_flag:      dc.b     0                   ;0: application (.PRG ou .GTP), -1: accessoire (.ACC). Trs utile!
               EVEN
disptime:      dc.b     0                   ;Drapeau d'affichage de l'heure (0: non affiche, <> 0: affiche,
                                            ;les secondes tant affiches ssi le MSB est  1).
dispdate:      dc.b     0                   ;Drapeau d'affichage de la date (0: non affiche, <> 0: affiche,
                                            ;l'anne tant affiche ssi le MSB est  1).
septime:       ascii    ':'                 ;Sparateur pour l'heure.
sepdate:       ascii    '/'                 ;Sparateur pour la date, au cas o il ne serait pas indiqu par "_IDT". 
fmttime:       dc.b     0                   ;Format d'heure par dfaut, au cas o "_IDT" serait absent.              
fmtdate:       dc.b     0                   ;Format de date par dfaut, au cas o "_IDT" serait absent.              
errflag:       dc.b     0                   ;Flag d'affichage des msg d'erreur (0: pas d'affichage, -1: affichage).
               EVEN
tfontid:       dc.w     756                 ;Identificateur de la fonte Speedo utilise pour "TETRHEX" (si elle existe).
nfontid:       dc.w     630                 ;Identificateur de la fonte Speedo utilise pour le nom de la rgle (").
gfontid:       dc.w     756                 ;Identificateur de la fonte Speedo utilise pour le jeu (").
ofontid:       dc.w     756                 ;Identificateur de la fonte Speedo utilise pour "game over" (").
hfontid:       dc.w     1                   ;Identificateur de la fonte Speedo utilise pour l'aide (").
mfontid:       dc.w     648                 ;Identificateur de la fonte Speedo utilise pour le menu (").
efontid:       dc.w     362                 ;Identificateur de la fonte Speedo utilise pour le titre du menu (").
pfontid:       dc.w     630                 ;Identificateur de la fonte Speedo utilise pour le mode PAUSE (").
sfontid:       dc.w     630                 ;Identificateur de la fonte Speedo utilise pour les meilleurs scores (").
               IFGE     REGISTERED
wfontid:       dc.w     710                 ;Identificateur de la fonte Speedo utilise pour "Shareware" (").
rfontid:       dc.w     649                 ;Identificateur de la fonte Speedo utilise pour le texte situ en dessous (").
               ENDIF
add_fid:       dc.w     0                   ;Valeur  ajouter aux identificateurs des fontes vectorielles ci-dessus.
outline:       IFGE     REGISTERED          ;
               dc.w     $07EF               ;
               ELSE                         ; Flags des fontes vectorielles.
               dc.w     $01EF               ;
               ENDIF                        ;
nhex:          dc.w     nhdef               ;Nb de petits hex. dans un ct du gd hex. (entre 6 et nhmax = 9).
nh2:           dc.w     4*(2*nhdef-1)       ;Taille, en octets, d'une colonne du tableau du jeu.
nh3:           dc.w     4*(nhdef-1)*(2*nhdef-1)  ;Offset de la case (0,0) par rapport au dbut du tableau.
nh4:           dc.w     2*nhdef-2           ;Hauteur de la case la + haute, nb de colonnes - 1.
col_pause:     dc.w     5                   ;Couleur de "-- PAUSE --" (en mode PAUSE).
col_icon:      dc.w     6                   ;Couleur de l'icne.
gend_key       dc.w     $0001               ;Etat des touches spciales + scancode  la fin du jeu.
delay:         dc.w     10                  ;Dlai pour evnt_timer, en ms.
hcol8:         dc.b     $30,$60,$78,$90,$A8,$C8,$D8,$F8  ;Intensits par dfaut des 8 niveaux des pixels des hexagones.
hwhite:        dc.b     $00,$00,$00,$00,$10,$20,$50,$80  ;Intensits en blanc par dfaut.
xmem:          dc.l     256*1024            ;Si la taille du + gd bloc mmoire dispo est < *xmem, alors la
                                            ;mmoire utilise par l'image de fond devra tre libre.
cfg_name:      asciiz   "TETRHEX.CFG"       ;Nom du fichier de configuration.
lng_name:      asciiz   "TETRHEX.LNG"       ;Nom du fichier de langue.
hex_col:       dc.b     192,192,192,48,48,48  ;Donnes pour calculer les couleurs du gd hex.
;\4
               dc.w     help_key-jmpitem    ;Aide sur TETRHEX.
               dc.w     shift_help-jmpitem  ;Aide sur la rgle.
               IFNE     REGISTERED          ;
               dc.w     undo_key-jmpitem    ; Charger une rgle (opration
               ELSE                         ; dsactive  dans  la version
               dc.w     wait_multi-jmpitem  ; non enregistre).
               ENDIF                        ;
               dc.w     chg_pname-jmpitem   ;Nom du joueur.
               dc.w     play-jmpitem        ;Jouer.
               dc.w     hi_scores-jmpitem   ;Meilleurs scores.
               dc.w     bottom-jmpitem      ;Msg bottom.
               dc.w     quit-jmpitem        ;Quitter.
itemaddr:                                   ;Fin de la table des offsets.
;\6
optdisp:       dc.b     'a',-1,-1,0,0       ;
               dc.b     'd',0,1,-1,0        ;
               dc.b     'n',0,0,0,0         ; Sert pour les
               dc.b     's',-1,0,0,-1       ; options "-d".
               dc.b     't',1,0,0,-1        ;
               dc.b     'y',0,-1,-1,0       ;
num_timr:      dc.w     timerD              ;N du timer utilis (pour XBIOS).
image:         INCBIN   "TETRHEX1.BIN"      ;Image "Vincent Lefvre presents" compresse.
hexag:         dc.b     0,2,5,-1,-1,7,0,0,7,-1,-1,9,0,1,7,0,0,7,0,1,5
;\4
bfire:         INCBIN   "TETRHEX2.BIN"      ;Liste de commandes.
; Codes:  0000: bas/gauche.    010: gauche.     101: haut/gauche.
;          001: bas.           011: suivant.    110: haut.
;         0001: bas/droite.    100: droite.     111: haut/droite.
;\3
cfire:         dc.w     -1,1,0,1,-1,0,0,0,1,0,-1,-1,0,-1,1,-1,1,1        ;Dplacement pour chaque commande (cf ci-dessous).
hexstart:      dc.l     %01010000000001101010101001000000
sfire:         dc.w     321,302,320,301,319,300,318,299,317,300,316,301  ;Il doit y avoir 2*nfire nb (ce sont
               dc.w     316,302,317,303,318,304,319,304,320,303          ;les coordonnes de dpart).
;\5
;  Donnes servant au calcul des plans 0, 1, 2, 3.
;    Priode de 192 bits (= 6 mots longs) --> 6 + 1 = 7 mots longs utiles.

cinc1:         dc.l     0,-1,0,-1,0,-1,0
cinc2:         dc.l     -1,-1,-1,0,0,0,-1
;\3
freq:          dc.w     11,15,19,31,37,43
val:           dc.w     0,0,0,128,0,128
dir:           dc.w     2,2,2,2,2,2
;\7
tetrhex:       INCBIN   "TETRHEX3.BIN"      ;Image 3 couleurs "TETRHEX" compresse, sur cran  coordonnes hexagonales.
;  Codes: 001: couleur du fond      --> plan 6  0, plan 7  0.
;         11: couleur intermdiaire --> plan 6  0, plan 7  1.
;         10: couleur 1er plan      --> plan 6  1, plan 7  1.
;         000 + n[6] + p[2]: n+1 pts de couleur p (p = 00, 11 ou 01).
;         01 + n[10] + p[8]: commandes n  n+p (la commande 0 tant la 1re).
;  Il y a en tout 144 codes.
;\6
;  Dans la version shareware, cette partie est code.

patdef:        dc.b     %00100101,%00100101,%10100010,%01101011,%11001001,%01101111
               dc.b     %00010101,%10101100,%01011010,%11110000,%01011011,%11000101
               dc.b     %01101011,%00010110,%10111100,%00101111,%00011100,%01010000
               dc.b     %10001111,%00110100,%00100011,%11001100,%00001100,%11000000
;\3
fgtext:        dc.w     v_gtext             ;v_gtext ou v_ftext.         
extent:        dc.w     vqt_extent          ;vqt_extent ou vqt_f_extent. 
segpos:        dc.w     0,$8000,$8080,1,$8040,$80C0,2
;\4
alerts:
alert_tetr:    dc.l     'TETR',windname_us-timer_flag,windname_fr-timer_flag
alert_paus:    dc.l     'PAUS',pause_usfr-timer_flag,pause_usfr-timer_flag
alert_chrs:    dc.l     'CHRS',chres_err_us-timer_flag,chres_err_fr-timer_flag
alert_vwks:    dc.l     'VWKS',vwks_err_us-timer_flag,vwks_err_fr-timer_flag
alert_aesr:    dc.l     'AESR',aes_err_us-timer_flag,aes_err_fr-timer_flag
alert_wind:    dc.l     'WIND',wind_err_us-timer_flag,wind_err_fr-timer_flag
alert_font:    dc.l     'FONT',font_err_us-timer_flag,font_err_fr-timer_flag
alert_imem:    dc.l     'IMEM',mem_err_us-timer_flag,mem_err_fr-timer_flag
alert_bpar:    dc.l     'BPAR',par_err_us-timer_flag,par_err_fr-timer_flag
alert_ruln:    dc.l     'RULN',rulnf_err_us-timer_flag,rulnf_err_fr-timer_flag
alert_brul:    dc.l     'BRUL',brul_err_us-timer_flag,brul_err_fr-timer_flag
alert_tlfn:    dc.l     'TLFN',tlfn_err_us-timer_flag,tlfn_err_fr-timer_flag
alert_gmds:    dc.l     'GMDS',gmdos_err_us-timer_flag,gmdos_err_fr-timer_flag
alert_lrul:    dc.l     'LRUL',loadrul_us-timer_flag,loadrul_fr-timer_flag
alert_name:    dc.l     'NAME',yn_us-timer_flag,yn_fr-timer_flag
alert_hssc:    dc.l     'HSSC',hisc_scores-timer_flag,hisc_scores-timer_flag
alert_hsmn:    dc.l     'HSMN',hisc_menu-timer_flag,hisc_menu-timer_flag
alert_ment:    dc.l     'MENT',menu-timer_flag,menu-timer_flag
alert_menu:    dc.l     'MENU',menu_us-timer_flag,menu_fr-timer_flag
alert_stck:    dc.l     'STCK',stkovfl_err-timer_flag,stkovfl_err-timer_flag
alert_nhlp:    dc.l     'NHLP',nohlpfile_us-timer_flag,nohlpfile_fr-timer_flag
alert_hfnf:    dc.l     'HFNF',hlpfilenf_us-timer_flag,hlpfilenf_fr-timer_flag
alert_bhlp:    dc.l     'BHLP',badhelp_us-timer_flag,badhelp_fr-timer_flag
alert_hlpt:    dc.l     'HLPT',help_us-timer_flag,help_fr-timer_flag
               IFEQ     REGISTERED
alert_swl1:    dc.l     'SWL1',sw_line1_us-timer_flag,sw_line1_fr-timer_flag
alert_swl2:    dc.l     'SWL2',sw_line2_us-timer_flag,sw_line2_fr-timer_flag
               ENDIF
               IFGT     REGISTERED
alert_swrt:    dc.l     'SWRT',sw_regto_us-timer_flag,sw_regto_fr-timer_flag
               ENDIF
alert_help:    dc.l     'HELP',0

msg_addr:      dc.l     d0_zero             ;Adr. du fichier de msg le + prioritaire (--> renvoie D0.L = 0).
pl456:         dc.w     8,13,22,35,52       ;Utiliss pour le calcul des plans 4, 5, 6 (image de fond).
;\6
;  Grand hexagone (pour nhex = 2):

;                           **************
;                           **************
;                          ***          ***
;                         ***            ***
;                         **              **
;                        ***              ***
;                       ***                ***
;                       **                  **
;                      ***                  ***
;                     ***                    ***
;         **************                      **************
;         **************                      **************
;        ***          ***                    ***          ***
;       ***            ***                  ***            ***
;       **              **                  **              **
;      ***              ***                ***              ***
;     ***                ***              ***                ***
;     **                  **              **                  **
;    ***                  ***            ***                  ***
;   ***                    ***          ***                    ***
;   **                      **************                      **
;   **                      **************                      **
;   ***                    ***    ^     ***                    ***
;    ***                  ***     |      ***                  ***
;     **                  **      |       **                  **
;     ***                ***      |       ***                ***
;      ***              ***       |        ***              ***
;       **              **        |         **              **
;       ***            ***        |         ***            ***
;        ***          ***         |          ***          ***
;         **************          |           **************
;         **************<------------22------>**************
;        ***          ***         |          ***          ***
;       ***            ***        |18       ***            ***
;       **              **        |         **              **
;      ***              ***       |        ***              ***
;     ***                ***      |       ***                ***
;     **                  **      |       **                  **
;    ***                  ***     |      ***                  ***
;   ***                    ***    v     ***                    ***
;   **                      **************                      **
;   **                      **************                      **
;   ***                    ***          ***                    ***
;    ***                  ***            ***                  ***
;     **                  **              **                  **
;     ***                ***              ***                ***
;      ***              ***                ***              ***
;       **              **                  **              **
;       ***            ***                  ***            ***
;        ***          ***                    ***          ***
;         **************                      **************
;         **************                      **************
;                     ***                    ***
;                      ***                  ***
;                       **                  **
;                       ***                ***
;                        ***              ***
;                         **              **
;                         ***            ***
;                          ***          ***
;                           **************
;                           **************
;\5
hex_abs:       dc.b     5,5,5,5,5,5,5,3,1,1,1,1,1,1,1,0  ;[,0,0]                                        
hexpos:        dc.w     0,0,0,20,18,10,18,-10,0,-20,-18,-10,-18,10                                     ;
               dc.w     0,40,18,30,36,20,36,0,36,-20,18,-30,0,-40,-18,-30,-36,-20,-36,0,-36,20,-18,30  ;
hexmad:        dc.w     hex_sh1-hex_sh0+30                                                             ;
               dc.w     hex_sh2-hex_sh0+30                                                             ;
;\6
;  Petit hexagone:

pattern1:      dc.l     %00000011111111111111000000  ;Note: les 2 dernires lignes
               dc.l     %00000011111111111111000000  ;d'un petit hexagone  corres-
pattern2:      dc.l     %00000111000000000011100000  ;pondent  aux 2 premires  du
               dc.l     %00001110000000000001110000  ;petit hexagone suivant, d'o
               dc.l     %00001100000000000000110000  ;la distinction  entre  les 2
               dc.l     %00011100000000000000111000  ;labels pattern1 et pattern2.
               dc.l     %00111000000000000000011100
               dc.l     %00110000000000000000001100
               dc.l     %01110000000000000000001110
               dc.l     %11100000000000000000000111
               dc.l     %11000000000000000000000011
               dc.l     %11000000000000000000000011
               dc.l     %11100000000000000000000111
               dc.l     %01110000000000000000001110
               dc.l     %00110000000000000000001100
               dc.l     %00111000000000000000011100
               dc.l     %00011100000000000000111000
               dc.l     %00001100000000000000110000
               dc.l     %00001110000000000001110000
               dc.l     %00000111000000000011100000
               dc.l     %00000011111111111111000000
               dc.l     %00000011111111111111000000
               dc.l     0
;\2
hmask:         dc.b     6,10,5,12,4,14,4,14,3,16,2,18,2,18,1,20,0,22
               dc.b     0,22,1,20,2,18,2,18,3,16,4,14,4,14,5,12,6,10
;\3
;  Flag de calcul de l'image de fond: positif ssi le calcul est effectu en ce moment-mme.

bkgr_mult:     dc.b     $80                 ;Flag de calcul de l'image de fond en tche de fond.

hbk_req:       dc.b     $80                 ;Flag de demande de ne pas mettre  jour gd.hexbk, lors de l'affichage du fond.
redraw_flag:   dc.b     $80                 ;Flag de redraw.
optfc:         ascii    "tngohmeps"         ;
               IFGE     REGISTERED          ;
               ascii    "wr"                ; Servent pour les options "-f".
               ENDIF                        ;
               asciiz   "+"                 ;
;\6
;  hexmask: liste des abscisses & longueurs des lignes d'un hex. en 3D.  Soit dy le nb form par les 3 bits de poids
;           fort de l'octet courant; alors l'abscisse de la ligne courante est =  l'abscisse de la ligne prcdente
;           + dy. La longueur de la ligne courante est = au nb form par les 5 bits de poids faible.

decr           equ      %11100000
incr           equ      %00100000
hexmask:       dc.b     10,decr|12,decr|14,15,decr|17,decr|19,19,decr|21,decr|23,23,incr|23
               dc.b     incr|23,23,incr|21,incr|19,19,incr|17,incr|15,incr|14,incr|12   ;[,incr|10] (cf ci-dessous).
hex_sh2:       dc.b     incr|10,decr|12,decr|14,15,decr|17,decr|18,19,decr|21,decr|22,23
               dc.b     incr|23,incr|22,21,incr|19,incr|18,17,incr|15,incr|14,incr|12   ;[,incr|10] (cf ci-dessous).
hex_sh1:       dc.b     incr|10,decr|12,decr|14,15,decr|16,decr|18,19,decr|20,decr|22
               dc.b     23,incr|22,incr|20,19,incr|18,incr|16,15,incr|14,incr|12        ;[,incr|10] (cf ci-dessous).
hex_sh0:       dc.b     incr|10,decr|12,decr|14,14,decr|16,decr|18,18,decr|20,decr|22
               dc.b     22,incr|20,incr|18,18,incr|16,incr|14,14,incr|12,incr|10
hexlin:        dc.b     2,3,3,2,1,1,2,4,4,4,3,2,1,0,0,0,1,2  ;[,3] (cf tth).
;\6
;  Paramtres pour la modification des couleurs avant le jeu.

tth:           dc.b     3,1,0,2
tt1:           dc.b     %10001000,%10001000
tt2:           dc.b     %10001100,%11001100,%01100110,%01100111
               dc.b     %01110011,%00010001,%00010001,%00010000
;\4
menu_title:    ascii    "  "
               mvers
               dc.b     0
windname1:     mvers
               asciiz   ", "
windname_us:   asciiz   "written by #"
windname_fr:   asciiz   "crit par #"
windname3:     asciiz   "Vincent Lefvre"
pause_usfr:    asciiz   "PAUSE"
tetrhex_str:   asciiz   "tetrhex: "
endwt:         dc.b     '.'      ;
str_crlf:      dc.b     cr,lf,0  ;
;\6
;  Messages d'alerte.

nohlpfile_us:  asciiz   "No help file"
nohlpfile_fr:  asciiz   "Pas de fichier d'aide"
hlpfilenf_us:  asciiz   "Help file not found"
hlpfilenf_fr:  asciiz   "Fichier d'aide non trouv"
badhelp_us:    asciiz   "Bad help format"
badhelp_fr:    asciiz   "Mauvais format d'aide"
help_us:       asciiz   "Help"
help_fr:       asciiz   "Aide"
chres_err_us:  asciiz   "unable to change|the resolution"
chres_err_fr:  asciiz   "impossible de changer|de rsolution"
vwks_err_us:   asciiz   "unable to open a virtual|workstation"
vwks_err_fr:   asciiz   "impossible d'ouvrir une|station de travail|virtuelle"
aes_err_us:    asciiz   "AES error"
aes_err_fr:    asciiz   "erreur AES"
wind_err_us:   asciiz   "unable to create|a window"
wind_err_fr:   asciiz   "impossible de crer|une fentre"
font_err_us:   asciiz   "unknown font problem"
font_err_fr:   asciiz   "problme de fonte inconnu"
mem_err_us:    asciiz   "insufficient memory"
mem_err_fr:    asciiz   "mmoire insuffisante"
par_err_us:    asciiz   "bad parameters"
par_err_fr:    asciiz   "mauvais paramtres"
rulnf_err_us:  asciiz   "rule file not found"
rulnf_err_fr:  asciiz   "fichier de rgle|non trouv"
brul_err_us:   asciiz   "illegal rule file format"
brul_err_fr:   asciiz   "mauvais format de|fichier de rgle"
tlfn_err_us:   asciiz   "internal error: too|long file name"
tlfn_err_fr:   asciiz   "erreur interne: nom de|fichier trop long"
gmdos_err_us:  asciiz   "GEMDOS error"
gmdos_err_fr:  asciiz   "erreur GEMDOS"
stkovfl_err:   asciiz   "stack overflow"
;\4
menu_key:      asciiz   "HELP"
               asciiz   "Shift-HELP"
               asciiz   "UNDO"
               asciiz   "N"
               asciiz   "RETURN"
               asciiz   "F1-F20"
               asciiz   "Ctrl-TAB"
               asciiz   "Ctrl-Q"
menu_us:       asciiz   "help about TETRHEX"
               asciiz   "help about the rule"
               asciiz   "load a rule"
               asciiz   "player name"
               asciiz   "play"
               asciiz   "high scores"
               asciiz   "bottom"
               asciiz   "quit"
               asciiz   "Rule file"
               asciiz   "Player"
menu_fr:       asciiz   "aide sur TETRHEX"
               asciiz   "aide sur la rgle"
               asciiz   "charger une rgle"
               asciiz   "nom du joueur"
               asciiz   "jouer"
               asciiz   "meilleurs scores"
               asciiz   "arrire-plan"
               asciiz   "quitter"
               asciiz   "Fichier de rgle"
               asciiz   "Joueur"
;\4
loadrul_us:    asciiz   "Load a rule file"
loadrul_fr:    asciiz   "Charger un fichier de rgle"
yn_us:         asciiz   "Your name: "
yn_fr:         asciiz   "Votre nom: "
menu:          asciiz   "Menu"
hisc_scores:   asciiz   "F1-F20: scores."
hisc_menu:     asciiz   "ESC: menu."
;\4
               IFGE     REGISTERED
shareware:     asciiz   "Shareware"
               IFNE     REGISTERED
sw_regto_us:   asciiz   "Registered to"
sw_regto_fr:   asciiz   "Enregistre "
               ELSE
sw_line1_us:   asciiz   "If you want to register,"
sw_line2_us:   asciiz   "read the README file."
sw_line1_fr:   asciiz   "Si vous voulez vous faire enregistrer,"
sw_line2_fr:   asciiz   "lisez le fichier LISEZMOI."
               ENDIF
               ENDIF
;\6
;  Dans la version shareware, cette partie est code.

rlp_expl:      dc.b     $6E,$C0,$BF,$51
rlp_down:      dc.b     $7F,$7C,$C0,$C0,$51
rlp_ldwn:      dc.b     $7F,$7C,$C0,$C5,$51
rlp_left:      dc.b     $63,$7C,$BF,$53,$4A,$71,$41,$73,$7C,$64,$C1,$72,$7C,$64,$C0,$FF,$EC,$53,$63,$41,$65,$C1,$FF,$ED
               dc.b     $71,$41,$73,$7C,$C0,$C1,$72,$7C,$C0,$51
rlp_rdwn:      dc.b     $7F,$7C,$C0,$C1,$51
rlp_righ:      dc.b     $63,$7C,$BF,$53,$4A,$71,$40,$73,$7C,$64,$C1,$72,$7C,$64,$C0,$FF,$EC,$53,$63,$41,$65,$C1,$FF,$ED
               dc.b     $71,$40,$73,$7C,$C0,$C1,$72,$7C,$C0,$51
rlp_end:
;\4
sys_err:       asciiz   "system error"
bad_proc:      asciiz   "bad processor"
int_err:       asciiz   "internal error"
bad_opt_str:   asciiz   "bad option string"
bad_lang:      asciiz   "bad language file format"
no_help:       asciiz   "help file not found"
bad_help:      asciiz   "bad help format"
               EVEN
text_err:      dc.w     sys_err-text_err,0,mem_err_us-text_err,chres_err_us-text_err,bad_proc-text_err
               dc.w     vwks_err_us-text_err,wind_err_us-text_err,font_err_us-text_err
               dc.w     rulnf_err_us-text_err,brul_err_us-text_err,int_err-text_err,bad_opt_str-text_err
               dc.w     bad_lang-text_err,no_help-text_err,bad_help-text_err,stkovfl_err-text_err

;\6
;    Ŀ
;     Segment BSS 
;    

               BSS                          ;Segment BSS: doit tre mis  zro par le systme.
               IFGE     REGISTERED
sw_fonthi:     ds.w     2                   ;Hauteur des caractres pour "Shareware" et le texte situ en dessous.
               ENDIF
               IFEQ     REGISTERED
tps96a:        ds.w     1                   ;Compteur dcrment toutes les 1/96 s (par la routine d'interruption).
tps96b:        ds.w     1                   ;Compteur dcrment en moyenne toutes les 1/96 s (qd la pice descend).
               ENDIF
hbk_addr:      ds.l     1                   ;Adr. de gd.hexbk (valide qd hbk_req est dsactiv).
shap_def:      ds.l     1                   ;Ptr sur la dfinition des formes (mis  jour lors du chargement d'une rgle).
textlim:       ds.l     2                   ;Limites du prg TETRHEX.
varflag:       ds.b     1                   ;Flag indiquant si on doit dcr. une variable du jeu. 
varcntr:       ds.b     1                   ;Compteur (diviseur de frquence) --> 1 Hz.           
varaddr:       ds.l     1                   ;Adr. de cette variable ventuelle.                   
counter:       ds.w     1                   ;Compteur pour le timer.                  
countr2:       ds.l     1                   ;Compteur pour la fin de la prsentation. 
col_gp:        ds.l     1                   ;Couleur de "-- PAUSE --" (pause du jeu). 
col_go:        ds.l     1                   ;Couleur de "game over".                  
col_gy:        ds.l     1                   ;Couleur de "Votre nom:" et du nom.       
col_date:      ds.l     1                   ;Couleur de la date.                      
col_time:      ds.l     1                   ;Couleur de l'heure.                      
col_help:      ds.l     1                   ;Couleur de l'aide.                       
pwtitle:       ds.l     1                   ;Adr. de sparation des titres de la fentre normale/pause.
patterns:      ds.l     1                   ;Ptr sur le bloc de mmoire contenant les motifs.
ledp_addr:     ds.l     1                   ;Adr. de la structure de LED Panel, ou 0 si LED Panel n'est pas prsent.
struct_msg:    ds.b     16                  ;8 octets pour les msg.
buffer:                                     ;Ptr sur le buffer (qui sera libr aprs la prsentation). 
rul_ptr:       ds.l     1                   ;Ptr sur le fichier de rgle en mmoire.                    
ap_id:         ds.w     1                   ;Identificateur de l'application.                           
handle:        ds.w     1                   ;Handle graphique.                                          
xx:            ds.w     1                   ;Abscisse maxi de l'cran systme.                          
yy:            ds.w     1                   ;Ordonne maxi de l'cran systme.                          
scrn_len:      ds.l     1                   ;Taille de l'cran en octets.                               
gdosflag:      ds.b     1                   ;-1 si SpeedoGDOS est install, 0 sinon.                    
windflag:      ds.b     1                   ;Ngatif si le jeu se droule dans une fentre GEM.         
multflag:      ds.b     1                   ;Flag de calcul en tche de fond.                           
backflag:      ds.b     1                   ;Ngatif si image de fond en mmoire, positif sinon.  
backaddr:      ds.l     1                   ;Adr. du bloc de mmoire rserv (s'il y en a un).    
addr_scr:      ds.l     1                   ;Adr. de l'cran logique.                             
xy0:           ds.w     2                   ;Coordonnes du point suprieur gauche de la fentre. 
xlen:          ds.w     1                   ;Taille en octets d'une ligne de l'cran systme.     
addr_win:      ds.l     1                   ;Adr. de la fentre (640 x 480) pdt la prsentation.  
dxy:           ds.w     2                   ;Coordonnes de la fentre: xy0 + dxy.
graphmode:     ds.w     1                   ;Ancien mode graphique (donn par Vsetmode).
whandle:       ds.w     1                   ;Handle de la fentre, si le jeu se droule dans une fentre GEM.
RGB0:          ds.l     256                 ;Couleur initiale des pinceaux. 
RGB:           ds.l     256                 ;Couleur courante des pinceaux. 
string:        ds.b     strlen              ;Buffer o seront stocks le nom du fichier de rgle et les chanes d'alerte.
winpos:                                     ;Donnes concernant la position de la fentre, provenant des options. 
bkgr_reg:      ds.l     17                  ; Registres de la routine gbkgr_start, sauvs                        
               ds.w     1                   ; ici en cas de calcul en tche de fond.                             
bksh_flag:     ds.b     1                   ;Flag interdisant un wind_move qd une pice est affiche (pdt le jeu).      
               ds.b     1                   ;Flag indiquant qu'on devra faire un wind_move qd bksh_flag sera dsactiv. 
               ds.w     2                   ;Coord. pour le wind_move (cf note bksh_flag).                              
wind_wh:       ds.w     2                   ;Hauteur et largeur de la fentre.                                          
pause_h:       ds.w     1                   ;Hauteur  laquelle il faudra afficher "-- PAUSE --" en mode pause du jeu.
dispflag:      ds.b     1                   ;Drapeau d'affichage de TETRHEX + version.
dateflag:      ds.b     1                   ;Drapeau positionn quand les cadres de la date et de l'heure sont dj affichs. 
lastdate:      ds.l     1                   ;Dernire date affiche.                                                          
langsys:       ds.b     1                   ;Langage utilis par le systme.
langlist:      ds.b     langlen             ;Liste des langages par ordre de prfrence, termine par un octet ngatif.
dta:           ds.b     44                  ;Emplacement de la nouvelle DTA.
numdata:       ds.l     1                   ;Adr. du bloc de mmoire o seront stockes les struct. num.
sfont_addr:    ds.l     1                   ;Adr. des donnes sur la fonte utilise pour les meilleurs scores, ou 0.
tcol:          ds.l     32                  ;Couleurs du texte (cf chcol) & buffer (cf load_rul).
menudata:      ds.w     1                   ;Hauteur de la fonte pour le menu.                                    
               ds.w     4*nmen              ;(Ymin,Ymax,Xmin,Xmax) des rectangles encadrant chaque ligne du menu. 
item:          ds.w     1                   ;N de l'item du menu sous le curseur de la souris. 
bitem:         ds.w     1                   ;Nul lorsqu'un item a t cliqu.                   
bstate:        ds.w     1                   ;Dernier tat des boutons de la souris.             
fx:            ds.w     1                   ;Contiendra les dizaines du 1er rang lors de l'affichage des meilleurs scores.
pname:         ds.b     namelen             ;Nom du joueur (0 si pas de nom).
pnam_flag:     ds.b     1                   ;Drapeau actif (-1) lorsque la liste des meilleurs scores doit tre inchange.
backtype:      ds.b     1                   ;Type de l'img de fond: 0: standard, -1: calcule par le fichier de msg.
helpflag:      ds.b     1                   ;Drapeau actif (ngatif) s'il faut envoyer le fichier d'aide sur la sortie std.
screen_sem:    ds.b     1                   ;Flag utilis lorsque le jeu se droule sur tout l'cran (cf option -wu).
gameflag:      ds.b     1                   ;Drapeau de jeu (actif lors du jeu). Sert pour l'arrt du timer et les phases P/Q.
vsync_flag:    ds.b     1                   ;Flag indiquant si on doit attendre l'interruption VBL avant certains affichages.
path:          ds.b     strlen-1            ; Utiliss par le slecteur
file:          ds.b     13                  ; de fichiers.
windtitle:     ds.b     80                  ;Titre de la fentre.

;\5
;    Ŀ
;     AES 
;    

               TEXT
;\4
;  Montre le curseur de la souris.

mouse_on:      move.w   #m_on,d0            ; Montre le curseur
               bra.s    mgr_mouse           ; de la souris.
;\6
;  Charge les fontes si SpeedoGDOS est install.

load_fonts:    tst.b    gdosflag(pc)        ; Branch. si SpeedoGDOS n'est pas install
               beq.s    set_arrow           ; (forme de la souris: flche).
               moveq    #busy_bee,d0        ; Souris: forme d'une abeille si le jeu
               bsr.s    gr_mouse            ; se droule dans une fentre GEM.
               clr.w    intin               ;0 (rserv).
               intvdi   vst_load_fonts      ;Charge les fontes.
set_arrow:     moveq    #arrow,d0           ;Souris: forme d'une flche si le jeu se droule dans une fentre GEM.
gr_mouse:      tst.b    windflag(pc)        ; Retour si le jeu se droule
               bpl.s    hide_rts            ; sur tout l'cran.
mgr_mouse:     move.w   d0,int_in           ;Paramtre pour graf_mouse.
               lea      control(pc),a0      ;Adr. du tableau control.
               move.w   #graf_mouse,(a0)+   ;Opcode.
aes1:          move.w   #1,(a0)+            ;Taille du tableau int_in.
aes2:          move.w   #1,(a0)+            ;Taille du tableau int_out.
aes3:          clr.w    (a0)                ;Taille du tableau addrin.
aes:           move.l   #aespb,d1           ;Bloc de paramtres AES.
               move.w   #$C8,d0             ;Code pour AES.
               trap     #gem                ;Appel GEM.
               move.w   int_out(pc),d0      ;Valeur de retour.
hide_rts:      rts                          ;Retour.
;\2
               DATA
aespb:         dc.l     control,global,int_in,int_out,addrin,addrout
;\4
               BSS
               EVEN
control:       ds.w     5
global:        ds.w     15
int_in:        ds.w     16
int_out:       ds.w     7
addrin:        ds.w     2
addrout:       ds.w     1

;\6
;    Ŀ
;     VDI 
;    

               DATA
vdipb:         dc.l     contrl,intin,ptsin,intout,ptsout
;\4
               BSS
contrl:        ds.w     12
intin:         ds.w     128
ptsin:         ds.w     256
intout:        ds.w     128
ptsout:        ds.w     256
;\4
bss_end:       ds.b     stack_len
stack_end:

               END
